<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-07 14:32:22 -0400 (lu., 07 ene. 2019) $
 * @version        $Rev: 10454 $
 * @package		Clientix.Classes.Database
 * @abstract		General Database Abstraction Layer
 *
 * CHANGE LOG
 *  Included label
 */
define('ASSOCIATIVE', CLX_NUM_ONE);
define('NUMERIC', CLX_NUM_TWO);
$GLOBALS["PRIMARY_ERROR"]=1;
class ClxDatabase {

    var $dblink;
    var $databaseURL;
    var $databaseUsername, $databasePassword, $databaseName;
    var $debug;
    var $timelog = false;
    var $logfile = 'temp/sqllog.txt';
    var $dumpScript = false;
    var $scriptFileOut = 'script_out.sql';
    var $fileObj = false;
    var $stime = CLX_INIT_ZERO;
    var $etime = CLX_INIT_ZERO;
    var $ttime = CLX_INIT_ZERO;
    var $permanentCnx = false;
    var $autocommit = true;
    var $charset = 'utf8';
    var $charsetCcollateBin = 'utf8_bin';
    var $charsetCollateCi = 'utf8_general_ci';
    var $dbTypes = array('mysql' => 'GEN_LBL_MySQL', 'mysqli' => 'GEN_LBL_MYSQLI', 'oci' => 'GEN_LBL_ORACLE');
    var $last_error = array('message' => '', 'code' => CLX_NUM_ZERO, 'sql' => '');
    var $error;
    var $ci_search = false;
	var $backtrace_on_error = true;
    var $temporary_supress_squote_change = false;
    var $audit=false;
    /**
     * Constructor
     */
    function __construct($url, $user, $pass, $name) {
        $this->databaseURL = $url;
        $this->databaseUsername = $user;
        $this->databasePassword = $pass;
        $this->databaseName = $name;
        $this->debug = false;
    }

    /**
     * Clintix Error Reporting Tool
     * @param: string sql, error number, error message
     */
    function reportError($sql, $errorNum, $errorMsg, $binds = array(),$showerror=true) {
		///pr e($errorNum);
		//pr e($errorMsg);
		if($this->audit==true)
			$showerror=false;
        $a_backtrace = array();
        $line_number = 'unknown line';
		$te = array();
		if($this->backtrace_on_error === true) {
		$te=debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, CLX_NUM_TEN);
		}
			
        for ($t=0;$t<18;$t++) { 
            if (isset($te[$t]['file']))	{
                if(!strpos($te[$t]['file'], UserRequest::$server['SCRIPT_NAME']) === false) {
                    $line_number = CLX_CHAR_EMPTY_STRING.$te[$t]['line'];
                }
                $a_backtrace[] = str_replace(kPathToWebSite, '', $te[$t]['file']).' | '.$te[$t]['line'].' | '.$te[$t]['function'].'()';
            }
        }
        $this->last_error['sql'] = $sql;
		IF($GLOBALS["PRIMARY_ERROR"]==1) {
			$this->crear_txt_alterno($errorMsg,$sql,$binds,$a_backtrace,$errorNum,$line_number);
		}
		$GLOBALS["PRIMARY_ERROR"]=0;
        $this->last_error['message'] = $errorMsg;
        $this->last_errror['code'] = $errorNum;
        $contenidoHTML = '';
		//ultimo error de ejecucion sql(para caso que rollback,commit,y cualquier cosa ejecutada dio error en loop hasta agotar memoria)
		
		//if ($showerror==true){
			$this->rollback();
	   //	}
		if($this->backtrace_on_error === false) {
			 $a_backtrace = array();
		}
        // $this->setAutocommit(true);
        if (!defined('clxInstallProcess')) {
            $request = array('script' => $sql,
                'binds' => $binds,
                'backtrace' => $a_backtrace,
                'request' => UserRequest::$request);
            $BUGS = getTool('BUGS');
            if (!empty($BUGS)) {
                $link=$BUGS->report(E_USER_ERROR, $errorMsg . ' (' . $errorNum . ' )', UserRequest::$server['SCRIPT_NAME'], $line_number, $request, CLX_NUM_ONE, $sql , 'index.php',false,$showerror );
            }
        } else {
            $contenidoHTML.= CLX_CHAR_NL . '*********' . $errorMsg . ' ' . $sql . CLX_CHAR_NL . '*********';
        }
		if ($showerror==true)
			echo $contenidoHTML;
    }
	function crear_txt_alterno($errorMsg,$sql,$binds,$a_backtrace,$errorNum,$line_number){
		$contenidoHTML='';
		$dd=date('d');
		$yy=date('y');
		$mm=date('m');
		for ($t=3;$t<20;$t++) {
			$time1=date('_Y_m_d',mktime(0,0,0,$mm,$dd-$t,$yy));
			$fech1=kPathToWebSite."/".kPathToTemp."/error_sql".$time1.".txt";
			if (file_exists($fech1))
				unlink($fech1);
		}
		$time1=date('_Y_m_d',mktime(0,0,0,$mm,$dd,$yy));
		$fech1=kPathToWebSite."/".kPathToTemp."/error_sql".$time1.".txt";
		$find=md5(json_encode($a_backtrace));
		$xfrom=stripos($sql,'from');
		$into=stripos($sql,'into');
		if ($xfrom!==false) {
			$xwhere=stripos($sql,'where',$xfrom);
			$from=substr($sql,$xfrom,$xwhere-$xfrom);
			$find=md5(json_encode($a_backtrace).$from);
			$find='from_'.$find;
		}
		else if ($into!==false) {
			$xselect=stripos($sql,'select');
			$xvalues=stripos($sql,'values');
			if ($xselect!==false) {
				$into=substr($sql,$xinto,$xselect-$xinto);
				$find=md5(json_encode($a_backtrace).$into);
				$find='intoS_'.$find;
			}
			else if ($xselect!==false) {
				$into=substr($sql,$xvalues,$xselect-$xvalues);
				$find=md5(json_encode($a_backtrace).$into);
				$find='intoV_'.$find;
			}
		}
		$xfrom=stripos($sql,'from');
		$xwhere=stripos($sql,'where');
		$from=substr($sql,$xfrom,$xwhere-$xfrom);
		$text='';
		if (file_exists($fech1))
			$text=file_get_contents($fech1);
		if (strpos($text,$find)==false) {
			$rra=fopen($fech1,"a+");
			$error=array($errorMsg,$sql,$binds,$find=>$a_backtrace,$errorNum,$line_number);
			fwrite($rra,print_r($error,true));
			fclose($rra);
		}
    }
	
    /**
     * Clintix Error Reporting Tool
     * @param: string sql, error number, error message
     */
    function reportErrorBatch() {
        $contenidoHTML = '';
        $return = false;
        $errNum = $this->errorNum();
        if (!empty($errNum)) {
            $contenidoHTML.= $this->errorMsg() . '(' . $errNum . ')';
            $return = true;
        }
        echo $contenidoHTML;
        return $return;
    }

    function isSelect($statement) {
        return is_resource($statement);
    }

    /** Change autocommit status
     *
     * @param bool $boolean
     */
    function setAutocommit($boolean) {
        $this->autocommit = $boolean;
        $sql = 'set autocommit = ';
        if (!($this->autocommit)) {
            $sql .= '1';
        } else {
            $sql .= '0';
        }
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Returns autocommit status
     *
     * @return boolean
     */
    function getAutocommit() {
        return $this->autocommit;
    }

    /**
     * Returns commit mode
     * Return integer
     */
    function getCommitMode() {
        return null;
    }

    /**
     * Commit Execute sql statement
     */
    function commit() {
        $retorno = $this->executeQuery('commit');
        unset($retorno);
    }

    /**
     * Rollback
     */
    function rollback() {
        $retorno = $this->executeQuery('rollback');
        unset($retorno);
    }

    /**
     * Database Error Number
     * @param: SQL Query
     */
    function errorNum() {
        return CLX_NUM_ZERO;
    }

    /**
     * Database Error Message
     * @param: SQL Query
     */
    function errorMsg() {

    }

    function clearErrorMsg() {
        $this->error = array('message' => '', 'code' => CLX_NUM_ZERO);
        $this->last_error = array('message' => '', 'code' => CLX_NUM_ZERO, 'sql' => '');
    }

    /**
     * Returns string with information about the most recent query.
     * @param: SQL Query
     */
    function info() {

    }

    /**
     * Set Start time for debug
     */
    function logStart() {
        $this->stime = microtime_float();
    }

    /**
     * Set End time
     */
    function logEnd() {
        $this->etime = microtime_float();
    }

    function logTime() {
        return $this->etime - $this->stime;
    }

    function writeTimeLog($msg) {
        if (!empty($this->timelog)) {
            $this->ttime += $this->logTime();
            if (!is_resource($this->fileObj)) {
                $this->fileObj = fopen($this->logfile, 'w');
            }
            fwrite($this->fileObj, $this->ttime . '||' . $this->logTime() . '||' . str_replace(CLX_CHAR_TAB, ' ', str_replace(CLX_CHAR_NL, ' ', str_replace(CLX_CHAR_TAB, ' ', str_replace('  ', ' ', $msg)))) . ';' . CLX_CHAR_NL);
        }
    }

    function dumpScript($sql) {
        if (!empty($this->dumpScript)) {
            if (!is_resource($this->fileObj)) {
                $this->fileObj = fopen($this->scriptFileOut, 'w');
            }
            fwrite($this->fileObj, $sql . ';' . CLX_CHAR_CR);
        }
    }

    /**
     * Open a connection to a Database Server
     */
    function connectToDatabase() {

    }

    /**
     * Selects the default database for queries
     */
    function selectDatabase() {

    }

    /**
     * Close database connection
     */
    function closeConnection() {

    }

    /**
     * Creates a new Mysql database
     */
    function createDatabase() {
        $sql = 'CREATE DATABASE IF NOT EXISTS ' . $this->databaseName;
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Remove a Mysql database if exist
     */
    function dropDatabase() {
        $sql = 'DROP DATABASE IF EXISTS ' . $this->databaseName;
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Executes SQL Query and returns the correspondant result resource
     * or error on failure.
     * @param: SQL Query
     */
    function executeQuery($sql) {
        ClxFreeReturn($sql);
        return null;
    }
    
    function executeQueryUniversal(&$sql, $binds) {
		$GLOBALS['BINDSX']=$binds;
		
		if (kDatabaseType === 'oci') {
            $results = $this->executeQuery($sql, $binds);
        } else {
            foreach($binds as $key => $val) {
                $val_final = $val;
                if(is_string($val)) {
                    $val_final = singleQuote($val);
                }
                $sql = str_replace(':'.$key, $val_final, $sql);
            }
            $results = $this->executeQuery($sql);
        }
        return $results;
    }

    /**
     * Executes SQL Query an unbuffered and returns the correspondant result resource
     * or error on failure.
     * @param: SQL Query
     */
    function executeUnbufferedQuery($sql) {
        return $this->executeQuery($sql);
    }

    /**
     * Executes SQL Query (case insensitive)
     * @param: SQL Query
     */
    function executeQueryCi($sql) {
        return $this->executeQuery($sql);
    }
    /**
     * Executes SQL Query (case insensitive)
     * @param: SQL Query
     */
    function executeQueryCiBinds($sql,$binds=array()) {
        return $this->executeQuery($sql,$binds);
    }
    /**
     * Reset sesion variables altered before Case Insensitive query execution and result set processing
     * @param: void
     */
    function executeQueryCiResetSesVars() {
    }

    /**
     * Equivalent to executeQuery with the exception of no error
     * reported on failure
     * @param: SQL Query
     */
    function executeQuerySilent($sql) {
        ClxFreeReturn($sql);
    }

    /**
     * Return boolean if error was found on sql
     * @return bool
     */
    function hasError() {
        return $this->errorNum() <> CLX_NUM_ZERO;
    }

    /**
     * Perfoms sql check by executing query silent.
     * @param string $sql Sql Query
     * @return bool
     */
    function checkQuery($sql) {
        $errorNum = CLX_INIT_ZERO;
        if (!stristr($sql, 'DELETE') && !stristr($sql, 'UPDATE')) {
            $this->executeQuerySilent($sql);
            $errorNum = $this->errorNum();
        }
        return $errorNum === CLX_INIT_ZERO;
    }

    /**
     * Free SQL Results
     */
    function freeResult($resource) {
        ClxFreeReturn($resource);
    }

    function viewExists($viewname) {
        return $this->tableExists($viewname);
    }

    function createView($viewname, $viewsql) {
        if ($this->viewExists($viewname)) {
            $this->dropView($viewname);
        }
        $viewsql = $this->extrac_dbms_sql($viewsql);
        $sql = 'CREATE VIEW ' . $viewname . ' AS ' . $viewsql;
        ClxFreeReturn($this->executeQuery($sql));
    }

    function alterView($viewname, $viewsql) {
        $viewsql = $this->extrac_dbms_sql($viewsql);
        $this->createView($viewname, $viewsql);
    }

    function dropView($viewname) {
        if ($this->viewExists($viewname)) {
            $sql = 'DROP VIEW ' . $viewname;
            $retorno = $this->executeQuery($sql);
            unset($retorno);
        }
    }

    /**
     * Return true if table exists or false if not found on database
     * @param: String tablename
     */
    function tableExists($tablename) {
        ClxFreeReturn($tablename);
    }

    /**
     * Return true if table exists or false if not found on database
     *
     * @param String tablename
     */
    function tempTableExists($tablename) {
        $this->executeQuerySilent('SELECT 1 FROM ' . $tablename . ' WHERE 1=2 LIMIT 1');
        return ($this->errorNum() !== CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Creates physical table on database.
     * @param string $tablename Name of table
     * @param string $tabletype Type of table VIEW, TEMP, ETC
     * @param array $fields List of field and its caracteristicts
     * @param bool $casesensitive Additiona parameter to define case sensitivity.
     */
    function createTable($tablename, $tabletype, $fields, $casesensitive = false) {
        ClxFreeReturn($tablename);
        ClxFreeReturn($tabletype);
        ClxFreeReturn($fields);
        ClxFreeReturn($casesentive);
    }

    /**
     * Translate table structure according db implementation current default mysql
     * @param array $table Table structure as defined in tool or application
     * @return array Modified table structure accordin to specific database
     */
    function translateTableStructure($table) {
        if (empty($table['case_sensitive'])) {
            $table['case_sensitive'] = false;
        }
        return $table;
    }

    /**
     * Return physical table information of empty array otherwise
     * @param string $tablename Name of table
     * @return array
     */
    function getTableInfo($tablename) {
        $info = array('name' => $tablename,
            'type' => 'default',
            'fields' => array(),
            'indexes' => array(),
            'case_sensitive' => false,
            'raw' => array());
        return $info;
    }

    /**
     * Changed table type
     * @param string $tablename Name of table
     * @param string $newtype Type of table ex: VIEW, TEMP, ETC
     */
    function changeTableType($tablename, $newtype) {
        ClxFreeReturn($tablename);
        ClxFreeReturn($newtype);
    }

    /**
     * Changes table name
     * @param string $oldtablename
     * @param string $newtablename
     */
    function renameTable($oldtablename, $newtablename) {
        ClxFreeReturn($oldtablename);
        ClxFreeReturn($newtablename);
    }

    /**
     * Drop Table from database
     */
    function dropTable($tablename) {
        ClxFreeReturn($tablename);
    }

    /**
     * Returns array containing tables names
     */
    function tables() {
        return array();
    }

    function tablePop($default, $name) {
        $tables = $this->tables();
        $pop = new htmlSelect($name);
        foreach ($tables as $tablename) {
            $pop->addItem($tablename, $tablename, ($tablename == $default));
        }
        return $pop;
    }

    /**
     * Create Field on database
     */
    function createField($tablename, $fieldname, $info) {
        $type = $info['type'];
        $null = ($info['null'] === 'NO') ? 'not null' : 'null';
		if (!array_key_exists('default', $info)) {
            $info['default'] = '';
        }
        $has_default = (strlen($info['default']) > CLX_NUM_ZERO) ? true : false;
        $default = '';
        if (!empty($has_default)) {
            $default = 'DEFAULT ' . $info['default'] . ' ';
        }
        if (strval($info['default']) === 'null' && $info['null'] === 'NO') {
            $default = '';
        }
        $properties = $info['properties'];
        $sql = 'ALTER TABLE ' . $tablename . ' ADD ' . $fieldname . ' ' . $type . ' ' . $null . ' ' . $properties . ' ' . $default;
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Modify a field on database
     */
    function modifyField($tablename, $oldfieldname, $newfieldname, $info) {
		$infooriginal=$info;
        $type = $info['type'];
        $null = ($info['null'] === 'NO') ? 'not null' : 'null';
        if (!array_key_exists('default', $info)) {
            $info['default'] = '';
        }
        $has_default = (strlen($info['default']) > CLX_NUM_ZERO) ? true : false;
        $default = '';
        if (empty($has_default)) {
            $default = 'DEFAULT ' . $info['default'] . ' ';
        }
        if (strval($info['default']) === 'null' && $info['null'] === 'NO') {
            $default = '';
        }
        $properties = $info['properties'];

        if (!empty($info ['collate'])) {
            $properties .= ' COLLATE ' . $info ['collate'];
        }
        $sql = 'ALTER TABLE ' . $tablename . ' CHANGE  `' . $oldfieldname . '` `' . $newfieldname . '` ' . $type . ' ' . $null . ' ' . $properties . ' ' . $default;
      
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Similar to modify Field but Multiple
     *
     * @param string $tablename
     * @param array $fieldsinfo array('oldfieldname'=>string, 'newfieldname'=>string, 'info'=>array(),'isaddfield'=>bool)
     */
    function modifyFields($tablename, $fieldsinfo) {

        if (!empty($fieldsinfo)) {
            $comma = '';
            $sql = 'ALTER TABLE ' . $tablename;
            foreach ($fieldsinfo as $info) {
                $oldfieldname = $info['oldfieldname'];
                $newfieldname = $info['newfieldname'];
                $type = $info['info']['type'];

                $null = ($info['info']['null'] === 'NO') ? 'NOT NULL' : 'NULL';
                if (!array_key_exists('default', $info['info'])) {
                    $info['info']['default'] = '';
                }
                $has_default = (strlen($info['info']['default']) > CLX_NUM_ZERO) ? true : false;
                $default = '';
                if (true === $has_default) {
                    $default = 'DEFAULT ' . $info['info']['default'] . ' ';
                }
                if (strval($info['info']['default']) === 'null' && $info['info']['null'] === 'NO') {
                    $default = '';
                }
                $properties = $info['info']['properties'];

                if (!empty($info['info']['collate'])) {
                    $properties .= ' COLLATE ' . $info ['info']['collate'];
                }
                $sql .= $comma . ' ';
				$ind='';
				if (kDatabaseType !== 'oci' && strpos( uppercase( $_SESSION['DATABASE_VERSION']),'MARIA')===false && strval($_SESSION['DATABASE_VERSION'])>=8) {
					IF (UPPERCASE($oldfieldname)=='ID') {
						$type= 'INT';
						$ind=',ADD PRIMARY KEY(ID)';
						//PRE($type);
					}
				}
                if (!empty($info['isaddfield'])) {
                    $sql .= 'ADD COLUMN `' . $oldfieldname . '` ' . $type . ' ' . $null . ' ' . $properties . ' ' . $default.$ind;
                } else {
                    $sql .= 'CHANGE `' . $oldfieldname . '` `' . $newfieldname . '` ' . $type . ' ' . $null . ' ' . $properties . ' ' . $default;
                }
                $comma = ', ';
            }//end foreach

            $retorno = $this->executeQuery($sql);
            unset($retorno);
        }
    }

    /**
     * Reorder a field on table after selected field.
     * @param string $tablename
     * @param string $fieldname
     * @param string $after_fieldname
     */
    function reorderField($tablename, $fieldname, $after_fieldname) {
        $info = $this->fieldInfo($tablename, $fieldname);
        if (empty($info)) {
            return;
        }
        $info = array_change_key_case($info, CASE_LOWER);
        $type = $info['type'];
        $null = ($info['null'] === 'NO') ? 'not null' : 'null';
        if (!array_key_exists('default', $info)) {
            $info['default'] = '';
        }
        $has_default = (strlen($info['default']) > CLX_NUM_ZERO) ? true : false;
        $default = '';
        if (!empty($has_default)) {
            if (is_numeric($info['default'])) {
                $default = 'DEFAULT ' . $info['default'] . ' ';
            } else {
                $default = 'DEFAULT ' . singleQuote($info['default']);
            }
        }
        if (strval($info['default']) === 'null' && $info['null'] === 'NO') {
            $default = '';
        }
        if (array_key_exists('extra', $info)) {
            $properties = $info['extra'];
        } else {
            $properties = $info['properties'];
        }

        if (!empty($info['collate'])) {
            $properties .= ' COLLATE ' . $info ['collate'];
        }
        $sql = 'ALTER TABLE ' . $tablename . ' MODIFY COLUMN `' . $fieldname . '` ' . $type . ' ' . $null . ' ' . $properties . ' ' . $default;
        if (empty($after_fieldname)) {
            $sql .= ' FIRST';
        } else {
            $sql .= ' AFTER `' . $after_fieldname . '`';
        }
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Reorder all field on table according fields array order
     * @param string $tablename
     * @param array $fields
     */
    function reorderFields($tablename, $fields) {
//get field information
        $fieldinfo = array();
        $rs = $this->fieldList($tablename);
        while ($info = $this->getNextRecord($rs, ASSOCIATIVE)) {
            $info = array_change_key_case($info, CASE_LOWER);
            $type = $info['type'];
            $null = ($info['null'] === 'NO') ? 'not null' : 'null';
            if (!array_key_exists('default', $info)) {
                $info['default'] = '';
            }
            $has_default = (strlen($info['default']) > CLX_NUM_ZERO) ? true : false;
            $default = '';
            if (!empty($has_default)) {
                if (is_numeric($info['default'])) {
                    $default = 'DEFAULT ' . $info['default'] . ' ';
                } else {
                    $default = 'DEFAULT ' . singleQuote($info['default']);
                }
            }
            if (strval($info['default']) === 'null' && $info['null'] === 'NO') {
                $default = '';
            }
            if (array_key_exists('extra', $info)) {
                $properties = $info['extra'];
            } else {
                $properties = $info['properties'];
            }
            if (!empty($info['collate'])) {
                $properties .= ' COLLATE ' . $info ['collate'];
            }
            $fieldinfo[$info['field']] = $type . ' ' . $null . ' ' . $properties . ' ' . $default;
        }
        $sql = 'ALTER TABLE ' . $tablename;
        $comma = '';
        foreach ($fields as $key => $val) {
            if (!array_key_exists($val, $fieldinfo)) {
                continue;
            }
            $sql .= $comma . ' MODIFY COLUMN ' . $val . ' ' . $fieldinfo[$val] . ' ';
            if (!array_key_exists(($key - CLX_NUM_ONE), $fields)) {
                $sql .= ' FIRST';
            } else {
                $sql .= ' AFTER ' . $fields[$key - CLX_NUM_ONE];
            }
            $comma = ',';
        }
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Return and array containing information related to the field.
     */
    function fieldInfo($tablename, $fieldname) {
		$fetched = false;
		if (kApcTtl_24>0) $returnx = apc_fetchFct($findVar='fieldinfo_'.$tablename.'_'.$fieldname.'_' , $fetched);
		
		if (empty($fetched)) {
			$sql = 'SHOW FIELDS FROM ' . $tablename . ' LIKE ' . singleQuote($fieldname);
			$returnx= $this->getOneRecord($sql);
			if (kApcTtl_24>0 && !empty($returnx)){
				apc_addFct($findVar,$returnx,kApcTtl_24);
			}
		}
		return $returnx;
    }

    /**
     * Rename Field
     */
    function renameField($tablename, $oldfieldname, $newfieldname) {
        $info = array_change_key_case($this->fieldInfo($tablename, $oldfieldname), CASE_LOWER);
        IF ($this->debug or $this->debugCF) {
			echo "----modifyfield--3------old---IN RENAME FIELD-----";
			PRE($oldfieldname);
			echo "new";
			PRE($newfieldname);
		}	
        $this->modifyField($tablename, $oldfieldname, $newfieldname, $info);
    }

    /**
     * Returns true is a field is found on table or false on failure.
     */
    function fieldExists($tablename, $fieldname) {
        $return = false;
        $fields = $this->fieldInfo($tablename, $fieldname);
        if (!empty($fields)) {
            $return = true;
        }
        return $return;
    }

    /**
     * Return resultset from query of fields on table, Apparently not in use
     */
    function fieldList($tablename, $fieldname = '') {
        $sql = 'SHOW FIELDS FROM ' . $tablename;
        if (strlen($fieldname) > CLX_NUM_ZERO) {
            $sql .= ' LIKE ' . singleQuote($fieldname);
        }
        return $this->executeQuery($sql);
    }

    /**
     * Returns array of fields conteined on table
     * @param string $tablename
     * @return array
     */
    function getTableFields($tablename) {
        $return = array();
        $rs = $this->fieldList($tablename);
        while (($r = $this->getNextRecord($rs, ASSOCIATIVE)) === true) {
            $return[$r['Field']] = array('FIELD' => $r['Field'], 'TYPE' => $r['Type'], 'null' => $r['Null'], 'KEY' => $r['Key'], 'DEFAULT' => $r['Default'], 'EXTRA' => $r['Extra']);
        }
        return $return;
    }

    /**
     * Create a table index
     */
    function createIndex($tablename, $fieldname, $indexname) {
		
        if ($this->hasIndex($tablename, $fieldname, $indexname)) {
            $this->dropIndex($tablename, $fieldname, $indexname);
        }
        $sql = 'CREATE INDEX ' . $indexname . ' ON ' . $tablename . ' (' . $fieldname . ')';
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Creates a primary index
     *
     * @param string $tablename
     * @param mixed $fieldname
     * @param string $indexname
     */
    function createPrimaryIndex($tablename, $fieldname, $indexname) {
        if (is_array($fieldname)) {//Process multiple fields
            $fieldname = implode(',', $fieldname);
        }
        $this->dropPrimaryIndex($tablename, $fieldname, $indexname);
        $sql = 'ALTER TABLE ' . $tablename . ' ADD PRIMARY KEY (' . $fieldname . ')';
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Creates a unique index
     *
     * @param string $tablename
     * @param mixed $fieldname
     * @param string $indexname
     */
    function createUniqueIndex($tablename, $fieldname, $indexname) {
        if ($this->hasIndex($tablename, $fieldname, $indexname)) {
            $this->dropIndex($tablename, $fieldname, $indexname);
        }
        if (is_array($fieldname)) {//Process multiple fields
            $fieldname = implode(',', $fieldname);
        }
        $sql = 'CREATE UNIQUE INDEX ' . $indexname . ' ON ' . $tablename . ' (' . $fieldname . ')';
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Drops table index
     *
     * @param string $tablename
     * @param mixed $fieldname
     * @param string $indexname
     */
    function dropIndex($tablename, $fieldname, $indexname) {
        if ($this->hasIndex($tablename, $fieldname, $indexname)) {
            $sql = 'DROP INDEX ' . $indexname . ' ON ' . $tablename;
            $retorno = $this->executeQuery($sql);
            unset($retorno);
        }
    }

    function getPrimaryIndexName($tablename) {
        return 'PRIMARY';
    }

    /**
     * Drops a primary index key
     *
     * @param unknown_type $tablename
     * @param unknown_type $fieldname
     * @param unknown_type $indexname
     */
    function dropPrimaryIndex($tablename, $fieldname, $indexname) {
        if ($this->hasPrimaryIndex($tablename, $fieldname, $indexname)) {
            $sql = 'ALTER TABLE ' . $tablename . ' DROP PRIMARY KEY,  CHANGE id id INT NOT NULL';
            $retorno = $this->executeQuery($sql);
            unset($retorno);
        }
    }

    /**
     * heck if table field exists
     *
     * @param string $tablename
     * @param mixed $fieldname
     * @param string $indexname
     * @return bool
     */
    function hasIndex($tablename, $fieldname, $indexname) {
		if (kMysqlVersion >= '5.0') {
            $sql = 'SHOW INDEX FROM ' . $tablename . ' WHERE KEY_NAME = ' . singleQuote($indexname);
            $results = $this->executeQuery($sql);
            return ($this->numRows($results) > CLX_NUM_ZERO) ? true : false;
        } else {
            $sql = 'SHOW INDEX FROM ' . $tablename;
            $rs = $this->executeQuery($sql);
            while (($result = $this->getNextRecord($rs, ASSOCIATIVE))) {
                if ($result['Key_name'] == $indexname) {
                    return true;
                }
            }
            return false;
        }
    }

    /**
     * check if table field exists
     *
     * @param string $tablename
     * @param mixed $fieldname
     * @param string $indexname
     * @return bool
     */
    function hasPrimaryIndex($tablename, $fieldname, $indexname) {
        $indexname = $this->getPrimaryIndexName($tablename); //mysql always saves it as primary
        if (kMysqlVersion >= '5.0') {
            $sql = 'SHOW INDEX FROM ' . $tablename . ' WHERE KEY_NAME = ' . singleQuote($indexname);
            $results = $this->executeQuery($sql);
            return ($this->numRows($results) > CLX_NUM_ZERO) ? true : false;
        } else {
            $sql = 'SHOW INDEX FROM ' . $tablename;
            $rs = $this->executeQuery($sql);
            while (($result = $this->getNextRecord($rs, ASSOCIATIVE))) {
                if ($result['Key_name'] == $indexname) {
                    return true;
                }
            }
            return false;
        }
    }
	function getTablaIndexesbytype($tablename, $type='UNI') {
		$return = array();
        $sql = 'SHOW INDEX FROM ' . $tablename;
       	if ($type='UNI') {
			$sql .=' WHERE Non_unique=0 or Null="YES"';
		}
		else if ($type='MUL') {
			$sql .=' WHERE Non_unique=1';
		}
		else if($type='PRI') {
			$sql .=' WHERE Key_name="PRIMARY"';
		}
        $indexes = $this->executeQuery($sql);
        while (($index = $this->getNextRecord($indexes, ASSOCIATIVE))) {
            if (empty($return[$index['Key_name']]['fieldname'])) {
                $return[$index['Key_name']]['fieldname'] = $index['Column_name'];
            } else {
                $return[$index['Key_name']]['fieldname'] .= ',' . $index['Column_name'];
            }
        }
        return $return;

	}
    /**
     * Returns array containing current table indexes
     *
     * @param string $tablename
     * @param string $fieldname
     * @return array
     */
    function getTableIndexes($tablename, $indexname) {
        $return = array();
        $sql = 'SHOW INDEX FROM ' . $tablename;
        if (strlen($indexname) > CLX_NUM_ZERO && kMysqlVersion >= '5.0') {
            $sql .=' WHERE Key_name=' . singleQuote($indexname);
        }
        $indexes = $this->executeQuery($sql);
        while (($index = $this->getNextRecord($indexes, ASSOCIATIVE))) {
            if (kMysqlVersion < '5.0' && strlen($indexname) > CLX_NUM_ZERO) {
                if ($index['Key_name'] <> $indexname)
                    continue;
            }
            if (empty($return[$index['Key_name']]['fieldname'])) {
                $return[$index['Key_name']]['fieldname'] = $index['Column_name'];
            } else {
                $return[$index['Key_name']]['fieldname'] .= ',' . $index['Column_name'];
            }
            if ($index['Key_name'] == $this->getPrimaryIndexName($tablename)) {
                $return[$index['Key_name']]['index'] = 'PRI';
            } else {
                if (!empty($index['Non_unique'])) {
                    $return[$index['Key_name']]['index'] = 'MUL';
                } else {
                    $return[$index['Key_name']]['index'] = 'UNI';
                }
            }
        }
        return $return;
    }

    /**
     * Remove a field from table
     */
    function dropField($tablename, $fieldname) {
        $sql = 'ALTER TABLE ' . $tablename . ' DROP ' . $fieldname;
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    /**
     * Sets the table collection for case sensitivity
     * @param string $tablename Name of table to set case sensitive
     * @param boolen $active Status of active or inactive
     */
    function changeTableCaseSensitive($tablename, $active) {

    }

// Structure Test methods
    /**
     * Performs testing of current index to see status
     *
     * @param string $tablename
     * @param string $fieldname
     * @param array $fieldinfo
     * @param array $msg
     * @param int $fix
     */
    function checkFieldIndex($tablename, $indexname, &$indexinfo, &$msg, $fix, $dump = false) {
        if ($indexinfo['index'] === 'PRI')
            $indexname = 'PRIMARY'; //mysql only since.
        $indexes = $this->getTableIndexes($tablename, $indexname);
        if (empty($indexes[$indexname])) {
            $indexes[$indexname] = array('index' => '', 'fieldname' => '');
        }
            	
		if ($indexes[$indexname]['index'] <> $indexinfo['index'] || $indexes[$indexname]['fieldname'] <> $indexinfo['fieldname']) {
			$error = array('tablename' => $tablename, 'fieldname' => $indexname . '(' . $indexinfo['fieldname'] . ')', 'error' => dict('GEN_ERR_FIELD_WRONG_INDEX'), 'comments' => dict('GEN_LBL_SET') . ': ' . $indexes[$indexname]['index'] . ' -> ' . $indexinfo['index']);
            if (!empty($fix)) {
                if (!empty($dump)) {
                    $this->dumpScript = true;
                }
                switch ($indexinfo['index']) {
                    case 'UNI':
                        $this->createUniqueIndex($tablename, $indexinfo['fieldname'], $indexname);
                        break;
                    case 'COM':
                        $this->createUniqueIndex($tablename, $indexinfo['fieldname'], $indexname);
                        break;
                    case 'MUL':
                        $this->createIndex($tablename, $indexinfo['fieldname'], $indexname);
                        break;
                    case 'PRI':
                        $this->createPrimaryIndex($tablename, $indexinfo['fieldname'], $indexname);
                        break;
                    default:
                        break;
                }
                if (!empty($dump)) {
                    $this->dumpScript = false;
                }
                $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
            }
            $msg[] = $error;
        }
    }

    /**
     * Perform testing on table fields agains metadata
     *
     * @param string $tablename
     * @param string $fieldname
     * @param array $fieldinfo
     * @param array $msg
     * @param bool $fix
     */
    function checkField($tablename, $fieldname, &$fieldinfo, &$msg, $fix, $dump = false) {
		if ($this->debugCF==true){
			PRE('INICIO CHECKFIELD IN CLXDATABASE');
			$te=debug_backtrace();$posx=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}	
			echo '--------->checkfield tablename';
			pre($tablename);
			echo '--------->checkfield fieldname';
			pre($fieldname);
			echo '--------->checkfield fieldinfo';
			pre($fieldinfo);
			echo '--------->errores anteriores';
			pre($msg);
				pre("--------->fix");
				pre($fix);
				pre("--------->post");
				pre(UserRequest::$post);
				echo "--------->DUMP";
				pre($dump);
				
		}
		//echo "====fieldinfo";
		//pre($fieldinfo);
		$only_solution_index=1;
        if (!array_key_exists('null', $fieldinfo)) {
            $fieldinfo['null'] = 'YES';
        }
		if (!array_key_exists('default', $fieldinfo)) {
            $fieldinfo['default'] = '';
        }
        if (!array_key_exists('properties', $fieldinfo)) {
            $fieldinfo['properties'] = '';
        }
        if (!$this->fieldExists($tablename, $fieldname)) {
            $error = array('tablename' => $tablename,
                'fieldname' => $fieldname,
                'error' => dict('GEN_ERR_FIELD_DOES_NOT_EXISTS'),
                'comments' => '');
            	

            if (!empty($fix)) {
                if (!empty($dump)) {
                    $this->dumpScript = true;
                }
                //$this->createField(array('tablename' => $tablename, 'fieldname' => $fieldname, 'info' => $fieldinfo));
                $this->createField($tablename, $fieldname, $fieldinfo);
                if (!empty($dump)) {
                    $this->dumpScript = false;
                }
                $error['comments'] = dict('GEN_LBL_FIXED');
            }
            $msg[] = $error;
			if ($this->debugCF OR $this->debug) {
				echo '--------->errores en pos_1';
				pre($msg);
			}
			$only_solution_index=0;
        } else {
			if ($this->debugCF OR $this->debug) {
				pre('if checkfield al contrario de create  field aprx linea 1139');
			}	
            $info = $this->fieldInfo($tablename, $fieldname);
			$info['null'] = ($info['null'] === 'YES') ? 'YES' : 'NO';
            $hasErrors = false;
            // Checks default value
            //Field default raw carries the default value without string quotes
            //if default is empty assume no default
            if (!array_key_exists('default', $fieldinfo)) {
                $fieldinfo['default'] = 'null';
            }
            if (strlen($fieldinfo['default']) == CLX_NUM_ZERO) {
                $fieldinfo['default'] = 'null';
            }
            if (kDatabaseType === 'oci') {
                $fieldinfo_val = trim($fieldinfo['default']);
                $info['default'] = trim($info['default']);
            } else {
                $fieldinfo_val = (array_key_exists('default_raw', $fieldinfo) ? $fieldinfo['default_raw'] : $fieldinfo['default']);
            }
			if (is_null($info['default'])) {
                $info['default'] = 'null';
            }
			if ( (UPPERCASE($info['default'])=='CURRENT_DATE' || UPPERCASE($info['default'])=='TODAY')&&
				 (UPPERCASE($fieldinfo_val) =='CURRENT_DATE' || UPPERCASE($fieldinfo_val )=='TODAY') ) {
			 
			}
			else if (kDatabaseType === 'oci' && $info['default']=='null' && $info['null']=='YES' && ($fieldinfo_val=='null'|| $fieldinfo_val=='0')) {
				
			}	
			else if (strval($info['default']) <> strval($fieldinfo_val)) {
				$verificar=true;		
				if (kDatabaseType === 'oci') {
					if ($fieldinfo_val==0) {
						if ($info['default']=='0' || $info['default']=="'0'" || $info['default']=='null') {
							$verificar=false;		
						} 
					}

				}

				if ($verificar) {
					$hasErrors = true;
					$error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_WRONG_DEFAULT'), 'comments' => '');
					$error['comments'] = dict('GEN_LBL_SET') . ': ' . $info['default'] . ' -> ' . $fieldinfo_val;
					if (!empty($fix)) {
						$error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
					}
					$msg[] = $error;
					if ($this->debugCF OR $this->debug) {
						echo '--------->errores en pos_2';
						pre($msg);
				
					}
					$only_solution_index=0;					
				}
				if ($this->debugCF OR $this->debug) {
					pre('has error ('.$haserror. ') linea 1194 ');
				}
            }
            // Checks Field type
			//pr e($info['type']);
			$info_type=$info['type'];
			$pos1=strpos($info['type'],'(');
			$fieldinfo_type=$fieldinfo['type'];
			if ($this->debugCF==true){
				pre('===>fieldname');
				pre($fieldname);
				pre('===>info(oracle)');
				pre($info);
				pre('===>fieldinfo(clientix)');
				pre($fieldinfo);
			
			}
			$pos2=strpos($fieldinfo['type'],'(');
			if (($pos1===false && $pos2===false) || ($pos1===true && $pos2===true) || (!is_bool($pos1)===true && !is_bool($pos2)===true) ) {	
						
			}
			else { 
				if ($pos1 !==false) {
					$type2=uppercase(substr($info['type'],0,$pos1));	
					//if ($type2=='TIMESTAMP')
						$info_type=$type2;
				}
				if ($pos2 !==false) {
					$type2=uppercase(substr($fieldinfo['type'],0,$pos2));	
				//	if ($type2=='TIMESTAMP')
						$fieldinfo_type=$type2;
				}
			}					
			if ($this->debugCF==true){			
				pre(")))((((info_type");
				pre($info_type);
				pre(")))((((fieldinfo_type");
				pre($fieldinfo_type);
			}
			$reg='/\(([0-9])+\)/';
			preg_match($reg, $fieldinfo['type'], $matches);
			$sizefieldinfo_type= $matches[0];
			preg_match($reg, $info['type'], $matches);
			$size_info_type= $matches[0];
			if ($this->debugCF OR $this->debug) {
				pre('size de fieldinfo line:'.__LINE__);
				pre($sizefieldinfo_type);
				pre('size de infotype line:'.__LINE__);
				pre($size_info_type);
			}
			if ($info_type=='NUMBER()' && $fieldinfo['original_type']=='BOOL'){
				$info_type=$fieldinfo_type;
				$sizefieldinfo_type=$size_info_type=1;
			
			}
			if ($info_type=='NUMBER()' && $fieldinfo['original_type']=='INTN'){
				$info_type=$fieldinfo_type;
				$sizefieldinfo_type=$size_info_type=4;
			}
			if ($info_type=='CHAR' && $fieldinfo['original_type']=='CHAR'){
				$info_type=$fieldinfo_type;
				$sizefieldinfo_type=$size_info_type=1;
			}
			if ($info_type=='NUMBER()' && $fieldname=='ID'){
				$info_type=$fieldinfo_type;
				$sizefieldinfo_type=$size_info_type=20;
			}
			if ($info_type=='TIMESTAMP' ){
				$info_type=$fieldinfo_type;
				$sizefieldinfo_type=$size_info_type=6;
			}
			//pre($_SESSION['DATABASE_VERSION']);
			
            if (trim(uppercase($info_type)) != trim(uppercase($fieldinfo_type)) or $sizefieldinfo_type!=$size_info_type) {
				$hasErrors = true;
                $error = array('tablename' => $tablename,
                    'fieldname' => $fieldname,
                    'error' => dict('GEN_ERR_FIELD_WRONG_TYPE'),
                    'comments' => '');
                $error['comments'] = dict('GEN_LBL_SET') . ': ' . $info['type'] . ' -> ' . $fieldinfo['type'];
                
                if (!empty($fix)) {
                    $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                }
				
                $msg[] = $error;
				if ($this->debugCF OR $this->debug) {
					echo '--------->errores en pos_3';
					pre($msg);
			
				}	
				$only_solution_index=0;
            }
            // Checks autoincrement
			if (kDatabaseType=='oci' && $fieldinfo['properties']=='auto_increment' && $info['extra'] != $fieldinfo['properties'] ) {
               	
				if ($fieldname=='ID' && $this->existsAutoIncrement($tablename, $fieldname)=='auto_increment' ) {
					//ech o "existe";
				}
				else  {
					$this->createAutoIncrement($tablename, $fieldname);
					
				}
				$only_solution_index=0;
			}
			else if ($info['extra'] != $fieldinfo['properties']  ) {
                $hasErrors = true;
                $error = array('tablename' => $tablename,
                    'fieldname' => $fieldname,
                    'error' => dict('GEN_ERR_FIELD_WRONG_PROP'),
                    'comments' => '');
                $error['comments'] = dict('GEN_LBL_SET') . ': ' . $fieldinfo['properties'] . ' ' . $info['extra'];
                if (!empty($fix)) {
                    $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                }
                $msg[] = $error;
				if ($this->debugCF OR $this->debug) {
					echo '--------->errores en pos_4';
					pre($msg);
			
				}	
				$only_solution_index=0;
            }
            // Checks nullable
            if ($info['null'] != $fieldinfo['null']) {
                $hasErrors = true;
                $error = array('tablename' => $tablename,
                    'fieldname' => $fieldname,
                    'error' => dict('GEN_ERR_FIELD_WRONG_null'),
                    'comments' => '');
                if ($fieldinfo['default'] === 'null') {
                    $fieldinfo['default'] = '';
                }
                $error['comments'] = dict('GEN_LBL_SET') . ': ' . dict('GEN_LBL_' . $fieldinfo['null']) . ' -> ' . dict('GEN_LBL_' . $info['null']);
                if (!empty($fix)) {
                    $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                }
                $msg[] = $error;
				if ($this->debugCF OR $this->debug) {
					echo '--------->errores en pos_5';
					pre($msg);
			
				}
				$only_solution_index=0;	
            }
			
			
			if (!empty($hasErrors) && !empty($fix)) {
				if ($this->debugCF OR $this->debug) {
					PRE('errores de field en checkfield');pre($error);echo "----modifyfield--2----old---IN CHECKFIELD-------";
					pre($fieldname);echo "new field";pre($fieldinfo);
				}	
                if (!empty($dump)) {
                    $this->dumpScript = true;
                }
				if ($only_solution_index==0){
					if ($this->debugCF OR $this->debug) { 	pre('llamar a modifield con '.$fieldname);}
					$this->modifyField($tablename, $fieldname, $fieldname, $fieldinfo);
                }
				else {
					if ($this->debugCF OR $this->debug) { 	pre('no llamar a modifield con '.$fieldname);;}
				}	
                if (!empty($dump)) {
                    $this->dumpScript = false;
                }
            }
			else {
				if ($this->debugCF OR $this->debug) {
					PRE('no vio el error para modified field en checkfield');
				}
        	}
    	}

    }

    /**
     * Perform testing on table fields agains metadata for multiple fields
     *
     * @param string $tablename
     * @param array $tablefields
     * @param array $msg
     * @param bool $fix
     */
    function checkFields($tablename, $tablefields, &$msg, $fix, $dump = false) {
        $alterfields = array(); //structure must be as array('oldfieldname'=>string, 'newfieldname'=>string, 'info'=>array(),'isaddfield'=>bool)

        foreach ($tablefields as $fieldname => $fieldinfo) {
            if (!array_key_exists('null', $fieldinfo)) {
                $fieldinfo['null'] = 'YES';
            }
            if (!array_key_exists('default', $fieldinfo)) {
                $fieldinfo['default'] = '';
            }
            if (!array_key_exists('properties', $fieldinfo)) {
                $fieldinfo['properties'] = '';
            }
            if (!$this->fieldExists($tablename, $fieldname)) {

                $error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_DOES_NOT_EXISTS'), 'comments' => '');
                if (!empty($fix)) {
                    $alterfields[] = array('oldfieldname' => $fieldname, 'newfieldname' => $fieldname, 'info' => $fieldinfo, 'isaddfield' => true);
                    $error['comments'] = dict('GEN_LBL_FIXED');
                }
                $msg[] = $error;
            } else {

                $info = array_change_key_case($this->fieldInfo($tablename, $fieldname), CASE_LOWER);
                $info['null'] = ($info['null'] === 'YES') ? 'YES' : 'NO';
                $hasErrors = false;
                // Checks default value
                //Field default raw carries the default value without string quotes
                //if default is empty assume no default
                if (!array_key_exists('default', $fieldinfo)) {
                    $fieldinfo['default'] = 'null';
                }
                if (strlen($fieldinfo['default']) == CLX_NUM_ZERO) {
                    $fieldinfo['default'] = 'null';
                }
                $fieldinfo_val = (array_key_exists('default_raw', $fieldinfo) ? $fieldinfo['default_raw'] : $fieldinfo['default']);

                if (is_null($info['default'])) {
                    $info['default'] = 'null';
                }
                if (UPPERCASE(TRIM($fieldinfo_val))=='TODAY' or UPPERCASE(TRIM($fieldinfo_val))=='HOY') {

					switch (kDatabaseType) {
						case 'oci': // Oracle
							$fieldinfo['default']=$fieldinfo_val='CURRENT_DATE';
							break;
						default: // MYSQL   NO TIENE FUNCIONES PARA DATE
							If($fieldinfo['type']=='DATE') {
								$fieldinfo['default']='';
								$info['default']='';
								$fieldinfo_val='';
							}
							break;
					}

				}
				if ($this->debug OR $this->debugCF) {
					echo 'info fieldinfo_val vs info_default line:'.__LINE__;
					PRE($fieldinfo_val);
					pre($info['default']);
				}
				
				if (strval($info['default']) <> strval($fieldinfo_val)) {
                    $hasErrors = true;
                    $error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_WRONG_DEFAULT'), 'comments' => '');
                    $error['comments'] = dict('GEN_LBL_SET') . ': ' . $info['default'] . ' -> ' . $fieldinfo_val;
                    if (!empty($fix)) {
                        $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                    }
                    $msg[] = $error;
                }
				$info_type=$info['type'];
				$pos1=strpos($info['type'],'(');
				$fieldinfo_type=$fieldinfo['type'];

				if ($this->debugCF==true){
					pre(")))((((info_type");
					pre($info_type);
					pre(")))((((fieldinfo_type");
					pre($fieldinfo_type);
				}
				$reg='/\(([\,0-9])+\)/';
				$sizefieldinfo_type=$size_info_type='';
				preg_match($reg, $fieldinfo['type'], $matches);
				if ($this->debugCF OR $this->debug) {
					echo 'fileinfo';
					PRE($matches);
				}
				if (isset($matches[0])) {
					$sizefieldinfo_type= $matches[0];
					$fieldinfo_type=str_replace($matches[0],'',$fieldinfo['type']);
					//pre($fieldinfo['type']);
				}
				preg_match($reg, $info['type'], $matches);
				if ($this->debugCF OR $this->debug) {
					echo 'info_type';
					PRE($matches);
				}
				if (isset($matches[0])) {
					$size_info_type= $matches[0];
					$info_type=str_replace($matches[0],'',$info['type']);
				}
				if ($this->debugCF OR $this->debug) {
					echo(']]1]]]]]====>');
					pre($info_type);
					pre('size de fieldinfo line:'.__LINE__);
					pre($sizefieldinfo_type);
					pre('size de infotype line:'.__LINE__);
					pre($size_info_type);
				}
				if (kDatabaseType !== 'oci' && strpos( uppercase( $_SESSION['DATABASE_VERSION']),'MARIA')===false && strval($_SESSION['DATABASE_VERSION'])>=8) {
					if (strpos(','.uppercase($info_type),'INT')>0) {
						$sizefieldinfo_type=$size_info_type;
					}
					if (uppercase($fieldname)=='ID') {
					//	PRE($fieldinfo_type);
					//	pre($info_type);
						
					 // ALTER TABLE USER_XXX7 ADD COLUMN`ID`  INT   NOT NULL AUTO_INCREMENT ,ADD PRIMARY KEY(ID);
 
						$fieldinfo_type=$info_type;
						$sizefieldinfo_type=$size_info_type;
						$info['extra'] = $fieldinfo['properties'];
						$info['null'] = $fieldinfo['null'];
					}
				}
				if ($this->debugCF OR $this->debug) {
					echo(']]]2]]]]====>');
					pre($info_type);
					pre('size de fieldinfo Line:'.__LINE__);
					pre($sizefieldinfo_type);
					pre('size de infotype Line:'.__LINE__);
					pre($size_info_type);
				}
                // Checks Field type
			
				if (trim(uppercase($info_type)) != trim(uppercase($fieldinfo_type)) or $sizefieldinfo_type!=$size_info_type) {
					
			//	if (uppercase($info['type']) != uppercase($fieldinfo['type'])) {
                    $hasErrors = true;
                    $error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_WRONG_TYPE'), 'comments' => '');
                    $error['comments'] = dict('GEN_LBL_SET') . ': ' . $info['type'] . ' -> ' . $fieldinfo['type'];
                    if (!empty($fix)) {
                        $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                    }
                    $msg[] = $error;
                }

                // Checks autoincrement
                if ($info['extra'] != $fieldinfo['properties']) {
                    $hasErrors = true;
                    $error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_WRONG_PROP'), 'comments' => '');
                    $error['comments'] = dict('GEN_LBL_SET') . ': ' . $fieldinfo['properties'] . ' ' . $info['extra'];
                    if (!empty($fix)) {
                        $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                    }
                    $msg[] = $error;
                }

                // Checks nullable
				
                if ($info['null'] != $fieldinfo['null']) {
                    $hasErrors = true;
                    $error = array('tablename' => $tablename, 'fieldname' => $fieldname, 'error' => dict('GEN_ERR_FIELD_WRONG_null'), 'comments' => '');
                    if ($fieldinfo['default'] === 'null') {
                        $fieldinfo['default'] = '';
                    }
                    $error['comments'] = dict('GEN_LBL_SET') . ': ' . dict('GEN_LBL_' . $fieldinfo['null']) . ' -> ' . dict('GEN_LBL_' . $info['null']);
                    if (!empty($fix)) {
                        $error['comments'] .= ' ' . dict('GEN_LBL_FIXED');
                    }
                    $msg[] = $error;
                }
                if (true === $hasErrors && !empty($fix)) {
                    $alterfields[] = array('oldfieldname' => $fieldname, 'newfieldname' => $fieldname, 'info' => $fieldinfo, 'isaddfield' => false);
                }
            }
        }//end foreach

        if (!empty($alterfields) && $fix) {
            if (!empty($dump)) {
                $this->dumpScript = true;
            }
			if ($this->debug OR $this->debugCF) {
				echo "----modifyfield---2-------------";
					IF (!empty($hasErrors))
						pre($hasErrors);
					PRE($alterfields);

			}	
            $this->modifyFields($tablename, $alterfields);
            if (!empty($dump)) {
                $this->dumpScript = false;
            }
        }
    }

    /**
     * Verifies table structure
     *
     * @param string $tablename
     * @param string $tabletype
     * @param array $fields
     * @param bool $fix
     * @param array $msg
     * @param bool $fields_only
     * @param bool $indexes_only
     */
    function checkTable($tabledef, $fix, &$msg, $fields_only = false, $indexes_only = false, $dump = false,$audit=false) {
		if ( isset($_SESSION["_dEBUG"]) ) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."91- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10)."table fix: ".var_export($tabledef,true).chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"]))fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));fclose($tta);}
		if ($audit==true)
			$this->audit=true;	
        if (empty($tabledef['name'])) {
            return;
        }

        if (!$this->tableExists($tabledef['name'])) {
            $error = array('tablename' => $tabledef['name'], 'fieldname' => 'DBTB: ' . $tabledef['idname'] . ' (' . ((array_key_exists('idcode', $tabledef)) ? $tabledef['idcode'] : 'TOOL') . ')', 'error' => dict('GEN_ERR_TABLE_DOES_NOT_EXISTS'), 'comments' => '');
            if (!empty($fix)) {

                if ($tabledef['type'] === 'VIEW') {
                    if (!empty($dump))
                        $this->dumpScript = true;
                    $this->createView($tabledef['name'], $tabledef['viewsql']);
                    if (!empty($dump))
                        $this->dumpScript = false;
                }else {
                    if (empty($tabledef['case_sensitive'])) {
                        $tabledef['case_sensitive'] = false;
                    }
                    if (!empty($dump))
                        $this->dumpScript = true;
                    $this->createTable($tabledef['name'], $tabledef['type'], $tabledef['fields'], $tabledef['case_sensitive'],$audit);
                    if (!empty($dump))
                        $this->dumpScript = false;
                }
                $error['comments'] = dict('GEN_LBL_FIXED');
            }
            $msg[] = $error;
            if ($tabledef['type'] === 'VIEW') {//nothing else to do if view
                return;
            }
            //checking indexes only if table was created on fix
            if (!empty($fix)) {
                if (!empty($indexes_only) || (empty($indexes_only) && empty($fields_only))) {
                    foreach ($tabledef['indexes'] as $indexname => $indexinfo) {
                        $this->checkFieldIndex($tabledef['name'], $indexname, $indexinfo, $msg, $fix, $dump);
                    }
                }
            }
        } else {
			$tableinfo = $this->getTableInfo($tabledef['name']);
            
			if ($this->debug OR $this->debugCF) {
				echo '-----> table info $tabledef_type vs tableinfo_type line:'.__LINE__;
				PRE($tableinfo['type']);
				pre($tabledef['type']);
			}
            if ($tableinfo['type'] <> '' && $tableinfo['type'] <> 'default' && $tableinfo['type'] <> $tabledef['type']) {
                $error = array('tablename' => $tabledef['name'],
                    'fieldname' => 'DBTB: ' . $tabledef['idname'] . ' (' . $tabledef['idcode'] . ')',
                    'error' => dict('GEN_ERR_TABLE_WRONG_TYPE') . ' Req: ' . $tableinfo['type'] . '  Cur:' . $tabledef['type'],
                    'comments' => '');
                if (!empty($fix)) {
                    if ($tabledef['type'] === 'VIEW') {
                        if (!empty($dump))
                            $this->dumpScript = true;
                        $this->dropTable($tabledef['name']);
                        $this->createView($tabledef['name'], $tabledef['viewsql']);
                        if (!empty($dump))
                            $this->dumpScript = false;
                    }else {

                        if (!empty($dump))
                            $this->dumpScript = true;
                        $this->changeTableType($tabledef['name'], $tabledef['type']);
                        if (!empty($dump))
                            $this->dumpScript = false;
                    }
                    $error['comments'] = dict('GEN_LBL_FIXED');
                }
                $msg[] = $error;
            }

            if ($fix && $tabledef['type'] === 'VIEW') {
                if (!empty($dump))
                    $this->dumpScript = true;
                $this->alterView($tabledef['name'], $tabledef['viewsql']);
                if (!empty($dump))
                    $this->dumpScript = false;
                return;
            }
            //Check case sensitivity
            if ($tabledef['type'] <> 'VIEW' && $tabledef['case_sensitive'] <> $tableinfo['case_sensitive']) {
                $error = array('tablename' => $tabledef['name'],
                    'fieldname' => '',
                    'error' => dict('GEN_LBL_CASE_SENSITIVE') . ' Cur: ' . (($tableinfo['case_sensitive']) ? CLX_NUM_ONE : CLX_NUM_ZERO) . ' Req.:' . (($tabledef['case_sensitive']) ? CLX_NUM_ONE : CLX_NUM_ZERO),
                    'comments' => '');

                if (!empty($fix)) {
                    if (!empty($dump))
                        $this->dumpScript = true;
                    $this->changeTableCaseSensitive($tabledef['name'], $tabledef['case_sensitive']);
                    if (!empty($dump))
                        $this->dumpScript = false;
                    $error['comments'] = dict('GEN_LBL_FIXED');
                }
                $msg[] = $error;
            }

            if (!empty($fields_only) || (empty($indexes_only) && empty($fields_only))) {
				if ($this->debug OR $this->debugCF) { ECHO "<BR>[[(((CHECKFIELDS)))]]<BR>";}
                $this->checkFields($tabledef['name'], $tabledef['fields'], $msg, $fix, $dump);
            }
            //checking indexes
            if (!empty($indexes_only) || (empty($indexes_only) && empty($fields_only))) {
                foreach ($tabledef['indexes'] as $indexname => $indexinfo) {
				//	pre($indexinfo);
                    $this->checkFieldIndex($tabledef['name'], $indexname, $indexinfo, $msg, $fix, $dump);
                }
            }
        }
    }

//Procedures
    function checkProcedure(&$data, $fix, $dump = false) {
        if ($this->existsProcedure($data['IDNAME'])) {
            if (!empty($fix)) {
                if (!empty($dump)) {
                    $this->dumpScript = true;
                }
                $ret = $this->fixProcedure($data);
                if (!empty($dump)) {
                    $this->dumpScript = false;
                }
                return $ret;
            } else {
                return true;
            }
        } else {
            if (!empty($fix)) {
                if (!empty($dump)) {
                    $this->dumpScript = true;
                }
                $ret = $this->createProcedure($data['IDNAME'], $data['PARAMETERS'], $data['ROUTINE_BODY']);
                if (!empty($dump)) {
                    $this->dumpScript = false;
                }
                return $ret;
            } else {
                return true;
            }
        }
    }

    function fixProcedure(&$data) {
        $this->dropProcedure($data['IDNAME']);
        return $this->createProcedure($data['IDNAME'], $data['PARAMETERS'], $data['ROUTINE_BODY']);
    }

    function existsProcedure($name) {
        ClxFreeReturn($name);
    }

    function dropProcedure($name) {
        ClxFreeReturn($name);
    }

    function createProcedure($name, $parameters, $body) {
        ClxFreeReturn($name);
        ClxFreeReturn($parameters);
        ClxFreeReturn($body);
        return null;
    }

    function checkFunction(&$data, $fix, $dump = false) {
        if ($this->existsFunction($data['IDNAME'])) {
            if (!empty($fix)) {
                if (!empty($dump))
                    $this->dumpScript = true;
                $ret = $this->fixFunction($data);
                if (!empty($dump))
                    $this->dumpScript = false;
                return $ret;
            }else {
                return true;
            }
        } else {
            if (!empty($fix)) {
                if (!empty($dump))
                    $this->dumpScript = true;
                $ret = $this->createFunction($data['IDNAME'], $data['PARAMETERS'], $data['ROUTINE_BODY'], $data['RETURN_TYPE']);
                if (!empty($dump))
                    $this->dumpScript = false;
                return $ret;
            }else {
                return true;
            }
        }
    }

    function fixFunction(&$data) {
        $this->dropFunction($data['IDNAME']);
        return $this->createFunction($data['IDNAME'], $data['PARAMETERS'], $data['ROUTINE_BODY'], $data['RETURN_TYPE']);
    }

    function existsFunction($name) {
        ClxFreeReturn($name);
    }

    function dropFunction($name) {
        ClxFreeReturn($name);
    }

    function createFunction($name, $parameters, $body, $return) {
        ClxFreeReturn($name);
        ClxFreeReturn($parameters);
        ClxFreeReturn($body);
        ClxFreeReturn($return);
        return null;
    }

    function hasDefault($tablename, $fieldname) {
        $sql = 'SHOW FIELDS FROM ' . $tablename . ' LIKE ' . singleQuote($fieldname);
        $record = $this->getOneRecord($sql);
        if (empty($record['Default']))
            $record['Default'] = '';
        return (strlen($record['Default']) > CLX_NUM_ZERO) ? true : false;
    }

    function hasNotNull($tablename, $fieldname) {
        $sql = 'SHOW FIELDS FROM ' . $tablename . ' LIKE ' . singleQuote($fieldname) . ' ';
        $record = $this->getOneRecord($sql);
        if (empty($record['Null']))
            $record['Null'] = 'YES';
        return ($record['Null'] === 'NO') ? true : false;
    }

    /**
     * Insert new record in database table.
     * @param: string table, array record
     */
    function createRecordVoid($table, $record, $silent) {
        ClxFreeReturn($this->createRecord($table, $record, $silent));
    }
	// extracriteria para un select en un insert,para que funcione el select $values_or_select DISTINTO DE 'VALUES' ('SELECT' POR EJEMPLO)
    function createRecord($table, $record, $silent=false,$extras=array('type'=>"VALUES",'returnid'=>true,'extracriteria'=>'','selectexistsid'=>'')) {
		//echo $table,"<br>";
	//	pre($extracriteria);
	//	pre($values_or_select);
        ClxFreeReturn($table);
        $fields = '';
        $values = '';
        $comma = '';
        ClxFreeReturn($this->addslashes($record));
        foreach ($record as $field => $value) {
            $fields .= $comma . ' `' . $field . '`';
            if ($value === 'null') {
                $values .= $comma . 'NULL';
			} else if (is_array($value)) { // sample $record['RUNID']=array('ESPECIAL_FIELD'=>' (SELECT MAX(RUNID)+1 FROM RCTA_TRN_MATCH_EXECS) ');
				$values.= $comma . (isset($value['ESPECIAL_FIELD'])?   $value['ESPECIAL_FIELD']:"");	
            } else {
                $values .= $comma . ((uppercase($value) === 'NOW()') ? $value : singleQuote($value));
            }
            $comma = ', ';
        }
		if ($extras['type']=="VALUES") { 
			$sql = 'INSERT INTO ' . $table . ' (' . $fields . ') VALUES (' . $values . ') ';
		}
		else { 
			$sql = 'INSERT INTO ' . $table . ' (' . $fields . ') SELECT ' . $values . ' FROM DUAL '. ((empty($extras['extracriteria']))?'': ' WHERE '.$extras['extracriteria'] );
		
		}
		if ( isset($_SESSION["_dEBUG"]) ) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."91- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10).beautiful_sql($sql,chr(13).chr(10),"    ",false).chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"]))fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));fclose($tta);}
		
		if (!empty($silent) or $this->audit==true) {
            $retorno=$this->executeQuerySilent($sql);
        } else {
            $retorno = $this->executeQuery($sql);
            unset($retorno);
        }

        $this->createIdSave=$this->createdId();
        return $this->createIdSave;
    }

    function  getcreateId() {
        return $this->createIdSave;
    }	

    /**
     * Returns the ID number of Last Insert
     */
    function createdId() {
        //return (int) CLX_NUM_ZERO;
    }

    /**
     *
     * @param string $table
     * @param array $record
     * @param array $criteria
     */
    function updateRecord($table, $record, $criteria) {
        $comma = '';
        $sqlfields = '';
        ClxFreeReturn($this->addslashes($record));
        foreach ($record as $key => $value) {
            $sqlfields .= $comma . ' `' . $key . '`=' . (($value === 'null') ? 'null' : singleQuote($value) );
            $comma = ', ';
        }
        $sql = 'UPDATE ' . $table . ' SET ' . $sqlfields . ' WHERE ' . $criteria;

        return $this->executeQuery($sql);
    }

    /**
     * Creates or Updates record if record found base on criteria
     * @param type $table
     * @param type $record
     * @param type $silent
     * @param type $criteria
     * @return inteer
     */
    function loadDbRecord($table, $record, $silent = false, $criteria = '') {
        $return = CLX_INIT_ZERO;
        if ('' === $criteria) {
            $return = $this->createRecord($table, $record, $silent);
        } elseif ($this->oneExistsRecords($table, $criteria) === CLX_NUM_ZERO) {
			
			
            $return = $this->createRecord($table, $record, $silent);
        } else {
            $return = $this->updateRecord($table, $record, $criteria);
        }
        return $return;
    }

    /**
     * Delete record on database
     * @param: string table, string [, criteria 1].[, criteria n]
     */
    function deleteRecords($table, $criteria) {
        $sql = 'DELETE FROM ' . $table . ($criteria <> null ? ' WHERE ' . $criteria : '');
        $retorno = $this->executeQuery($sql);
        unset($retorno);
    }

    function getRecord($table, $criteria = '') {
        $sql = 'SELECT * FROM ' . $table;
        if (strlen($criteria) > CLX_NUM_ZERO) {
            $sql .= ' WHERE ' . $criteria;
        }
        $rs = $this->executeQuery($sql);

        return $this->getNextRecord($rs, ASSOCIATIVE);
    }

    /**
     * Select records from database and return resource of results.
     * @param: string table, string [, criteria 1].[, criteria n]
     */
    function getRecords($table) {
// Arguments for this function:
// table [, criteria 1].[, criteria n]
        $qty = func_num_args();
        $sql = 'SELECT * FROM ' . $table;
        if ($qty > CLX_NUM_ONE) {
            $boolean = ' WHERE ';
            for ($i = CLX_NUM_ONE; $i < $qty; $i++) {
                $c = func_get_arg($i);
                if (!empty($c)) {
                    $sql .= $boolean . $c;
                    $boolean = ' AND ';
                }
            }
        }
        if($this->ci_search === false) {
            $result = $this->executeQuery($sql);
        } else {
            $result = $this->executeQueryCi($sql);
        }
        return $result;
    }

    function getNextRecord(&$id, $type = ASSOCIATIVE) {
        return mysql_fetch_array($id, $type);
    }

    /**
     * Counts number of record results from sql query
     * @param: string table, string [, criteria 1].[, criteria n]
     */
    function countRecords($table, $criteria = '') {
        $sql = 'SELECT COUNT(1) FROM ' . $table . (!empty($criteria)  ? ' WHERE ' . $criteria : '');
        return intVal($this->getOne($sql));
    }
	function oneExistsRecords($table, $criteria = '') { //sin esto devuelve 0 vs 1a muchos, y con el primero es suficiente
		if (stripos($criteria,'LIMIT')>0 || stripos($criteria,'ROWNUM')>0)
			return $this->countRecords($table,$criteria);
		else {	
			if (kDatabaseType=='oci')
				$sql = 'SELECT COUNT(1) FROM ' . $table . ' WHERE ' .$criteria. (empty($criteria) ? '' : ' AND '). ' ROWNUM = 1';
			else 
				$sql = 'SELECT COUNT(1) FROM ( SELECT 1 FROM ' . $table . (!empty($criteria)  ? ' WHERE ' . $criteria : '').' LIMIT 1) X';
				return intVal($this->getOne($sql));
		}
	}
    /**
     * Return Similar to get field method, but having as input string sql, col 0 row 0 from result on sql
     * @param string $sql
     * @param string $binds
     * @return multitype:
     */
    function getOne($sql, $binds = array()) {
        if($this->ci_search === false) {
            $rs = $this->executeQuery($sql, $binds);
        } else {
			if (empty($binds))
				$rs = $this->executeQueryCi($sql);
			else
				$rs = $this->executeQueryCiBinds($sql,$binds);
        }
        $rs2 = $this->getNextRecord($rs, NUMERIC);
        ClxFreeReturn($binds);
        if($this->ci_search === false) {
            $this->executeQueryCiResetSesVars();
        }
        return (isset($rs2[CLX_NUM_ZERO]) && !clx_is_empty($rs2[CLX_NUM_ZERO])) ? $rs2[CLX_NUM_ZERO] : null;
    }

    /**
     * Return Similar to get field method, but having as input string sql, col 0 row 0 from result on sql
     * @param string $sql
     * @param array $binds
     * @return multitype:
     */
    function getOneRecord($sql, $binds = array()) {
        ClxFreeReturn($binds);
		// 2018-06-04 CR
        //$rs = $this->executeQuery($sql);
        $rs = $this->executeQuery($sql, $binds);

        return $this->getNextRecord($rs, ASSOCIATIVE);
    }

    /**
     * Perform sql and return selected field value from result set
     * @param:string table, string fieldname, string [, criteria 1].[, criteria n]
     */
    function getField($table, $field) {
        $field = uppercase($field);
        $sql = 'SELECT ' . $field . ' FROM ' . $table;
        $qty = func_num_args();
        if ($qty > CLX_NUM_TWO) {
            $sql .= ' WHERE ';
            $boolean = '';
            for ($i = CLX_NUM_TWO; $i < $qty; $i++) {
                $sql .= $boolean . func_get_arg($i);
                $boolean = ' AND ';
            }
        }
        $result = $this->executeQuery($sql);
        $value = $this->getNextRecord($result, ASSOCIATIVE);
        $this->freeResult($result);
        return ($value != false) ? $value[$field] : false;
    }

    /**
     * Perform sql and return selected fields value from result set
     * @param:string table, string fieldname, string [, criteria 1].[, criteria n]
     */
    function getFields($table, $field) {
        $sql = 'SELECT ' . $field . ' FROM ' . $table;
        $qty = func_num_args();
        if ($qty > CLX_NUM_TWO) {
            $sql .= ' WHERE ';
            $boolean = '';
            for ($i = CLX_NUM_TWO; $i < $qty; $i++) {
                $sql .= $boolean . func_get_arg($i);
                $boolean = ' AND ';
            }
        }
        $result = $this->executeQuery($sql);
        $value = $this->getNextRecord($result, ASSOCIATIVE);
        return $value;
    }

    /**
     * Returns boolean after counting result from query
     * @param: string $table, string fieldname, string value
     */
    function keyExists($table, $field, $value) {
        return $this->oneExistsRecords($table, $field . '=' . singleQuote($value)) > CLX_NUM_ZERO;
    }

    /**
     * Moves the internal row pointer to the specified row number on result set
     * @param: resource cursor, int position
     */
    function moveTo($cursor, $position) {
        mysql_data_seek($cursor, $position);
    }

    /**
     * Returns the number of field columns on result set
     * @param: resource cursor
     */
    function numFields($cursor) {
        return mysql_num_fields($cursor);
    }

    /**
     * Returns the number of rows on result set
     * @param: resource cursor
     */
    function numRows($cursor) {
        return mysql_num_rows($cursor);
    }

    /**
     * Return field name
     * @param: resource cursor
     */
    function fieldName($cursor, $field_num) {
        return mysql_field_name($cursor, $field_num);
    }

    function executeQueryFile($sqlqueryfileid) { // ?? Not working
        $cacheFile = kPathToWWW . kPathToImport . 'f' . $sqlqueryfileid . '.sql';
        if (!file_exists($cacheFile)) {
            return 'Bad sql query file id';
        }
        $contents = file($cacheFile);
        $qty = count($contents);
        for ($i = CLX_INIT_ZERO; $i < $qty; $i++) {
            $retorno = $this->executeQuery(trim($contents[$i]));
            unset($retorno);
        }
        unlink($cacheFile);
    }

    /**
     * Dump Information about result set.
     * @param: resource resultset
     */
    function dumpRecords($records) {
        $contenidoHTML = '';
        $fields = array();
        $contenidoHTML.='<table border="1" cellspacing="0" cellpadding="0">' . CLX_CHAR_NL;
        $qty = $this->numFields($records);
        $contenidoHTML.='<tr>';
        for ($i = CLX_INIT_ZERO; $i < $qty; $i++) {
            $fields[$i] = $this->fieldName($records, $i);
            $contenidoHTML.=Sprintf('<td><b>%s</b></td>', $fields[$i]);
        }
        $contenidoHTML.='</tr>' . CLX_CHAR_NL;
        while (($record = $this->getNextRecord($records, ASSOCIATIVE))) {
            $contenidoHTML.='<tr>';
            for ($i = CLX_INIT_ZERO; $i < $qty; $i++) {
                $contenidoHTML.=Sprintf('<td>%s</td>', ((isset($record[$fields[$i]])) ? $record[$fields[$i]] : ''));
            }
            $contenidoHTML.='</tr>' . CLX_CHAR_NL;
        }
        $contenidoHTML.='</table>' . CLX_CHAR_NL;
        echo $contenidoHTML;
    }

    function addslashes(&$something) {
      //  $ignore = get_magic_quotes_gpc(); //deprecada 7.4
      //  if (empty($ignore)) {
            if (is_array($something)) {
                foreach ($something as $key => &$value) {
					if (!is_array($value)) {
						$value = $this->addslashes($value);
					}
                }
            } else {
                $something = addslashes($something);
            }
        //}
        return $something;
    }

    function stripslashes(&$something) {
      //  $ignore = get_magic_quotes_gpc(); //deprecada 7.4
      //  if (empty($ignore)) {
            if (is_array($something)) {
                foreach ($something as $key => $value) {
                    $value = $this->stripslashes($value);
                    $something[$key] = $value;
                }
            } else {
                $something = stripslashes($something);
            }
//        }
        return $something;
    }

    /**
     * Prepares dates acording database implementation default mysql stile
     */
    function prepareDate(&$date) {
        $date = singleQuote($date);
    }

    /**
     * Retuns SQL SELECT with MySQL's LIMIT emulation.
     */
    function select_limit($sql, $limit_string, $fromclause = '', $groupclause = '') {
        // Agrega LIMIT a instrucciones SELECT | Caso 1001929 - BNYM-Migracion de clx5dev a oracle | CR 2018-07-19 
        $limit_string = str_replace('LIMIT ', '', $limit_string);
        return $sql  . ' LIMIT ' . $limit_string;
    }

    /**
     * Return readible string from lob object
     */
    function getLob($lob) {
        return $lob;
    }

// DB MANTEINANCE RELATED METHOD
    /**
     * Reindex table or Tables if not tablecode is provided.
     *
     * @param string [$tablename]
     * @return void
     */
    function buldStats($tablename = '') {
        if ('' === $tablename) {
            $tables = $this->tables();
            foreach ($tables as $key => $val) {
                $retorno = $this->executeQuery('OPTIMIZE TABLE ' . $val);
            }
        } else {
            $retorno = $this->executeQuery('OPTIMIZE TABLE ' . $tablename);
        }
        unset($retorno);
    }

    /**
     * Clear cache spool
     *
     * @param string [$tablename]
     * @return void
     */
    function clearSpool() {

    }

    /**
     * format dimension of the value
     * @param string $dimension
     * @return string
     */
    function getMaxNumberFromDimension($dimension) {
        $parts = explode(',', $dimension);
        $int = '' . intval($parts[CLX_INIT_ZERO]);
        $dec = (!empty($parts[1])) ? '' . intval($parts[1]) : 0;
        $max = bcpow('10', $int);
        $maxdec = bcpow('10', $dec);
        $maxval = ($dec > '0') ? rounder(bcdiv(bcsub($max, '1'), $maxdec), $dec) : bcsub($max, '1');
        return $maxval;
    }

    function db_to_date($colname, $fmt = 'yyyy-mm-dd') {
    //function db_to_date($date_par, $fmt = 'yyyy-mm-dd') {
        //return singleQuote($date_par);
        return $colname;
    }

    function db_to_datetime($colname, $fmt = 'yyyy-mm-dd hh24:mi:ss') {
    //function db_to_datetime($datetime_par, $fmt = 'yyyy-mm-dd hh24:mi:ss') {
        //return $this->db_to_date($datetime_par, $fmt);
        return $this->db_to_date($colname, $fmt);
    }
    
    function extrac_dbms_sql($sql) {
        if(!defined('DBMS_OCI_TOKEN')) {
            define('DBMS_OCI_TOKEN', '{*}{oci}');
            define('DBMS_MSSQL_TOKEN', '{*}{mssql}');
            define('DBMS_MYSQL_TOKEN', '{*}{mysql}');
        }
        $response_sql = array(
            'mysql' => str_replace(DBMS_MYSQL_TOKEN, '', $sql),
            'oci' => '',
            'mssql' => ''
        );
        // Extrae la parte Oracle
        $parts = explode(DBMS_OCI_TOKEN, $response_sql['mysql']);
        $response_sql['mysql'] = trim($parts[0]);
        $response_sql['oci'] = (isset($parts[1]) ? trim($parts[1]) : '');
        // Extrae la parte SQL Server 1
        $parts = explode(DBMS_MSSQL_TOKEN, $response_sql['mysql']);
        $response_sql['mysql'] = trim($parts[0]);
        $response_sql['mssql'] = (isset($parts[1]) ? trim($parts[1]) : '');
        // Extrae la parte SQL Server 2
        $parts = explode(DBMS_MSSQL_TOKEN, $response_sql['oci']);
        $response_sql['oci'] = trim($parts[0]);
        $response_sql['mssql'] = (isset($parts[1]) ? trim($parts[1]) : '');
        switch (kDatabaseType) {
            case 'oci': // Oracle
                if($response_sql['oci'] !== '') {
                    return $response_sql['oci'];
                }
                break;
            case 'mssql': // MS SQL Server
                if($response_sql['mssql'] !== '') {
                    return $response_sql['mssql'];
                }
                break;
        }
        // MySQL Version all others
        return $response_sql['mysql'];
    }

    /**
     * Duplicate Table y truncate from database
     * Se duplica la tabla a una temporal y se vacia la tabla original
     * Esto se hace para poder hacer un ALTER TABLE en Oracle cuando la tabla tiene datos,
     * porque en algunos casos, Oracle da error cuando se intenta hacer esto.
     */
    function preAlterTable ($tablename) {
        return '';
    }
    
    /**
     * Insert data and Drop Table from database
     * Inserta la data desde la temporal hacia la tabla original 
     * y luego borra la tabla temporal.
     * Esto se hace para poder hacer un ALTER TABLE en Oracle cuando la tabla tiene datos,
     * porque en algunos casos, Oracle da error cuando se intenta hacer esto.
     */
    function postAlterTable($tablename) {
        return '';
    }
    
    function cast_to_char($colname) {
        return 'CONVERT(' . $colname . ' USING UTF8)';
    }
	function drop_real_orphans_fisic_fields($tablecode='',$tablename='',$fix) {
		if (empty($tablename)&& empty($tablecode)) {
			return ;
		}
		if ($tablename=='') {
			$tablename=$this->getone('SELECT CONCAT(DBTB.MODULECODE,CONCAT('.singleQuote('_').',DBTB.IDNAME)) TABLENAME FROM CLX_DB_TABLES DBTB WHERE DBTB.TABLECODE= '.singlequote($tablecode));
		}
		if ($tablecode=='') {
			$tablecode=$this->getone('SELECT TABLECODE FROM CLX_DB_TABLES WHERE CONCAT(DBTB.MODULECODE,CONCAT('.singleQuote('_').',DBTB.IDNAME)) = '.singlequote($tablename));
		}
		switch (kDatabaseType) {
			case 'oci': // Oracle
				$rs = $this->executeQuerySilent($sql='SELECT column_name, data_type,CASE WHEN data_type='.singlequote('NUMBER').' THEN TRIM(TO_CHAR(DATA_PRECISION))||'.singlequote('.').'||TRIM(TO_CHAR(DATA_SCALE)) ELSE  TO_CHAR(data_length) END  data_length  FROM all_tab_columns WHERE table_name = '.singleQuote($tablename)); 
				
			//	e cho $sql;
				break;
			default:
				$rs = $this->executeQuerySilent('describe '.$tablename);
			break;
		}
		
		$arreglo_fisic_fields=array();
		$retorno=false;
	//	e cho "<br>============<br>";
	  	while ($r = $this->getNextRecord($rs, NUMERIC)) {
			$arreglo_fisic_fields[]=$r[0];
		}
		$sql = 'SELECT F.FIELDNAME FROM CLX_DB_TABLES TB, CLX_DB_TABLEFIELDS TF, CLX_DB_FIELDS F WHERE TB.IDCODE = TF.TABLECODE AND TF.FIELDNAME = F.FIELDNAME AND TB.TYPE NOT IN (' . CLX_CHAR_SINGLE_QUOTE . 'VIEW' . CLX_CHAR_SINGLE_QUOTE . ') AND TF.TABLECODE = ' . singleQuote($tablecode) ;
				
		$rs = $this->executeQuerySilent($sql);
		$arreglo_clientix;
		while ($r = $this->getNextRecord($rs, NUMERIC)) {
			$arreglo_clientix[]=$r[0];
		}
		$orphans=array();
		foreach ($arreglo_fisic_fields as $key=>$campo) {
			if (!in_array($campo,$arreglo_clientix)&& (substr($campo,0,11)!='RECURRENT_R')) {		
			    if ($fix) {
					$this->dropField($tablename, $campo);
				}	
				$orphans[]= array($campo,"",dict('GEN_LBL_ORPHANS_FIELDS').(!empty($fix) ? "(".dict("GEN_LBL_KILL").")":""));
				
			}	
		}
		
		return $orphans;
	
	}
   /**
     * Creates or Updates record if record found base on criteria
     * @param string $table
     * @param array $record
     * @param bool $silent
     * @return int
     */
    function loadRecord($table, $record, $silent = false) {

        $crits = '';
        $qty = func_num_args();
        if ($qty > 3) {
            $boolean = "";
            for ($i = 3; $i < $qty; $i++) {
                $crits .= $boolean . func_get_arg($i);
                $boolean = " AND ";
            }
        }
        if ($crits == '') {
            return $this->createRecord($table, $record, $silent);
        } else {
            if ($this->oneExistsRecords($table, $crits) == 0) {
                return $this->createRecord($table, $record, $silent);
            } else {
                return $this->updateRecord($table, $record, $crits);
            }
        }
    }		
	function describe_table($tablename='') {
		if (empty($tablename)) {
			return array();
		}
		switch (kDatabaseType) {
			case 'oci': // Oracle
//				$rs = $this->executeQuerySilent('SELECT column_name, data_type,data_length  FROM all_tab_columns  WHERE table_name = '.singleQuote($tablename)); 
				$rs = $this->executeQuerySilent($sql='SELECT column_name, data_type,CASE WHEN data_type='.singlequote('NUMBER').' THEN TRIM(TO_CHAR(DATA_PRECISION))||'.singlequote('.').'||TRIM(TO_CHAR(DATA_SCALE)) ELSE  TO_CHAR(data_length*2) END  data_length  FROM all_tab_columns WHERE table_name = '.singleQuote($tablename)); 
			
			//	e cho $sql;
				break;
			default:
				$rs = $this->executeQuerySilent('describe '.$tablename);
			break;
		
		}
		$fisic_fields=array();
		$key_fisic_fields=array();
		$size_fields=array();
        if (!empty($rs)) {
			while ($r = $this->getNextRecord($rs, NUMERIC)) {
				$r[1]=strtoupper(preg_replace('/\((.*?)\)/i', '',$r[1]));
				$fisic_fields[strtoupper($r[0])]=$r[1];
				$key_fisic_fields[]=strtoupper($r[0]);
				IF ($r[1]=='NUMBER' && $r[2]=='.')
					$r[2]='22.0';
				
				$size_fields[strtoupper($r[0])]=$r[2];
				//$type_fields[strtoupper($r[0])]=$r[1];
			}
		}
		
		$x=  array('fisic_fields'=>$fisic_fields,'key_fisic_fields'=>$key_fisic_fields,'size_fields'=>$size_fields);
		return $x;
	}
	/**
     * Replace invalid values not required by oracle
     * @param mixed $val
     */
    function replaceInvalidValues(&$val) {
		if (is_Array($val)) {
			
		}
		else {	
			switch (strval($val)) {
				case '0000-00-00 00:00:00':
				case '0000-00-00':
				case 'null':
					$val = '';
					break;
				default:
					//do nothing
					break;
			}
		}
	}
	function getTableNameFromCode($tablecode) {
        $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
        return $tablerec['MODULECODE'].'_'.$tablerec['IDNAME'];
    }

}
