<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version        $Rev: 9902 $
 * @package		Clientix.Classes.Session
 * @abstract		Session Class
 * CHANGE LOG
 *  Included label
 */
class ClxSession {

    var $tablename;
    var $key;
    var $name;
    var $path;
    var $time_to_expire;
    var $expire_stamp;
    var $start_time;
    var $regenerate = false;

    /**
     * Constructor
     */
    function __construct() {
        $this->key = session_id();
        $this->time_to_expire = kSessionTimeout * CLX_NUM_60;
        $this->expire_stamp = adodb_date('Y-m-d H:i:s', (adodb_strtotime('now') + $this->time_to_expire));
        $this->start_time = adodb_date('Y-m-d H:i:s', adodb_strtotime('now'));
        $this->tablename = 'CLX_AC_USER_SESSIONS';
        session_set_save_handler(array(&$this, 'open'), array(&$this, 'close'), array(&$this, 'read'), array(&$this, 'write'), array(&$this, 'destroy'), array(&$this, 'trashMan'));
		
		if (defined('kAppCkd')) {
			session_set_cookie_params(
						 (!defined('kAppCkt')?3600:kAppCkt),
						 '/',
						 kAppCkd,
						(!defined(kAppCks)?0:1),
						 (!defined(kAppCkh)?0:1)
					);
		}	
		session_start(); 
		
		$_SESSION["maxdebug"]=isset($_GET["maxdebug"])? $_GET["maxdebug"]:4000000;
		$rutaarchivo=str_replace("//","/",kPathToWebSite."/".kPathToTemp."archivo.txt");
		if (isset($_GET["_dEBUG"]) ){
			$_SESSION["_dEBUG"]=($_GET["_dEBUG"] !=99)?1:99;
			
			$tta=fopen($rutaarchivo,"a+");
			fclose($tta);	
		}
		
		if (isset($_SESSION["_dEBUG"])) {
			
			$tta=fopen($rutaarchivo,"a+");
			fwrite($tta,"-------------------------------------------------".CHR(13).CHR(10).CHR(13).CHR(10));
			if (isset($_GET))
				fwrite($tta,"GET-".CHR(13).CHR(10).var_export($_GET,true).CHR(13).CHR(10));
			if (isset($_POST))
				fwrite($tta,"POST-".CHR(13).CHR(10).var_export($_POST,true).CHR(13).CHR(10));
			if (isset($argv))
				fwrite($tta,"ARG-".CHR(13).CHR(10).var_export($argv,true).CHR(13).CHR(10));
			fclose($tta);	
		}
		//PRINT_r($_GET);
		$YES=0;
		#$print_r($_SESSION);
		
		foreach($_GET as $key=>$value) {
			if (substr($key,0,9)=='ADDRDEBUG') {
				$_SESSION[$key]=$_SERVER['REMOTE_ADDR'];
				$YES=1;	
				pre($key);	
			}
		}//$_SESSION['ADDRDEBUGMYSQL']='201.211.243.171';
		IF (isset($_GET['ADDRDEBUGAPAGA']) OR isset($_GET['ADDRDEBUGLIMPIA'])OR isset($_GET['ADDRDEBUGRESET'])) {
			$arrays=array_keys($_SESSION);
			foreach (preg_grep("/ADDRDEBUG/",$arrays) as $key=>$values) {
				echo " delete $values<br>";
				unset($_SESSION[$values]);
			
			}
		}
		if (isset($_SESSION['ADDRDEBUGCREATEFIELD'])){
			ClxCommon::$db->debugCF=true;
		}	
		if (isset($_SESSION['ADDRDEBUGCREATEINDEX'])){
			ClxCommon::$db->debugCI=true;
		}
		if (isset($_SESSION['ADDRDEBUGVIEWSQL'])){
			ClxCommon::$db->debugVIEW=true;
		}
		if (kDatabaseType == 'oci') {
			if (isset($_SESSION['DATABASE_VERSION'])) {
				$_SESSION['DATABASE_VERSION']=ClxCommon::$db->getone('Select * from v$version where rownum=1');
			}
		}
		else {	
			if (!isset($_SESSION['DATABASE_VERSION'])) {
				 $_SESSION['DATABASE_VERSION']=ClxCommon::$db->getone('Select version()');
			}
		}

    }

    /**
     * Open property
     * @param type $save_path
     * @param type $session_name
     * @return boolean
     */
    public function open($save_path, $session_name) {
        $this->path = $save_path;
        $this->name = $session_name;
        return true;
    }

    public function close() {
        return true;
    }

    public function read($key) {
        $contents = '';
        $this->key = $key;
        $d = date('Y-m-d H:i:s');
        $record = ClxCommon::$db->getRecord($this->tablename, 'SESSION_KEY=' . singleQuote($key) . ' AND XDATE >' . singleQuote($d));
        if (!empty($record ['SESSION_DATA'])) {
            $contents = (kDatabaseType === 'oci') ? $record ['SESSION_DATA'] : stripslashes($record ['SESSION_DATA']);
        } else {
            $contents = '';
        }
        return $contents;
    }

    public function write($key, $value) {
        ClxCommon::$db->commit();
        ClxCommon::$db->setAutocommit(true);
        $record = array('USERNAME' => '', 'SESSION_KEY' => $key, 'SESSION_IP' => ClxSession::getSessionIp(), 'XDATE' => $this->expire_stamp, 'SESSION_DATE' => $this->expire_stamp);
        if (!empty($_SESSION ['user_record'] ['username'])) {
            $record ['USERNAME'] = $_SESSION ['user_record'] ['username'];
        }
        $record ['SESSION_DATA'] = (kDatabaseType === 'oci') ? $value : addslashes($value);
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'SESSION_KEY=' . singleQuote($key) . ' ') === CLX_NUM_ZERO) {
            $record ['CDATE'] = $this->start_time;
            ClxCommon::$db->createRecord($this->tablename, $record, false);
        } else {
            ClxCommon::$db->updateRecord($this->tablename, $record, 'SESSION_KEY=' . singleQuote($key));
        }
        ClxCommon::$db->commit();
        return true;
    }

    public function destroy($key) {
        ClxCommon::$db->deleteRecords($this->tablename, 'SESSION_KEY IN (' . singleQuote($key) . ',' . singleQuote($this->key) . ')');
        ClxCommon::$db->commit();
        return true;
    }

    public function trashMan() {
        $ACAD = &getTool('ACAD');
        $d = date('Y-m-d H:i:s');
        $records = ClxCommon::$db->getRecords($this->tablename, 'XDATE<' . singleQuote($d));
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
            $username = $record['USERNAME'];
            $ACAD->log('', '0', 'TIMEOUT', $username, '');
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'XDATE<' . singleQuote($d));
        ClxCommon::$db->commit();
        return true;
    }

    static function getSessionIp() {
        return (!empty($_SESSION['ip'])) ? $_SESSION['ip'] : ( isset(UserRequest::$server['REMOTE_ADDR']) ? UserRequest::$server['REMOTE_ADDR'] : '127.0.0.1' );
    }
}