<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-25 11:56:58 +0000 (Fri, 25 Sep 2015) $
 * @version        $Rev: 7004 $
 * @package		Clientix.Classes.Tree
 * @abstract		General Tree Class
 * CHANGE LOG
 *  Included label
 */
class clx_dataleaf {

    var $element_id;
    var $element;
    var $type;    // Type of this entry FIELD, TABLE, LOOKUP
    var $sons;    // the sons of this entry
    var $parent_tablecode;
    var $look_reverse_type; //Flag to describe if this is a reverse lookup lookfieldchield:chield
    var $tablecode;
    var $lookup_table;
    var $lookup_field;
    var $form_fieldname; // The fieldname in the form
    var $fieldname;   // the record fieldname
    var $prefix;
    var $sufix;
    var $format;
    var $value;    // Value of the field
    var $criteria;   // Criteria to select a record in a table
    var $error;
    var $errormsg;
    var $debug;

    function clx_dataleaf($parent_tablecode, $form_fieldname, $elementid, $element, $formating_data) {
        $this->elementid = $elementid;
        $this->element = $element;
        $this->parent_tablecode = $parent_tablecode;
        $this->sons = array();
        $this->look_reverse_type = false;
        $this->error = false;
        $this->debug = false;
        //$this->debug = true;
        $this->prefix = (!empty($formating_data['prefix'])) ? $formating_data['prefix'] : '';
        $this->sufix = (!empty($formating_data['sufix'])) ? $formating_data['sufix'] : '';
        $this->format = (!empty($formating_data['FORMAT'])) ? $formating_data['FORMAT'] : CLX_NUM_ZERO;
        $braket = strpos($element, '[');
        if (!empty($braket)) {
            $close_braket = strpos($element, ']');
            $this->criteria = substr($element, $braket + CLX_NUM_ONE, $close_braket - $braket - CLX_NUM_ONE);
            $element = substr($element, CLX_NUM_ZERO, $braket) . substr($element, $close_braket + CLX_NUM_ONE);
        }
        $colon = strpos($element, ':');
        if (substr($element, CLX_NUM_ZERO, CLX_NUM_ONE) === '!') {
            $this->type = 'VAR';
        } elseif (!empty($colon)) {
            $this->type = 'LOOKUP';
            $this->look_reverse_type = false; //setting base condition normal search
            $subelement1 = substr($element, CLX_NUM_ZERO, $colon);
            $subelement2 = substr($element, $colon + CLX_NUM_ONE);
            if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($subelement1)) == CLX_NUM_ONE) {
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($subelement2)) == CLX_NUM_ONE) {
                    $this->lookup_table = $subelement1;
                    $this->lookup_field = $subelement2;
                } else {
                    $this->error = true;
                    $this->errormsg .= $subelement2 . ' is not a field<br>';
                }
            } elseif (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'FIELDNAME=' . singleQuote($subelement1) . ' AND TABLECODE=' . singleQuote($this->parent_tablecode)) == CLX_NUM_ONE) {
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($subelement2)) == CLX_NUM_ONE) {
                    $this->lookup_table = $subelement2;
                    $this->lookup_field = $subelement1;
                } else {
                    $this->error = true;
                    $this->errormsg .= $subelement1 . ' is not a field in table ' . $this->parent_tablecode . ', or ' . $subelement2 . ' is not a table<br>';
                }
            } elseif (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'FIELDNAME=' . singleQuote($subelement1) . ' AND TABLECODE=' . singleQuote($subelement2)) == CLX_NUM_ONE) {
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($subelement2)) == CLX_NUM_ONE) {
                    $this->lookup_table = $subelement2;
                    $this->lookup_field = $subelement1;
                    $this->look_reverse_type = true;  //setting reverse look
                } else {
                    $this->error = true;
                    $this->errormsg .= $subelement1 . ' is not a field in table ' . $this->parent_tablecode . ' , or ' . $subelement2 . ' is not a table<br>';
                }
            } else {
                $this->error = true;
                $this->errormsg .= $subelement1 . ' is not a field nor a table<br>';
            }
        } else {
            $element_scaped = addslashes($element);
            if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($element_scaped)) == CLX_NUM_ONE) {
                if (($this->parent_tablecode === '') or $this->dynamicRelationExists($this->parent_tablecode, $element)) {
                    $this->type = 'TABLE';
                    $this->tablecode = $element;
                } else {
                    $this->error = true;
                    $this->errormsg .= 'There is no relation ' . $this->parent_tablecode . ' to ' . $element . '<br>';
                }
            } elseif (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'FIELDNAME=' . singleQuote($element_scaped) . ' AND TABLECODE=' . singleQuote($this->parent_tablecode)) == CLX_NUM_ONE) {
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($element)) == CLX_NUM_ONE) {
                    $this->type = 'FIELD';
                    $this->fieldname = $element;
                    $this->form_fieldname = $form_fieldname;
                } else {
                    $this->error = true;
                    $this->errormsg .= $element . ' is not a field<br>';
                }
            } else {
                $this->error = true;
                $this->errormsg .= $element . ' is not a field in ' . $this->parent_tablecode . ' nor a it is table<br>';
            }
        }
    }

    function getParent() {
        switch ($this->type) {
            case 'VAR':
            case 'FIELD':
                $retorno = $this->parent_tablecode;
                break;
            case 'TABLE':
                $retorno = $this->tablecode;
                break;
            case 'LOOKUP':
                $retorno = $this->lookup_table;
                break;
            default:
                $retorno = null;
                break;
        }
        return $retorno;
    }

    function parse($parent_tablecode, $form_fieldname, $elementid, $map, $formating_data) {
        if (!empty($this->debug))
            echoLog('Parsing: ' . $map . '<br>');
        $period = strpos($map, '.');
        if (!empty($period)) {
            $element = substr($map, CLX_NUM_ZERO, $period);
            $map = substr($map, $period + CLX_NUM_ONE);
        } else {
            $element = $map;
            $map = '';
        }
        if (!empty($this->debug))
            echoLog('--> Element: ' . $element . '<br>');
        if (!empty($this->debug))
            echoLog('--> Parent: ' . $parent_tablecode . '<br>');
        if (!array_key_exists($element, $this->sons)) {
            $this->sons[$element] = new clx_dataleaf($parent_tablecode, $form_fieldname, $elementid, $element, $formating_data);
        }
        if (empty($this->sons[$element]->error))
            if (strlen($map) != CLX_NUM_ZERO)
                $this->sons[$element]->parse($this->sons[$element]->getParent(), $form_fieldname, $elementid, $map, $formating_data);
        return $this->error;
    }

    function load_dataleaf($recordid, $record, $parent_tablecode, &$answers) {
        $question = '';
        $godeep = true;
        if ($this->parent_tablecode === '') {
            $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($this->tablecode));
            $newrecord = ClxCommon::$db->getRecord($tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'], 'ID=' . $recordid);
            $parent_tablecode = $this->tablecode;
            if (!empty($this->debug))
                echoLog('Loaded first table: ' . $this->tablecode . '<br>');
        } else {
            if (!empty($this->debug))
                echoLog('Loading ' . $parent_tablecode . ':' . $recordid - '<br>');
            switch ($this->type) {
                case 'FIELD':
                    if (!empty($this->debug))
                        echoLog('FIELD: ' . $this->fieldname . '<br>');
                    $this->value = $record[uppercase($this->fieldname)];
                    if (!empty($this->debug))
                        echoLog('--> Computed Value: ' . $this->value . '<br>');
                    break;
                case 'LOOKUP':
                    //getting lookup table field info
                    $lookup_tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($this->lookup_table));
                    $lookup_tablename = $lookup_tablerec['MODULECODE'] . '_' . $lookup_tablerec['IDNAME'];
                    //getting lookup field info
                    $lookup_fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($this->lookup_field));
                    if (!empty($this->debug)) {
                        echoLog('<br><br>ADDITIONAL INFORMATION<br><br>Look Table Information:<br>' . print_r($lookup_tablerec, true) .
                                '<br><br>Lookup Field Information:<br>' .
                                print_r($lookup_fieldrec, true) .
                                '<br><br>Lookup Field Information:<br>' . print_r($record, true) . '<br><br>');
                    }//end debug
                    if (!empty($this->debug))
                        echoLog('--> ' . $parent_tablecode . '.' . $this->lookup_field . '=' . $this->lookup_table . '<br>');
                    if (!empty($this->look_reverse_type)) {
                        $sql = 'SELECT ' . $this->lookup_table . '.*  FROM ' . $lookup_tablename . ' ' . $this->lookup_table . ' WHERE ' . $this->lookup_table . ' . ' . $lookup_fieldrec['FIELD_EXTRA2'] . ' = ' . singleQuote($record[uppercase($this->lookup_field)]);
                    } else { //id reverse
                        $sql = 'SELECT ' . $this->lookup_table . '.*  FROM ' . $lookup_tablename . ' ' . $this->lookup_table . ' WHERE ' . $this->lookup_table . ' . ' . $lookup_field . ' = ' . singleQuote($record[uppercase($this->lookup_field['FIELD_EXTRA2'])]);
                    }//end if reverse
                    if (strlen($this->criteria) > CLX_NUM_ZERO && $this->criteria !== '?') {
                        $sql .= ' and ' . $this->lookup_table . '.' . $this->criteria;
                    }
                    if (!empty($this->debug))
                        echoLog('-->' . $sql . '<br>');
                    $records = ClxCommon::$db->executeQuery($sql);
                    $qty = ClxCommon::$db->numRows($records);
                    //******************START ADDITION ?
                    if (($this->criteria === '?') and ( $qty > CLX_NUM_ZERO)) {
                        if (!empty($this->look_reverse_type)) {
                            $question = $this->lookup_table . ':' . $lookup_fieldrec['FIELD_EXTRA2'] . ':' . $record[$this->lookup_field];
                        } else { //id reverse
                            $question = $this->lookup_table . ':' . $this->lookup_field . ':' . $record[uppercase($lookup_fieldrec['FIELD_EXTRA2'])];
                        }//end if reverse
                        if (!empty($this->debug))
                            echoLog('Question: ' . $question . '<br>');
                        if (array_key_exists($question, $answers)) {
                            if (!empty($this->debug))
                                echoLog('--> Found!<br>');
                            $recordid = $answers[$question];
                            $newrecord = ClxCommon::$db->getRecord($lookup_tablename, 'ID=' . $recordid);
                            $question = '';
                        }
                        //-**********************end addition ?
                    }elseif ($qty == CLX_NUM_ZERO) {
                        $godeep = false;
                    } else {
                        $newrecord = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE);
                        $recordid = $newrecord['ID'];
                    }
                    break;
                case 'TABLE': // if the type is table is really a dynamic relation
                    if (!empty($this->debug))
                        echoLog('--> Tablename: ' . $this->tablecode . '<br>');
                    $rel_rec = ClxCommon::$db->getRecord('CLX_DB_DYNRELATIONS', 'PARENT_TABLECODE=' . singleQuote($this->parent_tablecode) . ' AND CHILD_TABLECODE=' . singleQuote($this->tablecode) . ' AND RELATION_TYPE = 0');
                    $rel_tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($rel_rec['TABLECODE']));
                    $rel_tablename = $rel_tablerec['MODULECODE'] . '_' . $rel_tablerec['IDNAME'];
                    $table_rec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($this->tablecode));
                    $tablename = $table_rec['MODULECODE'] . '_' . $table_rec['IDNAME'];
                    $sql = 'SELECT ' . $this->tablecode . '.*  FROM ' . $rel_tablename . ' x ,' . $tablename . ' ' . $this->tablecode . ' WHERE ' . 'x.PARENT_TABLECODE = ' . singleQuote($this->parent_tablecode) . ' and x.parent_recordid = ' . $recordid . ' and CHILD_TABLECODE = ' . singleQuote($this->tablecode) . ' and CHILD_RECORDID = ' . $this->tablecode . '.ID';
                    if (($this->criteria !== '?') and ! empty($this->criteria)) {
                        $sql .= ' AND ' . $this->criteria;
                    }
                    $result = ClxCommon::$db->executeQuery($sql);
                    $qty = ClxCommon::$db->numRows($result);
                    if (($this->criteria === '?') and ( $qty > CLX_NUM_ZERO)) {
                        $question = $parent_tablecode . ',' . $table_rec['IDCODE'];
                        if (!empty($this->debug))
                            echoLog('Question: ' . $question . '<br>');
                        if (array_key_exists($question, $answers)) {
                            if (!empty($this->debug)) {
                                echoLog('--> Found!<br>');
                            }
                            $recordid = $answers[$question];
                            $newrecord = ClxCommon::$db->getRecord($tablename, 'ID=' . $recordid);
                            $question = '';
                        }
                    } elseif ($qty > CLX_NUM_ZERO) {
                        $newrecord = ClxCommon::$db->getNextRecord($result);
                        $recordid = $newrecord['ID'];
                    } else {
                        if (!empty($this->debug)) {
                            echoLog('--> No records in relation<br>');
                        }
                        $godeep = false;
                    }
                    $parent_tablecode = $this->tablecode;
                    break;
                case 'VAR':
                    $godeep = false;
                    break;
                default:
                    break;
            }
        }
        if (empty($question) and $godeep) {
            foreach ($this->sons as $key => $value) {
                $question = $this->sons[$key]->load_dataleaf($recordid, $newrecord, $parent_tablecode, $answers); // $value is a copy of the entry.  I want the entry, not a copy
                if (!empty($question))
                    break;
            }
        }
        return $question;
    }

    function clear() {
        $this->value = '';
        foreach ($this->sons as $key => $value) {
            $this->sons[$key]->clear();
        }
    }

    function set(&$callback) {
        if ($this->type === 'FIELD') {
            if (!empty($this->format)) {
                $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($this->fieldname));
                $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
                $record = array();
                $record[$fieldrec['FIELDNAME']] = $this->value;
                $value = $fieldinstance->formatField($fieldrec['FIELDNAME'], $fieldrec, $record);
            } else {
                $value = $this->value;
            }
            if (!empty($this->debug)) {
                echoLog('Setting ' . $this->prefix . $this->form_fieldname . ' --> ' . quote($this->prefix . $value . $this->sufix) . '<br>');
            }
            $callback->set($this->form_fieldname, $this->prefix . $value . $this->sufix);
        } elseif ($this->type !== 'VAR') {
            foreach ($this->sons as $key => $value) {
                $this->sons[$key]->set($callback);
            }
        }
    }

    function hasQuestion() {
        $question = false;
        if ($this->criteria === '?') {
            $question = true;
        } elseif ($this->type !== 'FIELD') {
            foreach ($this->sons as $key => $value) {
                if ($value->hasQuestion()) {
                    $question = true;
                    break;
                }
            }
        }
        return $question;
    }

    function hasErrors() {
        $errors = false;
        if (!empty($this->error)) {
            $errors = true;
        } elseif ($this->type !== 'FIELD') {
            foreach ($this->sons as $key => $value) {
                if ($value->hasErrors()) {
                    $errors = true;
                    break;
                }
            }
        }
        return $errors;
    }

    function dump() {
        $table = '<table border=' . "'1'" . ' cellspacing=' . "'1'" . '>';
        $table .= '<tr>';
        $table .= '<td><p><b>' . $this->element . '</b>';
        $table .= '<br>Type: ' . $this->type;
        if (!empty($this->error)) {
            $url = 'tool.php?to=ANOF&ac=MODIFY&idlist=' . $this->elementid;
            $table .= '<br><a href=' . singleQuote($url) . '><font color=' . singleQuote('red') . '>Error: ' . $this->errormsg . '</font></a>';
        }
        switch ($this->type) {
            case 'FIELD':
                $table .= '<br>Fieldname: ' . $this->form_fieldname;
                $table .= '<br>Record' . CLX_CHAR_SINGLE_QUOTE . 's Fieldname: ' . $this->fieldname;
                if (!empty($this->value))
                    $table .= '<br>Value: ' . $this->value;
                break;
            case 'TABLE':
                $table .= '<br>Table Code: ' . $this->tablecode;
                break;
            case 'LOOKUP':
                $table .= '<br>Lookup Table: ' . $this->lookup_table;
                $table .= '<br>Lookup Field: ' . $this->lookup_field;
                break;
            default:
                break;
        }
        if (!empty($this->criteria))
            $table .= '<br>Criteria: ' . $this->criteria;
        $table .= '<br>Parent: ' . $this->parent_tablecode;
        $table .= '</p></td>';
        if (count($this->sons) > CLX_NUM_ZERO) {
            $table .= '<td>';
            foreach ($this->sons as $name => $e) {
                $table .= $e->dump();
            }
            $table .= '</td>';
        }
        $table .= '</tr>';
        $table .= '</table>';
        return $table;
    }

    // if this is true, there is a relation between table1 and table2.  Notice that fieldname_intable2 is only used in the relation is a lookup
    function tableRelationExists($table1, $table2, $fieldname_intable2) {
        if ($this->dynamicRelationExists($table1, $table2)) {
            $exists = true;
        } elseif ($this->dynamicRelationExists($table2, $table1)) {
            $exists = true;
        } elseif ($this->lookupRelationExists($table1, $table2, $fieldname_intable2)) {
            $exists = true;
        } else {
            $exists = false;
        }
        return $exists;
    }

// if this is true, parent is the parent of child
    function dynamicRelationExists($parent, $child) {
        return ClxCommon::$db->oneExistsRecords('CLX_DB_DYNRELATIONS', 'PARENT_TABLECODE = ' . singleQuote($parent) . ' AND CHILD_TABLECODE =  ' . singleQuote($child) . '  AND RELATION_TYPE = 0') > CLX_NUM_ZERO;
    }

// if this is true, there is a fieldname in the child table that is a lookup to table parent. $fieldname_inchild is optional and can be left blank
    function lookupRelationExists($parent, $child, $fieldname_inchild) {
        $sql = 'SELECT 	count(*) FROM CLX_DB_FIELDS f, CLX_DB_TABLEFIELDS tb WHERE f.fieldtype = ' . "'LOOK'" . ' and f.field_extra1 = ' . singleQuote($parent) . ' and tb.FIELDNAME = f.FIELDNAME and tb.TABLECODE = ' . singleQuote($child);
        if (!empty($fieldname_inchild)) {
            $sql .= ' and tb.FIELDNAME = ' . singleQuote($fieldname_inchild);
        }
        $result = ClxCommon::$db->executeQuery($sql);
        $value = ClxCommon::$db->getNextRecord($result, MYSQL_NUM);
        return $value[CLX_NUM_ZERO] == CLX_NUM_ONE; // If this is 0, no relation exists, if it is more than 1, there are more than one relation...
    }

}
