<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-03-15 14:13:07 +0000 (Fri, 15 Mar 2019) $
 * @version        $Rev: 10569 $
 * @package		Clientix.Classes.File
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class clx_file_fixed_record_length extends clx_file {

    var $record_length;
    var $num_records;
    var $buffer;
    var $buffer_size;
    var $loaded_size;
    var $EOF;
    var $line_delim = null;

    function __construct($file_name, $record_length,$read_all=false,$UTF8=false,$toresize=false,$line_delim='') {
        parent::__construct($file_name, 'r');
        $this->record_length = $record_length;
		$this->file_name=$file_name;
        $this->num_records = CLX_INIT_ZERO;
        $this->buffer = '';
		$this->ultimolotcorrido=0;
        $this->loaded_size = CLX_INIT_ZERO;
        $this->EOF = false;
        $this->debug = false;
		$this->countsuperlot=1;
		$this->initsuperlot=0;
		$this->init_lot=0;
		$this->UTF8=$UTF8;
		$this->filesize = (int) (filesize($file_name));
		//echo $file_name;echo '  1';die;
		if ($read_all===true) {
			$this->filesize=$this->buffer_size = (int) (filesize($file_name));
			$this->superlotnum=0;
			$this->open();
			if (empty($this->error)) {
				$this->size();
			}
			$this->buffer = $this->read($this->buffer_size);
			$buffer=&$this->buffer;
			if ($UTF8===true ) {
				$this->buffer=utf8_encode($this->buffer);
			}
			else {
				$this->buffer=iconv("UTF-8", "ASCII//TRANSLIT",$this->buffer);
			}
			if ($toresize===true) {
				//variable global para pasar al rellenador de espacios para convertir en bloque, solo $GLOBALS
				$GLOBALS['size_record']=$this->record_length;
				$this->buffer=preg_replace_callback('/((.*?)\s\n)/', "rpad_allfile", $this->buffer);
			}
			$this->record_length=$record_length+(empty($line_delim)?0:strlen($line_delim));
			$max_lot=500;
			$this->superlotsize=1;
			$buffer = str_split($this->buffer,$this->record_length*$max_lot);
			
			$this->countsuperlot=count($buffer);
			$this->max_num_lot=count($buffer[0]);
			$this->buffer=&$buffer;
		}
		else {
			$this->buffer_size = (int) (!$record_length) ? CLX_NUM_1024 : $record_length;
			$this->open();
			if (empty($this->error)) {
				$this->size();
			}
		}
    }

    function fill_buffer($UTF8=false) {
        $contenidoHTML = '';
		$contar_size_repeat=0;
        while ((mb_strlen($this->buffer) < $this->record_length) && ($this->loaded_size < $this->file_size)) {
            $b = $this->read($this->buffer_size);
            $this->loaded_size += ($tam_size =((int) mb_strlen($b)));
			if ($tam_size==0 and $contar_size_repeat++>30  )
				break;
			if ($UTF8) {
				$b=utf8_encode($b);
			}	
            $this->buffer .= $b;
            if (!empty($this->debug))
                $contenidoHTML.= '>>>===---Buffer Size: ' . $this->buffer_size . ' Loaded ' . $this->loaded_size . ' bytes of ' . $this->file_size . '<br>' . CLX_CHAR_NL;
        }
		

        echo $contenidoHTML;
    }

    function getNextRecord2($UTF8=false) {
        // Caso 1002664 - BEGIN
        // It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's
        if(!is_null($this->line_delim)) return $this->getNextRecord_FixDelim($UTF8);
        // Caso 1002664 - END
        $this->fill_buffer($UTF8);
        $record = mb_substr($this->buffer, CLX_NUM_ZERO, $this->record_length);
        $this->buffer = mb_substr($this->buffer, $this->record_length + CLX_NUM_ONE);
        $this->num_records++;
        $this->line_num++;
        $this->EOF = (mb_strlen($this->buffer) == CLX_NUM_ZERO);
        return $record;
    }

    // Caso 1002664 - BEGIN
    function getNextRecord_FixDelim($UTF8=false) {
        $this->fill_buffer($UTF8); 
		
        $pos = mb_strpos($this->buffer, $this->line_delim);
        if ($pos === false) {
            $pos = mb_strlen($this->buffer);
            $this->EOF = true;
        }
        $record = mb_substr($this->buffer, CLX_NUM_ZERO, $pos);
        $len_line_delim = mb_strlen($this->line_delim);
        if (mb_substr($record, mb_strlen($record)-$len_line_delim+CLX_NUM_ONE) === $this->line_delim) {
            $record = mb_substr($record, CLX_NUM_ZERO, mb_strlen($record)-CLX_NUM_ONE);
        }
        $this->buffer = mb_substr($this->buffer, $pos+$len_line_delim);
        $this->num_records++;
        $this->line_num++;
        return $record;
    }
    // Caso 1002664 - END
	
    function getNextRecord2_exp() {
		if(!is_null($this->line_delim)) return $this->getNextRecord_FixDelim($this->UTF8);
		$this->fill_buffer($this->UTF8);
        // Caso 1002664 - END
        $record = mb_substr($this->buffer, CLX_NUM_ZERO, $this->record_length);
		$this->buffer = mb_substr($this->buffer, $this->record_length + CLX_NUM_ONE);
		
        $this->num_records++;
        $this->line_num++;
        return $record;
    }

    // Caso 1002664 - BEGIN
    function getNextRecord_FixDelim_exp() {
        $pos = mb_strpos($this->buffer, $this->line_delim);
        if ($pos === false) {
            $pos = mb_strlen($this->buffer);
        }
	    $record = mb_substr($this->buffer, CLX_NUM_ZERO, $pos);
        $len_line_delim = mb_strlen($this->line_delim);
        if (mb_substr($record, mb_strlen($record)-$len_line_delim+CLX_NUM_ONE) === $this->line_delim) {
            $record = mb_substr($record, CLX_NUM_ZERO, mb_strlen($record)-CLX_NUM_ONE);
        }
		list($result_msg0,$batch_log_id)=$this->creation_executions_description_status($record,'',$batch_log_id,$saved_errors, $fd->num_records, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex);
	    $this->buffer = mb_substr($this->buffer, $pos+$len_line_delim);
        $this->num_records++;
        $this->line_num++;
        return $record;
    }
    function parsetoarray($import,$restrictions=array(),$counter='',$lot=0,$superlotnum=0){
		if ($this->superlotnum<>$superlotnum){
			$this->superlotnum=$superlotnum;
			$this->getinformationlot();
		}
		$fields_length=&$import->options_import['cuts_options'];
		$restrictions=&$import->options_import['restrictions'];	
		$ignored_records2=&$import->options_import['ignored_records2'];	
		foreach ($fields_length as $key=>$value) {
			if (empty($value['START_POSITION']) && empty($value['FIELD_LENGTH'])){
				unset ($fields_length[$key]);	
			}
		}
		$buffer=&$this->buffer;
		//pre($buffer);
		$bufferx=$buffer[$superlotnum];
		
		if($lot==0&&$superlotnum==0)
			$this->init_lot=0;
		else
			$this->init_lot+=1;
		$init_lot=$this->init_lot;
		$record_length=&$this->record_length;
		$this->count_record_lot=($max=strlen($bufferx))/$record_length;
		//$this->countsuperlot=($this->filesize/$this->superlotsize)+1;
		$read_buffer=array();
		foreach($fields_length as $key=>$value) {
			$readbuffer[$key]=array();	
		}
		$pos=0;
		if (!empty($counter)) {
			for ($r=0;$r<$max;$r+=$record_length){
				$text=substr($bufferx,$r,$record_length);
			//	echo "===========xx============";
			//	echo $text;
			//	echo "<br>";
			//	PRE(strlen($text));
				if ($import->apply_Restriction($restrictions,$text,++$pos +$init_lot)) {
					$ignored_records2++;
				}else{		
					foreach($fields_length as $key=>$value) {
						$readbuffer[$key][]=substr($bufferx,$r+$value['START_POSITION'],$value['FIELD_LENGTH']);
					}
					$readbuffer[$counter][]=($pos+$init_lot);
				}	
			}
		}	
		else {
			for ($r=0;$r<$max;$r+=$record_length){
				$text=substr($bufferx,$r,$record_length);
				if ($import->apply_Restriction($restrictions,$text,++$pos +$init_lot)) {
					$ignored_records2++;
				}else{		
					foreach($fields_length as $key=>$value) {
						$readbuffer[$key][]=substr($bufferx,$r+$value['START_POSITION'],$value['FIELD_LENGTH']);
					}
				}	
			}
			
		}
		$this->init_lot+=$pos;
		$this->bufferx=&$readbuffer;
		return true;
			
	}
	function getinformationlot() {
	//	$this->buffer_size = $this->superlotsize;
	//	$this->initsuperlot+=$this->superlotsize;
		//$this->buffer=''.$this->buffer;
//		$this->max_num_lot=count($buffer);
		//$this->buffer=&$buffer;
	//	$this->ultimolotcorrido=0;

	}	
	function getNumrowMax2 () {  //for bigfile
		$x=fopen($this->file_name,'r');
		$data='';
		$contar=0;
		$line_delim=$this->line_delim;
		$a=microtime(true);
		$max=250000;
		$lnsize=strlen($line_delim);
		while (!feof($x)) {
			$texto=fread($x,$max);
			$data.=$texto;
			$contarx=0;
			$contarx=substr_count($data,$line_delim);
			if ($contarx>0) {
				$contar+=$contarx;
				$pos=strrpos($data,$ch);
				
				if ($pos>=0) {
					$posi=-strlen($data)+$pos+$lnsize-1;
					$data=substr($data,$posi);
				}
				else {
				}
			}
			else {
				$data=substr($data,-1);
			}
		}
		fclose($x);
		return $contar+ (filesize($this->file_name)>0)? 1:0;
	}
	function getNumrowMax () {
		if(empty($this->file_name) or !file_exists($this->file_name) or  filesize($this->file_name)==0)
			return 0;
		$xx=fopen($this->file_name ,'r');
		$buffer=fread($xx,$this->record_length*3);
		fclose($xx);
		$pos = strpos($buffer, $this->line_delim);
        return (int) ($this->filesize/($pos+strlen($this->line_delim)))+1;
       
	}	
	
	
	
}
