<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-06-09 10:58:28 -0400 (Thu, 09 Jun 2016) $
 * @version        $Rev: 8410 $
 * @package		Clientix.Classes.Webservice
 * @abstract		General Class
 * CHANGE LOG
 * 2009/04/06 Included label
 *
 * WSDL Class
 * This class generates WSDL from a PHP5 class. Class was extended from original version
 * at: http://www.schlossnagle.org/~george/blog/index.php?/archives/234-WSDL-Generation.html
 *
 */
 $GLOBALS['DEBUG_WSDL']=0;
class wsdl {

    const SOAP_XML_SCHEMA_VERSION = 'http://www.w3.org/2001/XMLSchema'; //ok
    const SOAP_XML_SCHEMA_INSTANCE = 'http://www.w3.org/2001/XMLSchema-instance';
    const SOAP_SCHEMA_ENCODING = 'http://schemas.xmlsoap.org/soap/encoding/'; //ok
    const SOAP_ENVELOP = 'http://schemas.xmlsoap.org/soap/envelope/';
    const SCHEMA_SOAP_HTTP = 'http://schemas.xmlsoap.org/soap/http';
    const SCHEMA_SOAP = 'http://schemas.xmlsoap.org/wsdl/soap/'; //ok
    const SCHEMA_WSDL = 'http://schemas.xmlsoap.org/wsdl/'; //ok

    static public $baseTypes = array(
        'Array' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'array'),
        'IGNR' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'PNEL' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'SXML' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'CHAR' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'TEXT' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'ACID' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'ACMG' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'ACST' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'int'),
        'INTN' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'int'),
        'DECN' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'double'),
        'DATE' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'), //can be date
        'DATI' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'TIME' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'),
        'int' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'int'),
        'float' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'float'),
        'double' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'double'),
        'string' => array('ns' => self::SOAP_XML_SCHEMA_VERSION, 'name' => 'string'));
    //public $encoding = 'ISO-8859-1';
    public $encoding = 'UTF-8';
    public $types;
    public $operations = array();
    public $className;
    public $ns;
    public $endpoint;
    public $complexTypes;
    public $enableClientix;
    private $mytypes = array();

    /** The wsdl constructor
     * @param string $className The class containing the methods to implement
     * @param string $endpoint  The endpoint for the service
     * @param string $ns optional The namespace you want for your service.
     */
    function __construct($className, $endpoint, $ns = false, $enableClientix = false) {
		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $this->types = self::$baseTypes;
        $this->className = $className;
        if (!$ns) {
            $ns = $endpoint;
        }
        $this->ns = $ns;
        $this->endpoint = $endpoint;
        $this->enableClientix = $enableClientix;
        $this->createPHPTypes();

        $class = new ReflectionClass($className);
        $methods = $class->getMethods();
        $this->discoverOperations($methods);
        if ($this->enableClientix) {
            $this->discoverClientixOperations();
        }
        $this->discoverTypes();
    }

    protected function discoverOperations($methods) {
		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        foreach ($methods as $method) {

            //Adding parameters to prevent not public access to functions
            if (!$method->isPublic() || $method->getName() == '__call') {
                continue;
            }

            $this->operations[$method->getName()]['input'] = array();
            $this->operations[$method->getName()]['output'] = array();
            $doc = $method->getDocComment();
            if (preg_match_all('|@param\s+(?:object\s+)?(\w+)\s+\$(\w+)|', $doc, $matches, PREG_SET_ORDER)) {
                foreach ($matches as $match) {
                    $this->mytypes[$match[1]] = 1;
                    $this->operations[$method->getName()]['input'][] = array('name' => $match[2], 'type' => $match[1]);
                }
            }

            if (preg_match_all('|@return\s+(?:object\s+)?(\w+)\s+\$(\w+)|', $doc, $matches, PREG_SET_ORDER)) {
                foreach ($matches as $match) {
                    $this->mytypes[$match[1]] = 1;
                    $this->operations[$method->getName()]['output'][] = array('name' => $match[2], 'type' => $match[1]);
                }
            }
        }
    }

//End method

    protected function discoverClientixOperations() {IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $SKME = getTool('SKME');
        $methods = ClxCommon::$db->getRecords("CLX_SK_SERVICES", "SERVICE_TYPE='SRVR'
    							AND SERV_STATUS = 1");
        while (($method = ClxCommon::$db->getNextRecord($methods)) == true) {
			IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'	method ->'.print_r($method ,true).chr(13).chr(10)); fclose($kk);}
            if (!isset($this->operations[$method['IDNAME']]['input']))
                $this->operations[$method['IDNAME']]['input'] = array();
            if (!isset($this->operations[$method['IDNAME']]['output']))
                $this->operations[$method['IDNAME']]['output'] = array();

            //Seting username and password elements form authentication
            /*
              Cambio para manejarlo directamente sobre la session
              if($method['ACCESS_TYPE'] <> 'OPEN'){
              //$this->mytypes[$element['ELE_TYPE']] = 1;
              $this->operations[$method['IDNAME']]['input'][] = array('name' => 'CLX_USERNAME', 'type' =>'string');
              $this->operations[$method['IDNAME']]['input'][] = array('name' => 'CLX_PASSWORD', 'type' =>'string');
              } */
            if ($method['ACCESS_TYPE'] <> 'OPEN' && $method['ACCESS_TYPE'] <> 'SUSF') {
                //$this->mytypes[$element['ELE_TYPE']] = 1;
                $this->operations[$method['IDNAME']]['input'][] = array('name' => 'CLX_SESSION_ID', 'type' => 'string');
            }
            //Set input Operations from elements
            $elements = $SKME->getElementsResults($method['REQUEST_CODE']);
            while (($element = ClxCommon::$db->getNextRecord($elements)) == true) {
                $this->mytypes[$element['ELE_TYPE']] = 1;
                $this->operations[$method['IDNAME']]['input'][] = array('name' => $element['IDNAME'], 'type' => $element['ELE_TYPE']);
            }

            //Set Output Operations from elements
            $elements = $SKME->getElementsResults($method['RESPONSE_CODE']);
            while (($element = ClxCommon::$db->getNextRecord($elements)) == true) {
                if ($element['ELE_TYPE'] == 'PNEL') {
                    $this->mytypes[$element['ELE_TYPE']] = 1;
                    $this->operations[$method['IDNAME']]['output'][] = array('name' => 'result', 'type' => $element['ELE_TYPE']);
                    if ($element['ELE_TYPE'] == 'PNEL')
                        break;
                }else {
                    $this->mytypes[$element['ELE_TYPE']] = 1;
                    $this->operations[$method['IDNAME']]['output'][] = array('name' => $element['IDNAME'], 'type' => $element['ELE_TYPE']);
                }
            }
        }
    }

//End method

    protected function discoverTypes() {IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        foreach (array_keys($this->mytypes) as $type) {
            if (!isset($this->types[$type])) {
                $this->addComplexType($type);
            }
        }
    }

//End method

    protected function createPHPTypes() {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $this->complexTypes['mixed'] = array(array('name' => 'varString', 'type' => 'string'),
            array('name' => 'varInt', 'type' => 'int'),
            array('name' => 'varDouble', 'type' => 'double'),
            array('name' => 'varFloat', 'type' => 'float'),
            array('name' => 'varArray', 'type' => 'array')
        );
        $this->types['mixed'] = array('name' => 'mixed', 'ns' => $this->ns);
        $this->types['array'] = array('name' => 'array', 'ns' => $this->ns);
    }

//End method

    protected function addComplexType($className) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $class = new ReflectionClass($className);
        $this->complexTypes[$className] = array();
        $this->types[$className] = array('name' => $className, 'ns' => $this->ns);

        foreach ($class->getProperties() as $prop) {
            $doc = $prop->getDocComment();
            if (preg_match('|@var\s+(?:object\s+)?(\w+)|', $doc, $match)) {
                $type = $match[1];
                $this->complexTypes[$className][] = array('name' => $prop->getName(), 'type' => $type);
                if (!isset($this->types[$type])) {
                    $this->addComplexType($type);
                }
            }
        }
    }

//End method

    protected function addMessages(DomDocument $doc, DomElement $root) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        foreach (array('input', 'output') as $type) {

            foreach ($this->operations as $name => $params) {
                $el = $doc->createElementNS(self::SCHEMA_WSDL, 'message');
                $el->setAttribute("name", "$name" . ucfirst($type));
                foreach ($params[$type] as $param) {
                    $part = $doc->createElementNS(self::SCHEMA_WSDL, 'part');
                    $part->setAttribute('name', $param['name']);
                    $prefix = $root->lookupPrefix($this->types[$param['type']]['ns']);
                    $part->setAttribute('type', $prefix . "xsd:" . $this->types[$param['type']]['name']);
                    $el->appendChild($part);
                }//end foreach
                $root->appendChild($el);
            }//end foreach
        }
    }

//End method

    protected function addPortType(DomDocument $doc, DomElement $root) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $el = $doc->createElementNS(self::SCHEMA_WSDL, 'portType');
        $el->setAttribute('name', $this->className . "PortType");
        foreach ($this->operations as $name => $params) {
            $op = $doc->createElementNS(self::SCHEMA_WSDL, 'operation');
            $op->setAttribute('name', $name);
            foreach (array('input', 'output') as $type) {
                $sel = $doc->createElementNS(self::SCHEMA_WSDL, $type);
                $sel->setAttribute('message', 'tns:' . "$name" . ucfirst($type));
                $op->appendChild($sel);
            }
            $el->appendChild($op);
        }
        $root->appendChild($el);
    }

//End method

    protected function addBinding(DomDocument $doc, DomElement $root) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $el = $doc->createElementNS(self::SCHEMA_WSDL, 'binding');
        $el->setAttribute('name', $this->className . "Binding");
        $el->setAttribute('type', "tns:{$this->className}PortType");

        $s_binding = $doc->createElementNS(self::SCHEMA_SOAP, 'binding');
        $s_binding->setAttribute('style', 'rpc');
        $s_binding->setAttribute('transport', self::SCHEMA_SOAP_HTTP);
        $el->appendChild($s_binding);

        foreach ($this->operations as $name => $params) {
            $op = $doc->createElementNS(self::SCHEMA_WSDL, 'operation');
            $op->setAttribute('name', $name);
            foreach (array('input', 'output') as $type) {
                $sel = $doc->createElementNS(self::SCHEMA_WSDL, $type);
                $s_body = $doc->createElementNS(self::SCHEMA_SOAP, 'body');
                //$s_body->setAttribute('use', 'literal');
                $s_body->setAttribute('use', 'encoded');
                $s_body->setAttribute('encodingStyle', self::SOAP_SCHEMA_ENCODING);
                $sel->appendChild($s_body);
                $op->appendChild($sel);
            }
            $el->appendChild($op);
        }
        $root->appendChild($el);
    }

//End method

    protected function addService(DomDocument $doc, DomElement $root) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $el = $doc->createElementNS(self::SCHEMA_WSDL, 'service');
        $el->setAttribute('name', $this->className . "Service");
        //$el->setAttribute('scope', "request");
//scope=" soapsession"
        $port = $doc->createElementNS(self::SCHEMA_WSDL, 'port');
        $port->setAttribute('name', $this->className . "Port");
        $port->setAttribute('binding', "tns:{$this->className}Binding");

        $addr = $doc->createElementNS(self::SCHEMA_SOAP, 'address');
        $addr->setAttribute('location', $this->endpoint);

        $port->appendChild($addr);
        $el->appendChild($port);
        $root->appendChild($el);
    }

//End method

    protected function addTypes(DomDocument $doc, DomElement $root) {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $types = $doc->createElementNS(self::SCHEMA_WSDL, 'types');
        $root->appendChild($types);
        $el = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'schema');
        $types->appendChild($el);

        //http://schemas.xmlsoap.org/soap/encoding/
        //<s:import namespace="http://schemas.xmlsoap.org/soap/encoding/" />
        //<s:import namespace="http://schemas.xmlsoap.org/wsdl/" />
        $in = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'import');
        $in->setAttribute('namespace', self::SOAP_SCHEMA_ENCODING);
        $el->appendChild($in);

        /* BEGIN: crutch */
        $ct = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'complexType');
        $el->appendChild($ct);
        $ct->setAttribute('name', 'Array');
        $cc = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'complexContent');
        $ct->appendChild($cc);
        $restriction = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'restriction');
        $cc->appendChild($restriction);
        $restriction->setAttribute('base', 'soapenc:Array');
        $attribute = $doc->createElementNS(self::SOAP_XML_SCHEMA_VERSION, 'attribute');
        $restriction->appendChild($attribute);
        $attribute->setAttribute('ref', 'soapenc:arrayType');
        $attribute->setAttribute('arrayType', 'tns:mixed[]');
        //$attribute->setAttributeNS(self::SCHEMA_WSDL, 'arrayType', 'tns:mixed[]');

        /* END: crutch */

        foreach ($this->complexTypes as $name => $data) {
            $ct = $doc->createElementNS(self::SCHEMA_WSDL, 'complexType');
            $ct->setAttribute('name', $name);

            $all = $doc->createElementNS(self::SCHEMA_WSDL, 'all');

            foreach ($data as $prop) {
                $p = $doc->createElementNS(self::SCHEMA_WSDL, 'element');
                $p->setAttribute('name', $prop['name']);
                $p->setAttribute('name', $prop['name']);

                $prefix = $root->lookupPrefix($this->types[$prop['type']]['ns']);
                $p->setAttribute('type', $prefix . "xds:" . $this->types[$prop['type']]['name']);
                $all->appendChild($p);
            }
            $ct->appendChild($all);
            $el->appendChild($ct);
        }
    }

//End method

    /**
     * Return an XML representation of the WSDL file
     */
    public function toXML($version = '1.0') {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $wsdl = new DOMDocument($version, $this->encoding);
        $root = $wsdl->createElement('definitions');
        $root->setAttribute('name', 'webservice');
        $root->setAttribute('targetNamespace', $this->ns);
        $root->setAttribute('xmlns:tns', $this->ns);
        $root->setAttribute('xmlns:soap', self::SOAP_XML_SCHEMA_VERSION);
        $root->setAttribute('xmlns:xsd', self::SOAP_XML_SCHEMA_VERSION);
        $root->setAttribute('xmlns:soapenc', self::SOAP_SCHEMA_ENCODING);
        $root->setAttribute('xmlns:wsdl', self::SCHEMA_WSDL);
        $root->setAttribute('xmlns', self::SCHEMA_WSDL);

        //adding imports
        //<import namespace="http://stock.com/schemas/services/stock" location="Stock.xsd" /
        /* $import = $wsdl->createElement('import');
          $import->setAttribute('namespace', str_replace('webservices.php','types/',$this->ns));
          $import->setAttribute('location', str_replace('webservices.php','ws/',$this->ns));
          $root->appendChild($import); */

        $this->addTypes($wsdl, $root);
        $this->addMessages($wsdl, $root);
        $this->addPortType($wsdl, $root);
        $this->addBinding($wsdl, $root);
        $this->addService($wsdl, $root);

        $wsdl->appendChild($root);

        return $wsdl->saveXML();
    }

    function getServiceMethodAndTypes() {		IF ($GLOBALS['DEBUG_WSDL']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $return = array('method' => array(), 'types' => array());
        foreach ($this->operations as $operation => $detail) {

            $prmval = array();
            foreach ($detail['input'] as $val) {
                $prmval[] = new PhpWsdlParam($val['name'], $this->types[$val['type']]['name']);
            }
            if (count($prmval) == 0)
                $prmval = null;


            $countret = count($detail['output']);
            if ($countret == 0) {
                $retval = null;
            } elseif ($countret == 1) {
                $retval = new PhpWsdlParam($detail['output'][0]['name'], $this->types[$detail['output'][0]['type']]['name']);
            } else {

                $retval = new PhpWsdlParam($operation . 'ComplexResult', $operation . 'ComplexResultType');
                $retval2 = array();
                foreach ($detail['output'] as $val2) {
                    $retval2[] = new PhpWsdlElement($val2['name'], $this->types[$val2['type']]['name']);
                }
                $return['types'][] = new PhpWsdlComplex($operation . 'ComplexResultType', $retval2);
            }

            $return['method'][] = new PhpWsdlMethod($operation, $prmval, $retval);
        }

        if (count($return['method']) == 0)
            $return['method'] = null;
        if (count($return['types']) == 0)
            $return['types'] = null;

        return $return;
    }

}

?>