<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-17 22:43:20 +0000 (Sat, 17 Oct 2015) $
 * @version        $Rev: 7344 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Validate Project Task (PRTS) Form
 */
function validateFormPrts(&$msg, $record) {
    if ($record['PRTS_ISTASKCOMPLETED'] == CLX_NUM_ONE && $record['PRTS_ISTASKREJECTED'] == CLX_NUM_ONE) {
        $msg['PRTS_ISTASKCOMPLETED'] = dict('ADPO_ERR_TAKSCOMP_OR_REJ');
        $msg['PRTS_ISTASKREJECTED'] = dict('ADPO_ERR_TAKSCOMP_OR_REJ');
    }
}

/**
 * Selecciona el numero de actividades completadas o rechazadas y se es mayor o igual que
 * numero de actividades por segmento marcha el segmento como completado.
 * - SEGMENT_TASKS INTN 1.0.0-0 Segment Tasks
 * - TASKS_COMPLETED INTN 1.0.0-0 Tasks Completed
 * - TASKS_INCOMPLETE INTN 1.0.0-0 Incomplete Tasks
 */
function segmentTotals($record) {
    //EST_SEG_TASKS(proj)
    $prtsname = tableName('PRTS');
    $prsgname = tableName('PRSG');
    $projname = tableName('PROJ');
    $estSegTasks = ClxCommon::$db->getField($projname, 'EST_SEG_TASKS', 'IDCODE = ' . singleQuote($record['PROJECT_CODE']));
    $sql = 'SELECT COUNT(ID) COUNTER, ISTASKCOMPLETED, PROJ_ACTI, ACTIVITY_STATUS FROM ' . $prtsname . ' WHERE SEGMENT_CODE = ' . singleQuote($record['SEGMENT_CODE']) . ' GROUP BY PROJ_ACTI, ACTIVITY_STATUS';
    $rs = ClxCommon::$db->executeQuery($sql);
    $counter = array('VISITSPCT_VN' => CLX_NUM_ZERO, 'VISITS_VN' => CLX_NUM_ZERO, 'TASKS_COMPLETED' => CLX_NUM_ZERO, 'TASKS_INCOMPLETE' => CLX_NUM_ZERO, 'SEGMENT_TASKS' => CLX_NUM_ZERO, 'ISSEGCOMPLETED' => CLX_NUM_ZERO);
    while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        if ($result['PROJ_ACTI'] === 'VIS') {
            $counter['VISITS_VN'] += $result['COUNTER'];
        } elseif ($result['ACTIVITY_STATUS'] === 'C' || $result['ISTASKCOMPLETED'] === '1') {
            $counter['TASKS_COMPLETED'] += $result['COUNTER'];
        } else {
            $counter['TASKS_INCOMPLETE'] += $result['COUNTER'];
        }
        $counter['SEGMENT_TASKS'] +=$result['COUNTER'];
    }
    if ($counter['TASKS_COMPLETED'] >= $estSegTasks) {
        $counter['ISSEGCOMPLETED'] = CLX_NUM_ONE;
    }
    $counter['VISITSPCT_VN'] = ($counter['VISITS_VN'] / CLX_NUM_ONE) * CLX_NUM_HUNDRED;
    ClxCommon::$db->updateRecord($prsgname, $counter, 'IDCODE = ' . singleQuote($record['SEGMENT_CODE']));
}

/**
 * Updating totals
 */
function updateBalances() {
    $contenidoHTML = '';
    $prtsname = tableName('PRTS');
    $rs = ClxCommon::$db->getRecords($prtsname);
    while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        $contenidoHTML = 'Updating ' . $result['IDCODE'] . '<br>';
        echo $contenidoHTML;
        segmentTotals($result);
    }
}

function mdChart($url) {
    $contenidoHTML = '<script language="JavaScript" type="text/JavaScript">' . CLX_CHAR_NL . 'window.location ="' . $url . '";' . CLX_CHAR_NL . '</script>';
    echo $contenidoHTML;
    //salir();
}

function getPage($pagecode, &$contents) {
    UserRequest::$request['pc'] = $pagecode;
    $UIPG = getTool('UIPG');
    $contents .= $UIPG->action('PAGE', array());
}

/**
 * Administracion de Projecto POP (ADPO)
 */
class adpo {

    var $projname; //Project Table Name
    var $prcsname; //Project Segment Config
    var $pracname; //Project Activities Config
    var $prcrname; //Project Resources Config
    var $vtdaname; //Project Segments Catalog
    var $prsgname; //Project Segments
    var $prtsname; //Project Task
    var $pratname; //Project Activities
    var $prrename; //Project Resources Table(No config)
    var $debug;

    /**
     * Constructor
     */
    function __construct() {
        $this->projname = tableName('PROJ'); //Project Table Name
        $this->prcsname = tableName('PRCS'); //Project Segment Config
        $this->pracname = tableName('PRAC'); //Project Activities Config
        $this->prcrname = tableName('PRCR'); //Project Resources Config
        $this->vtdaname = tableName('VTDA'); //Project Segments Catalog
        $this->prsgname = tableName('PRSG'); //Project Segments
        $this->pratname = tableName('PRAT'); //Project Segments
        $this->prtsname = tableName('PRTS'); //Project Tasks
        $this->prrename = tableName('PRRE'); //Project Resources(no config)
        $this->debug = false;
    }

//Constructor
// General Utilities
    function initConfigSegments(&$record) {
        if (strlen($record['STORE_CODE']) > CLX_NUM_ZERO && $record['STORE_CODE'] !== 'null') {
            $storerec = ClxCommon::$db->getRecord($this->vtdaname, 'IDCODE = ' . singleQuote($record['STORE_CODE']));
            $record['REGION_MD'] = $storerec['REGION_MD'];
            $record['ZONA_MD'] = $storerec['ZONA_MD'];
            $record['RUTAMD'] = $storerec['RUTAMD'];
            $record['ESTADOMX'] = $storerec['ESTADOMX'];
            $record['CIUDADMX'] = $storerec['CIUDADMX'];
            $record['CADENA_CODE'] = $storerec['CADENA_CODE'];
        }
    }

    function initConfigActivityException(&$record) {
        if (strlen($record['STORE_CODE']) > CLX_NUM_ZERO && $record['STORE_CODE'] !== 'null') {
            $storerec = ClxCommon::$db->getRecord($this->vtdaname, 'IDCODE = ' . singleQuote($record['STORE_CODE']));
            $record['REGION_MD'] = $storerec['REGION_MD'];
            $record['ZONA_MD'] = $storerec['ZONA_MD'];
            $record['RUTAMD'] = $storerec['RUTAMD'];
            $record['ESTADOMX'] = $storerec['ESTADOMX'];
            $record['CIUDADMX'] = $storerec['CIUDADMX'];
            $record['CADENA_CODE'] = $storerec['CADENA_CODE'];
        }
    }

// Generate Project
    /**
     * Start Project Builder.
     */
    function generateProject() {
        $idlist = getIdlist();
        UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
        UserResponse::setRunTimeLimit(CLX_NUM_ONE * CLX_NUM_60 * CLX_NUM_60);
        if (!empty($this->debug))
            echolog('Generate Project Started');
        if (count($idlist) > CLX_NUM_ZERO) {
            foreach ($idlist as $key => $val) {
                $record = ClxCommon::$db->getRecord($this->projname, 'ID = ' . $val);
                if ($this->validateProject($record)) {
                    //Change Status
                    $this->buildProject($record);
                    ClxCommon::$db->updateRecord($this->projname, array('GENERATED' => CLX_NUM_ONE), 'IDCODE = ' . singleQuote($record['IDCODE']));
                }
            }
        }
        unset($trans, $gl);
        return $this->generatedNote();
    }

    /**
     * Note
     */
    function generatedNote($msg = '') {
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));

        $table->addCell(dict('ADPO_LBL_GENERATE_PROCESS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_ONE));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_NUM_ONE));
        $table->addCell(dict('GEN_LBL_PROCESS_COMPLETED'), array(CLX_PROP_COLSPAN => CLX_NUM_ONE));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_NUM_ONE));
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_NUM_ONE));
        return $table->source();
    }

    /**
     * Performs Project Validations
     */
    function validateProject($projrec) {
        $status = true;
        if ($projrec['EFFTSTAT'] !== 'A') {
            $status = false;
            /*
             * ADPO_ERR_INVALIDPROJSTATUS
             * Sorry. Project status invalid. Only active projects can be generated.
             * Disculpe. Este proyecto no se encuentra activo. Solo proyectos activos pueden generarse.
             */
            addMessage(dict('ADPO_ERR_INVALIDPROJSTATUS'));
        }
        //Project Already builded? do not generate
        if (!empty($projrec['GENERATED'])) {
            $status = false;
            /*
             * ADPO_ERR_ALREADYGENERATED
             * Sorry. Project was already generated, please create or duplicate a new project to continue.
             * Disculpe. Este proyecto ya fu� generado. favor crear o duplicar a un nuevo projecto para continuar.
             */
            addMessage(dict('ADPO_ERR_ALREADYGENERATED'));
        }
        //Segment must exists
        if (ClxCommon::$db->oneExistsRecords($this->prcsname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE'])) == CLX_NUM_ZERO) {
            $status = false;
            /*
             * ADPO_ERR_NOSEGMENTFOUND
             * No segment Defined, please add at least one segment to this project to continue.
             * Favor de definir segmentos para generar proyecto.
             */
            addMessage(dict('ADPO_ERR_NOSEGMENTFOUND'));
        }
        //Project Activity Config
        if (ClxCommon::$db->oneExistsRecords($this->pratname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE'])) == CLX_NUM_ZERO) {
            $status = false;
            /*
             * ADPO_ERR_NOACTIVITYFOUND
             * No activity has been defined, please add at least one activity to this project to continue.
             * Favor de definir actividades para generar proyecto.
             */
            addMessage(dict('ADPO_ERR_NOACTIVITYFOUND'));
        }
        //Project Activity Config Has Activity Type
        if (ClxCommon::$db->oneExistsRecords($this->pracname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE']), '(PROJ_ACTI=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR PROJ_ACTI IS NULL)') > CLX_NUM_ZERO) {
            $status = false;
            /**
             * ADPO_ERR_ACTIVITYNOTFOUND
             * Invalid activity type for one or more activities, please verify to continue.
             * Falta tipo de actividad para una o m�s actividades configuradas. Verificar la configuraci�n de actividades del proyecto.
             */
            addMessage(dict('ADPO_ERR_ACTIVITYNOTFOUND'));
        }
        //Project Resources Config
        if (ClxCommon::$db->oneExistsRecords($this->prcrname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE'])) == CLX_NUM_ZERO) {
            $status = false;
            /*
             * ADPO_ERR_NORESOURCESFOUND
             * No resources has been defined, please add at least one resource to this project to continue.
             * Favor de definir recursos para generar proyecto.
             */
            addMessage(dict('ADPO_ERR_NORESOURCESFOUND'));
        }
        //Validar Fechas
        $mindate = adodb_strtotime(ClxCommon::$db->getField($this->prcsname, 'MIN(FROM_DATE)', 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE'])));
        $maxdate = adodb_strtotime(ClxCommon::$db->getField($this->prcsname, 'MAX(TO_DATE)', 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE'])));
        if ($mindate <= CLX_NUM_ZERO || $maxdate <= CLX_NUM_ZERO || $mindate > $maxdate === true) {
            $status = false;
            /*
             * ADPO_ERR_INVALIDFROMTODATE
             * From or To Date Invalid on project Segment.
             * Fecha de Inicio o Fin de segmento invalida por favor verificar.
             */
            addMessage(dict('ADPO_ERR_INVALIDFROMTODATE'));
        }
        $start_date = adodb_strtotime($projrec['STARTDATE']);
        $end_date = adodb_strtotime($projrec['TARGET_END_DATE']);
        if ($start_date <= CLX_NUM_ZERO || $end_date <= CLX_NUM_ZERO || $start_date > $end_date) {
            $status = false;
            /*
             * ADPO_ERR_INVALIDPROJDATES
             * Project dates invalid, Please verify project dates.
             * Fechas del projecto invalidas. Favor verificar fechas del rpojecto.
             */
            addMessage(dict('ADPO_ERR_INVALIDPROJDATES'));
        }
        //Project dates vs Segment Dates
        if ($start_date > $mindate) {
            $status = false;
            /*
             * ADPO_ERR_PROJINIDTMOREFROMDATESEG
             * Project start date is greater than first segment date. Please verify project dates vs segment dates.
             * Fecha de inicio de projecto es mayor que la fecha del primer segmento. Favor verificar fechas de projecto vs fechas de segmento.
             */
            addMessage(dict('ADPO_ERR_INVALIDPROJDATES'));
        }
        //Project dates vs Segment Dates
        if ($end_date < $maxdate) {
            $status = false;
            /*
             * ADPO_ERR_PROJENDDTLESSTODATESEG
             * Project end date is less than last segment date. Please verify project dates vs segment dates.
             * Fecha de culminaci�n de projecto es menor que la fecha de termino del ultimo segmento. Favor verificar fechas de projecto vs fechas de segmento.
             */
            addMessage(dict('ADPO_ERR_PROJENDDTLESSTODATESEG'));
        }
        return $status;
    }

    /**
     * Generate Project from Project Config
     */
    function buildProject($projrec) {
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        //Search Activity Exclutions
        $exclution = array();
        $rs = ClxCommon::$db->getRecords($this->pracname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE']));
        while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $exclution[$result['PROJ_ACTI']][] = $this->criteria($result, '', true);
        }
        $exclutions = array();
        foreach ($exclution as $key => $val) {
            $exclutions[$key] = '(' . implode(') OR (', $val) . ')';
        }
        //Total de Tareas para Segmento.
        //Generando Tiendas A partir de consiguracion de segmento.
        //Buscar Segmentos Configurados
        $rs = ClxCommon::$db->getRecords($this->prcsname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE']));
        while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Por cada segmento...
            $criteria = $this->criteria($result);
            if ($criteria === '')
                continue;
            //Buscar tiendas en el segmento.
            $i = CLX_NUM_ONE;
            $results2 = ClxCommon::$db->getRecords($this->vtdaname, $criteria);
            while ($result2 = ClxCommon::$db->getNextRecord($results2, ASSOCIATIVE)) {
                //Por cada tienda...
                $rec = array('PROJECT_CODE' => $projrec['IDCODE'],
                    'STORE_CODE' => $result2['IDCODE'],
                    'IDCODE' => 'AUTO',
                    'IDNAME' => $result2['IDNAME'],
                    'SEQNUM' => $i,
                    'DESCRIPTION' => $result2['IDCODE'],
                    'START_DATE' => $result['START_DATE'],
                    'END_DATE' => $result['END_DATE'],
                    'ISSEGCOMPLETED' => CLX_NUM_ZERO,
                    'SEGMENT_HRS' => CLX_NUM_ZERO,
                    'SEGMENT_COST' => CLX_NUM_ZERO,
                    'SEGMENT_TASKS' => CLX_NUM_ZERO,
                    'TASKS_COMPLETED' => CLX_NUM_ZERO,
                    'TASKS_INCOMPLETE' => CLX_NUM_ZERO,
                    'VISITS_REJECTED' => CLX_NUM_ZERO,
                    'VISITS_VN' => CLX_NUM_ZERO,
                    'VISITSPCT_VN' => CLX_NUM_ZERO,
                    'CREATEDBY' => '',
                    'MODIFIEDBY' => '',
                    'CDATE' => '',
                    'MDATE' => '');
                //Creando Segmento
                setCreationData($rec);
                setCreationIdCode($rec, 'PRSG');
                ClxCommon::$db->createRecord($this->prsgname, $rec, false);
                $i++;
                //Para el segmento buscar actividades
                $results3 = ClxCommon::$db->getRecords($this->pratname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE']));
                while ($result3 = ClxCommon::$db->getNextRecord($results3, ASSOCIATIVE)) {
                    //Buscar Exclusion Actividad
                    if (array_key_exists($result3['IDCODE'], $exclutions)) {
                        $excl_criteria = $exclutions[$result3['IDCODE']];
                        $excl_criteria = str_replace('[ZONA_MD]', $result2['ZONA_MD'], $excl_criteria);
                        $excl_criteria = str_replace('[RUTAMD]', $result2['RUTAMD'], $excl_criteria);
                        $excl_criteria = str_replace('[ESTADOMX]', $result2['ESTADOMX'], $excl_criteria);
                        $excl_criteria = str_replace('[REGION_MD]', $result2['REGION_MD'], $excl_criteria);
                        $excl_criteria = str_replace('[CIUDADMX]', $result2['CIUDADMX'], $excl_criteria);
                        $excl_criteria = str_replace('[CADENA_CODE]', $result2['CADENA_CODE'], $excl_criteria);
                        $excl_criteria = str_replace('[STORE_CODE]', $result2['IDCODE'], $excl_criteria);
                        if (strlen($excl_criteria) > CLX_NUM_ZERO)
                            $excl_criteria = ' AND (' . $excl_criteria . ')';
                        if (ClxCommon::$db->oneExistsRecords($this->pracname, 'PROJ_ACTI =' . singleQuote($result3['IDCODE']) . ' AND PROJECT_CODE = ' . singleQuote($projrec['IDCODE']) . ' ' . $excl_criteria) > CLX_NUM_ZERO) {
                            continue;
                        }
                    }
                    //Creando Actividad
                    $taskrec = array('IDCODE' => 'AUTO',
                        'IDNAME' => $result3['IDNAME'],
                        'PROJECT_CODE' => $projrec['IDCODE'],
                        'SEGMENT_CODE' => $rec['IDCODE'],
                        'PROJ_ACTI' => $result3['IDCODE'],
                        'RECHAZO' => '0',
                        'ISMILESTONE' => CLX_NUM_ZERO,
                        'PRIORITY' => CLX_NUM_ONE,
                        'ACTIVITY_STATUS' => 'N',
                        'PERCENT_COMPLETE' => '0',
                        'START_DTTM' => $result['START_DATE'],
                        'TARGET_END_DTTM' => $result['TARGET_END_DATE'],
                        'END_DTTM' => $result['END_DATE'],
                        'EST_HOURS' => CLX_NUM_ZERO,
                        'ACTUAL_HOURS' => CLX_NUM_ZERO,
                        'ISTASKREJECTED' => '0',
                        'ISTASKCOMPLETED' => '0',
                        'CREATEDBY' => '',
                        'MODIFIEDBY' => '',
                        'CDATE' => '',
                        'MDATE' => '');
                    setCreationIdCode($taskrec, 'PRTS');
                    setCreationData($taskrec);
                    ClxCommon::$db->createRecord($this->prtsname, $taskrec, false);
                }//End result 3
                //Total de Actividades configuradas para el segmento.
                $total_activities = ClxCommon::$db->countRecords($this->prtsname, 'PROJECT_CODE =' . singleQuote($projrec['IDCODE']) . ' AND SEGMENT_CODE=' . singleQuote($rec['IDCODE']));
                if (!empty($total_activities)) {
                    ClxCommon::$db->updateRecord($this->prsgname, array('SEGMENT_TASKS' => $total_activities), 'PROJECT_CODE =' . singleQuote($projrec['IDCODE']) . ' AND IDNAME=' . singleQuote($result2['IDNAME']));
                }
            }//End result 2
        }
        //Adding Resources
        $regions = ClxCommon::$db->executeQuery('SELECT DISTINCT(VTDA.REGION_MD) REGION_MD FROM ' . $this->vtdaname . ' VTDA, ' . $this->prsgname . ' PRSG WHERE VTDA.IDCODE = PRSG.STORE_CODE AND PRSG.PROJECT_CODE = ' . singleQuote($projrec['IDCODE']));
        while ($region = ClxCommon::$db->getNextRecord($regions, ASSOCIATIVE)) {
            $results3 = ClxCommon::$db->getRecords($this->prcrname, 'PROJECT_CODE = ' . singleQuote($projrec['IDCODE']));
            while ($result3 = ClxCommon::$db->getNextRecord($results3, ASSOCIATIVE)) {
                $rec = array('PROJECT_CODE' => $projrec['IDCODE'],
                    'IDCODE' => 'AUTO',
                    'HRES_CODE' => $result3['HRES_CODE'],
                    'JOB_CODE' => $result3['JOB_CODE'],
                    'MRES_CODE' => $result3['MRES_CODE'],
                    'PREXP_CODE' => $result3['PREXP_CODE'],
                    'REGION_MD' => $region['REGION_MD'],
                    'ZONA_MD' => '',
                    'RUTAMD' => '',
                    'ESTADOMX' => '',
                    'CIUDADMX' => '',
                    'STORE_CODE' => '',
                    'EST_QTY' => $result3['EST_QTY'],
                    'EST_COST' => $result3['EST_COST'],
                    'EST_UNIT_COST' => $result3['EST_UNIT_COST'],
                    'UOM' => $result3['UOM'],
                    'QUOTE_UNIT_PRICE' => $result3['QUOTE_UNIT_PRICE'],
                    'QUOTE_AMT' => $result3['QUOTE_AMT'],
                    'ACTUAL_COST' => $result3['ACTUAL_COST'],
                    'GROSS_MARGIN' => $result3['GROSS_MARGIN'],
                    'CDATE' => '',
                    'CREATEDBY' => '',
                    'MDATE' => '',
                    'MODIFIEDBY' => '');
                setCreationIdCode($rec, 'PRRE');
                setCreationData($rec);
                ClxCommon::$db->createRecord($this->prrename, $rec, false);
            }
        }
    }

    function criteria($record, $prefix = '', $template = false) {
        $criteria = '';
        if (strlen($prefix) > CLX_NUM_ZERO)
            $prefix .='.';
        $bool = '';
	$key=array('ZONA_MD','RUTAMD','ESTADOMX','REGION_MD','CIUDADMX','CADENA_CODE','STORE_CODE');
	$max=count($key);
	for ($m=0;$m<$max;$m++) {   
	    if (strlen($record[$key[$m]]) > CLX_NUM_ZERO) {
		if (!empty($template)) {
		    $criteria .= $bool . $prefix . $key[$m].'=' . singleQuote('[' . $key[$m].']');
		} else {
		    $criteria .= $bool . $prefix . $key[$m].'=' . singleQuote($record[$key[$m]]);
		}
		$bool = ' AND ';
	    }
	}   
        return $criteria;
    }

// Duplicate Project
    /**
     * Duplicate Project Configuration
     */
    function duplicateProject() {
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        $idlist = getIdlist();
        foreach ($idlist as $key => $val) {
            //Duplicate Project
            $record = ClxCommon::$db->getRecord($this->projname, 'ID = ' . singleQuote($val));
            if (empty($record))
                continue;
            $sproject_code = $record['IDCODE'];
            $record['ID'] = '';
            $record['IDCODE'] = 'AUTO';
            $record['GENERATED'] = '0';
            $record['EFFTSTAT'] = 'A';
            $record = setCreationIdCode($record, 'PROJ');
            setCreationData($record);
            ClxCommon::$db->createRecord($this->projname, $record, false);
            $project_code = $record['IDCODE'];
            //Duplicate Segments
            $records = ClxCommon::$db->getRecords($this->prcsname, 'PROJECT_CODE = ' . singleQuote($sproject_code));
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                if (empty($record))
                    continue;
                $record['ID'] = '';
                $record['IDCODE'] = 'AUTO';
                $record['PROJECT_CODE'] = $project_code;
                setCreationIdCode($record, 'PRCS');
                setCreationData($record);
                ClxCommon::$db->createRecord($this->prcsname, $record, false);
            }
            //Duplicate Activity Types
            $records = ClxCommon::$db->getRecords($this->pratname, 'PROJECT_CODE = ' . singleQuote($sproject_code));
            $trans_acti = array();
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                if (empty($record))
                    continue;
                $oldcode = $record['IDCODE'];
                $record['ID'] = '';
                $record['IDCODE'] = 'AUTO';
                $record['PROJECT_CODE'] = $project_code;
                setCreationIdCode($record, 'PRAT');
                setCreationData($record);
                ClxCommon::$db->createRecord($this->pratname, $record, false);
                $trans_acti[$oldcode] = $record['IDCODE'];
            }
            //Duplicate Activities
            $records = ClxCommon::$db->getRecords($this->pracname, 'PROJECT_CODE = ' . singleQuote($sproject_code));
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                if (empty($record))
                    continue;
                $record['ID'] = '';
                $record['PROJ_ACTI'] = $trans_acti[$record['PROJ_ACTI']];
                $record['IDCODE'] = 'AUTO';
                $record['PROJECT_CODE'] = $project_code;
                setCreationIdCode($record, 'PRAC');
                setCreationData($record);
                ClxCommon::$db->createRecord($this->pracname, $record, false);
            }
            //Duplicate Resources
            $records = ClxCommon::$db->getRecords($this->prcrname, 'PROJECT_CODE = ' . singleQuote($sproject_code));
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                if (empty($record))
                    continue;
                $record['ID'] = '';
                $record['IDCODE'] = 'AUTO';
                $record['PROJECT_CODE'] = $project_code;
                setCreationIdCode($record, 'PRCR');
                setCreationData($record);
                ClxCommon::$db->createRecord($this->prcrname, $record, false);
            }
        }
    }

    function ganttXml($idlist) {
        $contenidoHTML = '';
        if (empty($idlist)) {
            echo 'no data';
            return '';
        }
        /**
         * ANATOMY
         * Categories and sub-categories (Dates)
         * Process names
         * Data Table for showing additional information
         * Gantt Task Bars
         * Milestones
         * Task Connectors
         * Trend Lines
         * Hover Caption
         */
        /** XML Creation * */
        $data = new XMLObject('chart');
        $data->setProp('dateFormat', 'yyyy/mm/dd');
        $data->setProp('showTaskNames', '1');
        $data->setProp('ganttWidthPercent', '70');
        $data->setProp('gridBorderAlpha', CLX_NUM_HUNDRED);
        $data->setProp('canvasBorderColor', '333333');
        $data->setProp('canvasBorderThickness', '0');
        $data->setProp('hoverCapBgColor', 'FFFFFF');
        $data->setProp('hoverCapBorderColor', '333333');
        $data->setProp('extendcategoryBg', '0');
        $data->setProp('ganttLineColor', '99cc00');
        $data->setProp('ganttLineAlpha', '20');
        $data->setProp('baseFontColor', '333333');
        $data->setProp('gridBorderColor', '99cc00');
        //Categories
        //Loop n Of This 1 Block Year, Block Months
        $cats = new XMLObject('categories');
        $cats->setProp('bgColor', '99cc00');
        $cats->setProp('fontColor', '333333');
        $cats->setProp('isBold', '1');
        $cats->setProp('fontSize', '14');
        //Categories and sub-categories (Dates)
        $rs = ClxCommon::$db->executeQuery('SELECT DISTINCT(DATE_FORMAT(MDATE,' . singleQuote(' %Y/%m/%d') . ')) MDATE  MDATE FROM CLX_AN_PLOT ORDER BY MDATE');
        while (ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Loop n Of This
            $cat = new XMLObject('category');
            $cat->setProp('start', '2004-09-01');
            $cat->setProp('end', '2004-12-31');
            $cat->setProp('name', '2004');
            $cats->addObject($cat);
        }
        $data->addObject($cats);
        //Processes Loop n Of This 1 Block Year, Block Months
        $procs = new XMLObject('processes');
        $procs->setProp('bgColor', '99cc00');
        $procs->setProp('fontColor', '333333');
        $procs->setProp('isBold', '1');
        $procs->setProp('fontSize', '14');
        //Loop n Of This
        $proc = new XMLObject('category');
        $proc->setProp('start', '2004-09-01');
        $proc->setProp('end', '2004-12-31');
        $proc->setProp('name', '2004');
        $procs->addObject($proc);
        $data->addObject($procs);
        //Outputing
        $contenidoHTML.= '<pre>' . $data->source() . '</pre><hr>';
        $filename = './temp/data.xml';
        echo $contenidoHTML;
        return $filename;
    }

    function buildGantt() {
        $idlist = getIdlist();
        $filename = $this->ganttXml($idlist);
        $contents = '<OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6, 0, 0,0" WIDTH="800" HEIGHT="600" id="FusionCharts" ALIGN="">
				<PARAM NAME=movie VALUE="./plot/FI2_gantt.swf">
				<PARAM NAME="FlashVars" VALUE="&dataURL=' . $filename . '&chartWidth=800&chartHeight=600">
				<PARAM NAME=quality VALUE=high>
				<PARAM NAME=bgcolor VALUE=#FFFFFF>
				<EMBED src="./plot/FI2_gantt.swf" FlashVars="&dataURL=' . $filename . '&chartWidth=800&chartHeight=600" quality=high bgcolor=#FFFFFF WIDTH="800" HEIGHT="600" NAME="FusionCharts" ALIGN="" TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer">
				</EMBED>
				</OBJECT>';
        return $contents;
    }

}
