<?php
/**
 * Fund Transfer Interface
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-03-31 16:58:57 -0400 (Thu, 31 Mar 2016) $
 * @version        $Rev: 8080 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
if (!class_exists('ibs_accounting_interface_commons'))
    includeCodeLib('EIBS_JE');
/*
  Depende de:
  tools/eb_sockets.php
  data/code/EIBS_utilities.php
  data/code/PROC_class_aid.php
  data/code/EIBS_util_ibiq.php
 */

/*
 * ******************************************************************************************************************
 * e-IBS Accounting Interface common properties and methods
 * *****************************************************************************************************************
 */
class ibs_transfers_interface_commons extends ibs_accounting_interface_commons {
    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function __construct($s_comp_code = null, $parameters = array()) {
        parent::__construct($this->s_comp_code, $parameters);
        if (!empty($this->debug)) {

        }
    }
}

// Class End
/*
 * ******************************************************************************************************************
 * e-IBS Batch Accounting Interface
 * *****************************************************************************************************************
 */
class ibs_transfers_batch_interface extends ibs_transfers_interface_commons {

    var $trdoname;

    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function __construct($s_comp_code = null, $parameters = array()) {
//$this->debug = true;
        parent::__construct($s_comp_code, $parameters);
        //   trae nombre de tabla FIAT
        multiTableName($this, array('TRDO', 'FIAT'));
        if (!defined('EIBS_FUND_TRANSFER_EXPORT_FILENAME')) {
            // Parameters for internal fund transfer
            define('EIBS_FUND_TRANSFER_EXPORT_FILENAME', EIBS_JOURNAL_ENTRY_EXPORT_FILENAME);
            define('EIBS_FUND_TRANSFER_EXPORT_FILE_EXT', EIBS_JOURNAL_ENTRY_EXPORT_FILE_EXT);
            // /home/fideicomiso/fide/fide/cont
            if (!defined('EIBS_TRSFR_EXPORT_DIR')) 
            	define('EIBS_TRSFR_EXPORT_DIR', trim(companyParameter('EIBS_TRSFR_EXPORT_DIR', $this->s_comp_code)));
            // /home/fideicomiso/fide/fide/cont_ibs_resp
            define('EIBS_TRSFR_IMPORT_DIR', trim(companyParameter('EIBS_TRSFR_IMPORT_DIR', $this->s_comp_code)));
            // Not used....
            define('EIBS_TRSFR_MAX_BUFFER_LINES', CLX_NUM_TEN);
            // Trasnfer file's name prefix
            define('EIBS_TRSFR_FILENAME_PREFIX', 'EIBS_TRSFR_');
        }
        if (!empty($this->debug)) {
            echoLog('EIBS_FUND_TRANSFER_EXPORT_FILENAME=' . EIBS_FUND_TRANSFER_EXPORT_FILENAME);
            echoLog('EIBS_FUND_TRANSFER_EXPORT_FILE_EXT=' . EIBS_FUND_TRANSFER_EXPORT_FILE_EXT);
            echoLog('EIBS_TRSFR_EXPORT_DIR=' . EIBS_TRSFR_EXPORT_DIR);
            echoLog('EIBS_TRSFR_MAX_BUFFER_LINES=' . EIBS_TRSFR_MAX_BUFFER_LINES);
            echoLog('EIBS_TRSFR_FILENAME_PREFIX=' . EIBS_TRSFR_FILENAME_PREFIX);
        }
    }

    /*
     * Update Transaction List with same row data
     * @param array
     * @return void
     */
    function updateFiatList($s_trans_list, $a_record, $b_interface_msg_complement = false, $b_add_trans_code = false) {
        $s_col_list = 'IDCODE';
        $s_interface_msg = $a_record['INTERFACE_MSG'];
        if ($b_interface_msg_complement === true) {
            $s_col_list .= ', INTERFACE_MSG';
        }
        $sql = 'SELECT ' . $s_col_list . ' FROM ' . $this->fiatname . ' WHERE IDCODE IN(' . $s_trans_list . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($fiatrec = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($b_interface_msg_complement === true) {
                // Agrega el contenido del elemento INTERFACE_MSG del array que se pasó como parámetro al contenido de la columna INTERFACE_MSG en la tabla FIAT
                $a_record['INTERFACE_MSG'] = $fiatrec['INTERFACE_MSG'] . CLX_CHAR_NL . $s_interface_msg;
            } elseif ($b_add_trans_code === true) {
                // Agrega el código de la transacción al contenido del elemento INTERFACE_MSG del array
                $a_record['INTERFACE_MSG'] = dict('CODE_GEN_TRANSACTION') . ' # ' . $fiatrec['IDCODE'] . CLX_CHAR_NL . $s_interface_msg;
            }
            // Actualiza el registro de FIAT para el IDCODE corriente
            $this->setprintChecksResult($fiatrec['IDCODE'], $a_record);
        }
    }

    /*
     * Builds a file for fund transfer batch export
     * @param text
     * @return text
     */

    function ibs_transfer_export($s_trans_idcode = null) {
        $contents = '';
        //if(!function_exists('setCreationData')) includeCodeLib('GEN_REC_UTIL');
        $DBLT = &getTool('DBLT');
        /*
         * CODE_LBL_ITRANSFEREMISSION_TITLE
         * Interbanking Transfers
         * Transferencias Internas
         */
        $contents = dict('CODE_LBL_ITRANSFEREMISSION_TITLE') . '<br>' . CLX_CHAR_NL . '<br>' . CLX_CHAR_NL;
        $s_idcode_list = $this->fiat_idcode_list($s_trans_idcode);
        if (!empty($this->debug))
            echoLog('ibs_transfer_export: s_trans_idcode = ' . $s_trans_idcode . ', s_idcode_list = ' . $s_idcode_list);
        // Nothing to transmit
        if ($s_idcode_list === '') {
            /*
             * CODE_ERR_IBS_CHKPRT_NOTRANS
             * There's not selected/approved transaction for checks emission
             * No hay transacciones seleccionadas/aprobadas para la emision de cheques
             */
            $contents .= '- ' . dict('CODE_ERR_IBS_CHKPRT_NOTRANS') . '<BR>' . CLX_CHAR_NL;
            return $contents;
        }
        // Extracts the beneficiaries from the transactions involved (ONLY INTERNAL TRANSFERS)
        if (!empty($this->sw_old_acco_struct)) {
            // Old version
            $s_sql_extra_pars_select = 'FIAT.COMP_CODE FIAT_COMP_CODE, FIAT.EFFTDATE FIAT_EFFTDATE,FIBT.BANKAC_CODE FIBT_BANKAC_CODE,FIBT.BANK_ACCOUNT_NO FIBT_BANK_ACCOUNT_NO';
        } else {
            $s_sql_extra_pars_select = 'FIAT.COMP_CODE FIAT_COMP_CODE, FIAT.EFFTDATE FIAT_EFFTDATE,FIAT.BANKAC_CODE FIBT_BANKAC_CODE,FIAT.BANK_ACCOUNT_NO FIBT_BANK_ACCOUNT_NO';
        }
        $sql = $this->printChecks_sql_statement($s_idcode_list, 'TI', $s_sql_extra_pars_select);
        if (!empty($this->debug))
            echoLog('printChecks_sql_statement = ' . $sql);
        $results = ClxCommon::$db->executeQuery($sql);
        $i_num_rows = ClxCommon::$db->numRows($results);
        // no transfers to do
        if (!empty($this->debug))
            echoLog('i_num_rows = ' . $i_num_rows);
        if ($i_num_rows == CLX_NUM_ZERO) {
            /*
             * CODE_ERR_IBS_ITRANS_NOTHINGTODO
             * No transfers to be issued
             * No hay transferencias a ser realizadas
             */
            $contents .= '- ' . dict('CODE_ERR_IBS_ITRANS_NOTHINGTODO') . '<BR>' . CLX_CHAR_NL;
            return $contents;
        }
        // Socket definition
        $EBSK = getTool('EBSK');
        $EBSK->debug = $this->debug;
        $EBSK->tfields_only = true;
        $EBSK->remove_decimal_point = true;
        $msg_code = EBSK_IBS_DEF_INPCLX_MSG;
        // Read Parameters to know the amounts lenght
        $mappings = null;
        $ar_amount_pars = $this->ibs_je_readpar_amtlen($EBSK, $msg_code, $mappings);
        // Prepares record creation
        $o_seq_name_file_generation = new seq_name_file_generation();
        $o_seq_name_file_generation->debug = $this->debug;
        $ar_pars = array();
        $ar_pars['export_dir'] = EIBS_TRSFR_EXPORT_DIR; // Export server directory
        $ar_pars['rec_type'] = 'ITRF'; // record type: Fund transfer
        $ar_pars['EBSK'] = $EBSK;
        $ar_pars['msg_code'] = $msg_code;
        //   - Caso 1002467 - BC-GAP-Interfaz con IBS
        // Estaba poniendo la fecha del dia calendario, no la fecha de operaciones
        $s_hoy = adodb_next_day($this->get_comp_acc_date());
        $ar_pars['efftdate'] = $s_hoy;
        $ar_pars['filename_prefix'] = EIBS_TRSFR_FILENAME_PREFIX;
        $ar_pars['output_to_file'] = $this->b_jeex_output_to_file;
        $ar_pars['output_dir'] = $this->s_jeex_trsfr_output_dir;
        $ar_pars['output_dir_html'] = $this->s_jeex_trsfr_output_dir_html;
        $o_seq_name_file_generation->def_pars_set($ar_pars);
        $o_seq_name_file_generation->s_cofiex_html = $o_seq_name_file_generation->cofiex_linegen_header(); // Prepares the column headers for the human readable version of the export file
        // Creates record in the log table
        $ar_seq_response = $o_seq_name_file_generation->create_record();
        if ($ar_seq_response['error'] === true) {
            //   error en la generacion de archivo de interfaz batch.
            // Actualiza todos los INTERFACE_MSG con el cod. transaccion+mensaje de error
            $contents .= '- ' . $ar_seq_response['errormsg'] . '<BR>' . CLX_CHAR_NL;
            $a_record = array('RECORD_BLOCKING' => '4', 'INTERFACE_MSG' => $ar_seq_response['errormsg'] . ' [1]');
            $this->updateFiatList($s_idcode_list, $a_record, false, true);
            return $contents;
        }
        // Debit/Credit accumulators
        $ar_amt_sum = array();
        $ar_amt_sum['DEBITS'] = '0';
        $ar_amt_sum['CREDITS'] = '0';
        // Process the beneficiaries from the transactions involved (ONLY INTERNAL TRANSFERS)
        $i_cont_reg = CLX_INIT_ZERO;
        $s_trans_code = '';
        $s_coma_sep_otherinfo = '';
        $s_trans_code_list_4_update = '';
        while ($fibtrec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            //   se inicializa el mensaje para cada transacción
            $contents = '';
            if (!empty($this->debug))
                echoLog('Ciclo-bucle: i_cont_reg = ' . $i_cont_reg . '<br>
						TRANS_CODE = ' . $fibtrec['TRANS_CODE'] . '<br>
						IDCODE = ' . $fibtrec['IDCODE']);
            // Complement transaction data
            $fibtrec = $this->printChecks_prepares_record($fibtrec, $mappings, false);
            $s_affect_cash = $fibtrec['AFFECT_CASH'];
            if (!empty($this->debug))
                echoLog('s_affect_cash = ' . $s_affect_cash);
            if (!empty($this->debug))
                echoLog(debug_dump('fibtrec', $fibtrec));
            //   - Caso 1002541 - BNP-Incid 189965 Rev Ope Fso
            // Como esta copiando el registro reversado en el de de reverso, tambien
            // copia el status de la transaccion. La estrategia debe ser otra. En este caso se va a
            // hacer Swap de las cuentas de banco antes de mandar el registro a la construcción de
            // la trama y luego a la interfaz. Ver el IF que verifica AFFECT_CASH más adelante
            // It must be CR or DR. If it's 'not applicable', skips all lines
            if ($s_affect_cash === '') {
                /*
                 * CODE_ERR_IBS_ITRANS_NOAFC
                 * Transaction doesn't affect cash
                 * La Transaccion no afecta el efectivo
                 */
                //   se actualiza el registro con el error de 'La Transaccion no afecta el efectivo'
                $contents = dict('CODE_GEN_TRANSACTION') . ' # ' . $fibtrec['TRANS_CODE'] . ': ' . CLX_CHAR_NL . dict('CODE_ERR_IBS_ITRANS_NOAFC');
                $this->setprintChecksResult($fibtrec['TRANS_CODE'], array('RECORD_BLOCKING' => '4', 'INTERFACE_MSG' => $contents));
                continue;
            }
            /*
             * CODE_GEN_TRANSACTION
             * Transaction
             * Transaccion
             */
            if ($s_trans_code != $fibtrec['TRANS_CODE']) {
                $s_trans_code = $fibtrec['TRANS_CODE'];
                //   corregido encabezado de mensaje inicial para este registro
                $contents .= dict('CODE_GEN_TRANSACTION') . ' # ' . $s_trans_code . CLX_CHAR_NL . CLX_CHAR_NL;
            }
            // Write info that will be used to chain response from IBS to original data
            $s_otherinfo = $s_coma_sep_otherinfo . $fibtrec['TRANS_CODE'] . ',' . $fibtrec['FIBT_ID'];
            $s_coma_sep_otherinfo = CLX_CHAR_NL;
            // Round amounts to avoid de 'cent' syndrome
            //$fibtrec['CREDITS'] = rounder($fibtrec['CREDITS'], $ar_amount_pars['CREDITS']['FIELD_DECIMALS']);	 se elimino x q no tiene sentido y da un warning. estas dos entradas se inicializan mas adelante...
            // Prepares the data to be transmitted
            /////  cjrd bda :
            ///// $record = $this->printChecks_prepares_record($fibtrec, $mappings, false);
            $record = $fibtrec;

            // Banck ID constant for internal transfer export
            // '01'
            $s_eibs_itrsf_export_bank = trim(companyParameter('EIBS_ITRSF_EXPORT_BANK', $record['FIAT_COMP_CODE'])); 
            if(is_null($s_eibs_itrsf_export_bank) || trim($s_eibs_itrsf_export_bank) === '') {
                // Si no esta definido, toma el banco de la interfaz contable
                $s_eibs_itrsf_export_bank = trim(companyParameter('EIBS_JEEX_EXPORT_BANK', $record['FIAT_COMP_CODE'])); 
                if(is_null($s_eibs_itrsf_export_bank)) {
                    // Si no esta ninguno de los dos, lo pone en blanco para que IBS devuelva error
                    $s_eibs_itrsf_export_bank = '--0--';
                }
            }
            // Cost Center constant for G/L and transfers export
            // '01'
            $s_eibs_itrsf_export_branch = trim(companyParameter('EIBS_ITRSF_EXPORT_BRANCH', $record['FIAT_COMP_CODE']));
            if(is_null($s_eibs_itrsf_export_branch) || trim($s_eibs_itrsf_export_branch) === '') {
                // Si no esta definido, toma la sucursal de la interfaz contable
                $s_eibs_itrsf_export_branch = trim(companyParameter('EIBS_JEEX_EXPORT_BRANCH', $record['FIAT_COMP_CODE']));
                if(is_null($s_eibs_itrsf_export_branch)) {
                    // Si no esta ninguno de los dos, lo pone en blanco para que IBS devuelva error
                    $s_eibs_itrsf_export_branch = '--1--';
                }
            }
            // Fix data wich is different than check printing
            $record['BANK_CODE'] = EIBS_ITRSF_EXPORT_BANK;
            $record['BRANCH_CODE'] = EIBS_ITRSF_EXPORT_BRANCH;

            // All the record need to have the export file ID
            $record['IDCODE'] = $o_seq_name_file_generation->s_idcode;
            // Transation date
            $s_hoy = $fibtrec['FIAT_EFFTDATE']; // getNow('Y-m-d');
            //   - Caso 1002467 - BC-GAP-Interfaz con IBS
            // En IBS 7 NO debe truncar el año, porque usa 4 digitos
            // In IBS 7 year must have 4 digits
            $s_hoy_yy = substr($s_hoy, CLX_NUM_ZERO, CLX_NUM_FOUR);
            $s_hoy_yy = substr($s_hoy_yy, -$ar_amount_pars['INPVDY']['FIELD_LENGTH']); // NOTE: must be only the last two digits of the year	//  > CDA - IBS 7
            $s_hoy_mm = substr($s_hoy, CLX_NUM_FIVE, CLX_NUM_TWO);
            $s_hoy_dd = substr($s_hoy, CLX_NUM_8, CLX_NUM_TWO);
            $record['DD'] = $s_hoy_dd;
            $record['MM'] = $s_hoy_mm;
            $record['YY'] = $s_hoy_yy;
            // Current UserID
            $record['USERNAME'] = $this->username;
            // These fields must be empty for transfers
            $record['GLACCOUNTCODE'] = '';
            // FJSH - Incorporado valor de banco, branch y moneda para credito y debito
            $record['INPOBK'] = $s_eibs_itrsf_export_bank;
            $record['INPDBK'] = $s_eibs_itrsf_export_bank;
            $record['INPCBK'] = $s_eibs_itrsf_export_bank;
            $record['INPOBR'] = $s_eibs_itrsf_export_branch;
            $record['INPDBR'] = $s_eibs_itrsf_export_branch;
            $record['INPCBR'] = $s_eibs_itrsf_export_branch;
            $record['CURRENCY_CODE'] = $fibtrec['CURRENCY_CODE_FIBK_FIAT'];
            $record['EXCHANGE_RT'] = (isset($record['EXCHANGE_RT']) ? $record['EXCHANGE_RT'] : CLX_NUM_ONE);
            // DB Acc. Descrip. -> Transaction description
            $record['IDNAME'] = fija($record['IDNAME_FIAT'], EIBS_JOURNAL_ENTRY_EXPORT_IDNAME_MAXLEN);
            // Caso 1002901 - BEGIN
            if ($this->sw_old_acco_struct === false) {
                // Cost center = Contracto Code, vers. 5.5.
                $record['CONTRACT_CODE'] = $record['FICO_IDCODE'];
                if (defined('EIBS_JEEX_EXPORT_COSTCNT_CHR') && EIBS_JEEX_EXPORT_COSTCNT_CHR === '1') {
                    $record['CONTRACT_CODE'] = $record['CHART_FIELD01'];
                }
                if (defined('EIBS_JEEX_EXPORT_COSTCENTER') && EIBS_JEEX_EXPORT_COSTCENTER !== '') {
                    $record['CONTRACT_CODE'] = EIBS_JEEX_EXPORT_COSTCENTER;
                }
            }
            if(mb_strlen($record['CONTRACT_CODE']) > $ar_amount_pars['INPDCC']['FIELD_LENGTH']) {
                // Global SAAS IBS 4.8 PTY - If contract code lenght is greater than cost center field lenght, asssign zero
                $record['CONTRACT_CODE'] = '0'; 
            }
            // Caso 1002901 - END
            // Bank acc. from
            // Determine fund destination(BANK or LEDGER ACCOUNT) for internal transfers
            if (is_null($record['FIAT_GLACCOUNTCODE']) || trim($record['FIAT_GLACCOUNTCODE']) === '') {
                // From a bank account
                $record['GLACCOUNTCODE_DB'] = '';
                $record['BANK_ACCOUNT_NO_DB'] = $this->bankact_code_fix($record['FIDU_BANKACT_CODE']);
            } else {
                // From a GL account
                $record['GLACCOUNTCODE_DB'] = $record['FIAT_GLACCOUNTCODE'];
                $record['BANK_ACCOUNT_NO_DB'] = '';
            }
            // Debit amount
            $record['DEBITS'] = $record['TRANS_AMT'];
            // CR Acc. Descrip. -> Payee name
            $record['IDNAME_2'] = fija($record['BENEFICIARY_NAME_1'], EIBS_JOURNAL_ENTRY_EXPORT_IDNAME_MAXLEN);
            // Bank acc. to
            // Determine fund destination (BANK or LEDGER ACCOUNT) for internal transfers
            if (is_null($record['FIAT_GLACCOUNTCODE2']) || trim($record['FIAT_GLACCOUNTCODE2']) === '' || trim($record['FIAT_GLACCOUNTCODE2']) === 'null') {
                // From a bank account
                $record['GLACCOUNTCODE_CR'] = '';
                if (!is_null($fibtrec['FIBT_BANKAC_CODE']) && trim($fibtrec['FIBT_BANKAC_CODE']) !== '') {
                    $record['BANK_ACCOUNT_NO_CR'] = $fibtrec['FIBT_BANKAC_CODE'];
                } else {
                    $record['BANK_ACCOUNT_NO_CR'] = $fibtrec['FIBT_BANK_ACCOUNT_NO'];
                }
                $record['BANK_ACCOUNT_NO_CR'] = $this->bankact_code_fix($record['BANK_ACCOUNT_NO_CR']);
            } else {
                // From a GL account
                $record['GLACCOUNTCODE_CR'] = $record['FIAT_GLACCOUNTCODE2'];
                $record['BANK_ACCOUNT_NO_CR'] = '';
            }
            // Credit amount
            $record['CREDITS'] = $record['TRANS_AMT'];
            // Split debit and credit amounts to respect the limit of accounting definition format number lenght
            $ar_record_acum = array();
            $ar_record_acum['DEBITS'] = $record['DEBITS'];
            $ar_record_acum['CREDITS'] = $record['CREDITS'];
            $ar_amt = $this->ibs_je_decr_split_amt($ar_record_acum, $ar_amount_pars);
            // If AFFECT_CASH is 'DR', it's a deposit (APORTE)
            // If AFFECT_CASH is 'CR', it's  a payment (DESEMBOLSO) (default value)
            //   - Caso 1002541 - BNP-Incid 189965 Rev Ope Fso
            // Para los reversos: como se reversa la contablilidad, va a dar un resultado inverso en
            // AFFECT_CASH, por lo cual la reversión ya se arregla con este IF...
            // Transpone las cuentas de banco, cuentas contable y descripciones de la fuente y el destino
            // Reverse transaction: because G/L is also reversed, it will get inverse result in AFFECT_CASH,
            // so reversion is fixed by this next IF...
            // Swap source and target bank account, G/L acc. and transaction description
            if ($s_affect_cash === 'DR') {
                // Swap bank account & name of transfer source and target
                $s_tmp_var = $record['IDNAME'];
                $record['IDNAME'] = $record['IDNAME_2'];
                $record['IDNAME_2'] = $s_tmp_var;
                $s_tmp_var = $record['BANK_ACCOUNT_NO_DB'];
                $record['BANK_ACCOUNT_NO_DB'] = $record['BANK_ACCOUNT_NO_CR'];
                $record['BANK_ACCOUNT_NO_CR'] = $s_tmp_var;
                $s_tmp_var = $record['GLACCOUNTCODE_DB'];
                $record['GLACCOUNTCODE_DB'] = $record['GLACCOUNTCODE_CR'];
                $record['GLACCOUNTCODE_CR'] = $s_tmp_var;
            }
            if (is_null($record['GLACCOUNTCODE_DB']) || $record['GLACCOUNTCODE_DB'] === 'null') {
                $record['GLACCOUNTCODE_DB'] = '';
            }
            if (is_null($record['GLACCOUNTCODE_CR']) || $record['GLACCOUNTCODE_CR'] === 'null') {
                $record['GLACCOUNTCODE_CR'] = '';
            }
            $s_tmp_from = $record['BANK_ACCOUNT_NO_DB'];
            if ($record['GLACCOUNTCODE_DB'] !== '') {
                $s_tmp_from = dict('GEN_LBL_ACCOUNTCODE') . ': ' . $record['GLACCOUNTCODE_DB'];
            }
            $s_tmp_to = $record['BANK_ACCOUNT_NO_CR'];
            if ($record['GLACCOUNTCODE_CR'] !== '') {
                $s_tmp_to = dict('GEN_LBL_ACCOUNTCODE') . ': ' . $record['GLACCOUNTCODE_CR'];
            }
            $contents .= '' .
                    /* Transaction Amount */
                    dict('GEN_LBL_AMOUNT') . ': ' . xFormat::number($record['CREDITS'], CLX_NUM_TWO) . CLX_CHAR_NL .
                    /* Currency */
                    dict('GEN_LBL_CURRENCY') . ': ' . $DBLT->getListItem('CURR', $record['CURRENCY_CODE']) . CLX_CHAR_NL .
                    /* Source */
                    '[' . dict('GEN_LBL_SOURCE') . ']' . CLX_CHAR_NL .
                    /* Source Account */
                    dict('GEN_LBL_AC_NUMBER') . ': ' . $s_tmp_from . CLX_CHAR_NL .
                    /* Source Description */
                    dict('GEN_LBL_DESCRIPTION') . ': ' . $record['IDNAME'] . CLX_CHAR_NL .
                    /* Target */
                    '[' . dict('GEN_LBL_TARGET') . ']' . CLX_CHAR_NL .
                    /* Target Account */
                    dict('GEN_LBL_AC_NUMBER') . ': ' . $s_tmp_to . CLX_CHAR_NL .
                    /* Target Description */
                    dict('GEN_LBL_DESCRIPTION') . ': ' . $record['IDNAME_2'] . CLX_CHAR_NL;
            // Banck account validation
            $s_line_validation_errors = '';
            /*
             * CODE_ERR_IBS_ITRANS_NODBBANKACC
             * Source banck account unspecified
             * No se especifico la cuenta de banco fuente
             */
            if (trim($record['BANK_ACCOUNT_NO_DB']) === '' && trim($record['GLACCOUNTCODE_DB']) === '') {
                $s_line_validation_errors .= '<br><b>' . dict('GEN_LBL_ERROR') . '</b> ' . dict('CODE_ERR_IBS_ITRANS_NODBBANKACC');
            }
            /*
             * CODE_ERR_IBS_ITRANS_NOCRBANKACC
             * Target banck account unspecified
             * No se especifico la cuenta de banco destino
             */
            if (trim($record['BANK_ACCOUNT_NO_CR']) === '' && trim($record['GLACCOUNTCODE_CR']) === '') {
                $s_line_validation_errors .= '<br><b>' . dict('GEN_LBL_ERROR') . '</b> ' . dict('CODE_ERR_IBS_ITRANS_NOCRBANKACC');
            }
            // Process each amount line
            $s_err_lines = '';
            $s_obs = $this->get_fiat_docum($fibtrec['TRANS_CODE']); // only put documentation on first
            $total = count($ar_amt['DEBITS']);
            for ($ik = CLX_INIT_ZERO; $ik < $total; $ik++) {
                if (!empty($this->debug))
                    echoLog('<br>ik = ' . $ik);
                $record['DEBITS'] = $this->integer_amt_fix_before_trsnfr($ar_amt['DEBITS'][$ik]);
                $record['CREDITS'] = $this->integer_amt_fix_before_trsnfr($ar_amt['CREDITS'][$ik]);
                $i_cont_reg++;
                $ar_socket_line = $EBSK->createMessage($msg_code, $record);
                //   Socket line generation Error handling
                $a_error_response = $this->send_field_error_verification($EBSK);
                if (!empty($this->debug)) {
                    echoLog('<hr>EIBS Socket Debug Info<br>' . $this->sdi_debug_dump($this->ar_last_sent_skt) . '<hr>');
                }
                if ($a_error_response['error'] === true) {
                    // fields error... socket record coluld not be send
                    if ($s_obs !== '') {
                        $s_obs .= '<br>';
                    }
                    $s_el_error = '<br><b>' . dict('GEN_LBL_ERROR') . '</b> [' . ($ik + CLX_NUM_ONE) . '] ' . $a_error_response['errormsg'];
                    $s_obs .= $s_el_error; // The error msg
                    /*
                     * GEN_LBL_ERROR
                     * Error
                     * Error
                     */
                    $s_err_lines .= $s_el_error;
                    $o_seq_name_file_generation->b_stop_file_generation = true; // stop file generation
                    if (!empty($this->debug))
                        echoLog($s_err_lines);
                }
                if (!empty($this->debug))
                    echoLog(debug_dump('ibs_transfer_export - <B>' . $i_cont_reg . '</B>', $ar_socket_line));
                $s_socket_line = $EBSK->toString_();
                if ($i_cont_reg > CLX_NUM_ONE)
                    $s_socket_line = CLX_CHAR_NL . $s_socket_line; // primera linea sin enter al principio
                if (!empty($this->debug))
                    echoLog('<B>' . $s_socket_line . '</B>');
                // Html version of the content
                $s_line_html = $o_seq_name_file_generation->cofiex_linegen_detail($i_cont_reg, $ar_socket_line, $s_obs . $s_line_validation_errors);
                $s_obs = '';
                // Writes record data
                $o_seq_name_file_generation->insert_record_data($s_socket_line, $s_line_html, $s_otherinfo);
                $o_seq_name_file_generation->i_cont_tot_reg++;  // Caso 1002901 - To know if there was records generated...
            }
            // Sum  debit and credit with bcadd
            $ar_amt_sum['DEBITS'] = bcadd($ar_amt_sum['DEBITS'], $ar_record_acum['DEBITS']);
            $ar_amt_sum['CREDITS'] = bcadd($ar_amt_sum['CREDITS'], $ar_record_acum['CREDITS']);
            if ($s_err_lines !== '') {
                $contents .= dict('GEN_LBL_ERROR') . ': ' . $s_err_lines;
                $s_record_blocking = '4';
            } else {
                ///////////////////////////////////////////
                // Temporal blocking of list of transactions, while the transfers file is processed
                //   Va registrando los IDCODE de las transacciones procesadas para eventual actualización masiva
                // en caso de error de generación del archivo de interfaz
                $s_trans_code_list_4_update .= ($s_trans_code_list_4_update === '' ? '' : ',') . singleQuote($fibtrec['TRANS_CODE']);
                if (!empty($this->debug))
                    echoLog('<br>s_trans_code_list_4_update = ' . $s_trans_code_list_4_update);
                ///////////////////////////////////////////
                $s_record_blocking = '2';
            }
            //Set status
            //   se complementa con mensajes para este registro
            $contents = strip_tags(str_replace('<br>', CLX_CHAR_NL, $contents));
            $this->setprintChecksResult(
                    $fibtrec['TRANS_CODE'], array(
                'RECORD_BLOCKING' => $s_record_blocking,
                'INTERFACE_MSG' => $contents
                    )
            );
        }//end while
        // Flush rest of pending content
        // Transfers the file
        // Traps errors and save it to database
        //$o_seq_name_file_generation->transfer_output_file(null, '</TABLE>');
        $o_seq_name_file_generation->s_line_footer_html = str_replace('%DEBITS%', xFormat::number($ar_amt_sum['DEBITS'], CLX_NUM_TWO), $o_seq_name_file_generation->s_line_footer_html);
        $o_seq_name_file_generation->s_line_footer_html = str_replace('%CREDITS%', xFormat::number($ar_amt_sum['CREDITS'], CLX_NUM_TWO), $o_seq_name_file_generation->s_line_footer_html);
        $o_seq_name_file_generation->transfer_output_file(null, $o_seq_name_file_generation->s_line_footer_html . '</TABLE>');
        /*
          The IBS import module process the file and eventually returns a .LOG file with a ramdomdly generated filename.
          The first line will contain the IDCODE of the record generated by this process, just to be able to identify the
          correspondence with the .log file and attach the result to the generated record
          The rest of the content are the error messages and it could be like the ones on the accounting interfase
         */
        if ($o_seq_name_file_generation->b_stop_file_generation == false && $i_cont_reg > CLX_NUM_ZERO) {
            if ($o_seq_name_file_generation->b_stop_file_gen_msg !== '') {
                $a_record = array(
                    'RECORD_BLOCKING' => '4',
                    'INTERFACE_MSG' => $o_seq_name_file_generation->b_stop_file_gen_msg . ' [2]'
                );
                $this->updateFiatList($s_trans_code_list_4_update, $a_record, true, false);
            }
            // Load the sockets interface (just in case)
            $this->massive_socket_ondemand_loader();
        } elseif ($i_cont_reg == CLX_NUM_ZERO) {
            /*
             * CODE_ERR_IBS_ITRANS_NOTHINGTODO
             * No transfers to be issued
             * No hay transferencias a ser realizadas
             */
            $contents .= '- ' . dict('CODE_ERR_IBS_ITRANS_NOTHINGTODO') . ' (*)<BR>' . CLX_CHAR_NL;
            return $contents;
        }
        return $contents;
    }

    /*
     * Check if there's a .log file response to any INTERNAL TRANSFER made
     * @param void
     * @return void
     */
    function ibs_transfer_logfile_check() {
        return $this->ibs_trsf_je_logfile_check('ITRF');
    }

    /*
     * Returns documentation of a given transaction in a string, separated by new lines <BR>
     *
     * @param string $s_transcode = transaction code
     * @return string
     */
    function get_fiat_docum($s_transcode) {
        $s_response = '';
        $s_sep = '';
        $records = ClxCommon::$db->getRecords($this->trdoname, 'TRANS_CODE=' . singleQuote($s_transcode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            $s_response .=  $s_sep . '[' . $record['EFFTDATE'] . '] ' .  $record['IDNAME'] .  '<br>' .  $record['DESCRIPTION'];
            $s_sep = '<br>';
        }
        return trim($s_response);
    }

}
