<?PHP
/**
* General Code File
* For more information contact  support@alenet.com
* 
* @author       $Author: fsantana $
* @copyright    Alenet, Inc.
* @since        $Date: 2011-10-11 15:47:42 -0600 (Tue, 11 Oct 2011) $
* @version        $Rev: 2747 $
* 
* CHANGE LOG
* 2009/09/02 Included svn prop
* Registro de cambios
  * 2007-04-04 CJR: implementada la carga bajo demanda de las interfaces masivas (massive_socket_ondemand_loader) y se corrigi que tome los parametros 
	PRES_CLIENT_SOCKET_CREATION y PRES_ACC_REQ_EXPRT_FILE si no estan definidas sus versiones de FONDAFA, esto para los dems bancos distintos 
	al BAV que usen el modulo de prestaciones sociales
  * 2007-04-11  CJR: se implemento la carga bajo demanda de las interfaces masivas en los metodos fondafa_bank_acc_req_export_run y 
	prestaciones_bank_acc_req_export_run.
  ------ Produccion inversiones en BAV
  * 2007-06-18 CJR: metodo prestaciones_bank_acc_req_export_run(). se agrego la podibilidad de tomar los valores de los campos cod. producto y tipo prod. desde la tabla 
	PRES (BT)
  * 2007-09-12 CJR: create_banck_account_and_link_to_crm(): PRES se arreglo un bug q impedia realizar la asignacion de las ctas de banco cuando habian varios registros 
	de lotes cargados con numeros de cuenta asignados. Esto sucede cuando se cargan varios lotes de una sola vez, incluyendo incorporaciones + otras operaciones que 
	tienen ya los numeros de cta de banco asignados en los archivos planos.
  * 2007-10-19 CJR: create_banck_account_and_link_to_crm() cuando la interfaz no logra asignar el numero de cuenta y el CUSCUN queda en zero, reporta que no se puede hacer nada y se regresa de inmediato. Anteriormente se quedaba en un loop
  * 2007-10-30 CJR: creacin de los mdulos de simulacin de interfaces IBS para presentaciones de LFR.
  * 2007-11-16 CJR: simulacion_generic_export_run(): se elimina los files fuentes en la simulacin de las interfaces
  *			  gen_bank_acc_req_file_import_action(): se elimina el archivo fuente de la creacion masiva de ctas de bco.
  * 2007-12-06 CJR: Se agreg en la condicin el estatus, para que no tome en cuenta otros registros que tengan el mismo CUSCUN y estatus de error u otro que no sea "en espera por cta. bancaria"
  * 2007-12-18 CJR: Se agregado la validacin para que no permita eliminar el registro si el estatus es END (Casos # 1000347 y 1000348)
  * 2008-01-24 CJR: Se agreg la posibilidad de que varios usuarios puedan enviar solicitudes de creacin masiva de clients y ctas. de bco.(Caso # 1000370)
			create_ibs_client_moverfile() = se sustituyo el copy() por la llamada a ibs_interface_queue. Se elimina el temporal porque ya la ibs_interface_queue hace una copia 
			de los archivos en su propio repositorio.
			fondafa_asigna_status_crm(): ahora devuelve el submodulo que lee de las lineas del archivo de respuesta de creac. masiva de clientes de IBS
			fondafa_client_import_run = se identifica el mdulo (FON=Fondafa, PRES=Prestaciones)
			fondafa_bank_acc_req_export =					"
			fondafa_bank_acc_req_export_run =					"
			fondafa_bank_acc_req_file_import =					"
			fondafa_bank_acc_req_file_import_doitnow =			"
			prestaciones_client_import_run =					"
			prestaciones_bank_acc_req_export =					"
			prestaciones_bank_acc_req_export_run =				"
			prestaciones_bank_acc_req_file_import =				"
			prestaciones_bank_acc_req_file_import_doitnow =		"
  * 2008-02-12 CJR: se agreg la llamada al mtodo ibiq_schedule_4_exec() para ejecutar automaticamente el monitor de la cola al final de los procesos que la usan
  *			y se genera un archivo con el reporte que antes quedaba en el cuerpo del monitor de procesos. para evitar desbordamiento de la memoria
  *			(ver mtodo open_rpt_process_run())
  * 2008-02-18 CJR: validateFonPres: la validacion del record con estaus END se hace contra el contenido de la tabla, no contra lo q hay en la forma, porque se puede 
  *			cambiar el estatus de la forma y la validacion no tiene efecto.
  *			fondafa_asigna_status_crm(): se agreg mensaje de error para los casos en los que el archivo RCLX???.TXT no tenga la 
  *			informacion necesaria para saber de cuales de los submodulos pertenece (PRES o FONDAFA) para evitar que de error en SELECT que 
  *			actualiza el estatus del registro en espera por creacion de codigo de IBS.
  * 2008-03-05 CJR: se agreg la llamada a la clase proc_eng_params() para que los errores en la asignacion de cuentas CRM queden en las excepciones.
  *			Se creo el metodo report_error() para llevar a cabo esta tarea.
  * 2008-03-06 CJR: se cambio la extension de los reportes de respuesta de las interaces a .html (antes .txt) para que sean mostrados correctamente en la cola de interfaces.
  2008-03-25 CJR: validateFonPres: no estaba tomando el nombre de la tabla q se pasaba como parametro, siempre tomaba PRES
  2008-05-05 CJR: se pusieron comillas simples en el metodo validateFonPres por compatibilidad con Oracle
  2009-06-26 CJR: crea_cta_crm(): se agreg un parametro de tipo de operacin cuyo valor por defecto es 0001 (creacion)
			crm_acc_status_assign() = se puso condicion para que no actualice tabla alguna en caso de no ser PRES o FON
			Se sacaron los mtodos que son inherentes a la creacion masiva de clientes en IBS y se trasladaron a EIBS_utilities_4.php
  */

if (!class_exists('ibs_client_interface_commons'))
	include "EIBS_ACCO.PHP";
//   includeCodeLib('EIBS_CHK');
class fondafa extends ibs_crm_account_mass_export
{

	var $foncname; // fondafa clients table
	var $fibkname; // bank account
	var $presname; // prestaciones sociales

	var $fondafa_client_import_schedule = 'FON_CIM';			// Cdigo del Process Scheduling Parameter para la CREACION DE CUENTAS CRM
	var $fondafa_bank_acc_req_export_schedule = 'FON_BAREX';	// Cdigo del Process Scheduling Parameter para la EXPORTACION (SOLICITUD) DE CUENTAS DE BANCO
	var $fondafa_bank_acc_req_import_schedule = 'FON_BARIM';	// Cdigo del Process Scheduling Parameter para la IMPORTACION DE CUENTAS DE BANCO
	var $fondafa_liquidacion_schedule = 'FONL';					// Cdigo del Process Scheduling Parameter para EL PROCESO DE IMPORTACIONES
	var $fondafa_ordencompra_schedule = 'FONO';					// Cdigo del Process Scheduling Parameter para EL PROCESO ORDENES DE COMPRA

	var $prestaciones_proceso_schedule = 'PRES';				// Cdigo del Process Scheduling Parameter para proceso de prestaciones sociales
	var $prestaciones_client_import_schedule = 'PRES_CIM';		// Cdigo del Process Scheduling Parameter para la creacin de clientes en IBS de prestaciones sociales
	var $prestaciones_bank_acc_req_export_schedule = 'PRES_BAREX';	// Cdigo del Process Scheduling Parameter para la EXPORTACION (SOLICITUD) DE CUENTAS DE BANCO de prestaciones sociales
	var $prestaciones_bank_acc_req_import_schedule = 'PRES_BARIM';	// Cdigo del Process Scheduling Parameter para la IMPORTACION DE CUENTAS DE BANCO de prestaciones sociales

	var $fon_acc_req_exprt_dir;

	var $debug = false;

	var $s_prd_cod;
	var $s_prd_tipo;
	var $s_lote;
	var $lang;

	var $ar_importselect_form_items;

	var $fibk_defval_idname_text;
	var $fibk_defval_city;
	var $fibk_defval_state;
	var $fibk_defval_country;

	var $submodule;		// "PRES" = Prestaciones / "FON" = Fondafa

	/**
	 * Constructor
	 */
	function __construct($s_comp_code=NULL, $parameters = array())
	{
		parent::__construct(NULL, $parameters);
		
		//*** Parametros Generales ***//
		// Archivo para la exportacin del archivo de solicitud masiva de creacin de cuentas (directorio + nombre del archivo)
		$this->fon_acc_req_exprt_dir = companyParameter('FONDAFA_ACC_REQ_EXPRT_FILE', $s_comp_code);
		if($this->fon_acc_req_exprt_dir == '') {
			$this->fon_acc_req_exprt_dir = companyParameter('PRES_ACC_REQ_EXPRT_FILE', $s_comp_code);
		}

		// Indicador para creacin de clientes: usando 1=sockets  o 0=batch 
		$fon_client_socket_creation = companyParameter('FONDAFA_CLIENT_SOCKET_CREATION', $s_comp_code);
		if($fon_client_socket_creation == '') {
			$fon_client_socket_creation = companyParameter('PRES_CLIENT_SOCKET_CREATION', $s_comp_code);
		}
		$fon_client_socket_creation = ($fon_client_socket_creation == '')? 1 : 0+$fon_client_socket_creation;
		
		// Nombre de la variable para la seleccion del archivo de texto plano a importar
		define('IMPORT_SELECT_FORM_VARNAME', 'FONDAFA_IMPRTFORM_importcode');

		// Si es true se detiene en los errores de verificacion de nombre de estado/municipio
		define('B_SEVERE_ERROR_STOP', false);

		/*
		 * CODE_MSG_FONDAFA_IMPRTFORM_IT_FONC_01
		 * Client's accounts open file
		 * Archivo de Apertura de Cuentas de Clientes
		 *
		 * CODE_MSG_FONDAFA_IMPRTFORM_IT_FONL
		 * Archivo de Liquidaciones
		 * Archivo de Liquidaciones
		 *
		 * CODE_MSG_FONDAFA_IMPRTFORM_IT_FONO
		 * Archivo de Ordenes de Pago
		 * Archivo de Ordenes de Pago
		 */
		$this->ar_importselect_form_items = array(
				'FONC_01' => dict("CODE_MSG_FONDAFA_IMPRTFORM_IT_FONC_01"),
				'FONL' => dict("CODE_MSG_FONDAFA_IMPRTFORM_IT_FONL"),
				'FONO' => dict("CODE_MSG_FONDAFA_IMPRTFORM_IT_FONO"),
			); 

		// Limite de tiempo para ejecucin de la creacion de clientes en IBS y ctas CRM
		define('TIME_LIMIT_4_CLIENT_IMPORT_RUN', 24*60*60);

		// Datos fijos para la creacin de clientes en IBS
		define('FONDAFA_DEFVAL_BIRTH_DATE', '1900-01-01');	// ADDRESS 1
		//define('FONDAFA_DEFVAL_ADDRESS1', 'FONDAFA');	// ADDRESS 1
		define('FONDAFA_DEFVAL_ADDRESS1', dict('CODE_MSG_FONDAFA_TITLE'));	// ADDRESS 1
		define('FONDAFA_DEFVAL_CITY', '0101');			// CITY
		define('FONDAFA_DEFVAL_STATE', '01' );			// STATE
		define('FONDAFA_DEFVAL_COUNTRY', 'VE');			// COUNTRY
		define('FONDAFA_DEFVAL_CUSTOMER_STATUS', '2');	// CUSTOMER STATUS "1.Inactivo 2.Activo 3.Lista Negra"
		define('FONDAFA_DEFVAL_INCOME_SOURCE', 'OTR');	// Fuente de ingreso (en tabla CONT): ACTIVIDADES PROPIA DE LA EMPRESA (ACT), EMPLEADO (EMP), INDEPENDIENTE (IND), JUBILADO (JUB), OTROS INGRESOS (OTR)
		define('FONDAFA_DEFVAL_INDUSTRYCLASS', '0115');	// AGRICOLA/FORESTAL (0115)
		define('FONDAFA_SUDEBAN_CODE_INDIVIDUALS_DEFVAL', '080100');	// '2'  CODIGO SUDEBAN PARA PERSONAS NATURALES NACIONALES O EXTRANJEROS
		define('FONDAFA_SUDEBAN_CODE_COMPANY_DEFVAL', '080200');	// '1' CODIGO SUDEBAN PARA PERSONAS JURIDICAS

		// Constantes para las solicitudes a IBS para la creacin de ctas bancarias de los beneficiarios
		define('BANK_ACC_REQ_IMPORT_ERRFILE_EXT', '.html');
		define('BANK_ACC_REQ_RECORD_DEFINITION_CODE', 'FON_ACCREQ_01');
		//define('FIBK_DEFVAL_IDNAME_TEXT', dict('CODE_MSG_FONDAFA_TITLE') . ': ^1');	// texto que inicia el texto descriptivo de la cuenta de banco
		//define('FIBK_DEFVAL_CITY', FONDAFA_DEFVAL_CITY);			// CITY
		//define('FIBK_DEFVAL_STATE', FONDAFA_DEFVAL_STATE );			// STATE
		//define('FIBK_DEFVAL_COUNTRY', FONDAFA_DEFVAL_COUNTRY);			// COUNTRY

		// Flag para habilitrar o desabilitar el proceso en linea de creacion de clientes
		define('FONDAFA_CLIENT_SOCKET_CREATION', $fon_client_socket_creation);	// 1 = encendido, usa socket; 0= apagado, usa batch file

		// Masivo de cuentas de banco
		define('IBS_MASSIVE_BACKACT_CREATION_FILENAME', TEMPORARY_OPERATIONS_DIRECTORY . 'ibs_mass_banckact_creat.txt');	
		define('IBS_MASSIVE_BACKACT_CREATION_RPT_FILENAME', TEMPORARY_OPERATIONS_DIRECTORY . 'ibs_mass_banckact_creat_rpt.html');

		multiTableName($this, array('FONC', 'FIBK', 'PRES', 'TTPA'));
	} // Method End
	
	/**
	  * FON* & PRES - Record validations on delete
	  * ON UPDATE RECORD PRE-DATABASE COMMIT: $a = new fondafa(); if(!$a->validateDelete($record)) $msg[ ] = 1;
	  */
	function validateDelete($record)
	{
		global $db;
		$status = true;
		if($record['REC_STATUS'] == 'END'){
			/**
			GEN_ERR_CANNOTDELETE
			Record can not be modified or deleted.
			Registro no puede ser modificado ni borrado
			*/
			addMessage(dict('GEN_ERR_CANNOTDELETE'));
			$status = false;
		}
		return $status;
	} // Method End

	/**
	  * FON* & PRES - Record validations on modify
	  * ON VALIDATE RECORD: fondafa::validateFonPres($record, $msg, 'FONC');
	  */
	function validateFonPres(&$record, &$msg, $prefijo)
	{
		global $db, $ac;
		$tableName = TableName($prefijo);
		$fm = '';
		$status = true;
		if($ac <> 'DELETE') $fm = $prefijo . '_';	// FONC, FONL, FONO, PRES
		if($ac <> 'CREATE'){
			//if($record[$fm.'REC_STATUS'] == 'END'){
			if( ClxCommon::$db->getField($tableName, "REC_STATUS", "ID = '". $record[$fm.'id'] . "'") == 'END'){	
				/**
				GEN_ERR_CANNOTDELETE
				Record can not be modified or deleted.
				Registro no puede ser modificado ni borrado
				*/
				addMessage(dict('GEN_ERR_CANNOTDELETE'));
				$msg[$fm.'REC_STATUS'] = dict('GEN_ERR_CANNOTDELETE');
				$status = false;
			}
		}
	}//end method


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	* Seleccion del tipo de Import a ser realizado
	*/
	function fondafa_selec_imprt()
	{
		if(isset($_REQUEST[IMPORT_SELECT_FORM_VARNAME]) && $_REQUEST[IMPORT_SELECT_FORM_VARNAME] != '') {
			return $this->fondafa_show_import_01_screen($_REQUEST[IMPORT_SELECT_FORM_VARNAME]);
		} else {
			return $this->fondafa_selec_imprt_dialog($_REQUEST, NULL);
		}
	} // Method End

	/**
	* Forma para seleccionar el tipo de Import a ser realizado
	*/
	function fondafa_selec_imprt_dialog($record, $msg)
	{
		global $db;

		// Setup de la forma y campos Hidden
		$OBJS = &getTool("OBJS");
        $form = new htmlForm("action",  $_SERVER['PHP_SELF'], 'id','theForm','name','theForm');
		$form->addArgument("to", $_REQUEST['to']);
		$form->addArgument("ac", $_REQUEST['ac']);
		$form->addArgument("idlist", (isset($_REQUEST['idlist'])) ? $_REQUEST['idlist'] : '');
		$form->addArgument("it", $_REQUEST['it']);
		$form->addArgument("wind", '1');
		$form->addArgument("confirm", '1');
		//$form->setProp("enctype", "multipart/form-data");
			
		// Datos que se solicitan
		$tableWidth = 2;
		$table = new htmlTable($tableWidth, "class", "form", "width", "100%");
		/*
		 * CODE_MSG_FONDAFA_IMPRTFORM_TITLE
		 * FONDAFA: Plain text files import
		 * FONDAFA: Importacin de Archivos de Texto Plano
		 */
		$code = "";
		$table->addCell(dict("CODE_MSG_FONDAFA_IMPRTFORM_TITLE"), "class", "title",
                        "colspan", $tableWidth);
		//$table->addCell(dict("TOOL_PACK_PROMPT_IMPORTEXPLAIN"), "class",
		$table->addCell('', "class",
                        "subtitle", "colspan", $tableWidth);
		if(!array_key_exists('FONDAFA_IMPRTFORM_importcode', $record))
            $record[IMPORT_SELECT_FORM_VARNAME]='';

		//Select con los tipos de import
		$select = new htmlSelect(IMPORT_SELECT_FORM_VARNAME);
		foreach($this->ar_importselect_form_items as $name => $val) {
			$select->addItem("$name, $val", $name, false);
		}
		/*
		 * CODE_LBL_FONDAFA_IMPRTFORM_ITYPE
		 * Import Type to perform
		 * Tipo de Importacin a realizar
		 */
		$table->addCell(dict('CODE_LBL_FONDAFA_IMPRTFORM_ITYPE'), 'class','prompt');
		$table->addCell($select->source(), 'class','data');

		// Botones y parte final
		$c = new htmlSubmit(dict("GEN_LBL_IMPORT"), "PRINT_DIALOG");
		$buttons = $c->source();
		if(strpos($_SERVER['PHP_SELF'],'pop.php')!==false){
			$c = new htmlButtonCloseWindow(dict("GEN_LBL_CANCEL"));
			$buttons .= $c->source();
		}
		$table->addCell($buttons, "class", "footers", "colspan", $tableWidth);
		$form->setContents($table->source());
		return $form->source();

	} // Method End

	/**
	 * Para poder hacer la llamada desde el menu a la opcion de importacion del sistema que ingresa los datos
	 * de los clientes desde el archivo separado x tabuladores a la tabla FONC
	 */
	function fondafa_show_import_01_screen($imprt_code)
	{
//print_r($_REQUEST);
		global $db;

		$ar_clxtool_record =  ClxCommon::$db->getRecord('CLX_DB_IMPORTS', "IDCODE = '$imprt_code'");
		$content = '';
		if(!$ar_clxtool_record) {
			/*
			 * CODE_FONDAFA_ERR_IMPDEFNOTFOUND
			 * '^1' import definition not found
			 * No se encontr la definicin '^1' de importacin
			 */
			$content .= dict("CODE_FONDAFA_ERR_IMPDEFNOTFOUND", $imprt_code);
		} else {
			//if(!isset($_POST["confirm"])) $_POST["confirm"] = '1';
			if(isset($_POST["confirm"])) unset($_POST["confirm"]);
			if(!isset($_POST["DBIM_id"])) $_POST["DBIM_id"] = $ar_clxtool_record['ID'];
			if(!isset($_POST["DBIM_idcode"])) $_POST["DBIM_idcode"] = "'$imprt_code'";
			if(!isset($_POST["DBIM_idname"])) $_POST["DBIM_idname"] = $ar_clxtool_record['IDNAME'];
			if(!isset($_POST["DBIM_test"])) $_POST["DBIM_test"] = '0';
			if(!isset($_POST["DBIM_save_errors"])) $_POST["DBIM_save_errors"] = '1';
			if(!isset($_POST["DBIM_show_file"])) $_POST["DBIM_show_file"] = '1';
			if(!isset($_POST["DBIM_error_limit"])) $_POST["DBIM_error_limit"] = '100';
			$DBIM = getTool("DBIM");
			$b_isadmin_ant = $DBIM->access["isadmin"];
			$DBIM->access["isadmin"] = true;
			$content .= $DBIM->action('IMPORT', array($ar_clxtool_record['ID']));
			$DBIM->access["isadmin"] = $b_isadmin_ant;
		}
		return $content;
	} // Method End

	/**
	* Para poder hacer la llamada desde el menu a la opcion de exportacin del sistema que devuelve
	* los clientes ya procesados de la tabla FONC en un archivo separado x tabuladores
	*/
	function fondafa_show_export_01_screen($exprt_code)
	{
		global $db;

		$ar_clxtool_record =  ClxCommon::$db->getRecord('CLX_DB_EXPORTS', "IDCODE = '$exprt_code'");
		$content = '';
		if(!$ar_clxtool_record) {
			/*
			 * CODE_FONDAFA_ERR_EXPDEFNOTFOUND
			 * '^1' export definition not found
			 * No se encontr la definicin '^1' de exportacin
			 */
			$content .= dict("CODE_FONDAFA_ERR_EXPDEFNOTFOUND", $exprt_code);
		} else {
			if(isset($_POST["confirm"])) unset($_POST["confirm"]);
			//if(!isset($_POST["idlist"])) $_POST["idlist"] = $ar_clxtool_record['ID'];
			if(!isset($_POST["DBEX_id"])) $_POST["DBEX_id"] = $ar_clxtool_record['ID'];
			if(!isset($_POST["DBEX_idcode"])) $_POST["DBEX_idcode"] = "'$exprt_code'";
			if(!isset($_POST["DBEX_idname"])) $_POST["DBEX_idname"] = $ar_clxtool_record['IDNAME'];
			if(!isset($_POST["DBEX_querycode"])) $_POST["DBEX_idname"] = $ar_clxtool_record['QUERYCODE'];
			if(!isset($_POST["DBEX_filename"])) $_POST["DBEX_filename"] = './export/fondafa.txt';
			//if(!isset($_POST["DBEX_format"])) $_POST["DBEX_format"] = $ar_clxtool_record['QUERYCODE'];
			$DBEX = getTool("DBEX");
			$b_isadmin_ant = $DBEX->access["isadmin"];
			$DBEX->access["isadmin"] = true;
//echoLog("ar_clxtool_record['ID'] = ". $ar_clxtool_record['ID']);
			$content .= $DBEX->action('EXPORT', array($ar_clxtool_record['ID']));
			$DBEX->access["isadmin"] = $b_isadmin_ant;
		}
		return $content;
	} // Method End


	/**
	 * Dialog Handler estndar para cuando se pide el nro. de lote previo a la ejecucin 
	 * de un item del motor de procesos
	 */
	function fondafa_gen_dialog_handle($s_process_code, $s_title=NULL)
	{
		$this->contents = '';
//$this->debug = false;
//print_r($_REQUEST);
		$this->lang = $_REQUEST['lan'];
		if($s_title==NULL) {
			$s_title = $_REQUEST['clientix_MenuBar_option'];
		}

		if(!array_key_exists('confirm', $_REQUEST)){
			// Si no se especificaron los parmetros, muestra la pantalla de dialogo que pide los parametros
			$this->contents = $this->fondafa_transac_import_dialog($s_process_code, $s_title, $_REQUEST);
		} else {
			// Valida la forma
			$msg = $this->fondafa_transac_import_dialog_validation($s_process_code, $_REQUEST);
			if(!empty($msg)) {
				$this->contents = $this->fondafa_transac_import_dialog($s_process_code, $s_title, $_REQUEST, $msg);
			} else {
				$s_lote = (isset($_REQUEST['RTBL_CUST_FILEID'])) ? $_REQUEST['RTBL_CUST_FILEID'] : '';
				$s_prd_cod = (isset($_REQUEST['RTBL_VZ_BK_PROD_CODE'])) ? $_REQUEST['RTBL_VZ_BK_PROD_CODE'] : '';
				$s_prd_tipo = (isset($_REQUEST['RTBL_VZ_BK_PROD_TYPE'])) ? $_REQUEST['RTBL_VZ_BK_PROD_TYPE'] : '';
				$s_trans_date = (isset($_REQUEST['RTBL_TRANS_DATE'])) ? $_REQUEST['RTBL_TRANS_DATE'] : '';

				//Create Process Schedule Schedule
				$ar_pars_2_send = array();
				$ar_pars_2_send['TRANS_DATE'] = $s_trans_date;
				$ar_pars_2_send['CUST_FILEID'] = $s_lote;
				$ar_pars_2_send['VZ_BK_PROD_CODE'] = $s_prd_cod;
				$ar_pars_2_send['VZ_BK_PROD_TYPE'] = $s_prd_tipo;
				$ar_pars_2_send['LANGUAGE'] = $this->lang;
				$ar_pars_2_send['USERNAME'] = $this->username;
				$this->contents = $this->create_proc_sched_sched($s_title, $s_process_code, $ar_pars_2_send);
			}
		}

		return $this->contents;
	} // Method End

	/*
	  * Valida los campos de la forma
	  */
	function fondafa_transac_import_dialog_validation($s_process_code, $_DREQUEST)
	{
		$ar_response = array();
		if(isset($D_REQUEST['RTBL_CUST_FILEID']) && $D_REQUEST['RTBL_CUST_FILEID'] == '') {
			/*
			  * GEN_ERR_LOT_FLD_MANDATORY
			  * Lot must be specified
			  * El Lote debe ser especificado
			  */
			$ar_response['RTBL_CUST_FILEID'] = dict('GEN_ERR_LOT_FLD_MANDATORY');
		}
		return $ar_response;
	}

/*
	/**
	* Pantalla que pide el nro. de lote
	* /
	function fondafa_client_import_dialog($s_title, $record)
	{
		global $db;
		if(!isset($msg)) $msg = array();

		// Setup de la forma y campos Hidden
        $form = $this->dialog_form_set($s_title);
			
		// Datos que se solicitan
		$tableWidth = 2;
		$table = new htmlTable($tableWidth, "class", "form", "width", "100%");
		/*
		 * CODE_MSG_FONDAFA_TITLE
		 * FONDAFA
		 * FONDAFA
		 * /
		$table->addCell(dict("CODE_MSG_FONDAFA_TITLE") . ": $s_title", "class", "title", "colspan", $tableWidth);
		//$table->addCell($s_title, "class", "panel", "colspan", $tableWidth);
		//if(!array_key_exists('CUST_FILEID', $record)) $record["CUST_FILEID"]='';
		//if(!array_key_exists('VZ_BK_PROD_CODE', $record)) $record["VZ_BK_PROD_CODE"]='';
		//if(!array_key_exists('VZ_BK_PROD_TYPE', $record)) $record["VZ_BK_PROD_TYPE"]='';
		if(!isset($record["RTBL_CUST_FILEID"])) $record["RTBL_CUST_FILEID"] = '' ;

		$table->addField($msg, dict( ClxCommon::$db->getField('CLX_DB_FIELDS','FIELDFORMLABEL',"FIELDNAME = 'CUST_FILEID'")) . ":",
            "RTBL_CUST_FILEID", $record["RTBL_CUST_FILEID"], 50, 255);

		// Botones y parte final
		$c = new htmlSubmit(dict("GEN_LBL_EXECUTE"), "PRINT_DIALOG");
		$buttons = $c->source();
		if(strpos($_SERVER['PHP_SELF'],'pop.php')!==false){
			$c = new htmlButtonCloseWindow(dict("GEN_LBL_CANCEL"));
			$buttons .= $c->source();
		}
		$table->addCell($buttons, "class", "footers", "colspan", $tableWidth);
		$form->setContents($table->source());
		return $form->source();

	} // Method End
*/

	/**
	* Pantalla que pide el nro. de lote
	*/
	function fondafa_transac_import_dialog($s_process_code, $s_title, $record, $msg=NULL)
	{
		global $db;
		$OBJS = &getTool("OBJS");
		if($msg==NULL) $msg = array();

		// Setup de la forma y campos Hidden
        $form = $this->dialog_form_set($s_title);
			
		// Datos que se solicitan
		$tableWidth = 2;
		$table = new htmlTable($tableWidth, "class", "form", "width", "100%");
		/*
		 * CODE_MSG_FONDAFA_TITLE
		 * FONDAFA
		 * FONDAFA
		 */
		//$table->addCell(dict("CODE_MSG_FONDAFA_TITLE") . ": $s_title", "class", "title", "colspan", $tableWidth);
		$table->addCell($s_title, "class", "title", "colspan", $tableWidth);

		//if(!array_key_exists('CUST_FILEID', $record)) $record["CUST_FILEID"]='';
		if(!array_key_exists("RTBL_CUST_FILEID",$record)) $record["RTBL_CUST_FILEID"] = '';
		if(!array_key_exists("RTBL_TRANS_DATE",$record)) {
			$edate = $this->ar_comp_record['ACCOUNTING_DATE'];
			if(empty($edate)){
				$edate = xformat::getNow('Y-m-d');
			}
			$sdate = explode('-', $edate);
			//Start Date
			$record["RTBL_TRANS_DATE"] = adodb_date('Y-m-d', adodb_mktime(0, 0, 0, $sdate[1], $sdate[2]+1, $sdate[0]));
		}
		$field = $OBJS->getObject("DBFT", 'DATE');

		// Pide lote y fecha 
		switch ($s_process_code) {
			case $this->fondafa_liquidacion_schedule:
			case $this->fondafa_ordencompra_schedule:
			case $this->prestaciones_proceso_schedule:
				//From date
				$cell = $field->placeEditFieldObj('theForm', $msg, $record["RTBL_TRANS_DATE"], 'DATE', 'RTBL_TRANS_DATE', 'SDATE', 'GEN_LBL_DATE', 20, 20,'', '', '', true, false, false);
				$table->addCell($cell->source(),'colspan',$tableWidth);
				break;

			default:
		}

		// Lote
		$table->addField($msg, dict( ClxCommon::$db->getField('CLX_DB_FIELDS','FIELDFORMLABEL',"FIELDNAME = 'CUST_FILEID'")) . ":",
            "RTBL_CUST_FILEID", $record["RTBL_CUST_FILEID"], 50, 255);

		// Botones y parte final
		$c = new htmlSubmit(dict("GEN_LBL_EXECUTE"), "PRINT_DIALOG");
		$buttons = $c->source();
		if(strpos($_SERVER['PHP_SELF'],'pop.php')!==false){
			$c = new htmlButtonCloseWindow(dict("GEN_LBL_CANCEL"));
			$buttons .= $c->source();
		}
		$table->addCell($buttons, "class", "footers", "colspan", $tableWidth);
		$form->setContents($table->source());
		return $form->source();

	} // Method End

	/*
	  * Common part of forms generation. Returns the forms object prepared for the battle
	  */
	function dialog_form_set($s_title)
	{
		if(!isset($_REQUEST['idlist'])) $_REQUEST['idlist'] = '';
		// Setup de la forma y campos Hidden
        $form = new htmlForm("action",  $_SERVER['PHP_SELF'], 'id','theForm','name','theForm');
		$form->addArgument("to", $_REQUEST['to']);
		$form->addArgument("ac", $_REQUEST['ac']);
		$form->addArgument("idlist", $_REQUEST['idlist']);
		$form->addArgument("it", $_REQUEST['it']);
		$form->addArgument("clientix_MenuBar_option", $s_title);
		$form->addArgument("wind", '1');
		$form->addArgument("confirm", '1');
		$form->setProp("enctype", "multipart/form-data");
		return ($form);
	} // Method End

	
	/**
	* Pantalla que pide lote, tipo de cuenta y codiigo del producto
	*/
	function fondafa_dialog_01($formcode)
	{
		global $db;
		if($this->debug) echoLog(debug_dump('_REQUEST', $_REQUEST));
		$ac = $_REQUEST['ac'];
		$to = $_REQUEST['to'];
		$it = $_REQUEST['it'];
		
		$EDIT = &getTool('EDIT');
		$record = array(); 
		$msg = array();
		$formrec =  ClxCommon::$db->getRecord('CLX_UI_FORMS', "IDCODE = '$formcode'");
		$record = $_POST;

//echo debug_dump('FORMREC', $formrec);
//echo debug_dump('RECORD', $record);

		if(!empty($record['confirm'])){
			//getLookupValue('RTBL_CONTRACT_CODE', 'CONTRACT_CODE', $record);
		 	$EDIT->checkForm($formrec, $msg);
		}
		
		$form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '');
		$this->contents = $form->source();
			
		if(empty($record['confirm']) || !empty($msg)) return false;
		
		$this->s_lote = $record['RTBL_CUST_FILEID'];
		$this->s_prd_cod = $record['RTBL_VZ_BK_PROD_CODE'];
		$this->s_prd_tipo = $record['RTBL_VZ_BK_PROD_TYPE'];

		return true;
	} // Method End

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/* 
	LISTA 'PROS' CON LOS POSIBLES VALORES PARA EL CAMPO 'FONC.REC_STATUS'
		Completado con Errores (ENDR) *= No se ha creado el cliente en IBS
		Terminado (END) *= ya fueron asignados la cta. CRM y la cta. FIBK
		Detenido (STOP)
		Error (ERRO) *= hubo algun error en la asignacin de la cta. CRM
		Cancelado (CANC)
		En marcha (RUN) *= falta asignar la cta. del banco
		No comenzado (NOT)
		Idle (IDLE) *= acabados de importar sin haber pasado x proceso alguno
	*/

	/**
	 * Importacion de clientes (futuros participantes) para los contratos de FONDAFA
	 * A ser llamado desde la opcin de men
	 */
	function fondafa_client_import()
	{
		/*
		 * CODE_FONDAFA_LBL_TITCIM
		 * PAYEE CRM ACCOUNT CREATION
		 * CREACION DE CUENTAS CRM DE BENEFICIARIOS
		 */
		return $this->fondafa_gen_dialog_handle($this->fondafa_client_import_schedule, $this->titfondafa(dict("CODE_FONDAFA_LBL_TITCIM")));
	} // Method End

	/**
	 * Devuelve el titulo estandar para las aplicaciones de FONDAFA
	 */
	function titfondafa($s_title)
	{
		return (dict("CODE_MSG_FONDAFA_TITLE") . ": $s_title");
	}
	
	/**
	 * Ejecucin de la Importacion de clientes en el Process Engine (Run Time)
	 * La fuente es el archivo Excel enviado por Fondafa, procesado por el operador quien le agrega
	 * las 3 columnas correspondientes al banco, lote y usuario, convertido a TAB delimited e importado
	 * a la tabla FONC (FONDAFA_CLIENTES)
	 */
	function fondafa_client_import_run($s_lang, $s_username, $s_prd_cod, $s_prd_tipo, $s_lote)
	{
//$this->debug = true;
		global $db;

		// Identifica el sub-modulo
		$this->submodule = "FON";

		set_time_limit(TIME_LIMIT_4_CLIENT_IMPORT_RUN);
		$this->lang = $s_lang;
		$this->s_lote = $s_lote;
		$this->s_prd_cod = $s_prd_cod;
		$this->s_prd_tipo = $s_prd_tipo;
		$this->username = $s_username;

		$contents = '';

		// Trata de abrir el reporte de salida
		$s_response = $this->open_rpt_process_run(IBS_MASSIVE_CLIENT_CREATION_RPT_FILENAME);
		if($s_response!='') {
			return $s_response;
		}
		// Si los parametros del proceso no se pasaron debidamente, emite error y sale
		$this->proc_eng_params->set_tablename("FONC");
		if(! $this->proc_eng_params->verify_parameters()) {
			$s_response = "<h1>" . $this->proc_eng_params->errormsg . "</h1>";
			$this->o_response_rpt->write($this->proc_eng_params->errormsg);
			$this->o_response_rpt->close();
			return $s_response;
		}

		// Esta variable permite chequear el cambio del tipo de cliente (ruptura de control) para poder escribir 
		// 2 archivos distintos segun el tipo de persona ya que contiene el ultimo tipo de persona procesado
		$s_tipo_persona = '';

		// Valores por defecto para las direcciones del as cuentas CRM a crear
		$defvals = array();
		$defvals['NA2'] = FONDAFA_DEFVAL_ADDRESS1;			// ADDRESS 1
		$defvals['CTY'] = FONDAFA_DEFVAL_CITY;				// CITY
		$defvals['STE'] = FONDAFA_DEFVAL_STATE;				// STATE
		$defvals['CTR'] = FONDAFA_DEFVAL_COUNTRY;			// COUNTRY
		$defvals['PID'] = FONDAFA_DEFVAL_COUNTRY;			// INCORPORATION_COUNTRY
		$defvals['GEC'] = FONDAFA_DEFVAL_COUNTRY;			// RESIDENCE_COUNTRY
		$defvals['STS'] = FONDAFA_DEFVAL_CUSTOMER_STATUS;	// CUSTOMER STATUS "1.Inactivo 2.Activo 3.Lista Negra"
		$defvals['BDM'] = substr(FONDAFA_DEFVAL_BIRTH_DATE, 5, 2);	// BIRTH DATE MM
		$defvals['BDD'] = substr(FONDAFA_DEFVAL_BIRTH_DATE, 8, 2);	// BIRTH DATE DD
		$defvals['BDY'] = substr(FONDAFA_DEFVAL_BIRTH_DATE, 0, 4);	// BIRTH DATE YY
		$defvals['SOI'] = FONDAFA_DEFVAL_INCOME_SOURCE;		// INCOME_SOURCE
		$defvals['INC'] = FONDAFA_DEFVAL_INDUSTRYCLASS;		// INDUSTRYCLASS
		$defvals['ACCTYPE'] = 'BEPG';						// Add value 'Payee' to the account type field in ACCO
		$defvals['USERNAME'] = $this->username;

		/*
		 * CODE_FONDAFA_LBL_TITCIM
		 * PAYEE CRM ACCOUNT CREATION
		 * CREACION DE CUENTAS CRM DE BENEFICIARIOS
		 */
		//$contents .= $this->titulo(dict("CODE_FONDAFA_LBL_TITCIM")) . "<BR><BR>\n";
		$this->o_response_rpt->write($this->titulo(dict("CODE_FONDAFA_LBL_TITCIM")) . "<BR><BR>\n");
		
		/*
		 * GEN_LBL_LOT
		 * Lot
		 * Lote
		 */
		$contents .= "<BR>\n" . dict('GEN_LBL_LOT') . ": $this->s_lote<BR>\n";
		$this->o_response_rpt->write(dict('GEN_LBL_LOT') . ": $this->s_lote<BR>\n");
		//echoLog("Cdigo de Producto: $this->s_prd_cod");
		//echoLog("Tipo de Producto: $this->s_prd_tipo");

		/*
		 * GEN_LBL_USER
		 * User
		 * Usuario
		 */
		//$contents .= dict('GEN_LBL_USER') . ": $this->username<BR>\n";
		$this->o_response_rpt->write(dict('GEN_LBL_USER') . ": $this->username<BR>\n");
		//echoLog("Usuario (SESSION): " . $_SESSION['user_record']['username']);

		$DBLT = getTool("DBLT");

		$sql = "
			SELECT 
				CASE VZLA_NAC 
					WHEN 'V' THEN 'I' 
					WHEN 'E' THEN 'I' 
					WHEN 'J' THEN 'C' 
					WHEN 'G' THEN 'C' 
					ELSE 'Z' 
					END TIPO_PERSONA, 
				FONC.* 
			FROM 
				$this->foncname FONC 
			WHERE 
				FONC.REC_STATUS NOT IN ('END', 'RUN', 'RWOC', 'RWAC', 'ERRO')
				%OTHER_WHERE_CONDITION%
			ORDER BY 
				TIPO_PERSONA;
			";
		if($s_lote==NULL) {
			$sql = str_replace("%OTHER_WHERE_CONDITION%", "", $sql);
		} else {
			$sql = str_replace("%OTHER_WHERE_CONDITION%", "AND FONC.CUST_FILEID = '$s_lote'", $sql);
		}
		
if($this->debug) { echo "<br>\n$sql<br>\n"; }

		$i_proc_counter = 0;
		$results =  ClxCommon::$db->executeQuery($sql);
		while($clientrec =  ClxCommon::$db->getNextRecord($results)){

if($this->debug) echoLog(debug_dump('clientrec', $clientrec));
			$b_sw_severe_error = false;
			$i_proc_counter++;

			/*
			 * CODE_FONDAFA_MSG_CIMRECIDINFO_2
			 * ^1) ^2-^3 <b>^4</B> Credit #: ^5:
			 * ^1) ^2-^3 <b>^4</B> Crdito #: ^5:
			 */
			$rec_id_info = dict("CODE_FONDAFA_MSG_CIMRECIDINFO_2", 
									$clientrec['ID'],
									$clientrec['VZLA_NAC'],
									$clientrec['IDENTIFICATION'],
									$clientrec['LASTNAME'] . ' ' . $clientrec['SECOND_LASTNAME'] . ' ' . 
												$clientrec['FIRSTNAME'] . ' ' . $clientrec['SECONDNAME'],
									$clientrec['FONDA_CREDITNO']
							) . " ";


			$ar_fonc_record = array(
				'ACCOUNTCODE' => $clientrec['ACCOUNTCODE'],	// codigo de acc. en CRM
				'REC_STATUS' => 'ERRO',	// asume con error por defecto
				'SCHEDULECODE' => $this->fondafa_client_import_schedule,
			);

			$s_response = '';
			$ar_client_record = NULL;

			// Verifica si todos los campos en blanco
			$b_en_blanco = true;
			foreach($clientrec as $nombre => $valor) {
				switch ($nombre) {
					case 'REC_STATUS':
					case 'CREATEDBY':
						break;
					default:
						if($valor != NULL && $valor != '') {
							$b_en_blanco = false;
						}
				}
			}
			if($b_en_blanco == true) {

				/*
				 * CODE_FONDAFA_ERR_EMPTYRECORD
				 * Empty record
				 * Registro est en blanco
				 */
				$ar_error['350'] = dict("CODE_FONDAFA_ERR_EMPTYRECORD");

			} elseif($clientrec['ACCOUNTCODE'] != '') {

				// Si ya fue asignada la cta CRM, extrae el ID para intentar crear nuevamente el cliente en IBS 
				//$n_acco_id =  ClxCommon::$db->getField($this->acconame, 'ID', "IDCODE = '" . $clientrec['ACCOUNTCODE'] . "'");
				$ar_client_record =  ClxCommon::$db->getRecord($this->acconame, "IDCODE = '" . $clientrec['ACCOUNTCODE'] . "'");
				$n_acco_id = $ar_client_record['ID'];

			} else {

				// Asigna la fecha en la que por primera vez se modific el registro x este proceso
				$ar_fonc_record['CDATE'] = adodb_date('Y-m-d');

				// Validacion de campos del FONC
				$ar_valida_fonc_data_response = $this->valida_fonc_data($clientrec, $ar_fonc_record);
				$ar_fonc_record = $ar_valida_fonc_data_response['ar_fonc_record'];
				$b_sw_severe_error = $ar_valida_fonc_data_response['b_sw_severe_error'];
				$ar_error = $ar_valida_fonc_data_response['ar_error'];
	
				//if(B_SEVERE_ERROR_STOP && count($ar_error) != 0) {
				if(count($ar_error) != 0) {
					// Hubo errores antes de crear el cliente en CRM
					$s_response .= $this->ar_error_display_out($ar_error);
				}
				if(!(B_SEVERE_ERROR_STOP && $b_sw_severe_error)) {
					// Crea la cuenta CRM
					$ar_crm_creat_response = $this->crea_cta_crm($i_proc_counter, $clientrec, $defvals);
					// Enlaza la cuenta CRM
					$ar_fonc_record['ACCOUNTCODE'] = $ar_crm_creat_response['s_acco_idcode'];
					$n_acco_id = $ar_crm_creat_response['n_acco_id'];
					$s_response .= $ar_crm_creat_response['s_response'];
					$b_sw_severe_error = $ar_crm_creat_response['b_sw_severe_error'];
				}
			}

			if($b_sw_severe_error == false) {

				// No hubo error, crea cliente en IBS
				$ar_other_dat = array('UC9' => trim($ar_fonc_record['ACCOUNTCODE']) . ',FONC,' . $clientrec['ID'] . ",$this->s_lote");
				$ar_create_ibs_client_response = $this->create_ibs_client($ar_fonc_record['ACCOUNTCODE'], 
					FONDAFA_CLIENT_SOCKET_CREATION, $s_tipo_persona, $clientrec, $ar_other_dat);
				$ar_client_record = $ar_create_ibs_client_response['client_record'];
//echo "<br>\nar_client_record<br>\n"; print_r($ar_client_record);echo "<br>\n";
				if($ar_create_ibs_client_response['other_info'] != '') {
					//$contents .= $ar_create_ibs_client_response['other_info'] . "<br><br>";
					$this->o_response_rpt->write($ar_create_ibs_client_response['other_info'] . "<br><br>");
				}
				if($ar_create_ibs_client_response['severe_error'] == true) {
					// Si hubo un error severo, por ejemplo abriendo el archivo de salida del masivo de clientes, detiene el proceso
					//$contents .= $ar_create_ibs_client_response['errormsg'];
					$this->report_error($ar_create_ibs_client_response['errormsg']);
					$this->o_response_rpt->close();
					//return $contents;
					return $ar_create_ibs_client_response['errormsg'];
				} else {
					$s_tipo_persona = $ar_create_ibs_client_response['tipo_persona'];
					if($ar_create_ibs_client_response['error'] == true) {
						// Hubo problemas creando el cliente en IBS
						$s_response .= $ar_create_ibs_client_response['errormsg'];
						$ar_fonc_record['REC_STATUS'] = 'ENDR';	// Completado con Errores (ENDR)
					} else {
						// El cliente en IBS fue creado con exito
						if(FONDAFA_CLIENT_SOCKET_CREATION != 1 && $ar_client_record['IBS_CUSCUN'] == '') {
							// Batch
							$ar_fonc_record['REC_STATUS'] = 'RWOC';	// Waiting for IBS code (2007-01-17)
						} else {
							// Socket
							$ar_fonc_record['REC_STATUS'] = 'RUN';	// En marcha (RUN)
						}
					}
				}
			}

			// Salva el resultado del proceso de este registro en FONC
			if($this->debug) echoLog(debug_dump('ar_fonc_record', $ar_fonc_record));
			if($this->debug)  ClxCommon::$db->debug = true;
			 ClxCommon::$db->updateRecord($this->foncname, $ar_fonc_record, "ID = '" . $clientrec['ID'] . "'");
			if($this->debug)  ClxCommon::$db->debug = false;

			/*
			 * CODE_FONDAFA_MSG_OK
			 * OK
			 * OK
			 */
			if(empty($s_response)) {
				$s_response = dict('CODE_FONDAFA_MSG_OK');
				$error = false;
			} else {
				$error = true;
			}

			// Reporta resultado en el Log del process scheduler
			$s_msg_out = "$i_proc_counter - ($rec_id_info " . 
						$DBLT->getListItem('PROS', $ar_fonc_record['REC_STATUS']) . 
						" $s_response";
			//$contents .= $s_msg_out;
			$this->report_error($s_msg_out, $error);
			if($this->debug) {echoLog($s_msg_out);}
		}

		/*
		  * Si era la creacion batch de clientes, verifica si quedo algo pendiente
		  */
		$ar_create_ibs_client_moverfile = $this->create_ibs_client_moverfile(
			FONDAFA_CLIENT_SOCKET_CREATION, $s_tipo_persona);
		if($ar_create_ibs_client_moverfile['error'] == true) {
			//$contents .= "<BR>\n" . $ar_create_ibs_client_moverfile['errormsg'];
			$this->report_error($ar_create_ibs_client_moverfile['errormsg']);
		}

		// Si se especificaron los parametros de codigo de producto y tipo de producto, 
		// llama al metodo que genera la solicitud masiva de creacin de cuentas de banco
			
		if(trim($this->s_prd_cod . $this->s_prd_tipo) != '') {
			//$contents .= 
			//	"<br>\n<hr><br>\n" . 
			//	$this->fondafa_bank_acc_req_export($s_prd_cod, $s_prd_tipo, $s_lote);
			$this->o_response_rpt->write("<br>\n<hr><br>\n" . 
				$this->fondafa_bank_acc_req_export($s_prd_cod, $s_prd_tipo, $s_lote));
		}

		// Closes the output file for clients creation on IBS
		if(FONDAFA_CLIENT_SOCKET_CREATION != 1 && $this->o_createClient_outputFileHandle != NULL) {
			// Batch
			$this->o_createClient_outputFileHandle->close();
			// Load the sockets interface (just in case)
			$this->massive_socket_ondemand_loader();
		}
		$this->o_response_rpt->close();

		return $contents;
	} // Method End

	function crea_cta_crm($i_proc_counter, $clientrec, $defvals, $s_operation=NULL)
	{
		global $db;
		$s_acco_idcode = '';
		$n_acco_id = 0;
		$s_response = '';
		$b_sw_severe_error = false;
		if($s_operation==NULL) $s_operation='0001';	// Creacin por defecto, 	// 2009-06-26 CJR

		// Conversion de nacionalidad
		switch($clientrec['VZLA_NAC']) {
			// Personas: Extranjeros
			case 'E':
				$s_vnac = '2';
				$s_id_type = 'CIE';
				$s_sudeban_code = FONDAFA_SUDEBAN_CODE_INDIVIDUALS_DEFVAL;
				$s_natjur_varcode = 'E01';	// por defecto usa las variables de la trama de personas naturales
				break;
			// Empresas
			// Gobierno
			case 'J':
			case 'G':
				$s_vnac = '1';
				$s_id_type = 'RIF';
				$s_sudeban_code = FONDAFA_SUDEBAN_CODE_COMPANY_DEFVAL;
				$s_natjur_varcode = 'E02';	// variables de la trama de personas juridicas
				break;
			// Personas: Venezolanos
			case 'V':
				$s_vnac = '2';
				$s_id_type = 'CIV';
				$s_sudeban_code = FONDAFA_SUDEBAN_CODE_INDIVIDUALS_DEFVAL;
				$s_natjur_varcode = 'E01';	// por defecto usa las variables de la trama de personas naturales
				break;
			// Nacionalidad invalida OJO NO DEBERIA PASAR X ACA
			default:
				$b_sw_severe_error = true;
				//$s_vnac = $clientrec['VZLA_NAC'];
				//$s_id_type = '';
				//$s_sudeban_code = '';
				//$s_natjur_varcode = 'E01';	// por defecto usa las variables de la trama de personas naturales
		}

		if($b_sw_severe_error == false) {
			$s_idname = 
					$clientrec['LASTNAME'] . rtrim(' ' . $clientrec['SECOND_LASTNAME']) . ', ' . 
					$clientrec['FIRSTNAME'] . rtrim(' ' . $clientrec['SECONDNAME']);
			$s_identification = $clientrec['VZLA_NAC'] . $clientrec['IDENTIFICATION'];
			// Prepara la creacin del cliente en el CRM
			$ar_record = array();
			//$ar_record[] = array('FILEFIELD' => '', 'VAL' => $s_state);
			$ar_record[] = array('FILEFIELD' => 'H' . substr($s_natjur_varcode,1) . 'OPE', 'VAL' => $s_operation);	// 2009-06-26 CJR
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'IDN', 'VAL' => $s_identification);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'LGT', 'VAL' => $s_vnac);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'LN1', 'VAL' => $clientrec['LASTNAME']);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'LN2', 'VAL' => $clientrec['SECOND_LASTNAME']);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'FNA', 'VAL' => $clientrec['FIRSTNAME']);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'FN2', 'VAL' => $clientrec['SECONDNAME']);
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'TID', 'VAL' => $s_id_type);						// ID_TYPE
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'UC4', 'VAL' => $s_sudeban_code);				// VE_CLI_SUDEBAN
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'SHN', 'VAL' => $s_idname );
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'NA1', 'VAL' => $s_idname );
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'NA2', 'VAL' => $defvals['NA2']);		// ADDRESS 1
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'CTY', 'VAL' => $defvals['CTY']);			// CITY
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'STE', 'VAL' => $defvals['STE'] );			// STATE
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'CTR', 'VAL' => $defvals['CTR']);			// COUNTRY
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'PID', 'VAL' => $defvals['PID']);			// INCORPORATION_COUNTRY
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'GEC', 'VAL' => $defvals['GEC']);			// RESIDENCE_COUNTRY
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'STS', 'VAL' => $defvals['STS']);	// CUSTOMER STATUS "1.Inactivo 2.Activo 3.Lista Negra"
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'BDM', 'VAL' => $defvals['BDM']);	// BIRTH DATE MM
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'BDD', 'VAL' => $defvals['BDD']);	// BIRTH DATE DD
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'BDY', 'VAL' => $defvals['BDY']);	// BIRTH DATE YY
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'SOI', 'VAL' => $defvals['SOI']);	// INCOME_SOURCE
			$ar_record[] = array('FILEFIELD' => $s_natjur_varcode . 'INC', 'VAL' => $defvals['INC']);	// INDUSTRYCLASS

			if($this->debug){
				reset($ar_record);
				reset($clientrec);
				echo"<BR>\nAR_RECORD<BR>\n"; print_r($ar_record);echo"<BR>\n";
				echo"<BR>\nclientrec<BR>\n"; print_r($clientrec);echo"<BR>\n";
			}
			$dummy_var = '';
			$this->ar_clientImport_aditional_fields = 
				array(
					'ACCO' => 
						array(
								'ACCTYPE' => $defvals['ACCTYPE'],
								'CREATEDBY' => $defvals['USERNAME'],
								'MODIFIEDBY' => $defvals['USERNAME'],
							)
					);	// Add value 'Payee' to the account type field in ACCO
			if($s_natjur_varcode == "E01") {
				// Personas naturales
				$ar_response_client_creation = $this->create_client_individual_frm_ibs($i_proc_counter, $ar_record, $dummy_var);
			} else {
				// Personas juridicas
				$ar_response_client_creation = $this->create_client_company_frm_ibs($i_proc_counter, $ar_record, $dummy_var);
			}
			if($ar_response_client_creation["error"] == false) {
				// Lo pudo crear sin problemas
				//$ar_fonc_record['ACCOUNTCODE'] = $ar_response_client_creation["idcode"];
				$s_acco_idcode = $ar_response_client_creation["idcode"];
				$n_acco_id = $ar_response_client_creation["id"];
			} else {
				if (count($ar_response_client_creation["ar_error"]) == 1 && isset($ar_response_client_creation["ar_error"]['0210'])) {
					// La cdula del cliente ya existe en el CRM, asi que  
					// copia el codigo de ACCO existente
					$s_srch_criteria = "IDENTIFICATION = '$s_identification' AND ID_TYPE = '$s_id_type'";
					$ar_client_record =  ClxCommon::$db->getRecord($this->acconame, $s_srch_criteria);
					if($this->debug) {echoLog("s_srch_criteria=$s_srch_criteria, " . debug_dump('ar_client_record', $ar_client_record));}
					//
					// NOTA: 2007-01-26 SE LE QUITO LA VALIDACION POR NOMBRE POR ORDEN DE LA GENTE DEL BAV
					// YA QUE EL CLIENTE PUDO SER CREADO EN IBS CON EL MISMO NOMBRE PERO ESCRITO DE MANERA DIFERENTE
					// AUNQUE NO COMPARTO ESTE CRITERIO, SE SIGUIO CON LA DIRECTRIZ DICTADA X EL CLIENTE. CJRD
					//
					//if(	$ar_client_record['IDNAME'] == $s_idname ) {
						// Coinciden los nombres, asi que esta es la cuenta CRM correcta
						//$ar_fonc_record['ACCOUNTCODE'] = $ar_client_record['IDCODE'];
						$s_acco_idcode = $ar_client_record['IDCODE'];
						$n_acco_id = $ar_client_record['ID'];
						//if($this->debug) {echoLog("ENLACE CON EL CLIENTE: " . $ar_fonc_record['ACCOUNTCODE']);}
						if($this->debug) {echoLog("ENLACE CON EL CLIENTE: " . $s_acco_idcode);}
					//} else {
						// NO Coinciden los nombres, reporta error de inconsistencia
						/*
						 * CODE_FONDAFA_ERR_CRMOTHERPERS
						 * CRM account already exists but assigned to other person/company (^1) ^2 different than ^3
						 * La cuenta CRM ya existe pero a nombre de otra persona (^1) ^2 distinto de ^3
						 */
						//$s_response .= $this->ar_error_display_out(array('350' => dict('CODE_FONDAFA_ERR_CRMOTHERPERS',	$ar_client_record['ID_TYPE'] . "-" . $ar_client_record['IDENTIFICATION'], $ar_client_record['IDNAME'], $s_idname) ));
						//$b_sw_severe_error = true;
						//if($this->debug) {echoLog("ERROR AL COMPARAR CLIENTE: $s_response");}
					//}
				} else {
					// Hubo problemas creando el cliente en el CRM
					//$s_response = $ar_response_client_creation['errormsg'];
					$s_response .= $this->ar_error_display_out($ar_response_client_creation['ar_error']);
					$b_sw_severe_error = true;
					if($this->debug) {echoLog("ERROR AL CREAR CLIENTE: $s_response");}
				}
			}
		}

		$ar_response = array();
		$ar_response['s_acco_idcode'] = $s_acco_idcode;
		$ar_response['n_acco_id'] = $n_acco_id;
		$ar_response['s_response'] = $s_response;
		$ar_response['b_sw_severe_error'] = $b_sw_severe_error;
		return $ar_response;
	} // Method End

	/*
	  * Mtodo a ser llamado por el motor de procesos para realizar la verificacin de las respuestas del IBS a la creacion masiva de clientes
	  */
	function recibe_ibs_clients_cuscun()
	{
//$this->debug = true;
		$s_response = parent::receive_ibs_massive_clients_creation_response('fondafa_asigna_status_crm');
		return $s_response;
	} // Method End
	

	/*
	  * Realiza la validacion de los datos que vienen de la importacion de beneficiarios de FONDAFA
	  */
	function valida_fonc_data($clientrec, $ar_fonc_record)
	{
		global $db;
		$b_sw_severe_error = false;
		$ar_error = array();

		// Conversion de nacionalidad
		switch($clientrec['VZLA_NAC']) {
			// Empresas
			case 'J':
			// Gobierno
			case 'G':
			// Personas: Venezolanos
			case 'V':
			// Personas: Extranjeros
			case 'E':
				break;
			// Nacionalidad invalida
			default:
				//$s_vnac = $clientrec['VZLA_NAC'];
				//$s_id_type = '';
				//$s_sudeban_code = '';
				/*
				 * CODE_FONDAFA_ERR_INVALNAC
				 * Nationality must be V, E or J
				 * Nacionalidad debe ser V, E o J
				 */
				$ar_error['310'] = dict("CODE_FONDAFA_ERR_INVALNAC");
				$b_sw_severe_error = true;
		}
/*
		// Verifica cdigo de la agencia
		$s_branch = $DBLT->getListItem('VEAG', $clientrec['BRANCH']);
		if($s_branch == '') {
			// No existe la agencia en la tabla

			/*
			 * CODE_FONDAFA_LBL_AGENCY
			 * Agency
			 * Agencia
			 */
			/*
			 * CODE_FONDAFA_ERR_INVALLISTC
			 * ^1 ^2 doesn't exists on List ^3
			 * ^1 ^2 no existe en la Lista ^3
			 * /
			$ar_error['340'] = dict('CODE_FONDAFA_ERR_INVALLISTC', 
										dict("CODE_FONDAFA_LBL_AGENCY"), 
										"(" . $clientrec['BRANCH'] . ")",
										"VEAG"
								);
		}
*/
		/*
		// Deduce el cdigo de la agencia
		$s_branch = '';
		$clientrec['COMPLOC_NAME'] = trim($clientrec['COMPLOC_NAME']);
		if($clientrec['COMPLOC_NAME'] != '') {
			$s_branch = $this->getListItemByDescUpCase('VEAG', "%" . $clientrec['COMPLOC_NAME'] . "%", $this->lang);
			if($s_branch == '') {
				// No existe la agencia en la tabla

				/*
				 * CODE_FONDAFA_LBL_AGENCY
				 * Agency
				 * Agencia
				 */
				/*
				 * CODE_FONDAFA_ERR_INVALLISTC
				 * ^1 ^2 doesn't exists on List ^3
				 * ^1 ^2 no existe en la Lista ^3
				 * /
				$ar_error['340'] = dict('CODE_FONDAFA_ERR_INVALLISTC', 
											dict("CODE_FONDAFA_LBL_AGENCY"), 
											$clientrec['COMPLOC_NAME'],
											"VEAG"
									);
			} else {
				$ar_fonc_record['BRANCH'] = $s_branch;
			}
		}
		*/

		// Deduce cdigo de la tabla de estados de venezuela
		$s_state = '';
		$clientrec['VE_ESTADO'] = trim($clientrec['VE_ESTADO']);
		if($clientrec['VE_ESTADO'] != '') {
			$s_state = $this->getListItemByDescUpCase('VZST', $clientrec['VE_ESTADO'], $this->lang);
			if($s_state == '') {
				// No existe el estado en la tabla
				/*
				 * CODE_FONDAFA_LBL_STATE
				 * State
				 * Estado
				 */
				$ar_error['320'] = dict('CODE_FONDAFA_ERR_INVALLISTC', 
											dict("CODE_FONDAFA_LBL_STATE"), 
											$clientrec['VE_ESTADO'],
											"VZST"
									);
		} else {
				$ar_fonc_record['STATE'] = $s_state;
			}
		}

		// Deduce cdigo de la tabla de municipios de venezuela
		$s_municipio = '';
		$clientrec['VE_MUNICIPIO'] = trim($clientrec['VE_MUNICIPIO']);
		if($clientrec['VE_MUNICIPIO'] != '') {
			$s_municipio = $this->getListItemByDescUpCase('VZMU', $clientrec['VE_MUNICIPIO'], $this->lang);
			if($s_municipio == '') {
				// No existe el municipio en la tabla
				/*
				 * CODE_FONDAFA_LBL_MUNICIP
				 * Municipality
				 * Municipio
				 */
				$ar_error['330'] = dict('CODE_FONDAFA_ERR_INVALLISTC', 
											dict("CODE_FONDAFA_LBL_MUNICIP"), 
											$clientrec['VE_MUNICIPIO'],
											"VZMU"
									);
			} else {
				$ar_fonc_record['MUNICIPALITY'] = $s_municipio;
			}
		}

		$ar_response = array();
		$ar_response['ar_fonc_record'] = $ar_fonc_record;
		$ar_response['b_sw_severe_error'] = $b_sw_severe_error;
		$ar_response['ar_error'] = $ar_error;
		return $ar_response;
	} // Method End

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	* Pantalla que pide los datos para realizar la export de solicitud de ctas de banco
	*/
	function fondafa_bank_acc_req_export_dialog()
	{
		return $this->fondafa_dialog_01('RTBL_FON_P02');
	} // Method End

	/**
	* Generacion del archivo para la solicitud de ctas. de banco para los beneficiarios de Fondafa
	* Para ser llamado desde el Menu
	*/
	function fondafa_bank_acc_req_export()
	{
		// Identifica el sub-modulo
		$this->submodule = "FON";

		return $this->fondafa_gen_dialog_handle($this->fondafa_bank_acc_req_export_schedule, $this->titfondafa(dict("CODE_FONDAFA_LBL_TITACCEXP")));
	} // Method End

	/**
	* Generacion del archivo para la solicitud de ctas. de banco para los beneficiarios de Fondafa
	* Para ser llamado desde el Process Engine
	*/
	function fondafa_bank_acc_req_export_run($s_prd_cod=NULL, $s_prd_tipo=NULL, $s_lote=NULL)
	{
		// Identifica el sub-modulo
		$this->submodule = "FON";

		// Enlaza el archivo de fondafa con el de CRM haciendo filtro de aquellos que hayan sido procesado 
		// exitosamente y que no se les haya asignado aun la cuenta bancaria
		$sql = "SELECT 
						ACCO.IBS_CUSCUN, 
						FONC.COMPLOC_CODE,
						ACCO.IDNAME, 
						FONC.ID FONC_ID, 
						FONC.VZLA_NAC,
						FONC.IDENTIFICATION,
						FONC.FONDA_CREDITNO,
						FONC.LASTNAME,
						FONC.SECOND_LASTNAME,
						FONC.FIRSTNAME,
						FONC.SECONDNAME,
						FONC.VZ_BK_PROD_CODE,
						FONC.VZ_BK_PROD_TYPE

					FROM $this->foncname FONC 
						LEFT JOIN $this->acconame ACCO ON FONC.ACCOUNTCODE = ACCO.IDCODE
					WHERE 
						FONC.REC_STATUS = 'RUN'
						AND ACCO.IBS_CUSCUN <> ''
						AND (FONC.BANKAC_CODE = '' OR FONC.BANKAC_CODE IS NULL)
				";
		// Eventual filtro x lotes
		if($s_lote!=NULL) $sql .= " AND FONC.CUST_FILEID = '$s_lote'";

		/*
		 * CODE_FONDAFA_LBL_TITACCEXP
		 * BANK ACCOUNT CREATION REQUEST FILE GENERATION
		 * GENERACION DEL ARCHIVO DE SOLICITUD DE CREACION DE CUENTAS BANCARIAS
		 */
		$v_response = $this->bank_acc_req_export_run(dict("CODE_FONDAFA_LBL_TITACCEXP"), 
			$this->fon_acc_req_exprt_dir, $sql, $this->foncname, $s_lote);

		// Load the sockets interface (just in case)
		$this->massive_socket_ondemand_loader();

		// Devuelve el resultado de bank_acc_req_export_run()
		return $v_response;
	}

	/*
	  * Metodo generico para crear el archivo de solicitud masiva de creacin de cuentas bancarias en IBS
	  */
	function bank_acc_req_export_run($s_titulo, $s_fon_acc_req_exprt_dir, $sql, $s_tablename, $s_lote=NULL)
	{
//$this->debug = true;
		global $db;

		//$contents = '';
		$s_response = $this->open_rpt_process_run(IBS_MASSIVE_BACKACT_CREATION_RPT_FILENAME);
		if($s_response!='') {
			return $s_response;
		}
		// Si los parametros del proceso no se pasaron debidamente, emite error y sale
		$this->proc_eng_params->set_tablename("PRES");
		if(! $this->proc_eng_params->verify_parameters()) {
			$s_response = "<h1>" . $this->proc_eng_params->errormsg . "</h1>";
			$this->o_response_rpt->write($this->proc_eng_params->errormsg);
			$this->o_response_rpt->close();
			return $s_response;
		}

		if($this->debug) echoLog("Entro en fondafa_bank_acc_req_export");
		$this->s_lote = $s_lote;

		//$contents .= $this->titulo($s_titulo) . "<BR><BR>\n";
		$this->o_response_rpt->write($this->titulo($s_titulo) . "<BR><BR>\n");

		//$contents .= dict("GEN_LBL_LOT") . ": $this->s_lote<BR>\n";
		$this->o_response_rpt->write(dict("GEN_LBL_LOT") . ": $this->s_lote<BR>\n");
		//echoLog("Lote: $this->s_lote");

		// Abre el archivo de salida
		//$contents .= "$s_fon_acc_req_exprt_dir<br>\n";
		$this->o_response_rpt->write("$s_fon_acc_req_exprt_dir<br>\n");
		//$ar_response = $this->fondafa_bank_acc_req_file_ops('open', $s_fon_acc_req_exprt_dir);
		$ar_response = $this->fondafa_bank_acc_req_file_ops('open', IBS_MASSIVE_BACKACT_CREATION_FILENAME);
		if($ar_response['error'] == true) {
			//$contents .= $ar_response['errormsg'];
			$this->report_error($ar_response['errormsg']);
			$this->o_response_rpt->close();
			//return ($contents);
			return $ar_response['errormsg'];
		}

		// Interfaz con las funciones para construir la estructura del registro en el archivo plano
		$EBSK = getTool("EBSK");
		$EBSK->debug = $this->debug;
		$EBSK->tfields_only = true;
		$EBSK->remove_decimal_point = true;
		$msg_code = BANK_ACC_REQ_RECORD_DEFINITION_CODE;

		// Prepares record creation
		$output_record = array();
		$output_record['BACCCODE'] = '';

		$i_proc_counter = 0;
		if($this->debug) { echo "<br>\n$sql<br>\n"; }
		$results =  ClxCommon::$db->executeQuery($sql);
		$i_num_rows =  ClxCommon::$db->num_rows($results);
		if($i_num_rows==0) {
			// No bank accounts to request
			/*
			  * CODE_FONDAFA_ERR_ACCEXP_ER01
			  * Invalid Lot or records pending for CRM account creation
			  * Lote invalido o registros pendientes por creacin de cuentas CRM
			  */
			//$contents .= dict('CODE_FONDAFA_ERR_ACCEXP_ER01');
			$this->report_error(dict('CODE_FONDAFA_ERR_ACCEXP_ER01'));
			$this->o_response_rpt->close();
			//return ($contents);
			return dict('CODE_FONDAFA_ERR_ACCEXP_ER01');
		}

		$this->o_response_rpt->write("<BR>\n");
		while($clientrec =  ClxCommon::$db->getNextRecord($results)){

			$i_proc_counter++;
			/*
			 * CODE_FONDAFA_MSG_CIMRECIDINFO
			 * ^1) ^2-^3 <b>^4</B> IBS Client #: ^5 Branch: ^6:
			 * ^1) ^2-^3 <b>^4</B> Cliente IBS #: ^5 Sucursal: ^6:
			 */
			$rec_id_info = 
				dict('CODE_FONDAFA_MSG_CIMRECIDINFO',
					$i_proc_counter, 
					$clientrec['VZLA_NAC'],
					$clientrec['IDENTIFICATION'],
					$clientrec['LASTNAME'] . ' ' . $clientrec['SECOND_LASTNAME'] . ' ' . 
												$clientrec['FIRSTNAME'] . ' ' . $clientrec['SECONDNAME'],
					$clientrec['IBS_CUSCUN'],
					$clientrec['COMPLOC_CODE']
				) . ': ';
			//$contents .= $rec_id_info;
			//$this->o_response_rpt->write($rec_id_info);

			$record = $output_record;
			$record['BRANCH'] = $clientrec['COMPLOC_CODE'];
			$record['IBSCUSCUN'] = $clientrec['IBS_CUSCUN'];
			$record['PRODTYPE'] = $clientrec['VZ_BK_PROD_TYPE'];
			$record['PRODDESC'] = $clientrec['VZ_BK_PROD_CODE'];
			$ar_socket_line = $EBSK->createMessage($msg_code, $record);

			// Remueve el utlimo elemento del array (Cdigo de la cuenta) ya que este formato se usa tanto 
			// para enviar la xsolicitud como para recibir su resultado, y cuando se envcia, no hace 
			// falta la ultima posicin)
			array_pop($ar_socket_line);

			// Como hizo modificaciones en el array que se usa como fuenta para generar la linea de texto plano
			// Asigna la propiedad de la clase IBS
			$EBSK->msgrecord = $ar_socket_line;

			if($this->debug) { 
				echoLog("<B>$i_proc_counter</B>");
				print_r($ar_socket_line); 
				echoLog(""); 
			}

			// Genera la linea de salida (texto plano de longitud fija)
			$s_socket_line = $EBSK->toString();
			//if($i_proc_counter < $i_num_rows) $s_socket_line .= "\n"; // ultima linea sin enter
			if($this->debug) echoLog("<B>$s_socket_line</B>");

			// Escribe la linea en el archivo de salida
			$ar_response = $this->fondafa_bank_acc_req_file_ops('write', $s_socket_line);
			if($ar_response['error'] == true) {
				// Al haber problemas escribiendo el archivo de salida, termina el proceso
				//$contents .= $ar_response['errormsg'];
				$this->report_error($rec_id_info . $ar_response['errormsg']);
				$this->o_response_rpt->close();
				$this->fondafa_bank_acc_req_file_ops('close');
				//return ($contents);
				return $ar_response['errormsg'];
			} else {
				//$contents .= dict('CODE_FONDAFA_MSG_OK');
				$this->o_response_rpt->write($rec_id_info . dict('CODE_FONDAFA_MSG_OK'));
				// Asigna estatus al cliente de tal forma de no incluirlo nuevamente en una solicitud de apertura de cta. de bco.
				$ar_fonc_record = array();
				$ar_fonc_record['REC_STATUS'] = 'RWAC';	// Waiting for bank account code ( 2007-01-24)
				 ClxCommon::$db->updateRecord($s_tablename, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
			}
			//$contents .= "<br>\n";
			$this->o_response_rpt->write("<br>\n");
		}

		// Cierra el archivo de salida
		$this->fondafa_bank_acc_req_file_ops('close');

		// Copia el archivo de intercambio para la interfaz
		$a = new ibs_interface_queue(
			array(
				'comp_code'=> $this->s_comp_code, 
				'interface' => "CTA", 
				'submodule' => $this->submodule, 
				'subtype' => ''
				)
			);
		if(! $a->initpar()) {
			//$contents .= "<BR>\n" .	$a->get_errormsg();
			$this->report_error($a->get_errormsg());
		} elseif(! $a->enter_queue(	IBS_MASSIVE_BACKACT_CREATION_FILENAME, 
									IBS_MASSIVE_BACKACT_CREATION_RPT_FILENAME)) {
		//if(!copy(IBS_MASSIVE_BACKACT_CREATION_FILENAME, $s_fon_acc_req_exprt_dir)) {
			/*
			 * GEN_ERR_FILESYS_COPYFAIL
			 * Error copying from file  ^1 to file ^2
			 * Error realizando la copia del archivo ^1 al archivo ^2
			 */
			//$contents .= "<BR>\n" .	$a->get_errormsg();
			$this->report_error($a->get_errormsg());
			//$contents .= "<BR>\n" .	dict('GEN_ERR_FILESYS_COPYFAIL', IBS_MASSIVE_BACKACT_CREATION_FILENAME, $s_fon_acc_req_exprt_dir);
		} else {
			// Elimina el temporal
			unlink(IBS_MASSIVE_BACKACT_CREATION_FILENAME);
			unlink(IBS_MASSIVE_BACKACT_CREATION_RPT_FILENAME);
		}
		// Schedule queue monitor run
		$this->ibiq_schedule_4_exec();

		//return $contents;
		$this->o_response_rpt->close();
		return '';
	} // Method end

	/**
	 * Operaciones de bajo nivel para la generacion del archivo para la solicitud de ctas. de banco
	 */
	var $o_fondafa_bank_acc_req_file;
	function fondafa_bank_acc_req_file_ops($s_ope, $s_par=NULL)
	{
		$b_error = false;
		$s_errormsg = '';

		switch ($s_ope) {
			case 'open':
				$this->o_fondafa_bank_acc_req_file = new clx_logfile_mngr($s_par);
				if($this->o_fondafa_bank_acc_req_file->error) {
					$b_error = true;
					$s_errormsg = $this->o_fondafa_bank_acc_req_file->errorMsg;
				}
				break;
			case 'write':
				$this->o_fondafa_bank_acc_req_file->write($s_par);
				if($this->o_fondafa_bank_acc_req_file->error) {
					$b_error = true;
					$s_errormsg = $this->o_fondafa_bank_acc_req_file->errorMsg;
				}
				break;
			case 'close':
				$this->o_fondafa_bank_acc_req_file->close();
				break;
		}
		return array(
				'error' => $b_error, 
				'errormsg' => $s_errormsg
			);
	} // Method end

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	var $current_bank_acc_req_import_schedule;
	var $bank_acc_req_import_inputvarname;
	var $bank_acc_req_import_sql;
	var $input_aux_tablename;
	var $bank_acc_req_import_tabaux_fieldname;
	var $bank_acc_req_file_import_savefile_id;
	var $bank_acc_req_file_import_id_token;

	/**
	* Importacion del archivo que viene de vuelta como respuesta a la solicitud  de ctas. de banco para los beneficiarios de Fondafa.
	* Para ser llamado desde el Menu
	*/
	function fondafa_bank_acc_req_file_import($filename=NULL)
	{
		// Identifica el sub-modulo
		$this->submodule = "FON";

		if($this->debug) echo "fondafa_bank_acc_req_file_import($filename)<br>";
		$this->bank_acc_req_import_var_selector($this->fondafa_bank_acc_req_import_schedule);
		return $this->gen_bank_acc_req_file_import($filename);
	} // Method End

	/*
	  * Importacion del archivo que viene de vuelta como respuesta a la solicitud  de ctas. de banco para los beneficiarios de Fondafa
	  * A ser llamado desde el motor de procesos
	  */
	function fondafa_bank_acc_req_file_import_doitnow($s_import_filename)
	{
//$this->debug = true;
		// Identifica el sub-modulo
		$this->submodule = "FON";

		if($this->debug) echo "fondafa_bank_acc_req_file_import_doitnow($s_import_filename)<br>";
		$this->bank_acc_req_import_var_selector($this->fondafa_bank_acc_req_import_schedule);
		return $this->gen_bank_acc_req_file_import_doitnow($s_import_filename);
	} // Method End

	/**
	* Importacion del archivo que viene de vuelta como respuesta a la solicitud de ctas. de banco.
	* Este metodo decide que hacer, si pide el archivo x pantalla o si pasa el control directamente a la funcion que ejecuta la importacion.
	*/
	function gen_bank_acc_req_file_import($filename=NULL)
	{
//print_r($_REQUEST);
		if($filename != NULL) {
			// If the parameter has passed, executes the import process directly, assuming that it's an automatic process between systems
			$this->contents = $this->gen_bank_acc_req_file_import_doitnow($filename);
		} else {
			// Ask the user for the import file location
			$ac = $_REQUEST['ac'];
			$this->contents = $this->gen_bank_acc_req_file_import_action($ac);
		}
		return $this->contents;
	} // Method End

	/*
	  * Asigna las propiedades comunes de acuerdo al tipo de proceso
	  */
	function bank_acc_req_import_var_selector($s_selected_schedule)
	{
		if($this->debug) echo "bank_acc_req_import_var_selector($s_selected_schedule)<br>";
		$this->current_bank_acc_req_import_schedule = $s_selected_schedule;

		// Calcula nombre base para las variables y nombres de mensajes multilengua
		switch ($this->current_bank_acc_req_import_schedule) {
			case $this->fondafa_bank_acc_req_import_schedule:
				$this->bank_acc_req_file_import_id_token = 'FONDAFA';
				$this->bank_acc_req_file_import_savefile_id = 'fondafa_bank_acc_req_file_import';	// ID del proceso para cuando se salva el archivo funente mediante la herramienta $SDFL->saveFile
				$this->bank_acc_req_import_inputvarname = $this->bank_acc_req_file_import_id_token . '_FIBK';
				$this->fibk_defval_idname_text = dict('CODE_MSG_FONDAFA_TITLE') . ': ^1';	// texto que inicia el texto descriptivo de la cuenta de banco
				$this->fibk_defval_city = FONDAFA_DEFVAL_CITY;			// Banck Acc. CITY
				$this->fibk_defval_state = FONDAFA_DEFVAL_STATE;		// Banck Acc. STATE
				$this->fibk_defval_country = FONDAFA_DEFVAL_COUNTRY;	// Banck Acc. COUNTRY
				$this->input_aux_tablename = tableName('FONC');			// Nombre de la tabla fuente de f9ondafa
				$this->bank_acc_req_import_tabaux_fieldname = 'BANKAC_CODE';	// nombre del campo con la cta. de banco en la tabla fuente
				$this->bank_acc_req_import_sql = "
					SELECT 
						FONC.BANKAC_CODE,
						FONC.ID FONC_ID, 
						FONC.FONDA_CREDITNO,
						FONC.REC_STATUS,
						FONC.CUST_FILEID,
						ACCO.IDCODE, 
						ACCO.IDNAME
					FROM $this->foncname FONC, $this->acconame ACCO 
					WHERE 
						ACCO.IBS_CUSCUN = '%s_ibs_cuscun%'
						AND ACCO.IDCODE = FONC.ACCOUNTCODE
					;";
				break;

			case $this->prestaciones_bank_acc_req_import_schedule:
				$this->bank_acc_req_file_import_id_token = 'PRES';
				$this->bank_acc_req_file_import_savefile_id = 'prestaciones_bank_acc_req_file_import';	// ID del proceso para cuando se salva el archivo funente mediante la herramienta $SDFL->saveFile
				$this->bank_acc_req_import_inputvarname = $this->bank_acc_req_file_import_id_token . '_FIBK';
				/*
				  * CODE_MSG_PRES_TITLE
				  * Employee Severances
				  * Prestaciones Sociales
				  */
				$this->fibk_defval_idname_text = dict('CODE_MSG_PRES_TITLE') . ': ^1';	// texto que inicia el texto descriptivo de la cuenta de banco
				$this->fibk_defval_city = FONDAFA_DEFVAL_CITY;			// Banck Acc. CITY
				$this->fibk_defval_state = FONDAFA_DEFVAL_STATE;		// Banck Acc. STATE
				$this->fibk_defval_country = FONDAFA_DEFVAL_COUNTRY;	// Banck Acc. COUNTRY
				$this->input_aux_tablename = tableName('PRES');
				$this->bank_acc_req_import_tabaux_fieldname = 'BANK_ACCOUNT_NO';
				$this->bank_acc_req_import_sql = "
					SELECT 
						PRES.BANK_ACCOUNT_NO BANKAC_CODE,
						PRES.ID FONC_ID, 
						PRES.CONTRACT_CODE FONDA_CREDITNO,
						PRES.REC_STATUS,
						PRES.CUST_FILEID,
						ACCO.IDCODE, 
						ACCO.IDNAME
					FROM $this->presname PRES, $this->acconame ACCO 
					WHERE 
						ACCO.IBS_CUSCUN = '%s_ibs_cuscun%'
						AND ACCO.IDENTIFICATION = CONCAT(PRES.LEGAL_TYPE, PRES.IDENTIFICATION)
					;";
				break;
		}
	} // Method End

	/**
	* Takes action depending of form's values 
	*/
	function gen_bank_acc_req_file_import_action($ac, $filename=NULL)
	{
		$msg = array();
		if(!array_key_exists('confirm', $_REQUEST) || !empty($msg) || !$this->gen_bank_acc_req_file_import_check_file_upload_dialog($msg, $this->bank_acc_req_import_inputvarname)){
			$contents = $this->gen_bank_acc_req_file_import_file_upload_dialog($_POST, $msg);
		} else {
			if($filename==NULL) $filename = $this->gen_bank_acc_req_file_import_filename($this->bank_acc_req_import_inputvarname);

			if(!class_exists('clx_file')) require kPathToWebSite . "classes/clx_file.php";
			$o_file_hndl = new clx_file($filename, 'r');
			$o_file_hndl->open();
			$s_file_contents = $o_file_hndl->read($o_file_hndl->size());
			$o_file_hndl->close();

			$SDFL = getTool('SDFL');
			/*
			  * CODE_FONDAFA_MSG_BKACCFILIMPDESC
			  * FONDAFA bank account assignment import
			  * Importacin de asignacin cuentas de banco de FONDAFA
			  */
			/*
			  * CODE_PRES_MSG_BKACCFILIMPDESC
			  * Employee Severances bank account assignment import
			  * Importacin de asignacin cuentas de banco de Prestaciones Sociales
			  */
			$id = $SDFL->saveFile(
					$this->bank_acc_req_file_import_savefile_id, 
					'text/plain', 
					$s_file_contents, 
					false, 
					kPathToWebSite . kPathToData, 
					"", 
//					dict("CODE_FONDAFA_MSG_BKACCFILIMPDESC")
					dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_MSG_BKACCFILIMPDESC")

				);
			$sdfl_record = $SDFL->loadRecord($id);

			//Create Process Schedule 
			$contents = $this->create_proc_sched_sched(
					/*
					 * CODE_FONDAFA_FIBKIMPRT_TITLE
					 * FONDAFA CLIENT BANK ACCOUNT ASSIGNMENT
					 * ASIGNACION DE CUENTAS BANCARIAS A BENEFICIARIOS DE FONDAFA
					 */
					/*
					 * CODE_PRES_FIBKIMPRT_TITLE
					 * EMPLOYEE SEVERENACES CLIENT BANK ACCOUNT ASSIGNMENT
					 * ASIGNACION DE CUENTAS BANCARIAS A PARTICIPANTES DE PRESTACIONES SOCIALES
					 */
					dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_FIBKIMPRT_TITLE"), 
					//$this->fondafa_bank_acc_req_import_schedule, 
					$this->current_bank_acc_req_import_schedule,
					array(
							'ANYFILE' => $sdfl_record['SDFL_filename'], // $filename, 
						)
				);

			// 2007-11-16 CJR se elimina el archivo fuente para evitar confusiones en futuras importaciones del masivo de cuentas
			unlink ($filename);
		}

		return $contents;
	} // Method End

	/**
	* Returns the form's especified filename
	*/
	function gen_bank_acc_req_file_import_filename($s_base_fieldname)
	{
		if (empty($_POST[$s_base_fieldname . "_localfile"])) {
			$filename = $_FILES[$s_base_fieldname . "_uploadfile"]["tmp_name"];
		} else {
			$filename = $_POST[$s_base_fieldname . "_localfile"];
		}
		return $filename;
	} // Method End

	/**
	* Form to get the import filespec, for those cases where it isn't specified as entry point method parameter
	*/
	function gen_bank_acc_req_file_import_file_upload_dialog($record, $msg) {
		global $db;
//print_r($_REQUEST);
		// Setup de la forma y campos Hidden
		$OBJS = &getTool("OBJS");
        $form = new htmlForm("action",  $_SERVER['PHP_SELF'], 'id','theForm','name','theForm');
		$form->addArgument("to", $_REQUEST['to']);
		$form->addArgument("ac", $_REQUEST['ac']);
		$form->addArgument("idlist", (isset($_REQUEST['idlist'])) ? $_REQUEST['idlist'] : '');
		$form->addArgument("it", $_REQUEST['it']);
		$form->addArgument("wind", '1');
		$form->addArgument("confirm", '1');
		$form->setProp("enctype", "multipart/form-data");
			
		// Datos que se solicitan
		$tableWidth = 2;
		$table = new htmlTable($tableWidth, "class", "form", "width", "100%");
		$table->addCell(dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_FIBKIMPRT_TITLE"), "class", "title",
                        "colspan", $tableWidth);
		$table->addCell(dict("TOOL_PACK_PROMPT_IMPORTEXPLAIN"), "class",
                        "subtitle", "colspan", $tableWidth);
		if(!array_key_exists($this->bank_acc_req_import_inputvarname . '_localfile', $record))
            //$record[$this->bank_acc_req_import_inputvarname . "_localfile"]= companyParameter('FONDAFA_ACC_REQ_IMPRT_FILE', $this->s_comp_code);
            $record[$this->bank_acc_req_import_inputvarname . "_localfile"]= trim(companyParameter($this->bank_acc_req_file_import_id_token . '_ACC_REQ_IMPRT_FILE', $this->s_comp_code));
		if(!array_key_exists($this->bank_acc_req_import_inputvarname . '_uploadfile', $record))
            $record[$this->bank_acc_req_import_inputvarname . "_uploadfile"]='';

		$table->addField($msg, dict("TOOL_PACK_PROMPT_FILEONSERVER") . ":",
            $this->bank_acc_req_import_inputvarname . "_localfile", 
			$record[$this->bank_acc_req_import_inputvarname . "_localfile"], 48, 255);
		$table->addFile($msg, dict("TOOL_PACK_PROMPT_UPLOADFILE") . ":",
            $this->bank_acc_req_import_inputvarname . "_uploadfile", 
			$record[$this->bank_acc_req_import_inputvarname . "_uploadfile"]);

		// Botones y parte final
		$c = new htmlSubmit(dict("GEN_LBL_CONTINUE"), "PRINT_DIALOG");
		$buttons = $c->source();
		if(strpos($_SERVER['PHP_SELF'],'pop.php')!==false){
			$c = new htmlButtonCloseWindow(dict("GEN_LBL_CANCEL"));
			$buttons .= $c->source();
		}
		$table->addCell($buttons, "class", "footers", "colspan", $tableWidth);
		$form->setContents($table->source());
		return $form->source();

	} // Method End

	/**
	* Form values validation para el upload del archivo que se recibo de IBS con la asignacion de cuentas
	*/
	function gen_bank_acc_req_file_import_check_file_upload_dialog(&$msg, $s_base_fieldname) {
		global $db;
	
		$msg = array();
		if (empty($_POST[$s_base_fieldname . "_localfile"])) {
			if ($_FILES[$s_base_fieldname . "_uploadfile"]["error"]) {
				$msg[$s_base_fieldname . "_uploadfile"] = dict('ERR_PACK_FILETOOBIG');
			}
		} elseif (!file_exists($_POST[$s_base_fieldname . "_localfile"])) {
			/*
			 * GEN_ERR_FILE_NOT_FOUND
			 * File not found: ^1
			 * Archivo no encontrado: ^1
			 */
			$msg[$s_base_fieldname . "_localfile"] = 
					dict("GEN_ERR_FILE_NOT_FOUND") . ": " . 
					$_POST[$s_base_fieldname . "_localfile"];
			}
		
		return (count($msg) == 0);
	} // Method End

	/*
	  * Importacion del archivo que viene de vuelta como respuesta a la solicitud  de ctas. de banco para los beneficiarios de Fondafa y prestaciones sociales
	  * Ejecuta la importacion desde el archivo plano
	  */
	function gen_bank_acc_req_file_import_doitnow($s_import_filename)
	{
//$this->debug = true;
		$contents = '';
  		$EBSK = getTool("EBSK");
		$EBSK->debug = $this->debug;
		//$EBSK->tfields_only = true;
		//$EBSK->remove_decimal_point = true;
		$msg_code = BANK_ACC_REQ_RECORD_DEFINITION_CODE;

		// Trata de abrir el reporte de salida
		$contents = $this->open_rpt_process_run(
			$s_import_filename . BANK_ACC_REQ_IMPORT_ERRFILE_EXT);
		if($contents!='') {
			return $contents;
		}
		// Si los parametros del proceso no se pasaron debidamente, emite error y sale
		if(! $this->proc_eng_params->verify_parameters()) {
			$contents = "<h1>" . $this->proc_eng_params->errormsg . "</h1>";
			$this->o_response_rpt->write($this->proc_eng_params->errormsg);
			$this->o_response_rpt->close();
			return $contents;
		}

		/*
		 * CODE_FONDAFA_LBL_TITBKACCREQIMP
		 * BANK ACCOUNT CREATION REQUEST FILE IMPORT
		 * IMPORTACION DEL ARCHIVO DE SOLICITUD DE CREACION DE CUENTAS DE BANCO
		 */
		/*
		 * CODE_PRES_LBL_TITBKACCREQIMP
		 * BANK ACCOUNT CREATION REQUEST FILE IMPORT
		 * IMPORTACION DEL ARCHIVO DE SOLICITUD DE CREACION DE CUENTAS DE BANCO
		 */
		//$contents .= (
		$this->o_response_rpt->write(
			"<br>\n" .
			$this->titulo(dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_LBL_TITBKACCREQIMP")) .
			"<br>");

		if(!file_exists($s_import_filename)) {
			// There's nothing to import
			$this->report_error(dict("GEN_ERR_FILE_NOT_FOUND") . ": " . $s_import_filename);
			return $contents;
		} else {
			//$contents .= 
			$this->o_response_rpt->write($s_import_filename . "<br>\n");
		}

		if(!class_exists('clx_file')) require kPathToWebSite . "classes/clx_file.php";
		$o_clx_file = new clx_file($s_import_filename, 'r');
		$o_clx_file->open();
		if($o_clx_file->error) {
			$this->report_error($o_clx_file->errorMsg);
			return $contents;
		}

		/*
		$o_logfile_mngr = new clx_logfile_mngr($s_import_filename . BANK_ACC_REQ_IMPORT_ERRFILE_EXT);
		if($o_logfile_mngr->error) {
			$contents .= ($o_logfile_mngr->errorMsg);
			return $contents;
		}
		*/

		$buffer = $o_clx_file->read_line();
		$i_proc_counter = 0;
		while(!$o_clx_file->eof) {

			$i_proc_counter++;
			if($buffer == '') {
				$buffer = $o_clx_file->read_line();
				continue;
			}
			// Reads flat file line
			$ar_record = $EBSK->readMessage($msg_code, $buffer);
			if($this->debug) echoLog(debug_dump('$i_proc_counter - ar_record', $ar_record));

			// Creates and assigns the banck account to FIBK and FONC
			$ar_response = $this->create_banck_account_and_link_to_crm($ar_record);
///echo "<br>create_banck_account_and_link_to_crm<br>";print_r($ar_response);return $contents;

			// Text for output
			//$s_response = $ar_response['rec_id_info'] . ": <li>" . $ar_response['errormsg'] . "</li><br>";
			$s_response = $ar_response['rec_id_info'] . ": <br>* " . $ar_response['errormsg'] . "<br><br>";

			// screen output
			//$contents .= $s_response;	// 2008-02-12 -- para eliminar la cantidad de contenido en el log del proceso, es suficiente el Log File "o_logfile_mngr"

			// Writes error file
			//$o_logfile_mngr->write($s_response);
			$this->report_error($s_response, $ar_response['error']);

			// Reads next flat file line
			$buffer = $o_clx_file->read_line();
//if($i_proc_counter>10) return $contents;
		}

		// close input file
		$o_clx_file->close();
		if($o_clx_file->error) {
			$this->report_error($o_clx_file->errorMsg);
		}

		// close output error file
		$this->o_response_rpt->close();
		/*
		$o_logfile_mngr->close();
		if($o_logfile_mngr->error) {
			$contents .= ($o_logfile_mngr->errorMsg);
		}
		*/

		// Reset the queue record to free the resource
		$a = new ibs_interface_queue(
			array(
				'comp_code'=> $this->s_comp_code, 
				'interface' => "CTA", 
				'submodule' => $this->submodule, 
				'subtype' => ''
				)
			);
		if(! $a->initpar()) {
			$this->report_error($a->get_errormsg());
		} else {
			// The interface result file isn't the same name all the time...
			$a->s_par_filespec_out = $s_import_filename;
			if(! $a->exit_queue(array($s_import_filename . BANK_ACC_REQ_IMPORT_ERRFILE_EXT))) {
				$this->report_error($a->get_errormsg());
			}
		}

		// Schedule queue monitor run
		$this->ibiq_schedule_4_exec();

		return $contents;
	} // Method End

	/**
	 * Crea la cuenta bancaria en la tabla FIBK y la enlaza con la cta. CRM
	 */
	function create_banck_account_and_link_to_crm($ar_record_original)
	{
//$this->debug = true;
		global $db;
		$prev_debug_state =  ClxCommon::$db->debug;
		 ClxCommon::$db->debug = $this->debug;

		$ar_record = $this->eibs_def_array_directval_assing($ar_record_original);
		if($this->debug) echoLog(debug_dump('ar_record en create_banck_account_and_link_to_crm()', $ar_record));


		/*
		 * CODE_FONDAFA_MSG_BKACCLNKCRM_DAT
		 * Bank acc. # ^1, IBS Client # ^2
		 * Cta. Bco. # ^1, Cliente IBS # ^2
		 */
		$ar_response = array(
				'error'=> false, 
				'errormsg' => dict('CODE_FONDAFA_MSG_OK'),
//				'rec_id_info' => dict("CODE_FONDAFA_MSG_BKACCLNKCRM_DAT", $ar_record['BACCCODE'], $s_ibs_cuscun),
				'rec_id_info' => dict("CODE_FONDAFA_MSG_BKACCLNKCRM_DAT", $ar_record['BACCCODE'], $ar_record['IBSCUSCUN']),
			);

///return array();
		$s_ibs_cuscun = $this->remove_leading_zeroes($ar_record['IBSCUSCUN']);
		if($s_ibs_cuscun == "") {
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_BKACNOTASS
			 * Bank account code was not assigned by IBS
			 * El nmero de cuenta de banco no fue asignado por IBS
			 */
			$ar_response['errormsg'] = "(CCNA) " . dict("CODE_FONDAFA_ERR_BKACCLNKCRM_BKACNOTASS");
			$ar_response['error'] = true;
			return $ar_response;
		}
if($this->debug) echoLog(debug_dump('create_banck_account_and_link_to_crm - ar_record', $ar_record));

		// Extrae la cuenta CRM relacionada con FONC segn el CUSCUN  que viene en el archivo plano
		/*
		$sql = "SELECT 
						FONC.BANKAC_CODE,
						FONC.ID FONC_ID, 
						FONC.FONDA_CREDITNO,
						FONC.REC_STATUS,
						ACCO.IDCODE, 
						ACCO.IDNAME
					FROM $this->foncname FONC 
						LEFT JOIN $this->acconame ACCO ON ACCO.IDCODE = FONC.ACCOUNTCODE
					WHERE 
						ACCO.IBS_CUSCUN = '$s_ibs_cuscun'
				;";
		*/
		$sql = str_replace('%s_ibs_cuscun%', $s_ibs_cuscun, $this->bank_acc_req_import_sql);
		if($this->debug) { echo "<br>\n$sql<br>\n"; }
		$results =  ClxCommon::$db->executeQuery($sql);

///$ar_response['error'] = false;
///return $ar_response;
/*
		if(! $clientrec =  ClxCommon::$db->getNextRecord($results)) {
			// No se encontro el registro de CRM
			$ar_response['error'] = true;
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_CRMNOTFND
			 * Inconsistency Error: CRM account doesn't exists for IBS Client # ^1
			 * Error de incosistencia: no existe La cuenta CRM correpondiente al Cliente IBS # ^1
			 * /
			$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACCLNKCRM_CRMNOTFND", $s_ibs_cuscun);
			return $ar_response;
		} else {

			// Identifica al cliente para el Print Out
			$ar_response['rec_id_info'] .= ", CRM # " . $clientrec['IDCODE'] . ", " . $clientrec['IDNAME'];
			$ar_result_clientrec = array();

			do {
				if($clientrec['BANKAC_CODE'] == $ar_record['BACCCODE']) {
					// Ya fue asignada la cuenta de banco (o sea, ya fue ejecutado el proceso con este archivo)
					if($clientrec['REC_STATUS'] != 'END') {
						// SI NO TENIA ASIGNADO BIEN EL ESTATUS, LO ASIGNA CORRECTAMENTE ?
						$ar_fonc_record = array();
						$ar_fonc_record['REC_STATUS'] = 'END';	// Terminado (END) : finalizado el proceso para este beneficiario
						// ClxCommon::$db->updateRecord($this->foncname, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
						 ClxCommon::$db->updateRecord($this->input_aux_tablename, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
					}
					/*
					 * CODE_FONDAFA_ERR_BKACCLNKCRM_BKACALASS
					 * Bank account ^1 already assigned to this payee
					 * La Cuenta de Banco ^1 ya fue asignada a este Beneficiario
					 */
					/*
					 * CODE_PRES_ERR_BKACCLNKCRM_BKACALASS
					 * Bank account ^1 already assigned to this participant
					 * La Cuenta de Banco ^1 ya fue asignada a este participante
					 * /
					$ar_response['error'] = true;
					$ar_response['errormsg'] = dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_ERR_BKACCLNKCRM_BKACALASS", $clientrec['BANKAC_CODE']);
					return $ar_response;
				}
				$ar_result_clientrec[] = $clientrec;
			} while ($clientrec =  ClxCommon::$db->getNextRecord($results));
		}
*/
		if( ClxCommon::$db->num_rows($results) > 0) {
			$ar_result_clientrec = array();
			while ($clientrec =  ClxCommon::$db->getNextRecord($results))
			{

				if($clientrec['BANKAC_CODE'] == $ar_record['BACCCODE']) {
					// Ya fue asignada la cuenta de banco (o sea, ya fue ejecutado el proceso con este archivo)
					if($clientrec['REC_STATUS'] != 'END') {
						// SI NO TENIA ASIGNADO BIEN EL ESTATUS, LO ASIGNA CORRECTAMENTE ?
						$ar_fonc_record = array();
						$ar_fonc_record['REC_STATUS'] = 'END';	// Terminado (END) : finalizado el proceso para este beneficiario
						// ClxCommon::$db->updateRecord($this->foncname, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
						 ClxCommon::$db->updateRecord($this->input_aux_tablename, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
					}
					/*
					 * CODE_FONDAFA_ERR_BKACCLNKCRM_BKACALASS
					 * Bank account ^1 already assigned to this payee
					 * La Cuenta de Banco ^1 ya fue asignada a este Beneficiario
					 */
					/*
					 * CODE_PRES_ERR_BKACCLNKCRM_BKACALASS
					 * Bank account ^1 already assigned to this participant
					 * La Cuenta de Banco ^1 ya fue asignada a este participante
					 */
					$ar_response['error'] = true;
					$ar_response['errormsg'] = dict("CODE_" . $this->bank_acc_req_file_import_id_token . "_ERR_BKACCLNKCRM_BKACALASS", $clientrec['BANKAC_CODE']);
					return $ar_response;
				}
				$ar_result_clientrec[] = $clientrec;
			}
		} else {
			// No se encontro el registro de CRM
			$ar_response['error'] = true;
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_CRMNOTFND
			 * Inconsistency Error: CRM account doesn't exists for IBS Client # ^1
			 * Error de incosistencia: no existe La cuenta CRM correpondiente al Cliente IBS # ^1
			 */
			$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACCLNKCRM_CRMNOTFND", $s_ibs_cuscun);
			return $ar_response;
		}
		
		// Verifica a cual record de FONC le debe asignar la cuenta
		// El criteria es: el primero que encuentre con la cta. de banco en blanco
		$clientrec = NULL;
		for($i=0;$i<count($ar_result_clientrec);$i++) {
			if($this->debug) echoLog(
					"FONC_ID=" . $ar_result_clientrec[$i]['FONC_ID'] . ", " .
					"IDNAME=" . $ar_result_clientrec[$i]['IDNAME'] . ", " .
					"BANKAC_CODE=" . $ar_result_clientrec[$i]['BANKAC_CODE'] . ", " .
					""
				);
			//if(empty($ar_result_clientrec[$i]['BANKAC_CODE'])) {
			// 2007-12-06 CJR Se agreg en la condicin el estatus, para que no tome en cuenta otros registros que tengan el mismo CUSCUN y estatus de error u otro que no sea "en espera por cta. bancaria"
			if(empty($ar_result_clientrec[$i]['BANKAC_CODE']) && $ar_result_clientrec[$i]['REC_STATUS'] == "RWAC") {
				// cuando encuentra uno en blanco, asigna $clientrec con los datos del registro a procesar
if($this->debug) echoLog("ESTE ULTIMO QUEDO....");
				$clientrec = $ar_result_clientrec[$i];
				break;
			}
		}

		if($clientrec == NULL) {
			// Ya todos los registros de clientes fueron asignados con ctas. de banco
			// Esto es una inconsistencia ya que se supone q ninguno de ellos tiene 
			// el nro. de cuenta q se esta procesando
			/*
			  * CODE_FONDAFA_ERR_REC2ASSNOTAVAIL
			  * Could not find an assignment pending credit number to assign the Bank Account # ^1
			  * No se encontr un nmero de credito que estuviera pendiente por asignacin de la Cuenta de Banco # ^1
			  */
			/*
			  * CODE_PRES_ERR_REC2ASSNOTAVAIL
			  * Could not find an assignment pending record to assign the Bank Account # ^1
			  * No se encontr ningn registro de incorporacin que estuviera pendiente por asignacin de la Cuenta de Banco # ^1
			  */
			$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_REC2ASSNOTAVAIL", $ar_record['BACCCODE']);
			$ar_response['error'] = true;
			return $ar_response;
		}

		//if($clientrec['BANKAC_CODE'] != '') {
			// Cta. Ya fue asignada
			//$ar_response['error'] = true;
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_BKACALASS
			 * Bank account ^1 already assigned to this payee
			 * La Cuenta de Banco ^1 ya fue asignada a este Beneficiario
			 */
			//$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACCLNKCRM_BKACALASS", $clientrec['BANKAC_CODE']);
			//return $ar_response;
		//}

		if(trim($ar_record['BACCCODE']) == '') {
			// No hay asignacin de la cuenta de banco
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_BKACNOTASS
			 * Bank account code was not assigned by IBS
			 * El nmero de cuenta de banco no fue asignado por IBS
			 */
			$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACCLNKCRM_BKACNOTASS");
			$ar_response['error'] = true;

		} elseif((integer)$ar_record['BACCCODE'] == 0) {
			// El cliente esta en estatus "en espera por aprobacin" y aun no se puede asignar la cuenta
			/*
			 * CODE_FONDAFA_ERR_BKACCLNKCRM_CLIESAPR
			 * Bank account code was not assigned by IBS because client is waiting for approval
			 * El nmero de cuenta de banco no fue asignado por IBS porque el cliente esta en espera de aprobacin
			 */
			$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACCLNKCRM_CLIESAPR");
			$ar_response['error'] = true;
		}
		if($ar_response['error'] == true) {
			// Si a este punto hubo errores, es necesario reversar el estus del cliente en FONC 
			// para volver a incluirlo en el proximo lote de asignacin de cuentas de banco
if($this->debug) echoLog("ERROR Q DEVUELVE A STATUS RUN (1): " . $ar_response['errormsg']);
			$ar_fonc_record = array();
			$ar_fonc_record['REC_STATUS'] = 'RUN';	// Waiting for bank account code ( 2007-01-24)
			// ClxCommon::$db->updateRecord($this->foncname, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
			 ClxCommon::$db->updateRecord($this->input_aux_tablename, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
			return $ar_response;
		}

		$ar_fibk =  ClxCommon::$db->getRecord($this->fibkname, "BANK_ACCOUNT_NO = '" . $ar_record['BACCCODE'] . "'");
		if($ar_fibk) {
			// La cuenta ya fue creada, verifica consistencia: la cta. debe estar asignada al contacto correspondiente
			if($ar_fibk['ACCOUNTCODE'] != $clientrec['IDCODE']) {
				$ar_response['error'] = true;
				/*
				 * CODE_FONDAFA_ERR_BKACASSOTHCRM
				 * Inconsistency error: Bank account ^1 already assigned to a different CRM account # ^2
				 * Error de incosistencia: La Cuenta de Banco ^1 est asignada a una cuenta CRM # ^2 diferente
				 */
				$ar_response['errormsg'] = dict("CODE_FONDAFA_ERR_BKACASSOTHCRM", 
												$ar_record['BACCCODE'], $ar_fibk['ACCOUNTCODE']);
				return $ar_response;
			}
if($this->debug) echoLog("FIBK EXISTE Y PERTENECE AL CLIENTE IDCODE=" . $ar_fibk['ACCOUNTCODE']);
		} else {

			// Crea la cuenta bancaria de CLX
			$ar_bank_record = 
				array(
					'IDNAME' => str_replace('^1', $clientrec['IDNAME'], $this->fibk_defval_idname_text), // 	Nombre Corto / Name of the record - FONDAFA: nombre del cliente
					'ACCOUNTCODE' => $clientrec['IDCODE'], // 	Cdigo de Cuenta / Account ID Code - enlace con ACCO
					'CONTRACT_CODE' => '', // 	LOOK 	1.0.0-12 	Cdigo del Contrato 	Yes 	Trust/Fideicomisos Contract
					'EFFTDATE' => adodb_date('Y-m-d'), // 	DATE 	1.0.0-10 	Fecha Efectiva 	Yes 	Effective Date
					'BANK_NAME' => $this->ar_comp_record['IDNAME'], // 	CHAR 	1.0.0-1 	Banco 	No 	Bank Name
					'GLACCOUNTCODE' => $this->ar_comp_record['DEFCASHCODE'], // 	LOOK 	1.0.0-2 	Cdigo Contable 	No 	GL Account Code
					'BRANCH' => $ar_record['BRANCH'], // 	LIST 	1.0.0-1 	Sucursal 	No 	Branch
					'BANK_ACCOUNT_NO' => $ar_record['BACCCODE'], // 	CHAR 	1.0.0-3 	Nmero de Cuenta Bancaria 	No 	Bank Account Number
					'BANK_ROUTING_NO' => '', // 	CHAR 	1.0.0-3 	ABA (Routing No.) 	No 	Bank Routing Number
					'BANK_SWIFT' => '', // 	CHAR 	1.0.0-0 	Cdigo Swift 	No 	Swift Code
					'ADDRESS' => '', // 	CHAR 	1.0.0-2 	Direccin 	No 	Address
					'EXT_PRODUCT_CODE' => $clientrec['FONDA_CREDITNO'], // 	CHAR 	1.0.0-2 	Direccin 	No 	Address - # CREDITO DE FONDAFA
					'CITY' => $this->fibk_defval_city, // 	LIST 	1.0.0-8 	Ciudad 	No 	City name
					'STATE' => $this->fibk_defval_state, // 	LIST 	1.0.0-5 	Estado 	No 	State Name or code State of USA, USST estado de venezuela VEST
					'COUNTRY' => $this->fibk_defval_country, // 	LIST 	1.0.0-5 	Pas 	No 	Country
					'PHONE' => '', // 	CHAR 	0.0.0-1 	Nmero de Telfono 	No 	
					'FAX' => '', // 	CHAR 	0.0.0-0 	Nmero de Fax 	No 	
					'LAST_CHECK_NO' => '', // 	CHAR 	1.0.0-1 	ltimo Cheque 	No 	Last Check Number
					'CURRENCY_CODE' => $this->ar_comp_record['CURRENCY_CODE'], // 	LIST 	1.0.0-4 	Moneda 	Yes 	Currency Code
					'MIN_BALANCE_AMT' => 0, // 	DECN 	1.0.0-2 	Saldo Mnimo 	No 	Minimum Balance Amount
					'BALANCE_AMT' => 0, // 	DECN 	1.0.0-22 	Saldo 	Yes 	Balance or Asset Value
				);
			$new_fibk_record_id =  ClxCommon::$db->createRecord($this->fibkname, $ar_bank_record);
if($this->debug) echoLog("CREO LA CTA FIBK : " . $ar_record['BACCCODE']);
		}

		// Identifica al cliente para el Print Out
		$ar_response['rec_id_info'] .= ", CRM # " . $clientrec['IDCODE'] . ", " . 
			$clientrec['IDNAME'] . ", " . dict('GEN_LBL_LOT') . ": " . $clientrec['CUST_FILEID'];

		// Salva el resultado del proceso de este registro en FONC
		$ar_fonc_record = array();
		//$ar_fonc_record['BANKAC_CODE'] = $ar_record['BACCCODE']; // asigna el # de cta. de banco en FONC
		$ar_fonc_record[$this->bank_acc_req_import_tabaux_fieldname] = $ar_record['BACCCODE']; // asigna el # de cta. de banco en FONC
		$ar_fonc_record['REC_STATUS'] = 'END';	// Terminado (END) : finalizado el proceso para este beneficiario
		// ClxCommon::$db->updateRecord($this->foncname, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
		 ClxCommon::$db->updateRecord($this->input_aux_tablename, $ar_fonc_record, "ID = '" . $clientrec['FONC_ID'] . "'");
if($this->debug) echoLog("ACTUALIZO FONC ID: " . $clientrec['FONC_ID'] . " CON ESTATUS  " . $ar_fonc_record['REC_STATUS'] );

		 ClxCommon::$db->debug = $prev_debug_state;
		return $ar_response;
	} // Method End

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Invoca el procesammiento de Liquidaciones
	 */
	function fondafa_liquidacion_process()
	{
		/*
		 * CODE_FONDAFA_LBL_TITLIQUIDACION
		 * PROCESO DE LIQUIDACIONES
		 * PROCESO DE LIQUIDACIONES
		 */
		return $this->fondafa_gen_dialog_handle($this->fondafa_liquidacion_schedule, $this->titfondafa(dict("CODE_FONDAFA_LBL_TITLIQUIDACION")));
	} // Method End

	/**
	 * Invoca el procesammiento de Ordenes de Compra
	 */
	function fondafa_ordencompra_process()
	{
		/*
		 * CODE_FONDAFA_LBL_TITORDENPAGO
		 * PROCESO DE ORDENES DE PAGO
		 * PROCESO DE ORDENES DE PAGO
		 */
		return $this->fondafa_gen_dialog_handle($this->fondafa_ordencompra_schedule, $this->titfondafa(dict("CODE_FONDAFA_LBL_TITORDENPAGO")));
	} // Method End

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Llamada al proceso de prestaciones
	 * Sustituye la llamada de menu: "List Records with listing: PRSC_PRES"
	 */
	function prestaciones_proceso($s_id_proceso=NULL)
	{
		global $db;
		if($s_id_proceso==NULL) $s_id_proceso=$this->prestaciones_proceso_schedule;
		$s_titulo =  ClxCommon::$db->getField('CLX_PR_PROCESS', 'IDNAME', "IDCODE = '$s_id_proceso'");
		return $this->fondafa_gen_dialog_handle($s_id_proceso, $s_titulo);
	} // Method End

	/**
	 * Creacion de clientes en IBS a partir de las incorporaciones de prestaciones sociales
	 * A ser llamado desde la opcin de men
	 */
	function prestaciones_client_import()
	{
		/*
		 * CODE_PRES_LBL_TITCIM
		 * EMPLOYEE SEVERANCES:  IBS CLIENT CREATION
		 * PRESTACIONES SOCIALES:  CREACION DE CLIENTES EN IBS
		 */
		return $this->fondafa_gen_dialog_handle($this->prestaciones_client_import_schedule, 
			dict("CODE_PRES_LBL_TITCIM"));
	} // Method End

	/**
	  * Ejecucin de la creacion de clientes IBS desde Prestaciones en el Process Engine (Run Time)
	  */
	function prestaciones_client_import_run($s_lang, $s_username, $s_lote)
	{
		global $db;

		// Identifica el sub-modulo
		$this->submodule = "PRES";

		set_time_limit(TIME_LIMIT_4_CLIENT_IMPORT_RUN);
		$this->lang = $s_lang;
		$this->s_lote = $s_lote;
		$this->username = $s_username;

		$contents = '';
		$s_response = $this->open_rpt_process_run(IBS_MASSIVE_CLIENT_CREATION_RPT_FILENAME);
		if($s_response!='') {
			return $s_response;
		}
		// Si los parametros del proceso no se pasaron debidamente, emite error y sale
		if(! $this->proc_eng_params->verify_parameters()) {
			$s_response = "<h1>" . $this->proc_eng_params->errormsg . "</h1>";
			$this->o_response_rpt->write($this->proc_eng_params->errormsg);
			$this->o_response_rpt->close();
			return $s_response;
		}

		// Esta variable permite chequear el cambio del tipo de cliente (ruptura de control) para poder escribir 
		// 2 archivos distintos segun el tipo de persona ya que contiene el ultimo tipo de persona procesado
		$s_tipo_persona = '';

		/*
		 * CODE_PRES_LBL_TITCIM
		 * EMPLOYEE SEVERANCES:  IBS CLIENT CREATION
		 * PRESTACIONES SOCIALES:  CREACION DE CLIENTES EN IBS
		 */
		//$contents .= $this->titulo(dict("CODE_PRES_LBL_TITCIM"));
		$this->o_response_rpt->write($this->titulo(dict("CODE_PRES_LBL_TITCIM")));
		
		/*
		 * GEN_LBL_LOT
		 * Lot
		 * Lote
		 */
		//$contents .= dict('GEN_LBL_LOT') . ": $this->s_lote<BR>\n";
		$contents .= "<BR>\n" . dict('GEN_LBL_LOT') . ": $this->s_lote<BR>\n";
		$this->o_response_rpt->write(dict('GEN_LBL_LOT') . ": $this->s_lote<BR>\n");

		/*
		 * GEN_LBL_USER
		 * User
		 * Usuario
		 */
		//$contents .= dict('GEN_LBL_USER') . ": $this->username<BR>\n";
		$this->o_response_rpt->write(dict('GEN_LBL_USER') . ": $this->username<BR>\n");

		$DBLT = getTool("DBLT");

		$sql = "
			SELECT 
				CASE PRES.LEGAL_TYPE 
					WHEN 'R' THEN 'I' 
					WHEN 'V' THEN 'I' 
					WHEN 'E' THEN 'I' 
					WHEN 'J' THEN 'C' 
					WHEN 'G' THEN 'C' 
					ELSE 'Z' 
					END TIPO_PERSONA, 
				ACCO.IDCODE ACCO_IDCODE,
				PRES.*
			FROM 
				$this->presname PRES 
					LEFT JOIN $this->acconame ACCO ON ACCO.IDENTIFICATION = CONCAT(PRES.LEGAL_TYPE, PRES.IDENTIFICATION)
			WHERE 
				PRES.REC_STATUS IN ('RWIC')
				AND PRES.PRES_OPERATION_TYPE IN ('IN')
				%OTHER_WHERE_CONDITION%
			ORDER BY 
				TIPO_PERSONA;
			";
		if($s_lote==NULL) {
			$sql = str_replace("%OTHER_WHERE_CONDITION%", "", $sql);
		} else {
			$sql = str_replace("%OTHER_WHERE_CONDITION%", "AND PRES.CUST_FILEID = '$s_lote'", $sql);
		}
		
if($this->debug) { echo "<br>\n$sql<br>\n"; }

		$i_proc_counter = 0;
		$results =  ClxCommon::$db->executeQuery($sql);
		while($clientrec =  ClxCommon::$db->getNextRecord($results)){

if($this->debug) echoLog(debug_dump('clientrec', $clientrec));
			$b_sw_severe_error = false;
			$i_proc_counter++;
			$s_response = '';

			/*
			 * CODE_PRES_MSG_CIMRECIDINFO
			 * ^1) ^2-^3 <b>^4</B> Contract #: ^5:
			 * ^1) ^2-^3 <b>^4</B> Contrato #: ^5:
			 */
			$rec_id_info = dict("CODE_PRES_MSG_CIMRECIDINFO", 
									$clientrec['ID'],
									$clientrec['LEGAL_TYPE'],
									$clientrec['IDENTIFICATION'],
									$clientrec['LASTNAME'] . ' ' . $clientrec['SECOND_LASTNAME'] . ' ' . 
												$clientrec['FIRSTNAME'] . ' ' . $clientrec['SECONDNAME'],
									$clientrec['CONTRACT_CODE']
							) . " ";


			$ar_fonc_record = array(
				'REC_STATUS' => 'RWIC',	// asume status igual como estaba por defecto, de tal forma que si hay errores lo debe volver a procesar
			);

			if($b_sw_severe_error == false) {

				// No hubo error, crea cliente en IBS
				$ar_other_dat = array('UC9' => trim($clientrec['ACCO_IDCODE']) . ',PRES,' . $clientrec['ID'] . ",$this->s_lote");
				$ar_create_ibs_client_response = $this->create_ibs_client($clientrec['ACCO_IDCODE'], 
					FONDAFA_CLIENT_SOCKET_CREATION, $s_tipo_persona, $clientrec, $ar_other_dat);
				$ar_client_record = $ar_create_ibs_client_response['client_record'];
				if($ar_create_ibs_client_response['other_info'] != '') {
					//$contents .= $ar_create_ibs_client_response['other_info'] . "<br><br>";
					$this->o_response_rpt->write($ar_create_ibs_client_response['other_info'] . "<br><br>");
				}
				if($ar_create_ibs_client_response['severe_error'] == true) {
					// Si hubo un error severo, por ejemplo abriendo el archivo de salida del masivo de clientes, detiene el proceso
					//$contents .= $ar_create_ibs_client_response['errormsg'];
					$this->report_error($ar_create_ibs_client_response['errormsg']);
					$this->o_response_rpt->close();
					//return $contents;
					return $ar_create_ibs_client_response['errormsg'];
				} else {
					$s_tipo_persona = $ar_create_ibs_client_response['tipo_persona'];
					if($ar_create_ibs_client_response['error'] == true) {
						// Hubo problemas creando el cliente en IBS
						$s_response .= $ar_create_ibs_client_response['errormsg'];
						//$ar_fonc_record['REC_STATUS'] = 'ENDR';	// Completado con Errores (ENDR)
					} else {
						// El cliente en IBS fue creado con exito
						if(FONDAFA_CLIENT_SOCKET_CREATION != 1 && $ar_client_record['IBS_CUSCUN'] == '') {
							// Batch
							$ar_fonc_record['REC_STATUS'] = 'RWOC';	// Waiting for IBS code
						} else {
							// Socket
							$ar_fonc_record['REC_STATUS'] = 'END';	// Terminado
						}
					}
				}
			}

			// Salva el resultado del proceso de este registro en FONC
			if($this->debug) echoLog(debug_dump('ar_fonc_record', $ar_fonc_record));
			if($this->debug)  ClxCommon::$db->debug = true;
			 ClxCommon::$db->updateRecord($this->presname, $ar_fonc_record, "ID = '" . $clientrec['ID'] . "'");
			if($this->debug)  ClxCommon::$db->debug = false;

			/*
			 * CODE_FONDAFA_MSG_OK
			 * OK
			 * OK
			 */
			if(empty($s_response)) {
				$error = false;
				$s_response = dict('CODE_FONDAFA_MSG_OK');
			} else {
				$error = true;
			}

			// Reporta resultado en el Log del process scheduler
			$s_msg_out = "$i_proc_counter - ($rec_id_info " . 
						$DBLT->getListItem('PROS', $ar_fonc_record['REC_STATUS']) . 
						" $s_response<BR>\n";
			//$contents .= $s_msg_out;
			$this->report_error($s_msg_out, $error);
			if($this->debug) {echoLog($s_msg_out);}
		}

		/*
		  * Si era la creacion batch de clientes, verifica si quedo algo pendiente
		  */
		$ar_create_ibs_client_moverfile = $this->create_ibs_client_moverfile(
			FONDAFA_CLIENT_SOCKET_CREATION, $s_tipo_persona);
		if($ar_create_ibs_client_moverfile['error'] == true) {
			//$contents .= "<BR>\n" . $ar_create_ibs_client_moverfile['errormsg'];
			$this->report_error($ar_create_ibs_client_moverfile['errormsg']);
		}

		// Si se especificaron los parametros de codigo de producto y tipo de producto, 
		// llama al metodo que genera la solicitus masiva de creacin de cuentas de banco
		if(trim($this->s_prd_cod . $this->s_prd_tipo) != '') {
			//$contents .= "<br>\n<hr><br>\n" . $this->fondafa_bank_acc_req_export($s_prd_cod, $s_prd_tipo, $s_lote);
			$this->o_response_rpt->write("<br>\n<hr><br>\n" . 
				$this->fondafa_bank_acc_req_export($s_prd_cod, $s_prd_tipo, $s_lote));
		}

		// Closes the output file for clients creation on IBS
		if(FONDAFA_CLIENT_SOCKET_CREATION != 1 && $this->o_createClient_outputFileHandle != NULL) {
			// Batch
			$this->o_createClient_outputFileHandle->close();
			// Load the sockets interface (just in case)
			$this->massive_socket_ondemand_loader();
		}
		$this->o_response_rpt->close();
		return $contents;

	} // Method End

	/**
	* Generacion del archivo para la solicitud de ctas. de banco para los beneficiarios de Fondafa
	* Para ser llamado desde el Menu
	*/
	function prestaciones_bank_acc_req_export()
	{
		// Identifica el sub-modulo
		$this->submodule = "PRES";

		/*
		 * CODE_PRES_LBL_TITACCEXP
		 * EMPLOYEE SEVERANCES: BANK ACCOUNT CREATION REQUEST FILE GENERATION
		 * PRESTACIONES SOCIALES: GENERACION DE SOLICITUD DE CREACION DE CUENTAS BANCARIAS
		 */
		return $this->fondafa_gen_dialog_handle($this->prestaciones_bank_acc_req_export_schedule, dict("CODE_PRES_LBL_TITACCEXP"));
	} // Method End

	/*
	  * Generacion del archivo para la solicitud de ctas. de banco para prestaciones sociales
	  * Para ser llamado desde el Process Engine
	  */
	function prestaciones_bank_acc_req_export_run($s_lote=NULL)
	{
		// Identifica el sub-modulo
		$this->submodule = "PRES";

		// Enlaza el archivo de fondafa con el de CRM haciendo filtro de aquellos que hayan sido procesado 
		// exitosamente y que no se les haya asignado aun la cuenta bancaria
		$sql = "SELECT 
						ACCO.IBS_CUSCUN, 
						ACCO.IDNAME, 

						PRES.ID FONC_ID, 
						PRES.LEGAL_TYPE VZLA_NAC,
						PRES.IDENTIFICATION,
						PRES.LASTNAME,
						PRES.SECOND_LASTNAME,
						PRES.FIRSTNAME,
						PRES.SECONDNAME,

						FICO.BRANCH COMPLOC_CODE,

						CASE PRES.VZ_BK_PROD_CODE
							WHEN '' THEN TTPA.VZ_BK_PROD_CODE 
							WHEN NULL THEN TTPA.VZ_BK_PROD_CODE 
							ELSE PRES.VZ_BK_PROD_CODE
						END VZ_BK_PROD_CODE, 

						CASE PRES.VZ_BK_PROD_TYPE 
							WHEN '' THEN TTPA.VZ_BK_PROD_TYPE 
							WHEN NULL THEN TTPA.VZ_BK_PROD_TYPE 
							ELSE PRES.VZ_BK_PROD_TYPE
						END VZ_BK_PROD_TYPE

						FROM $this->presname PRES 
						LEFT JOIN $this->acconame ACCO ON ACCO.IDENTIFICATION = CONCAT(PRES.LEGAL_TYPE, PRES.IDENTIFICATION)
						LEFT JOIN $this->ficoname FICO ON PRES.CONTRACT_CODE = FICO.IDCODE
						LEFT JOIN $this->ttpaname TTPA ON FICO.FI_TYPE = TTPA.FI_TYPE AND FICO.CONTRACT_TYPE = TTPA.CONTRACT_TYPE
					WHERE 
						PRES.REC_STATUS = 'RUN'
						AND ACCO.IBS_CUSCUN <> ''
						AND PRES.PRES_OPERATION_TYPE IN ('IN')
						AND (PRES.BANK_ACCOUNT_NO = '' OR PRES.BANK_ACCOUNT_NO IS NULL)
				";
		// Eventual filtro x lotes
		if($s_lote!=NULL) $sql .= " AND PRES.CUST_FILEID = '$s_lote'";
//echo "SQL=$sql<BR>";

		/*
		 * CODE_PRES_LBL_TITACCEXP
		 * EMPLOYEE SEVERANCES: BANK ACCOUNT CREATION REQUEST FILE GENERATION
		 * PRESTACIONES SOCIALES: GENERACION DE SOLICITUD DE CREACION DE CUENTAS BANCARIAS
		 */
		$v_response = $this->bank_acc_req_export_run(dict("CODE_PRES_LBL_TITACCEXP"), 
			$this->fon_acc_req_exprt_dir, $sql, $this->presname, $s_lote);

		// Load the sockets interface (just in case)
		$this->massive_socket_ondemand_loader();

		// Devuelve el resultado de bank_acc_req_export_run()
		return $v_response;

	} // Method End

	/*
	  * Importacion del archivo que viene de vuelta como respuesta a la solicitud de ctas. de banco para los particiopantes de Prestaciones Sociales
	  * Para ser llamado desde el Menu
	  */
	function prestaciones_bank_acc_req_file_import($filename=NULL)
	{
		// Identifica el sub-modulo
		$this->submodule = "PRES";

		$this->bank_acc_req_import_var_selector($this->prestaciones_bank_acc_req_import_schedule);
		return $this->gen_bank_acc_req_file_import($filename);
	} // Method End

	/*
	  * Importacion del archivo que viene de vuelta como respuesta a la solicitud  de ctas. de banco para los participantes de Prestaciones Sociales
	  * A ser llamado desde el motor de procesos
	  */
	function prestaciones_bank_acc_req_file_import_doitnow($s_import_filename)
	{
		// Identifica el sub-modulo
		$this->submodule = "PRES";

		$this->bank_acc_req_import_var_selector($this->prestaciones_bank_acc_req_import_schedule);
		return $this->gen_bank_acc_req_file_import_doitnow($s_import_filename);
	} // Method End

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	* Get a List item by its description in uppercase
	*/
	var $ar_unexistent_list_elements;
	function getListItemByDescUpCase($listcode, $itemdesc, $lang) {
		global $db;
		if(!is_array($this->ar_unexistent_list_elements)) $this->ar_unexistent_list_elements = array();
		if(!isset($this->ar_unexistent_list_elements[$listcode])) $this->ar_unexistent_list_elements[$listcode] = array();
		if($this->debug) echoLog ("getListItemByDescUpCase = $listcode, $itemdesc");
		//$itemdesc = strtoupper($itemdesc);
		if($this->debug)  ClxCommon::$db->debug=true;
		if(isset($this->ar_unexistent_list_elements[$listcode]["$itemdesc"])) {
			// Take it from previous searches. It speeds up this tedious secuential search
			$item = $this->ar_unexistent_list_elements[$listcode]["$itemdesc"];
		} else {
			$sql = "
				SELECT 
					LISTITEMS.IDCODE
				FROM 
					CLX_DB_LIST_ITEMS LISTITEMS
						LEFT JOIN CLX_DICTIONARY DICT ON 
							DICT.ENTRY = LISTITEMS.idname 
							AND LANGUAGE = '$lang'
				WHERE 
					LISTITEMS.LISTCODE='$listcode' 
					AND UPPER(DICT.VALUE) LIKE UPPER('$itemdesc') 
					AND LISTITEMS.INACTIVE = 0;
				";
			$results =  ClxCommon::$db->executeQuery($sql);
			$item = '';
			if($record =  ClxCommon::$db->getNextRecord($results)) {
				$item = $record['IDCODE'];
			}
			$this->ar_unexistent_list_elements[$listcode]["$itemdesc"] = $item;
		}
		if($this->debug)  ClxCommon::$db->debug=false;
		return $item;
	} // Method end

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////// SIMULACION DE LAS INTERFACES ///////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function simulacion_ibs_interfaz_clientes($s_tipo_persona)
	{
echo "entro simulacion_ibs_interfaz_clientes($s_tipo_persona)<br>";

		$s_import_filename = companyParameter(
					'EIBS_CLIEX_FILESPEC_'.$s_tipo_persona, 
					$this->s_comp_code);
		$s_fon_acc_req_exprt_dir = companyParameter(
					'EIBS_CLIEX_RESP_FILESPEC_'.$s_tipo_persona, 
					$this->s_comp_code);
		$s_fon_acc_req_imprt_dir = IBS_MASSIVE_CLIENT_CREATION_FILENAME;
		if($s_tipo_persona == 'I') {
			$msg_code = S_CLI_SCKTCODE_INDIVIDUAL;
			$titulo = 'CLIENTES PERSONAS NATURALES';
		} else {
			$msg_code = S_CLI_SCKTCODE_COMPANY;
			$titulo = 'CLIENTES PERSONAS JURIDICAS';
		}
		$random_gen_fieldname = 'IBS_CUSCUN';
		$random_num_range = 99999;
		$n_len_code = 5;
		return $this->simulacion_generic_export_run(
						$titulo,
						$s_import_filename, 
						$s_fon_acc_req_imprt_dir, 
						$s_fon_acc_req_exprt_dir, 
						$msg_code, 
						$random_gen_fieldname,
						$random_num_range,
						$n_len_code);
	}

	function simulacion_ibs_interfaz_cuentas()
	{
		$s_import_filename = $this->fon_acc_req_exprt_dir;
		$s_fon_acc_req_exprt_dir = companyParameter('FONDAFA_ACC_REQ_IMPRT_FILE', $s_comp_code);
		$s_fon_acc_req_imprt_dir = IBS_MASSIVE_BACKACT_CREATION_FILENAME;
		$msg_code = BANK_ACC_REQ_RECORD_DEFINITION_CODE;
		$random_gen_fieldname = 'BACCCODE';
		$random_num_range = 9999999999;
		$n_len_code = 10;
		$titulo = 'CUENTAS DE BANCO';
		return $this->simulacion_generic_export_run(
						$titulo,
						$s_import_filename, 
						$s_fon_acc_req_imprt_dir, 
						$s_fon_acc_req_exprt_dir, 
						$msg_code, 
						$random_gen_fieldname,
						$random_num_range,
						$n_len_code);
	}

	function simulacion_generic_export_run(
		$titulo,
		$s_import_filename,
		$s_fon_acc_req_imprt_dir, 
		$s_fon_acc_req_exprt_dir, 
		$msg_code, 
		$random_gen_fieldname,
		$random_num_range,
		$n_len_code)
	{
//$this->debug = true;
		$contents = '';
		if($this->debug) echoLog("simulacion_ibs_bank_acc_export_run");

		$contents .= $this->titulo("<BR><BR>SIMULACION DE " . $titulo) . "<BR><BR>";

		//echoLog("Lote: $this->s_lote");

		// Abre el archivo de salida
		$contents .= "ENTRADA: $s_import_filename<br>";
		$contents .= "TEMPORAL: $s_fon_acc_req_imprt_dir<br>";
		$contents .= "SALIDA: $s_fon_acc_req_exprt_dir<br>";

		$ar_response = $this->fondafa_bank_acc_req_file_ops('open', $s_fon_acc_req_imprt_dir);
		if($ar_response['error'] == true) {
			$contents .= $ar_response['errormsg'];
			return ($contents);
		}

		// Interfaz con las funciones para construir la estructura del registro en el archivo plano
		$EBSK = getTool("EBSK");
		$EBSK->debug = $this->debug;
		$EBSK->tfields_only = true;
		$EBSK->remove_decimal_point = true;

		if(!file_exists($s_import_filename)) {
			// There's nothing to import
			$contents .= dict("GEN_ERR_FILE_NOT_FOUND") . ": " . $s_import_filename;
			return $contents;
		} else {
			$contents .= $s_import_filename . "<br>";
		}

		if(!class_exists('clx_file')) require kPathToWebSite . "classes/clx_file.php";
		$o_clx_file = new clx_file($s_import_filename, 'r');
		$o_clx_file->open();
		if($o_clx_file->error) {
			$contents .= ($o_clx_file->errorMsg);
			return $contents;
		}

		$buffer = $o_clx_file->read_line();
		$i_proc_counter = 0;
		while(!$o_clx_file->eof) {

			$i_proc_counter++;
			if($buffer == '') {
				$buffer = $o_clx_file->read_line();
				continue;
			}
			// Reads flat file line
			$ar_record_original = $EBSK->readMessage($msg_code, $buffer);
			if($this->debug) echoLog(debug_dump('$i_proc_counter - ar_record', $ar_record));

			// Asinga un array sencillo con los valores de los campos leidos desde el archivo de texto
			$record = $this->eibs_def_array_directval_assing($ar_record_original);

			// Generacion del numero de cuentas de 10 digitos
			//mt_srand(time());
			list($usec, $sec) = explode(' ', microtime());
			mt_srand( (10000000000 * (float)$usec) ^ (float)$sec );
			$record[$random_gen_fieldname] = (mt_rand()%$random_num_range);
			if($n_len_code != NULL) {
				$record[$random_gen_fieldname] = fija_izq($record[$random_gen_fieldname], 
													$n_len_code, '0');
			}
			
			$ar_socket_line = $EBSK->createMessage($msg_code, $record);

			// Como hizo modificaciones en el array que se usa como fuenta para generar la linea de texto plano
			// Asigna la propiedad de la clase IBS
			$EBSK->msgrecord = $ar_socket_line;

			// Genera la linea de salida (texto plano de longitud fija)
			$s_socket_line = $EBSK->toString();
			if($this->debug) echoLog("<B>$s_socket_line</B><BR>");

			// Escribe la linea en el archivo de salida
			$ar_response = $this->fondafa_bank_acc_req_file_ops('write', $s_socket_line);

			// Text for output
			$contents .= $i_proc_counter . " = ";
			if($ar_response['error'] == true) {
				// Al haber problemas escribiendo el archivo de salida, termina el proceso
				$contents .= $ar_response['errormsg'];
				$this->fondafa_bank_acc_req_file_ops('close');
				return ($contents);
			} else {
				$contents .= dict('CODE_FONDAFA_MSG_OK');
			}
			$contents .= "<br>";

			// Reads next flat file line
			$buffer = $o_clx_file->read_line();
		}

		// close input file
		$o_clx_file->close();
		if($o_clx_file->error) {
			$contents .= ($o_clx_file->errorMsg);
		}

		// Cierra el archivo de salida
		$this->fondafa_bank_acc_req_file_ops('close');
		if(!copy($s_fon_acc_req_imprt_dir, $s_fon_acc_req_exprt_dir)) {
			/*
			 * GEN_ERR_FILESYS_COPYFAIL
			 * Error copying from file  ^1 to file ^2
			 * Error realizando la copia del archivo ^1 al archivo ^2
			 */
			$contents .= 
				"<BR>" .
				dict('GEN_ERR_FILESYS_COPYFAIL', 
				$s_fon_acc_req_imprt_dir, $s_fon_acc_req_exprt_dir);
		} else {
			// Elimina el temporal
			unlink($s_fon_acc_req_imprt_dir);
			// Elimina el archivo de entrada
			unlink ($s_import_filename);
		}

		$contents .= "<br>";
		return $contents;
	} // Method end

	function simulacion_generic_export_scheduler()
	{
		//Create Process Schedule Schedule
		$s_title = "SIMULADOR DE INTERFACES DE IBS";
		$s_process_code = "IBS_SIMUL_01";
		$ar_pars_2_send = array();
		$contents = $this->create_proc_sched_sched($s_title, $s_process_code, 
								$ar_pars_2_send);
		return $contents;
	}

	//////////////////////////////////////////

} // Class End


/*
  * Si el codigo de la cuenta CRM del cliente fue creado correctamente en el IBS, asigna el estatus que le permite realizar la solicitud de la cta de banco.
  * Lo que hace es buscar los registros de FONC cuya cuenta CRM es la que le fue asignado el CUSCUN y cuyo estatos sea "pemdiente x asignar cod. en IBS" 
  * y les cambia el estatus.
  */
function fondafa_asigna_status_crm(&$ar_pars)
{
	global $db;
	$ar_pars['submodulo'] = "";
	// $ar_pars['error'] = true si hubo algun error
	// $ar_pars['errormsg'] = eventual mensaje de error
	// $ar_pars['ibs_cuscun'] = codigo asignado x ibs al cliente, en caso de no haber ningun error
	// $ar_pars['idcode'] = codigo clientix del cliente,tabla,ID de la tabla
	// $ar_pars['line_status'] = 1 si hubo error, 0 si todo ok
	if($ar_pars['error'] == false) {
		$ar_fonc_record = array();
		$ar_fonc_record["REC_STATUS"] = 'RUN';
		list($s_idcode, $s_tablename, $s_id_tablename, $s_lote) = 
				explode(',', $ar_pars['idcode']);
		$s_tablename = trim($s_tablename);
		if($s_tablename == "") {
			/**
			  * GEN_ERR_IBS_ASCRM_INCON01
			  * CRM acc. status assigment: table name is empty. ID = ^1
			  * Error en la asignacin status cta. CRM: nombre de la tabla esta vacio. ID = ^1
			  **/
			$ar_pars['error'] = true;
			$ar_pars['errormsg'] = dict('GEN_ERR_IBS_ASCRM_INCON01', $ar_pars['idcode']);
		} else {
			$ar_pars['submodulo'] = ($s_tablename == "PRES" ? "PRES" : "FON");
			$b_update = true;
			if($s_tablename != "PRES" && $s_tablename != "FONC") {
				$ar_pars['submodulo'] = $s_tablename;
				$b_update = false;
			}
			if($b_update) {
				 ClxCommon::$db->updateRecord(
						tableName($s_tablename), 
						$ar_fonc_record, 
						"ID = '" . $s_id_tablename  . "' AND REC_STATUS = 'RWOC'"
					);
			}
		}
	}
	return $ar_pars;
} // Function End

/*
  * Usado para poder mostrar las excepciones de unas imports especificas (las cuales se filtran por su cdigo o cepa del mismo)
  */
function import_exceptions_show($s_filter)
{
echo "
<html>
<body>
<form id=\"fly\" name=\"fly\" action=\"tool.php\" method=\"post\">
<input type=\"hidden\" name=\"to\" value=\"DBIM\">
<input type=\"hidden\" name=\"ac\" value=\"FILTER\">
<input type=\"hidden\" name=\"confirm\" value=\"1\">
<input type=\"hidden\" name=\"DBIM_idcode\" value=\"$s_filter\">
</form>
<script language=\"Javascript\">document.fly.submit();</script>
</body>
</html>
";
exit;
}

/*
  * Fija el string a un numero de espacios especificos rellenando a la izquierda (por defecto rellena con espacios en blanco)
  */
function fija_izq($s_str, $n_len, $c_filler = ' ')
{
	return substr(str_repeat($c_filler, $n_len) . trim($s_str), -$n_len);
} // Function End

/*

F O N D A F A

*****************************************************
MENU
*****************************************************
Nombre: Import Texto Plano
Descripcin: Importacin del archivo de enviado por Fondafa con los datos de los beneficiarios de los crditos. 
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); $contents .= $a->fondafa_selec_imprt();

*****************************************************
MENU
*****************************************************
Nombre: Consulta del Import
Descripcin: Permite ver el resultado de la Importacin de Clientes desde el archivo separado por tabuladores
Cdigo de Mdulo: FIDU
Listado: FONC

*****************************************************
MENU
*****************************************************
Nombre: Creacin Ctas. CRM
Descripcin: Creacin de las cuentas CRM desde la tabla que almacena el resultado del Import desde el archivo plano separado por tabuladores
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); $contents .= $a->fondafa_client_import();

*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: FON_CIM
Nombre: FONDAFA: Creacin de Cuentas CRM
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); echo $a->fondafa_client_import_run($parameters['LANGUAGE'], $parameters['USERNAME'], $parameters['VZ_BK_PROD_CODE'], $parameters['VZ_BK_PROD_TYPE'], $parameters['CUST_FILEID']);

*****************************************************
MENU
*****************************************************
Nombre: Solicitud Ctas Banco
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); $contents .= $a->fondafa_bank_acc_req_export();

*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: FON_BAREX
Nombre: FONDAFA: Solicitud Ctas Banco
Descripcin: Exportacin del archivo para solicitar la asignacin de las cuentas de banco al IBS mediante el formato utilizado por la aplicacin desarrollada en el BAV
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); echo $a->fondafa_bank_acc_req_export_run($parameters['VZ_BK_PROD_CODE'], $parameters['VZ_BK_PROD_TYPE'], $parameters['CUST_FILEID']);

*****************************************************
MENU
*****************************************************
Nombre: Asignacin Ctas Banco
Descripcin: Lee el archivo que genera IBS en respuesta a la solicitud de asignacin de cuentas para beneficiarios de Fondafa
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); $contents .= $a->fondafa_bank_acc_req_file_import();


*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: FON_BARIM
Nombre: FONDAFA: Asignacin Ctas Banco
Descripcin: Importacin del archivo que devuelve la aplicacin del IBS desarrollada en el BAV con las cuentas de banco asignadas para cada cliente IBS.
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); echo $a->prestaciones_bank_acc_req_file_import_doitnow($parameters['ANYFILE']);


*****************************************************
MENU
*****************************************************
Nombre: Export Clientes a Fondafa
Descripcin: Exportacin del archivo separado por tabuladores con la asignacin de las cuentas de banco para los beneficiarios, a ser enviado de vuelta a Fondafa.
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa('BAV'); $contents .= $a->fondafa_show_export_01_screen('FONC_01');

*****************************************************
PROCESS ENGINE
*****************************************************

Proceso:

Cdigo 	IBS_MASCLIEX_MON
Nombre Corto 	IBS : massive client creation monitor / IBS : Monitor de creacin masiva de clientes
Modulo Caja	FIDU
Descripcin	Monitor del proceso de creacin masiva de clientes desde IBS

Seccin del Proceso
Cdigo 	AUTO
Nombre Corto 	Main Section
Is Main Section 	S
Estado 	Activo
Proceso 	IBS_MASCLIEX_MON, IBS : massive client creation monitor
Descripcin 	 

Vista de Paso del Proceso
Seccin 	IBS_MASCLIEX_MON, Main Section
Nombre Corto 	PHP Code
Nmero de Sequencia 	1
Code Type 	Cdigo PHP
Do Seccin 	 
Do Seccin Tipo 	NOT
Biblioteca de Cdigo 	FONDAFA
Code, Library Call, or Do Section Condition 	$a = new fondafa(); $a->debug=false; echo $a->recibe_ibs_clients_cuscun();
Fecha de Creacin 	Dec 07, 2006 18:35:00
ltima Modificacin 	Dec 07, 2006 18:35:00

Cronograma del Proceso:

Cdigo 	IBS_MASCLIEX_MON
Nombre Corto 	IBS : massive client creation monitor / IBS : Monitor de creacin masiva de clientes
Proceso 	IBS_MASCLIEX_MON, IBS : massive client creation monitor
Estado 	Activo
Notas 	
Opciones de Cronograma
Fecha de Inicio 	today
Recurrencia 	Cada Hora
Prxima Ejecucin 	 
Hora prxima ejecucin 	
Opciones Adicionales
Proceso de Dependencia 	
Mostrar 	S
Depurador 	S


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

P R E S T A C I O N E S   S O C I A L E S 

*****************************************************
MENU
*****************************************************
Nombre: Creacin Clientes IBS
Descripcin: Creacin de clientes en IBS a partir de los registros de incorporacin de Prestaciones Sociales
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); $contents .= $a->prestaciones_client_import();

*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: PRES_CIM
Nombre: Prestaciones Sociales: Creacin de Clientes en IBS
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); echo $a->prestaciones_client_import_run($parameters['LANGUAGE'], $parameters['USERNAME'], $parameters['CUST_FILEID']);

*****************************************************
MENU
*****************************************************
Nombre: Solicitud Ctas Banco
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); $contents .= $a->prestaciones_bank_acc_req_export();

*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: PRES_BAREX
Nombre: Prestaciones Sociales: Solicitud Ctas Banco
Descripcin: Exportacin del archivo para solicitar la asignacin de las cuentas de banco al IBS mediante el formato utilizado por la aplicacin desarrollada en el BAV
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); echo $a->prestaciones_bank_acc_req_export_run($parameters['CUST_FILEID']);

*****************************************************
MENU
*****************************************************
Nombre: Asignacin Ctas Banco
Descripcin: Importacin del archivo que genera IBS en respuesta a la solicitud de asignacin de cuentas para particiopantes de Prestaciones Sociales
Cdigo de Mdulo: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); $contents .= $a->prestaciones_bank_acc_req_file_import();

*****************************************************
PROCESS ENGINE
*****************************************************
Cdigo: PRES_BARIM
Nombre: Prestaciones Sociales: Asignacin Ctas. Banco
Descripcin: Importacin del archivo que genera IBS en respuesta a la solicitud de asignacin de cuentas para participantes de Prestaciones Sociales
Mdulo Caja: FIDU
Tipo: Code Library
Ventana: Misma Ventana
Lenguaje: PHP
Biblioteca: FONDAFA
Llamada: $a = new fondafa(); echo $a->prestaciones_bank_acc_req_file_import_doitnow($parameters['ANYFILE']);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Para ver como se generan una transaccin (para el caso de las liquidaciones):

LIBRERIA INVE_utilities.php

METODO tax_fees($record)

				if($record['TAX_AMT']<>0.00){
					$rec = array();
					$rec['IDNAME'] 			= $inprrec['TAX_TRANS_CODE'];
					$rec['PORTFOLIO_CODE'] 	= $record['PORTFOLIO_CODE'];
					$rec['INVESTPROD_CODE'] = $record['INVESTPROD_CODE'];
					$rec['CONTRACT_CODE'] 	= $result['CONTRACT_CODE'];
					$rec['EFFTDATE'] 		= $record['EFFTDATE'];
					$rec['CURRENCY_CODE'] 	= $comprec['CURRENCY_CODE'];
					$rec['TRANS_AMT'] 		= rounder(bcmul($record['TAX_AMT'], $participation),$this->rounding);
					$rec['BASE_TRANS_AMT'] 	= $rec['TRANS_AMT'];
                    $rec['ASSET_CODE'] 	 	= '';
                    $rec['CASH_ASSET_CODE']	= $result['CASH_ASSET_CODE'];//$cash_code;
					$rec['PORTFOLIO_CODE']  = $record['PORTFOLIO_CODE'];
					$rec['INVTRANS_CODE'] 	= $record['IDCODE'];
					$rec['EXCHANGE_RT'] 	= '1';
					$rec['EFFTDATE']		= $record['EFFTDATE'];
					$rec['TRANSTBL_CODE'] 	= $inprrec['TAX_TRANS_CODE'];
					$rec['INVTRANS_CODE'] 	= $record['IDCODE'];//Investment Transaction Code
					//Creating Contract Transaction
					$trans = new fidu_transaction();
					$rec = $trans->buildTransaction($rec);
					$trans->portfolio_redistribution = true;
					$trans->approveStatusByTranscode($rec['IDCODE']);
				}//end tax amount
*/

/*
SQL PARA AGREGAR EL LEGAL_TYPE COMO PRIMER CARACTER AL IDENTIFICACION EN ACCO:
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = CONCAT(ACCO.LEGAL_TYPE,ACCO.IDENTIFICATION)
Nota: se debe correr solo una vez

SELECT `IDNAME`,`IDENTIFICATION` FROM `CRM_ACCOUNTS` 
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, 'JJ-', 'J')
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, 'GG-', 'G')
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, 'RG-', 'G')
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, 'RJ-', 'J')
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, 'JG-', 'G')
UPDATE `CRM_ACCOUNTS` ACCO SET ACCO.IDENTIFICATION = REPLACE(ACCO.IDENTIFICATION, '-', '')
*/
/*
// Para las pruebas, se debe vaciar los archivos primero...
DELETE FROM CRM_ACCOUNTS WHERE CDATE LIKE "%2006-11-30%";
UPDATE FIDU_FONDAFA_CLIENTES SET REC_STATUS = 'IDLE', ACCOUNTCODE = '', BANKAC_CODE = '';
DELETE FROM FIDU_BANK_ACCOUNTS WHERE IDNAME LIKE "%FONDAFA: %";
*/

?>