<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-05-23 16:35:51 -0400 (Mon, 23 May 2016) $
 * @version        $Rev: 8269 $
 *
 * CHANGE LOG
 * 2009/09/02 Included svn prop
 */
class fidu_prestaciones {

    var $modulecode;  // Module Code
    var $compname;   // Contracts
    var $ficoname;   // Contracts
    var $fiasname;   // Assets
    var $inprname;   // Investment Products
    var $contents;  // Html Source
    var $keepLog = true;
    var $debug = false;
    var $datestamp = '';
    var $field_delimiter = 't';
    //Import Parameters
    var $filename = '';
    var $import_table = '';
    var $import_type = ''; //Import Types: TRANS - Transacciones, INCO - Incorporaciones
    var $import_folder = 'temp/';
    var $header_row = ''; //Header rows on imports
    var $file_fields = array();
    var $import_types = array();
    var $import_exclusion_parameters = array(); //Usado para validar cuanto puede permitirse por tipo de archivos.
    var $allowances = array();
    var $header_err = array(); //Header errors, used on import report
    var $FIRE_lib;

    /**
     * Constructor
     */
    function __construct() {

        $this->datestamp = date('YmdHis');
        $this->modulecode = 'FIPR'; // Module
        $this->import_table = tableName('PRES');
        multiTableName($this, array('FICO', 'COMP', 'FIAS', 'INPR', 'GLAC', 'FIDA',
            'JELN', 'IETB', 'JEHD', 'ACCO', 'FIPA', 'FIBT',
            'FIAT', 'PRES', 'GDVW', 'FIBK', 'PRPT', 'DYCL'));
        $this->import_types = array('TRANS' => dict('GEN_LBL_TRANS'), 'INCO' => dict('GEN_LBL_INCORPORACION'));
        $this->contents = '';

        //define how to process
        /*
          BLOCK_ALL - Block all errors
          BLOCK_INCOME - Block Income Transactions
          BLOCK_WITHDRAWAL - Block withdrawal Trans
          BLOCK_NONE - Allow all transactions
         */
        $this->allowances = companyParameter('PRES_IMPORT_COND');
        if (empty($this->allowances)) {
            $this->allowances = 'BLOCK_ALL';
        }
        $this->allow_partial_imports = array('BLOCK_ALL' => false,
            'BLOCK_INCOME' => array('AP', 'AM', 'IN'),
            'BLOCK_WITHDRAWAL' => array('DI', 'AN', 'PR'),
            'BLOCK_NONE' => true);
    }

    function source() {
        return $this->contents;
    }

    //-------------------------------------------------------------------
    // Importador de archivo de Prestaciones Sociales V1
    //-------------------------------------------------------------------
    function prompt($formcode) {//Pres Import Form
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = UserRequest::$request['it'];

        $this->file_fields = array();
        //RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        UserRequest::$post['RTBL_ID'] = ''; //Entrada en blanco para evitar warning en object file.
        //Prepare Valiues
        if (!empty($record['confirm'])) {
            if ($EDIT->checkForm2($msg, $formrec)) {
                if (empty(UserRequest::$post['RTBL_localfile'])) {

                    $filename_tmp = $_FILES['RTBL_TEXT_FILE']['tmp_name'];
                    $filename = $this->import_folder . $_FILES['RTBL_TEXT_FILE']['name'];
                    if (!move_uploaded_file($filename_tmp, $filename)) {
                        addMessage(dict('GEN_ERR_UPLOADFAIL'));
                    } else {
                        //$this->import_type = UserRequest::$post['RTBL_PRES_IMP_TYPE'];
                        $this->saveFile($filename);
                        return;
                        //Upload OK Start Procesing FIle
                    }
                } else {
                    $filename = UserRequest::$post['RTBL_localfile'];
                }
            }
        }
        $this->print_btn = false;

        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
        $this->contents = $form->source();

        return (empty($record['confirm']) || !empty($msg)) ? false : true;
    }

    function saveFile($filename = '') {


        $this->filename = $filename;
        //$file_md5 = md5($this->filename);
        $file_md5 = $this->filename;
        if ($this->debug)
            $this->contents .= 'File Load Completed: <a href="' . $this->filename . '" target="_blank">' . $filename . '</a>, Import Type:' . $this->import_type;
        $lote_tmp = str_replace('.', '', microtime(true));

        if ($this->debug)
            echoLog('Starting Pres Interfase: ' . $this->filename);
        if (!file_exists($filename)) {
            if ($this->debug)
                echoLog('Error, File not found');
            return;
        }

        //test if file already loaded. if idle or error then replace old records and start over. any other status just fail.
        if (!$this->validate_reprocesing($file_md5))
            return;

        //Clearing all Imports for reprocesing.
        ClxCommon::$db->executeQuery("DELETE FROM $this->import_table WHERE FILE_NAME ='" . $file_md5 . "' AND REC_STATUS IN ('ERRO','IDLE') "); //'IDLE',
        //Init log file
        $log = new clx_file($this->filename . 'log.txt', 'w');
        $log->open();
        $log->write('');
        $log->close();

        //Star Read

        $a = new clx_file($this->filename, 'r');
        $a->open();
        $i = CLX_NUM_ZERO;
        while (($row = $a->read_line()) == true) {
            $i++;
            $row = trim($row);
            if (strlen($row) == CLX_NUM_ZERO)
                continue;
            if ($i == 1) {//Header Information for future validations
                $this->header_row = $row;
                $this->header = explode('t', $this->header_row);
                if ($this->debug)
                    echoLog('Header row saved:' . $this->header_row);
                continue;
            }
            $data_line = $this->format_data_line($row, $i);
            $data_line['CUST_FILEID'] = $lote_tmp;
            $data_line['FILE_NAME'] = $file_md5;


            ClxFreeReturn($this->validate($data_line, $i));
            if (!empty($data_line)) {
                ClxCommon::$db->createRecord($this->import_table, $data_line);
            }
            clearMessage();
        }

        //Final Validations
        ClxFreeReturn($this->validate_header($file_md5));

        //Send output to user
        $this->import_report($file_md5);
    }

    /**
     * Retorna el numero de secuencia del lote desde la tabla de codigos de prestaciones
     * Numero secuencial que debe colcarse en tabla IDCODES BAJO TABLA PRES
     */
    function get_next_lote() {


        $record = array('IDCODE' => 'AUTO');
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        setCreationIdCode($record, 'PRES');
        return $record['IDCODE'];
    }

    /**
     * Format Record
     */
    function format_data_line($line, $lineno) {

        $import = explode($this->field_delimiter, $line);
        $qty = count($import);

        if ($qty == CLX_NUM_NINE || $qty == CLX_NUM_SIX)
            $import_type = 'TRANS'; //Anticipos
        elseif ($qty == CLX_NUM_14)
            $import_type = 'INCO'; //Aportes
        else
            $import_type = '';
        $this->import_type = $import_type;

        $record = array();
        switch ($import_type) {
            case 'TRANS':
                $record = array('CONTRACT_CODE' => $import[CLX_NUM_ONE],
                    'PRES_OPERATION_TYPE' => $import[CLX_NUM_TWO], // => AN,
                    'LEGAL_TYPE' => $import[CLX_NUM_THREE], // => V,
                    'IDENTIFICATION' => $import[CLX_NUM_FOUR], // => 208010136,
                    'TRANS_AMT' => $import[CLX_NUM_FIVE], // => 50000.00,
                    'BANK_ACCOUNT_NO' => ($qty == CLX_NUM_NINE) ? $import[CLX_NUM_SIX] : '', // => 0,
                    'DISBURSEMENT_TYPE' => ($qty == CLX_NUM_NINE) ? $import[CLX_NUM_SEVEN] : '', // => CH,
                    'CAPITALIZATION_PCT' => CLX_NUM_ZERO,
                    'CAPPAYMENT_PCT' => CLX_NUM_ZERO,
                    'ADVANCE_LOAN_REASON' => ($qty == CLX_NUM_SIX) ? $import[CLX_NUM_8] : '', // => A108-A,
                    'REC_STATUS' => 'IDLE',
                    'COMMENTS' => '',
                    'BANK_PROD_CODE' => '', //codigo de producto
                    'BANK_PROD_TYPE' => '', //Tipo de producto
                    'AVAILABLE_AMT' => '0',
                    'TRANS_SOURCE' => 'IM');
                /*
                  CONTRACT_CODE		CODIGO CONTRATO
                  PRES_OPERATION_TYPE	TIPO DE TRANSACCION
                  LEGAL_TYPE			NACIONALIDAD
                  IDENTIFICATION		NUMERO DE CEDULA  DE IDENTIDAD
                  TRANS_AMT			MONTO DE LA TRANSACCION
                  BANK_ACCOUNT_NO		NUMERO DE CUENTA BANCARIA
                  DISBURSEMENT_TYPE	FORMA DE DESEMBOLSO
                  REFERENCE		CONCEPTO RETIRO
                  PRODUCT_TYPE		TIPO DE PRODUCTO
                  PRODUCT_CODE		SUB-PRODUCTO
                 */
                break;
            case 'INCO':
                $record = array('CONTRACT_CODE' => $import[CLX_NUM_ONE],
                    'LEGAL_TYPE' => $import[CLX_NUM_TWO], // => V,
                    'PRES_OPERATION_TYPE' => 'IN', //$import[3],// => AN,
                    'IDENTIFICATION' => $import[CLX_NUM_THREE], // => 208010136,
                    'LASTNAME' => $import[CLX_NUM_FOUR], // => 50000.00,
                    'SECOND_LASTNAME' => $import[CLX_NUM_FIVE], // => 0,
                    'FIRSTNAME' => $import[CLX_NUM_SIX], // => CH,
                    'SECONDNAME' => $import[CLX_NUM_SEVEN], // => A108-A,
                    'TRANS_AMT' => $import[CLX_NUM_8], // => 50000.00,
                    'CAPITALIZATION_PCT' => $import[CLX_NUM_NINE], // => 50000.00,
                    'CAPPAYMENT_PCT' => (CLX_NUM_HUNDRED - $import[CLX_NUM_TEN]),
                    //'CAPPAYMENT_PCT'		=> $import[9],// => 50000.00,
                    'BANK_ACCOUNT_NO' => $import[CLX_NUM_11], // => 0,
                    'ACDEPT_CODE' => $import[CLX_NUM_12], // => CH,
                    'BANK_PROD_CODE' => $import[CLX_NUM_13], //codigo de producto
                    'BANK_PROD_TYPE' => $import[CLX_NUM_14], //Tipo de producto
                    'ADVANCE_LOAN_REASON' => '',
                    'REC_STATUS' => 'IDLE',
                    'COMMENTS' => '',
                    'AVAILABLE_AMT' => '0',
                    'TRANS_SOURCE' => 'IM');
                /*
                  CONTRACT_CODE		CODIGO CONTRATO
                  LEGAL_TYPE		NACIONALIDAD
                  IDENTIFICATION		NUMERO DE CEDULA  DE IDENTIDAD
                  LASTNAME		PRIMER APELLIDO
                  SECOND_LASTNAME		SEGUNDO APELLIDO
                  FIRSTNAME		PRIMER NOMBRE
                  SECOND_NAME		SEGUNDO NOMBRE
                  TRANS_AMT		MONTO DE LA TRANSACCION
                  CAPITALIZATION_PCT	PROCENTAJE CAPITALIZACION DE GANANCIAS
                  BANK_ACCOUNT_NO		NUMERO DE CUENTA BANCARIA
                  ACDEPT_CODE		CENTRO DE COSTO (EMPRESA)
                 */
                break;
            default:
                //nothing to do
                break;
        }//end switch

        return $record;
    }

//---------------------------------------------------------------------------------------------
// Validation Sections
//---------------------------------------------------------------------------------------------

    function validate_reprocesing($file_key) {


        $status = true;
        //test if file already loaded. if idle or error then replace old records and start over. any other status just fail.
        $qty = ClxCommon::$db->oneExistsRecords($this->import_table, "FILE_NAME ='" . $file_key . "' AND REC_STATUS NOT IN ('ERRO','IDLE') "); //'IDLE',
        if ($qty > 0) {
            //e cho Error. Archivo ya fue cargado
            /*
             * GEN_ERR_FILEALREADYDONE
             * File already completed, please change filename to import.
             * El archivo a importar ya fue procesado, favor cambiar el nombre del archivo si desea procesarlo nuevamente.
             */
            $this->contents = alert(dict('GEN_ERR_FILEALREADYDONE'));
            $status = false;
        }
        return $status;
    }

    /**
     * Header Validations
     */
    function validate_header($file_key) {


        $status = true;

        /*
          Definicion del encabezado
          Key Valor
          0 	IDENTIFICACION REGISTRO DE CABECERA
          1 	CODIGO CONTRATO
          2 	TOTAL REGISTROS ENVIADOS
          3 	TOTAL MONTOS
         */
        $this->header_err = array();
        $qty_total = ClxCommon::$db->countRecords($this->import_table, ' FILE_NAME = ' . singlequote($file_key)); //'IDLE',
        if ((int) $this->header[CLX_NUM_TWO] <> $qty_total) {//Verificando el total de los registros importados
            /*
             * GEN_ERR_TOTALROWINVALID
             * Total Rows dont match header count. please verify Import
             * El total de registros importados no coincide con el numero de registros de cabecera. favor verificar archivo.
             */
            $emsg = dict('GEN_ERR_TOTALROWINVALID') . 'r';
            $this->header_err[] = $emsg;
            $this->contents .= alert(dict('GEN_ERR_TOTALROWINVALID'));
            $status = false;
        }

        $qty_contract = ClxCommon::$db->countRecords($this->import_table, "CONTRACT_CODE = '" . $this->header[1] . "' AND FILE_NAME ='" . $file_key . '\''); //'IDLE',
        if ($qty_contract <> $qty_total) {//Verificando el total de los registros importados sea para el contrato seleccionado
            /*
             * GEN_ERR_CONTRACTMUSTBEONE
             * Only one contract per file, please verify
             * Solo es permitido un contrato
             */
            $emsg = dict('GEN_ERR_CONTRACTMUSTBEONE') . 'r';
            $this->contents .= alert(dict('GEN_ERR_CONTRACTMUSTBEONE'));
            $this->header_err[] = $emsg;
            $status = false;
        }

        $trans_total = ClxCommon::$db->getOne("SELECT SUM(TRANS_AMT) TRANS_AMT FROM $this->import_table WHERE FILE_NAME ='" . $file_key . "' GROUP BY FILE_NAME"); //'IDLE',
        if (bcadd('0', $trans_total) <> bcadd($this->header[2], '0')) {//Verificando el total de los registros importados sea para el contrato seleccionado
            /*
             * GEN_ERR_TOTALAMTINVALID
             * Total file donot match. Please verify amounts
             * Total de Transaccion(es) no coincide con el total reportado. Favor verificar.
             */
            $emsg = dict('GEN_ERR_TOTALAMTINVALID') . 'r';
            $this->contents .= alert(dict('GEN_ERR_TOTALAMTINVALID'));
            $this->header_err[] = $emsg;
            $status = false;
        }

        if (empty($status)) {
            ClxCommon::$db->executeQuery("UPDATE $this->import_table SET REC_STATUS = 'ERRO' WHERE FILE_NAME ='" . $file_key . '\'');
            return $status;
        }
        switch ($this->allowances) {
            case 'BLOCK_ALL'://no allowances
                $sql = 'SELECT COUNT(ID) FROM ' . $this->import_table . ' WHERE REC_STATUS = ' . singleQuote('ERRO') . ' AND FILE_NAME =' . singleQuote($file_key);
                $qty = ClxCommon::$db->getOne($sql);
                if ($qty > CLX_NUM_ZERO) {
                    ClxCommon::$db->executeQuery("UPDATE $this->import_table SET REC_STATUS = 'ERRO' WHERE FILE_NAME ='" . $file_key . '\'');
                    /*
                      GEN_ERR_NOERRORSALLOWED
                      No errors are allowed, please verify and try again.
                      No estan permitidos errores, favor verificar archivo y reprocesar.
                     */

                    $emsg = dict('GEN_ERR_NOERRORSALLOWED') . 'r';
                    $this->contents .= alert(dict('GEN_ERR_NOERRORSALLOWED'));
                    $this->header_err[] = $emsg;
                    $status = false;
                }
                break;
            case 'BLOCK_INCOME'://block if one error on income
                $sql = "SELECT COUNT(ID) FROM $this->import_table WHERE REC_STATUS = 'ERRO' AND FILE_NAME ='" . $file_key . "' AND PRES_OPERATION_TYPE IN ('" . implode("','", $this->allow_partial_imports['BLOCK_INCOME']) . "')";
                $qty = ClxCommon::$db->getOne($sql);
                if ($qty > CLX_NUM_ZERO) {
                    ClxCommon::$db->executeQuery("UPDATE $this->import_table SET REC_STATUS = 'ERRO' WHERE FILE_NAME ='" . $file_key . '\'');
                    /*
                      GEN_ERR_INCOMEERRNOTPERMITED
                      Errors on incomes are not permited, please verify and try again
                      Registros de ingresos con errores no estan permitidos. Favor verificar el archivo e intentar de nuevo
                     */
                    $emsg = dict('GEN_ERR_INCOMEERRNOTPERMITED') . 'r';
                    $this->contents .= alert(dict('GEN_ERR_INCOMEERRNOTPERMITED'));
                    $this->header_err[] = $emsg;
                    $status = false;
                }
                break;
            case 'BLOCK_WITHDRAWAL'://block if one error on withdrawal
                $sql = "SELECT COUNT(ID) FROM $this->import_table WHERE REC_STATUS = 'ERRO' AND FILE_NAME ='" . $file_key . "' AND PRES_OPERATION_TYPE IN ('" . implode("','", $this->allow_partial_imports['BLOCK_WITHDRAWAL']) . "')";
                $qty = ClxCommon::$db->getOne($sql);
                if ($qty > 0) {
                    ClxCommon::$db->executeQuery("UPDATE $this->import_table SET REC_STATUS = 'ERRO' WHERE FILE_NAME ='" . $file_key . '\'');
                    /*
                      GEN_ERR_WITHDRAWAL_ERRNOTPERMITED
                      Errors on withdrawals are not permited, please verify and try again
                      Registros de egresos con errores no estan permitidos. Favor verificar el archivo e intentar de nuevo
                     */
                    $emsg = dict('GEN_ERR_WITHDRAWALERRNOTPERMITED') . 'r';
                    $this->contents .= alert(dict('GEN_ERR_WITHDRAWALERRNOTPERMITED'));
                    $this->header_err[] = $emsg;
                    $status = false;
                }
                break;
            default:
                break;
        }//end swtich


        return $status;
    }

    /**
     * Record Validations
     */
    function validate(&$record, $line_no) {

        $msg = array();
        $status = true;
        $filekey = $record['FILE_NAME'];

        //Open Log file
        $log = new clx_file($this->filename . 'log.txt', 'a');
        $log->open();

        //Start Field Validations
        foreach ($record as $field => $field_value) {
            if (empty($this->file_fields[$field]))
                $this->file_fields[$field] = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME = \'' . $field . '\'');
            $fieldinstance = getToolObject('DBFT', $this->file_fields[$field]['FIELDTYPE']);
            $fieldinstance->validateImportField($msg, $this->file_fields[$field], $field_value);
            if (!empty($msg[$field])) {
                $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ', ' . $field . ':' . $field_value . ',' . $msg[$field] . 'r';
                $record['COMMENTS'] .= $emsg;
                $record['REC_STATUS'] = 'ERRO';
                $log->write($emsg);
            }
        }

        //Validar Operacion Duplicada en Lote
        $sql = "SELECT
				COUNT(ID)
				FROM $this->presname PRES
				WHERE PRES.FILE_NAME = '$filekey'
				AND (PRES.REC_STATUS = 'RUN'
				OR PRES.REC_STATUS = 'END' )
				GROUP BY PRES.LEGAL_TYPE,
					PRES.IDENTIFICATION, PRES.PRES_OPERATION_TYPE
				HAVING COUNT(*) > 1 ";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", Validar Operacion Duplicada en Loter";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Generar Excepciones (CONTRATO SIN CUENTA DE ANTICIPOS)
        $sql = 'SELECT ' . singleQuote('X') . '   FROM ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND ' . singleQuote('AN') . '=' . singleQuote($record['PRES_OPERATION_TYPE']) . ' AND FIAS.TRUST_ITEM_TYPE = ' . singleQuote('AD');
        $result = ClxCommon::$db->getOneRecord($sql);
        if (empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", CONTRATO SIN CUENTA DE ANTICIPOS " . $record['CONTRACT_CODE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Generar Excepciones (CONTRATO SIN CUENTA DE EFECTIVO)
        $sql = 'SELECT ' . singleQuote('X') . ' FROM ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND FIAS.TRUST_ITEM_TYPE = ' . singleQuote('CA');
        $result = ClxCommon::$db->getOneRecord($sql);
        if (empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", CONTRATO SIN CUENTA DE EFECTIVO:" . $record['CONTRACT_CODE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Generar Excepciones (CONTRATO SIN CUENTA DE PRESTAMOS)
        $sql = 'SELECT ' . singleQuote('X') . ' FROM ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND FIAS.TRUST_ITEM_TYPE = ' . singleQuote('PR');
        $result = ClxCommon::$db->getOneRecord($sql);
        if (empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", CONTRATO SIN CUENTA DE PRESTAMOS:" . $record['CONTRACT_CODE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Marcar Registros con Errores (INCORPORACION SIN NOMBRE)
        if ($record['PRES_OPERATION_TYPE'] == 'IN' && ($record['LASTNAME'] == '' || $record['FIRSTNAME'] == '')) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", INCORPORACION SIN NOMBRE/APELLIDO PARA BENEFICIARIO CON CEDULA / RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', ' . $record['FIRSTNAME'] . ' ' . $record['LASTNAME'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Marcar Registros con Errores (INCOR-CUENTA CRM EXISTE)
        $sql = "SELECT 'X' FROM $this->acconame ACCO, $this->fipaname FIPA WHERE ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND 'IN' = '" . $record['PRES_OPERATION_TYPE'] . '\'';
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", YA EXISTE INCORPORACION DE BENEFICIARIO CON CEDULA / RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', ' . $record['FIRSTNAME'] . ' ' . $record['PRES.LASTNAME'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Marcar Registros con Errores (CTA BANCO-NO MATCH)
        $sql = "SELECT 'X' FROM $this->acconame ACCO, FIDU_BANK_ACCOUNTS FIBK WHERE ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIBK.ACCOUNTCODE = ACCO.IDCODE AND FIBK.BANK_ACCOUNT_NO = '" . $record['BANK_ACCOUNT_NO'] . "' AND
				  'IN' = '" . $record['PRES_OPERATION_TYPE'] . '\'';
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", CUENTA DE BANCO NO: " . $record['BANK_ACCOUNT_NO'] . " NO ESTA REGISTRADA PARA CEDULA/RIF:" . $record['LEGAL_TYPE'] . ' ' . $record['IDENTIFICATION'] . ', ' . $record['FIRSTNAME'] . ' ' . $record['LASTNAME'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Marcar Registros con Errores (APORTE/DESELBOLSO SIN CTA BANCO)
        if ($this->import_type == 'TRANS' && empty($record['BANK_ACCOUNT_NO'])) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ', OPERACION DE APORTE/DESEMBOLSO: ' . $record['PRES_OPERATION_TYPE'] . ', NO TIENE CUENTA DE BANCO EN ARCHIVO DE IMPORTACION PARA CEDULA/RIF: ' . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . 'r';
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Validar Monto de Anticipo > Capital Limite
        $sql = "SELECT ( ( (SUM(DEBIT_AMT) - SUM(CREDIT_AMT)) * (FICO.PRES_AVAIL_PCT/100) ) * -1) CAPITAL_LIMITE, ( ( (SUM(DEBIT_AMT) - SUM(CREDIT_AMT)) * (FICO.PRES_AVAIL_PCT/100) ) * -1) SALDO FROM $this->acconame ACCO, $this->fipaname FIPA, $this->jehdname JEHD, $this->jelnname JELN, $this->ficoname FICOWHERE JEHD.CONTRACT_CODE = FICO.IDCODE AND JEHD.JE_STATUS NOT IN('PEND', 'REJ') AND '" . $record['PRES_OPERATION_TYPE'] . "' = 'AN' AND ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND FIPA.CONTRACT_CODE = JEHD.CONTRACT_CODE AND JEHD.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "' AND JELN.JEHDR_CODE = JEHD.IDCODE AND JELN.GLACCOUNTCODE LIKE '731%' AND JELN.PARTICIPANT_ID = FIPA.ACCOUNTCODE GROUP BY JELN.GLACCOUNTCODE HAVING ROUND('" . $record['TRANS_AMT'] . "', 2) > CAPITAL_LIMITE";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", Monto de Anticipo > Capital Limiter";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Validar Monto de Prestamo > Capital Limite
        $sql = "SELECT JELN.GLACCOUNTCODE, ( ( (SUM(DEBIT_AMT) - SUM(CREDIT_AMT)) * (FICO.PRES_AVAIL_PCT/100) ) * -1) CAPITAL_LIMITE, ( ( (SUM(DEBIT_AMT) - SUM(CREDIT_AMT)) * (FICO.PRES_AVAIL_PCT/100) ) * -1) SALDO FROM $this->acconame ACCO, $this->fipaname FIPA, $this->jehdname JEHD, $this->jelnname JELN, $this->ficoname FICO WHERE JEHD.JE_STATUS NOT IN('PEND', 'REJ') AND FICO.IDCODE = JEHD.CONTRACT_CODE AND '" . $record['PRES_OPERATION_TYPE'] . "' = 'PR' AND ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND FIPA.CONTRACT_CODE = JEHD.CONTRACT_CODE AND JEHD.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "' AND JELN.JEHDR_CODE = JEHD.IDCODE AND JELN.GLACCOUNTCODE LIKE '731%' AND JELN.PARTICIPANT_ID = FIPA.ACCOUNTCODE GROUP BY JELN.GLACCOUNTCODE HAVING ROUND('" . $record['TRANS_AMT'] . "', 2) > CAPITAL_LIMITE";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ",  Monto de Prestamo > Capital Limiter";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Validar (Anticipo+Saldo Prestamos y Anticipos) > Capital Limite
        $sql = "SELECT ACCO.IDENTIFICATION, (SELECT (((SUM( JELN1.DEBIT_AMT ) - SUM( JELN1.CREDIT_AMT )) * ( FICO.PRES_AVAIL_PCT /100 )) * -1) FROM $this->jehdname JEHD1, $this->jelnname JELN1 WHERE FICO.IDCODE = JEHD1.CONTRACT_CODE AND JEHD1.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD1.CONTRACT_CODE = FICO.IDCODE AND JELN1.JEHDR_CODE = JEHD1.IDCODE AND JELN1.GLACCOUNTCODE LIKE '731%' AND JELN1.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) CAPITAL_LIMITE, ( SELECT SUM( JELN2.DEBIT_AMT ) - SUM( JELN2.CREDIT_AMT ) FROM $this->jehdname JEHD2, $this->jelnname JELN2 WHERE FICO.IDCODE = JEHD2.CONTRACT_CODE AND JEHD2.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD2.CONTRACT_CODE = FICO.IDCODE AND JELN2.JEHDR_CODE = JEHD2.IDCODE AND JELN2.GLACCOUNTCODE LIKE '713%' AND JELN2.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) PRESTAMOS_ANTICIPOS, 	( (SELECT (((SUM( JELN1.DEBIT_AMT ) - SUM( JELN1.CREDIT_AMT )) * (FICO.PRES_AVAIL_PCT /100 )) * -1) FROM $this->jehdname JEHD1, $this->jelnname JELN1 WHERE FICO.IDCODE = JEHD1.CONTRACT_CODE AND JEHD1.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD1.CONTRACT_CODE = FICO.IDCODE AND JELN1.JEHDR_CODE = JEHD1.IDCODE AND JELN1.GLACCOUNTCODE LIKE '731%' AND JELN1.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) - (SELECT SUM( JELN2.DEBIT_AMT ) - SUM( JELN2.CREDIT_AMT ) FROM $this->jehdname JEHD2, $this->jelnname JELN2 WHERE FICO.IDCODE = JEHD2.CONTRACT_CODE AND JEHD2.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD2.CONTRACT_CODE = FICO.IDCODE AND JELN2.JEHDR_CODE = JEHD2.IDCODE AND JELN2.GLACCOUNTCODE LIKE '713%'AND JELN2.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) ) SALDO FROM $this->acconame ACCO, $this->fipaname FIPA, $this->ficoname FICO WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.IDCODE = '" . $record['CONTRACT_CODE'] . "' AND '" . $record['PRES_OPERATION_TYPE'] . "' = 'AN' AND ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE HAVING ROUND( '" . $record['TRANS_AMT'] . "' + PRESTAMOS_ANTICIPOS, 2 ) > ROUND( CAPITAL_LIMITE, 2 ) ";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ",  (Anticipo+Saldo Prestamos y Anticipos) > Capital Limiter";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Validar (Prestamo + Saldo Prest. y Anticipos) > Capital Limite
        $sql = "SELECT ACCO.IDENTIFICATION, (SELECT (((SUM( JELN1.DEBIT_AMT ) - SUM( JELN1.CREDIT_AMT )) * ( FICO.PRES_AVAIL_PCT /100 )) * -1) FROM $this->jehdname JEHD1, $this->jelnname JELN1 WHERE FICO.IDCODE = JEHD1.CONTRACT_CODE AND JEHD1.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD1.CONTRACT_CODE = FICO.IDCODE AND JELN1.JEHDR_CODE = JEHD1.IDCODE AND JELN1.GLACCOUNTCODE LIKE '731%' AND JELN1.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) CAPITAL_LIMITE, ( SELECT SUM( JELN2.DEBIT_AMT ) - SUM( JELN2.CREDIT_AMT ) FROM $this->jehdname JEHD2, $this->jelnname JELN2 WHERE FICO.IDCODE = JEHD2.CONTRACT_CODE AND JEHD2.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD2.CONTRACT_CODE = FICO.IDCODE AND JELN2.JEHDR_CODE = JEHD2.IDCODE AND JELN2.GLACCOUNTCODE LIKE '713%' AND JELN2.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) PRESTAMOS_ANTICIPOS, ( (SELECT (((SUM( JELN1.DEBIT_AMT ) - SUM( JELN1.CREDIT_AMT )) * (FICO.PRES_AVAIL_PCT /100 )) * -1) FROM $this->jehdname JEHD1, $this->jelnname JELN1 WHERE FICO.IDCODE = JEHD1.CONTRACT_CODE AND JEHD1.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD1.CONTRACT_CODE = FICO.IDCODE AND JELN1.JEHDR_CODE = JEHD1.IDCODE AND JELN1.GLACCOUNTCODE LIKE '731%' AND JELN1.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) - (SELECT SUM( JELN2.DEBIT_AMT ) - SUM( JELN2.CREDIT_AMT ) FROM $this->jehdname JEHD2, $this->jelnname JELN2 WHERE FICO.IDCODE = JEHD2.CONTRACT_CODE AND JEHD2.JE_STATUS NOT IN('PEND', 'REJ') AND JEHD2.CONTRACT_CODE = FICO.IDCODE AND JELN2.JEHDR_CODE = JEHD2.IDCODE AND JELN2.GLACCOUNTCODE LIKE '713%' AND JELN2.PARTICIPANT_ID = FIPA.ACCOUNTCODE ) ) SALDO FROM $this->acconame ACCO, $this->fipaname FIPA, $this->ficoname FICO WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.IDCODE = '" . $record['CONTRACT_CODE'] . "' AND '" . $record['PRES_OPERATION_TYPE'] . "' = 'PR' AND ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE HAVING ROUND( '" . $record['TRANS_AMT'] . "' + PRESTAMOS_ANTICIPOS, 2 ) > ROUND( CAPITAL_LIMITE, 2 ) ";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ',  (Anticipo+Saldo Prestamos y Anticipos) > Capital Limiter';
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }


        //Marcar Registros con Errores (NO ES PERSONA NATURAL)
        if ($this->import_type == 'INCO' && ($record['LEGAL_TYPE'] <> 'V' || $record['LEGAL_TYPE'] <> 'E')) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ', REGISTRO NO ES DE PERSONA NATURAL: ' . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', ' . $record['FIRSTNAME'] . ' ' . $record['LASTNAME'] . 'r';
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//'MONTO DE LA OPERACION ES NEGATIVO PARA BENEFICIARIO CON CEDULA / RIF:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION, ' ,'  'OPERACION: ', PRES.PRES_OPERATION_TYPE
        //Marcar Registros con Errores (MONTO DE LA OPERACION = 0)
        if ($this->import_type == 'TRANS' && $record['TRANS_AMT'] <= CLX_NUM_ZERO) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ', MONTO DE LA OPERACION ES NEGATIVO PARA BENEFICIARIO CON CEDULA / RIF:' . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', OPERACION: ' . $record['PRES_OPERATION_TYPE'] . 'r';
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//'MONTO DE OPERACION = 0, PARA BENEFICIARIO CON CEDULA / RIF:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION, ' ,'  'OPERACION: ', PRES.PRES_OPERATION_TYPE
        //Marcar Registros con Errores (CONTRATO NO ES DE PRESTACIONES)
        $sql = "SELECT 'X' FROM $this->ficoname FICO  WHERE FICO.IDCODE = '" . $record['CONTRACT_CODE'] . "' AND FICO.FI_TYPE = 'AD01'";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", MONTO DE OPERACION = 0, PARA BENEFICIARIO CON CEDULA / RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', OPERACION: ' . $record['PRES_OPERATION_TYPE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//'CONTRATO NO: ', PRES.CONTRACT_CODE, ' NO ES DE PRESTACIONES SOCIALES. CEDULA / RIF:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION, ' ,'  'OPERACION: ', PRES.PRES_OPERATION_TYPE
        //Marcar Registros con Errores (TIPO DE DESEMBOLSO NO DEFINIDO)
        if (($record['PRES_OPERATION_TYPE'] == 'AN' || $record['PRES_OPERATION_TYPE'] == 'PR') && empty($record['DISBURSEMENT_TYPE'])) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", CONTRATO NO: " . $record['CONTRACT_CODE'] . " NO ES DE PRESTACIONES SOCIALES. CEDULA / RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', OPERACION: ' . $record['PRES_OPERATION_TYPE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//'OPERACION DE DESEMBOLSO: ', PRES.PRES_OPERATION_TYPE,  ' ,NO TIENE DEFINIDO EL TIPO DE DESEMBOLSO. CEDULA/RIF:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION
        if ($this->import_type == 'TRANS' && empty($record['PRES_OPERATION_TYPE'])) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ",OPERACION DE DESEMBOLSO: " . $record['PRES_OPERATION_TYPE'] . ", NO TIENE DEFINIDO EL TIPO DE DESEMBOLSO. CEDULA/RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//'DESINCORPORACION CON MONTO PARA BENEFICIARIO CON CEDULA / RIF:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION, ' ,'  'OPERACION: ', PRES.PRES_OPERATION_TYPE
        //Marcar Registros con Errores (DESINCORPORACION CON MONTO)
        if ($record['PRES_OPERATION_TYPE'] == 'DI' && !empty($record['TRANS_AMT'])) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", DESINCORPORACION CON MONTO PARA BENEFICIARIO CON CEDULA / RIF:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . ', OPERACION: ' . $record['PRES_OPERATION_TYPE'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

//AMORTIZACION SIN PRESTAMO. CEDULA:' , PRES.LEGAL_TYPE, PRES.IDENTIFICATION
        //Validar Monto de Amortizacion > Prestamos
        //AND '".$record['PRES_OPERATION_TYPE'] = 'AM'
        $sql = "SELECT 'X' FROM $this->acconame ACCO, $this->fipaname FIPA, $this->fidaname FIDA, $this->fiasname FIAS WHERE ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND FIDA.PARTICIPANT_ID = FIPA.ACCOUNTCODE AND FIAS.IDCODE = FIDA.ASSET_CODE AND FIAS.TRUST_ITEM_TYPE = 'PR' AND '" . $record['PRES_OPERATION_TYPE'] . "' = 'AM' AND FIAS.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "' AND FIDA.BALANCE_AMT < " . $record['TRANS_AMT'];
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", AMORTIZACION MAYOR A PRESTAMO. CEDULA:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //Marcar Registros con Errores (AMORTIZACION SIN PRESTAMOS)
        $sql = "SELECT 'X' FROM $this->acconame ACCO, $this->fipaname FIPA, $this->fidaname FIDA, $this->fiasname FIAS WHERE ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "' AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE AND FIAS.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "' AND FIAS.TRUST_ITEM_TYPE = 'PR' AND FIDA.PARTICIPANT_ID = FIPA.ACCOUNTCODE AND FIDA.ASSET_CODE = FIAS.IDCODE";
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", AMORTIZACION SIN PRESTAMO. CEDULA:" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "r";
            $record['COMMENTS'] .= $emsg;
            $record['REC_STATUS'] = 'ERRO';
            $log->write($emsg);
        }

        //ADVANCE_LOAN_REASON
        //si blank do nothing
        if (($record['PRES_OPERATION_TYPE'] == 'PR' || $record['PRES_OPERATION_TYPE'] == 'AN') && $record['ADVANCE_LOAN_REASON'] <> '' && $record['ADVANCE_LOAN_REASON'] <> 'D') {
            $accountingdate = ClxCommon::$db->getOne("SELECT COMP.ACCOUNTING_DATE
											FROM $this->compname COMP,
													$this->ficoname FICO
											WHERE COMP.IDCODE = FICO.COMP_CODE AND
												FICO.IDCODE = '" . $record['CONTRACT_CODE'] . '\'');
            $year = substr($accountingdate, CLX_NUM_ZERO, CLX_NUM_FOUR);
            $sdate = $year . '-01-01';
            $edate = $year . '-12-31';
            $sql = "SELECT FICO.PRES_AVAIL_PERIOD-COUNT(FIAT.ID)
				  FROM $this->ficoname FICO,
				  		$this->fipaname FIPA,
						$this->fiatname FIAT,
						$this->acconame ACCO
				  WHERE
				  		FIAT.TRANS_STATUS IN ('AP','VER', 'CLOS')
						AND ACCO.IDENTIFICATION = '" . $record['LEGAL_TYPE'] . $record['IDENTIFICATION'] . "'
	 					AND FIPA.ACCOUNTCODE = ACCO.IDCODE
						AND FIPA.CONTRACT_CODE = FICO.IDCODE
						AND FIPA.CONTRACT_CODE = '" . $record['CONTRACT_CODE'] . "'
						AND FIAT.CONTRACT_CODE = FICO.IDCODE
						AND FIAT.PARTICIPANT_ID = FIPA.ACCOUNTCODE
						AND FIAT.TRANSTBL_CODE IN ('SYS_PRES-PRESTA','SYS_PRES-ANT')
						AND FIAT.EFFTDATE >= '" . $sdate . "'
						AND FIAT.EFFTDATE <= '" . $edate . "'
				 ";
            $result = ClxCommon::$db->getOneRecord($sql);
            if ($result < CLX_NUM_ZERO) {
                $emsg = 'Err. Ln: ' . $line_no . ', Lote:' . $record['CUST_FILEID'] . ", " . dict('GEN_ERR_JUSTONEAYEAR') . " r";
                $record['COMMENTS'] .= $emsg;
                $record['REC_STATUS'] = 'ERRO';
                $log->write($emsg);
            }
        }
        if (count($msg)) {
            $status = false;
        }

        return $status;
    }

    //---------------------------------------------------------------------------------------------
    // Import Report
    //---------------------------------------------------------------------------------------------

    function import_report($file_key) {


        $qty_total = ClxCommon::$db->countRecords($this->import_table, "FILE_NAME ='" . $file_key . '\''); //'IDLE',
        $qty_total_err = ClxCommon::$db->countRecords($this->import_table, "FILE_NAME ='" . $file_key . "' AND REC_STATUS = 'ERRO'"); //'IDLE',
        $trans_total = ClxCommon::$db->getOne("SELECT SUM(TRANS_AMT) TRANS_AMT FROM $this->import_table WHERE FILE_NAME ='" . $file_key . "' GROUP BY FILE_NAME"); //'IDLE',
        $trans_totals = ClxCommon::$db->executeQuery("SELECT PRES_OPERATION_TYPE, SUM(TRANS_AMT) TRANS_AMT FROM $this->import_table WHERE FILE_NAME ='" . $file_key . "' GROUP BY FILE_NAME, 	PRES_OPERATION_TYPE"); //'IDLE',


        $table = new htmlTable(2, CLX_PROP_CLASS, CLX_CLASS_FORM, CLX_PROP_ALIGN, 'center');
        $b = new htmlButton(dict('GEN_LBL_PRINT'));
        $b->setProp('onClick', 'javascript:open_div_window('.singleQuote('div_to_print').', '.singleQuote('Print').','.singleQuote(skinPath() . '/styles.css').');');


        /*
         * GEN_CODE_IMPORTREPORT  Import Report - Reporte de Importaci�n
         * GEN_LBL_IMPORTSTATUS Import Status - Estado de la importaci�n
         * GEN_LBL_IMPORTTOTALROWS Import total rows - Total de registros procesados
         * GEN_LBL_IMPORTTOTALERRS Import errors - Total de registros en error
         * GEN_LBL_LOGFILE Log file - Archivo de Errores
         * GEN_LBL_IMPORTTOTALAMT Total Amount - Monto Total
         */
        $table->addCell('Reporte de Importación', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => "2"));
        //
        $table->addCell('<b>' . dict('GEN_LBL_FILENAME') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->filename, array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        $table->addCell('<b>' . dict('GEN_LBL_IMPORTTYPE') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->import_types[$this->import_type], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $contract_name = ClxCommon::$db->getField($this->ficoname, "IDNAME", 'IDCODE = \'' . $this->header[1] . '\'');
        $table->addCell('<b>' . dict('GEN_LBL_CONTRACT_CODE') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->header[1] . ' ' . ((empty($contract_name)) ? '[' . dict('TOOL_CODE_ERR_NO_RECORD') . ']' : $contract_name), array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        //Estado
        $table->addCell('<b>' . dict('GEN_LBL_IMPORTSTATUS') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell((($qty_total_err > 0 || count($this->header_err) > 0) ? dict('GEN_LBL_ERROR') : dict('GEN_LBL_COMPLETED')), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        foreach ($this->header_err as $key => $val) {
            $table->addCell('&nbsp;', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($val, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
        //Total de registros
        $table->addCell('<b>' . dict('GEN_LBL_IMPORTTOTALAMT') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell(clx_format_currency($trans_total), array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        $DBTL = getTool('DBLT');
        while (($trans_total = ClxCommon::$db->getNextRecord($trans_totals)) == true) {
            //Total de registros
            $table->addCell('<b>' . dict('GEN_LBL_IMPORTTOTALAMT') . ' (' . $DBTL->getListItem('PREO', $trans_total['PRES_OPERATION_TYPE']) . '): </b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell(clx_format_currency($trans_total['TRANS_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }

        //Total de registros
        $table->addCell('<b>' . dict('GEN_LBL_IMPORTTOTALROWS') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($qty_total, array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        //Total de registros en error
        $table->addCell('<b>' . dict('GEN_LBL_IMPORTTOTALERRS') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($qty_total_err, array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        if ($qty_total_err > CLX_NUM_ZERO) {
            $table->addCell('<b>' . dict('TOOL_DBIE_TITLE_LIST') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => "2"));
            $table->addCell('<b>' . dict('GEN_LBL_LOGFILE') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell('<a href="' . $this->filename . 'log.txt' . '" target="blank">' . dict("GEN_LBL_DOWNLOAD_THE_FILE") . '</a>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }

        $this->contents = '<div id="div_to_print" name="div_to_print">' . $table->source() . '</div><p align="right">' . $b->source() . '</p>';
    }

    /**
     * Start press process
     */
    function schedule_process() {

    }

}

//-----------------------------------------------------------------------------------------

/**
 * Reporte para prestaciones sociales
 */
class fidu_prestaciones_reports extends fidu_prestaciones {

    var $sdate; //Start Date
    var $edate; //To date
    var $user_sdate; //This userdate
    var $comp_code; // Company
    var $chart_field01; // Contract
    var $part = '';
    var $keepLog = true;
    var $debug = false;
    var $datestamp = '';
    var $contents = '';
    var $date_format = 'd/m/Y';
    var $enable_participant = false;
    var $comp_address = '';
    var $print_btn = true;
    //Parametros de reportes
    var $subcuenta_prestamos = '713';
    var $subcuenta_anticipos = '713';
    var $subcuenta_intereses = '751';
    var $subcuenta_capital = '731';
    var $subcuenta_ingresos = '75';
    var $subcuenta_gastos = '74';

    function __construct() {
        parent::__construct();
    }

    //--------------------------------------------------------------------
    // PDF Creation
    //--------------------------------------------------------------------
    function build_pdf($orientation, $title, $headers, $data, $variants, $asof, $filename = 'temp_pdf', $papersize = 'letter') {


        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = \'' . $this->comp_code . '\'');
        $colorec = ClxCommon::$db->getRecord(tableName('COLO'), "COMP_CODE = '" . $comprec['IDCODE'] . "' ORDER BY ISPRIMARY DESC");

        $DBLT = &getTool('DBLT');
        $colorec['CITY'] = $DBLT->getListItem('loci', $colorec['CITY']);
        if (!empty($this->chart_field01)) {
            $ficorec = ClxCommon::$db->getRecord($this->ficoname, "IDCODE='$this->chart_field01'");
            $title .=CLX_CHAR_NL . dict('GEN_LBL_CONTRACT_NAME') . ': ' . $ficorec['IDNAME'] . CLX_CHAR_NL . dict('GEN_LBL_CONTRACT_CODE') . ': ' . $ficorec['CONTRACT_NUMBER'];
        } else {
            $title .=CLX_CHAR_NL;
        }


        $sdate = ($this->user_sdate <> '') ? $this->user_sdate : $this->sdate;
        if (empty($asof)) {
            $title .= CLX_CHAR_NL . dict("GEN_LBL_FROM") . ' ' . xFormat::date($sdate, $this->date_format) . ' ' . dict("GEN_LBL_UNTIL") . ' ' . xFormat::date($this->edate, $this->date_format);
        } else {
            $title .= CLX_CHAR_NL . dict("GEN_LBL_ASOF") . ' ' . xFormat::date($this->edate, $this->date_format) . CLX_CHAR_NL;
        }

        //Company Record
        $FILE = getToolObject('DBFT', 'FILE');
        $complogo = $FILE->fileName($comprec['COMP_LOGO']);
        //Output Report
        $RPPD = getToolObject('RPFT', 'RPPD');
        $RPPD->FPDF($orientation, 'mm', $papersize);
        $RPPD->SetAuthor($comprec['IDNAME']);
        $RPPD->Open();
        $RPPD->setHeader('logo_x', CLX_NUM_TEN);
        $RPPD->setHeader('logo_y', CLX_NUM_ZERO);
        $RPPD->setHeader('logo_width', 36.5);
        $RPPD->setHeader('logo_height', 24.6);
        $RPPD->setHeader('logo_img', $complogo);
        $RPPD->setHeader(CLX_CLASS_TITLE, uppercase($title));
        $RPPD->setHeader('logo_text1', strip_tags(str_replace('<br>', CLX_CHAR_NL, $comprec['REP_GERENCIA'])));
        $RPPD->setHeader('height', CLX_NUM_FIVE);
        $RPPD->setHeader('border', CLX_NUM_ZERO);
        $RPPD->setHeader('pagination', false);
        $RPPD->setHeader('date', true);
        $RPPD->setHeader('table_headers', $headers);
        $RPPD->setFooter('enabled', true);
        $this->FIRE_lib->page_footer_put_pdf_lines($RPPD, $comprec['VE_TXTINFO']);

        $RPPD->setFooter('page_location', 'R');

        $RPPD->AddPage();
        $RPPD->SetFont('Arial', 'B', CLX_NUM_TEN);
        $RPPD->SetFont('Arial', 'B', CLX_NUM_SEVEN);
        $RPPD->buildTableData($data, $variants);
        $RPPD->Close();
        $flname = kPathToTemp . $filename . str_replace('.', '', microtime(true)) . '.pdf';
        $RPPD->Output($flname, 'F');
        $this->contents .= note('<a href="' . $flname . '" target="_blank">' . dict("GEN_LBL_DOWNLOAD_THE_FILE") . '</a><br>'); //.implode('<bR>',$data);
    }

    function showContract(&$table, $tableWidth) {

        if (!empty($this->chart_field01)) {
            $ficorec = ClxCommon::$db->getRecord($this->ficoname, "IDCODE='$this->chart_field01'");
            $table->addCell(uppercase('<br><font size = 2><b>' . dict('GEN_LBL_CONTRACT_NAME') . ':</b> ' . $ficorec['IDNAME'] . '' . '<br><b>' . dict('GEN_LBL_CONTRACT_CODE') . ':</b> ' . $ficorec['CONTRACT_NUMBER'] . '</font>'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
        }
    }

    function showTitle(&$table, $tableWidth, $asof, $title) {
        $table->addCell('<br>' . uppercase($title) . '<br>', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth, CLX_PROP_ALIGN => 'center'));
        $sdate = ($this->user_sdate <> '') ? $this->user_sdate : $this->sdate;
        if (empty($asof))
            $table->addCell(uppercase('<font size = 2><b>' . dict('GEN_LBL_FROM') . ' ' . xFormat::date($sdate, $this->date_format) . ' ' . dict('GEN_LBL_UNTIL') . ' ' . xFormat::date($this->edate, $this->date_format) . '</b></font>'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth, CLX_PROP_ALIGN => 'center'));
        else
            $table->addCell(uppercase('<font size = 2><b>' . dict("GEN_LBL_ASOF") . ' ' . xFormat::date($this->edate, $this->date_format) . '</b></font>'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth, CLX_PROP_ALIGN => 'center'));
    }

    function comp_logo() {

        $fieldinstance = getToolObject('DBFT', 'FILE');
        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote('COMP_LOGO'));
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($this->comp_code));
        $return = $fieldinstance->formatField('COMP_LOGO', $fieldrec, $comprec);
        $return .= '<br><font size=3><b>' . $comprec['REP_GERENCIA'] . '</b></font><br>';
        return $return;
    }

    function showFooter(&$table, $tableWidth) {


        $this->coloname = tableName('COLO');
        if (!empty($this->chart_field01)) {
            $sql = "SELECT
						COMP.*, COLO.*
					FROM
						$this->compname COMP,
						$this->dyclname DYCL,
						$this->coloname COLO

					WHERE
						COMP.IDCODE = '" . $this->comp_code . "'
						AND DYCL.COMP_CODE = COMP.IDCODE
						AND DYCL.COMPLOC_CODE = COLO.IDCODE";
            $results = ClxCommon::$db->executeQuery($sql);
            $result = ClxCommon::$db->getNextRecord($results);
            $txt = '<center><br>' . $this->FIRE_lib->page_footer_process_special_tokens($result['VE_TXTINFO']);
            if ($this->FIRE_lib->page_footer_use_def_address == true) {
                $txt .= $this->FIRE_lib->page_footer_address;
            }
            $txt .= '</center>';

            $table->addCell($txt, array(CLX_PROP_CLASS => 'caption', CLX_PROP_COLSPAN => $tableWidth, CLX_PROP_ALIGN => 'center'));
        }
    }

    /**
     * Returns source code
     */
    function source() {
        $contents = '';
        if ($this->print_btn) {
            $table = new htmlTable(1, CLX_PROP_CLASS, CLX_CLASS_FORM, CLX_PROP_ALIGN, 'center');
            $b = new htmlButton(dict('GEN_LBL_PRINT'));
            $b->setProp('onClick', 'javascript:open_div_window('.singleQuote('div_to_print').', '.singleQuote('Print').','.singleQuote(skinPath() . '/styles.css').');');
            $table->addCell($b->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $contents .=$table->source();
        }
        $contents .= '<div id="div_to_print">' . $this->contents . '</div>';
        return $contents;
    }

// End method
//------------------------------------------------------------------------------
// Reports
//------------------------------------------------------------------------------
    function prompt($formcode) {


        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = UserRequest::$request['it'];
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = \'' . $formcode . '\'');
        $record = UserRequest::$post;

        //Prepare Valiues
        if (!empty($record['confirm'])) {
            $EDIT->checkForm2($msg, $formrec);
        }
        $this->comp_code = (array_key_exists('RTBL_COMP_CODE', $record)) ? $record['RTBL_COMP_CODE'] : '';
        $this->chart_field01 = (array_key_exists('RTBL_CONTRACT_CODE', $record)) ? $record['RTBL_CONTRACT_CODE'] : '';
        $this->chart_field02 = (array_key_exists('RTBL_PARTICIPANT_ID', $record)) ? $record['RTBL_PARTICIPANT_ID'] : '';

        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($this->comp_code);
        if (array_key_exists('RTBL_EDATE', $record)) {
            $this->sdate = $record['RTBL_SDATE'];
            $this->edate = $record['RTBL_EDATE'];
        } else {
            $record['RTBL_COMP_CODE'] = $comprec['IDCODE'];
            $record['RTBL_EDATE'] = $comprec['OPERATION_DATE'];
            $record['RTBL_SDATE'] = xFormat::date($record['RTBL_EDATE'], 'Y-m-01');
        }

        $this->send_pdf = !empty($record['RTBL_SEND_PDF']);
        $this->print_btn = false;

        //print_r($record);
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
        $this->contents = $form->source();

        if (!class_exists('fidu_statement')) {
            includeCodeLib('FIRE');
        }
        $this->FIRE_lib = new fidu_statement();
        $this->FIRE_lib->send_pdf = $this->send_pdf;
        $this->FIRE_lib->page_footer_start($this->comp_code);

        return (empty($record['confirm']) || !empty($msg)) ? false : true;
    }

//------------------------------------------------------------------------------
// BALANCE REPORT
//------------------------------------------------------------------------------
    function balance_start() {
        if (!$this->prompt('RTBL_PRE_BAL')) {
            return;
        } else {
            $this->contents = '';
            $this->balance_report();
        }
    }

    /**
     * Resumen de saldos por contrato
     * Required parameters: $this->chart_field01, $this->comp_code, $this->sdate, $this->edate, $this->send_pdf
     */
    function balance_report() {


        $title = dict('FIDU_PR_REPSALDOS');

        $sql = 'SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	/* Saldo Inicial*/
                	IFNULL((SELECT
                		SUM(GDVW.CREDIT_AMT-GDVW.DEBIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN,
							    PRPT.PRBE_OPER_AP, PRPT.PRBE_OPER_DI)
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ' /*731*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . '), 0)  EQ_INI,
                	/*prestamos x-*/
                	IFNULL((SELECT
                		SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('PR') . '/*713*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->sdate) . '), 0)  PR_INI,
                	#anticipos
                	/*-*/
                	IFNULL((SELECT
                		SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('AD') . '/*713*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->sdate) . '), 0)  AD_INI,
                	0 INITBALANCE,
                	/*Aportes*/
                	IFNULL((SELECT
                		SUM(GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '/*731*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . '), 0)  APORTES,
                	/*#prestamos*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('PR') . '/*713*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') LOANS,
                	/*#anticipos*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('AD') . '/*713*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') ANTICIPOS,
                	/*retiros*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '/*731*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') WITHDRAWALS,
                	/*Intereses*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT-GDVW.DEBIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ')
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') INTERESTS,
                	0 BALANCE,
                	PRPT.PRES_ADVNCE_PCT,
                	PRPT.PRES_ADVN_PERIOD,
                	PRPT.PRES_AVAIL_PCT,
                	PRPT.PRES_AVAIL_PERIOD,
                        ACCO.IDCODE BENEFICIARY_CODE,
                	CASE PRPT.PRES_ADVN_PERIOD
        				WHEN ' . singleQuote('W') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 WEEK)
        				WHEN ' . singleQuote('M') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 MONTH)
        				WHEN ' . singleQuote('B') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -2 MONTH)
        				WHEN ' . singleQuote('Q') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -3 MONTH)
        				WHEN ' . singleQuote('S') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -6 MONTH)
        				WHEN ' . singleQuote('A') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 YEAR)
        				ELSE ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 DAY)
        			END PERIOD_START_DATE
                FROM
                	' . $this->prptname . ' PRPT,
                	' . $this->fipaname . ' FIPA,
                	' . $this->acconame . ' ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                        ' . (($this->chart_field02 <> '') ? ' AND FIPA.ACCOUNTCODE = ' . singleQuote($this->chart_field02) . ' ' : '') . '
                	AND PRPT.GL_PER_FIPA = 1
                	AND FIPA.CONTRACT_CODE = ' . singleQuote($this->chart_field01) . '
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM ' . $this->prptname . ' PRPTX
                		WHERE PRPTX.CONTRACT_CODE = ' . singleQuote($this->chart_field01) . '
                		AND PRPTX.CLX_EFFTDATE <=' . singleQuote($this->edate) . ')
                /*ORDER BY
                	ACCO.IDENTIFICATION*/
               UNION ALL
        		SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	/* Saldo Inicial*/
                	IFNULL((SELECT
                		SUM(GDVW.CREDIT_AMT-GDVW.DEBIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN,
				PRPT.PRBE_OPER_AP, PRPT.PRBE_OPER_DI)
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '/*731*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->sdate) . '), 0)  EQ_INI,
                	/*prestamos -*/
                	IFNULL((SELECT
                		SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('PR') . '/*713*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->sdate) . '), 0)  PR_INI,
                	#anticipos
                	/*-*/
                	IFNULL((SELECT
                		SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('AD') . '/*713*/
                		AND GDVW.EFFTDATE <=' . singleQuote($this->sdate) . '), 0)  AD_INI,
                	0 INITBALANCE,
                	/*Aportes*/
                	IFNULL((SELECT
                		SUM(GDVW.CREDIT_AMT)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '/*731*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . '), 0)  APORTES,
                	/*#prestamos*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('PR') . '/*713*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') LOANS,
                	/*#anticipos*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                		AND GDVW.GL_TYPE = ' . singleQuote('AS') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('AD') . '/*713*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') ANTICIPOS,
                	/*retiros*/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = ' . singleQuote('EQ') . '
                		AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '/*731*/
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') WITHDRAWALS,
                	/*Intereses*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT-GDVW.DEBIT_AMT), 0)
                	FROM
                		' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ')
                		AND GDVW.EFFTDATE >=' . singleQuote($this->sdate) . '
                		AND GDVW.EFFTDATE <=' . singleQuote($this->edate) . ') INTERESTS,
                	0 BALANCE,
                	PRPT.PRES_ADVNCE_PCT,
                	PRPT.PRES_ADVN_PERIOD,
                	PRPT.PRES_AVAIL_PCT,
                	PRPT.PRES_AVAIL_PERIOD,
                        ACCO.IDCODE BENEFICIARY_CODE,
                	CASE PRPT.PRES_ADVN_PERIOD
        				WHEN ' . singleQuote('W') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 WEEK)
        				WHEN ' . singleQuote('M') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 MONTH)
        				WHEN ' . singleQuote('B') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -2 MONTH)
        				WHEN ' . singleQuote('Q') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -3 MONTH)
        				WHEN ' . singleQuote('S') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -6 MONTH)
        				WHEN ' . singleQuote('A') . ' THEN ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 YEAR)
        				ELSE ADDDATE(' . singleQuote($this->edate) . ', INTERVAL -1 DAY)
        			END PERIOD_START_DATE
                FROM
                	' . $this->prptname . ' PRPT,
                	' . $this->fipaname . ' FIPA,
                	' . $this->acconame . ' ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                         ' . (($this->chart_field02 <> '') ? ' AND FIPA.ACCOUNTCODE = ' . singleQuote($this->chart_field02) . ' ' : '') . '
                	AND PRPT.GL_PER_FIPA = 0
                	AND FIPA.PARTICIPANT_TYPE = ' . singleQuote('G') . '
                	AND FIPA.CONTRACT_CODE = ' . singleQuote($this->chart_field01) . '
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM ' . $this->prptname . ' PRPTX
                		WHERE PRPTX.CONTRACT_CODE =' . singleQuote($this->chart_field01) . '
                		AND PRPTX.CLX_EFFTDATE <=' . singleQuote($this->edate) . ')
                ORDER BY
                	IDENTIFICATION';
        $summary = array();

        $sql2 = "SELECT PRPT.GL_PER_FIPA FROM $this->prptname PRPT
                WHERE
                	PRPT.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate') ";
        $gl_per_fipa = ClxCommon::$db->getOne($sql2);

        if ($gl_per_fipa == CLX_NUM_ZERO) {
            if (!class_exists("FiloReports"))
                includeCodeLib("FILOREP");
            $a = new FiloReports();
            $a->rep_participation_report($this->comp_code, $this->edate, 'Y-m-d', $this->chart_field01);
        }

        //-------------
        //
        //Sumary Line
        $summary[CLX_NUM_ZERO] = array('IDENTIFICATION' => '',
            'IDNAME' => 'Total',
            'INITBALANCE' => '0',
            'APORTES' => '0',
            'LOANS' => '0',
            'ANTICIPOS' => '0',
            'WITHDRAWALS' => '0',
            'INTERESTS' => '0',
            'BALANCE' => '0',
            'AVAILABLE_AMT' => '0',
            'PRES_AVAILABLE_AMT' => '0');
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {

            if ($gl_per_fipa == CLX_NUM_ZERO) {
                $result['INTERESTS'] = ClxCommon::$db->getField("TEMP1_TMP", "IN_AMT", "BENEFICIARY_CODE = '" . $result['BENEFICIARY_CODE'] . '\'');
            }

            //$result['AVAILABLE_AMT'] = ($result['EQ_INI']+($result['APORTES']-$result['WITHDRAWALS']));
            $result['AVAILABLE_AMT'] = ($result['EQ_INI'] + ($result['APORTES'] - $result['WITHDRAWALS']));
            $result['AVAILABLE_AMT'] *= ($result['PRES_ADVNCE_PCT'] / 100);
            $result['AVAILABLE_AMT'] -= $result['AD_INI'];
            $result['AVAILABLE_AMT'] -= $result['ANTICIPOS'];
            $result['AVAILABLE_AMT'] -= $result['PR_INI'];
            $result['AVAILABLE_AMT'] -= $result['LOANS'];
            $result['AVAILABLE_AMT'] = rounder($result['AVAILABLE_AMT'], CLX_NUM_TWO);

            /* PRPT.PRES_AVAIL_PCT,
              PRPT.PRES_AVAIL_PERIOD, */
            $result['PRES_AVAILABLE_AMT'] = CLX_NUM_ZERO;
            $result['PRES_AVAILABLE_AMT'] = ($result['EQ_INI'] + ($result['APORTES'] - $result['WITHDRAWALS']));
            $result['PRES_AVAILABLE_AMT'] *= ($result['PRES_AVAIL_PCT'] / 100);
            $result['PRES_AVAILABLE_AMT'] -= $result['AD_INI'];
            $result['PRES_AVAILABLE_AMT'] -= $result['ANTICIPOS'];
            $result['AVAILABLE_AMT'] -= $result['PR_INI'];
            $result['PRES_AVAILABLE_AMT'] -= $result['LOANS'];
            $result['PRES_AVAILABLE_AMT'] = rounder($result['PRES_AVAILABLE_AMT'], CLX_NUM_TWO);

            $result['INITBALANCE'] = bcsub($result['EQ_INI'], bcadd($result['PR_INI'], $result['AD_INI']));

            //print_r($result);
            $summary[$i] = array('IDENTIFICATION' => $result['IDENTIFICATION'],
                'IDNAME' => $result['IDNAME'],
                'INITBALANCE' => $result['INITBALANCE'],
                'APORTES' => $result['APORTES'],
                'LOANS' => $result['LOANS'],
                'ANTICIPOS' => $result['ANTICIPOS'],
                'WITHDRAWALS' => $result['WITHDRAWALS'],
                'INTERESTS' => $result['INTERESTS'],
                'BALANCE' => $result['INITBALANCE'],
                'AVAILABLE_AMT' => $result['AVAILABLE_AMT'],
                'PRES_AVAILABLE_AMT' => $result['PRES_AVAILABLE_AMT']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['APORTES']);
            $summary[$i]['BALANCE'] = bcsub($summary[$i]['BALANCE'], $summary[$i]['LOANS']);
            $summary[$i]['BALANCE'] = bcsub($summary[$i]['BALANCE'], $summary[$i]['ANTICIPOS']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['WITHDRAWALS']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['INTERESTS']);

            if ($summary[$i]['BALANCE'] <> CLX_NUM_ZERO) {//adding available
                $summary[$i]['AVAILABLE_AMT'] = $result['AVAILABLE_AMT'];
                $summary[$i]['PRES_AVAILABLE_AMT'] = $result['PRES_AVAILABLE_AMT'];
            } else {
                $summary[$i]['AVAILABLE_AMT'] = CLX_NUM_ZERO;
                $summary[$i]['PRES_AVAILABLE_AMT'] = CLX_NUM_ZERO;
            }


            //Balance
            $summary[CLX_NUM_ZERO]['INITBALANCE'] = bcadd($summary[CLX_NUM_ZERO]['INITBALANCE'], $summary[$i]['INITBALANCE']);
            $summary[CLX_NUM_ZERO]['APORTES'] = bcadd($summary[CLX_NUM_ZERO]['APORTES'], $summary[$i]['APORTES']);
            $summary[CLX_NUM_ZERO]['LOANS'] = bcadd($summary[CLX_NUM_ZERO]['LOANS'], $summary[$i]['LOANS']);
            $summary[CLX_NUM_ZERO]['ANTICIPOS'] = bcadd($summary[CLX_NUM_ZERO]['ANTICIPOS'], $summary[$i]['ANTICIPOS']);
            $summary[CLX_NUM_ZERO]['WITHDRAWALS'] = bcadd($summary[CLX_NUM_ZERO]['WITHDRAWALS'], $summary[$i]['WITHDRAWALS']);
            $summary[CLX_NUM_ZERO]['INTERESTS'] = bcadd($summary[CLX_NUM_ZERO]['INTERESTS'], $summary[$i]['INTERESTS']);
            $summary[CLX_NUM_ZERO]['BALANCE'] = bcadd($summary[CLX_NUM_ZERO]['BALANCE'], $summary[$i]['BALANCE']);
            $summary[CLX_NUM_ZERO]['AVAILABLE_AMT'] = bcadd($summary[CLX_NUM_ZERO]['AVAILABLE_AMT'], $summary[$i]['AVAILABLE_AMT']);
            $summary[CLX_NUM_ZERO]['PRES_AVAILABLE_AMT'] = bcadd($summary[CLX_NUM_ZERO]['PRES_AVAILABLE_AMT'], $summary[$i]['PRES_AVAILABLE_AMT']);

            //formating
            $summary[$i]['INITBALANCE'] = xFormat::number($summary[$i]['INITBALANCE']);
            $summary[$i]['APORTES'] = xFormat::number($summary[$i]['APORTES']);
            $summary[$i]['LOANS'] = xFormat::number($summary[$i]['LOANS']);
            $summary[$i]['ANTICIPOS'] = xFormat::number($summary[$i]['ANTICIPOS']);
            $summary[$i]['WITHDRAWALS'] = xFormat::number($summary[$i]['WITHDRAWALS']);
            $summary[$i]['INTERESTS'] = xFormat::number($summary[$i]['INTERESTS']);
            $summary[$i]['BALANCE'] = xFormat::number($summary[$i]['BALANCE']);
            $summary[$i]['AVAILABLE_AMT'] = xFormat::number($summary[$i]['AVAILABLE_AMT']);
            $summary[$i]['PRES_AVAILABLE_AMT'] = xFormat::number($summary[$i]['PRES_AVAILABLE_AMT']);
            $i++;
        }
        //formating
        $summary[CLX_NUM_ZERO]['INITBALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['INITBALANCE']);
        $summary[CLX_NUM_ZERO]['APORTES'] = xFormat::number($summary[CLX_NUM_ZERO]['APORTES']);
        $summary[CLX_NUM_ZERO]['LOANS'] = xFormat::number($summary[CLX_NUM_ZERO]['LOANS']);
        $summary[CLX_NUM_ZERO]['ANTICIPOS'] = xFormat::number($summary[CLX_NUM_ZERO]['ANTICIPOS']);
        $summary[CLX_NUM_ZERO]['WITHDRAWALS'] = xFormat::number($summary[CLX_NUM_ZERO]['WITHDRAWALS']);
        $summary[CLX_NUM_ZERO]['INTERESTS'] = xFormat::number($summary[CLX_NUM_ZERO]['INTERESTS']);
        $summary[CLX_NUM_ZERO]['BALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['BALANCE']);
        $summary[CLX_NUM_ZERO]['AVAILABLE_AMT'] = xFormat::number($summary[CLX_NUM_ZERO]['AVAILABLE_AMT']);
        $summary[CLX_NUM_ZERO]['PRES_AVAILABLE_AMT'] = xFormat::number($summary[CLX_NUM_ZERO]['PRES_AVAILABLE_AMT']);
        $summary[] = $summary[CLX_NUM_ZERO];
        unset($summary[CLX_NUM_ZERO]);
        if ($this->send_pdf) {
            $variants = array();
            $headers = array(
                array(dict('FICO_CODE_CEDULA'), '40', 'C'),
                array(dict('FICO_CODE_NAME'), '60', 'L'),
                array(dict('FICO_CODE_SBALANCE'), '30', 'R'),
                array(dict('FICO_CODE_APORTES'), '30', 'R'),
                array(dict('FICO_CODE_LOANS'), '30', 'R'),
                array(dict('FICO_CODE_ANTICIPOS'), '30', 'R'),
                array(dict('FICO_CODE_WITHDRAWALS'), '30', 'R'),
                //array(dict('FICO_CODE_INTERESTS'),'30','R'),
                array(dict('FICO_CODE_EARNINGS'), '30', 'R'),
                array(dict('FICO_CODE_BALANCE'), '30', 'R'),
                array(dict('GEN_LBL_ADV_AVAILABLE'), '30', 'R'),
                array(dict('GEN_LBL_PRES_AVAILABLE'), '30', 'R')
            );
            $variants[count($summary)] = array('font_face' => 'b');
            $this->build_pdf('L', $title, $headers, $summary, $variants, false, 'rep_pre_saldos', 'legal');
        } else {
            //Building Report Table
            $tableWidth = (int) CLX_NUM_ONE;
            $tableFrame = new htmlTable($tableWidth, CLX_PROP_WIDTH, CLX_PROP_100PCT);

            $tableFrame->addCell($this->comp_logo(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
            $this->showContract($tableFrame, $tableWidth);
            $this->showTitle($tableFrame, $tableWidth, false, $title);

            $table = new htmlTable(($tableWidth + CLX_NUM_TEN), CLX_PROP_WIDTH, CLX_PROP_100PCT, CLX_PROP_CLASS, CLX_CLASS_FORM);
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_CEDULA') . '</b>', '<b>' . dict('FICO_CODE_NAME') . '</b>', '<b>' . dict('FICO_CODE_SBALANCE') . '</b>', '<b>' . dict('FICO_CODE_APORTES') . '</b>', '<b>' . dict('FICO_CODE_LOANS') . '</b>', '<b>' . dict('FICO_CODE_ANTICIPOS') . '</b>', '<b>' . dict('FICO_CODE_WITHDRAWALS') . '</b>', '<b>' . dict('FICO_CODE_EARNINGS') . '</b>', '<b>' . dict('FICO_CODE_BALANCE') . '</b>', '<b>' . dict('GEN_LBL_ADV_AVAILABLE') . '</b>', '<b>' . dict('GEN_LBL_PRES_AVAILABLE') . '</b>'));
            //build html
            $i = count($summary);
            $class = CLX_CLASS_DATA;
            foreach ($summary as $key => $val) {
                if ($i == $key)
                    $class = CLX_CLASS_HEADERS;
                $table->addcell($val['IDENTIFICATION'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['IDNAME'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['INITBALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['APORTES'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['LOANS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['ANTICIPOS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['WITHDRAWALS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['INTERESTS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['BALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['AVAILABLE_AMT'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['PRES_AVAILABLE_AMT'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
            }
            $tableFrame->addcell($table->source(), array());
            $this->showFooter($tableFrame, 1);
            $this->contents .= $tableFrame->source();
        }
        unset($summary, $variants, $table, $tableFrame, $tableWidth, $headers);
    }

//----------------------------------------------------------
// LOAN REPORT
//----------------------------------------------------------

    function loan_start() {
        if (!$this->prompt('RTBL_PRE_LOAN')) {
            return;
        } else {
            $this->contents = '';
            $this->loan_report();
        }
    }

    /**
     * Resumen de gastos
     * Required parameters: $this->chart_field01, $this->comp_code, $this->sdate, $this->edate, $this->send_pdf
     */
    function loan_report() {


        $title = dict('FIDU_PR_REPLOANS');
        $sql = "SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	# Saldo Inicial
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE <='$this->sdate') INITBALANCE,
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') LOANS,
                	0 BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->acconame ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 1
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                /*ORDER BY
                	ACCO.IDENTIFICATION*/
                UNION ALL
                	SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	# Saldo Inicial
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE <='$this->sdate') INITBALANCE,
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_PR, PRPT.PRBE_OPER_AM)
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'PR'/*713*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') LOANS,
                	0 BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->acconame ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND FIPA.PARTICIPANT_TYPE = 'G'
                	AND PRPT.GL_PER_FIPA = 0
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                ORDER BY
                	IDENTIFICATION";
        $summary = array();
        $summary[CLX_NUM_ZERO] = array('IDENTIFICATION' => '',
            'IDNAME' => dict('GEN_LBL_TOTAL'),
            'EFFTDATE' => '',
            'INITBALANCE' => '0',
            'LOANS' => '0',
            'BALANCE' => '0');
        $i = 1;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {
            //print_r($result);
            $summary[$i] = array('IDENTIFICATION' => $result['IDENTIFICATION'],
                'IDNAME' => $result['IDNAME'],
                'EFFTDATE' => (($result['EFFTDATE'] <> '') ? xFormat::date($result['EFFTDATE'], $this->date_format) : ''),
                'INITBALANCE' => $result['INITBALANCE'],
                'LOANS' => $result['LOANS'],
                'BALANCE' => $result['INITBALANCE']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['LOANS']);

            //Total Balance
            $summary[CLX_NUM_ZERO]['INITBALANCE'] = bcadd($summary[CLX_NUM_ZERO]['INITBALANCE'], $summary[$i]['INITBALANCE']);
            $summary[CLX_NUM_ZERO]['LOANS'] = bcadd($summary[CLX_NUM_ZERO]['LOANS'], $summary[$i]['LOANS']);
            $summary[CLX_NUM_ZERO]['BALANCE'] = bcadd($summary[CLX_NUM_ZERO]['BALANCE'], $summary[$i]['BALANCE']);

            //formating
            $summary[$i]['INITBALANCE'] = xFormat::number($summary[$i]['INITBALANCE']);
            $summary[$i]['LOANS'] = xFormat::number($summary[$i]['LOANS']);
            $summary[$i]['BALANCE'] = xFormat::number($summary[$i]['BALANCE']);

            $i++;
        }

        //End formating
        $summary[CLX_NUM_ZERO]['INITBALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['INITBALANCE']);
        $summary[CLX_NUM_ZERO]['LOANS'] = xFormat::number($summary[CLX_NUM_ZERO]['LOANS']);
        $summary[CLX_NUM_ZERO]['BALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['BALANCE']);
        $summary[] = $summary[CLX_NUM_ZERO];
        unset($summary[CLX_NUM_ZERO]);
        if ($this->send_pdf) {
            $variants = array();
            $headers = array(
                array(dict('FICO_CODE_CEDULA'), '20', 'C'),
                array(dict('FICO_CODE_NAME'), '60', 'L'),
                array(dict('FICO_CODE_DATE'), '20', 'C'),
                array(dict('FICO_CODE_SBALANCE'), '30', 'R'),
                array(dict('FICO_CODE_LOANS'), '30', 'R'),
                array(dict('FICO_CODE_BALANCE'), '30', 'R')
            );
            $variants[count($summary)] = array('font_face' => 'b');
            $this->build_pdf('P', $title, $headers, $summary, $variants, false, 'rep_pre_prestamos');
        } else {
            //Building Report Table
            $tableWidth = (int) CLX_NUM_ONE;
            $tableFrame = new htmlTable($tableWidth, CLX_PROP_WIDTH, CLX_PROP_100PCT);

            $tableFrame->addCell($this->comp_logo(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
            $this->showContract($tableFrame, $tableWidth);
            $this->showTitle($tableFrame, $tableWidth, false, $title);

            $table = new htmlTable(($tableWidth + CLX_NUM_FIVE), CLX_PROP_WIDTH, CLX_PROP_100PCT, CLX_PROP_CLASS, CLX_CLASS_FORM);
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_CEDULA') . '</b>', '<b>' . dict('FICO_CODE_NAME') . '</b>', '<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_SBALANCE') . '</b>', '<b>' . dict('FICO_CODE_LOANS') . '</b>', '<b>' . dict('FICO_CODE_BALANCE') . '</b>'));
            //build html
            $i = count($summary);
            $class = CLX_CLASS_DATA;
            foreach ($summary as $key => $val) {
                if ($i == $key)
                    $class = CLX_CLASS_HEADERS;
                $table->addcell($val['IDENTIFICATION'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['IDNAME'], array(CLX_PROP_CLASS => $class));
                $table->addcell((($val['EFFTDATE'] == '') ? '&nbsp' : $val['EFFTDATE']), array(CLX_PROP_CLASS => $class));
                $table->addcell($val['INITBALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['LOANS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['BALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
            }
            $tableFrame->addcell($table->source(), array());
            $this->showFooter($tableFrame, 1);
            $this->contents .= $tableFrame->source();
        }
        unset($summary, $variants, $table, $tableFrame, $tableWidth, $headers);
    }

//----------------------------------------------------------
// LOAN REPORT
//----------------------------------------------------------

    function anti_start() {
        if (!$this->prompt('RTBL_PRE_ANTI')) {
            return;
        } else {
            $this->contents = '';
            $this->anti_report();
        }
    }

    /**
     * Resumen de gastos
     * Required parameters: $this->chart_field01, $this->comp_code, $this->sdate, $this->edate, $this->send_pdf
     */
    function anti_report() {


        $title = dict('FIDU_PR_REPANTI');
        $sql = "SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = 'SYS_PRES-ANT'
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	# Saldo Inicial
                		(SELECT
                			IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                		FROM
                			$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                			AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                			AND GDVW.GL_TYPE = 'AS'
                			AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/
                			AND GDVW.EFFTDATE <='$this->sdate') INITBALANCE,
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN
                		AND GDVW.GL_TYPE = 'AS'
                		AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') LOANS,
                	0 BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->acconame ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 1
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                /*ORDER BY ACCO.IDENTIFICATION*/ UNION ALL SELECT ACCO.IDENTIFICATION,ACCO.IDNAME, (SELECT IFNULL(MAX(GDVW.EFFTDATE), '$this->edate') FROM $this->gdvwname GDVW WHERE GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE AND GDVW.TRANSTBL_CODE = 'SYS_PRES-ANT' AND GDVW.GL_TYPE = 'AS' AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/ AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,/* Saldo Inicial */ (SELECT IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0) FROM $this->gdvwname GDVW, $this->fiatname FIAT WHERE GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE AND FIAT.IDCODE = GDVW.TRANS_CODE AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02 AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN AND GDVW.GL_TYPE = 'AS' AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/ AND GDVW.EFFTDATE <='$this->sdate') INITBALANCE, (SELECT IFNULL(SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT), 0) FROM $this->gdvwname GDVW, $this->fiatname FIAT WHERE GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE AND FIAT.IDCODE = GDVW.TRANS_CODE AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02 AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_AN AND GDVW.GL_TYPE = 'AS' AND GDVW.TRUST_ITEM_TYPE = 'AD'/*713*/ AND GDVW.EFFTDATE >='$this->sdate' AND GDVW.EFFTDATE <='$this->edate') LOANS, 0 BALANCE FROM $this->prptname PRPT, $this->fipaname FIPA, $this->acconame ACCO WHERE PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE  AND FIPA.ACCOUNTCODE = ACCO.IDCODE AND PRPT.GL_PER_FIPA = 0 AND FIPA.PARTICIPANT_TYPE = 'G' AND FIPA.CONTRACT_CODE = '$this->chart_field01' AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE) FROM $this->prptname PRPTX WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01' AND PRPTX.CLX_EFFTDATE <='$this->edate') ORDER BY IDENTIFICATION";

        $summary = array();
        $summary[CLX_NUM_ZERO] = array('IDENTIFICATION' => '',
            'IDNAME' => dict('GEN_LBL_TOTAL'),
            'EFFTDATE' => '',
            'INITBALANCE' => '0',
            'LOANS' => '0',
            'BALANCE' => '0');
        $i = 1;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {
            //print_r($result);
            $summary[$i] = array('IDENTIFICATION' => $result['IDENTIFICATION'],
                'IDNAME' => $result['IDNAME'],
                'EFFTDATE' => (($result['EFFTDATE'] <> '') ? xFormat::date($result['EFFTDATE'], $this->date_format) : ''),
                'INITBALANCE' => $result['INITBALANCE'],
                'LOANS' => $result['LOANS'],
                'BALANCE' => $result['INITBALANCE']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['LOANS']);

            //Total Balance
            $summary[CLX_NUM_ZERO]['INITBALANCE'] = bcadd($summary[CLX_NUM_ZERO]['INITBALANCE'], $summary[$i]['INITBALANCE']);
            $summary[CLX_NUM_ZERO]['LOANS'] = bcadd($summary[CLX_NUM_ZERO]['LOANS'], $summary[$i]['LOANS']);
            $summary[CLX_NUM_ZERO]['BALANCE'] = bcadd($summary[CLX_NUM_ZERO]['BALANCE'], $summary[$i]['BALANCE']);

            //formating
            $summary[$i]['INITBALANCE'] = xFormat::number($summary[$i]['INITBALANCE']);
            $summary[$i]['LOANS'] = xFormat::number($summary[$i]['LOANS']);
            $summary[$i]['BALANCE'] = xFormat::number($summary[$i]['BALANCE']);

            $i++;
        }

        //End formating
        $summary[CLX_NUM_ZERO]['INITBALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['INITBALANCE']);
        $summary[CLX_NUM_ZERO]['LOANS'] = xFormat::number($summary[CLX_NUM_ZERO]['LOANS']);
        $summary[CLX_NUM_ZERO]['BALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['BALANCE']);
        $summary[] = $summary[CLX_NUM_ZERO];
        unset($summary[CLX_NUM_ZERO]);
        if ($this->send_pdf) {
            $variants = array();
            $headers = array(
                array(dict('FICO_CODE_CEDULA'), '20', 'C'),
                array(dict('FICO_CODE_NAME'), '60', 'L'),
                array(dict('FICO_CODE_DATE'), '20', 'C'),
                array(dict('FICO_CODE_SBALANCE'), '30', 'R'),
                array(dict('FICO_CODE_ANTICIPOS'), '30', 'R'),
                array(dict('FICO_CODE_BALANCE'), '30', 'R')
            );
            $variants[count($summary)] = array('font_face' => 'b');
            $this->build_pdf('P', $title, $headers, $summary, $variants, false, 'rep_pre_prestamos');
        } else {
            //Building Report Table
            $tableWidth = (int) CLX_NUM_ONE;
            $tableFrame = new htmlTable($tableWidth, CLX_PROP_WIDTH, CLX_PROP_100PCT);

            $tableFrame->addCell($this->comp_logo(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
            $this->showContract($tableFrame, $tableWidth);
            $this->showTitle($tableFrame, $tableWidth, false, $title);

            //$tableFrame->addcell('<h4>'.dict('FIDU_PR_REPSALDOS') . '</h4>',array(CLX_PROP_ALIGN=>CLX_PROP_LEFT, CLX_PROP_CLASS=>CLX_CLASS_TITLE));
            $table = new htmlTable(($tableWidth + 5), CLX_PROP_WIDTH, CLX_PROP_100PCT, CLX_PROP_CLASS, CLX_CLASS_FORM);
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_CEDULA') . '</b>', '<b>' . dict('FICO_CODE_NAME') . '</b>', '<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_SBALANCE') . '</b>', '<b>' . dict('FICO_CODE_ANTICIPOS') . '</b>', '<b>' . dict('FICO_CODE_BALANCE') . '</b>'));
            //$table->addcell('&nbsp;',CLX_PROP_COLSPAN,8);
            //build html
            $i = count($summary);
            $class = CLX_CLASS_DATA;
            foreach ($summary as $key => $val) {
                if ($i == $key)
                    $class = CLX_CLASS_HEADERS;
                $table->addcell($val['IDENTIFICATION'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['IDNAME'], array(CLX_PROP_CLASS => $class));
                $table->addcell((($val['EFFTDATE'] == '') ? '&nbsp' : $val['EFFTDATE']), array(CLX_PROP_CLASS => $class));
                $table->addcell($val['INITBALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['LOANS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['BALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
            }
            $tableFrame->addcell($table->source(), array());
            $this->showFooter($tableFrame, 1);
            $this->contents .= $tableFrame->source();
        }
        unset($summary, $variants, $table, $tableFrame, $tableWidth, $headers);
    }

//----------------------------------------------------------
// INCOME REPORT
//----------------------------------------------------------
    function income_start() {
        if (!$this->prompt('RTBL_PRE_INCO')) {
            return;
        } else {
            $this->contents = '';
            $this->income_report();
        }
    }

    /**
     * Resumen de saldos por contrato
     * Required parameters: $this->chart_field01, $this->comp_code, $this->sdate, $this->edate, $this->send_pdf
     */
    function income_report() {
        $title = dict('FIDU_PR_REPINCO');

        $sql = "SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	/* Prestamo*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') LOANS,
                	/*Intereses*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT - GDVW.DEBIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE IN ('IN','EX')
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') INTEREST,
                	0 BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->acconame ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 1
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                /*ORDER BY
                	ACCO.IDENTIFICATION*/
                UNION ALL
        		SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	/* Prestamo*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') LOANS,
                	/*Intereses*/
                	(SELECT
                		IFNULL(SUM(GDVW.CREDIT_AMT - GDVW.DEBIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE IN (PRPT.PRBE_OPER_IN, PRPT.PRBE_OPER_AP)
                		AND GDVW.GL_TYPE IN ('IN','EX')
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') INTEREST,
                	0 BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->acconame ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 0
                	AND FIPA.PARTICIPANT_TYPE = 'G'
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                ORDER BY
                	IDENTIFICATION";
        $summary = array();
        $summary[CLX_NUM_ZERO] = array('IDENTIFICATION' => '',
            'IDNAME' => dict('GEN_LBL_TOTAL'),
            'EFFTDATE' => '',
            'LOANS' => '0',
            'INTEREST' => '0',
            'BALANCE' => '0');
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {
            //print_r($result);
            $summary[$i] = array('IDENTIFICATION' => $result['IDENTIFICATION'],
                'IDNAME' => $result['IDNAME'],
                'EFFTDATE' => (($result['EFFTDATE'] <> '') ? xFormat::date($result['EFFTDATE'], $this->date_format) : ''),
                'LOANS' => $result['LOANS'],
                'INTEREST' => $result['INTEREST'],
                'BALANCE' => $result['BALANCE']);
            $summary[$i]['BALANCE'] = bcadd($summary[$i]['BALANCE'], $summary[$i]['LOANS']);

            //Sum values
            $summary[CLX_NUM_ZERO]['INTEREST'] = bcadd($summary[CLX_NUM_ZERO]['INTEREST'], $summary[$i]['INTEREST']);
            $summary[CLX_NUM_ZERO]['LOANS'] = bcadd($summary[CLX_NUM_ZERO]['LOANS'], $summary[$i]['LOANS']);
            $summary[CLX_NUM_ZERO]['BALANCE'] = bcadd($summary[CLX_NUM_ZERO]['BALANCE'], $summary[$i]['BALANCE']);

            //formating
            $summary[$i]['INTEREST'] = xFormat::number($summary[$i]['INTEREST']);
            $summary[$i]['LOANS'] = xFormat::number($summary[$i]['LOANS']);
            $summary[$i]['BALANCE'] = xFormat::number($summary[$i]['BALANCE']);
            $i++;
        }
        //formating

        $summary[CLX_NUM_ZERO]['LOANS'] = xFormat::number($summary[CLX_NUM_ZERO]['LOANS']);
        $summary[CLX_NUM_ZERO]['INTEREST'] = xFormat::number($summary[CLX_NUM_ZERO]['INTEREST']);
        $summary[CLX_NUM_ZERO]['BALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['BALANCE']);

        $summary[] = $summary[CLX_NUM_ZERO];
        unset($summary[CLX_NUM_ZERO]);
        if ($this->send_pdf) {
            $headers = array(
                array(dict('FICO_CODE_CEDULA'), '20', 'C'),
                array(dict('FICO_CODE_NAME'), '60', 'L'),
                array(dict('FICO_CODE_FECHAINGRESO'), '30', 'C'),
                array(dict('FICO_CODE_APORTES'), '30', 'R'),
                array(dict('FICO_CODE_INTERESTS'), '30', 'R'),
                array(dict('FICO_CODE_BALANCE'), '30', 'R')
            );
            $variants = array();
            $variants[count($summary)] = array('font_face' => 'b');
            $this->build_pdf('P', $title, $headers, $summary, $variants, false, 'rep_pre_prestamos');
        } else {
            //Building Report Table
            $tableWidth = (int) CLX_NUM_ONE;
            $tableFrame = new htmlTable($tableWidth, CLX_PROP_WIDTH, CLX_PROP_100PCT);

            $tableFrame->addCell($this->comp_logo(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
            $this->showContract($tableFrame, $tableWidth);
            $this->showTitle($tableFrame, $tableWidth, false, $title);

            $table = new htmlTable(($tableWidth + CLX_NUM_FIVE), CLX_PROP_WIDTH, CLX_PROP_100PCT, CLX_PROP_CLASS, CLX_CLASS_FORM);
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_CEDULA') . '</b>', '<b>' . dict('FICO_CODE_NAME') . '</b>', '<b>' . dict('FICO_CODE_FECHAINGRESO') . '</b>', '<b>' . dict('FICO_CODE_APORTES') . '</b>', '<b>' . dict('FICO_CODE_INTERESTS') . '</b>', '<b>' . dict('FICO_CODE_BALANCE') . '</b>'));
            //build html
            $i = count($summary);
            $class = CLX_CLASS_DATA;
            foreach ($summary as $key => $val) {
                if ($i == $key)
                    $class = CLX_CLASS_HEADERS;
                $table->addcell($val['IDENTIFICATION'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['IDNAME'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['EFFTDATE'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['LOANS'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['INTEREST'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
                $table->addcell($val['BALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
            }
            $tableFrame->addcell($table->source(), array());
            $this->showFooter($tableFrame, 1);
            $this->contents .= $tableFrame->source();
        }
        unset($summary, $variants, $table, $tableFrame, $tableWidth, $headers);
    }

//----------------------------------------------------------
// EXPENSE REPORT - DESINCORPORATIONS
//----------------------------------------------------------

    function expense_start() {
        if (!$this->prompt('RTBL_PRE_EXP')) {
            return;
        } else {
            $this->contents = '';
            $this->expense_report();
        }
    }

    /**
     * Resumen de saldos por contrato
     * Required parameters: $this->chart_field01, $this->comp, $this->sdate, $this->edate, $this->send_pdf
     */
    function expense_report() {


        $title = dict('FIDU_PR_REPDESINCORP');
        //Initial Balance
        $sql = "SELECT X.* FROM
        		  (SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	/**/
                	(SELECT
                			IFNULL(MAX(FIAT.DISBURSEMENT_TYPE), '')
                		FROM
                			$this->fiatname FIAT,
                			$this->gdvwname GDVW
                		WHERE
                			GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                			AND FIAT.IDCODE = GDVW.TRANS_CODE
                			AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                			AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                			AND GDVW.GL_TYPE = 'EQ'
                			AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                			AND GDVW.EFFTDATE >='$this->sdate'
                			AND GDVW.EFFTDATE <='$this->edate') PAYMENT_METHOD,
                	/**/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->fiatname ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 1
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                ORDER BY
                	ACCO.IDENTIFICATION) X
                WHERE X.BALANCE <> 0
                	 UNION ALL
               	SELECT X.*
        		FROM
        		  (SELECT
                	ACCO.IDENTIFICATION,
                	ACCO.IDNAME,
                	(SELECT
                		IFNULL(MAX(GDVW.EFFTDATE), '$this->edate')
                	FROM
                		$this->gdvwname GDVW, $this->fiatname FIAT
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND FIAT.IDCODE = GDVW.TRANS_CODE
                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') EFFTDATE,
                	/**/
                	(SELECT
                			IFNULL(MAX(FIAT.DISBURSEMENT_TYPE), '')
                		FROM
                			$this->fiatname FIAT,
                			$this->gdvwname GDVW
                		WHERE
                			GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
	                		AND FIAT.IDCODE = GDVW.TRANS_CODE
	                		AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02
	                		AND FIAT.BENEFICIARY_CODE = FIPA.ACCOUNTCODE
                			AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                			AND GDVW.GL_TYPE = 'EQ'
                			AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                			AND GDVW.EFFTDATE >='$this->sdate'
                			AND GDVW.EFFTDATE <='$this->edate') PAYMENT_METHOD,
                	/**/
                	(SELECT
                		IFNULL(SUM(GDVW.DEBIT_AMT), 0)
                	FROM
                		$this->gdvwname GDVW
                	WHERE
                		GDVW.CHART_FIELD01 = FIPA.CONTRACT_CODE
                		AND GDVW.CHART_FIELD02 = FIPA.ACCOUNTCODE
                		AND GDVW.TRANSTBL_CODE = PRPT.PRBE_OPER_DI
                		AND GDVW.GL_TYPE = 'EQ'
                		AND GDVW.TRUST_ITEM_TYPE = 'EQ'/*731*/
                		AND GDVW.EFFTDATE >='$this->sdate'
                		AND GDVW.EFFTDATE <='$this->edate') BALANCE
                FROM
                	$this->prptname PRPT,
                	$this->fipaname FIPA,
                	$this->fiatname ACCO
                WHERE
                	PRPT.CONTRACT_CODE = FIPA.CONTRACT_CODE
                	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
                	AND FIPA.CONTRACT_CODE = '$this->chart_field01'
                	AND PRPT.GL_PER_FIPA = 0
                	AND FIPA.PARTICIPANT_TYPE = 'G'
                	AND PRPT.CLX_EFFTDATE = (SELECT MAX(PRPTX.CLX_EFFTDATE)
                		FROM $this->prptname PRPTX
                		WHERE PRPTX.CONTRACT_CODE = '$this->chart_field01'
                		AND PRPTX.CLX_EFFTDATE <='$this->edate')
                ORDER BY
                	ACCO.IDENTIFICATION) X
                WHERE X.BALANCE <> 0";
        $summary = array();
        $i = CLX_NUM_ONE;
        $DBLT = &getTool('DBLT');
        $summary[CLX_NUM_ZERO] = array('IDENTIFICATION' => '',
            'IDNAME' => dict('GEN_LBL_TOTAL'),
            'EFFTDATE' => '',
            'PAYMENT_METHOD' => '',
            'BALANCE' => '0');
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {
            $summary[$i] = array('IDENTIFICATION' => $result['IDENTIFICATION'],
                'IDNAME' => $result['IDNAME'],
                'EFFTDATE' => xFormat::date($result['EFFTDATE'], $this->date_format),
                'PAYMENT_METHOD' => $DBLT->getListItem('DISB', $result['PAYMENT_METHOD']),
                'BALANCE' => $result['BALANCE']);

            $summary[CLX_NUM_ZERO]['BALANCE'] = bcadd($summary[CLX_NUM_ZERO]['BALANCE'], $summary[$i]['BALANCE']);
            //formating
            $summary[$i]['BALANCE'] = xFormat::number($summary[$i]['BALANCE']);
            $i++;
        }
        //formating
        $summary[CLX_NUM_ZERO]['BALANCE'] = xFormat::number($summary[CLX_NUM_ZERO]['BALANCE']);
        $summary[] = $summary[CLX_NUM_ZERO];
        unset($summary[CLX_NUM_ZERO]);
        if ($this->send_pdf) {
            $headers = array(
                array(dict('FICO_CODE_CEDULA'), '20', 'C'),
                array(dict('FICO_CODE_NAME'), '70', 'L'),
                array(dict('FICO_CODE_DATE'), '30', 'C'),
                array(dict('FICO_CODE_PAYMENTHOD'), '30', 'C'),
                array(dict('FICO_CODE_SALDO'), '30', 'R')
            );
            $variants = array();
            $variants[count($summary)] = array('font_face' => 'b');
            $this->build_pdf('P', $title, $headers, $summary, $variants, false, 'rep_pre_prestamos');
        } else {
            //Building Report Table
            $tableWidth = (int) 1;
            $tableFrame = new htmlTable($tableWidth, CLX_PROP_WIDTH, CLX_PROP_100PCT);

            $tableFrame->addCell($this->comp_logo(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
            $this->showContract($tableFrame, $tableWidth);
            $this->showTitle($tableFrame, $tableWidth, false, $title);

            $table = new htmlTable(($tableWidth + CLX_NUM_FOUR), CLX_PROP_WIDTH, CLX_PROP_100PCT, CLX_PROP_CLASS, CLX_CLASS_FORM);
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_CEDULA') . '</b>', '<b>' . dict('FICO_CODE_NAME') . '</b>', '<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_PAYMENTHOD') . '</b>', '<b>' . dict('FICO_CODE_SALDO') . '</b>'));
            //build html
            $i = count($summary);
            $class = CLX_CLASS_DATA;
            foreach ($summary as $key => $val) {
                if ($i == $key)
                    $class = CLX_CLASS_HEADERS;
                $table->addcell($val['IDENTIFICATION'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['IDNAME'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['EFFTDATE'], array(CLX_PROP_CLASS => $class));
                $table->addcell($val['PAYMENT_METHOD'], array(CLX_PROP_ALIGN => 'center', CLX_PROP_CLASS => $class));
                $table->addcell($val['BALANCE'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => $class));
            }
            $tableFrame->addcell($table->source(), array());
            $this->showFooter($tableFrame, CLX_NUM_ONE);
            $this->contents .= $tableFrame->source();
        }
        unset($summary, $variants, $table, $tableFrame, $tableWidth, $headers);
    }

}
