<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-05-08 11:21:10 +0000 (Tue, 08 May 2018) $
 * @version        $Rev: 9814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class redi_utitities {

    /**
     * Constructor
     */
    var $now;

	function redi_utitities() {
        multiTableName($this, array('RELO', 'REDI', 'LORE','RCJH','RCJL','REIV','REIL','REBA','	REDP'));
		$this->now = xFormat::getNow("Y-m-d H:i:s");
    }


// end method
    /**
     * SRRQ Validation
     *
     * @param array $msg
     * @param array $record
     * @return boolean
     */
    
	function init_form(&$record) {


	}
    
	function retr_init_form(&$record) {
        if (UserRequest::$request['ac'] == 'DUPLICATE') {
			  $record ['RETR_TRANS_STATUS']='PEND';
		 }	

	}    
	
	function load_form(&$record) {

    }

	function retr_validate_form(&$msg, &$record) {
        $status = true;  
		if ($record['RETR_TRANS_STATUS'] == 'PROC'){
			$msg ['RETR_TRANS_STATUS'] = dict('CODE_ERR_NOT_VALID');
			return false;
		}
        return $status;
	}
    
    function reiv_validate_form(&$msg, &$record) {
        $status = true;  
        $fact_pagada=false;
        if (UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'MODIFY' ){
            //verifico que la factura no haya sido pagada
            $sql = 'SELECT COUNT(REIV.ID) FROM REDI_INVOICES REIV WHERE REIV.IDCODE = '.singleQuote($record['REIV_IDCODE']).' AND REIV.REIV_STAT=' . singleQuote('CANC');
            $count = ClxCommon::$db->getOne($sql);
            if ($count>0){
                $fact_pagada=true;
            }    
            if ($fact_pagada==true){
                $msg ['REIV_REIV_STAT'] = dict('CODE_ERR_NOT_VALID');
                return false;
            }
            if ($record['REIV_REIV_STAT']=='CANC' && $fact_pagada==false){
                $msg ['REIV_REIV_STAT'] = dict('CODE_ERR_NOT_VALID');
                return false;
            }

        }
        return $status;
	}
	
	function reil_validate_form(&$msg, &$record) {
        $status = true;  

		if (UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'MODIFY'){
            $sql = 'SELECT INTEREST_PROV_AMT, INTEREST_PAY_AMT, REDISCOUNT_AMT, CAPITAL_PAY_AMT, PAYMENT_AMT, INT_CAPITALIZED_AMT FROM REDI_REDISCOUNTS REDI, REDI_INVOICES REIV WHERE REIV.IDCODE = '.singleQuote($record['REIL_REIV_CODE']).' AND REDI.COMP_CODE=REIV.COMP_CODE AND REDI.REDI_NO = ' . singleQuote($record['REIL_REDI_NO']);

            $results = ClxCommon::$db->executeQuery($sql);

            if ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                //Se verifica que el abono_capital+interes sea igual a la cuota
                if (($record['REIL_CAPITAL']+$record['REIL_INTEREST_AMT']-$record['REIL_LINE_AMT'])==0){
                    $record['REIL_OBSERVATION'] = '';
                }else{
                    $record['REIL_STATUS_LINE'] = '0';
                    $record['REIL_OBSERVATION'] = dict('CODE_ERR_REDI_NEQUAL_CUOTA');
                    $msg ['REIL_LINE_AMT'] = dict('CODE_ERR_REDI_NEQUAL_CUOTA');
                    return false;
                } 
                // se verifica que: Que el redescuento mantenga saldo pendiente de pago 
                // Intereses provisionados menos intereses pagados > 0 y
                // 	Monto Redescontado menos capital pagado > 0
                if (($result['INTEREST_PROV_AMT']-$result['INTEREST_PAY_AMT'])==0 && 
                    ($result['REDISCOUNT_AMT']-$result['CAPITAL_PAY_AMT'])==0 ){
                    $record['REIL_STATUS_LINE'] = '0';
                    $record['REIL_OBSERVATION'] .= ' '.dict('CODE_ERR_REDI_NOTSALDO');
                    $msg ['REIL_REDI_NO'] = dict('CODE_ERR_REDI_NOTSALDO');
                    return false;

                }

                //Se verifica que la cuota de la FACTURA debe ser menor o igual a la cuota del REDESCUENTO
                if ($record['REIL_LINE_AMT']>$result['PAYMENT_AMT']){
                    $record['REIL_STATUS_LINE'] = '0';
                    $record['REIL_OBSERVATION'] .= ' '.dict('CODE_ERR_CTRANS_CREDIS');
                    $msg ['REIL_LINE_AMT'] = dict('CODE_ERR_CTRANS_CREDIS');
                    return false;
                }

                //Se verifica que el monto de capital a pagar de la FACTURA debe ser menor o igual al saldo del REDESCUENTO

                $saldo=floatval($result['REDISCOUNT_AMT']-$result['CAPITAL_PAY_AMT']+$result['INT_CAPITALIZED_AMT']);

                if ($record['REIL_CAPITAL'] > $saldo){
                    $record['REIL_STATUS_LINE'] = '0';
                    $record['REIL_OBSERVATION'] .= ' '.dict('CODE_ERR_PAY_GRANT_SALDO');
                    $msg ['REIL_CAPITAL'] = dict('CODE_ERR_PAY_GRANT_SALDO');
                    return false;
                }
            }else{
                $record['REIL_STATUS_LINE'] = '0';
                $record['REIL_OBSERVATION'] =  dict('CODE_ERR_REDI_NOTEXIST');
                $msg ['REIL_REDI_NO'] = dict('CODE_ERR_REDI_NOTEXIST');


                //Se verifica que el abono_capital+interes sea igual a la cuota

                if (($record['REIL_CAPITAL']+$record['REIL_INTEREST_AMT'])!=$record['REIL_LINE_AMT']){
                    $record['REIL_OBSERVATION'] = dict('CODE_ERR_REDI_NEQUAL_CUOTA');
                    $msg ['REIL_LINE_AMT'] .= dict('CODE_ERR_REDI_NEQUAL_CUOTA');

                } 
                return false;
            }
            //Si pasa todas las validaciones entonces coloco la linea de la factura como valida y limpio campo Observaciones
            $record['REIL_OBSERVATION'] = '';
            $record['REIL_STATUS_LINE'] = '1';
        }    
        return $status;
	}


	function validateRedi(&$msg, &$record) {
  		$status = true;

		if (UserRequest::$request['ac'] == 'REQAUTHORIZATION' && $record['REDI_CLX_AUTH_STATUS'] == 'PEND'){ 
			//Verificar que existen prestamos vinculados al redescuento
			$sqt = ClxCommon::$db->countRecords($this->lorename, '	REDI_CODE = ' . singleQuote($record ['REDI_REDI_NO']));

			if ($sqt==0){
				$msg ['REDI_CLX_AUTH_STATUS'] = dict('CODE_ERR_NOT_LOIN');
				return false;
			}
			//verificamos que el monto del redescuento sea menor o igual a la suma de los prestamos
			$sql = 'SELECT SUM(RELO.CAPITAL_TOTAL) AS SUM_LOIN FROM REDI_LOANS RELO, REDI_RELO_REDI LORE  WHERE LORE.REDI_CODE = ' . singleQuote($record['REDI_REDI_NO']). ' AND  LORE.CODE_LOAN = RELO.LOAN_CD' ;
			$saldo = ClxCommon::$db->getOne($sql);
			if ($record['REDI_REDISCOUNT_AMT']>$saldo){
				addMessage(dict('GEN_LBL_ALERT_CAPITAL_MOUNT'));
				//$msg ['REDI_REDISCOUNT_AMT'] = dict('GEN_LBL_ALERT_CAPITAL_MOUNT');
				//return false; Mostramos solo alerta
			}
		}
		if (UserRequest::$request['ac'] == 'REQAUTHORIZATION' && $record['REDI_CLX_AUTH_STATUS'] != 'PEND') {
            $msg ['REDI_CLX_AUTH_STATUS'] = dict('CODE_ERR_NOT_VALID');
			return false;
        }
		
		if ($record['REDI_CLX_AUTH_STATUS'] == 'AP'){
			$msg ['REDI_CLX_AUTH_STATUS'] = dict('CODE_ERR_NOT_VALID');
			return false;
		}
		
		if (UserRequest::$request['ac'] == 'DELETE'){
			$idlist = UserRequest::$request['idlist'];
			$sql = 'SELECT REDI.CLX_AUTH_STATUS AS status FROM REDI_REDISCOUNTS REDI WHERE REDI.ID IN ('.$idlist.') AND REDI.CLX_AUTH_STATUS='.singleQuote('AP');
			$status = ClxCommon::$db->getOne($sql);

			if  ($status == 'AP'){
				$msg [''] = dict('CODE_ERR_NOT_VALID');
				return false;
			}	
		}
		
		if (UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'MODIFY'){
            //validando que monto redescontado sea mayor a cero
            if ($record['REDI_REDISCOUNT_AMT']==0){
				$msg ['REDI_REDISCOUNT_AMT'] = dict('CODE_ERR_REDISCOUNT_AMT');
				return false;
            }

            //validando que fecha de Redescuento no puede ser mayor o igual a la fecha de inicio y menos a la fecha de vencimiento
			$fecha_redesc = new DateTime($record['REDI_REDI_DATE']);
			$fecha_inicio = new DateTime($record['REDI_START_DATE']);
            $fecha_final  =  new DateTime($record['REDI_END_DATE']);
			if (!($fecha_redesc>=$fecha_inicio && $fecha_redesc<$fecha_final)){
				$msg ['REDI_REDI_DATE'] = dict('CODE_ERR_REDI_DATE');
				return false;
			}
			//Validando que la fecha de vencimiento del redescuento sea igual o mayor a la fecha de inicio
			if (!($fecha_final>=$fecha_inicio)){
				$msg ['REDI_END_DATE'] = dict('CODE_ERR_REDI_END_DATE');
				return false;
			}
		
		}
		return $status;
	}
	
	
	
	function validateReloRedi(&$msg, &$record){
		$status = true;
		$idlist = getIdlist();
		
		$sql = 'SELECT CLX_AUTH_STATUS AS status FROM REDI_REDISCOUNTS REDI WHERE REDI.REDI_NO = ' . singleQuote($record['LORE_REDI_CODE']);
		$status = ClxCommon::$db->getOne($sql);
		if ((UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'MODIFY') && $status == 'AP'){
			$msg ['LORE_REDI_CODE'] = dict('CODE_ERR_NOT_VALID');
			return false;
		}
		
		if (UserRequest::$request['ac'] == 'DELETE'){
			$sql = 'SELECT CLX_AUTH_STATUS AS status FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE WHERE REDI.REDI_NO = LORE.REDI_CODE AND LORE.ID =' . singleQuote($idlist[0]);
			$status = ClxCommon::$db->getOne($sql);
			if  ($status == 'AP'){
				$msg [''] = dict('CODE_ERR_NOT_VALID');
				return false;
			}
		}

		return $status;
		
	}
	
	
	function pre_update_relo_redi($record){
		//obtengo id del registro a modificar
		$id=UserRequest::$request['LORE_ID'];
		//actualizo registro de prestamo
		$sql='UPDATE REDI_LOANS RELO SET RELO.REDI_LOAN='.singleQuote('0'). ' WHERE RELO.LOAN_CD IN (SELECT LORE.CODE_LOAN FROM REDI_RELO_REDI LORE WHERE LORE.ID ='.singleQuote($id).')';
		//$sql = 'UPDATE REDI_LOANS RELO, REDI_RELO_REDI LORE SET RELO.REDI_LOAN='.singleQuote('0'). ' WHERE RELO.LOAN_CD = LORE.CODE_LOAN AND LORE.ID ='.singleQuote($id);
		ClxCommon::$db->executeQuery($sql);
		
	}
	
	function post_update_relo_redi($record){
		//actualizo registro de prestamo
		$sql = 'UPDATE REDI_LOANS RELO SET RELO.REDI_LOAN='.singleQuote('1'). ' WHERE RELO.LOAN_CD = '.singleQuote($record['CODE_LOAN']);
		ClxCommon::$db->executeQuery($sql);
	}
	
	
	function post_create_relo_redi($record){
		if (UserRequest::$request['ac'] == 'CREATE' ){
			$sql = 'UPDATE REDI_LOANS SET REDI_LOAN='.singleQuote('1'). ' WHERE LOAN_CD = '.singleQuote($record['CODE_LOAN']);
			ClxCommon::$db->executeQuery($sql);
		}
	}
	
	function post_delete_relo_redi($record){
		//actualizo registro de prestamo
		$sql = 'UPDATE REDI_LOANS RELO SET RELO.REDI_LOAN='.singleQuote('0'). ' WHERE RELO.LOAN_CD = '.singleQuote($record['LORE_CODE_LOAN']);
		ClxCommon::$db->executeQuery($sql);
    }
	
	//función para crear el comprobante contable
    function comp_contable(&$msg, $comp_code='', $type_comp, $rein_code = '', $fecha_ejec = ''){
		$status = true;
		$idlist = toString(getIdlist());
        /*if ($fecha_ejec==''){
			$fecha_ejec = $this->now; 
		}*/
		if ($type_comp=='COMP_SAP'){
			//verificamos que todos los redescuentos seleccionados esten aprobados
			$sql = 'SELECT COUNT(REDI.ID) AS COUNT_REDI FROM REDI_REDISCOUNTS REDI WHERE REDI.ID IN ('.$idlist.') AND CLX_AUTH_STATUS <> ' . singleQuote('AP');

			$count = ClxCommon::$db->getOne($sql);
			if ($count>0){
				//$msg ['LORE_REDI_CODE'] = dict('CODE_ERR_NOT_VALID');
				addMessage(dict('CODE_ERR_REDI_NOAP'));
				return false;
			}
			//verificamos que todos los redescuentos seleccionados pertenezcan  a una misma compañia
			$sql = 'SELECT COUNT(DISTINCT REDI.COMP_CODE) AS COUNT FROM REDI_REDISCOUNTS REDI WHERE REDI.ID IN ('.$idlist.')';


			$count = ClxCommon::$db->getOne($sql);
			if ($count>1){
				//$msg ['LORE_REDI_CODE'] = dict('CODE_ERR_NOT_VALID');
				addMessage(dict('CODE_ERR_REDI_COMPCODE'));
				return false;
			}else{
    			$sqlcomp = 'SELECT REDI.COMP_CODE FROM REDI_REDISCOUNTS REDI WHERE REDI.ID IN ('.$idlist.') group by REDI.COMP_CODE';
                $parcomp_code = ClxCommon::$db->getOneRecord($sqlcomp);
                $fecha_ejec = $this->get_date_operation($parcomp_code['COMP_CODE']);
            }

	    }

		if ($type_comp=='COMP_SAP'){
			//QUERY MATRIZ / REDESCUENTOS - DESEMBOLSOS
			$sql='SELECT REDI.COMP_CODE, REDI.REIN_CODE, SUM(RELO.CAPITAL_TOTAL) AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE REDI.ID IN ('.$idlist.') AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD group by REDI.COMP_CODE, REDI.REIN_CODE, REDI.CURRENCY_CODE';
		}
        if ($type_comp=='PROV_INT_PAG'){
			//QUERY MATRIZ / REDESCUENTOS - PROVISION INTERESES POR PAGAR
			//$fecha_actual=date('Y-m-d');
			$sql='SELECT REDI.COMP_CODE, REDI.REIN_CODE, SUM(RELO.CAPITAL_TOTAL) AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD AND REDI.COMP_CODE='.singleQuote($comp_code).' AND (REDI.REDISCOUNT_AMT-CAPITAL_PAY_AMT+INT_CAPITALIZED_AMT)>0 AND REDI.PASSIVE_RT>0 AND REDI.START_DATE<=TO_DATE('.singleQuote($fecha_ejec).', '.singleQuote('YYYY-MM-DD'). ') 
			GROUP BY REDI.COMP_CODE, REDI.REIN_CODE, REDI.CURRENCY_CODE' ;
            //echo $sql.'</br>';
		}
        if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
			//QUERY MATRIZ / REDESCUENTOS - PAGO ANTICIPADO DE FACTURA
            $sql='SELECT REDI.COMP_CODE, REIV.IDCODE, REIV.REIN_CODE, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
            WHERE REIL.REDI_NO=REDI.REDI_NO AND REIV.IDCODE=REIL.REIV_CODE AND REIV.ID = '.singleQuote($idlist). ' GROUP BY REDI.COMP_CODE, REIV.IDCODE, REIV.REIN_CODE, REDI.CURRENCY_CODE';

        }
		if ($type_comp=='AJUS_INT'){
			//QUERY MATRIZ / REDESCUENTOS - AJUSTE DE INTERESES 
			/*$sql='SELECT REDI.COMP_CODE, REDI.REIN_CODE, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI WHERE REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' AND REDI.COMP_CODE='.singleQuote($comp_code).' AND REIN_CODE = '.singleQuote($rein_code).' AND REDI.INTEREST_PROV_AMT-REDI.INTEREST_PAY_AMT!=0
			GROUP BY REDI.COMP_CODE, REDI.REIN_CODE, REDI.CURRENCY_CODE' ;*/
			$sql='SELECT REDI.COMP_CODE, REIV.IDCODE, REIV.REIN_CODE, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
            WHERE REIL.REDI_NO=REDI.REDI_NO AND REIV.IDCODE=REIL.REIV_CODE AND REIV.ID = '.singleQuote($idlist). ' GROUP BY REDI.COMP_CODE, REIV.IDCODE, REIV.REIN_CODE, REDI.CURRENCY_CODE';
            //echo $sql.'</br>';
		}
        if ($type_comp=='COMP_INT_CAP'){
			//QUERY MATRIZ / REDESCUENTOS - INTERESES CAPITALIZADOS
            $sql='SELECT RETR.COMP_CODE, RETR.REIN_CODE, RETR.CURRENCY_CODE FROM REDI_TRANSACTIONS RETR
			WHERE RETR.COMP_CODE = '.singleQuote($comp_code).' AND RETR.REIN_CODE = '.singleQuote($rein_code). ' AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).' AND RETR.REDI_TRXCD='.singleQuote('03').' AND  RETR.TRANS_STATUS='.singleQuote('PEND').' AND RETR.TRANS_AMT<>0 GROUP BY RETR.COMP_CODE, RETR.REIN_CODE, RETR.CURRENCY_CODE';
            //echo $sql.'</br>';
		}

		$results = ClxCommon::$db->executeQuery($sql);
        $fecha_real= $this->now;
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			//creando arreglo con info para el comprobante contable
            $jehd = Array();
            $fecha_ejec = $this->get_date_operation($result['COMP_CODE']);
			$jehd['IDCODE'] = 'AUTO'; 
			if ($type_comp=='COMP_SAP'){
				$jehd['IDNAME'] = 'Redescuento - Desembolsos';
			}
			if ($type_comp=='PROV_INT_PAG'){
				$jehd['IDNAME'] = 'Redescuento - Provisión de Intereses por Pagar';
			}

            if ($type_comp=='COMP_PAGO_ANT'){
				$jehd['IDNAME'] = 'Redescuento - Pago de Factura';
			}
            if ($type_comp=='COMP_PAGO_EXT'){
				$jehd['IDNAME'] = 'Redescuento - Pago de Factura Extraordinario';
			}
            if ($type_comp=='AJUS_INT'){
				$jehd['IDNAME'] = 'Redescuento - Ajuste de Intereses';
			}
			if ($type_comp=='COMP_INT_CAP'){
				$jehd['IDNAME'] = 'Redescuento - Capitalización de Intereses';
			}

			$jehd['COMP_CODE'] = $result['COMP_CODE'];
			$jehd['RCLE_CODE'] = '';
			$jehd['RCAP_CODE'] = '';
			$jehd['EFFTDATE'] = $fecha_ejec;
			$jehd['REAL_DATE'] = $fecha_real;
			$jehd['JE_STATUS'] = 'AP';
			$jehd['CLX_AUTH_STATUS'] = 'AP';
			$jehd['JEEXP_STAT'] = '';
			$jehd['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
			$jehd['CDATE'] = $fecha_real;			
			$jehd['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
			$jehd['MDATE'] = $fecha_real;			
			$jehd['MODIFIEDBY']	= $_SESSION ['user_record'] ['username'];		

            if (!function_exists('setCreationData'))
					includeCodeLib('GEN_REC_UTIL');
			if ($jehd['IDCODE'] == 'AUTO') {
				setCreationIdCode($jehd, 'RCJH');
			}
			//creando comprobante contable
			ClxCommon::$db->createRecord($this->rcjhname, $jehd, TRUE);

			//Pago de facturas
            if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
                $sql2='SELECT REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, REDI.CURRENCY_CODE, REIL.CAPITAL, REIL.INTEREST_AMT, REIL.LINE_AMT MONTO FROM REDI_REDISCOUNTS REDI, REDI_INVOICE_LINES REIL WHERE REDI.COMP_CODE = '.singleQuote($result['COMP_CODE']).' AND REIL.REDI_NO = REDI.REDI_NO AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']).' AND REIL.REIV_CODE = '.singleQuote($result['IDCODE']);
			}
            //Desembolso
            if ($type_comp=='COMP_SAP'){
                $sql2='SELECT REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT AS MONTO, REDI.CAPITAL_PAY_AMT AS MONTO_PAY, REDI.PASSIVE_RT AS TASA_PASIVA, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE REDI.ID IN ('.$idlist.') AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']) .' AND REDI.CLX_AUTH_STATUS = '.singleQuote('AP').'  group by REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.PASSIVE_RT, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE';
            }
            //Provisión de intereses 
			if ($type_comp=='PROV_INT_PAG'){
                $sql2='SELECT '.singleQuote($fecha_ejec).' EFFTDATE, REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT AS MONTO, REDI.CAPITAL_PAY_AMT AS MONTO_PAY, REDI.PASSIVE_RT AS TASA_PASIVA, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE REDI.COMP_CODE='.singleQuote($comp_code).' AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']) .' AND REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' AND (REDI.REDISCOUNT_AMT-CAPITAL_PAY_AMT+INT_CAPITALIZED_AMT)>0 AND REDI.PASSIVE_RT>0 AND REDI.START_DATE<=TO_DATE('.singleQuote($fecha_ejec).', '.singleQuote('YYYY-MM-DD'). ')  group by REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.PASSIVE_RT, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE';
				//echo $sql2.'</br>';
            }

            //Ajuste de intereses
            if ($type_comp=='AJUS_INT'){
                /*$sql2='SELECT REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, (REDI.INTEREST_PAY_AMT-REDI.INTEREST_PROV_AMT) AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI WHERE REDI.COMP_CODE='.singleQuote($comp_code).' AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']) .' AND REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' AND REDI.INTEREST_PROV_AMT-REDI.INTEREST_PAY_AMT!=0';*/
                $sql2='SELECT REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, (REDI.INTEREST_PAY_AMT-REDI.INTEREST_PROV_AMT) AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_INVOICE_LINES REIL WHERE REDI.COMP_CODE = '.singleQuote($result['COMP_CODE']).' AND REIL.REDI_NO = REDI.REDI_NO AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']).' AND REIL.REIV_CODE = '.singleQuote($result['IDCODE']);
			}
			
			//Capitalización de Intereses
            if ($type_comp=='COMP_INT_CAP'){
				$sql2='SELECT REDI.COMP_CODE, REDI.REIN_CODE, REDI.REDI_NO, RETR.TRANS_AMT AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_TRANSACTIONS RETR WHERE REDI.COMP_CODE = '.singleQuote($result['COMP_CODE']).' AND RETR.REDI_CODE = REDI.REDI_NO AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']).' AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).' AND RETR.TRANS_STATUS='.singleQuote('PEND').' AND RETR.REDI_TRXCD='.singleQuote('03').' AND RETR.TRANS_AMT<>0';
			}
			//OJO
			//SE INCORPORO LA MONEDA EN LOS CRITERIOS PARA NO LIGAR PERAS CON MANZANAS

            $results2 = ClxCommon::$db->executeQuery($sql2);
			//echo $sql2;
			//$seqnum=1;

			$lcuenta_contable_cr = Array();
			$lcuenta_contable_db = Array();
			while ($result2 = ClxCommon::$db->getNextRecord($results2, ASSOCIATIVE)) {
				//buscar cuenta contable en programa de redescuento
				$sql3='SELECT REPG.RCAC_CODE1, REPG.RCAC_CODE2, REPG.RCAC_CODE3, REPG.RCAC_CODE4 FROM REDI_REDISCOUNTS REDI, REDI_PROGRAMS_TBL REPG 
				WHERE REDI.REPG_CODE=REPG.IDCODE AND REPG.REIN_CODE=REDI.REIN_CODE AND REDI.REDI_NO='.singleQuote($result2['REDI_NO']);

				//echo $sql3;
                $cuenta_contable = ClxCommon::$db->getOneRecord($sql3);
				
				$monto=0;
				if ($type_comp=='COMP_SAP'){
					$monto=$result2['MONTO'];
                    $item_ref_no='';
					//$cuenta_contable_cr=$cuenta_contable['RCAC_CODE1'];
					//$cuenta_contable_db=$cuenta_contable['RCAC_CODE2'];

					$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] + $monto;
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE2']] =
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE2']] + $monto;	
				}
				if ($type_comp=='PROV_INT_PAG'){
				    $monto=$this->calcular_int_provisionados($result2);
                    $item_ref_no='';
					//$cuenta_contable_cr=$cuenta_contable['RCAC_CODE3'];
					//$cuenta_contable_db=$cuenta_contable['RCAC_CODE4'];
					
					$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] + $monto;
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE4']] =
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE4']] + $monto;	
				}
				if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
					//Si es un pago de factura se deben hacer 4 lineas, dos para el capital y dos para los intererses pagados con cada redescuento
                    //siempre y cuando sea distinto de cero
                    //comenzamos con el capital
                    $monto=$result2['CAPITAL'];
                    $item_ref_no=$result['IDCODE'];
					//$cuenta_contable_cr=$cuenta_contable['RCAC_CODE2'];
					//$cuenta_contable_db=$cuenta_contable['RCAC_CODE1'];
					
					$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE2']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE2']] + $monto;
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE1']] =
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE1']] + $monto;	

				}
                if ($type_comp=='AJUS_INT'){
                    $monto=$result2['MONTO'];
                    $item_ref_no='';
                    //Si la diferencia del Ajuste es cero...no se genera linea contable
                    if ($monto>0){
					    //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE3'];
					    //$cuenta_contable_db=$cuenta_contable['RCAC_CODE4'];
						
						$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] + $monto;
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE4']] =
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE4']] + $monto;	
                    }
                    if ($monto<0){
					    //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE4'];
					    //$cuenta_contable_db=$cuenta_contable['RCAC_CODE3'];
						
						//cuando sea negativo lo convierto a positivo para crear la linea contable correctamente
						$monto=$monto*-1; 
						
						$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE4']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE4']] + $monto;
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] =
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] + $monto;	
                    }
                }    


                if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
                    if ($result2['INTEREST_AMT']>0){
                        //Si es un pago de factura se deben hacer 2 lineas mas para los intererses pagados con cada redescuento
                        //siempre y cuando sea distinto de cero
                        $monto=$result2['INTEREST_AMT'];
                        //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE2'];
                        //$cuenta_contable_db=$cuenta_contable['RCAC_CODE3'];
						
						$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE2']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE2']] + $monto;
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] =
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] + $monto;					
                    }   
                }
				
                if ($type_comp=='COMP_INT_CAP'){
                    $monto=$result2['MONTO'];
                    $item_ref_no='';
                    if ($monto>0){
					    //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE1'];
					    //$cuenta_contable_db=$cuenta_contable['RCAC_CODE3'];
						$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] + $monto;
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] =
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE3']] + $monto;	

                    }else{
					    //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE3'];
					    //$cuenta_contable_db=$cuenta_contable['RCAC_CODE1'];

						//cuando sea negativo lo convierto a positivo para crear la linea contable correctamente
						$monto=$monto*-1; 
						$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE3']] + $monto;
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE1']] =
						$lcuenta_contable_db[$cuenta_contable['RCAC_CODE1']] + $monto;	

                    }
                }    


				if ($type_comp=='PROV_INT_PAG'){
					$this->update_int_provisionados($result2, $monto);
				}
                if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
					//actualizamos el capital e interes del redescuento
                    $this->update_capital_intereses($result2, $result2['CAPITAL'],$result2['INTEREST_AMT']);
                }
                if ($type_comp=='COMP_PAGO_EXT'){
					//actualizamos el abono extraordinario del redescuento
                    $this->update_abono_extraordinario($result2, $result2['MONTO']);
                }
                if ($type_comp=='AJUS_INT'){
					//actualizamos el ajuste de intereses
                    $this->update_ajuste($result2, $result2['MONTO']);
                }
				if ($type_comp=='COMP_INT_CAP'){
					$this->update_int_cap($result2, $result2['MONTO']);
				}
			}
			//pre($lcuenta_contable_cr);
			//pre($lcuenta_contable_db);
			//Ahora construyo las lineas del comprobante contable
			$seqnum=1;

			//CREDITO
			$jeln = Array();
			foreach($lcuenta_contable_cr as $key => $val) {
                //print "$key = $val <br>";
				$cuenta_contable = ''.$key;
				$monto = round($val, 2);
				$jeln['RCJH_CODE'] = $jehd['IDCODE']; 
                $jeln['SEQNUM'] = $seqnum;
                $jeln['RCAC_CODE'] = $cuenta_contable; 
                $jeln['IDNAME'] = $jehd['IDNAME'];
                $jeln['ITEM_REF_NO'] = $item_ref_no;
				$jeln['ALLOCATION_NO'] = $_SESSION ['user_record'] ['username'];
				$jeln['PRCT_CODE'] = 'HN01100316';
				$jeln['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
				$jeln['EXCHANGE_RT'] = 1;

				$jeln['DEBIT_AMT'] = 0;
				$jeln['DEBIT_TRANS_AMT'] = 0;
				$jeln['CREDIT_AMT'] = $monto;
				$jeln['CREDIT_TRANS_AMT'] = $monto;
 
				//creando linea de comprobante contable (CREDITO) 
                ClxCommon::$db->createRecord($this->rcjlname, $jeln, TRUE);
				$seqnum++;
			}
			
			//pre($jeln);
			
			//DEBITO
			$jeln = Array();
			foreach($lcuenta_contable_db as $key => $val) {
                //print "$key = $val <br>";
				$cuenta_contable = ''.$key;
				$monto = round($val, 2);
				$jeln['RCJH_CODE'] = $jehd['IDCODE']; 
                $jeln['SEQNUM'] = $seqnum;
                $jeln['RCAC_CODE'] = $cuenta_contable; 
                $jeln['IDNAME'] = $jehd['IDNAME'];
                $jeln['ITEM_REF_NO'] = $item_ref_no;
				$jeln['ALLOCATION_NO'] = $_SESSION ['user_record'] ['username'];
				$jeln['PRCT_CODE'] = 'HN01100316';
				$jeln['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
				$jeln['EXCHANGE_RT'] = 1;

				$jeln['DEBIT_AMT'] = $monto;
				$jeln['DEBIT_TRANS_AMT'] = $monto;
				$jeln['CREDIT_AMT'] = 0;
				$jeln['CREDIT_TRANS_AMT'] = 0;
 
				//creando linea de comprobante contable (DEBITO) 
                ClxCommon::$db->createRecord($this->rcjlname, $jeln, TRUE);
				$seqnum++;
			}
			//pre($jeln);
		}
        if ($type_comp!='AJUS_INT'){  
            addMessage(dict('CODE_COMP_CONT_EXITO'));
		}
	    //Función para registrar historico de saldos de Redescuento
        $efftdate = xFormat::getNow("Y-m-d");
        $this->reg_saldo_redescuento($idlist, $type_comp, $efftdate, $comp_code, $fecha_ejec, $rein_code);	
    }


//función que calcula los intereses provisionados
function calcular_int_provisionados($record){
	$monto=0;
	$fraccion=1;

	//FORMULA: ((Monto Redescontado – Capital Pagado + intereses capitalizados) * (Tasa Pasiva/100) * 30 )/ 360
	$monto=(($record['MONTO']-$record['MONTO_PAY']+$record['INT_CAPITALIZED_AMT'])*($record['TASA_PASIVA']/100)*1)/360;

    //ANTES DE OBTENER EL MONTO DEBEMOS VERIFICAR SI ESTAMOS EN EL ULTIMO DÍA DEL MES ACTUAL 
	//DIA 28 SE MULTIPLICA POR 3 EL MONTO
	//DIA 29 SE MULTIPLICA POR 2 EL MONTO
	//DIAS 1-27 y 30 ES IGUAL AL MONTO CALCULADO

	$fecha = explode('-', $record['EFFTDATE']);
	$diaproceso = intval($fecha[2]);
	$mesproceso = intval($fecha[1]);
	$anoproceso = intval($fecha[0]);
	$dias_mes = cal_days_in_month(CAL_GREGORIAN, $mesproceso, $anoproceso); //Obtengo el numero de días del mes

	if ($dias_mes == 28 && $diaproceso == 28){
		$fraccion=3;
	}
	if ($dias_mes == 29 && $diaproceso == 29){
		$fraccion=2;
	}

    return round($monto*$fraccion, 2);
}

//función que actualiza los intereses provisionados en el redescuento
function update_int_provisionados($record, $monto){
	$sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.INTEREST_PROV_AMT = REDI.INTEREST_PROV_AMT + '.$monto.' where REDI.COMP_CODE='.singleQuote($record['COMP_CODE']).' AND REDI.REDI_NO='.singleQuote($record['REDI_NO']);
	ClxCommon::$db->executeQuery($sql);

}

//función que actualiza el capital e intereses pagados de un redescuento
function update_capital_intereses($record, $capital, $interes){
    $sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.CAPITAL_PAY_AMT = REDI.CAPITAL_PAY_AMT  + '.$capital.' , REDI.INTEREST_PAY_AMT = REDI.INTEREST_PAY_AMT + '.$interes.'  WHERE REDI.COMP_CODE ='.singleQuote($record['COMP_CODE']).' AND REDI.REDI_NO='.singleQuote($record['REDI_NO']);
    ClxCommon::$db->executeQuery($sql);
}

//función que actualiza el pago extraordinario de un redescuento    
 function update_abono_extraordinario($record, $monto_extraord){
	$sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.ABONO_EXTRAORD = REDI.ABONO_EXTRAORD  + '.$monto_extraord.' where REDI.COMP_CODE ='.singleQuote($record['COMP_CODE']).' AND REDI.REDI_NO='.singleQuote($record['REDI_NO']);
	ClxCommon::$db->executeQuery($sql);
 }    

//función que actualiza el ajuste de intereses    
 function update_ajuste($record, $monto_ajuste){
	$sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.INTEREST_PROV_AMT = REDI.INTEREST_PROV_AMT  + '.$monto_ajuste.' where REDI.COMP_CODE ='.singleQuote($record['COMP_CODE']).' AND REDI.REDI_NO='.singleQuote($record['REDI_NO']);
	ClxCommon::$db->executeQuery($sql);
 }
	
//funcion para actualizar los intereses capitalizados
 function update_int_cap($record, $monto_ajuste){
	$sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.INT_CAPITALIZED_AMT = REDI.INT_CAPITALIZED_AMT  + '.$monto_ajuste.' where REDI.COMP_CODE ='.singleQuote($record['COMP_CODE']).' AND REDI.REDI_NO='.singleQuote($record['REDI_NO']);
	ClxCommon::$db->executeQuery($sql);
 }

//función para cargar las transacciones de abono en una factura
function carga_transacciones_abono($parameters, $tipo_transaccion){
    //verificamos si viene fecha en el parametro del proceso
    if ($parameters['EFFTDATE']==''){
        $fecha_ejec = $this->get_date_operation($parameters['COMP_CODE']);
	}else{
		$fecha_ejec = $parameters['EFFTDATE'];
	}
	$fecha_reg=$this->now;
	//Seleccionamos solo transacciones de abono (4) o (5)
    $criteria='WHERE RETR.COMP_CODE = '.singleQuote($parameters['COMP_CODE']).' AND RETR.REDI_TRXCD = '. singleQuote($tipo_transaccion) .' AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).' AND RETR.TRANS_STATUS = '.singleQuote('PEND');
    //verificamos si obtenemos todos los entes redescontantes o uno en particular
    if ($parameters['REIN_CODE']!=''){
         $criteria .= ' AND RETR.REIN_CODE = '.singleQuote($parameters['REIN_CODE']); 
    } 
    //obtenemos los entes redescontantes
    $sql = 'SELECT RETR.REIN_CODE, RETR.TRANS_DATE FROM REDI_TRANSACTIONS RETR ' .$criteria . ' GROUP BY RETR.REIN_CODE, RETR.TRANS_DATE';

    $results = ClxCommon::$db->executeQuery($sql);
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		//creando arreglo con el encabezado de la factura 
		$reiv = Array();
		$reiv['IDCODE'] = 'AUTO'; 
        $reiv['COMP_CODE'] = $parameters['COMP_CODE']; 
		if ($tipo_transaccion=='04'){
            $reiv['IDNAME'] = 'Redescuento - Pago Mensual';
        }else{
            $reiv['IDNAME'] = 'Redescuento - Pago Extraordinario';
        }    
		$reiv['REIN_CODE'] = $result['REIN_CODE'];
		$reiv['INVOICE_DATE'] = $result['TRANS_DATE'];
        $reiv['EXPIRATION_DATE'] = $result['TRANS_DATE'];
        $reiv['REIV_STAT'] = 'ACT';
        $reiv['CDATE'] = $fecha_reg;			
		$reiv['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
		$reiv['MDATE'] = $fecha_reg;			
		$reiv['MODIFIEDBY']	= $_SESSION ['user_record'] ['username'];		


		if (!function_exists('setCreationData'))
			includeCodeLib('GEN_REC_UTIL');
		if ($reiv['IDCODE'] == 'AUTO') {
			setCreationIdCode($reiv, 'REIV');
		}
		//creando cabecera de la factura
        ClxCommon::$db->createRecord($this->reivname, $reiv, TRUE);

        //obtenemos las transacciones del ente redescontante

        $sql2 = 'SELECT RETR.COMP_CODE, RETR.REIN_CODE, RETR.REDI_CODE, RETR.TRANS_DATE, RETR.ABONO_CAPITAL, RETR.INTPAID_AMT, RETR.TRANS_AMT, RETR.CURRENCY_CODE FROM REDI_TRANSACTIONS RETR WHERE RETR.COMP_CODE = '.singleQuote($parameters['COMP_CODE']).' AND RETR.REIN_CODE = '. singleQuote($result['REIN_CODE']) .' AND RETR.TRANS_STATUS = '. singleQuote('PEND') . ' AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).'  AND RETR.REDI_TRXCD = '. singleQuote($tipo_transaccion);

        $results2 = ClxCommon::$db->executeQuery($sql2);
        $seqnum=1;
        while ($result2 = ClxCommon::$db->getNextRecord($results2, ASSOCIATIVE)) {
            //verificamos si existe el redescuento  
            $sql3 = 'SELECT INTEREST_PROV_AMT, INTEREST_PAY_AMT, REDISCOUNT_AMT, CAPITAL_PAY_AMT, PAYMENT_AMT FROM REDI_REDISCOUNTS REDI WHERE REDI.COMP_CODE='.singleQuote($result2 ['COMP_CODE']).' AND REDI.REDI_NO = ' . singleQuote($result2 ['REDI_CODE']);
            $results3 = ClxCommon::$db->executeQuery($sql3);

            $reil = Array();
            $reil['REIV_CODE'] = $reiv['IDCODE']; 
            $reil['LINE_NO'] = $seqnum;
            $reil['REDI_NO'] = $result2['REDI_CODE'];

			if ($result3 = ClxCommon::$db->getNextRecord($results3, ASSOCIATIVE)) {
                $reil['CAPITAL'] = $result2['ABONO_CAPITAL'];
                $reil['INTEREST_AMT'] = $result2['INTPAID_AMT'];
                $reil['LINE_AMT'] = $result2['TRANS_AMT'];
                $reil['STATUS_LINE'] = '1';
                //Se verifica que el abono_capital+interes sea igual a la cuota
                if (($result2['ABONO_CAPITAL']+$result2['INTPAID_AMT']-$result2['TRANS_AMT'])==0){
                    $reil['OBSERVATION'] = '';
                }else{
                    $reil['STATUS_LINE'] = '0';
                    $reil['OBSERVATION'] = dict('CODE_ERR_REDI_NEQUAL_CUOTA');
                } 
                // se verifica que: Que el redescuento mantenga saldo pendiente de pago 
                // Intereses provisionados menos intereses pagados > 0 y
                // 	Monto Redescontado menos capital pagado > 0
                if (($result3['INTEREST_PROV_AMT']-$result3['INTEREST_PAY_AMT'])==0 && 
                    ($result3['REDISCOUNT_AMT']-$result3['CAPITAL_PAY_AMT'])==0 ){
                    $reil['STATUS_LINE'] = '0';
                    $reil['OBSERVATION'] .= ' '.dict('CODE_ERR_REDI_NOTSALDO');
                }
				
				//Se verifica que la cuota de la FACTURA debe ser menor o igual a la cuota del REDESCUENTO
                if (($result2['TRANS_AMT']>$result3['PAYMENT_AMT'])&&$tipo_transaccion=='04'){
                    $reil['STATUS_LINE'] = '0';
                    $reil['OBSERVATION'] .= ' '.dict('CODE_ERR_CTRANS_CREDIS');
                }
				
				//Se verifica que el monto de capital a pagar de la FACTURA debe ser menor o igual al saldo del REDESCUENTO
                $saldo=$result3['REDISCOUNT_AMT']-$result3['CAPITAL_PAY_AMT']+$result3['INT_CAPITALIZED_AMT'];
				if ($result2['ABONO_CAPITAL']>$saldo){
                    $reil['STATUS_LINE'] = '0';
                    $reil['OBSERVATION'] .= ' '.dict('CODE_ERR_PAY_GRANT_SALDO');
                }
			}else{
                $reil['CAPITAL'] = $result2['ABONO_CAPITAL'];
                $reil['INTEREST_AMT'] = $result2['INTPAID_AMT'];
                $reil['LINE_AMT'] = $result2['TRANS_AMT'];
                $reil['STATUS_LINE'] = '0';
                $reil['OBSERVATION'] =  dict('CODE_ERR_REDI_NOTEXIST');

                //Se verifica que el abono_capital+interes sea igual a la cuota
                if (($result2['ABONO_CAPITAL']+$result2['INTPAID_AMT'])!=$result2['TRANS_AMT']){
                    $reil['OBSERVATION'] .= '. '.dict('CODE_ERR_REDI_NEQUAL_CUOTA');
                } 
            }

        	//creando lineas de la factura
		    ClxCommon::$db->createRecord($this->reilname, $reil, TRUE);
            $seqnum++;

        }
        //Actualizamos el status de las trasacciones procesadas
        $sql4 = 'UPDATE REDI_TRANSACTIONS RETR SET RETR.TRANS_STATUS = '. singleQuote('PROC').' '.$criteria;
        ClxCommon::$db->executeQuery($sql4);
    }    



} 

//Función para cambia el status de la factura a Pagada
function cambiar_factura_pagada($record, $capital, $interes){
	$sql='UPDATE REDI_REDISCOUNTS REDI SET MDATE=CURRENT_TIMESTAMP, REDI.CAPITAL_PAY_AMT = REDI.CAPITAL_PAY_AMT  + '.$capital.' , REDI.INTEREST_PAY_AMT = REDI.INTEREST_PAY_AMT + '.$interes.'  where REDI.REDI_NO='.singleQuote($record['REDI_NO']);

	ClxCommon::$db->executeQuery($sql);

}

//Funcion para procesar pagos de factura    
function proc_pagos_factura($tipo_pago){
    $idlist = getIdlist();
    $criteria_tipo_fact='';
    if ($tipo_pago=='04'){
       $criteria_tipo_fact='Redescuento - Pago Mensual';
    }
    if ($tipo_pago=='05'){
       $criteria_tipo_fact='Redescuento - Pago Extraordinario';
    }

    //validar que la factura corresponda al tipo de pago que se quiere efectuar
    $sql='SELECT COUNT(REIV.ID) FROM REDI_INVOICES REIV WHERE REIV.ID = '.singleQuote($idlist[0]). ' AND REIV.IDNAME = '.singleQuote($criteria_tipo_fact);
    $count = ClxCommon::$db->getOne($sql);
	if ($count==0 ){
		addMessage(dict('CODE_ERR_INVO_TYPE'));
		return false;
	}

    //validar que la factura tenga estatus de Vigente para procesar su pago
    $sql='SELECT COUNT(REIV.ID) FROM REDI_INVOICES REIV WHERE REIV.ID = '.singleQuote($idlist[0]). ' AND REIV.REIV_STAT = '.singleQuote('ACT');
    $count = ClxCommon::$db->getOne($sql);
	if ($count==0){
		addMessage(dict('CODE_ERR_INVO_STATUS'));
		return false;
	}


    //validar que las lineas de la factura no tenga lineas inactivas
    $sql='SELECT COUNT(REIL.ID) FROM REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
    WHERE REIV.IDCODE = REIL.REIV_CODE AND REIL.STATUS_LINE = '.singleQuote('0') .' AND REIV.ID = '.singleQuote($idlist[0]);

    $count = ClxCommon::$db->getOne($sql);
	if ($count>0){
		addMessage(dict('CODE_ERR_INVO_LINE_INACT'));
		return false;
	}

    //Si factura tiene sus lineas bien generamos comprobante contable del pago
	if ($tipo_pago=='04'){
        $this->comp_contable($msg, '', 'COMP_PAGO_ANT');
    }
	if ($tipo_pago=='05'){
        $this->comp_contable($msg, '', 'COMP_PAGO_EXT');
    }

	//Luego de pagar factura entonces ejecutamos el ajuste de intereses
    //Solo si la factura tiene lineas donde se paga intereses
	$sql='SELECT COUNT(REIL.ID) FROM REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
    WHERE REIV.IDCODE = REIL.REIV_CODE AND REIL.STATUS_LINE = '.singleQuote('1') .' AND REIV.ID = '.singleQuote($idlist[0]).' AND REIL.INTEREST_AMT <> 0';
    $count = ClxCommon::$db->getOne($sql);
    if ($count>0){
        $this->comp_contable($msg, '', 'AJUS_INT');
    }

    //Cambiamos el status de la factura a Pagada
    $sql='UPDATE REDI_INVOICES REIV SET REIV.REIV_STAT = '.singleQuote('CANC') .' WHERE REIV.ID = '.singleQuote($idlist[0]);
    ClxCommon::$db->executeQuery($sql);

}


  	//función para crear el comprobante contable en procesos batch
	function comp_contable_batch($type_comp){
		$status = true;

		if ($type_comp=='COMP_SAP'){ //BATCH
			//QUERY MATRIZ / REDESCUENTOS - DESEMBOLSOS
			$sql='SELECT REDI.COMP_CODE, REDI.REIN_CODE, SUM(RELO.CAPITAL_TOTAL) AS MONTO, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE LORE.LOG_ID=-1 AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD group by REDI.COMP_CODE, REDI.REIN_CODE, REDI.CURRENCY_CODE';
		}


		$results = ClxCommon::$db->executeQuery($sql);
        $fecha_reg = $this->now;
		while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			//creando arreglo con info para el comprobante contable
			$jehd = Array();
            $fecha_ejec = $this->get_date_operation($result['COMP_CODE']);
			$jehd['IDCODE'] = 'AUTO'; 
			if ($type_comp=='COMP_SAP'){
				$jehd['IDNAME'] = 'Redescuento - Desembolsos';
			}

			$jehd['COMP_CODE'] = $result['COMP_CODE'];
			$jehd['RCLE_CODE'] = '';
			$jehd['RCAP_CODE'] = '';
			$jehd['EFFTDATE'] = $fecha_ejec;
			$jehd['REAL_DATE'] = $fecha_reg;
			$jehd['JE_STATUS'] = 'AP';
			$jehd['CLX_AUTH_STATUS'] = 'AP';
			$jehd['JEEXP_STAT'] = '';
			$jehd['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
			$jehd['CDATE'] = $fecha_reg;			
			$jehd['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
			$jehd['MDATE'] = $fecha_reg;			
			$jehd['MODIFIEDBY']	= $_SESSION ['user_record'] ['username'];		

			if (!function_exists('setCreationData'))
					includeCodeLib('GEN_REC_UTIL');
			if ($jehd['IDCODE'] == 'AUTO') {
				setCreationIdCode($jehd, 'RCJH');
			}
			//creando comprobante contable
			ClxCommon::$db->createRecord($this->rcjhname, $jehd, TRUE);

            //Desembolso y Provisión de intereses
            if ($type_comp=='COMP_SAP'){ //BATCH COMP_SAP
                $sql2='SELECT REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT AS MONTO, REDI.CAPITAL_PAY_AMT AS MONTO_PAY, REDI.PASSIVE_RT AS TASA_PASIVA, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE, REDI_LOANS RELO WHERE LORE.LOG_ID=-1 AND LORE.REDI_CODE = REDI.REDI_NO AND LORE.CODE_LOAN = RELO.LOAN_CD AND REDI.REIN_CODE='. singleQuote($result['REIN_CODE']). ' AND REDI.CURRENCY_CODE='. singleQuote($result['CURRENCY_CODE']) .' AND REDI.CLX_AUTH_STATUS = '.singleQuote('AP').'  group by REDI.REIN_CODE, REDI.REDI_NO, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.PASSIVE_RT, REDI.INT_CAPITALIZED_AMT, REDI.CURRENCY_CODE';
            }
			//OJO
			//SE INCORPORO LA MONEDA EN LOS CRITERIOS PARA NO LIGAR PERAS CON MANZANAS

            $results2 = ClxCommon::$db->executeQuery($sql2);
			$seqnum=1;

			while ($result2 = ClxCommon::$db->getNextRecord($results2, ASSOCIATIVE)) {
				//buscar cuenta contable en programa de redescuento
				$sql3='SELECT REPG.RCAC_CODE1, REPG.RCAC_CODE2, REPG.RCAC_CODE3, REPG.RCAC_CODE4 FROM REDI_REDISCOUNTS REDI, REDI_PROGRAMS_TBL REPG 
				WHERE REDI.REPG_CODE=REPG.IDCODE AND REPG.REIN_CODE=REDI.REIN_CODE AND REDI.REDI_NO='.singleQuote($result2['REDI_NO']);

				//echo $sql3;
                $cuenta_contable = ClxCommon::$db->getOneRecord($sql3);

				$monto=0;
				if ($type_comp=='COMP_SAP'){
					$monto=$result2['MONTO'];
                    $item_ref_no='';
					if ($cuenta_contable['RCAC_CODE1']=='' || $cuenta_contable['RCAC_CODE1']==NULL
                      ||$cuenta_contable['RCAC_CODE2']=='' || $cuenta_contable['RCAC_CODE2']==NULL){
                       continue;
                    }
                    //$cuenta_contable_cr=$cuenta_contable['RCAC_CODE1'];
					//$cuenta_contable_db=$cuenta_contable['RCAC_CODE2'];
					$lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] = $lcuenta_contable_cr[$cuenta_contable['RCAC_CODE1']] + $monto;
					$lcuenta_contable_db[$cuenta_contable['RCAC_CODE2']] = $lcuenta_contable_db[$cuenta_contable['RCAC_CODE2']] + $monto;	
				}
			}
			
			$seqnum=1;

			//CREDITO
			$jeln = Array();
			foreach($lcuenta_contable_cr as $key => $val) {
                //print "$key = $val <br>";
				$cuenta_contable = ''.$key;
				$monto = round($val, 2);
				$jeln['RCJH_CODE'] = $jehd['IDCODE']; 
                $jeln['SEQNUM'] = $seqnum;
                $jeln['RCAC_CODE'] = $cuenta_contable; 
                $jeln['IDNAME'] = $jehd['IDNAME'];
                $jeln['ITEM_REF_NO'] = $item_ref_no;
				$jeln['ALLOCATION_NO'] = $_SESSION ['user_record'] ['username'];
				$jeln['PRCT_CODE'] = 'HN01100316';
				$jeln['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
				$jeln['EXCHANGE_RT'] = 1;

				$jeln['DEBIT_AMT'] = 0;
				$jeln['DEBIT_TRANS_AMT'] = 0;
				$jeln['CREDIT_AMT'] = $monto;
				$jeln['CREDIT_TRANS_AMT'] = $monto;

				//creando linea de comprobante contable (CREDITO) 
                ClxCommon::$db->createRecord($this->rcjlname, $jeln, TRUE);
				$seqnum++;
			}

			//pre($jeln);

			//DEBITO
			$jeln = Array();
			foreach($lcuenta_contable_db as $key => $val) {
                //print "$key = $val <br>";
				$cuenta_contable = ''.$key;
				$monto = round($val, 2);
				$jeln['RCJH_CODE'] = $jehd['IDCODE']; 
                $jeln['SEQNUM'] = $seqnum;
                $jeln['RCAC_CODE'] = $cuenta_contable; 
                $jeln['IDNAME'] = $jehd['IDNAME'];
                $jeln['ITEM_REF_NO'] = $item_ref_no;
				$jeln['ALLOCATION_NO'] = $_SESSION ['user_record'] ['username'];
				$jeln['PRCT_CODE'] = 'HN01100316';
				$jeln['CURRENCY_CODE'] = $result['CURRENCY_CODE'];
				$jeln['EXCHANGE_RT'] = 1;

				$jeln['DEBIT_AMT'] = $monto;
				$jeln['DEBIT_TRANS_AMT'] = $monto;
				$jeln['CREDIT_AMT'] = 0;
				$jeln['CREDIT_TRANS_AMT'] = 0;

				//creando linea de comprobante contable (DEBITO) 
                ClxCommon::$db->createRecord($this->rcjlname, $jeln, TRUE);
				$seqnum++;
			}
			//pre($jeln);
		}
        //addMessage(dict('CODE_COMP_CONT_EXITO'));
}

//función para cargar las transacciones de Intereses Capitalizados
function carga_transacciones_int_cap($parameters, $tipo_transaccion){
    //verificamos si viene fecha en el parametro del proceso
    if ($parameters['EFFTDATE']==''){
		$fecha_ejec = $this->get_date_operation($parameters['COMP_CODE']);
	}else{
		$fecha_ejec = $parameters['EFFTDATE'];
	}
	
    $this->comp_contable($msg, $parameters['COMP_CODE'], 'COMP_INT_CAP',$parameters['REIN_CODE'],$fecha_ejec);

	//Seleccionamos solo transacciones de abono (03) 
    $criteria='WHERE RETR.COMP_CODE = '.singleQuote($parameters['COMP_CODE']).' AND RETR.REDI_TRXCD = '. singleQuote($tipo_transaccion) .' AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).' AND RETR.TRANS_STATUS = '.singleQuote('PEND').' AND RETR.TRANS_AMT<>0';
    //verificamos si obtenemos todos los entes redescontantes o uno en particular
    if ($parameters['REIN_CODE']!=''){
         $criteria .= ' AND RETR.REIN_CODE = '.singleQuote($parameters['REIN_CODE']); 
    }

    //Actualizamos el status de las trasacciones procesadas
    $sql4 = 'UPDATE REDI_TRANSACTIONS RETR SET RETR.TRANS_STATUS = '. singleQuote('PROC').' '.$criteria;
    ClxCommon::$db->executeQuery($sql4);

} 

//función para construir historicos de saldos de redescuento por proceso batch
function reg_saldo_redescuento_batch(){	
    $fecha_reg = $this->now;
    //CONSULTAMOS LOS REDESCUENTOS QUE FUERON IMPORTADOS
    $sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD  
          FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE WHERE LORE.REDI_CODE=REDI.REDI_NO AND LORE.LOG_ID=-1 GROUP BY REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD';

    $results = ClxCommon::$db->executeQuery($sql);
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
       //COMO SON LOS MISMOS CAMPOS USO EL RESULTADO DE LA CONSULTA
       $fecha_ejec = $this->get_date_operation($result['COMP_CODE']);
       $result['CLX_EFFTDATE']=$fecha_ejec;

       $sql = 'SELECT COUNT(*) FROM '.$this->rebaname.' WHERE
              COMP_CODE='. singleQuote($result['COMP_CODE']) . '
              AND REDI_NO='. singleQuote($result['REDI_NO']) . '
              AND CLX_EFFTDATE= '.singleQuote($fecha_ejec);
       $result['SALDO_CAPITAL'] =  $result['REDISCOUNT_AMT'] - $result['CAPITAL_PAY_AMT'] + $result['INT_CAPITALIZED_AMT'];
       $result['SALDO_INTERESES'] = $result['INTEREST_PROV_AMT'] - $result['INTEREST_PAY_AMT'] - $result['INT_CAPITALIZED_AMT']; 
       //SI NO EXISTE ENTRADA DE SALDO DE REDESCUENTO ENTONCES SE AGREGA
        if (ClxCommon::$db->getOne($sql)==0){
           $result['CDATE'] = $fecha_reg;			
           $result['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
           $result['MDATE'] = $fecha_reg;			
           $result['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];		
           ClxCommon::$db->createRecord($this->rebaname, $result, TRUE); 
       }else{
           $result['MDATE'] = $fecha_reg;			
           $result['MODIFIEDBY']	= $_SESSION ['user_record'] ['username'];		
           //SI EXISTE ENTRADA DE ACTUALIZA SALDO DE REDESCUENTO
           $crit = 'COMP_CODE =' . singleQuote($result['COMP_CODE']) . ' AND REDI_NO='. singleQuote($result['REDI_NO']) . ' AND CLX_EFFTDATE= '.singleQuote($fecha_ejec);
           ClxCommon::$db->updateRecord($this->rebaname,  $result, $crit);
       }    
    }       
}

//función para construir historicos de saldos de redescuento en linea
function reg_saldo_redescuento($idlist, $type_comp, $efftdate, $comp_code, $fecha_ejec, $rein_code){	
    $fecha_reg = $this->now;
    unset($efftdate);
    //CONSULTAMOS LOS REDESCUENTOS QUE FUERON IMPORTADOS
	if ($type_comp=='COMP_SAP'){
		//QUERY MATRIZ / REDESCUENTOS - DESEMBOLSOS
        $sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD  
          FROM REDI_REDISCOUNTS REDI 
          WHERE REDI.ID IN ('.$idlist.')'; 
	}
    if ($type_comp=='PROV_INT_PAG'){
		//QUERY MATRIZ / REDESCUENTOS - PROVISION INTERESES POR PAGAR
    	//$fecha_actual=date('Y-m-d');
		$sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD 
        FROM REDI_REDISCOUNTS REDI, REDI_RELO_REDI LORE
        WHERE REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' AND REDI.COMP_CODE='.singleQuote($comp_code).' AND LORE.REDI_CODE = REDI.REDI_NO AND (REDI.REDISCOUNT_AMT-CAPITAL_PAY_AMT+INT_CAPITALIZED_AMT)>0 AND REDI.PASSIVE_RT>0 AND REDI.START_DATE<=TO_DATE('.singleQuote($fecha_ejec).', '.singleQuote('YYYY-MM-DD'). ')
        GROUP BY REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD' ;
         //echo $sql.'</br>';
	}
    if ($type_comp=='COMP_PAGO_ANT' || $type_comp=='COMP_PAGO_EXT'){
		//QUERY MATRIZ / REDESCUENTOS - PAGO ANTICIPADO DE FACTURA
        $sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD  
        FROM REDI_REDISCOUNTS REDI, REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
        WHERE REIL.REDI_NO=REDI.REDI_NO AND REIV.IDCODE=REIL.REIV_CODE AND REIV.ID = '.singleQuote($idlist);

    }
	if ($type_comp=='AJUS_INT'){
		//QUERY MATRIZ / REDESCUENTOS - AJUSTE DE INTERESES 
		$sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD   
        FROM REDI_REDISCOUNTS REDI, REDI_INVOICES REIV, REDI_INVOICE_LINES REIL 
        WHERE REIL.REDI_NO=REDI.REDI_NO AND REIV.IDCODE=REIL.REIV_CODE AND REIV.ID = '.singleQuote($idlist);
        //echo $sql.'</br>';
	}
    if ($type_comp=='COMP_INT_CAP'){
	    //QUERY MATRIZ / REDESCUENTOS - INTERESES CAPITALIZADOS
        $sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD    
        FROM REDI_REDISCOUNTS REDI, REDI_TRANSACTIONS RETR 
        WHERE RETR.COMP_CODE = '.singleQuote($comp_code).' 
        AND RETR.REDI_CODE = REDI.REDI_NO 
        AND RETR.REIN_CODE='. singleQuote($rein_code). ' 
        AND RETR.TRANS_DATE = '.singleQuote($fecha_ejec).' 
        AND RETR.TRANS_STATUS='.singleQuote('PEND').' 
        AND RETR.REDI_TRXCD='.singleQuote('03').' 
        AND RETR.TRANS_AMT<>0';
        //echo $sql.'</br>';
	}

    $results = ClxCommon::$db->executeQuery($sql);
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
       //COMO SON LOS MISMOS CAMPOS USO EL RESULTADO DE LA CONSULTA
       $result['CLX_EFFTDATE']=$fecha_ejec;

       $sql = 'SELECT COUNT(*) FROM '.$this->rebaname.' WHERE
              COMP_CODE='. singleQuote($result['COMP_CODE']) . '
              AND REDI_NO='. singleQuote($result['REDI_NO']) . '
              AND CLX_EFFTDATE= '.singleQuote($fecha_ejec);
       //SI NO EXISTE ENTRADA DE SALDO DE REDESCUENTO ENTONCES SE AGREGA 
       $result['SALDO_CAPITAL'] =  $result['REDISCOUNT_AMT'] - $result['CAPITAL_PAY_AMT'] + $result['INT_CAPITALIZED_AMT'];
       $result['SALDO_INTERESES'] = $result['INTEREST_PROV_AMT'] - $result['INTEREST_PAY_AMT'] - $result['INT_CAPITALIZED_AMT']; 
       if (ClxCommon::$db->getOne($sql)==0){
           $result['CDATE'] = $fecha_reg;			
           $result['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
           $result['MDATE'] = $fecha_reg;			
           $result['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];		
           ClxCommon::$db->createRecord($this->rebaname, $result, TRUE); 
       }else{
           $result['MDATE'] = $fecha_reg;			
           $result['MODIFIEDBY']	= $_SESSION ['user_record'] ['username'];		
           //SI EXISTE ENTRADA DE ACTUALIZA SALDO DE REDESCUENTO
           $crit = 'COMP_CODE =' . singleQuote($result['COMP_CODE']) . ' AND REDI_NO='. singleQuote($result['REDI_NO']) . ' AND CLX_EFFTDATE= '.singleQuote($fecha_ejec);
           ClxCommon::$db->updateRecord($this->rebaname,  $result, $crit);
       }    
    }       
}

//función para construir historicos de saldos de redescuento diarios solo a aquellos que no han tenido moviemientos en el día
function reg_saldo_redescuento_masivo($parameters){	
    //verificamos si viene fecha en el parametro del proceso
    $fecha_reg = $this->now;
    $comp_code = $parameters['COMP_CODE'];
    if ($parameters['EFFTDATE']==''){
		$fecha_ejec = $this->get_date_operation($comp_code);
	}else{
		$fecha_ejec = $parameters['EFFTDATE'];
	}
    //CONSULTAMOS LOS REDESCUENTOS QUE FUERON IMPORTADOS
	$sql='SELECT REDI.COMP_CODE, REDI.REDI_NO, REDI.CLX_EFFTDATE, REDI.CLX_AUTH_STATUS, REDI.REDISCOUNT_AMT, REDI.CAPITAL_PAY_AMT, REDI.INT_CAPITALIZED_AMT, REDI.INTEREST_PROV_AMT, REDI.INTEREST_PAY_AMT, REDI.ABONO_EXTRAORD 
          FROM REDI_REDISCOUNTS REDI
          WHERE REDI.CLX_AUTH_STATUS = '.singleQuote('AP').' 
          AND REDI.COMP_CODE='.singleQuote($comp_code).' 
          AND (REDI.REDISCOUNT_AMT-CAPITAL_PAY_AMT+INT_CAPITALIZED_AMT)<>0 
          AND REDI.PASSIVE_RT>0 AND REDI.START_DATE<=TO_DATE('.singleQuote($fecha_ejec).', '.singleQuote('YYYY-MM-DD'). ')' ;

    $results = ClxCommon::$db->executeQuery($sql);
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
       //COMO SON LOS MISMOS CAMPOS USO EL RESULTADO DE LA CONSULTA
       $result['CLX_EFFTDATE']=$fecha_ejec;

       $sql = 'SELECT COUNT(*) FROM '.$this->rebaname.' WHERE
              COMP_CODE='. singleQuote($result['COMP_CODE']) . '
              AND REDI_NO='. singleQuote($result['REDI_NO']) . '
              AND CLX_EFFTDATE= '.singleQuote($fecha_ejec);
       //SI NO EXISTE ENTRADA DE SALDO DE REDESCUENTO ENTONCES SE AGREGA 
       $result['SALDO_CAPITAL'] =  $result['REDISCOUNT_AMT'] - $result['CAPITAL_PAY_AMT'] + $result['INT_CAPITALIZED_AMT'];
       $result['SALDO_INTERESES'] = $result['INTEREST_PROV_AMT'] - $result['INTEREST_PAY_AMT'] - $result['INT_CAPITALIZED_AMT']; 
       if (ClxCommon::$db->getOne($sql)==0){
           $result['CDATE'] = $fecha_reg;
           $result['CREATEDBY'] = $_SESSION ['user_record'] ['username'];			
           $result['MDATE'] = $fecha_reg;			
           $result['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];		
           ClxCommon::$db->createRecord($this->rebaname, $result, TRUE); 
       }    
    }       
}

//Función para obtener dia de operación 
function get_date_operation($comp_code){
   $sql = 'SELECT OPERATION_DATE FROM REDI_PARAMETERS_TBL WHERE COMP_CODE='. singleQuote($comp_code);
   $results = ClxCommon::$db->executeQuery($sql);

   if ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
       return  date("Y-m-d", strtotime($result['OPERATION_DATE']));
   }else{
       return date('Y-m-d');
   }
}

}    
// end class