<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-25 14:47:34 -0400 (Fri, 25 Sep 2015) $
 * @version        $Rev: 7014 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class SERV_reports {

    /**
     * Constructor
     */
    function __construct() {
        multiTableName($this, array('SRRQ', 'SRRS', 'SRAN'));
    }

// end function
    function case_dashboard() {
        $to = UserRequest::$request[CLX_PROP_TO];
        $ac = UserRequest::$request['ac'];
        $it = UserRequest::$request['it'];
        $idlist = getIdlist();
        $contents = '';
        $contents .= setJavaScriptTag(getJavaScriptFilename('UILG_dialog.js'), true);
        if (!empty($_SESSION['PROJECT_CODE']) && !array_key_exists('PROJECT_CODE', UserRequest::$request)) {
            UserRequest::$request['PROJECT_CODE'] = $_SESSION['PROJECT_CODE'];
        }

        $project_code = (!empty(UserRequest::$request['PROJECT_CODE'])) ? UserRequest::$request['PROJECT_CODE'] : CLX_CHAR_EMPTY_STRING;
        $_SESSION['PROJECT_CODE'] = $project_code;
        //Set priorities if defined ?PROJECT_CODE=BANCORP_FIDU&p=M&it=2583
        pushHistory($to, $ac, $idlist);
        addHistory('it', $it);
        if (!empty(UserRequest::$request['pr']) && !empty(UserRequest::$request['p']) && !empty($project_code) && (UserRequest::$request['p'] === 'M' || UserRequest::$request['p'] === 'L' || UserRequest::$request['p'] === 'H')) {
            $sql = 'UPDATE SERV_REQUESTS SET PRIORITY = ' . singleQuote(UserRequest::$request['p']) . ' WHERE ID = ' . UserRequest::$request['pr'] . ' AND PROJECT_CODE = ' . singleQuote($project_code);
            ClxCommon::$db->executeQuery($sql);
        }
        $list = new htmlSelect('PROJECT_CODE');
        $list->addItem('', '', true);
        $sql = 'SELECT  PROJ.IDCODE, PROJ.IDNAME FROM PROJ_PROJECTS PROJ WHERE PROJ.PROJ_STATUS NOT IN (' . singleQuoteArray(array('C', 'D')) . ') ORDER BY IDNAME';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $list->addItem($r['IDNAME'], $r['IDCODE'], ($r['IDCODE'] == $project_code));
        }
        $list->setProp('onchange', 'this.form.submit()');
        $form = new htmlForm();
        $form->setProp(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument('ac', $ac);
        $form->addArgument(CLX_PROP_TO, $to);
        $form->addArgument('it', $it);
        $form->addContents(dict('GEN_LBL_PROJECT') . ': ' . $list->source());
        $contents .= '<h1>' . dict('GEN_LBL_PROJECT_DASHBOARD') . '</h1><br>' . $form->source();
        if (empty($project_code)) {
            $contents .= '<h2>' . dict('GEN_LBL_GENERAL_SUMMARY') . '</h2><br>';
            //Vista de total de casos por projecto
            $table = new htmlTable(CLX_WIDTH_13);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_lBL_IDCODE'), dict('GEN_LBL_IDNAME'), dict('GEN_LBL_TOTAL_CASES'), dict('GEN_LBL_OPEN_CASES'), dict('GEN_LBL_IN_PROGRESS'), dict('GEN_LBL_APPROVAL_PEND_CASES'), dict('GEN_LBL_WAIT_CLIENT'), dict('GEN_LBL_CLOSED_CASES'), dict('GEN_LBL_DEFERRED_CASES'), dict('GEN_LBL_REJECTED_CASES'), dict('GEN_LBL_OTHER_CASES'), dict('GEN_LBL_PCT_PENDING'), dict('GEN_LBL_PCT_COMPLETED')));
            //Adding report here - Project summary
            $sql = 'SELECT  PROJ.IDCODE, PROJ.IDNAME, COUNT(SRRQ.ID) TOTAL_CASOS, SUM(IF(SRRQ.REQSTATUS =' . singleQuote('O') . ', 1, 0)) CASOS_ABIERTOS, SUM(IF(SRRQ.REQSTATUS =' . singleQuote('IP') . ', 1, 0)) CASOS_EN_PROGRESO, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('PE') . ', 1, 0)) CASOS_ESPERA_APROBACION, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('C') . ', 1, 0)) CASOS_CERRADOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('D') . ', 1, 0)) CASOS_DIFERIDOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('R') . ', 1, 0)) CASOS_RECHAZADOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('WC') . ', 1, 0)) CASOS_ESPERA_CLIENTE, SUM(IF(SRRQ.REQSTATUS NOT IN(' . singleQuoteArray(array('O', 'IP', 'PE', 'WC', 'C', 'D', 'R')) . '), 1, 0)) CASOS_OTROS, ROUND((SUM(IF(SRRQ.REQSTATUS NOT IN (' . singleQuoteArray(array('C', 'D', 'R')) . '), 1, 0))/COUNT(SRRQ.ID))*100, 2) PCT_PENDIENTE, ROUND((SUM(IF(SRRQ.REQSTATUS IN (' . singleQuoteArray(array('C', 'D', 'R')) . '), 1, 0))/COUNT(SRRQ.ID))*100, 2) PCT_AVANCE FROM  SERV_REQUESTS SRRQ, PROJ_PROJECTS PROJ WHERE  PROJ.PROJ_STATUS NOT IN (' . singleQuote('C') . ',' . singleQuote('D') . ') AND SRRQ.PROJECT_CODE = PROJ.IDCODE GROUP BY  PROJ.IDCODE, PROJ.IDNAME';
            $rs = ClxCommon::$db->executeQuery($sql);
            $class = CLX_CLASS_DATA;
            $totals = array('TOTAL_CASOS' => CLX_NUM_ZERO, 'CASOS_ABIERTOS' => CLX_NUM_ZERO, 'CASOS_EN_PROGRESO' => CLX_NUM_ZERO, 'CASOS_ESPERA_APROBACION' => CLX_NUM_ZERO, 'CASOS_ESPERA_CLIENTE' => CLX_NUM_ZERO, 'CASOS_CERRADOS' => CLX_NUM_ZERO, 'CASOS_DIFERIDOS' => CLX_NUM_ZERO, 'CASOS_RECHAZADOS' => CLX_NUM_ZERO, 'CASOS_OTROS' => CLX_NUM_ZERO,);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $table->addCells($class, array(uppercase($r['IDCODE']), uppercase($r['IDNAME']), $r['TOTAL_CASOS'], $r['CASOS_ABIERTOS'], $r['CASOS_EN_PROGRESO'], $r['CASOS_ESPERA_APROBACION'], $r['CASOS_ESPERA_CLIENTE'], $r['CASOS_CERRADOS'], $r['CASOS_DIFERIDOS'], $r['CASOS_RECHAZADOS'], $r['CASOS_OTROS'], $r['PCT_PENDIENTE'] . '%', $r['PCT_AVANCE'] . '%'));
                $class = ($class == CLX_CLASS_DATA) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
                $totals['TOTAL_CASOS'] += $r['TOTAL_CASOS'];
                $totals['CASOS_ABIERTOS'] += $r['CASOS_ABIERTOS'];
                $totals['CASOS_EN_PROGRESO'] += $r['CASOS_EN_PROGRESO'];
                $totals['CASOS_ESPERA_APROBACION'] += $r['CASOS_ESPERA_APROBACION'];
                $totals['CASOS_ESPERA_CLIENTE'] += $r['CASOS_ESPERA_CLIENTE'];
                $totals['CASOS_CERRADOS'] += $r['CASOS_CERRADOS'];
                $totals['CASOS_DIFERIDOS'] += $r['CASOS_DIFERIDOS'];
                $totals['CASOS_RECHAZADOS'] += $r['CASOS_RECHAZADOS'];
                $totals['CASOS_OTROS'] += $r['CASOS_OTROS'];
            }
            $table->addCells(CLX_CLASS_HEADERS, array('', dict('GEN_LBL_TOTAL'), $totals['TOTAL_CASOS'], $totals['CASOS_ABIERTOS'], $totals['CASOS_EN_PROGRESO'], $totals['CASOS_ESPERA_APROBACION'], $totals['CASOS_ESPERA_CLIENTE'], $totals['CASOS_CERRADOS'], $totals['CASOS_DIFERIDOS'], $totals['CASOS_RECHAZADOS'], $totals['CASOS_OTROS'], '', ''));
            $contents .= $table->source() . '<br>';
            return $contents;
        }// end if empty contents
        $contents .= '<h2>' . dict('GEN_LBL_PROJECT_SUMMARY') . '</h2><br>';
        //Adding report here - Project summary
        $sql = 'SELECT  PROJ.IDCODE, PROJ.IDNAME, COUNT(SRRQ.ID) TOTAL_CASOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('O') . ', 1, 0)) CASOS_ABIERTOS, SUM(IF(SRRQ.REQSTATUS =' . singleQuote('IP') . ', 1, 0)) CASOS_EN_PROGRESO, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('PE') . ', 1, 0)) CASOS_ESPERA_APROBACION, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('C') . ', 1, 0)) CASOS_CERRADOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('D') . ', 1, 0)) CASOS_DIFERIDOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('R') . ', 1, 0)) CASOS_RECHAZADOS, SUM(IF(SRRQ.REQSTATUS=' . singleQuote('WC') . ', 1, 0)) CASOS_ESPERA_CLIENTE, SUM(IF(SRRQ.REQSTATUS NOT IN(' . singleQuote('O') . ',' . singleQuote('IP') . ',' . singleQuote('WC') . ',' . singleQuote('C') . ',' . singleQuote('PE') . ',' . singleQuote('D') . ',' . singleQuote('R') . '), 1, 0)) CASOS_OTROS, ROUND((SUM(IF(SRRQ.REQSTATUS NOT IN (' . singleQuote('C') . ',' . singleQuote('D') . ',' . singleQuote('R') . '), 1, 0))/COUNT(SRRQ.ID))* 100, 2) PCT_PENDIENTE, ROUND((SUM(IF(SRRQ.REQSTATUS IN (' . singleQuote('C') . ',' . singleQuote('D') . ',' . singleQuote('R') . '), 1, 0))/COUNT(SRRQ.ID))* 100, 2) PCT_AVANCE FROM  SERV_REQUESTS SRRQ, PROJ_PROJECTS PROJ WHERE  PROJ.PROJ_STATUS NOT IN (' . singleQuote('C') . ',' . singleQuote('D') . ') AND SRRQ.PROJECT_CODE = PROJ.IDCODE AND PROJ.IDCODE = ' . singleQuote($project_code) . ' GROUP BY  PROJ.IDCODE, PROJ.IDNAME';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, 'border' => '1'));
            $table->addCell(dict('GEN_LBL_NAME'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['IDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_TOTAL_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['TOTAL_CASOS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_OPEN_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_ABIERTOS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_IN_PROGRESS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_EN_PROGRESO'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_APPROVAL_PEND_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_ESPERA_APROBACION'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_WAIT_CLIENT'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_ESPERA_CLIENTE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_CLOSED_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_CERRADOS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_DEFERRED_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_DIFERIDOS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_REJECTED_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_RECHAZADOS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_OTHER_CASES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['CASOS_OTROS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_PCT_PENDING'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['PCT_PENDIENTE'] . '%', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_PCT_COMPLETED'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($r['PCT_AVANCE'] . '%', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $contents .= $table->source() . '<br>';
        }
        $DBLT = &getTool('DBLT');
        $rstatus = $DBLT->getListAsArray('RQST');
        $rtype = $DBLT->getListAsArray('RQTY');
        $rpriority = $DBLT->getListAsArray('ACPR');
        $contents .= '<h2>' . dict('GEN_LBL_REQUEST_ITEMS') . '</h2><br>';
        $table = new htmlTable(CLX_WIDTH_NINE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
        $table->addCells(CLX_CLASS_HEADERS, array(CLX_CHAR_HTML_NBSP, dict('GEN_LBL_CASE_NUMBER'), dict('GEN_LBL_SUBJECT'), dict('GEN_LBL_REQ_STATUS'), dict('GEN_LBL_REQ_TYPE'), dict('GEN_LBL_PRIORITY'), dict('GEN_LBL_DAYS'), dict('GEN_LBL_ASSIGNEDTO_USER'), dict('GEN_LBL_CHANGE_PRIORITY')));
        //Listado de casos
        $sql = 'SELECT  SRRQ.ID, SRRQ.PROJECT_CODE, SRRQ.IDCODE, SRRQ.SUBJECT, SRRQ.REQSTATUS, SRRQ.REQTYPE, SRRQ.PRIORITY, SRRQ.ASSIGNEDTO_USER, SRRQ.DESCRIPTION, IF(SRRQ.RESOLVED_DATI, DATEDIFF(SRRQ.RESOLVED_DATI, SRRQ.EFFTDATETIME), DATEDIFF(CURDATE(), SRRQ.EFFTDATETIME)) DAYS, case SRRQ.REQSTATUS  WHEN ' . singleQuote('PE') . ' THEN 0 WHEN ' . singleQuote('IP') . ' THEN 100 WHEN ' . singleQuote('WC') . ' THEN 60 ELSE 50 END SEQSTATUS, case SRRQ.REQTYPE  WHEN ' . singleQuote('BUG') . ' THEN 100 WHEN ' . singleQuote('NF') . ' THEN 50 ELSE 0 END SEQTYPE, case SRRQ.PRIORITY WHEN ' . singleQuote('H') . ' THEN 100 WHEN ' . singleQuote('N') . ' THEN 50 ELSE 0 END SEQPRIORITY FROM  SERV_REQUESTS SRRQ, PROJ_PROJECTS PROJ WHERE  SRRQ.REQSTATUS NOT IN (' . singleQuote('C') . ',' . singleQuote('D') . ',' . singleQuote('R') . ') AND SRRQ.PROJECT_CODE = PROJ.IDCODE AND PROJ.PROJ_STATUS NOT IN (' . singleQuote('C') . ',' . singleQuote('D') . ') AND PROJ.IDCODE = ' . singleQuote($project_code) . ' ORDER BY  SRRQ.PROJECT_CODE ASC, SEQSTATUS DESC, SEQTYPE DESC, SEQPRIORITY DESC';
        $rs = ClxCommon::$db->executeQuery($sql);
        $class = CLX_CLASS_DATA;
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //javascript:%20createDialog('Requests',%20'window.php?to=EDIT&ac=TOOLTIP&li=REQUESTS&qy=REQUESTS&relfm=&idlist=2773',true)
            $lview = '<a href="javascript: createDialog(' . singleQuote('Open Requests') . ',' . singleQuote('window.php?to=EDIT&ac=TOOLTIP&li=REQUESTS&qy=REQUESTS&relfm=&idlist=' . $r['ID']) . ',true)"><img border="0" title="Summary" src="skins/default/icons/tooltip.gif"></img></a>';
            $linkto = '<a href="tool.php?to=EDIT&ac=MODIFY&it=' . $it . '&li=REQUESTS&qy=REQUESTS&relfm=&idlist=' . $r['ID'] . '">' . $r['IDCODE'] . '</a>';
            $link = '[ <a href="tool.php?to=' . $to . '&ac=' . $ac . '&it=' . $it . '&PROJECT_CODE=' . $project_code . '&p=L&pr=' . $r['ID'] . '">' . $rpriority['L'] . '</a> ]';
            $link .= ' [ <a href="tool.php?to=' . $to . '&ac=' . $ac . '&it=' . $it . '&PROJECT_CODE=' . $project_code . '&p=N&pr=' . $r['ID'] . '">' . $rpriority['N'] . '</a> ]';
            $link .= ' [ <a href="tool.php?to=' . $to . '&ac=' . $ac . '&it=' . $it . '&PROJECT_CODE=' . $project_code . '&p=H&pr=' . $r['ID'] . '">' . $rpriority['H'] . '</a> ]';
            $table->addCells($class, array($lview, $linkto, $r['SUBJECT'], $rstatus[$r['REQSTATUS']], $rtype[$r['REQTYPE']], $rpriority[$r['PRIORITY']], $r['DAYS'], $r['ASSIGNEDTO_USER'], $link));
            $class = ($class == CLX_CLASS_DATA) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
        }
        $contents .=$table->source();
        return $contents;
    }

}

// end class
