<?php
/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-07-02 15:47:17 -0400 (Thu, 02 Jul 2015) $
 * @version        $Rev: 5988 $
 *
 * CHANGE LOG
 * 2009/09/02 Included svn prop
 */
class Crrp {

    var $gl_cred_use_ch03 = true;

    /**
     *Constructor
     * @param array $procParameters
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('CRRP','FIAS', 'FIAT', 'FILO','PROD','FILC','FIBK','PRAT', 'GLPF','PRLT','FITB', 'FICO','JEHD', 'JELN', 'PROD', 'GDVW', 'COMP','GLCP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION["user_record"]["username"];
        $this->now = xFormat::getNow("Y-m-d H:i:s");
        $this->today = xFormat::getNow("Y-m-d");
        $this->je_source = '';
        $this->debug = false;
    }

    //--------------------------------------------------------------------------

    /**
     *Initial
     * @param type $record
     */
    function init_form(&$record) {

        if (UserRequest::$request['ac'] == 'DUPLICATE' && empty(UserRequest::$post['confirm'])) {
            $record['CRRP_EFFTDATE'] = $this->today;
        }
        if(UserRequest::$request['ac'] == 'DISPLAY'){
            $this->crrpCalcTransAmt($record);

              $sql = "SELECT
                        GLPF.IDNAME, GLPF.SEQNUM, GLPF.FEE_FORMULA,
                        GLPF.*
                    FROM
                        $this->glpfname GLPF, $this->filoname FILO
                    WHERE
                        GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE
                        AND GLPF.STATUS = 'A'
                      AND FILO.IDCODE = '".$record['CRRP_LOAN_CODE']."'
                          AND FILO.CLX_EFFTDATE= (SELECT MAX(FILOX.CLX_EFFTDATE)
                                    FROM $this->filoname FILOX
                                WHERE FILOX.IDCODE = FILO.IDCODE
                                        AND FILOX.CLX_EFFTDATE <=NOW())
                    ORDER BY GLPF.SEQNUM ASC";
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs)) {
                $i = $r['SEQNUM'];
                $lbl = '';
                /*if (substr($r['FEE_FORMULA'], 0, 1) == 'P') $lbl = '% ';*/
                $record['CRRP_FEE_0' . $i . '_NAME'] = $lbl . $r['IDNAME'];
                $record['CRRP_FEE_0' . $i . '_NAME2'] = $record['CRRP_FEE_0' . $i . '_NAME'];
            }
        }
    }


    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form_ori(&$record, &$msg) {

        /*if ($record['CRRP_END_DATE'] <> '' && $record['CRRP_CLX_EFFTDATE'] > $record['CRRP_END_DATE']) {
            $msg['CRRP_END_DATE'] = smsg('MSG-205');
        }*/

        //Validar que registro este en status de pendiente para ser modificado.
        if($record['CRRP_CLX_AUTH_STATUS']<> 'PEND'){
            $msg['CRRP_CLX_AUTH_STATUS'] = smsg('MSG-434');

            if (UserRequest::$request['ac'] == 'DELETE')
                addMessage($msg['CRRP_CLX_AUTH_STATUS']);
        }


        //Validar que el credito se encuentre al dia.
        //Validar que creditos al vencimiento prorrogas no sean mayores a 6 meses
        $sql = "SELECT
                    FILO.IDCODE,
                    FILO.START_DATE,
                    FILO.CLX_EFFTDATE,
                    GLCP.OPERATION_DATE,
                    FILO.PRODUCT_CODE,
                    FILO.PRINCIPAL_BAL,
                    FILO.CRED_LINE_CODE
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = '".$record['CRRP_LOAN_CODE']."'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())";
        $filo = ClxCommon::$db->getOneRecord($sql);

        $sql = "SELECT
                    GLCP.OPERATION_DATE,
                    FILO.PRODUCT_CODE,
                    SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) PRINCIPAL_BAL,
                    SUM(FILS.INTEREST_PAY-FILS.INTPAID_AMT) INTEREST_BAL
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO,
                    CRED_PAYMNT_SCHEDULES FILS
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = FILS.LOAN_CODE
                    AND FILO.CLX_EFFTDATE = FILS.EFFTDATE
                    AND FILS.PERIOD_END_DATE <= GLCP.OPERATION_DATE
                    AND FILO.IDCODE = '".$record['CRRP_LOAN_CODE']."'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())
                GROUP BY
                    GLCP.OPERATION_DATE,
                    FILO.PRODUCT_CODE,
                    FILO.PRINCIPAL_BAL";
        $fils = ClxCommon::$db->getOneRecord($sql);


        //Validar de no prorrogar el primer dia del credito.
        if($filo['START_DATE']==$filo['OPERATION_DATE'] && $record['CRRP_CRED_EXT_TYPE']==0){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-448');
        }


        //Validar que tenga cuenta contables
        if($record['CRRP_CRED_EXT_TYPE']==1 && $record['CRRP_RES_FEE_AMT']<>0){

            $sql = "SELECT COUNT(PRAT.ID)
                    FROM $this->pratname PRAT
                    WHERE PRAT.PRODUCT_CODE = '".$filo['PRODUCT_CODE']."'
                        AND PRAT.REFE_GL_CODE IS NULL";
            if(ClxCommon::$db->getOne($sql)>0){
                $msg['CRRP_RES_FEE_AMT'] = smsg('MSG-150', $filo['PRODUCT_CODE']);
            }
        }


        //Validar que las fechas efectivas de prorroga no sea igual a la fecha de restructuracion
        if($filo['CLX_EFFTDATE']>=$record['CRRP_EFFTDATE']){
            $msg['CRRP_EFFTDATE'] = smsg("MSG-444");
        }


        //Validando saldo de capital
       /* if(!empty($fils['PRINCIPAL_BAL']) && $fils['PRINCIPAL_BAL']>0  && $record['CRRP_CRED_EXT_TYPE']==0){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-432', xFormat::number($fils['PRINCIPAL_BAL']));
        }

        //validar saldos de intereses
        if(!empty($fils['INTEREST_BAL']) && $fils['INTEREST_BAL']>0 && $record['CRRP_CRED_EXT_TYPE']==0){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-433', xFormat::number($fils['INTEREST_BAL']));
        }
        */
        $sql = "SELECT
                    PRLT.MAX_EXT_PERIOD,
                    PRLT.EXT_PERIOD_TYPE,
                    PRLT.MAX_RES_PERIOD,
                    PRLT.RES_PERIOD_TYPE,
                    PRLT.EXT_PRV_LMT_PERIOD,
                    PRLT.EXT_PRV_LMT_TYPE
                FROM
                    CRED_PROD_PRMTR_TBL PRLT
                WHERE
                    PRLT.PRODUCT_CODE = '".$filo['PRODUCT_CODE']."'";
        $prlt = ClxCommon::$db->getOneRecord($sql);
        //Validar que no se extiendan el numero de couta mas de seis meses.
        //Validacion no puede pasar de 6 meses.
        $max_date = adodb_period_date($filo['OPERATION_DATE'], $prlt['EXT_PERIOD_TYPE'], $prlt['MAX_EXT_PERIOD']);
        if($record['CRRP_CRED_EXT_TYPE']==1){
            $new_date = adodb_period_date($filo['OPERATION_DATE'], $record['CRRP_PERIOD_TYPE'], $record['CRRP_LOAN_PERIOD']);
        }else{
            $new_date = adodb_period_date($filo['OPERATION_DATE'], $record['CRRP_PERIOD_TYPE'], $record['CRRP_EXTENSION_PERIOD']);
        }

        //Si fecha de restructuracion es menor o igual fecha de operaciones es invalido.
        if($filo['OPERATION_DATE'] >= $new_date){
            if($record['CRRP_CRED_EXT_TYPE']==1){
                $msg['CRRP_LOAN_PERIOD'] = smsg('MSG-435');
            }else{
                $msg['CRRP_EXTENSION_PERIOD'] = smsg('MSG-435');
            }
        }

        //Se fecha de fin es mayor que maxima fecha entonces es error
        if($record['CRRP_CRED_EXT_TYPE']==0 && $prlt['EXT_PERIOD_TYPE']<>'' && $new_date>$max_date){
            $msg['CRRP_EXTENSION_PERIOD'] = smsg('MSG-436', $new_date, $max_date);
        }

        //Validar que credito no se encuentre en status de preparacion o cancelado.
        if(empty($filo['PRINCIPAL_BAL']) || $filo['PRINCIPAL_BAL']==0){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-437').' '.xFormat::number($filo['PRINCIPAL_BAL']);
        }

        //EXT_PRV_LMT_PERIOD
        if($prlt['EXT_PRV_LMT_PERIOD']<>0){

            $prevnew_date = adodb_period_date($record['CRRP_EFFTDATE'], $prlt['EXT_PRV_LMT_TYPE'], -1*$prlt['EXT_PRV_LMT_PERIOD']);

            //Validar que no haya renovaciones en los ultimos 12 meses
            $sql = "SELECT
                        COUNT(CRRP.ID) QTY
                    FROM
                        $this->crrpname CRRP
                    WHERE
                        CRRP.LOAN_CODE = '".$record['CRRP_LOAN_CODE']."'
                        AND CRRP.EFFTDATE <'".$record['CRRP_EFFTDATE']."'
                        AND  CRRP.EFFTDATE >= '$prevnew_date'
                        AND CRRP.CLX_AUTH_STATUS = 'AP'";
            if(ClxCommon::$db->getOne($sql)>0){
                $msg['CRRP_EFFTDATE'] = smsg('MSG-438');
            }
        }

        if($record['CRRP_CRED_EXT_TYPE']==1){
            //FILO_PAY_BANKACT_NO
            //Validar que el monto final de intereses sea igual a cero.
            if(@$record['CRRP_INT_ENDING_AMT']<>0){
               $msg['CRRP_INT_ENDING_AMT'] = smsg('MSG-443');
            }



            //Validando que el monto de capital restructurado no sea mayor al monto de la linea
            if(!empty($filo['CRED_LINE_CODE']) && $record['CRRP_CAP_ENDING_AMT']>0){
                $sql = "SELECT
                        ((CRCL.LINE_AMT-
                                        IFNULL(
                            (SELECT SUM(CASE PRLT.AMRT_LINE_CREDIT
                            WHEN 1 THEN FILO.PRINCIPAL_BAL
                            ELSE FILO.LOAN_AMT END)
                                        FROM
                                                CRED_CREDITS FILO,
                                                CRED_PROD_PRMTR_TBL PRLT
                                        WHERE
                                                CRCL.IDCODE = FILO.CRED_LINE_CODE
                                                AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE
                                                AND FILO.LOAN_STATUS NOT IN ('PRE','REEC')
                                                AND FILO.IDCODE<>'".$filo['IDCODE']."'
                                                AND FILO.CLX_EFFTDATE= (SELECT MAX(X.CLX_EFFTDATE)
                                                        FROM CRED_CREDITS X
                                                        WHERE X.IDCODE = FILO.IDCODE
                                                        AND X.CLX_EFFTDATE<=NOW())),0)-".$record['CRRP_CAP_ENDING_AMT'].")) CRCL_AVAILABLE_AMT_WRK
                        FROM
                            CRM_ACCOUNTS ACCO,
                            CRED_CREDIT_LINES CRCL,
                            GL_PARAMETERS_TBL GLCP
                        WHERE
                            ACCO.IDCODE = CRCL.ACCOUNTCODE
                            AND GLCP.COMP_CODE = CRCL.COMP_CODE
                            AND CRCL.IDCODE = '".$filo['CRED_LINE_CODE']."'
                            AND CRCL.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
                                                    FROM CRED_CREDIT_LINES X
                                                    WHERE  X.IDCODE=CRCL.IDCODE AND  X.CLX_EFFTDATE<=GLCP.OPERATION_DATE)";
                $one = ClxCommon::$db->getOne($sql);
                if($one < 0){
                    $msg['CRRP_CAP_ENDING_AMT'] = smsg('MSG-466');
                }
            }
        }//end if $record['CRRP_CRED_EXT_TYPE']==0

        $sql = "SELECT
                    COUNT(JEHD.ID) QTY
                FROM
                    GL_JOURNAL_HDR JEHD,
                    GL_JOURNAL_LINES JELN,
                    FIDU_ITEMS FIAS
                WHERE
                    JEHD.IDCODE = JELN.JEHDR_CODE
                    AND JELN.CHART_FIELD03 = FIAS.IDCODE
                    AND JEHD.JE_SOURCE IN ('CINDX','CRGR','CRCG')
                    AND FIAS.LOAN_CODE = '".$record['CRRP_LOAN_CODE']."'
                    AND JEHD.JE_STATUS = 'PEND'";
        if(ClxCommon::$db->getOne($sql)>0){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-446', $record['CRRP_LOAN_CODE']);
        }

        //Validacion para prevenir que si esta vencido ya no se pueda prorrogar en cuyo caso se restructura
        $sql = "SELECT
                    GLCP.OPERATION_DATE,
                    MAX(FILS.PERIOD_END_DATE) PERIOD_END_DATE
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO,
                    CRED_PAYMNT_SCHEDULES FILS
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = FILS.LOAN_CODE
                    AND FILO.CLX_EFFTDATE = FILS.EFFTDATE
                    AND FILO.IDCODE = '".$record['CRRP_LOAN_CODE']."'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())
                GROUP BY
                    GLCP.OPERATION_DATE
                HAVING
                    MAX(FILS.PERIOD_END_DATE) < GLCP.OPERATION_DATE";
        $fils2 = ClxCommon::$db->getOneRecord($sql);
        if($record['CRRP_CRED_EXT_TYPE']==0 && !empty($fils2)){
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-447');
        }





    }

    //--------------------------------------------------------------------------

    /**
     * Save form event
     *
     * @param array $record
     */
    function save_form(&$record) {
        //global $db;
        if ($record['CRED_EXT_TYPE'] <> '0') {
            $sql = 'SELECT FILO.DEBTOR_CODE FROM CRED_CREDITS FILO '
                    . 'WHERE FILO.IDCODE = ' . singleQuote($record['LOAN_CODE']) . ' '
                    . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) '
                    . ' FROM CRED_CREDITS FILOX '
                    . ' WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <=CURDATE())';
            $debtor = ClxCommon::$db->getOne($sql);
            if (isset($record['DEBTOR_CODE']) && $record['DEBTOR_CODE'] <> 'null' && $debtor <> $record['DEBTOR_CODE']) {
                $record['CRED_EXT_TYPE'] = 2;
            } else {
                $record['CRED_EXT_TYPE'] = 1;
            }
        }
    }


    /**
     * Post Authorization Method
     *
     * @param array $record
     */
    function post_autorize_ori(&$record) {

        //Retorna si ya esta aprobado.

        //Al aprobar no incluye el codigo de la tabla solo la forma al modificar si hace ambas
        if(array_key_exists('CRRP_LOAN_CODE', $record)){
            foreach($record as $key=>$val){
                $record[str_replace('CRRP_','',$key)] = $val;
            }
            $record['ID'] = $record['id'];
        }

        if($record['CLX_AUTH_STATUS']=='AP' || $record['CLX_AUTH_STATUS']=='REJ') return;

        switch($record['CRED_EXT_TYPE']){
            case 0:
                $this->extension($record);
                break;
            case 1:
                $this->restructure($record);
                break;
            case 2:
                $this->restructure($record);
                break;
            default:
                break;
        }


    }

    /**
     *Proceso de prorroga
     * @param type $record
     */
    private function extension(&$record){

    }

    /**
     *Proceso de restructuracion
     * @param type $record
     */
    private function restructure_ori(&$record){

    }//end method


    /**
     *Calculates operation totals according to crrp record
     * @param type $record
     */
    private function crrpCalcTransAmt(&$record){

        //Prefijo se usa en display ya que incluye el CRRP
        #$prefix = (!empty($record['CRRP_id']))?"CRRP_":"";
        $prefix = (array_key_exists('CRRP_LOAN_CODE', $record)) ? "CRRP_" : "";
        $cap = '0';//$record[$prefix.'CAP_PREV_AMT'];
        $inte = $record[$prefix.'INT_PREV_AMT'];
        $fee = '0.00';

        //Monto de capital
        //$cap += $record[$prefix.'CAP_PREV_AMT'];
        $cap = bcadd($cap,$record[$prefix.'CAP_PREV_AMT'],2);
        //$cap -= $record[$prefix.'CAP_PAYMENT_AMT'];
        $cap = bcadd($cap, $record[$prefix.'CAP_PAYMENT_AMT'],2);
        //Int Cap
        /*$cap += $record[$prefix.'INT_CAP_AMT'];
        $cap += $record[$prefix.'FEE_01_CAP_AMT'];
        $cap += $record[$prefix.'FEE_02_CAP_AMT'];
        $cap += $record[$prefix.'FEE_03_CAP_AMT'];
        $cap += $record[$prefix.'FEE_04_CAP_AMT'];
        $cap += $record[$prefix.'FEE_05_CAP_AMT'];*/
        $cap = bcadd($cap, $record[$prefix.'INT_CAP_AMT'],2);
        $cap = bcadd($cap, $record[$prefix.'FEE_01_CAP_AMT'],2);
        $cap = bcadd($cap, $record[$prefix.'FEE_02_CAP_AMT'],2);
        $cap = bcadd($cap, $record[$prefix.'FEE_03_CAP_AMT'],2);
        $cap = bcadd($cap, $record[$prefix.'FEE_04_CAP_AMT'],2);
        $cap = bcadd($cap, $record[$prefix.'FEE_05_CAP_AMT'],2);

        //Interes
        /*$inte += $record[$prefix.'INT_PREV_AMT'];
        $inte -= $record[$prefix.'INT_CAP_AMT'];
        $inte -= $record[$prefix.'INT_CAP_AMT'];
        $inte -= $record[$prefix.'INT_PAYMENT_AMT'];*/
        //$inte = bcadd($inte, $record[$prefix.'INT_PREV_AMT'],2);
        $inte = bcsub($inte, $record[$prefix.'INT_CAP_AMT'],2);
        $inte = bcsub($inte, $record[$prefix.'INT_DISP_AMT'],2);
        $inte = bcsub($inte, $record[$prefix.'INT_PAYMENT_AMT'],2);
        //loop for fees
        for($i = 1; $i<=5; $i++){
            /*$fee = $record[$prefix.'FEE_0'.$i.'_AMT'];
            $fee -= $record[$prefix.'FEE_0'.$i.'_PAY_AMT'];
            $fee -= $record[$prefix.'FEE_0'.$i.'_CAP_AMT'];
            $fee -= $record[$prefix.'FEE_0'.$i.'_DISP_AMT'];*/
            $fee = $record[$prefix.'FEE_0'.$i.'_AMT'];
            $fee = bcsub($fee, $record[$prefix.'FEE_0'.$i.'_PAY_AMT'], 2);
            $fee = bcsub($fee, $record[$prefix.'FEE_0'.$i.'_CAP_AMT'], 2);
            $fee = bcsub($fee, $record[$prefix.'FEE_0'.$i.'_DISP_AMT'], 2);
            if($record[$prefix.'FEE_0'.$i.'_AMT']<>0){
                $record[$prefix.'FEE_0'.$i.'_END_AMT'] = rounder($fee,2);
            }
        }
        //Setting totals
        $record[$prefix.'CAP_ENDING_AMT'] = rounder($cap, 2);
        $record[$prefix.'INT_ENDING_AMT']= rounder($inte, 2);


    }

    /**
     * Process Restructure
     * @param type $record
     */
    private function buildRestructure(&$record) {
        //global $db;

        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');

        //calculate totals
        $this->crrpCalcTransAmt($record);

        //1. COPIAR REGISTRO DE CREDITO CON NUEVA FECHA EFECTIVA.
        $sql = "SELECT
                    FILO.*,
                    GLCP.OPERATION_DATE,
                    CRRP.DEBTOR_CODE NEW_DEBTOR_CODE,
                    CRRP.FIRST_PYMNT_DATE NEW_FIRST_PYMNT_DATE,
                    CRRP.CLX_AUTH_STATUS CRRP_CLX_AUTH_STATUS
                FROM
                    CRED_EXTENSION CRRP,
                    CRED_CREDITS FILO,
                    GL_PARAMETERS_TBL GLCP
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND CRRP.LOAN_CODE = '" . $record['LOAN_CODE'] . "'
                    AND CRRP.EFFTDATE = '" . $record['EFFTDATE'] . "'
                    AND FILO.IDCODE = CRRP.LOAN_CODE
                    AND CRRP.CLX_AUTH_STATUS = 'PEND'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                        FROM CRED_CREDITS FILOX
                        WHERE FILOX.IDCODE = FILO.IDCODE
                        AND FILOX.CLX_EFFTDATE<=CURDATE())";
        $filorec = ClxCommon::$db->getOneRecord($sql);
        if (empty($filorec)) {
            return;
        }



        $debtor_code = $filorec['DEBTOR_CODE'];
        $asuncion_adeudo = false;
        $filo_name = $filorec['IDNAME'];
        if (!empty($filorec['NEW_DEBTOR_CODE']) && $filorec['DEBTOR_CODE'] <> $filorec['NEW_DEBTOR_CODE']) {
            $asuncion_adeudo = true;
            $debtor_code = $filorec['NEW_DEBTOR_CODE'];
            $filo_name = ClxCommon::$db->getField('CRM_ACCOUNTS', 'IDNAME', 'IDCODE=' . singleQuote($debtor_code));
            if (empty($filo_name)) {
                $filo_name = $filorec['IDNAME'];
            }
        }
        $first_paymant_date = $filorec['NEW_FIRST_PYMNT_DATE'];
        unset($filorec['NEW_DEBTOR_CODE'], $filorec['NEW_FIRST_PYMNT_DATE']);

        //usado despues al completar el cambio de status
        $clx_auth_status = $filorec['CRRP_CLX_AUTH_STATUS'];
        unset($filorec['CRRP_CLX_AUTH_STATUS']);
        $oldfilorec = $filorec;

        $operation_date = $filorec['OPERATION_DATE'];
        unset($filorec['ID'], $filorec['OPERATION_DATE']);

        //Ajustar campos y valores en la restructuracion para inicializar el registro
        $filorec['IDCODE'] = (empty($record['NEW_LOAN_CODE']) || strtoupper($record['NEW_LOAN_CODE'])=='NULL' || $record['NEW_LOAN_CODE']=='') ? 'AUTO' : $record['NEW_LOAN_CODE'];
        $filorec['IDNAME'] = $filo_name;
        $filorec['CLX_EFFTDATE'] = $record['EFFTDATE'];
        $filorec['START_DATE'] = $operation_date;

        $filorec['PAY_DAY'] = intval(xFormat::date($filorec['START_DATE'], 'd'));
        $filorec['LOAN_STATUS'] = ($asuncion_adeudo) ? 'VIG' : 'REE';
        $filorec['DEBTOR_CODE'] = $debtor_code;
        $filorec['FIRST_PYMNT_DATE'] = $first_paymant_date;
        if($filorec['IDCODE']==='AUTO'){
            setCreationIdCode($filorec, 'FILO');

        }
        $filorec['CLX_AUTH_STATUS'] = $clx_auth_status;
        setCreationData($filorec);

        $filorec['EXT_PRODUCT_CODE'] = $filorec['IDCODE'];
        $filorec['END_DATE'] = adodb_period_date($filorec['START_DATE'], $filorec['PERIOD_TYPE'], $filorec['LOAN_PERIOD']);

        $filorec['PREV_INTEARNED_AMT'] = 0.00;
        $filorec['INTEARNED_AMT'] = 0.00;
        $filorec['INTPAID_AMT'] = 0.00;
        $filorec['PRINCIPAL_BAL'] = 0.00;
        $filorec['LATE_FEE_BALANCE'] = 0.00;
        $filorec['PREV_LATE_FEE_AMT'] = 0.00;
        $filorec['COMMISSIONS_AMT'] = 0.00;
        $filorec['PREV_COMM_AMT'] = 0.00;
        $filorec['RESERVE_AMT'] = 0.00;
        $filorec['INSURANCE_AMT'] = 0.00;
        $filorec['FEE_01_AMT'] = 0.00;
        $filorec['FEE_02_AMT'] = 0.00;
        $filorec['FEE_03_AMT'] = 0.00;
        $filorec['FEE_04_AMT'] = 0.00;
        $filorec['FEE_05_AMT'] = 0.00;

        $filorec['FEE_01_RATE'] = $record['FEE_01_RATE'];
        $filorec['FEE_02_RATE'] = $record['FEE_02_RATE'];
        $filorec['FEE_03_RATE'] = $record['FEE_03_RATE'];
        $filorec['FEE_04_RATE'] = $record['FEE_04_RATE'];
        $filorec['FEE_05_RATE'] = $record['FEE_05_RATE'];

        $filorec['FEE_01_FIN_PER'] = $record['FEE_01_FIN_PER'];
        $filorec['FEE_02_FIN_PER'] = $record['FEE_02_FIN_PER'];
        $filorec['FEE_03_FIN_PER'] = $record['FEE_03_FIN_PER'];
        $filorec['FEE_04_FIN_PER'] = $record['FEE_04_FIN_PER'];
        $filorec['FEE_05_FIN_PER'] = $record['FEE_05_FIN_PER'];

        $filorec['INTEARNED_ACC'] = 0.00;
        $filorec['LAST_INT_DATE'] = 'NULL';
        $filorec['INT_ACCRUED_DAYS'] = 0;
        $filorec['DUE_PRO_AMT'] = 0.00;
        $filorec['DUE_AR_AMT'] = 0.00;
        $filorec['LAST_DUE_DATE'] = 'NULL';
        $filorec['DUE_OLDST_INST'] = 0;
        $filorec['CURRENT_INST'] = 0;
        $filorec['BALLOON_SDATE'] = 'NULL';
        $filorec['INTEREST_TYPE'] = $record['INTEREST_TYPE'];
        $filorec['LOAN_INTEREST'] = $record['LOAN_INTEREST'];
        $filorec['INTEREST_CALC'] = $record['INTEREST_CALC'];

        $filorec['ADJ_INDEX'] = $record['ADJ_INDEX'];
        $filorec['INDEX_RATE'] = $record['INDEX_RATE'];
        $filorec['ADJ_POINTS_OVERINDEX'] = $record['ADJ_POINTS_OVERINDEX'];
        $filorec['ADJ_PATT_PERIOD'] = $record['ADJ_PATT_PERIOD'];
        $filorec['ADJ_PATTERN'] = $record['ADJ_PATTERN'];
        $filorec['PAY_BANKACT_NO'] = $record['FIDU_BANKACT_CODE'];

        $filorec['LOAN_PERIOD'] = $record['LOAN_PERIOD'];
        $filorec['PERIOD_TYPE'] = $record['PERIOD_TYPE'];
        $filorec['PAYMENT_FREQ'] = $record['PAYMENT_FREQ'];
        $filorec['CRED_PAY_METHOD'] = $record['CRED_PAY_METHOD'];
        $filorec['NO_PAYMENTS'] = $record['NO_PAYMENTS'];
        $filorec['EQ_GRACE_PERIODS'] = $record['EQ_GRACE_PERIODS'];
        $filorec['INT_GRACE_PERIODS'] = $record['INT_GRACE_PERIODS'];


        //Incrementando al loan amount los montos capitalizados
        /* $filorec['LOAN_AMT'] += $record['INT_CAP_AMT'];
          $filorec['LOAN_AMT'] -= $record['CAP_PAYMENT_AMT'];
          for($i = 1; $i<=5; $i++){
          $filorec['LOAN_AMT'] += $record['FEE_0'.$i.'_CAP_AMT'];
          } */
        $filorec['LOAN_AMT'] = $record['CAP_ENDING_AMT'];
        $filorec['REQUESTED_AMT'] = $filorec['LOAN_AMT'] + $filorec['DOWN_PYMT_AMT'];


        //loading credit record with new effective date
        ClxCommon::$db->loadRecord('CRED_CREDITS', $filorec, true, "IDCODE = '" . $filorec['IDCODE'] . "' AND CLX_EFFTDATE = '" . $filorec['CLX_EFFTDATE'] . "'");

        //Copiando fias para registro seleccionado mantenga su subcuenta
        $fiasrecold = ClxCommon::$db->getRecord($this->fiasname, "LOAN_CODE = '" . $oldfilorec['IDCODE'] . "'");
        $fiasrecnew = $fiasrecold;
        if (ClxCommon::$db->countRecords($this->fiasname, "LOAN_CODE = '" . $filorec['IDCODE'] . "'") == 0) {
            unset($fiasrecnew['ID']);
            $fiasrecnew['IDCODE'] = 'AUTO';
            $fiasrecnew['LOAN_CODE'] = $filorec['IDCODE'];
            $fiasrecnew['EXT_PRODUCT_CODE'] = $filorec['IDCODE'];
            $fiasrecnew['IDNAME'] = $filo_name;
            setCreationData($fiasrecnew);
            setCreationIdCode($fiasrecnew, 'FIAS');
            ClxCommon::$db->createRecord($this->fiasname, $fiasrecnew);
        }


        //Creando nuevo deudor en caso de no existir
        if ($asuncion_adeudo) {
            $contract_code = ClxCommon::$db->getField($this->fiasname, "CONTRACT_CODE", "LOAN_CODE = '" . $filorec['IDCODE'] . "'");
            if (!class_exists('Fipa'))
                includeCodeLib('FIPA');
            $fipa = new Fipa();
            $fipa->build($contract_code, $debtor_code, 'DB');
        }

        //Generando cronogramas de pagos para restructuracion una vez creado el credito.
        $restructure = 1;
        $rate_change = 0;
        //ClxCommon::$db->executeQuery("CALL CRED_SET_FILS('" . $filorec['IDCODE'] . "', '" . $filorec['CLX_EFFTDATE'] . "','" . $this->username . "', $restructure, $rate_change)");
        //Actualizando nuevo numero de prestamo para futuras referencias
        ClxCommon::$db->updateRecord($this->crrpname, array('NEW_LOAN_CODE' => $filorec['IDCODE']), "LOAN_CODE = " . singleQuote($record['LOAN_CODE']));

        //Copiar Garantias para el nuevo registro
        //Type: Unique  LOAN_CODE, ASSETCODE, CLX_EFFTDATE
        $sql = "SELECT * FROM $this->filcname WHERE LOAN_CODE = '" . $oldfilorec['IDCODE'] . "'";
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs)) == true) {
            unset($r['ID']);

            $r['LOAN_CODE'] = $filorec['IDCODE'];
            $r['FIAS_LOAN_CODE'] = $fiasrecnew['IDCODE'];
            setCreationData($r);

            ClxCommon::$db->loadRecord($this->filcname, $r, false, "LOAN_CODE='" . $r['LOAN_CODE'] . "' AND ASSETCODE='" . $r['ASSETCODE'] . "' AND CLX_EFFTDATE='" . $r['CLX_EFFTDATE'] . "'");
        }


        //----------------------------------------------------------------------
        //Generando Transacciones de transferencia y pagos SYS-CRED
        //----------------------------------------------------------------------
        //Informacion contable del producto
        $pratfiloold = ClxCommon::$db->getRecord($this->pratname, "PRODUCT_CODE = '" . $oldfilorec['PRODUCT_CODE'] . "' AND PROD_STATUS = '" . $oldfilorec['LOAN_STATUS'] . "'");
        $pratfilonew = ClxCommon::$db->getRecord($this->pratname, "PRODUCT_CODE = '" . $filorec['PRODUCT_CODE'] . "' AND PROD_STATUS = '" . $filorec['LOAN_STATUS'] . "'");

        $bank_acc_no = (!empty($record['FIDU_BANKACT_CODE'])) ? $record['FIDU_BANKACT_CODE'] : $oldfilorec['PAY_BANKACT_NO'];

        $sql = "SELECT
                    FIBK.BANK_ACCOUNT_NO,
                    PRAT.PRO_GL_CODE,
                    FIAS.IDCODE,
                    FIAS.CONTRACT_CODE,
                    IFNULL(NULLIF(FIAS.ACCOUNTCODE,''), (SELECT MAX(FIPA.ACCOUNTCODE)
                        FROM FIDU_PARTICIPANTS FIPA
                        WHERE FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE AND FIPA.ISPRIMARY = 1 AND FIPA.STATUS = 'A')) ACCOUNTCODE,
                    FIBK.CURRENCY_CODE
                FROM
                    $this->pratname PRAT,
                    $this->fibkname FIBK,
                    $this->fiasname FIAS
                WHERE
                    FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO
                    AND FIAS.CONTRACT_CODE = '" . $fiasrecnew['CONTRACT_CODE'] . "'
                    AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
                    AND PRAT.PROD_STATUS = 'VIG'
                    AND FIBK.BANK_ACCOUNT_NO = '$bank_acc_no'
                ";
        $pratfibk = ClxCommon::$db->getOneRecord($sql);


        //Seleccionando participante del credito.
        $sql = "SELECT
                    FIAS.CONTRACT_CODE CHART_FIELD01,
                    IFNULL(NULLIF(FIAS.ACCOUNTCODE,''), (SELECT MAX(FIPA.ACCOUNTCODE)
                        FROM FIDU_PARTICIPANTS FIPA
                        WHERE FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE AND FIPA.ISPRIMARY = 1 AND FIPA.STATUS = 'A')) CHART_FIELD02
                FROM
                    $this->fiasname FIAS
                WHERE
                    FIAS.LOAN_CODE = '" . $oldfilorec['IDCODE'] . "'";
        $fipa = ClxCommon::$db->getOneRecord($sql);


        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        if (!class_exists('Jeln'))
            includeCodeLib('JELN');
        if (!class_exists('Curr'))
            includeCodeLib('CURR');
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');

        $comp = new comp();
        $curr = new Curr();
        $jehd = new Jehd();
        $jeln = new Jeln();
        $fiat = new Fiat ();

        //Informacion de la compania para este proceso
        $comprec = $comp->comp_operation_parameters($filorec['COMP_CODE']);

        $gl_rec = $jehd->jehd_init_record();
        $gl_rec['IDCODE'] = (!empty($record['JEHDR_CODE'])) ? $record['JEHDR_CODE'] : 'AUTO';
        $gl_rec['TRANSTBL_CODE'] = (($asuncion_adeudo) ? 'SYS_CRED-ASU' : 'SYS_CRED-REE');
        $gl_rec['IDNAME'] = ClxCommon::$db->getField($this->fitbname, 'IDNAME', "IDCODE ='" . $gl_rec['TRANSTBL_CODE'] . "'");
        $gl_rec['JE_SOURCE'] = 'PREES';
        $gl_rec['LGGROUP_CODE'] = $comprec['LGGROUP_CODE'];
        $gl_rec['EFFTDATE'] = $comprec['OPERATION_DATE'];
        $gl_rec['COMP_CODE'] = $filorec['COMP_CODE'];
        $gl_rec['TRANS_CODE'] = null;
        $gl_rec['REQ_CHANNEL'] = 'SYS';
        $gl_rec['BATCH_ID'] = $this->batch_id;



        //Obtener cambios requeridos para $filorec['CURRENCY_CODE'] y $pratfibk['CURRENCY_CODE']
        $filoxrate = $curr->get_convertion_info($comprec['CURRENCY_CODE'], $filorec['CURRENCY_CODE'], $comprec['OPERATION_DATE']);
        $fibkxrate = $curr->get_convertion_info($comprec['CURRENCY_CODE'], $pratfibk['CURRENCY_CODE'], $comprec['OPERATION_DATE']);
        $foreigncur = $curr->get_convertion_info($pratfibk['CURRENCY_CODE'], $filorec['CURRENCY_CODE'], $comprec['OPERATION_DATE']);

        //Eliminar monto de capital anterior
        //Incrementar monto de capital actual
        $cash_amt = '0';
        $cap_amount = '0';
        $int_left = '0';
        $operation_lines = array();

        //Include Line for capital to be reduce from old credito
        if ($record['CAP_PREV_AMT'] > 0) {
            $adjustment = '0';

            //Incorporando lineas de productos que esten en otras cuentas
            /* $sql = "SELECT
              JCBV.GLACCOUNTCODE,
              SUM(JCBV.BALANCE_AMT) BALANCE_AMT
              FROM
              GL_CUR_BALANCE_VW JCBV,
              FIDU_ITEMS FIAS
              WHERE
              JCBV.CHART_FIELD03 = FIAS.IDCODE
              AND FIAS.LOAN_CODE = '".$oldfilorec['IDCODE']."'
              AND JCBV.CURRENCY_CODE = '".$oldfilorec['CURRENCY_CODE']."'
              AND JCBV.GLACCOUNTCODE <> '".$pratfiloold['PRO_GL_CODE']."'
              AND EXISTS (SELECT PRAT.ID
              FROM GL_PROD_PRMTR_TBL PRAT
              WHERE PRAT.PRO_GL_CODE = JCBV.GLACCOUNTCODE
              AND PRAT.PRODUCT_CODE = '".$oldfilorec['PRODUCT_CODE']."')
              GROUP BY
              JCBV.GLACCOUNTCODE";
              $rs = ClxCommon::$db->executeQuery($sql);
              while(($r = ClxCommon::$db->getNextRecord($rs))==true){
              $operation_lines[] = array('GLACCOUNTCODE'=>$r['GLACCOUNTCODE'],
              "CURRENCY_CODE"=>$oldfilorec['CURRENCY_CODE'],
              'EXCHANGE_RT'=>$filoxrate['EXCHANGE_RT'],
              'CUR_OPERATOR'=>$filoxrate['CUR_OPERATOR'],
              "DEBIT_TRANS_AMT"=>($r['BALANCE_AMT']<0)?rounder((-1*$r['BALANCE_AMT']),2):0,
              "CREDIT_TRANS_AMT"=>($r['BALANCE_AMT']>0)?$r['BALANCE_AMT']:0,
              "CHART_FIELD01"=>$fipa['CHART_FIELD01'],
              "CHART_FIELD02"=>$fipa['CHART_FIELD02'],
              "CHART_FIELD03"=>$fiasrecold['IDCODE'],
              "ITEM_CODE"=>'CRED',
              'ITEM_REF_NO'=>$fiasrecold['LOAN_CODE']);
              //$adjustment += $r['BALANCE_AMT'];
              $adjustment = bcadd($adjustment, $r['BALANCE_AMT'],2);
              // $cap_amount += $r['BALANCE_AMT'];
              } */


            //Linea para cancelar credito eliminando capital anterior
            $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['PRO_GL_CODE'],
                "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                "DEBIT_TRANS_AMT" => 0,
                "CREDIT_TRANS_AMT" => rounder($record['CAP_PREV_AMT'] - $adjustment, 2),
                "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                "CHART_FIELD03"=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecold['IDCODE'],
                "ITEM_CODE" => 'CRED',
                'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
            //Linea para nuevo credito capital total luedo se descuentan las partes
            $cap_amount = bcadd($cap_amount, $record['CAP_PREV_AMT'], 2);
        }

        if ($record['CAP_PAYMENT_AMT'] > 0) {
            $cap_amount = bcsub($cap_amount, $record['CAP_PAYMENT_AMT'], 2);
            $cash_amt = bcadd($cash_amt, $record['CAP_PAYMENT_AMT'], 2);
        }

        $has_ar_order = false;
        //Reduciendo Intereses en credito anterior
        if ($record["INT_PREV_AMT"] > 0) {

            $adjustment = '0';
            $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['AR_GL_CODE'],
                "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                "DEBIT_TRANS_AMT" => 0,
                "CREDIT_TRANS_AMT" => rounder($record['INT_PREV_AMT'] - $adjustment, 2),
                "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                "CHART_FIELD03"=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecold['IDCODE'],
                "ITEM_CODE" => 'CRED',
                'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);

            //Verificar si cuenta de intereses es cuenta de orden en cuyo caso es necesario agregar una contrapartida para eliminar la cuenta
            if (ClxCommon::$db->countRecords("GL_CODES_TBL", "IDCODE = '" . $pratfiloold['AR_GL_CODE'] . "' AND GL_TYPE IN ('OR','CG')") == 1) {
                $has_ar_order = true;

                $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['INC_GL_CODE'],
                    "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                    'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                    'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                    "DEBIT_TRANS_AMT" => $record['INT_PREV_AMT'],
                    "CREDIT_TRANS_AMT" => 0,
                    "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                    "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                    "CHART_FIELD03"=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecold['IDCODE'],
                    "ITEM_CODE" => 'CRED',
                    'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);

                if ($record["INT_PAYMENT_AMT"] <> 0) {
                    //Incorporando el ingreso por restructuracion
                    $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['AR_ALT_GL_CODE'],
                        "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                        'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                        'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                        "DEBIT_TRANS_AMT" => 0,
                        "CREDIT_TRANS_AMT" => $record["INT_PAYMENT_AMT"],
                        "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                        "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                        //"CHART_FIELD03"=>"NULL",//$fiasrecold['IDCODE'],
                        "CHART_FIELD03" => "NULL",
                        "ITEM_CODE" => 'CRED',
                        'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
                }
            }

            $int_left = bcadd($int_left, $record['INT_PREV_AMT'], 2);
        }


        //Reduciendo Intereses pagados para incorporarlos a efectivo
        if ($record["INT_PAYMENT_AMT"] > 0) {
            $int_left = bcsub($int_left, $record["INT_PAYMENT_AMT"], 2);
            $cash_amt = bcadd($cash_amt, $record["INT_PAYMENT_AMT"], 2);
        }


        //Intereses eliminando intereses capitalizados del total transferido
        if ($record['INT_CAP_AMT'] > 0) {

            $int_left = bcsub($int_left, $record["INT_CAP_AMT"], 2);
            $cap_amount = bcadd($cap_amount, $record['INT_CAP_AMT'], 2);
        }

        //Dispensa de intereses
        if ($record["INT_DISP_AMT"] > 0) {

            //Descargar de ingresos
            if (!$has_ar_order) {
                $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['EXP_GL_CODE'],
                    "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                    'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                    'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                    "DEBIT_TRANS_AMT" => $record['INT_DISP_AMT'],
                    "CREDIT_TRANS_AMT" => 0,
                    "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                    "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                    //"CHART_FIELD03"=>"NULL", $fiasrecnew['IDCODE'],
                    "CHART_FIELD03" => "NULL",
                    "ITEM_CODE" => 'CRED',
                    'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
            }
            //$int_left -= $record["INT_DISP_AMT"];
            $int_left = bcsub($int_left, $record["INT_DISP_AMT"], 2);
        }

        //Si el saldo restante de intereses es mayor que cero entonces contabilzar los intereses
        if (rounder($int_left, 2) <> 0) {

            //Transfiriendo interes anterior a nuevo credito
            $operation_lines[] = array('GLACCOUNTCODE' => $pratfilonew['AR_GL_CODE'],
                "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                "DEBIT_TRANS_AMT" => rounder($int_left, 2),
                "CREDIT_TRANS_AMT" => 0,
                "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                "CHART_FIELD03"=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecnew['IDCODE'],
                "ITEM_CODE" => 'CRED',
                'ITEM_REF_NO' => $fiasrecnew['LOAN_CODE']);

        }

        //Incorporando lineas de comisiones en cada caso
        for ($i = 1; $i <= 5; $i++) {

            //Si el monto esta en cero continuar de lo contrario descargar y luego revisar el nuevo credito
            $feerec = ClxCommon::$db->getRecord("GL_PROD_FEES", "PRODUCT_CODE = '" . $oldfilorec['PRODUCT_CODE'] . "' AND SEQNUM = " . $i);
            $fee_left = '0';

            if ($record['FEE_0' . $i . '_AMT'] <> 0 && !empty($feerec['FEE2_GL_CODE'])) {
                $fee_gl_type = ClxCommon::$db->getField('GL_CODES_TBL','GL_TYPE',"IDCODE = ".singleQuote( $feerec['FEE2_GL_CODE']));
                $operation_lines[] = array('GLACCOUNTCODE' => $feerec['FEE2_GL_CODE'],
                    "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                    'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                    'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                    "DEBIT_TRANS_AMT" => 0,
                    "CREDIT_TRANS_AMT" => $record['FEE_0' . $i . '_AMT'],
                    "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                    "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                    //"CHART_FIELD03"=>($feerec['GLPF_FEE_TYPE'] =='LF')?((!$this->gl_cred_use_ch03)?'NULL':$fiasrecold['IDCODE']):'NULL',
                    "CHART_FIELD03"=>((!$this->gl_cred_use_ch03)?'NULL':(($feerec['GLPF_FEE_TYPE'] =='LF' OR $fee_gl_type == 'AS')?$fiasrecold['IDCODE']:'NULL')),
                    "ITEM_CODE" => $feerec['FEE_ITEM_CODE'],
                    'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
                $fee_left = $record['FEE_0' . $i . '_AMT'];
            }


            if ($record['FEE_0' . $i . '_PAY_AMT'] <> 0 && !empty($feerec['FEE2_GL_CODE'])) {

                //si es solamente pago ya que no tiene saldo acumulado de comisiones por ejemplo por recuperacion
                if ($record['FEE_0' . $i . '_AMT'] == 0) {
                    $operation_lines[] = array('GLACCOUNTCODE' => $feerec['FEE2_GL_CODE'],
                        "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                        'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                        'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                        "DEBIT_TRANS_AMT" => 0,
                        "CREDIT_TRANS_AMT" => $record['FEE_0' . $i . '_PAY_AMT'],
                        "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                        "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                        "CHART_FIELD03" => "NULL",
                        "ITEM_CODE" => $feerec['FEE_ITEM_CODE'],
                        'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
                }
                //contrapartida en caso de aplicar al cliente
                if ($feerec['CHARGE_CUSTOMER'] == 0 && $record['FEE_0' . $i . '_AMT'] == 0) {
                    $operation_lines[] = array('GLACCOUNTCODE' => $feerec['FEE_GL_CODE'],
                        "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                        'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                        'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                        "DEBIT_TRANS_AMT" => $record['FEE_0' . $i . '_PAY_AMT'],
                        "CREDIT_TRANS_AMT" => 0,
                        "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                        "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                        "CHART_FIELD03" => "NULL",
                        "ITEM_CODE" => $feerec['FEE_ITEM_CODE'],
                        'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
                }

                if ($record['FEE_0' . $i . '_AMT'] <> 0) {
                    //$fee_left -= $record['FEE_0'.$i.'_PAY_AMT'];
                    $fee_left = bcsub($fee_left, $record['FEE_0' . $i . '_PAY_AMT'], 2);
                }

                //$cash_amt += $record['FEE_0'.$i.'_PAY_AMT'];
                if ($feerec['CHARGE_CUSTOMER'] <> '0') {
                    $cash_amt = bcadd($cash_amt, $record['FEE_0' . $i . '_PAY_AMT'], 2);
                }
            }

            if ($record['FEE_0' . $i . '_CAP_AMT'] <> 0) {
                if ($record['FEE_0' . $i . '_AMT'] <> 0) {
                    //$fee_left -= $record['FEE_0'.$i.'_CAP_AMT'];
                    $fee_left = bcsub($fee_left, $record['FEE_0' . $i . '_CAP_AMT'], 2);
                }
                //$cap_amount += $record['FEE_0'.$i.'_CAP_AMT'];
                $cap_amount = bcadd($cap_amount, $record['FEE_0' . $i . '_CAP_AMT'], 2);
            }

            //Dispansa
            if ($record['FEE_0' . $i . '_DISP_AMT'] <> 0) {
                //$operation_lines[] = array('GLACCOUNTCODE'=>($feerec['FEE_GL_CODE']<>'')?$feerec['FEE_GL_CODE']:$pratfiloold['EXP_GL_CODE'],
                $operation_lines[] = array('GLACCOUNTCODE' => ((!empty($feerec['FEE_GL_CODE'])) ? $feerec['FEE_GL_CODE'] : $pratfiloold['EXP_GL_CODE']),
                    "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                    'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                    'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                    "DEBIT_TRANS_AMT" => $record['FEE_0' . $i . '_DISP_AMT'],
                    "CREDIT_TRANS_AMT" => 0,
                    "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                    "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                    "CHART_FIELD03"=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecold['IDCODE'],
                    "ITEM_CODE" => $feerec['FEE_ITEM_CODE'],
                    'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
                if ($record['FEE_0' . $i . '_AMT'] <> 0) {
                    //$fee_left -= $record['FEE_0'.$i.'_DISP_AMT'];
                    $fee_left = bcsub($fee_left, $record['FEE_0' . $i . '_DISP_AMT'], 2);
                }
            }

            //Colocando comision restante como parte del nuevo credito
            if (rounder($fee_left, 2) <> 0) {
                $operation_lines[] = array('GLACCOUNTCODE' => $feerec['FEE2_GL_CODE'],
                    "CURRENCY_CODE" => $filorec['CURRENCY_CODE'],
                    'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                    'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                    "DEBIT_TRANS_AMT" => rounder($fee_left, 2),
                    "CREDIT_TRANS_AMT" => 0,
                    "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                    "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                    "CHART_FIELD03" => "NULL",
                    "ITEM_CODE" => 'CRED',
                    'ITEM_REF_NO' => $fiasrecnew['LOAN_CODE']);
            }
        }

        //Linea de Ingreso por comision de restructuracion
        if ($record['RES_FEE_AMT'] > 0) {
            $operation_lines[] = array('GLACCOUNTCODE' => $pratfiloold['REFE_GL_CODE'],
                "CURRENCY_CODE" => $oldfilorec['CURRENCY_CODE'],
                'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                "DEBIT_TRANS_AMT" => 0,
                "CREDIT_TRANS_AMT" => $record['RES_FEE_AMT'],
                "CHART_FIELD01" => $fipa['CHART_FIELD01'],
                "CHART_FIELD02" => $fipa['CHART_FIELD02'],
                //"CHART_FIELD03"=>"NULL", //$fiasrecnew['IDCODE'],
                "CHART_FIELD03" => "NULL",
                "ITEM_CODE" => 'CRED',
                'ITEM_REF_NO' => $fiasrecold['LOAN_CODE']);
            //$cash_amt +=$record['RES_FEE_AMT'];
            $cash_amt = bcadd($cash_amt, $record['RES_FEE_AMT'], 2);
        }

        //Contrapartida de capital
        if ($cap_amount > 0) {

            //Agregando lineas de montos capitalizados
            $operation_lines[] = array('GLACCOUNTCODE' => $pratfilonew['PRO_GL_CODE'],
                'CURRENCY_CODE' => $filorec['CURRENCY_CODE'],
                'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR'],
                'DEBIT_TRANS_AMT' => $cap_amount,
                'CREDIT_TRANS_AMT' => 0,
                'CHART_FIELD01' => $fipa['CHART_FIELD01'],
                'CHART_FIELD02' => $fipa['CHART_FIELD02'],
                'CHART_FIELD03'=>(!$this->gl_cred_use_ch03)?'NULL':$fiasrecnew['IDCODE'],
                'ITEM_CODE' => 'CRED',
                'ITEM_REF_NO' => $fiasrecnew['LOAN_CODE']);
        }

        //Efectivo
        if ($cash_amt > 0) {
            $cash_line_amt = $cash_amt;
            if ($foreigncur['EXCHANGE_RT'] <> 1) {
                $cash_line_amt = (($foreigncur['CUR_OPERATOR'] == 1) ? bcmul($cash_line_amt, $foreigncur['EXCHANGE_RT']):bcdiv($cash_line_amt, $foreigncur['EXCHANGE_RT']));
            }

            $operation_lines[] = array('GLACCOUNTCODE' => $pratfibk['PRO_GL_CODE'],
                'CURRENCY_CODE' => $pratfibk['CURRENCY_CODE'],
                'EXCHANGE_RT' => $fibkxrate['EXCHANGE_RT'],
                'CUR_OPERATOR' => $fibkxrate['CUR_OPERATOR'],
                //'DEBIT_TRANS_AMT'=>(($pratfibk['CURRENCY_CODE']==$filorec['CURRENCY_CODE'])?$cash_amt:(($fibkxrate['CUR_OPERATOR']==1)?($cash_amt/$fibkxrate['EXCHANGE_RT']):($cash_amt*$fibkxrate['EXCHANGE_RT']))),
                'DEBIT_TRANS_AMT' => rounder($cash_line_amt, 2),
                'CREDIT_TRANS_AMT' => 0,
                'CHART_FIELD01' => $fipa['CHART_FIELD01'],
                'CHART_FIELD02' => $fipa['CHART_FIELD02'],
                'CHART_FIELD03'=>(!$this->gl_cred_use_ch03)?'NULL':$pratfibk['IDCODE'],
                'ITEM_CODE' => 'CRED',
                'ITEM_REF_NO' => $pratfibk['BANK_ACCOUNT_NO']);
        }



        //No contabilizar si hay lineas
        if (empty($operation_lines))
            return;

        $trans_amt = $cash_amt;

        $trans_rec = array('DISBURSEMENT_TYPE' => 'OT',
            'IDNAME' => $gl_rec['IDNAME'],
            "AVAILABILITY_DATE" => $gl_rec['EFFTDATE'],
            'CURRENCY_CODE' => $filorec['CURRENCY_CODE'],
            'EXCHANGE_RT' => $filoxrate['EXCHANGE_RT'],
            'CUR_OPERATOR' => $filoxrate['CUR_OPERATOR']);
        if ($trans_amt == 0)
            $trans_amt = $cap_amount;


        $trans_code = ClxCommon::$db->getField($this->jehdname, 'TRANS_CODE', 'IDCODE = ' . singleQuote($gl_rec['IDCODE']));
        if (empty($trans_code)) {
            $trans_code = $fiat->fiat_build($gl_rec['COMP_CODE'], $gl_rec['TRANSTBL_CODE'], $fipa ['CHART_FIELD01'], $fipa ['CHART_FIELD02'], $trans_amt, $trans_rec);
        }

        $gl_rec['TRANS_CODE'] = $trans_code;
        $gl_rec['IDCODE'] = ClxCommon::$db->getField($this->jehdname, "IDCODE", "TRANS_CODE='" . $trans_code . "'");

        //updating journal
        ClxCommon::$db->updateRecord($this->crrpname, array('JEHDR_CODE' => $gl_rec['IDCODE']), "LOAN_CODE = " . singleQuote($record['LOAN_CODE']));

        //Construir asiento
        $jehd->jehd_build($gl_rec);
        ClxCommon::$db->updateRecord($this->jelnname, array('IS_REMOVE' => 1), 'JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']));
        //Construyendo lineas

        foreach ($operation_lines as $key => $val) {
            $val['JEHDR_CODE'] = $gl_rec['IDCODE'];
            $val['DEBIT_AMT'] = round($val['DEBIT_TRANS_AMT'], 2);
            $val['CREDIT_AMT'] = round($val['CREDIT_TRANS_AMT'], 2);
            $val['DEBIT_TRANS_AMT'] = 0;
            $val['CREDIT_TRANS_AMT'] = 0;
            //$val['CHART_FIELD03'] = 'NULL';
            $val['CHART_FIELD04'] = "";
            $val['SEQNUM'] = $key;
            $val['IS_REMOVE'] = 0;
            $operation_lines[$key]['SEQNUM'] = $key;
            $operation_lines[$key]['JEHDR_CODE'] = $gl_rec['IDCODE'];
            $jeln->jeln_build($val, false); // $revert_exchange = false
        }
        ClxCommon::$db->deleteRecords($this->jelnname, 'JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND IS_REMOVE = 1');


        //Ajustando diferencias por conversiones contra ultima linea en caso de existir
        $sql = "SELECT MAX(SEQNUM) SEQNUM, ROUND(SUM(DEBIT_AMT-CREDIT_AMT),2) DIF
                FROM GL_JOURNAL_LINES
                WHERE JEHDR_CODE = '" . $gl_rec['IDCODE'] . "'
                HAVING ROUND(SUM(DEBIT_AMT-CREDIT_AMT),2) BETWEEN -0.3 AND 0.3";
        $r = ClxCommon::$db->getOneRecord($sql);
        if (!empty($r)) {

            if ($operation_lines[$r['SEQNUM']]['EXCHANGE_RT'] == 1) {

                if ($r['DIF'] <= 0) {
                    $sql1 = 'UPDATE GL_JOURNAL_LINES SET DEBIT_AMT = DEBIT_AMT + (' . bcmul($r['DIF'], '-1', 2) . '), DEBIT_TRANS_AMT = DEBIT_AMT WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND DEBIT_AMT > 0.3 AND CREDIT_AMT = 0';
                    $sql2 = 'UPDATE GL_JOURNAL_LINES SET CREDIT_AMT = CREDIT_AMT + (' . bcmul($r['DIF'], '-1', 2) . '), CREDIT_TRANS_AMT = CREDIT_AMT WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND CREDIT_AMT > 0.3 AND DEBIT_AMT = 0';
                } else {
                    $sql1 = 'UPDATE GL_JOURNAL_LINES SET DEBIT_AMT = DEBIT_AMT + (' . bcmul($r['DIF'], '1', 2) . '), DEBIT_TRANS_AMT = DEBIT_AMT WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND DEBIT_AMT > 0.3 AND CREDIT_AMT = 0';
                    $sql2 = 'UPDATE GL_JOURNAL_LINES SET CREDIT_AMT = CREDIT_AMT + (' . bcmul($r['DIF'], '1', 2) . '), CREDIT_TRANS_AMT = CREDIT_AMT WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND CREDIT_AMT > 0.3 AND DEBIT_AMT = 0';
                }
            } else {
                if ($r['DIF'] <= 0) {
                    $sql1 = 'UPDATE GL_JOURNAL_LINES SET DEBIT_AMT = DEBIT_AMT + (' . bcmul($r['DIF'], '-1', 2) . ') WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND DEBIT_AMT > 0.3 AND CREDIT_AMT = 0';
                    $sql2 = 'UPDATE GL_JOURNAL_LINES SET CREDIT_AMT = CREDIT_AMT + (' . bcmul($r['DIF'], '-1', 2) . ') WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND CREDIT_AMT > 0.3 AND DEBIT_AMT = 0';
                } else {
                    $sql1 = 'UPDATE GL_JOURNAL_LINES SET DEBIT_AMT = DEBIT_AMT + (' . bcmul($r['DIF'], '1', 2) . ') WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND DEBIT_AMT > 0.3 AND CREDIT_AMT = 0';
                    $sql2 = 'UPDATE GL_JOURNAL_LINES SET CREDIT_AMT = CREDIT_AMT + (' . bcmul($r['DIF'], '1', 2) . ') WHERE JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND SEQNUM = ' . $r['SEQNUM'] . ' AND CREDIT_AMT > 0.3 AND DEBIT_AMT = 0';
                }
            }

            ClxCommon::$db->executeQuery($sql1);
            ClxCommon::$db->executeQuery($sql2);
        }

        //Aprovar asiento contable
        //$fiat->fiat_approve_by_transcode ( $trans_code );
        //el estatus se define en proceso. Cambiar status a registro anterior a estatus REEC
        //ClxCommon::$db->updateRecord($this->filoname, array('LOAN_STATUS'=> ($asuncion_adeudo)?'ASU':'REEC', 'LOAN_AMT'=>0,'PRINCIPAL_BAL'=>0,'INTEARNED_AMT'=>0,'INTPAID_AMT'=>0,'INTEARNED_ACC'=>0), "ID = ".$oldfilorec['ID']);
    }
    //end method

    /**
     * Save form event
     *
     * @param array $record
     */
    function save_form_post(&$record) {
        //build accounting and information regarding redistribution
        if ($record['CRED_EXT_TYPE'] <> '0') {
            $this->buildRestructure($record);
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
       // global $db, $ac;

        $ac = UserRequest::$request['ac'];

        //Validar que registro este en status de pendiente para ser modificado.
        if($record['CRRP_CLX_AUTH_STATUS']<> 'PEND'){
            $msg['CRRP_CLX_AUTH_STATUS'] = smsg('MSG-434');
            if ($ac == 'DELETE') {
                addMessage($msg['CRRP_CLX_AUTH_STATUS']);
            }
            return false;
        }

        if ($ac == 'DELETE') {
            return true;
        }



        //Validar que el credito se encuentre al dia.
        //Validar que creditos al vencimiento prorrogas no sean mayores a 6 meses
        $sql = "SELECT
                    FILO.IDCODE,
                    FILO.START_DATE,
                    FILO.CLX_EFFTDATE,
                    GLCP.OPERATION_DATE,
                    FILO.PRODUCT_CODE,
                    FILO.PRINCIPAL_BAL,
                    FILO.CRED_LINE_CODE,
                    FILO.END_DATE
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = '" . $record['CRRP_LOAN_CODE'] . "'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())";
        $filo = ClxCommon::$db->getOneRecord($sql);


        //Validar de no prorrogar el primer dia del credito.
        if ($filo['START_DATE'] == $filo['OPERATION_DATE'] && $record['CRRP_CRED_EXT_TYPE'] == 0) {
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-448');
        }


        //Validar que tenga cuenta contables
        if ($record['CRRP_CRED_EXT_TYPE'] <> 0 && $record['CRRP_RES_FEE_AMT'] <> 0) {

            $sql = "SELECT COUNT(PRAT.ID)
                    FROM $this->pratname PRAT
                    WHERE PRAT.PRODUCT_CODE = '" . $filo['PRODUCT_CODE'] . "'
                        AND PRAT.REFE_GL_CODE IS NULL";
            if (ClxCommon::$db->getOne($sql) > 0) {
                $msg['CRRP_RES_FEE_AMT'] = smsg('MSG-150', $filo['PRODUCT_CODE']);
            }
        }


        //Validar que las fechas efectivas de prorroga no sea igual a la fecha de restructuracion
        if ($filo['CLX_EFFTDATE'] >= $record['CRRP_EFFTDATE']) {
            $msg['CRRP_EFFTDATE'] = smsg("MSG-444");
        }

        //Extension no puede ser menor o mayor de rango del credito en caso de prorrogas
        if ($record['CRRP_CRED_EXT_TYPE'] == 0 && ($filo['START_DATE'] > $record['CRRP_EFFTDATE'] || $filo['END_DATE'] < $record['CRRP_EFFTDATE'])) {
            $msg['CRRP_EFFTDATE'] = smsg('MSG-20170126095844', $filo['START_DATE'], $filo['END_DATE']);
        }

        //Validando saldo de capital
        /* if(!empty($fils['PRINCIPAL_BAL']) && $fils['PRINCIPAL_BAL']>0  && $record['CRRP_CRED_EXT_TYPE']==0){
          $msg['CRRP_LOAN_CODE'] = smsg('MSG-432', xFormat::number($fils['PRINCIPAL_BAL']));
          }

          //validar saldos de intereses
          if(!empty($fils['INTEREST_BAL']) && $fils['INTEREST_BAL']>0 && $record['CRRP_CRED_EXT_TYPE']==0){
          $msg['CRRP_LOAN_CODE'] = smsg('MSG-433', xFormat::number($fils['INTEREST_BAL']));
          }
         */
        $sql = "SELECT
                    PRLT.MAX_EXT_PERIOD,
                    PRLT.EXT_PERIOD_TYPE,
                    PRLT.MAX_RES_PERIOD,
                    PRLT.RES_PERIOD_TYPE,
                    PRLT.EXT_PRV_LMT_PERIOD,
                    PRLT.EXT_PRV_LMT_TYPE
                FROM
                    CRED_PROD_PRMTR_TBL PRLT
                WHERE
                    PRLT.PRODUCT_CODE = '" . $filo['PRODUCT_CODE'] . "'";
        $prlt = ClxCommon::$db->getOneRecord($sql);
        //Validar que no se extiendan el numero de couta mas de seis meses.
        //Validacion no puede pasar de 6 meses.
        $max_date = adodb_period_date($filo['OPERATION_DATE'], $prlt['EXT_PERIOD_TYPE'], $prlt['MAX_EXT_PERIOD']);
        if($record['CRRP_PERIOD_TYPE'] =='S'){
            $record['CRRP_PERIOD_TYPE'] = 'SE';
        }
        if ($record['CRRP_CRED_EXT_TYPE'] <> 0) {
            $new_date = adodb_period_date($filo['OPERATION_DATE'], $record['CRRP_PERIOD_TYPE'], $record['CRRP_LOAN_PERIOD']);
        } else {
            echo $filo['OPERATION_DATE'],', ', $record['CRRP_PERIOD_TYPE'],', ', $record['CRRP_EXTENSION_PERIOD'],'<br>';

            $new_date = adodb_period_date($filo['OPERATION_DATE'], $record['CRRP_PERIOD_TYPE'], $record['CRRP_EXTENSION_PERIOD']);
        }
        //Validar que fecha de operaciones de extension no sea mayor a la fecha de opeaciones
        if ($filo['OPERATION_DATE'] < $record['CRRP_EFFTDATE']) {
            $msg['CRRP_EFFTDATE'] = smsg('MSG-20170126095416');
        }

        //Si fecha de restructuracion es menor o igual fecha de operaciones es invalido.
        if ($filo['OPERATION_DATE'] >= $new_date) {
            if ($record['CRRP_CRED_EXT_TYPE'] <> 0) {
                $msg['CRRP_LOAN_PERIOD'] = smsg('MSG-435');
            } else {
                $msg['CRRP_EXTENSION_PERIOD'] = smsg('MSG-435');
            }
        }

        //Se fecha de fin es mayor que maxima fecha entonces es error
        if ($record['CRRP_CRED_EXT_TYPE'] == 0 && $prlt['EXT_PERIOD_TYPE'] <> '' && $new_date > $max_date) {
            $msg['CRRP_EXTENSION_PERIOD'] = smsg('MSG-436', $new_date, $max_date);
        }

        //Validar que credito no se encuentre en status de preparacion o cancelado.
        if (empty($filo['PRINCIPAL_BAL']) || $filo['PRINCIPAL_BAL'] == 0) {
            $msg['CRRP_LOAN_CODE'] = smsg('MSG-437') . ' ' . xFormat::number($filo['PRINCIPAL_BAL']);
        }

        //EXT_PRV_LMT_PERIOD
        if ($prlt['EXT_PRV_LMT_PERIOD'] <> 0) {

            $prevnew_date = adodb_period_date($record['CRRP_EFFTDATE'], $prlt['EXT_PRV_LMT_TYPE'], -1 * $prlt['EXT_PRV_LMT_PERIOD']);

            //Validar que no haya renovaciones en los ultimos 12 meses
            $sql = "SELECT
                        COUNT(CRRP.ID) QTY
                    FROM
                        $this->crrpname CRRP
                    WHERE
                        CRRP.LOAN_CODE = '" . $record['CRRP_LOAN_CODE'] . "'
                        AND CRRP.EFFTDATE <'" . $record['CRRP_EFFTDATE'] . "'
                        AND  CRRP.EFFTDATE >= '$prevnew_date'
                        AND CRRP.CLX_AUTH_STATUS = 'AP'";
            if (ClxCommon::$db->getOne($sql) > 0) {
                $msg['CRRP_EFFTDATE'] = smsg('MSG-438');
            }
        }

        if ($record['CRRP_CRED_EXT_TYPE'] <> 0) {

            //load derived amount
            $this->crrpCalcTransAmt($record);

            //FILO_PAY_BANKACT_NO
            //Validar que el monto final de intereses sea igual a cero.
            if ($record['CRRP_INT_ENDING_AMT'] <> 0) {
                $msg['CRRP_INT_ENDING_AMT'] = smsg('MSG-443');
            }

            if (!empty($filo['CRED_LINE_CODE'])) {
                 $sql = "SELECT MAX(CRCL.END_DATE) CRCL_AVAILABLE_AMT_WRK
                        FROM
                            CRM_ACCOUNTS ACCO,
                            CRED_CREDIT_LINES CRCL,
                            GL_PARAMETERS_TBL GLCP
                        WHERE
                            ACCO.IDCODE = CRCL.ACCOUNTCODE
                            AND GLCP.COMP_CODE = CRCL.COMP_CODE
                            AND CRCL.IDCODE = '" . $filo['CRED_LINE_CODE'] . "'
                            AND CRCL.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
                                                    FROM CRED_CREDIT_LINES X
                                                    WHERE  X.IDCODE=CRCL.IDCODE AND  X.CLX_EFFTDATE<=GLCP.OPERATION_DATE)";
                    $crcl_end_date = ClxCommon::$db->getOne($sql);
                    $new_end_date = adodb_period_date($record['CRRP_EFFTDATE'], $record['CRRP_PERIOD_TYPE'], $record['CRRP_LOAN_PERIOD']);
                    if($crcl_end_date<$new_end_date){
                        $msg['CRRP_LOAN_PERIOD'] = smsg('MSG-20170804125552', $crcl_end_date, $new_end_date);
                    }



            }


            //Validando que el monto de capital restructurado no sea mayor al monto de la linea
            if (!empty($filo['CRED_LINE_CODE']) && $record['CRRP_CAP_ENDING_AMT'] > 0) {

                $sql = "SELECT (CRCL.LINE_AMT-CRCL.BORROWED_AMT) CRCL_AVAILABLE_AMT_WRK
                        FROM
                            CRM_ACCOUNTS ACCO,
                            CRED_CREDIT_LINES CRCL,
                            GL_PARAMETERS_TBL GLCP
                        WHERE
                            ACCO.IDCODE = CRCL.ACCOUNTCODE
                            AND GLCP.COMP_CODE = CRCL.COMP_CODE
                            AND CRCL.IDCODE = '" . $filo['CRED_LINE_CODE'] . "'
                            AND CRCL.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
                                                    FROM CRED_CREDIT_LINES X
                                                    WHERE  X.IDCODE=CRCL.IDCODE AND  X.CLX_EFFTDATE<=GLCP.OPERATION_DATE)";
                $one = ClxCommon::$db->getOne($sql);
                if ($one < $record['CRRP_CAP_ENDING_AMT']) {
                    $msg['CRRP_CAP_ENDING_AMT'] = smsg('MSG-466');
                }
            }

            //validando que todas las comisiones se encuentren en cero.
            for ($i = 1; $i <= 5; $i++) {
                if ($record['CRRP_FEE_0' . $i . '_AMT'] <> 0 && $record['CRRP_FEE_0' . $i . '_END_AMT'] <> 0) {
                    $msg['CRRP_FEE_0' . $i . '_END_AMT'] = smsg('MSG-20170427131033') . ' ' . $i;
                }
            }

            //verificar que comprobante este correcto
            if ($ac == 'REQAUTHORIZATION') {
                //set status ap
                ClxCommon::$db->updateRecord('CRED_CREDITS',array('CLX_AUTH_STATUS'=>'AP'), 'IDCODE = '.singleQuote($record['CRRP_NEW_LOAN_CODE']).' AND CLX_AUTH_STATUS = '.singleQuote('PEND'));

                if (!class_exists('Jehd')) {
                    includeCodeLib('JEHD');
                }
                $jehd = new Jehd ();
                $jehd->jehd_validate_by_code($record['CRRP_JEHDR_CODE'], $msg);

                if(!empty($msg)){
                     ClxCommon::$db->updateRecord('CRED_CREDITS',array('CLX_AUTH_STATUS'=>'PEND'),'IDCODE = '.singleQuote($record['CRRP_NEW_LOAN_CODE']).' AND CLX_AUTH_STATUS = '.singleQuote('AP'));
                }
            }

        }//end if $record['CRRP_CRED_EXT_TYPE']==0

        /* $sql = "SELECT
          COUNT(JEHD.ID) QTY
          FROM
          GL_JOURNAL_HDR JEHD,
          GL_JOURNAL_LINES JELN,
          FIDU_ITEMS FIAS
          WHERE
          JEHD.IDCODE = JELN.JEHDR_CODE
          AND JELN.CHART_FIELD03 = FIAS.IDCODE
          AND JEHD.JE_SOURCE IN ('CINDX','CRGR','CRCG')
          AND FIAS.LOAN_CODE = '".$record['CRRP_LOAN_CODE']."'
          AND JEHD.JE_STATUS = 'PEND'";
          if(ClxCommon::$db->getOne($sql)>0){
          $msg['CRRP_LOAN_CODE'] = smsg('MSG-446', $record['CRRP_LOAN_CODE']);
          } */

        //Validacion para prevenir que si esta vencido ya no se pueda prorrogar en cuyo caso se restructura
        /* $sql = "SELECT
          GLCP.OPERATION_DATE,
          MAX(FILS.PERIOD_END_DATE) PERIOD_END_DATE
          FROM
          GL_PARAMETERS_TBL GLCP,
          CRED_CREDITS FILO,
          CRED_PAYMNT_SCHEDULES FILS
          WHERE
          GLCP.COMP_CODE = FILO.COMP_CODE
          AND FILO.IDCODE = FILS.LOAN_CODE
          AND FILO.CLX_EFFTDATE = FILS.EFFTDATE
          AND FILO.IDCODE = '".$record['CRRP_LOAN_CODE']."'
          AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
          FROM CRED_CREDITS FILOX
          WHERE FILOX.IDCODE = FILO.IDCODE
          AND FILOX.CLX_EFFTDATE <= NOW())
          GROUP BY
          GLCP.OPERATION_DATE
          HAVING
          MAX(FILS.PERIOD_END_DATE) < GLCP.OPERATION_DATE"; */

        /*if (!class_exists('Filo'))
            includeCodeLib('FILO');
        $filoobj = new Filo();
        $filoobj->loadCreditInstallments($filo['IDCODE'], $filo['OPERATION_DATE']);*/

        #$sql = "SELECT
        #            MIN(CSTM.PERIOD_START_DATE) PERIOD_START_DATE,
        #            MAX(CSTM.PERIOD_END_DATE) PERIOD_END_DATE
        #        FROM
        #            CRED_SCHEDULE_TMP CSTM
        #        WHERE
        #            CSTM.LOAN_CODE = '" . $record['CRRP_LOAN_CODE'] . "'";
        #$fils2 = ClxCommon::$db->getOneRecord($sql);
        #if ($record['CRRP_CRED_EXT_TYPE'] == 0 && !empty($fils2) && $fils2['PERIOD_END_DATE'] < $filo['OPERATION_DATE']) {
        #    $msg['CRRP_LOAN_CODE'] = smsg('MSG-447');
        #}

        #if ($record['CRRP_CRED_EXT_TYPE'] == 0 && !empty($fils2) && $fils2['PERIOD_START_DATE'] >= $record['CRRP_EFFTDATE']) {
        #    $msg['CRRP_LOAN_CODE'] = smsg('MSG-20170314171329');
        #}


        //Validar que comisiones por colocacion (Desembolso) sean cero en caso de restructuracion ya que este evento desembolso no ocurrira.
        #$sql = "SELECT DISTINCT GLPF.SEQNUM
        #        FROM GL_PROD_FEES GLPF, CRED_CREDITS FILO
        #        WHERE
        #          GLPF.FEE_FORMULA IN ('P0007','F0002')
        #          AND GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE
        #          AND FILO.IDCODE = '" . $record['CRRP_LOAN_CODE'] . "'
        #          AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE)
        #          AND 0<>" . $record['CRRP_CRED_EXT_TYPE'];
        #$rs = ClxCommon::$db->executeQuery($sql);
        #while ($r = ClxCommon::$db->getNextRecord($rs)) {
        #    if ($record['CRRP_FEE_0' . $r['SEQNUM'] . '_RATE'] <> 0) {
        #        $msg['CRRP_FEE_0' . $r['SEQNUM'] . '_RATE'] = smsg('MSG-20170417150141');
        #    }
        #    if ($record['CRRP_FEE_0' . $r['SEQNUM'] . '_FIN_PER']) {
        #        $msg['CRRP_FEE_0' . $r['SEQNUM'] . '_FIN_PER'] = smsg('MSG-20170417150141');
        #    }
        #}


    }

    /**
     * Post Authorization Method
     *
     * @param array $record
     */
    function post_autorize(&$record) {
        #global $ac;

        $ac = UserRequest::$request['ac'];
        if(empty($record['ac']) && !empty($ac)){
            $record['ac'] = $ac;
        }

        //Retorna si ya esta aprobado.
        if (empty($record) || (!empty($record['ac']) && $record['ac'] == 'DELETE')) {
            return;
        }

        //Al aprobar no incluye el codigo de la tabla solo la forma al modificar si hace ambas
        if (array_key_exists('CRRP_LOAN_CODE', $record)) {
            foreach ($record as $key => $val) {
                $record[str_replace('CRRP_', '', $key)] = $val;
            }
            $record['ID'] = $record['id'];
        }

        if ($record['CLX_AUTH_STATUS'] <>'PEND' && $record['CLX_AUTH_STATUS'] <> 'AP')
            return;
        switch ($record['CRED_EXT_TYPE']) {
            case 0:
                $this->extension($record);
                break;
            case 1:
                $record['CRRP_NEW_LOAN_STATUS'] = 'REEC';
                $this->restructure($record);
                break;
            case 2:
                $record['CRRP_NEW_LOAN_STATUS'] = 'ASU';
                $this->restructure($record);
                break;
            default:
                break;
        }
    }

    /**
     * Credit extension process
     * @param type $record
     */
    private function restructure(&$record) {
        #global $db;

        ClxCommon::$db->updateRecord('CRED_CREDITS',array('CLX_AUTH_STATUS'=>'AP'),'IDCODE = '.singleQuote($record['NEW_LOAN_CODE']).' AND CLX_AUTH_STATUS = '.singleQuote('PEND'));

        $sql = "SELECT 
                    FILO.PRINCIPAL_BAL,
                    FILO.CLX_EFFTDATE
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = '" . $record['LOAN_CODE'] . "'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())";
        $filo = ClxCommon::$db->getOneRecord($sql);
		$sql = "SELECT 
                    FILO.LOAN_AMT,
                    FILO.CLX_EFFTDATE
                FROM
                    GL_PARAMETERS_TBL GLCP,
                    CRED_CREDITS FILO
                WHERE
                    GLCP.COMP_CODE = FILO.COMP_CODE
                    AND FILO.IDCODE = '" . $record['NEW_LOAN_CODE'] . "'
                    AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM CRED_CREDITS FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                            AND FILOX.CLX_EFFTDATE <= NOW())";
        $new_filo = ClxCommon::$db->getOneRecord($sql);
        #$new_cred_principal_bal = $filo['PRINCIPAL_BAL'];
		$new_cred_principal_bal = $new_filo['LOAN_AMT'];
        ClxCommon::$db->updateRecord('CRED_CREDITS',array('PRINCIPAL_BAL'=>$new_cred_principal_bal),'IDCODE = '.singleQuote($record['NEW_LOAN_CODE']).' AND CLX_AUTH_STATUS = '.singleQuote('AP'));

        $trans_code = ClxCommon::$db->getField($this->jehdname, 'TRANS_CODE', 'IDCODE = ' . singleQuote($record['JEHDR_CODE']) . ' AND JE_STATUS = ' . singleQuote('PEND'));
        if (!empty($trans_code)) {
            if (!class_exists('Fiat'))
                includeCodeLib('FIAT');
            $fiat = new Fiat ();
            $fiat->fiat_approve_by_transcode($trans_code);
            if(array_key_exists('CRRP_NEW_LOAN_STATUS', $record)){
                ClxCommon::$db->updateRecord('CRED_CREDITS',array('LOAN_STATUS'=>$record['CRRP_NEW_LOAN_STATUS']),'IDCODE = '.singleQuote($record['LOAN_CODE']).' AND CLX_AUTH_STATUS = '.singleQuote('AP'));
                $this->restructure_schedule($record['LOAN_CODE'],$filo['CLX_EFFTDATE'],$record['NEW_LOAN_CODE'],$record['CRRP_NEW_LOAN_STATUS']);
            }
        }
    }

    function restructure_schedule($loan_code,$loan_code_clxefftdate,$new_loan_code,$new_loan_status){
                $sql = "SELECT 
                        FILO.DEBTOR_CODE,
                        FILO.CLX_EFFTDATE
                    FROM
                        GL_PARAMETERS_TBL GLCP,
                        CRED_CREDITS FILO
                    WHERE
                        GLCP.COMP_CODE = FILO.COMP_CODE
                        AND FILO.IDCODE = '" . $new_loan_code . "'
                         ORDER BY FILO.ID DESC";
                $filo = ClxCommon::$db->getOneRecord($sql);
        switch ($new_loan_status) {
            case 'REEC':
                ClxCommon::$db->executeQuery("CALL CRED_SET_FILS('" . $new_loan_code . "', '" . $filo['CLX_EFFTDATE'] . "','" . $this->username . "', 0, 0)");
                ClxCommon::$db->updateRecord('CRED_CREDITS',array('PRINCIPAL_BAL'=>0),'IDCODE = '.singleQuote($loan_code).' AND LOAN_STATUS = '.singleQuote('REEC'));
                break;
            case 'ASU':
                $sql = 'INSERT INTO CRED_PAYMNT_SCHEDULES (
                        `EFFTDATE`,
                        `LOAN_CODE`,
                        `LOAN_INTEREST`,
                        `LOAN_PERIOD`,
                        `CRED_PAY_METHOD`,
                        `NO_PAYMENTS`,
                        `PRINCIPAL_BAL`,
                        `SEQNUM`,
                        `PAYMENT_AMT`,
                        `PRINCIPAL_PAY`,
                        `INTEREST_PAY`,
                        `PAYMENT_DATE`,
                        `RESERVE_PCT`,
                        `INSTALLMENT_NO`,
                        `PERIOD_START_DATE`,
                        `PERIOD_END_DATE`,
                        `PAID_AMT`,
                        `LOAN_AMT`,
                        `RESERVE_PAY`,
                        `INDEX_RATE`,
                        `ADJ_INDEX`,
                        `INTEREST_TYPE`,
                        `ADJ_POINTS_OVERINDEX`,
                        `RESERVE_INDEX`,
                        `INTEREST_CALC`,
                        `RESERVE_AMT`,
                        `NO_DAYS`,
                        `DAILY_INTEREST`,
                        `DAILY_RESERVE`,
                        `INTEREST_AMT`,
                        `RESERVE_PERIOD`,
                        `INTEREST_PERIOD`,
                        `EQ_GRACE_PERIODS`,
                        `DEBTOR_CODE`,
                        `BALLOON_PAY_AMT`,
                        `FEES_AMT`,
                        `DUE_PAY_DATE`,
                        `PPAL_PAID_AMT`,
                        `INTPAID_AMT`,
                        `MODIFIEDBY`,
                        `RESTRUCTURE`,
                        `CAPITALIZATION_AMT`,
                        `FEE_01_AMT`,
                        `MDATE`,
                        `IS_REMOVE`,
                        `EXT_NO_DAYS`,
                        `ADVANCE_PAID_AMT`,
                        `FEE_02_AMT`,
                        `FEE_03_AMT`,
                        `FEE_04_AMT`,
                        `FEE_05_AMT`,
                        `FEE_01_PAID`,
                        `FEE_02_PAID`,
                        `FEE_03_PAID`,
                        `FEE_04_PAID`,
                        `FEE_05_PAID`,
                        `FEE_06_AMT`,
                        `FEE_07_AMT`,
                        `FEE_06_PAID`,
                        `FEE_07_PAID`
                    )
                    SELECT 
                        `EFFTDATE`,
                        ' . singleQuote($new_loan_code) . ',
                        `LOAN_INTEREST`,
                        `LOAN_PERIOD`,
                        `CRED_PAY_METHOD`,
                        `NO_PAYMENTS`,
                        `PRINCIPAL_BAL`,
                        `SEQNUM`,
                        `PAYMENT_AMT`,
                        `PRINCIPAL_PAY`,
                        `INTEREST_PAY`,
                        `PAYMENT_DATE`,
                        `RESERVE_PCT`,
                        `INSTALLMENT_NO`,
                        `PERIOD_START_DATE`,
                        `PERIOD_END_DATE`,
                        `PAID_AMT`,
                        `LOAN_AMT`,
                        `RESERVE_PAY`,
                        `INDEX_RATE`,
                        `ADJ_INDEX`,
                        `INTEREST_TYPE`,
                        `ADJ_POINTS_OVERINDEX`,
                        `RESERVE_INDEX`,
                        `INTEREST_CALC`,
                        `RESERVE_AMT`,
                        `NO_DAYS`,
                        `DAILY_INTEREST`,
                        `DAILY_RESERVE`,
                        `INTEREST_AMT`,
                        `RESERVE_PERIOD`,
                        `INTEREST_PERIOD`,
                        `EQ_GRACE_PERIODS`,
                         ' . singleQuote($filo['DEBTOR_CODE']) . ',
                        `BALLOON_PAY_AMT`,
                        `FEES_AMT`,
                        `DUE_PAY_DATE`,
                        `PPAL_PAID_AMT`,
                        `INTPAID_AMT`,
                        `MODIFIEDBY`,
                        `RESTRUCTURE`,
                        `CAPITALIZATION_AMT`,
                        `FEE_01_AMT`,
                        `MDATE`,
                        `IS_REMOVE`,
                        `EXT_NO_DAYS`,
                        `ADVANCE_PAID_AMT`,
                        `FEE_02_AMT`,
                        `FEE_03_AMT`,
                        `FEE_04_AMT`,
                        `FEE_05_AMT`,
                        `FEE_01_PAID`,
                        `FEE_02_PAID`,
                        `FEE_03_PAID`,
                        `FEE_04_PAID`,
                        `FEE_05_PAID`,
                        `FEE_06_AMT`,
                        `FEE_07_AMT`,
                        `FEE_06_PAID`,
                        `FEE_07_PAID`
                    FROM CRED_PAYMNT_SCHEDULES WHERE LOAN_CODE = ' . singleQuote($loan_code) . ' AND EFFTDATE = ' . singleQuote($loan_code_clxefftdate);
                ClxCommon::$db->executeQuery($sql);
                ClxCommon::$db->updateRecord('CRED_CREDITS',array('PRINCIPAL_BAL'=>0),'IDCODE = '.singleQuote($loan_code).' AND LOAN_STATUS = '.singleQuote('ASU'));
                break;
            default:
                # code...
                break;
        }
    }
}
?>