<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-12-12 14:05:13 -0500 (Tue, 12 Dec 2017) $
 * @version        $Rev: 9662 $
 *
 * CHANGE LOG
 */
class Glac {

    function __construct($procParameters = array()) {
        multiTableName($this, array('GLAC', 'GLCP'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

// end method
    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        // Validar que no sea la misma cuenta
        $ac= UserRequest::$request['ac'];
        if ($ac == 'DELETE'){
            $idlist = toString(getIdlist());
            $formrec = ClxCommon::$db->getRecord ($this->glacname, 'ID = '.singleQuote($idlist));
            $record['GLAC_IDCODE'] = $formrec['IDCODE'];
            $record['GLAC_ACPARENT'] = $formrec['ACPARENT'];
            $record['GLAC_GLGROUP_CODE'] = $formrec['GLGROUP_CODE'];
        }
        if ($record ['GLAC_IDCODE'] == $record ['GLAC_ACPARENT']) {
            $msg ['GLAC_ACPARENT'] = smsg('MSG-211');
        }
        if ($record ['GLAC_ACPARENT'] != '') {
            // validar que padre este en mismo grupo contable
            if (ClxCommon::$db->oneExistsRecords($this->glacname, 'IDCODE = ' . singleQuote($record ['GLAC_ACPARENT']) . ' AND GLGROUP_CODE = ' . singleQuote($record ['GLAC_GLGROUP_CODE'])) == CLX_NUM_ZERO) {
                $msg ['GLAC_ACPARENT'] = smsg('MSG-212');
            }
            // Validar que no tenga loop infinito
            $donegl = array();
            $parent = $record ['GLAC_ACPARENT'];
            for ($i = CLX_INIT_ZERO; $i <= CLX_NUM_THOUSAND; $i ++) {
                $parent = ClxCommon::$db->getField($this->glacname, 'ACPARENT', 'IDCODE = ' . singleQuote($parent) . '  AND GLGROUP_CODE = ' . singleQuote($record ['GLAC_GLGROUP_CODE']));
                if ($parent != '' && $parent == $record ['GLAC_IDCODE']) {
                    $msg ['GLAC_ACPARENT'] = smsg('MSG-213', $parent);
                    break;
                }
                if (empty($parent))
                    break;
                if (!empty($donegl [$parent])) {
                    $msg ['GLAC_ACPARENT'] = smsg('MSG-213', $parent);
                    break;
                }
                $donegl [$parent] = CLX_NUM_ONE;
            }
            //Validar que cuenta padre no sea de movimiento.
            // validar que padre este en mismo grupo contable
            if (ClxCommon::$db->oneExistsRecords($this->glacname, 'IDCODE = ' . singleQuote($record ['GLAC_ACPARENT']) . ' AND ALLOW_ACTIVITY = 1 AND GLGROUP_CODE = ' . singleQuote($record ['GLAC_GLGROUP_CODE'])) > CLX_NUM_ZERO) {
                $msg ['GLAC_ACPARENT'] = smsg('MSG-428');
            }
        }
    }

// end function
    /**
     * Returns true if gl has accounts that donot allows movemen for company.
     *
     * @param string $comp_code
     * @param string $glaccountcode
     * @return boolean
     */
    function invalid_gl_glroup($comp_code, $glaccountcode) {
        $sql = 'SELECT COUNT(GLAC.ID) QTY FROM ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = ' . singleQuote($glaccountcode) . '  AND GLCP.COMP_CODE = ' . singleQuote($comp_code);
        return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Return true if glgroup donot macht account glgroup
     * @param string $glgroup
     * @param string $glaccountcode
     * @return bool
     */
    function invalid_glgroup_by_group($glgroup, $glaccountcode) {
        $sql = 'SELECT COUNT(GLAC.ID) QTY FROM ' . $this->glacname . ' GLAC WHERE GLAC.GLGROUP_CODE = ' . singleQuote($glgroup) . '  AND GLAC.IDCODE = ' . singleQuote($glaccountcode);
        return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Build tree object
     * @param string $glgroup_code
     */
    public function paintTree($glgroup_code = '') {
        require_once 'classes/JTree.php';
        $sql = 'SELECT DISTINCT GLGROUP_CODE FROM GL_CODES_TBL';
        if ($glgroup_code <> '') {
            $sql .=' WHERE GLGROUP_CODE = ' . singleQuote($glgroup_code);
        }
        $grs = ClxCommon::$db->executeQuery($sql);$kk='(xx)';
        while (($gr = ClxCommon::$db->getNextRecord($grs))) {
            $categories = array();
            $sql = 'SELECT IDCODE, IDNAME, IFNULL(ACPARENT,0) ACPARENT FROM GL_CODES_TBL WHERE GLGROUP_CODE = ' . singleQuote($gr['GLGROUP_CODE']) . '  ORDER BY IDCODE ASC';
			$rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $categories[] = array('IDCODE' => $r['IDCODE'], 'IDNAME' => $r['IDCODE'] . ' - ' . $r['IDNAME'], 'ACPARENT' => $r['ACPARENT']);
            }
            //create a new tree object 
            $jt = new JTree();
            //iterate building the tree
            foreach ($categories as $category) {
                $uid = $jt->createNode($category['IDNAME'], $category['IDCODE']);
                $parentId = null;
                if (!empty($category['ACPARENT'])) {
                    $parentId = $category['ACPARENT'];
                }
                $jt->addChild($parentId, $uid);
            }
            $it = new JTreeRecursiveIterator($jt, new JTreeIterator($jt->getTree()), false);
		    echo '<h4>' . $gr['GLGROUP_CODE'] . '</h4>'; 
			// No borrar nunca el siguiente Foreach, sus variables no estan en uso(error kiuwan), pero logra ejecutar metodos del iterador
			// en clase Jtree, que tiene unos echo en metodo callHasChildren. (i>>>logical code<<<)
			foreach($it as $k => $v) {
				
			}
            unset($it); 
            //iterate to create the ul list  
         
        }
       
    }

    /**
     * Builds chart of account tree
     * @return string
     */
    public function paintTreeButton() {
        $contents = '<h1 class=CLX_CLASS_TITLE>' . dict('0548AC6EDE4D675E280D258A45B2F11C') . '<h1>';
        $a = new Glac();
        ob_start();
        $a->paintTree();
        $contents .= ob_get_clean();
        return $contents;
    }

}

// end class
