<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: jclerma $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2018-01-26 15:45:08 -0500 (Fri, 26 Jan 2018) $
 * @version		$Rev: 9707 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Inat {

    var $display = false;
    var $debug_temp_tbl = false;

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        // Initial tables
        multiTableName($this, array('INAT', 'INFA', 'JEHD', 'GLAC', 'GLAG', 'COMP', 'INFU', 'FIAS', 'FIAC', 'JELN', 'TTPA', 'FIBK', 'GLCP', 'FIGN', 'FTMP', 'FIAT', 'FITB', 'FITS', 'JEIT', 'OPBV', 'LEDG', 'LEBA', 'INTT', 'INFU', 'FIPA', 'INPR', 'INTL', 'GLCP', 'JELN', 'FICO', 'COMP', 'TTPA', 'FIBK', 'PTMP', 'JCBV', 'JTMP', 'PRAT', 'IAT1', 'IAT2', 'IAT3', 'IAT4', 'CURR', 'INDT', 'INDV', 'PROD', 'IFUV'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice inat form
     * Executed on init event
     */
    function inat_init_form(&$record) {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!empty($record ['INAT_PORTFOLIO_CODE'])) {
            $comp_code = ClxCommon::$db->getField($this->infuname, 'COMP_CODE', 'IDCODE = ' . singleQuote($record ['INAT_PORTFOLIO_CODE']));
        } else {
            $comp_code = '';
        }
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($comp_code);
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
            $record ['INAT_CLX_AUTH_STATUS'] = 'PEND';
            $record ['INAT_IDCODE'] = 'AUTO';
            $record ['INAT_REVACTI_CODE'] = null;
            $record ['INAT_REVERSED'] = '0';
            $record ['INAT_EFFTDATE'] = $comprec ['OPERATION_DATE'];
            $record ['INAT_REAL_DATE'] = $comprec ['OPERATION_DATE'];
            $record ['INAT_ISSUE_DATE'] = $comprec ['OPERATION_DATE'];
            $record ['INAT_ACQUISITION_DATE'] = $comprec ['OPERATION_DATE'];
            $record ['INAT_INV_PERIOD'] = CLX_INIT_ZERO;
            $record ['INAT_CASH_AMT'] = CLX_INIT_ZERO;
            $record ['INAT_ACCRUED_INT_AMT'] = CLX_INIT_ZERO;
            $record ['INAT_INVEST_AMT'] = CLX_INIT_ZERO;
            $record ['INAT_FACE_VALUE'] = CLX_INIT_ZERO;
            $record ['INAT_TAX_AMT'] = CLX_INIT_ZERO;
            $record ['INAT_FEES_AMT'] = CLX_INIT_ZERO;
            $record ['INAT_SHARES'] = CLX_INIT_ZERO;
            $record ['INAT_UNIT_PRICE'] = CLX_INIT_ZERO;
            $record ['INAT_UNIT_PRICE_PCT'] = CLX_INIT_ZERO;
        }
        unset($comp);
        $record ['INAT_COMP_CODE'] = $comprec ['IDCODE'];
        if ($record ['INAT_FACE_VALUE'] != CLX_NUM_ZERO) {
            $price = round(bcmul(bcdiv($record ['INAT_INVEST_AMT'], $record ['INAT_FACE_VALUE']), CLX_NUM_HUNDRED), CLX_NUM_FIVE);
        } else {
            $price = CLX_INIT_ZERO;
        }
        if ($record ['INAT_INVEST_ACTIVITY'] === 'BY' || $record ['INAT_INVEST_ACTIVITY'] === 'BYT') {
            $record ['INAT_PURCHASE_PRICE'] = $price;
        } elseif ($record ['INAT_INVEST_ACTIVITY'] === 'SL' || $record ['INAT_INVEST_ACTIVITY'] === 'CA' || $record ['INAT_INVEST_ACTIVITY'] === 'RD' || $record ['INAT_INVEST_ACTIVITY'] === 'VE') {
            $record ['INAT_SELL_PRICE'] = $price;
        }
        // loading product information if exists
        $this->load_inpr_fields_to_inat($record);
    }

    /**
     * Loads INPR Record
     *
     * @param array $record
     */
    function load_inpr_fields_to_inat(&$record) {
        if (!empty($record['INAT_INVESTMENT_CODE'])) {
            $inprrec = $this->get_inpr_record($record['INAT_INVESTMENT_CODE']);
            if (!empty($inprrec)) {
                $prodrec = ClxCommon::$db->getFields($this->prodname, 'IDCODE, IDNAME', 'IDCODE = ' . singleQuote($inprrec['PRODUCT_CODE']));
                if (!empty($prodrec)) {
                    $record['INPR_PRODUCT_CODE_prim'] = $prodrec['IDCODE'];
                    $record['INPR_PRODUCT_CODE_secd'] = $prodrec['IDNAME'];
                }
                foreach ($inprrec as $key => $val) {
                    $record['INPR_' . $key] = $val;
                }
            } else {
                $record['INPR_MATURITY_DATE'] = '';
                $record['INPR_CREATEDBY'] = '';
                $record['INPR_MODIFIEDBY'] = '';
            }
            $record['INPR_COMP_CODE'] = $record['INAT_COMP_CODE'];
        } else {
            $record['INPR_MATURITY_DATE'] = '';
            $record['INPR_CREATEDBY'] = '';
            $record['INPR_MODIFIEDBY'] = '';
        }
        if (isset($record ['INAT_MATURITY_DATE'])) {
            $record ['INPR_INV_PERIOD'] = day_diff($record ['INPR_MATURITY_DATE'], $record ['INAT_ACQUISITION_DATE']);
        } else {
            $record ['INPR_INV_PERIOD'] = CLX_INIT_ZERO;
        }
        //loading infa values
        $infarec = ClxCommon::$db->getFields($this->infaname, 'BOOK_VALUE_AMT INAT_BOOK_VALUE_AMT, FACE_VALUE INAT_CUR_FACE_VALUE, INVEST_AMT INAT_CUR_INVEST_AMT, SHARES INAT_CUR_SHARES, AMORTIZED_AMT INAT_CUR_AMORTIZED_AMT, VALORIZED_AMT INAT_CUR_VALORIZED_AMT, (ACCRUED_INT_AMT-PAID_INT_AMT) INAT_CUR_INTEREST', 'POSITION_NUMBER = ' . singleQuote($record['INAT_POSITION_NUMBER']));
        if (!empty($infarec)) {
            $record = array_merge($record, $infarec);
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function inat_validate_form(&$record, &$msg) {

        // validar situacion de transaccion pendiente o no
        if (UserRequest::$request['ac'] == 'DELETE') {
            $inat = ClxCommon::$db->getRecord($this->inatname, 'ID = ' . singleQuote($record ['idlist']));
            if ($inat['CLX_AUTH_STATUS'] !== 'PEND') {
                $msg [''] = smsg('MSG-105', $inat ['IDCODE']);
                //addMessage($msg);
                return false;
            }
        }    
        if (UserRequest::$request['ac'] === 'DELETE') {
            return true;
        }


        if (!empty($record['INAT_REVACTI_CODE']) && $record['INAT_REVACTI_CODE'] <> 'null' && UserRequest::$request['ac'] <> 'REQAUTHORIZATION' && UserRequest::$request['ac'] <> 'DELETE') {
            $msg['INAT_INVESTMENT_CODE'] = smsg('MSG-339');
            return false;
        }
        if (!class_exists('Infu'))
            includeCodeLib('INFU');

        $infurec = ClxCommon::$db->getRecord($this->infuname, 'IDCODE = ' . singleQuote($record ['INAT_PORTFOLIO_CODE']));
        $inprrec = $this->get_inpr_record($record['INAT_INVESTMENT_CODE'], $record['INAT_EFFTDATE']);

        if (!array_key_exists('INPR_PRODUCT_CODE', $record) && !empty($inprrec)) {
            $record['INPR_PRODUCT_CODE'] = $inprrec['PRODUCT_CODE'];
        }

        if (empty($record['INPR_PRODUCT_CODE']) && !empty(UserRequest::$request['INPR_PRODUCT_CODE'])) {
            $record['INPR_PRODUCT_CODE'] = UserRequest::$request['INPR_PRODUCT_CODE'];
        }

        if (!array_key_exists('INPR_ISSUE_DATE', $record) && array_key_exists('ISSUE_DATE', $inprrec)) {
            $record['INPR_ISSUE_DATE'] = $inprrec['ISSUE_DATE'];
        }
        if (!array_key_exists('INPR_MATURITY_DATE', $record) && array_key_exists('MATURITY_DATE', $inprrec)) {
            $record['INPR_MATURITY_DATE'] = $inprrec['MATURITY_DATE'];
        }

        // Validar que la fecha de la operacion sea menor o igual a la contabilidad +1 dia
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($infurec ['COMP_CODE']);
        unset($comp);

        $operation_date = $comprec ['OPERATION_DATE'];
        $bckdtdop = $comprec ['BCKDATE_ALLWCE'];
        if (!array_key_exists('INAT_COMP_CODE', $record)) {
            $record ['INAT_COMP_CODE'] = $comprec ['IDCODE'];
        }
        // adding product information
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' || UserRequest::$request['ac'] === 'IMPORT') {
            $this->load_inpr_fields_to_inat($record);
        }
        $reversal = (!empty($record ['INAT_REVACTI_CODE']));
        // reversal can not be modified
        if ($reversal && UserRequest::$request['ac'] !== 'REQAUTHORIZATION') {
            $msg ['INAT_IDCODE'] = smsg('MSG-106', $record ['INAT_IDCODE']);
        }
        // Validar que para actividades en portafolio dirigidos
        // (discretionary_port = 0) se incluya el contrato
        if ($infurec ['DISCRETIONARY_PORT'] == CLX_NUM_ZERO && empty($record ['INAT_CONTRACT_CODE'])) {
            $msg ['INAT_CONTRACT_CODE'] = smsg('MSG-104', $record ['INAT_IDCODE']);
        }
        if (ClxCommon::$db->oneExistsRecords($this->infuname, 'IDCODE = ' . singleQuote($record ['INAT_PORTFOLIO_CODE']) . ' AND COMP_CODE = ' . singleQuote($record ['INAT_COMP_CODE'])) == CLX_NUM_ZERO) {
            $msg ['INAT_COMP_CODE'] = smsg('MSG-332');
        }
        if (!empty($record ['INAT_CONTRACT_CODE'])) {
            if (ClxCommon::$db->oneExistsRecords($this->ficoname, 'IDCODE = ' . singleQuote($record ['INAT_CONTRACT_CODE']) . ' AND COMP_CODE = ' . singleQuote($record ['INAT_COMP_CODE'])) == CLX_NUM_ZERO) {
                $msg ['INAT_CONTRACT_CODE'] = smsg('MSG-331');
            }
        }
        // Validar que participante (de existir) pertenesca al contrato
        if (!empty($record ['INAT_PARTICIPANT_ID'])) {
            if (ClxCommon::$db->oneExistsRecords($this->fipaname, 'CONTRACT_CODE = ' . singleQuote($record ['INAT_CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record ['INAT_PARTICIPANT_ID']) . ' AND STATUS = ' . singleQuote('A') . '') == CLX_NUM_ZERO) {
                $msg ['INAT_PARTICIPANT_ID'] = smsg('MSG-108');
            }
        }
        $inttrec = $this->inat_get_intt($record ['INAT_INVEST_ACTIVITY']);
        if (empty($inttrec ['AFFECT_ASSET']) && empty($inttrec ['AFFECT_ORDER']) && empty($inttrec ['AFFECT_DIVIDEND']) && ($record ['INAT_INVEST_AMT'] != CLX_NUM_ZERO || $record ['INAT_FACE_VALUE'] != CLX_NUM_ZERO || $record ['INAT_SHARES'] != CLX_NUM_ZERO || $record ['INAT_UNIT_PRICE'] != CLX_NUM_ZERO)) {
            if ($inttrec['IDCODE'] <> 'DIVE') {
                $msg ['INAT_INVEST_AMT'] = smsg('MSG-109', $record ['INAT_IDCODE']);
                $msg ['INAT_FACE_VALUE'] = $msg ['INAT_INVEST_AMT'];
                $msg ['INAT_UNIT_PRICE'] = $msg ['INAT_INVEST_AMT'];
                $msg ['INAT_SHARES'] = $msg ['INAT_INVEST_AMT'];
            }
        }
        //Incluir solo si es compra
        $is_purchase = ($inttrec ['IDCODE'] === 'BY' || $inttrec ['IDCODE'] === 'BYT' || $inttrec ['IDCODE'] === 'APINV') ? true : false;
        // Validar saldos de devengo en reduccion
        if (empty($inttrec ['AFFECT_ASSET']) && !empty($inttrec ['AFFECT_RECEIVABLES']) && $record ['INAT_ACCRUED_INT_AMT'] == CLX_NUM_ZERO) {
            $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-110', $record ['INAT_IDCODE']);
        }
        if (empty($inttrec ['APPLY_GAIN']) && empty($inttrec ['APPLY_LOSS']) && $record ['INAT_GAIN_AMT'] != CLX_NUM_ZERO) {
            $msg ['INAT_GAIN_AMT'] = smsg('MSG-111', $record ['INAT_IDCODE']);
        }
        if (empty($inttrec ['APPLY_TAX']) && $record ['INAT_TAX_AMT'] != CLX_NUM_ZERO) {
            $msg ['INAT_TAX_AMT'] = smsg('MSG-112', $record ['INAT_IDCODE']);
        }
        if (empty($inttrec ['APPLY_FEES']) && $record ['INAT_FEES_AMT'] != CLX_NUM_ZERO) {
            $msg ['INAT_FEES_AMT'] = smsg('MSG-113', $record ['INAT_IDCODE']);
        }
        if (!array_key_exists('INPR_PRODUCT_CODE', $record)) {
            if (!empty($record ['INAT_SPRODUCT_CODE'])) {
                $record ['INPR_PRODUCT_CODE'] = $record ['INAT_SPRODUCT_CODE'];
            } elseif (!empty($record ['INAT_INVESTMENT_CODE'])) {
                $record ['INPR_PRODUCT_CODE'] = $inprrec['PRODUCT_CODE'];
            } else {
                $record ['INPR_PRODUCT_CODE'] = $record ['INAT_PRODUCT_CODE'];
            }
        }
        // Validando cuentas contables requeridas para actividad
        $sql = 'SELECT DISTINCT PRAT.PRO_GL_CODE, PRAT.INC_GL_CODE, PRAT.GAIN_GL_CODE, PRAT.LOSS_GL_CODE, PRAT.AR_GL_CODE, PRAT.TAX_GL_CODE, PRAT.FEE_GL_CODE, PRAT.TMAS_GL_CODE, PRAT.DISCOUNT_GL_CODE, PRAT.PYD2D_GL_CODE, PRAT.PREMIUM_GL_CODE, PRAT.PYD2P_GL_CODE, GLAC.GL_TYPE, PROD.PRODUCT_CLASS FROM ' . $this->prodname . ' PROD, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE PROD.IDCODE = PRAT.PRODUCT_CODE AND PRAT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRO_GL_CODE = GLAC.IDCODE AND GLCP.COMP_CODE = ' . singleQuote($record ['INAT_COMP_CODE']) . ' AND PROD.IDCODE = ' . singleQuote($record ['INPR_PRODUCT_CODE']);
        $inin_gl = ClxCommon::$db->getOneRecord($sql);
        if ($record ['INAT_GAIN_AMT'] != CLX_NUM_ZERO && (empty($inin_gl ['GAIN_GL_CODE']) || empty($inin_gl ['LOSS_GL_CODE']))) {
            $msg ['INAT_GAIN_AMT'] = smsg('MSG-103', $record ['INAT_IDCODE']);
        }
        if ($record ['INAT_INVEST_AMT'] != CLX_NUM_ZERO && empty($inin_gl ['PRO_GL_CODE'])) {
            $msg ['INAT_INVEST_AMT'] = smsg('MSG-114', $record ['INAT_IDCODE']);
        }
        if ($record ['INAT_ACCRUED_INT_AMT'] != CLX_NUM_ZERO && empty($inin_gl ['AR_GL_CODE'])) {
            $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-115', $record ['INAT_IDCODE']);
        }
        if ($record ['INAT_TAX_AMT'] != CLX_NUM_ZERO && empty($inin_gl ['TAX_GL_CODE'])) {
            $msg ['INAT_TAX_AMT'] = smsg('MSG-116', $record ['INAT_IDCODE']);
        }
        if ($record ['INAT_FEES_AMT'] != CLX_NUM_ZERO && empty($inin_gl ['FEE_GL_CODE'])) {
            $msg ['INAT_FEES_AMT'] = smsg('MSG-117', $record ['INAT_IDCODE']);
        }
        $gl_type_sign = ($inin_gl ['GL_TYPE'] === 'LI') ? - CLX_NUM_ONE : CLX_NUM_ONE;
        if (array_key_exists('INPR_IS_FIXINCOME', $record)) {
            $stock = ($record ['INPR_IS_FIXINCOME'] == CLX_NUM_ZERO) ? true : false;
        } elseif (array_key_exists('INAT_IS_FIXINCOME', $record)) {
            $stock = ($record ['INPR_IS_FIXINCOME'] == CLX_NUM_ZERO) ? true : false;
        } else {

        }
        //validacion de cuentas contable de prima o descuento.
        if (($inttrec ['IDCODE'] === 'BYT' || $inttrec ['IDCODE'] === 'BY') && !empty($record['INAT_UNIT_PRICE_PCT']) && $record['INAT_UNIT_PRICE_PCT'] <> CLX_NUM_HUNDRED && ($inin_gl['DISCOUNT_GL_CODE'] === '' || $inin_gl['PYD2D_GL_CODE'] === '' || $inin_gl['PREMIUM_GL_CODE'] === '' || $inin_gl['PYD2P_GL_CODE'] === '')) {
            if (empty($stock)) {
                $msg['INAT_UNIT_PRICE_PCT'] = smsg('MSG-384');
            }
        }
        //Validating parameters for t2/t3 activities
        if ($inttrec ['IDCODE'] === 'BYT' && empty($inin_gl['TMAS_GL_CODE'])) {
            $msg['INAT_IDCODE'] = smsg('MSG-383', $record ['INAT_IDCODE']);
        }

        //Validaciones de producto
        if (!class_exists('inpr'))
            includeCodeLib('INPR');
        $inpr = new Inpr();
        $inpr->inpr_validate_form($record, $msg);
        //Fin de validaciones de producto
        // Validar montos de inversiones en salidas - considerar Posibles campos
        $infarec = ClxCommon::$db->getRecord($this->infaname, 'POSITION_NUMBER = ' . singleQuote($record ['INAT_POSITION_NUMBER']) . ' AND PORTFOLIO_CODE =' . singleQuote($record['INAT_PORTFOLIO_CODE']));
        if (empty($infarec)) {
            $infarec = array('POSITION_NUMBER' => '', 'INVESTMENT_CODE' => '', 'PORTFOLIO_CODE' => '', 'INVEST_AMT' => CLX_NUM_ZERO, 'FACE_VALUE' => CLX_NUM_ZERO, 'SHARES' => CLX_NUM_ZERO, 'AMORTIZED_AMT' => CLX_NUM_ZERO, 'PAID_INT_AMT' => CLX_NUM_ZERO, 'ACCRUED_INT_AMT' => CLX_NUM_ZERO, 'GAIN_AMT' => CLX_NUM_ZERO, 'TAX_AMT' => CLX_NUM_ZERO, 'FEES_AMT' => CLX_NUM_ZERO);
        }
        // validating product
        if (empty($record ['INPR_PRODUCT_CODE'])) {
            $msg ['INPR_PRODUCT_CODE'] = smsg('MSG-118', $record ['INAT_IDCODE']);
        }
        // Mnto de dividendo no puede ser mayor
        if ($record ['INAT_DIVIDEND_AMT'] != CLX_NUM_ZERO && $inttrec ['AFFECT_DIVIDEND'] === 'CR' && !$reversal && $infarec ['DIVIDEND_AMT'] < $record ['INAT_DIVIDEND_AMT']) {
            $msg ['INAT_DIVIDEND_AMT'] = smsg('MSG-280', $record ['INAT_IDCODE'], round($infarec ['DIVIDEND_AMT'], CLX_NUM_TWO));
        }
        // Monto de inversiones no puede ser mayor
        if ($record ['INAT_INVEST_AMT'] != CLX_NUM_ZERO && ($inttrec ['AFFECT_ASSET'] === 'CR' && !$reversal) && round(($record ['INAT_INVEST_AMT'] - $record ['INAT_GAIN_AMT']), CLX_NUM_TWO) > round($infarec ['INVEST_AMT'], CLX_NUM_TWO)) {
            $msg ['INAT_INVEST_AMT'] = smsg('MSG-119', $record ['INAT_IDCODE'], $record ['INAT_INVEST_AMT'], round($infarec ['INVEST_AMT'], CLX_NUM_TWO));
        }
        // validando monto de amortizacion
        if ($inttrec ['AMORTIZATION'] == CLX_NUM_ONE && abs($infarec ['INVEST_AMT'] - $infarec ['FACE_VALUE']) < $record ['INAT_INVEST_AMT']) {
            $msg ['INAT_INVEST_AMT'] = smsg('MSG-120', $record ['INAT_IDCODE'], abs($infarec ['INVEST_AMT'] - $infarec ['FACE_VALUE']));
        }
        if ($inttrec ['AMORTIZATION'] == CLX_NUM_ONE && ($infarec ['INVEST_AMT'] - $infarec ['FACE_VALUE']) > CLX_NUM_ZERO && ($inttrec ['AFFECT_ASSET'] === 'DR' || ($inttrec ['AFFECT_ASSET'] === 'DR' && $reversal))) {
            $msg ['INAT_INVEST_ACTIVITY'] = smsg('MSG-121', $record ['INAT_IDCODE']);
        }
        if ($inttrec ['AMORTIZATION'] == CLX_NUM_ONE && ($infarec ['INVEST_AMT'] - $infarec ['FACE_VALUE']) < CLX_NUM_ZERO && ($inttrec ['AFFECT_ASSET'] === 'CR' || ($inttrec ['AFFECT_ASSET'] === 'CR' && $reversal))) {
            $msg ['INAT_INVEST_ACTIVITY'] = smsg('MSG-122', $record ['INAT_IDCODE']);
        }
        // validando tipo de amortizacion
        if ($record ['INAT_FACE_VALUE'] != CLX_NUM_ZERO && ($inttrec ['AFFECT_ASSET'] === 'CR' && !$reversal) && $record ['INAT_FACE_VALUE'] * $gl_type_sign > $infarec ['FACE_VALUE']) {
            $msg ['INAT_FACE_VALUE'] = smsg('MSG-123', $record ['INAT_FACE_VALUE'], $infarec ['FACE_VALUE']);
        }
        // Validando ganancia renta fija
        //Ganancia = Cantidad * (Precio de venta - Precio de compra)-amortizado
        //Precio de compra = Monto / unidades compra = Inversion / nominal
        //Precio de venta = Monto / unidades venta = Inversion / nominal
        if ($inttrec ['IDCODE'] <> 'RD') {
            if ($gl_type_sign > CLX_NUM_ZERO && !$stock && $record ['INAT_FACE_VALUE'] != CLX_NUM_ZERO && $infarec ['FACE_VALUE'] != CLX_NUM_ZERO && $inttrec ['AFFECT_ASSET'] === 'CR' && !$reversal) {
                $ratio = $record ['INAT_FACE_VALUE'] / $infarec ['FACE_VALUE'];
                //$gain = rounder(($record ['INAT_INVEST_AMT'] - (($infarec ['INVEST_AMT'] - $record['INAT_AMORTIZED_AMT']) * $ratio)), CLX_NUM_TWO);
                 $gain = rounder(($record ['INAT_INVEST_AMT'] - rounder(($infarec ['INVEST_AMT'] * $ratio),2)), 2);
                if ($record ['INAT_GAIN_AMT'] != $gain) {
                    $msg ['INAT_GAIN_AMT'] = smsg('MSG-124', $record ['INAT_IDCODE'], $gain);
                }
            }
        }
        // Validando ganancia acciones
        if ($stock === true && ($inttrec ['AFFECT_ASSET'] === 'CR' || ($inttrec ['AFFECT_ASSET'] === 'DR' && $reversal))) {
            // gain = S.shares *(S.Price x P.Price)) =>
            // gain = S.shares * (S.Price - (P.Invest Amt/P.shares))
            if ($infarec ['SHARES'] <> CLX_NUM_ZERO) {
                $gain = rounder(($record ['INAT_SHARES'] * ($record ['INAT_UNIT_PRICE'] - ($infarec ['INVEST_AMT'] / $infarec ['SHARES']))), CLX_NUM_TWO);
            } else {
                $gain = CLX_INIT_ZERO;
            }
            if ($record ['INAT_GAIN_AMT'] != $gain && !$reversal) {
                $msg ['INAT_GAIN_AMT'] = smsg('MSG-124', $record ['INAT_IDCODE'], $gain);
            }
        }

        // Numero de acciones
        if ($record ['INAT_SHARES'] != CLX_NUM_ZERO && ($inttrec ['AFFECT_ASSET'] === 'CR' || ($inttrec ['AFFECT_ASSET'] === 'DR' && $reversal)) && ($record ['INAT_SHARES'] * $gl_type_sign > $infarec ['SHARES'] && !$reversal === true)) {
            $msg ['INAT_SHARES'] = smsg('MSG-125', $record ['INAT_IDCODE'], $record ['INAT_SHARES'], $infarec ['SHARES']);
        }
        // Montos en intereses
        if ($record ['INAT_ACCRUED_INT_AMT'] != CLX_NUM_ZERO && ($inttrec ['AFFECT_RECEIVABLES'] === 'CR' || ($inttrec ['AFFECT_RECEIVABLES'] === 'DR' && $reversal)) && round($record ['INAT_ACCRUED_INT_AMT'] * $gl_type_sign, CLX_NUM_TWO) > round($infarec ['ACCRUED_INT_AMT'], CLX_NUM_TWO)) {
            $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-126', $record ['INAT_IDCODE'], $record ['INAT_ACCRUED_INT_AMT'], $infarec ['ACCRUED_INT_AMT']);
        }
        // Validando fechas
        // Validar que fecha de maduracion del instrumento sea menor a la fecha
        // efectiva de la actividad
        // Validar que la fecha de emision sea menor o igual a la fecha efectiva
        // del producto
        if (!array_key_exists('INAT_MATURITY_DATE', $record)) {
            $record ['INAT_MATURITY_DATE'] = '';
        }
        if (!array_key_exists('INAT_ISSUE_DATE', $record)) {
            $record ['INAT_ISSUE_DATE'] = '';
        }
        if (!empty($record ['INPR_MATURITY_DATE']))
            $record ['INAT_MATURITY_DATE'] = $record ['INPR_MATURITY_DATE'];
        if (!empty($record ['INPR_ISSUE_DATE']))
            $record ['INAT_ISSUE_DATE'] = $record ['INPR_ISSUE_DATE'];
        //Verficar
        $prodrec = ClxCommon::$db->getFields($this->prodname, 'HAS_ISSUE_DATE, HAS_MATURITY_DATE, 0 HAS_FRST_COUPON_DT', 'IDCODE = ' . singleQuote($record ['INPR_PRODUCT_CODE']));

        //Validar que el codigo de la inversion sea igual a la anteriormente registrada en caso de existir
        if(!empty($infarec['INVESTMENT_CODE']) && !empty($record['INAT_INVESTMENT_CODE']) &&  $infarec['INVESTMENT_CODE']<>$record['INAT_INVESTMENT_CODE']){
            $msg['INAT_INVESTMENT_CODE'] = smsg('MSG-20170411155106', $infarec['INVESTMENT_CODE'], $record['INAT_POSITION_NUMBER']);
        }

        //Validar que un numero de posicion sea unico para un portafolio
        $sql = 'SELECT COUNT(INAT.ID) QTY FROM INVE_ACTIVITIES INAT WHERE INAT.POSITION_NUMBER = ' . singleQuote($record ['INAT_POSITION_NUMBER']) . ' AND INAT.PORTFOLIO_CODE <> ' . singleQuote($record ['INAT_PORTFOLIO_CODE']) . ' AND INAT.REVERSED = 0';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $msg['INAT_POSITION_NUMBER'] = 'Numero de posicion ya existe en otro portafolio';
        }
        if ($is_purchase && $prodrec['HAS_ISSUE_DATE'] == CLX_NUM_ONE && $record ['INAT_ISSUE_DATE'] === '') {
            $msg ['INAT_ISSUE_DATE'] = smsg('MSG-164', $record ['INAT_IDCODE'], $record ['INAT_ISSUE_DATE']);
        }
        if ($is_purchase && $prodrec['HAS_MATURITY_DATE'] == CLX_NUM_ONE && $record ['INAT_MATURITY_DATE'] === '') {
            $msg ['INAT_MATURITY_DATE'] = smsg('MSG-165', $record ['INAT_IDCODE'], $record ['INAT_MATURITY_DATE']);
        }
        //HAS_FRST_COUPON_DT
        if ($prodrec['HAS_FRST_COUPON_DT'] == CLX_NUM_ONE && $record ['INPR_FIRST_PYMNT_DATE'] === '') {
            $msg ['INPR_FIRST_PYMNT_DATE'] = smsg('MSG-430', $record ['INAT_IDCODE']);
        }
        if ($is_purchase && $record ['INAT_MATURITY_DATE'] <> '' && ($record ['INAT_EFFTDATE'] > $record ['INAT_MATURITY_DATE'])) {
            $msg ['INAT_EFFTDATE'] = smsg('MSG-128', $record ['INAT_IDCODE'], $record ['INAT_INVESTMENT_CODE'] . ' ' . $record ['INAT_EFFTDATE'] . '>' . $record ['INAT_MATURITY_DATE']);
        }
        if ($is_purchase && $record ['INAT_ISSUE_DATE'] <> '' && ($record ['INAT_EFFTDATE'] < $record ['INAT_ISSUE_DATE'])) {
            $msg ['INAT_EFFTDATE'] = smsg('MSG-127', $record ['INAT_IDCODE'], $record ['INAT_INVESTMENT_CODE'] . ' ' . $record ['INAT_EFFTDATE'] . '>' . $record ['INAT_ISSUE_DATE']);
        }
        if ($is_purchase && $record ['INAT_ISSUE_DATE'] <> '' && $record ['INAT_MATURITY_DATE'] <> '' && ($record ['INAT_MATURITY_DATE'] < $record ['INAT_ISSUE_DATE'])) {
            $msg ['INAT_EFFTDATE'] = smsg('MSG-349', $record ['INAT_IDCODE'], $record ['INAT_INVESTMENT_CODE'] . ' ' . $record ['INAT_MATURITY_DATE'] . '<' . $record ['INAT_ISSUE_DATE']);
        }
        //INPR_FIRST_PYMNT_DATE
        if (($record ['INAT_INVEST_ACTIVITY'] === 'BY' || $record ['INAT_INVEST_ACTIVITY'] === 'BYT') && $record ['INPR_FIRST_PYMNT_DATE'] <> '' && $record ['INAT_ISSUE_DATE'] <> '' && ($record ['INPR_FIRST_PYMNT_DATE'] < $record ['INAT_ISSUE_DATE'])) {
            $msg ['INPR_FIRST_PYMNT_DATE'] = smsg('MSG-350', $record ['INAT_IDCODE'], $record ['INAT_INVESTMENT_CODE'] . ' ' . $record ['INPR_FIRST_PYMNT_DATE'] . '<' . $record ['INAT_ISSUE_DATE']);
        }
        if (($record ['INAT_INVEST_ACTIVITY'] === 'BY' || $record ['INAT_INVEST_ACTIVITY'] === 'BYT') && $record ['INPR_FIRST_PYMNT_DATE'] <> '' && $record ['INAT_MATURITY_DATE'] <> '' && ($record ['INPR_FIRST_PYMNT_DATE'] > $record ['INAT_MATURITY_DATE'])) {
            $msg ['INPR_FIRST_PYMNT_DATE'] = smsg('MSG-351', $record ['INAT_IDCODE'], $record ['INAT_INVESTMENT_CODE'] . ' ' . $record ['INPR_FIRST_PYMNT_DATE'] . '<' . $record ['INAT_ISSUE_DATE']);
        }
        //validar que requira cuenta de banco
        if ($record['INAT_FIDU_BANKACT_CODE'] === 'null')
            $record['INAT_FIDU_BANKACT_CODE'] = '';
        $sql = 'SELECT COUNT(INTL.ID) FROM ' . $this->intlname . ' INTL WHERE INTL.INVEST_ACTIVITY IN (' . singleQuoteArray(array('BY', 'BYT')) . ') AND ACT_LINE_TYPE = ' . singleQuote('CA');
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO && $record['INAT_FIDU_BANKACT_CODE'] === '') {
            $msg ['INAT_FIDU_BANKACT_CODE'] = smsg('MSG-337', $record ['INAT_IDCODE']);
        }
        //validar que cuenta de banco sea de la misma moneda que el portafolio
        if ($record['INAT_FIDU_BANKACT_CODE'] <> '') {
            $sql = 'SELECT COUNT(INFU.ID) FROM ' . $this->infuname . ' INFU, ' . $this->fibkname . ' FIBK WHERE INFU.CURRENCY_CODE = FIBK.CURRENCY_CODE AND INFU.IDCODE =' . singleQuote($record['INAT_PORTFOLIO_CODE']) . ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['INAT_FIDU_BANKACT_CODE']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['INAT_FIDU_BANKACT_CODE'] = smsg('MSG-338', $record ['INAT_IDCODE']);
                ;
            }
            //Validar que la cuenta de banco exista en contrato de actividad.
            $sql = 'SELECT COUNT(FIAS.ID) QTY FROM ' . $this->fiasname . ' FIAS WHERE FIAS.FIDU_BANKACT_CODE =' . singleQuote($record['INAT_FIDU_BANKACT_CODE']) . ' AND FIAS.CONTRACT_CODE =' . singleQuote($record['INAT_CONTRACT_CODE']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['INAT_FIDU_BANKACT_CODE'] = smsg('MSG-348', $record ['INAT_IDCODE']);
                ;
            }
        }
        //Validar que el producto de inversion sea de la misma moneda que la
        //moneda del portafolio
        $sql = 'SELECT COUNT(INFU.ID) FROM ' . $this->infuname . ' INFU, ' . $this->prodname . ' PROD WHERE INFU.CURRENCY_CODE = PROD.CURRENCY_CODE AND INFU.IDCODE =' . singleQuote($record['INAT_PORTFOLIO_CODE']) . ' AND PROD.IDCODE =' . singleQuote($record['INPR_PRODUCT_CODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg ['INAT_INVESTMENT_CODE'] = smsg('MSG-353', $record ['INAT_IDCODE']);
        }
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') {
            $record ['INAT_EFFTDATE'] = xFormat::anytimedate($record ['INAT_EFFTDATE'], 'Y-m-d');
            if (empty($bckdtdop))
                $bckdtdop = CLX_INIT_ZERO;
            if (day_diff($record ['INAT_EFFTDATE'], $operation_date) < $bckdtdop) {
                $msg ['INAT_EFFTDATE'] = smsg('MSG-102', $record ['INAT_EFFTDATE'], $operation_date, $record ['INAT_IDCODE']);
            }
            //Fecha real siempre debe ser igual a la fecha de operaciones
            if ($record ['INAT_REAL_DATE'] != $operation_date) {
                $msg ['INAT_REAL_DATE'] = smsg('MSG-102', $record ['INAT_REAL_DATE'], $operation_date, $record ['INAT_IDCODE']);
            }
        }
        if (empty($stock) && ($inttrec ['IDCODE'] === 'BYT' ) && !empty($infarec ['INVESTMENT_CODE']) && empty($reversal)) {//se permite multiples para poder ajustar
            $msg ['INAT_INVESTMENT_CODE'] = smsg('MSG-129', $record ['INAT_IDCODE']);
        }
        $infurec ['INFU_IDCODE'] = $infurec ['IDCODE'];
        // Activity validations
        switch ($record ['INAT_INVEST_ACTIVITY']) {
            case 'BY' : case 'BYT' :
                if ($record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_INVEST_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'RD' :
                if (empty($reversal) && round($record ['INAT_ACCRUED_INT_AMT'], CLX_NUM_TWO) != round($infarec ['ACCRUED_INT_AMT'] - $infarec['PAID_INT_AMT'], CLX_NUM_TWO)) {
                    $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['ACCRUED_INT_AMT']));
                }
                if ($record ['INAT_FACE_VALUE'] == CLX_NUM_ZERO) {
                    $msg ['INAT_FACE_VALUE'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO && $record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'SL' :
                if ($record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_INVEST_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO && $record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'VE' :
                if ($record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_INVEST_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO && $record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'CA' :
                if ($record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_INVEST_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO && $record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                // Validando que se coloquen los intereses restantes
                if (round($record ['INAT_ACCRUED_INT_AMT'], CLX_NUM_TWO) != round($infarec ['ACCRUED_INT_AMT'] - $infarec['PAID_INT_AMT'], CLX_NUM_TWO)) {
                    $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['ACCRUED_INT_AMT']));
                }
                break;
            case 'DIVAO' :
            case 'DIVEO' :
                if ($record ['INAT_DIVIDEND_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_DIVIDEND_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                break;
            case 'DIVA' :
                if ($record ['INAT_INVEST_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_INVEST_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_DIVIDEND_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_DIVIDEND_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['DIVIDEND_AMT']));
                }
                break;
            case 'DIVE' :
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                if ($record ['INAT_DIVIDEND_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_DIVIDEND_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($record ['INAT_DIVIDEND_AMT']));
                }
                break;
            case 'UEI' :
                if ($record ['INAT_ACCRUED_INT_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['ACCRUED_INT_AMT']));
                }
                break;
            case 'PINT' :
                if ($record ['INAT_ACCRUED_INT_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['ACCRUED_INT_AMT']));
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'PINTR' :
                if ($record ['INAT_ACCRUED_INT_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_ACCRUED_INT_AMT'] = smsg('MSG-133', $record ['INAT_IDCODE'], clx_format_currency($infarec ['ACCRUED_INT_AMT']));
                }
                if ($record ['INAT_CASH_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_CASH_AMT'] = smsg('MSG-132', $record ['INAT_IDCODE']);
                }
                break;
            case 'PA' :
            case 'DA' :
                if ($record ['INAT_AMORTIZED_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_AMORTIZED_AMT'] = smsg('MSG-134', $record ['INAT_IDCODE']);
                }
                break;
            case 'AVAL' :
                if ($record ['INAT_VALORIZED_AMT'] == CLX_NUM_ZERO) {
                    $msg ['INAT_VALORIZED_AMT'] = smsg('MSG-131', $record ['INAT_IDCODE']);
                }
                break;
            default :
                break;
        }
        // Validar existencia de actividad
        if (!empty($record ['INAT_CONTRACT_CODE']) && $record ['INAT_INVEST_ACTIVITY'] !== 'BY' && $record ['INAT_INVEST_ACTIVITY'] !== 'BYT' && $record ['INAT_INVEST_ACTIVITY'] !== 'APINV' && $record ['INAT_INVEST_ACTIVITY'] !== 'DIVAO' && $record ['INAT_INVEST_ACTIVITY'] !== 'DIVEO' && $record ['INAT_INVEST_ACTIVITY'] !== 'UEI' && !$reversal) {
            $sql = 'SELECT COUNT(ID) FROM ' . $this->infaname . ' WHERE POSITION_NUMBER = ' . singleQuote($record ['INAT_POSITION_NUMBER']) . ' AND INVEST_AMT <> 0';
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['INAT_POSITION_NUMBER'] = smsg('MSG-145', $record ['INAT_IDCODE']);
            }
        }
        //Validando asiento
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && empty($msg)) {
            if (!class_exists('Jehd')) {
                includeCodeLib('JEHD');
            }
            $jehd = new Jehd ();
            $jehdrec = ClxCommon::$db->getRecord($this->jehdname, 'INAT_CODE = ' . singleQuote($record ['INAT_IDCODE']));
            if (!empty($jehdrec)) {
                foreach ($jehdrec as $key => $val) {
                    $jehdrec ['JEHD_' . $key] = $val;
                }
                $jehd->jehd_validate_form($jehdrec, $msg);
            } else {
                //Missing Journal cannot happend
                $msg ['INAT_INVESTMENT_CODE'] = smsg('MSG-369', $record ['INAT_IDCODE']);
            }
        }
        return (count($msg) > CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Saves product (INPR) if validation pass
     *
     * @param unknown_type $form_record
     */
    function save_inpr($form_record) {
        if (!array_key_exists('INPR_PRODUCT_CODE', $form_record)) {
            return;
        }
        if (ClxCommon::$db->oneExistsRecords($this->inttname, 'IDCODE = ' . singleQuote($form_record ['INAT_INVEST_ACTIVITY']) . ' AND PROMPT_PROD_INFO = 1') == CLX_NUM_ZERO) {
            return;
        }
        $rec = array('IDNAME' => $form_record ['INPR_IDNAME'],
            'PRODUCT_CODE' => $form_record ['INPR_PRODUCT_CODE']);
        $sql = 'SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote('INPR') . ' AND FIELDNAME NOT IN (' . singleQuoteArray(array('ID', 'IDNAME', 'PRODUCT_CODE', 'CDATE', 'MDATE', 'CREATEDBY', 'MODIFIEDBY')) . ') ORDER BY SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (array_key_exists('INPR_' . $r ['FIELDNAME'], $form_record)) {
                if ($form_record ['INPR_' . $r ['FIELDNAME']] === '') {
                    $rec [$r ['FIELDNAME']] = 'null';
                } else {
                    $rec [$r ['FIELDNAME']] = $form_record ['INPR_' . $r ['FIELDNAME']];
                }
            } else {
                $rec [$r ['FIELDNAME']] = 'null';
            }
        }
        if ($rec['COUPON_RT'] <> CLX_NUM_ZERO)
            $rec['CALC_INTEREST'] = CLX_NUM_ONE;
        $inprrec = $this->get_inpr_record($form_record['INAT_INVESTMENT_CODE'], $form_record['INAT_EFFTDATE']);
        if (!empty($inprrec)) {
            unset($rec['ID']);
            $rec ['STATUS'] = 'A';
            $rec ['MODIFIEDBY'] = $this->username;
            $rec ['MDATE'] = $this->now;
            $rec ['CLX_EFFTDATE'] = $inprrec['CLX_EFFTDATE'];
            ClxCommon::$db->updateRecord($this->inprname, $rec, 'ID = ' . singleQuote($inprrec ['ID']));
        } else {
            $rec ['STATUS'] = 'A';
            $rec ['CREATEDBY'] = $this->username;
            $rec ['CDATE'] = $this->now;
            $rec ['MODIFIEDBY'] = $this->username;
            $rec ['MDATE'] = $this->now;
            $rec ['CLX_EFFTDATE'] = $form_record['INAT_EFFTDATE'];
            ClxCommon::$db->createRecord($this->inprname, $rec, false);
        }
        //Calculating amortizacion
        if (!class_exists('Inas'))
            includeCodeLib('INAS');
        $inas = new Inas();
        $inas->build_payment_schedule($form_record ['INAT_INVESTMENT_CODE'], $form_record['INAT_EFFTDATE']);
    }

// end method
    /**
     * Update Parent (INAT) Information once record is saved
     *
     * @param array $record
     */
    function inat_save_form(&$record) {
        // Adding inpr if not exists
        $this->save_inpr(UserRequest::$post);
    }

    /**
     * Perform save recors post commit
     */
    function inat_save_form_post(&$record) {
        //Building accounting
        if (!array_key_exists('COMP_CODE', $record)) {
            return;
        } else {
            $this->inat_build_accounting_batch($record['COMP_CODE'], $record['EFFTDATE'], array(), $record['IDCODE']);
        }
    }

    /**
     * Test if transaction can be modified
     */
    function inat_is_editable($idcode) {
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        $jehd = new Jehd ();
        $jehdr_code = $jehd->jehd_get_idcode_by_transcode($idcode);
        return !$jehd->jehd_exists($jehdr_code) || $jehd->jehd_is_editable($jehdr_code);
    }

    /**
     * Builds inat Record
     */
    function inat_build(&$record) {
        if (empty($record ['IDCODE'])) {
            $record ['IDCODE'] = 'AUTO';
        }
        $record ['CLX_AUTH_STATUS'] = 'PEND';
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp ();
        // Validar que la fecha de la operacion sea menor o igual a la
        // contabilidad +1 dia
        if (array_key_exists('PORTFOLIO_CODE', $record)) {
            $comp_code = ClxCommon::$db->getField($this->infuname, 'COMP_CODE', 'IDCODE= ' . singleQuote($record ['PORTFOLIO_CODE']));
            $comprec = $comp->comp_operation_parameters($comp_code);
        } elseif (array_key_exists('INAT_PORTFOLIO_CODE', $record)) {
            $comp_code = ClxCommon::$db->getField($this->infuname, 'COMP_CODE', 'IDCODE= ' . singleQuote($record ['INFA_PORTFOLIO_CODE']));
            $comprec = $comp->comp_operation_parameters($comp_code);
        } else {
            $comprec = $comp->comp_operation_parameters();
        }
        if (!array_key_exists('EFFTDATE', $record)) {
            $record ['EFFTDATE'] = $comprec ['OPERATION_DATE'];
        }
        if (!array_key_exists('REAL_DATE', $record)) {
            $record ['REAL_DATE'] = $comprec ['OPERATION_DATE'];
        }
        if (!function_exists('setCreationData')) {
            includeCodeLib('GEN_REC_UTIL');
        }
        setCreationData($record);
        setCreationIdCode($record, 'INAT');
        ClxCommon::$db->createRecord($this->inatname, $record, false);
        return $record ['IDCODE'];
    }

    // Reversal functions
    /**
     * Execute bottom demand from listing jehd
     */
    function inat_reverse_build() {
        $idlist = toString(getIdlist());
        $results = ClxCommon::$db->executeQuery('SELECT IDCODE FROM ' . $this->inatname . ' WHERE ID IN (' . $idlist . ')');
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            ClxFreeReturn($this->inat_reverse($result ['IDCODE']));
        }
    }

    /**
     * Reverses transaction
     */
    private function inat_reverse($inat_code) {
        $new_inat_code = '';
        // Validating if not reverse of reverse
        if (!$this->inat_reverse_validate($inat_code)) {
            return $new_inat_code;
        }
        $record = ClxCommon::$db->getRecord($this->inatname, 'IDCODE = ' . singleQuote($inat_code), 'CLX_AUTH_STATUS = ' . singleQuote('AP') . '');
        // REV Transaccion Generation
        $revtrans = $record;
        unset($revtrans ['ID'], $revtrans ['REAL_DATE']);
        $revtrans ['REVACTI_CODE'] = $inat_code;
        $revtrans ['IDCODE'] = 'AUTO';
        $revtrans ['CLX_AUTH_STATUS'] = 'PEND';
        ClxFreeReturn($this->inat_build($revtrans));
        $new_inat_code = $revtrans ['IDCODE'];
        unset($revtrans);
        //Reverse jehd if exists
        $jehdr_code = ClxCommon::$db->getfield($this->jehdname, 'IDCODE', 'INAT_CODE = ' . singleQuote($inat_code));
        if ($jehdr_code <> '') {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd();
            $jehd->jehd_reverse($jehdr_code, '', $new_inat_code);
        }
        return $new_inat_code;
    }

    /**
     * Reversal validations
     */
    function inat_reverse_validate($inat_code) {
        $record = ClxCommon::$db->getRecord($this->inatname, 'REVACTI_CODE = ' . singleQuote($inat_code) . ' OR (IDCODE = ' . singleQuote($inat_code) . ' AND REVACTI_CODE IS NOT null)');
        $status = true;
        if (!empty($record)) {
            addMessage('INATREV01 ' . dict('CODE_ERR_TRANSTOREVSTATUSFAIL', $inat_code));
            return false;
        }
        return $status;
    }

    /**
     * Approve an validate activity
     * @param string $trans_code
     */
    function inat_approve_by_transcode_validate($trans_code, &$msg) {
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        $jehd = new Jehd ();
        $jehdrec = ClxCommon::$db->getRecord($this->jehdname, 'INAT_CODE = ' . singleQuote($trans_code));
        if (!empty($jehdrec)) {
            foreach ($jehdrec as $key => $val) {
                $jehdrec ['JEHD_' . $key] = $val;
            }
            $jehd->jehd_validate_form($jehdrec, $msg);
        } else {
            //Missing Journal cannot happend
            $msg ['INAT_INVESTMENT_CODE'] = smsg('MSG-369', $trans_code);
        }
        if (empty($msg)) {
            $this->inat_approve_by_transcode($trans_code);
            return true;
        } else {
            addMessage($msg ['INAT_INVESTMENT_CODE']);
            return false;
        }
    }

    /**
     * Approve transaction by transaction code
     * @param string $trans_code
     */
    function inat_approve_by_transcode($trans_code) {
        // Authorize transaction
        $record = ClxCommon::$db->getRecord($this->inatname, 'IDCODE = ' . singleQuote($trans_code));
        if (!empty($record)) {
            $this->inat_post_autorize($record);
            ClxCommon::$db->updateRecord($this->inatname, array('CLX_AUTH_STATUS' => 'AP', 'JE_COMPLETED' => CLX_NUM_ONE), 'IDCODE = ' . singleQuote($record ['IDCODE']));
        }
    }

    /**
     * Updates portfolio totals
     *
     * @param string $comp_code
     * @param string $portfolio_code
     */
    function inat_update_portfolio_totals($comp_code, $portfolio_code = '') {
        if (!class_exists('Infu')) {
            includeCodeLib('INFU');
        }
        $infu = new Infu ();
        $infu->infu_update_portfolio_totals($comp_code, $portfolio_code);
        unset($infu);
    }

    /**
     * Events running post autorizations
     */
    function inat_post_autorize(&$record, $reject = false) {
        if ($reject === true) {
            $sql = 'UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('REJ') . ', JE_STATUS = ' . singleQuote('REJ') . ' WHERE INAT_CODE =' . singleQuote($record['IDCODE']) . ' AND JE_STATUS =' . singleQuote('PEND');
            ClxCommon::$db->executeQuery($sql);
            return;
        }
        if (UserRequest::$request ['ac'] === 'DELETE')
            return;
        //Build infa and update infu totals if not T2+T3 where investment record should not be affected.
        if ($record['INVEST_ACTIVITY'] <> 'BYT') {
            $this->process_auxiliar($record);
        }
        // Send accounting to queue
        $jehdr_code = ClxCommon::$db->getField($this->jehdname, 'IDCODE', 'INAT_CODE =' . singleQuote($record ['IDCODE']));
        if ($jehdr_code <> '') {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd();
            $jehd->jehd_approve_queue_by_code($jehdr_code);
        }
    }

    /**
     * Updates infa from approval
     * @param array $record inat record
     */
    private function process_auxiliar(&$record) {
        $reverse_sign = (!empty($record ['REVACTI_CODE'])) ? CLX_NUM_MINUS_1 : CLX_NUM_ONE;
        // Create infa if not exists
        if (!function_exists('infa_build')) {
            includeCodeLib('INFA');
        }

        $infa = new Infa ();
        $infa->infa_build($record ['POSITION_NUMBER'], $record ['COMP_CODE'], $record ['PORTFOLIO_CODE'], $record ['INVESTMENT_CODE'], $record['CONTRACT_CODE'], $record['PARTICIPANT_ID'], $record ['EFFTDATE'], $record['INVEST_CLASS'], $record['SEC_BROKER'], $record['SEC_CUSTODIAN'], $record['UNIT_PRICE'], $record['UNIT_PRICE_PCT'], $record['YIELD_RT'], $record['PD_YIELD_RT']);
        // Retrieve Activity information
        $inttrec = $this->inat_get_intt($record ['INVEST_ACTIVITY']);
        // Based on activity parameters perform updates.
        // see inat_get_intt for Options
        // Update infa according to activity parameters.
        $run_sql = false;
        $comma = '';
        $sql = 'UPDATE ' . $this->infaname . ' SET ';
        // Setting Dividend AFFECT_DIVIDEND
        // Investments
        if ($inttrec ['AFFECT_DIVIDEND'] === 'DR' && $record ['DIVIDEND_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' DIVIDEND_AMT = DIVIDEND_AMT + (' . $reverse_sign . ' * ' . $record ['DIVIDEND_AMT'] . ')';
            $comma = ', ';
            if ($record ['SHARES'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' SHARES = SHARES + (' . $reverse_sign . ' * ' . $record ['SHARES'] . ')';
            }
        }
        if ($inttrec ['AFFECT_DIVIDEND'] === 'CR' && $record ['DIVIDEND_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' DIVIDEND_AMT = DIVIDEND_AMT - (' . $reverse_sign . ' * ' . $record ['DIVIDEND_AMT'] . ')';
            $comma = ', ';
            if ($record ['SHARES'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' SHARES = SHARES - (' . $reverse_sign . ' * ' . $record ['SHARES'] . ')';
            }
        }
        // Investments
        if ($inttrec ['AFFECT_ASSET'] === 'DR' && $record ['INVEST_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            if ($record ['FACE_VALUE'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' FACE_VALUE = FACE_VALUE + (' . $reverse_sign . ' * ' . $record ['FACE_VALUE'] . ')';
                $comma = ', ';
                $sql .= $comma . ' PREMIUM_DISC_AMT = PREMIUM_DISC_AMT + (' . $reverse_sign . ' * ' . ($record ['INVEST_AMT'] - $record ['FACE_VALUE']) . ')';
            } elseif ($record ['SHARES'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' SHARES = SHARES + (' . $reverse_sign . ' * ' . $record ['SHARES'] . ')';
                $comma = ', ';
            } elseif ($record ['FACE_VALUE'] == CLX_NUM_ZERO && $record ['SHARES'] == CLX_NUM_ZERO) { // face and shares=0 means amortization
                $sql .= $comma . ' AMORTIZED_AMT = AMORTIZED_AMT + (' . $reverse_sign . ' * ' . $record ['INVEST_AMT'] . ')';
                $comma = ', ';
            }
        }
        //handling paid interest field
        if ($record ['INVEST_ACTIVITY'] === 'RD') {
            //El monto amortizado en el caso de redencion debe contener el monto total redimido. lo amortizado mas lo que se esta bajando en la venta.
            $sql .= $comma . ' AMORTIZED_AMT = AMORTIZED_AMT - (' . $reverse_sign . ' * ' . $record ['AMORTIZED_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['AFFECT_ASSET'] === 'CR' && $record ['INVEST_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            if ($record ['FACE_VALUE'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' FACE_VALUE = FACE_VALUE - (' . $reverse_sign . ' * ' . $record ['FACE_VALUE'] . ')';
                $comma = ', ';
                $sql .= $comma . ' PREMIUM_DISC_AMT = PREMIUM_DISC_AMT - (' . $reverse_sign . ' * ' . ($record ['AMORTIZED_AMT']) . ')';
            } elseif ($record ['SHARES'] != CLX_NUM_ZERO) {
                $sql .= $comma . ' SHARES = SHARES - (' . $reverse_sign . ' * ' . $record ['SHARES'] . ')';
                $comma = ', ';
            } elseif ($record ['FACE_VALUE'] == CLX_NUM_ZERO && $record ['SHARES'] == CLX_NUM_ZERO) { // face and  shares=0 means amortization
                $sql .= $comma . ' AMORTIZED_AMT = AMORTIZED_AMT - (' . $reverse_sign . ' * ' . $record ['INVEST_AMT'] . ')';
                $comma = ', ';
            }
        }
        // cash amount
        // Investments
        if ($inttrec ['AFFECT_CASH'] === 'DR' && $record ['CASH_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' CASH_AMT = CASH_AMT + (' . $reverse_sign . ' * ' . $record ['CASH_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['AFFECT_CASH'] === 'CR' && $record ['CASH_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' CASH_AMT = CASH_AMT - (' . $reverse_sign . ' * ' . $record ['CASH_AMT'] . ')';
            $comma = ', ';
        }
        // Equity amount
        if ($inttrec ['AFFECT_EQUITY'] === 'DR' && $record ['CASH_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' EQUITY_AMT = EQUITY_AMT + (' . $reverse_sign . ' * ' . $record ['CASH_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['AFFECT_EQUITY'] === 'CR' && $record ['CASH_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' EQUITY_AMT = EQUITY_AMT - (' . $reverse_sign . ' * ' . $record ['CASH_AMT'] . ')';
            $comma = ', ';
        }
        // About Interests
        if ($record ['INVEST_ACTIVITY'] !== 'PINTR' && $inttrec ['AFFECT_RECEIVABLES'] === 'DR' && $record ['ACCRUED_INT_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' ACCRUED_INT_AMT = ACCRUED_INT_AMT + (' . $reverse_sign . ' * ' . $record ['ACCRUED_INT_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['AFFECT_RECEIVABLES'] === 'CR' && $record ['ACCRUED_INT_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            if ($inttrec ['IS_REVERSAL'] == CLX_NUM_ONE) {
                $sql .= $comma . ' ACCRUED_INT_AMT = ACCRUED_INT_AMT - (' . $reverse_sign . ' * ' . $record ['ACCRUED_INT_AMT'] . ')';
                $comma = ', ';
            } else {
                $sql .= $comma . ' PAID_INT_AMT = PAID_INT_AMT + (' . $reverse_sign . ' * ' . $record ['ACCRUED_INT_AMT'] . ')';
                $comma = ', ';
            }
        }
        //Amortizacion de prima o descuento
        if ($record ['INVEST_ACTIVITY'] === 'PA') {
            $run_sql = true;
            $sql .= $comma . ' AMORTIZED_AMT = AMORTIZED_AMT - (' . $reverse_sign . ' * ' . $record ['AMORTIZED_AMT'] . ')';
            $comma = ', ';
            $sql .= $comma . ' INVEST_AMT =  INVEST_AMT- (' . $reverse_sign . ' * ' . $record ['AMORTIZED_AMT'] . ')';
            $sql .= $comma . ' PREMIUM_DISC_AMT = PREMIUM_DISC_AMT - (' . $reverse_sign . ' * ' . ($record ['AMORTIZED_AMT']) . ')';
        }
        if ($record ['INVEST_ACTIVITY'] === 'DA') {
            $run_sql = true;
            $sql .= $comma . ' AMORTIZED_AMT = AMORTIZED_AMT + (' . $reverse_sign . ' * ' . $record ['AMORTIZED_AMT'] . ')';
            $comma = ', ';
            $sql .= $comma . ' INVEST_AMT =  INVEST_AMT+ (' . $reverse_sign . ' * ' . $record ['AMORTIZED_AMT'] . ')';
            $sql .= $comma . ' PREMIUM_DISC_AMT = PREMIUM_DISC_AMT + (' . $reverse_sign . ' * ' . ($record ['AMORTIZED_AMT']) . ')';
        }
        //Ajuste de valoracion
        if ($record ['INVEST_ACTIVITY'] === 'AVAL') {
            if ($record ['VALORIZED_AMT'] > CLX_NUM_ZERO) {
                $record ['VALORIZED_GAIN_AMT'] = $record ['VALORIZED_AMT'];
            } elseif ($record ['VALORIZED_AMT'] < CLX_NUM_ZERO) {
                $record ['VALORIZED_LOSS_AMT'] = $record ['VALORIZED_AMT'];
            } else {
                $record ['VALORIZED_GAIN_AMT'] = CLX_INIT_ZERO;
                $record ['VALORIZED_LOSS_AMT'] = CLX_INIT_ZERO;
            }
            $run_sql = true;
            $sql .= $comma . ' VALORIZED_GAIN_AMT = VALORIZED_GAIN_AMT + (' . $reverse_sign . ' * ' . $record ['VALORIZED_GAIN_AMT'] . ')';
            $comma = ', ';
            $sql .= $comma . ' VALORIZED_LOSS_AMT = VALORIZED_LOSS_AMT + (' . $reverse_sign . ' * ' . $record ['VALORIZED_LOSS_AMT'] . ')';
            $sql .= $comma . ' VALORIZED_AMT = VALORIZED_AMT + (' . $reverse_sign . ' * ' . $record ['VALORIZED_AMT'] . ')';
        }
        //monto de valoracion para cancelaciones
        if ($record ['INVEST_ACTIVITY'] === 'SL' || $record ['INVEST_ACTIVITY'] === 'CA' || $record ['INVEST_ACTIVITY'] === 'VE' || $record ['INVEST_ACTIVITY'] === 'RD') {
            $sql .= $comma . ' VALORIZED_GAIN_AMT = VALORIZED_GAIN_AMT - (' . $reverse_sign . ' * ' . $record ['VALORIZED_GAIN_AMT'] . ')';
            $comma = ', ';
            $sql .= $comma . ' VALORIZED_LOSS_AMT = VALORIZED_LOSS_AMT - (' . $reverse_sign . ' * ' . $record ['VALORIZED_LOSS_AMT'] . ')';
            $sql .= $comma . ' VALORIZED_AMT = VALORIZED_GAIN_AMT+VALORIZED_LOSS_AMT ';
        }
        //handling paid interest field
        if ($record ['INVEST_ACTIVITY'] === 'PINTR') {
            $run_sql = true;
            $sql .= $comma . ' PAID_INT_AMT = PAID_INT_AMT - (' . $reverse_sign . ' * ' . $record ['ACCRUED_INT_AMT'] . ')';
            $comma = ', ';
        }
        // Others
        if ($inttrec ['APPLY_GAIN'] == CLX_NUM_ONE && $record ['GAIN_AMT'] > CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' GAIN_AMT = GAIN_AMT + (' . $reverse_sign . ' * ' . $record ['GAIN_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['APPLY_LOSS'] == CLX_NUM_ONE && $record ['GAIN_AMT'] < CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' GAIN_AMT = GAIN_AMT + (' . $reverse_sign . ' * ' . $record ['GAIN_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['APPLY_TAX'] == CLX_NUM_ONE && $record ['TAX_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' TAX_AMT = TAX_AMT + (' . $reverse_sign . ' * ' . $record ['TAX_AMT'] . ')';
            $comma = ', ';
        }
        if ($inttrec ['APPLY_FEES'] == CLX_NUM_ONE && $record ['FEES_AMT'] != CLX_NUM_ZERO) {
            $run_sql = true;
            $sql .= $comma . ' FEES_AMT = FEES_AMT + (' . $reverse_sign . ' * ' . $record ['FEES_AMT'] . ')';
        }
        if ($inttrec ['AFFECT_ASSET'] === 'CR' && $record ['INVEST_AMT'] != CLX_NUM_ZERO) {
            $sql .= $comma . ' INVEST_AMT =  INVEST_AMT- (' . $reverse_sign . ' * ' . ($record ['INVEST_AMT'] - $record['GAIN_AMT']) . ')';
        }
        if ($inttrec ['AFFECT_ASSET'] === 'DR' && $record ['INVEST_AMT'] != CLX_NUM_ZERO) {
            $sql .= $comma . ' INVEST_AMT =  INVEST_AMT+ (' . $reverse_sign . ' * ' . $record ['INVEST_AMT'] . ')';
        }
        $sql .= $comma . ' BOOK_VALUE_AMT = (FACE_VALUE + (SHARES*UNIT_PRICE))+VALORIZED_AMT+(PREMIUM_DISC_AMT)'; //valor de mercado
        $comma = ', ';
         if ($record ['INVEST_ACTIVITY'] === 'BY' || $record ['INVEST_ACTIVITY'] === 'APINV' || $record ['INVEST_ACTIVITY'] === 'BYT') {
             $sql .= $comma . ' UNIT_PRICE = ROUND(IF(SHARES = 0, 0, INVEST_AMT/SHARES), 5) '; //Convertido en caso de acciones
         }
        // setting investment criterias
        $sql .= ' WHERE POSITION_NUMBER = ' . singleQuote($record ['POSITION_NUMBER']);
        if ($run_sql === true) {
            ClxCommon::$db->executeQuery($sql);
        }
        // Last step inactivate all investments that has being canceled
        if ($reverse_sign < CLX_NUM_ZERO) { // on cancelation reversal then activate again
            // mark reversed transaction where it applys if
            // reversal
            $sql = 'UPDATE ' . $this->inatname . ' SET REVERSED = 1 WHERE IDCODE = ' . singleQuote($record ['REVACTI_CODE']);
            ClxCommon::$db->executeQuery($sql);
        }
        // Updating portfolio totals
        $this->inat_update_portfolio_totals($record ['COMP_CODE'], $record ['PORTFOLIO_CODE']);
    }

    /**
     * Get information regarding the activity
     *
     * @param unknown_type $invest_activity
     * @return Ambigous <multitype:, multitype:>
     */
    private function inat_get_intt($invest_activity) {
        /*
         * INTT for Options: AFFECT_CASH	- For accounting only when buiilding
         * accounting AFFECT_ASSET - Alter investment amount, face value, and
         * shares, May change amortized amount fi not face provided
         * AFFECT_INCOME - For accounting only when buiilding accounting
         * AFFECT_EQUITY - For accounting only when buiilding accounting
         * AFFECT_RECEIVABLES - Alters earnend interest or paid interest is the
         * case ------------ Aditional options to be handled agains cash if cash
         * apply only AFFECT_GAIN - Alters gain amounts AFFECT_LOSS - Alters
         * gain amounts AFFECT_TAX	- Alters tax amounts AFFECT_FEES - Alters
         * fess amounts AMORTIZATION - Alters fess amounts
         */
        //tmas or  t2/t3 affects asset after 2 days that is why INTL.ACT_LINE_TYPE IN ('IN','TMAS')
        $sql = 'SELECT (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE =' . singleQuote('CA') . ') AFFECT_CASH, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE IN (' . singleQuoteArray(array('IN', 'TMAS')) . ')) AFFECT_ASSET, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE = ' . singleQuote('INC') . ') AFFECT_INCOME, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE = ' . singleQuote('EQ') . ') AFFECT_EQUITY, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE = ' . singleQuote('AR') . ') AFFECT_RECEIVABLES, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE IN (' . singleQuoteArray(array('ORDER', 'ORDER2')) . ')) AFFECT_ORDER, (SELECT MAX(INTL.DEBIT_CREDIT) FROM ' . $this->intlname . ' INTL WHERE INVEST_ACTIVITY = INTT.IDCODE AND INTL.ACT_LINE_TYPE = ' . singleQuote('DIVIDEND') . ') AFFECT_DIVIDEND, /*----additional options-----*/ INTT.APPLY_GAIN, INTT.APPLY_LOSS, INTT.APPLY_TAX, INTT.APPLY_FEES, INTT.AMORTIZATION, INTT.IS_REVERSAL, INTT.IDCODE FROM ' . $this->inttname . ' INTT WHERE INTT.IDCODE = ' . singleQuote($invest_activity);
        return ClxCommon::$db->getOneRecord($sql);
    }

    // Building Activity Accounting
    /**
     * Distribucion por boton
     */
    function inat_btn_distribute() {
        $idlist = getIdlist();
        return;
        if (empty($idlist)) {
            return;
        }
        $ids = toString($idlist);
        $sql = 'SELECT DISTINCT COMP_CODE FROM ' . $this->infuname . ' WHERE ID IN (' . $ids . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            // ClxCommon::$db->debug = true;
            $this->inat_build_accounting_batch($r ['COMP_CODE']);
            // ClxCommon::$db->debug = false;
        }
    }

// end method
    /**
     * Initialice all temporary tables
     *
     * @param unknown_type $batch_id
     */
    private function init_temporary_tables($batch_id) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('IAT1');
        $DBTB->buildTemporaryTable('IAT2');
        $DBTB->buildTemporaryTable('IAT3');
        $DBTB->buildTemporaryTable('IAT4');
        $DBTB->buildTemporaryTable('JTMP');
        $this->clear_temporary_tables($batch_id);
    }

    /**
     * Delete all records from temporary table
     *
     * @param unknown_type $batch_id
     */
    private function clear_temporary_tables($batch_id) {
        // Clearing Temporary table for batch id
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat2name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat3name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat4name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

    /**
     * Build activities summary for accounting
     *
     * @param string $batch_id
     * @param string $comp_code
     * @param string $operation_date
     * @param string $priority_no
     * @param string $activity_code
     */
    private function build_activities_summary(&$batch_id, &$comp_code, &$operation_date, &$priority_no, $activity_code = '') {
        // 1 SUMARIZANDO ACTIVIDADES MONTO EN ACTIVIDADES PARA TABLA TEMPORAL 1
        $sql = 'INSERT INTO ' . $this->iat1name . ' (IDCODE, IDNAME, INVEST_ACTIVITY, POSITION_NUMBER, INVESTMENT_CODE, DISCRETIONARY_PORT, PRIORITY_SEQNUM, COMP_CODE, PORTFOLIO_CODE, EFFTDATE, BANK_ACCOUNT_NO, CA_GL_CODE, EQ_GL_CODE, AR_GL_CODE, TAX_GL_CODE, FEE_GL_CODE, GAIN_GL_CODE, LOSS_GL_CODE, INC_GL_CODE, INV_GL_CODE, ORDER_GL_CODE, ORDER2_GL_CODE, DIVIDEND_GL_CODE, DIVIDEND2_GL_CODE, VALOR_GL_CODE, VALOR2_GL_CODE, VALOR3_GL_CODE, VALOR4_GL_CODE, PREMIUM_GL_CODE, PYD2P_GL_CODE, DISCOUNT_GL_CODE, PYD2D_GL_CODE, CLX_AUTH_STATUS, JE_SOURCE, CLOSING_ENTRY, REVERSED, BATCH_ID, CREATEDBY, MODIFIEDBY, CDATE, MDATE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, BENEFICIARY_CODE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, PRODUCT_CODE, CASH_AMT, INVEST_AMT, SHARES, SHARES_SOLD, UNIT_PRICE, AMORTIZED_AMT, VALORIZED_AMT, VALORIZED_GAIN_AMT, VALORIZED_LOSS_AMT, PREMIUM_AMT, DISCOUNT_AMT, FACE_VALUE, ACCRUED_INT_AMT, FEES_AMT, TAX_AMT, GAIN_AMT, DIVIDEND_AMT, PARTICIPANT_AMT, TOTAL_FUND_AMT, ADJUSTMENT, INV_DIR_DIST_TYPE, INV_NDIR_DIST_TYPE, INT_DIR_DIST_TYPE, INT_NDIR_DIST_TYPE, DISTRIBUTION_TYPE, TMAS_GL_CODE, ACTI_TERM) SELECT ' . singleQuote('AUTO') . ' IDCODE, INTT.IDNAME, INAT.INVEST_ACTIVITY, INAT.POSITION_NUMBER, INAT.INVESTMENT_CODE, INFU.DISCRETIONARY_PORT, INTT.PRIORITY_SEQNUM, INFU.COMP_CODE, INFU.IDCODE PORTFOLIO_CODE, INAT.EFFTDATE, /*ACCOUNTING*/ INAT.FIDU_BANKACT_CODE BANK_ACCOUNT_NO, null CA_GL_CODE, null EQ_GL_CODE, PRAT.AR_GL_CODE, PRAT.TAX_GL_CODE, PRAT.FEE_GL_CODE, PRAT.GAIN_GL_CODE, PRAT.LOSS_GL_CODE, PRAT.INC_GL_CODE, PRAT.PRO_GL_CODE, PRAT.ORDER_GL_CODE, PRAT.ORDER2_GL_CODE, PRAT.DIVIDEND_GL_CODE, PRAT.DIVIDEND2_GL_CODE, PRAT.VALOR_GL_CODE, PRAT.VALOR2_GL_CODE, PRAT.VALOR3_GL_CODE, PRAT.VALOR4_GL_CODE, PRAT.PREMIUM_GL_CODE, PRAT.PYD2P_GL_CODE, PRAT.DISCOUNT_GL_CODE, PRAT.PYD2D_GL_CODE, ' . singleQuote('PEND') . ' CLX_AUTH_STATUS, ' . singleQuote('INAC') . ' JE_SOURCE, 0 CLOSING_ENTRY, 0 REVERSED, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE, INAT.CONTRACT_CODE CHART_FIELD01, INAT.PARTICIPANT_ID CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, INAT.BENEFICIARY_CODE, INFU.CURRENCY_CODE, 1 CUR_OPERATOR, 1.000000 EXCHANGE_RT, INPR.PRODUCT_CODE, IFNULL(SUM(INAT.CASH_AMT),0) CASH_AMT, IFNULL(SUM(INAT.INVEST_AMT),0) INVEST_AMT, IFNULL(SUM(INAT.SHARES),0) SHARES, IFNULL(SUM(INAT.SHARES_SOLD),0) SHARES_SOLD, IFNULL(SUM(INAT.UNIT_PRICE),0) UNIT_PRICE, IFNULL(SUM(INAT.AMORTIZED_AMT),0) AMORTIZED_AMT, IFNULL(SUM(INAT.VALORIZED_AMT),0) VALORIZED_AMT, IFNULL(SUM(INAT.VALORIZED_GAIN_AMT),0) VALORIZED_GAIN_AMT, IFNULL(SUM(INAT.VALORIZED_LOSS_AMT),0) VALORIZED_LOSS_AMT, IFNULL(SUM(INAT.PREMIUM_AMT),0) PREMIUM_AMT, IFNULL(SUM(INAT.DISCOUNT_AMT),0) DISCOUNT_AMT, IFNULL(SUM(INAT.FACE_VALUE),0) FACE_VALUE, IFNULL(SUM(INAT.ACCRUED_INT_AMT),0) ACCRUED_INT_AMT, IFNULL(SUM(INAT.FEES_AMT),0) FEES_AMT, IFNULL(SUM(INAT.TAX_AMT),0) TAX_AMT, IFNULL(SUM(INAT.GAIN_AMT),0) GAIN_AMT, IFNULL(SUM(INAT.DIVIDEND_AMT),0) DIVIDEND_AMT, 0 PARTICIPANT_AMT, 0 TOTAL_FUND_AMT, INTT.IS_REVERSAL ADJUSTMENT, INTT.INV_DIR_DIST_TYPE, INTT.INV_NDIR_DIST_TYPE, INTT.INT_DIR_DIST_TYPE, INTT.INT_NDIR_DIST_TYPE, 0 DISTRIBUTION_TYPE, PRAT.TMAS_GL_CODE, INAT.ACTI_TERM FROM ' . $this->pratname . ' PRAT, ' . $this->inprname . ' INPR, ' . $this->inatname . ' INAT, ' . $this->inttname . ' INTT, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = INAT.PORTFOLIO_CODE  AND PRAT.PRODUCT_CODE = INPR.PRODUCT_CODE AND INTT.IDCODE = INAT.INVEST_ACTIVITY AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND INAT.EFFTDATE = ' . singleQuote($operation_date) . ' AND INFU.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($activity_code <> '') ? ' AND INAT.IDCODE = ' . singleQuote($activity_code) : ' AND INAT.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND INAT.JE_COMPLETED = 0 ') . ' AND INAT.REVERSED = 0 AND INAT.REVACTI_CODE IS NULL AND INTT.PRIORITY_SEQNUM = ' . singleQuote($priority_no) . ' AND INPR.INVESTMENT_CODE = INAT.INVESTMENT_CODE AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE<=INAT.EFFTDATE) GROUP BY INTT.IDNAME, INAT.INVEST_ACTIVITY, INAT.POSITION_NUMBER, INAT.INVESTMENT_CODE, INFU.DISCRETIONARY_PORT, INTT.PRIORITY_SEQNUM, INFU.COMP_CODE, INFU.IDCODE, INAT.EFFTDATE, INAT.FIDU_BANKACT_CODE, PRAT.AR_GL_CODE, PRAT.TAX_GL_CODE, PRAT.FEE_GL_CODE, PRAT.GAIN_GL_CODE, PRAT.LOSS_GL_CODE, PRAT.INC_GL_CODE, PRAT.PRO_GL_CODE, PRAT.ORDER_GL_CODE, PRAT.ORDER2_GL_CODE, PRAT.DIVIDEND_GL_CODE, PRAT.DIVIDEND2_GL_CODE, PRAT.VALOR_GL_CODE, PRAT.VALOR2_GL_CODE, PRAT.VALOR3_GL_CODE, PRAT.VALOR4_GL_CODE, PRAT.PREMIUM_GL_CODE, PRAT.PYD2P_GL_CODE, PRAT.DISCOUNT_GL_CODE, PRAT.PYD2D_GL_CODE, INAT.CONTRACT_CODE, INAT.PARTICIPANT_ID, INFU.CURRENCY_CODE, INPR.PRODUCT_CODE, INTT.IS_REVERSAL, INTT.INV_DIR_DIST_TYPE, INTT.INV_NDIR_DIST_TYPE, INTT.INT_DIR_DIST_TYPE, INTT.INT_NDIR_DIST_TYPE, INAT.BENEFICIARY_CODE, PRAT.TMAS_GL_CODE, INAT.ACTI_TERM ORDER BY INTT.PRIORITY_SEQNUM ASC, INAT.CONTRACT_CODE ASC, INAT.PARTICIPANT_ID ASC';
        ClxCommon::$db->executeQuery($sql);
        /* COLOCANDO CONVERSIONES DE MONEDAS PARA ACTIVIDADES */
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp ();
        $sql = 'SELECT	DISTINCT COMP_CODE, CURRENCY_CODE FROM ' . $this->iat1name . ' TMP WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($result ['COMP_CODE'], $result ['CURRENCY_CODE'], $operation_date);
            $sql = 'UPDATE ' . $this->iat1name . ' SET CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ', EXCHANGE_RT = ' . $rate ['EXCHANGE_RT'] . ', CUR_OPERATOR = ' . singleQuote($rate ['CUR_OPERATOR']) . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        }
        /* ACTUALIZANDO CASOS CON PARTICIPACION = 1 EN CASO DE DIRIGIDOS */
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.PARTICIPANT_AMT=1, TMP.TOTAL_FUND_AMT=1, DISTRIBUTION_TYPE=2 WHERE TMP.CHART_FIELD01 IS NOT null AND TMP.CHART_FIELD02 IS NOT null AND TMP.BATCH_ID=' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* ACTUALIZANDO CUENTA CONTABLE DE EFECTIVO CASH GL_CODE */
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.CA_GL_CODE = (SELECT PRAT.PRO_GL_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK WHERE FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.BANK_ACCOUNT_NO = TMP.BANK_ACCOUNT_NO) WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* Actualizando codigo de subcuenta de inversiones */
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.CHART_FIELD03 = (SELECT MAX(FIAS.IDCODE) FROM ' . $this->fiasname . ' FIAS WHERE FIAS.PORTFOLIO_CODE = TMP.PORTFOLIO_CODE AND FIAS.CONTRACT_CODE = TMP.CHART_FIELD01) WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* ACTUALIZANDO CODIGO DE ACTIVO DE EFECTIVO CASH_ASSET_CODE */
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.CASH_ASSET_CODE = (SELECT MAX(FIAS.IDCODE) FROM ' . $this->fiasname . ' FIAS WHERE FIAS.FIDU_BANKACT_CODE = TMP.BANK_ACCOUNT_NO AND FIAS.CONTRACT_CODE = TMP.CHART_FIELD01 AND FIAS.TRUST_ITEM_TYPE IN (' . singleQuote('CA') . ',' . singleQuote('OT') . ')) WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* UPDATING CA GL CODE */
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.CA_GL_CODE = (SELECT PRAT.PRO_GL_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK WHERE FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.BANK_ACCOUNT_NO = TMP.BANK_ACCOUNT_NO) WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Updating equity gl code
        $sql = 'UPDATE ' . $this->iat1name . ' TMP SET TMP.EQ_GL_CODE = (SELECT MAX(TTPA.EQ_GL_CODE) FROM ' . $this->compname . ' COMP, ' . $this->ttpaname . ' TTPA, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND FICO.CONTRACT_TYPE = TTPA.CONTRACT_TYPE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FICO.IDCODE = TMP.CHART_FIELD01) WHERE TMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->executeQuery('UPDATE ' . $this->iat1name . ' SET CHART_FIELD01 = null WHERE CHART_FIELD01 = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND BATCH_ID=' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('UPDATE ' . $this->iat1name . ' SET CHART_FIELD02 = null WHERE CHART_FIELD02 = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND BATCH_ID=' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('UPDATE ' . $this->iat1name . ' SET CHART_FIELD03 = null WHERE CHART_FIELD03 = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND BATCH_ID=' . singleQuote($batch_id));
        ClxCommon::$db->executeQuery('UPDATE ' . $this->iat1name . ' SET CHART_FIELD04 = null WHERE CHART_FIELD04 = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND BATCH_ID=' . singleQuote($batch_id));
    }

// end method
    /**
     * Procesar operaciones de forma masiva
     * Process steps:
     * 1.
     * Sumarizar actividades de inversion segun instrumento,
     * tipo operacion, contracto y participante
     * 2. Determinar participaciones por actividad sumarizada. Las que posean
     * participantes seran 1 o total fondo entre fondo participante 1/1
     * 3. Generar contabilidad basado en distribucion.
     */
    function inat_build_accounting_batch($comp_code, $operation_date = '', $parameters = array(), $activity_code = '') {
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        $jehd = new Jehd ();
        if ($operation_date === '') {
            if (!class_exists('Comp')) {
                includeCodeLib('COMP');
            }
            $comp = new Comp ();
            $op = $comp->comp_operation_parameters($comp_code);
            $operation_date = $op ['OPERATION_DATE'];
            unset($comp);
        }
        // Determine batch id
        $je_source = 'INAC';
        if ($this->display === true) {
            echoLog(' PROCESSING PORTFOLIO ACTIVITIES. BATCH ID: ' . $this->batch_id);
            echoLog('Efective charge date : ' . $operation_date);
            echoLog('Company: ' . (($comp_code === '') ? 'ALL' : $comp_code));
        }
        // create temporary tables
        $this->init_temporary_tables($this->batch_id);
        /*
         * Construir contabilidad agrupada por prioridad. debe hacer compras
         * para poder hacer ventas posteriormente AND INAT.INVEST_ACTIVITY =
         * 'APINV'
         */
        $sql = 'SELECT DISTINCT INTT.PRIORITY_SEQNUM, ' . (($activity_code <> '') ? ' INTT.IDNAME' : ' ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME') . ' FROM ' . $this->inttname . ' INTT, ' . $this->inatname . ' INAT, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = INAT.PORTFOLIO_CODE AND INTT.IDCODE = INAT.INVEST_ACTIVITY AND INAT.EFFTDATE = ' . singleQuote($operation_date) . ' AND INFU.COMP_CODE = ' . singleQuote($comp_code) . ' AND INAT.REVERSED = 0 ' . (($activity_code <> '') ? ' AND INAT.IDCODE = ' . singleQuote($activity_code) : ' AND INAT.CLX_AUTH_STATUS = ' . singleQuote('AP') . '  AND INAT.JE_COMPLETED = 0 ') . ' AND (INAT.REVACTI_CODE IS NULL OR INAT.REVACTI_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') ORDER BY INTT.PRIORITY_SEQNUM ASC';
        $priorities = ClxCommon::$db->executeQuery($sql);
        while (($priority = ClxCommon::$db->getNextRecord($priorities))) {
            $priority_no = $priority ['PRIORITY_SEQNUM'];
            // Inicializando tablas temporales
            $this->clear_temporary_tables($this->batch_id);
            // Build activities summary and required information like accounts in a single table
            $this->build_activities_summary($this->batch_id, $comp_code, $operation_date, $priority_no, $activity_code);
            /* construyendo lineas de asientos de tabla sumarizada */
            //Si TMP1.ACTI_TERM=1 entonces es t2+t3 y debe contemplar el usar cuenta de reserva en vez de efectivo
            $sql = 'INSERT INTO ' . $this->iat3name . ' (BATCH_ID, ACT_LINE_TYPE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) '
                    . 'SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, INTL.ACT_LINE_TYPE, 
                    (CASE INTL.ACT_LINE_TYPE 
                    WHEN ' . singleQuote('CA') . ' THEN 1
                    WHEN ' . singleQuote('IN') . ' THEN 2
                    WHEN ' . singleQuote('TMAS') . ' THEN 2
                    WHEN ' . singleQuote('AR') . ' THEN 3
                    WHEN ' . singleQuote('ORDER') . ' THEN 4
                    WHEN ' . singleQuote('ORDER2') . ' THEN 5
                    WHEN ' . singleQuote('DIVIDEND') . ' THEN 6
                    WHEN ' . singleQuote('DIVIDEND2') . ' THEN 7
                    WHEN ' . singleQuote('PYD') . ' THEN 8
                    WHEN ' . singleQuote('PYD2') . ' THEN 9
                    WHEN ' . singleQuote('VAL') . ' THEN 10
                    WHEN ' . singleQuote('VAL2') . ' THEN 11
                    WHEN ' . singleQuote('EQ') . ' THEN 12
                    WHEN ' . singleQuote('INC') . ' THEN 13
                    WHEN ' . singleQuote('TAX') . ' THEN 14
                    WHEN ' . singleQuote('FEES') . ' THEN 15
                    WHEN ' . singleQuote('GAIN') . ' THEN 16
                    ELSE 0
                    END) SEQNUM,
                    (CASE INTL.ACT_LINE_TYPE
                    WHEN ' . singleQuote('CA') . ' THEN IF(TMP1.ACTI_TERM=1, TMP1.TMAS_GL_CODE,TMP1.CA_GL_CODE)
                    WHEN ' . singleQuote('EQ') . ' THEN TMP1.EQ_GL_CODE
                    WHEN ' . singleQuote('IN') . ' THEN TMP1.INV_GL_CODE
                    WHEN ' . singleQuote('TMAS') . ' THEN TMP1.TMAS_GL_CODE
                    WHEN ' . singleQuote('AR') . ' THEN TMP1.AR_GL_CODE
                    WHEN ' . singleQuote('INC') . ' THEN TMP1.INC_GL_CODE
                    WHEN ' . singleQuote('TAX') . ' THEN TMP1.TAX_GL_CODE
                    WHEN ' . singleQuote('FEES') . ' THEN TMP1.FEE_GL_CODE
                    WHEN ' . singleQuote('GAIN') . ' THEN IF(TMP1.GAIN_AMT>=0, TMP1.GAIN_GL_CODE,TMP1.LOSS_GL_CODE)
                    WHEN ' . singleQuote('ORDER') . ' THEN TMP1.ORDER_GL_CODE
                    WHEN ' . singleQuote('ORDER2') . ' THEN TMP1.ORDER2_GL_CODE
                    WHEN ' . singleQuote('DIVIDEND') . ' THEN TMP1.DIVIDEND_GL_CODE
                    WHEN ' . singleQuote('DIVIDEND2') . ' THEN TMP1.DIVIDEND2_GL_CODE
                    WHEN ' . singleQuote('PYD') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.PREMIUM_GL_CODE
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.DISCOUNT_GL_CODE
                                  WHEN ' . singleQuote('RD') . ' THEN IF((TMP1.AMORTIZED_AMT)>0, TMP1.PREMIUM_GL_CODE, TMP1.DISCOUNT_GL_CODE)
                                  WHEN ' . singleQuote('VE') . ' THEN IF((TMP1.AMORTIZED_AMT)>0, TMP1.PREMIUM_GL_CODE, TMP1.DISCOUNT_GL_CODE)
                                  ELSE IF((TMP1.INVEST_AMT-TMP1.FACE_VALUE)>0, TMP1.PREMIUM_GL_CODE, TMP1.DISCOUNT_GL_CODE)
                          END
                    WHEN ' . singleQuote('PYD2') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.PYD2P_GL_CODE
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.PYD2D_GL_CODE
                                  WHEN ' . singleQuote('RD') . ' THEN IF((TMP1.AMORTIZED_AMT)>0, TMP1.PYD2P_GL_CODE, TMP1.PYD2D_GL_CODE)
                                  WHEN ' . singleQuote('VE') . ' THEN IF((TMP1.AMORTIZED_AMT)>0, TMP1.PYD2P_GL_CODE, TMP1.PYD2D_GL_CODE)
                                  ELSE IF((TMP1.INVEST_AMT-TMP1.FACE_VALUE)>0, TMP1.PYD2P_GL_CODE, TMP1.PYD2D_GL_CODE)
                          END
                    WHEN ' . singleQuote('VAL') . ' THEN IF(TMP1.VALORIZED_AMT>0, TMP1.VALOR_GL_CODE,TMP1.VALOR3_GL_CODE)
                    WHEN ' . singleQuote('VAL2') . ' THEN IF(TMP1.VALORIZED_AMT>0, TMP1.VALOR2_GL_CODE,TMP1.VALOR4_GL_CODE)
                    END) GLACCOUNTCODE,
                    TMP1.CHART_FIELD01,
                    TMP1.CHART_FIELD02,
                    (CASE INTL.ACT_LINE_TYPE
                    WHEN ' . singleQuote('CA') . ' THEN IF(TMP1.ACTI_TERM=1, TMP1.CHART_FIELD03,TMP1.CASH_ASSET_CODE)
                    WHEN ' . singleQuote('IN') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('TMAS') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('AR') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('ORDER') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('ORDER2') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('DIVIDEND') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('DIVIDEND2') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('PYD') . ' THEN TMP1.CHART_FIELD03
                    WHEN ' . singleQuote('VAL') . ' THEN TMP1.CHART_FIELD03
                    ELSE NULL
                    END) CHART_FIELD03,
                    TMP1.CHART_FIELD04,
                    ' . singleQuote('INVE') . ' ITEM_CODE,
                    TMP1.POSITION_NUMBER ITEM_REF_NO,
                    TMP1.CURRENCY_CODE,
                    TMP1.EXCHANGE_RT,
                    TMP1.CUR_OPERATOR,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 1 ELSE 0 END)*
                    (CASE INTL.ACT_LINE_TYPE
                    WHEN ' . singleQuote('CA') . ' THEN 
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('RD') . ' THEN IF (TMP1.GAIN_AMT<>0, (TMP1.CASH_AMT+TMP1.GAIN_AMT), TMP1.CASH_AMT)
                                  ELSE TMP1.CASH_AMT
                          END
                    /*0 TMP1.CASH_AMT*/
                    WHEN ' . singleQuote('TMAS') . ' THEN TMP1.CASH_AMT
                    WHEN ' . singleQuote('EQ') . ' THEN IF(TMP1.CASH_AMT<>0, TMP1.CASH_AMT, IF(TMP1.FACE_VALUE=0, TMP1.INVEST_AMT, TMP1.FACE_VALUE))
                    WHEN ' . singleQuote('IN') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('RD') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('SL') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('CA') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('VE') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  ELSE IF(TMP1.FACE_VALUE=0, TMP1.INVEST_AMT, TMP1.FACE_VALUE)
                          END
                    WHEN ' . singleQuote('AR') . ' THEN TMP1.ACCRUED_INT_AMT
                    WHEN ' . singleQuote('INC') . ' THEN (TMP1.ACCRUED_INT_AMT+TMP1.AMORTIZED_AMT+TMP1.DIVIDEND_AMT)
                    WHEN ' . singleQuote('TAX') . ' THEN TMP1.TAX_AMT
                    WHEN ' . singleQuote('FEES') . ' THEN TMP1.FEES_AMT
                    WHEN ' . singleQuote('GAIN') . ' THEN TMP1.GAIN_AMT
                    WHEN ' . singleQuote('ORDER') . ' THEN TMP1.INVEST_AMT
                    WHEN ' . singleQuote('ORDER2') . ' THEN TMP1.INVEST_AMT
                    WHEN ' . singleQuote('DIVIDEND') . ' THEN TMP1.DIVIDEND_AMT
                    WHEN ' . singleQuote('DIVIDEND2') . ' THEN TMP1.DIVIDEND_AMT
                    WHEN ' . singleQuote('PYD') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('RD') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('SL') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('CA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('VE') . ' THEN TMP1.AMORTIZED_AMT
                                  ELSE IF(TMP1.FACE_VALUE = 0, 0,(TMP1.INVEST_AMT-TMP1.FACE_VALUE))
                          END
                    WHEN ' . singleQuote('PYD2') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('RD') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('SL') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('CA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('VE') . ' THEN TMP1.AMORTIZED_AMT
                                  ELSE IF(TMP1.FACE_VALUE = 0, 0,(TMP1.INVEST_AMT-TMP1.FACE_VALUE))
                          END
                    WHEN ' . singleQuote('VAL') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('SL') . ' THEN 0
                                  WHEN ' . singleQuote('CA') . ' THEN 0
                                  WHEN ' . singleQuote('VE') . ' THEN 0
                                  WHEN ' . singleQuote('RD') . ' THEN 0
                                  ELSE TMP1.VALORIZED_AMT
                          END
                    WHEN ' . singleQuote('VAL2') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('SL') . ' THEN 0
                                  WHEN ' . singleQuote('CA') . ' THEN 0
                                  WHEN ' . singleQuote('VE') . ' THEN 0
                                  WHEN ' . singleQuote('RD') . ' THEN 0
                                  ELSE TMP1.VALORIZED_AMT
                          END
                    END)) DEBIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR') . ' THEN 1 ELSE 0 END)*
                    (CASE INTL.ACT_LINE_TYPE
                    WHEN ' . singleQuote('CA') . ' THEN TMP1.CASH_AMT
                    WHEN ' . singleQuote('TMAS') . ' THEN TMP1.CASH_AMT
                    WHEN ' . singleQuote('EQ') . ' THEN IF(TMP1.CASH_AMT<>0, TMP1.CASH_AMT, IF(TMP1.FACE_VALUE=0, TMP1.INVEST_AMT, TMP1.FACE_VALUE))
                    WHEN ' . singleQuote('IN') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('RD') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('SL') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('CA') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  WHEN ' . singleQuote('VE') . ' THEN IF(TMP1.FACE_VALUE=0, (TMP1.INVEST_AMT-TMP1.GAIN_AMT), TMP1.FACE_VALUE)
                                  ELSE IF(TMP1.FACE_VALUE=0, TMP1.INVEST_AMT, TMP1.FACE_VALUE)
                          END
                    WHEN ' . singleQuote('AR') . ' THEN TMP1.ACCRUED_INT_AMT
                    WHEN ' . singleQuote('INC') . ' THEN (TMP1.ACCRUED_INT_AMT + TMP1.AMORTIZED_AMT + TMP1.DIVIDEND_AMT)
                    WHEN ' . singleQuote('TAX') . ' THEN TMP1.TAX_AMT
                    WHEN ' . singleQuote('FEES') . ' THEN TMP1.FEES_AMT
                    WHEN ' . singleQuote('GAIN') . ' THEN (TMP1.GAIN_AMT/*+TMP1.VALORIZED_GAIN_AMT*/)
                    WHEN ' . singleQuote('ORDER') . ' THEN TMP1.INVEST_AMT
                    WHEN ' . singleQuote('ORDER2') . ' THEN TMP1.INVEST_AMT
                    WHEN ' . singleQuote('DIVIDEND') . ' THEN TMP1.DIVIDEND_AMT
                    WHEN ' . singleQuote('DIVIDEND2') . ' THEN TMP1.DIVIDEND_AMT
                    WHEN ' . singleQuote('PYD') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('RD') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('SL') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('CA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('VE') . ' THEN TMP1.AMORTIZED_AMT
                                  ELSE IF(TMP1.FACE_VALUE = 0, 0,(TMP1.INVEST_AMT-TMP1.FACE_VALUE))
                          END
                    WHEN ' . singleQuote('PYD2') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('PA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('DA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('RD') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('SL') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('CA') . ' THEN TMP1.AMORTIZED_AMT
                                  WHEN ' . singleQuote('VE') . ' THEN TMP1.AMORTIZED_AMT
                                  ELSE IF(TMP1.FACE_VALUE = 0, 0,(TMP1.INVEST_AMT-TMP1.FACE_VALUE))
                          END
                    WHEN ' . singleQuote('VAL') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('SL') . ' THEN 0
                                  WHEN ' . singleQuote('CA') . ' THEN 0
                                  WHEN ' . singleQuote('VE') . ' THEN 0
                                  WHEN ' . singleQuote('RD') . ' THEN 0
                                  ELSE TMP1.VALORIZED_AMT
                          END
                    WHEN ' . singleQuote('VAL2') . ' THEN
                          CASE INTL.INVEST_ACTIVITY
                                  WHEN ' . singleQuote('SL') . ' THEN 0
                                  WHEN ' . singleQuote('CA') . ' THEN 0
                                  WHEN ' . singleQuote('VE') . ' THEN 0
                                  WHEN ' . singleQuote('RD') . ' THEN 0
                                  ELSE TMP1.VALORIZED_AMT
                          END
                    END)) CREDIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 1 ELSE 0 END)*(CASE INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) DEBIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR') . ' THEN 1 ELSE 0 END)*(CASE INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) CREDIT_TRANS_AMT,
                    0 RECONCILIED
                    FROM
                    ' . $this->iat1name . ' TMP1,
                    ' . $this->intlname . ' INTL
                    WHERE
                    INTL.INVEST_ACTIVITY = TMP1.INVEST_ACTIVITY
                    AND TMP1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);

            /*$sql = 'SELECT * FROM ' . $this->iat1name;
            $regs = ClxCommon::$db->executeQuery($sql);
            while (($reg = ClxCommon::$db->getNextRecord($regs))) {
                //pre($reg);
            }

            //echo('##########################################################################');

            $sql = 'SELECT * FROM ' . $this->iat3name;
            $regs = ClxCommon::$db->executeQuery($sql);
            while (($reg = ClxCommon::$db->getNextRecord($regs))) {
                //pre($reg);
            }

            //echo('##########################################################################');
            $sql = 'SELECT * FROM ' . $this->intlname;
            $regs = ClxCommon::$db->executeQuery($sql);
            while (($reg = ClxCommon::$db->getNextRecord($regs))) {
                //pre($reg);
            }*/

            //Eliminando cuentas de ganancia por valorizacion en cancelacion Colocando monto en cuentas ya que este monto de valorizacion debe descargar todas las cuentas que esten incluidas VALORIZED_GAIN_AMT
            $sql = 'INSERT INTO ' . $this->iat3name . ' (BATCH_ID, ACT_LINE_TYPE,SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT,RECONCILIED)
                    SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, INTL.ACT_LINE_TYPE,
                     (CASE INTL.ACT_LINE_TYPE
                            WHEN ' . singleQuote('VAL') . ' THEN 10
                            WHEN ' . singleQuote('VAL2') . ' THEN 11
                            ELSE 0
                            END) SEQNUM,
                    (CASE INTL.ACT_LINE_TYPE
                            WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALOR_GL_CODE
                            WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALOR2_GL_CODE
                            END) GLACCOUNTCODE,
                    TMP1.CHART_FIELD01,
                    TMP1.CHART_FIELD02,
                            (CASE INTL.ACT_LINE_TYPE
                            WHEN ' . singleQuote('VAL') . ' THEN TMP1.CHART_FIELD03
                            ELSE NULL
                            END) CHART_FIELD03,
                    TMP1.CHART_FIELD04,
                    ' . singleQuote('INVE') . ' ITEM_CODE,
                    TMP1.POSITION_NUMBER ITEM_REF_NO,
                    TMP1.CURRENCY_CODE,
                    TMP1.EXCHANGE_RT,
                    TMP1.CUR_OPERATOR,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 1 ELSE 0 END)*
                    (CASE INTL.ACT_LINE_TYPE
                            WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALORIZED_GAIN_AMT
                            WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALORIZED_GAIN_AMT
                            END)) DEBIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR') . ' THEN 1 ELSE 0 END)*
                    (CASE INTL.ACT_LINE_TYPE
                            WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALORIZED_GAIN_AMT
                            WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALORIZED_GAIN_AMT
                            END)) CREDIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 1 ELSE 0 END)*(CASE INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) DEBIT_TRANS_AMT,
                    ((CASE INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR') . ' THEN 1 ELSE 0 END)*(CASE INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) CREDIT_TRANS_AMT,
                    0 RECONCILIED
                    FROM
                    ' . $this->iat1name . ' TMP1,
                    ' . $this->intlname . ' INTL
                    WHERE
                    INTL.INVEST_ACTIVITY = TMP1.INVEST_ACTIVITY
                    AND INTL.INVEST_ACTIVITY IN (' . singleQuote('SL') . ',' . singleQuote('CA') . ',' . singleQuote('VE') . ',' . singleQuote('RD') . ')
                    AND INTL.ACT_LINE_TYPE IN (' . singleQuote('VAL') . ',' . singleQuote('VAL2') . ')
                    AND TMP1.VALORIZED_GAIN_AMT <> 0
                    AND TMP1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);

            //VALORIZED_LOSS_AMT
            $sql = 'INSERT INTO ' . $this->iat3name . ' (BATCH_ID, ACT_LINE_TYPE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) '
                    . 'SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, INTL.ACT_LINE_TYPE, '
                    . '(case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('VAL') . ' THEN 10 WHEN ' . singleQuote('VAL2') . ' THEN 11 ELSE 0 END) SEQNUM, '
                    . '(case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALOR4_GL_CODE WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALOR3_GL_CODE END) GLACCOUNTCODE, '
                    . 'TMP1.CHART_FIELD01, TMP1.CHART_FIELD02, '
                    . '(case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('VAL') . ' THEN null ELSE TMP1.CHART_FIELD03 END) CHART_FIELD03, '
                    . 'TMP1.CHART_FIELD04, ' . singleQuote('INVE') . ' ITEM_CODE, TMP1.POSITION_NUMBER ITEM_REF_NO, TMP1.CURRENCY_CODE,'
                    . 'TMP1.EXCHANGE_RT, TMP1.CUR_OPERATOR,'
                    . ' ((case INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 0 ELSE 1 END)* (case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALORIZED_LOSS_AMT WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALORIZED_LOSS_AMT END)) DEBIT_TRANS_AMT,'
                    . ' ((case INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR') . ' THEN 0 ELSE 1 END)* (case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('VAL') . ' THEN TMP1.VALORIZED_LOSS_AMT WHEN ' . singleQuote('VAL2') . ' THEN TMP1.VALORIZED_LOSS_AMT END)) CREDIT_TRANS_AMT, '
                    . '((case INTL.DEBIT_CREDIT WHEN ' . singleQuote('DR') . ' THEN 0 ELSE 1 END)*(case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) DEBIT_TRANS_AMT, '
                    . '((case INTL.DEBIT_CREDIT WHEN ' . singleQuote('CR'). ' THEN 0 ELSE 1 END)*(case INTL.ACT_LINE_TYPE WHEN ' . singleQuote('CA') . ' THEN TMP1.PART_CASH_AMT ELSE 0 END)) CREDIT_TRANS_AMT, '
                    . '0 RECONCILIED '
                    . 'FROM ' . $this->iat1name . ' TMP1, ' . $this->intlname . ' INTL '
                    . 'WHERE INTL.INVEST_ACTIVITY = TMP1.INVEST_ACTIVITY '
                    . 'AND INTL.INVEST_ACTIVITY IN (' . singleQuoteArray(array('SL', 'CA', 'VE', 'RD')) . ') '
                    . 'AND INTL.ACT_LINE_TYPE IN (' . singleQuoteArray(array('VAL', 'VAL2')) . ') '
                    . 'AND TMP1.VALORIZED_LOSS_AMT <> 0 AND TMP1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Si es venta o cancelacion el monto
            $sql = 'UPDATE ' . $this->iat3name . ' SET CREDIT_TRANS_AMT = -1*DEBIT_TRANS_AMT, DEBIT_TRANS_AMT = 0 WHERE DEBIT_TRANS_AMT<0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->iat3name . ' SET DEBIT_TRANS_AMT = -1*CREDIT_TRANS_AMT, CREDIT_TRANS_AMT = 0 WHERE CREDIT_TRANS_AMT<0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->iat3name . ' SET DEBIT_AMT = ROUND((DEBIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2), CREDIT_AMT = ROUND((CREDIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DELETE FROM ' . $this->iat3name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_TRANS_AMT = 0 AND CREDIT_TRANS_AMT=0';
            ClxCommon::$db->executeQuery($sql);
            // test if something to account if not return
            $sql = 'SELECT COUNT(*) FROM ' . $this->iat3name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                continue;
            }
            if ($activity_code <> '') {
                $inat_dates = ClxCommon::$db->getFields($this->inatname, 'EFFTDATE,REAL_DATE', 'IDCODE = ' . singleQuote($activity_code));
                $jehdr_code = ClxCommon::$db->getField($this->jehdname, 'IDCODE', 'INAT_CODE = ' . singleQuote($activity_code));
                if (empty($jehdr_code)) {
                    $jehdrec = array('IDCODE' => 'AUTO', 'IDNAME' => $priority['IDNAME'], 'COMP_CODE' => $comp_code, 'INAT_CODE' => $activity_code, 'REAL_DATE' => $inat_dates['REAL_DATE'], 'EFFTDATE' => $inat_dates['EFFTDATE'], 'CLX_AUTH_STATUS' => 'PEND', 'JE_SOURCE' => $je_source, 'CLOSING_ENTRY' => CLX_NUM_ZERO, 'REVERSED' => CLX_NUM_ZERO, 'ADJUSTMENT' => CLX_NUM_ZERO, 'BATCH_ID' => $this->batch_id, 'CREATEDBY' => $this->username, 'MODIFIEDBY' => $this->username, 'CDATE' => $this->now, 'MDATE' => $this->now);
                    $jehd->jehd_build($jehdrec);
                    $jehdr_code = $jehdrec ['IDCODE'];
                } else {
                    $jehdrec = array('COMP_CODE' => $comp_code, 'REAL_DATE' => $inat_dates['REAL_DATE'], 'EFFTDATE' => $inat_dates['EFFTDATE'], 'MODIFIEDBY' => $this->username, 'MDATE' => $this->now);
                    ClxCommon::$db->updateRecord($this->jehdname, $jehdrec, 'IDCODE = ' . singleQuote($jehdr_code));
                }
            } else {
                $jehdrec = array('IDCODE' => 'AUTO', 'IDNAME' => substr(dict('GEN_LBL_INV_OPERATIONS') . ' ' . dict('GEN_LBL_PRIORITY') . ' ' . $priority_no, CLX_NUM_ZERO, CLX_NUM_60), 'COMP_CODE' => $comp_code, 'EFFTDATE' => $operation_date, 'CLX_AUTH_STATUS' => 'PEND', 'JE_SOURCE' => $je_source, 'CLOSING_ENTRY' => CLX_NUM_ZERO, 'REVERSED' => CLX_NUM_ZERO, 'ADJUSTMENT' => CLX_NUM_ZERO, 'BATCH_ID' => $this->batch_id, 'CREATEDBY' => $this->username, 'MODIFIEDBY' => $this->username, 'CDATE' => $this->now, 'MDATE' => $this->now);
                $jehd->jehd_build($jehdrec);
                $jehdr_code = $jehdrec ['IDCODE'];
            }
            //Clear journal
            ClxCommon::$db->deleteRecords($this->jelnname, 'JEHDR_CODE = ' . singleQuote($jehdr_code));
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, TMP.SEQNUM, TMP.GLACCOUNTCODE, TMP.CHART_FIELD01, TMP.CHART_FIELD02, TMP.CHART_FIELD03, TMP.CHART_FIELD04, TMP.ITEM_CODE, TMP.ITEM_REF_NO, TMP.CURRENCY_CODE, TMP.EXCHANGE_RT, TMP.CUR_OPERATOR, TMP.DEBIT_TRANS_AMT, TMP.CREDIT_TRANS_AMT, TMP.DEBIT_AMT, TMP.CREDIT_AMT, TMP.RECONCILIED FROM ' . $this->iat3name . ' TMP WHERE TMP.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($jehdr_code);
            $this->clear_temporary_tables($this->batch_id);
        } // END LOOP PRIORYTY
        $this->clear_temporary_tables($this->batch_id);
    }

    /**
     * Runs tmas operations from previous operations
     * @param unknown_type $comp_code
     */
    function inat_build_accounting_tmas($comp_code) {
        //este metodo resuelve la segunda operacione de t1/t2/t3.
        //El proceso es 1: se aprueba t2 como actividad BTY. 2: se copia BTY a BY al siguiente dia
        //y se trata de aprobar.
        //este proceso corre en el cierre despues de que cambia la fecha contable
        //Opciones comunes a copias de actividades
        $options = array('INVEST_ACTIVITY' => 'BY', 'CLX_AUTH_STATUS' => 'PEND', 'ACTI_TERM' => CLX_NUM_ONE);
        //buscando actividades de compra para actividades tmas que debe generar compra si no existe.
        $sql = 'SELECT INAT.IDCODE, GLCP.OPERATION_DATE FROM ' . $this->inatname . ' INAT, ' . $this->glcpname . ' GLCP WHERE INAT.INVEST_ACTIVITY = ' . singleQuote('BYT') . ' AND INAT.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND INAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLCP.COMP_CODE = INAT.COMP_CODE AND INAT.EFFTDATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL -1 DAY) AND NOT EXISTS (SELECT INATX.ID FROM ' . $this->inatname . ' INATX WHERE INATX.POSITION_NUMBER = INAT.POSITION_NUMBER AND INATX.INVEST_ACTIVITY = ' . singleQuote('BY') . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //setting dates for new activity
            $options['EFFTDATE'] = $r['OPERATION_DATE'];
            $options['REAL_DATE'] = $r['OPERATION_DATE'];
            //Creando actividad de compra y contabilidad
            ClxFreeReturn($this->inat_copy_activity($r['IDCODE'], $options));
        }
    }

    private function inat_copy_activity($idcode_src, $new_options) {
        $sql = 'SELECT INAT.* FROM ' . $this->inatname . ' INAT, ' . $this->glcpname . ' GLCP WHERE INAT.COMP_CODE = GLCP.COMP_CODE AND INAT.IDCODE = ' . singleQuote($idcode_src);
        $record = ClxCommon::$db->getOneRecord($sql);
        if (empty($record))
            return false;
        if (!empty($new_options)) {
            $record = array_merge($record, $new_options);
        }
        unset($record['ID'], $record['REVACTI_CODE']);
        $record['REVERSED'] = CLX_INIT_ZERO;
        $record['IDCODE'] = 'AUTO';
        ClxFreeReturn($this->inat_build($record));

        //Building Accounting
        $this->inat_build_accounting_batch($record ['COMP_CODE'], $record ['EFFTDATE'], null, $record['IDCODE']);
        return $record['IDCODE'];
    }

    // Others Methods
    /**
     * Return cash amount required for transation
     *
     * @param string $inatcode
     * @return double
     */
    function inat_cash_amount($inatcode, $invest_amt = CLX_NUM_ZERO, $accrued_int = CLX_NUM_ZERO) {
        $trans_amt = rounder(bcadd($invest_amt, $accrued_int), CLX_NUM_TWO);
        switch (kDatabaseType) {
            case 'oci' :
                $sql = 'SELECT SUM((TO_CHAR(case INTL.DEBIT_CREDIT) WHEN ' . "'CR'" . ' THEN -1 WHEN ' . "'DR'" . ' THEN 1 ELSE 0 END) *  (' . $trans_amt . ')) INVEST_AMT FROM ' . $this->inatname . ' INAT, ' . $this->intlname . ' INTL, ' . $this->glcpname . ' GLCP, ' . $this->infuname . ' INFU WHERE INAT.INVEST_ACTIVITY = INTL.INVEST_ACTIVITY AND INFU.IDCODE = INAT.PORTFOLIO_CODE AND INTL.ACT_LINE_TYPE =' . singleQuote('CA') . ' AND GLCP.COMP_CODE = INFU.COMP_CODE AND INAT.EFFTDATE = GLCP.OPERATION_DATE AND INAT.IDCODE = ' . singleQuote($inatcode);
                break;
            default :
                $sql = 'SELECT SUM((case INTL.DEBIT_CREDIT WHEN ' . "'CR'" . ' THEN -1 WHEN ' . "'DR'" . ' THEN 1 ELSE 0 END) *  (' . $trans_amt . ')) INVEST_AMT FROM ' . $this->inatname . ' INAT, ' . $this->intlname . ' INTL, ' . $this->glcpname . ' GLCP, ' . $this->infuname . ' INFU WHERE INAT.INVEST_ACTIVITY = INTL.INVEST_ACTIVITY AND INFU.IDCODE = INAT.PORTFOLIO_CODE AND INTL.ACT_LINE_TYPE =' . singleQuote('CA') . ' AND GLCP.COMP_CODE = INFU.COMP_CODE AND INAT.EFFTDATE = GLCP.OPERATION_DATE AND INAT.IDCODE = ' . singleQuote($inatcode);
        }
        return ClxCommon::$db->getOne($sql);
    }

    /**
     * Executes accounting generatin in cases where accounting is not generated inmediatly
     */
    function inat_build_accounting_button() {
        $idlist = getIdlist();
        $sql = 'SELECT DISTINCT INFU.COMP_CODE, GLCP.OPERATION_DATE FROM ' . $this->infuname . ' INFU, ' . $this->glcpname . ' GLCP WHERE INFU.COMP_CODE = GLCP.COMP_CODE AND INFU.ID IN (' . toString($idlist) . ')';
        $r = ClxCommon::$db->getOneRecord($sql);
        if (!empty($r)) {
            $this->inat_build_accounting_batch($r ['COMP_CODE'], $r ['OPERATION_DATE'], array());
        }
    }

// end method
    /**
     * Returns inpr record
     * @param string $investment_code
     * @param string $efftdate
     * @return Array
     */
    private function get_inpr_record($investment_code, $efftdate = '') {
        if ($efftdate === '')
            $efftdate = $this->now;
        $sql = 'SELECT INPR.* FROM ' . $this->inprname . ' INPR WHERE INPR.INVESTMENT_CODE = ' . singleQuote($investment_code) . ' AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE<=' . singleQuote($efftdate) . ')';
        return ClxCommon::$db->getOneRecord($sql);
    }

}
