<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-11-20 09:25:25 -0500 (Fri, 20 Nov 2015) $
 * @version        $Rev: 7526 $
 *
 * CHANGE LOG
 *  File loaded
 */
class Incl {

    var $mail_template_code = '';
    var $from_mail = '';
    var $oper_status = 'Liquidada';
    var $path_replace_active = '';
    var $path_replace_search = '';
    var $path_replace = '';
    var $test_email = '';
    var $error_msgs = array();
    var $schedule_code = '';
    var $mesa_in = '1';

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('INCL', 'INCF', 'ACCO'));
        $this->schedule_code = (!empty($procParameters['SCHEDULECODE'])) ? $procParameters['SCHEDULECODE'] : '';
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        if (!empty($procParameters['LA_OPR_STATUS']))
            $this->oper_status = $procParameters['LA_OPR_STATUS'];
        if (!empty($procParameters['LA_MESIN']))
            $this->mesa_in = $procParameters['LA_MESIN'];
        //some parameters
        $this->test_email = companyParameter('INBK_INCF_TEST_EMAIL_TO');
        $this->mail_template_code = companyParameter('INBK_CONF_TEMPLATE');
        $this->from_mail = companyParameter('INBK_CONF_FROM_EMAIL');
        $this->cc_mail = companyParameter('INBK_CONF_CC_EMAIL');
        $this->path_replace_active = companyParameter('INBK_INCF_RENAME_ACTIVE');
        $this->path_replace_search = companyParameter('INBK_INCF_RENAME_PATH_FROM');
        $this->path_replace = companyParameter('INBK_INCF_RENAME_PATH_TO');
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->error_msgs[CLX_NUM_ZERO] = dict('GEN_ERR_EXPECTING_EMAIL');
        $this->error_msgs[CLX_NUM_ONE] = dict('GEN_ERR_EVENTMAILFAIL');
        $this->error_msgs[CLX_NUM_TWO] = dict('GEN_LBL_FROM');
        $this->error_msgs[CLX_NUM_THREE] = dict('GEN_LBL_TO');
        $this->error_msgs[CLX_NUM_FOUR] = dict('GEN_LBL_MISSINGDOCS');
    }

    function sendNotificationUntilDate($efftdate) {
        $efftdate = xFormat::date($efftdate, 'Y-m-d');
        $date = explode('-', $efftdate);
        if (empty($date[CLX_NUM_TWO]) || !checkdate($date[CLX_NUM_ONE], $date[CLX_NUM_TWO], $date[CLX_NUM_ZERO])) {
            echoLog('Invalid date/Fecha invalida: ' . $efftdate);
            return false;
        }
        $sql = 'SELECT MAX(EFFTDATE) FROM ' . $this->inclname . ' WHERE EFFTDATE <=' . singleQuote($efftdate);
        $last_date = ClxCommon::$db->getOne($sql);
        if (empty($last_date)) {
            echoLog('Single date process, no previous founded/Fecha individual, no se encontraron registros previos: ' . $efftdate);
            ClxFreeReturn($this->sendNofitications($efftdate));
        } else {
            $i = CLX_INIT_ZERO;
            echoLog('Last date processed/Ultima fecha procesada: ' . $last_date);
            while (true) {
                $last_date = adodb_next_day($last_date);
                $i++;
                if ($i > CLX_NUM_30) {
                    echoLog('Only allowed up to 30 days per run/Limite de 30 dias por ejecucion, correr de nuevo el proceso.');
                } elseif ($last_date <= $efftdate) {
                    echoLog('Next date to process/Proxima fecha a ejecutar: ' . $last_date);
                    ClxFreeReturn($this->sendNofitications($efftdate));
                } else {
                    break;
                }
            }
        }//end if last date
    }

    /**
     * Sends notification by date. To be executed by cron. and process INCL01
     *
     * @param unknown_type $efftdate
     * @return unknown
     */
    function sendNofitications($efftdate) {
        $contenidoHTML = '';
        $efftdate = xFormat::date($efftdate, 'Y-m-d');
        $date = explode('-', $efftdate);
        if (empty($date[CLX_NUM_TWO]) || !checkdate($date[CLX_NUM_ONE], $date[CLX_NUM_TWO], $date[CLX_NUM_ZERO])) {
            echoLog('Invalid date: ' . $efftdate);
            return false;
        }
        unset($date);
        echoLog(dict('GEN_LBL_DATE') . ': ' . $efftdate . ',Mesa:' . $this->mesa_in . ', Oper:' . $this->oper_status);
        /*
          1 Conectar a servicio para descargar todas las notificaciones
          de no tener fecha se enviara el dia actual ya que el proceso se hara de forma diaria 2 Generar registro de notificacion por fecha y cliente(identificacion)
          basado en notificaciones recividas
          3 Por cada identificacion localizar informacion de cuenta, de no
          existir, cuenta en crm importar informacion de cliente. Para completar email. 4 Martar como error aquellos casos donde no se pudo encontrar el email 5 Por cada notificacion construir email adjuntando la informaci�n de
          notificaciones y enviar.
          6. Marcar como completado o error de no poder ser enviado. */
        //Step 1 get todays notification.
        $parameters = array('status' => CLX_NUM_ZERO,
            'mensaje' => '',
            'fechin' => $efftdate,
            'valorcierre' => '',
            'actpas' => CLX_NUM_ZERO,
            'mesin' => $this->mesa_in, 'veh' => '',
            'rifi' => '',
            'mrkt' => '9', //all markets
            'cadxml' => '');
        getService('LA_CONFIR', $parameters); //activos
        $parameters = array('status' => CLX_NUM_ZERO,
            'mensaje' => '',
            'fechin' => $efftdate,
            'valorcierre' => '',
            'actpas' => CLX_NUM_ONE,
            'mesin' => $this->mesa_in, 'veh' => '',
            'rifi' => '',
            'mrkt' => '9', //all markets
            'cadxml' => '');
        getService('LA_CONFIR', $parameters); //pasivos
        //2.Step 2 Generar registro de notificaciones por dia
        $sql = 'INSERT INTO ' . $this->inclname . ' (IDENTIFICATION, EFFTDATE, ACCOUNTCODE, EMAIL, EMAIL_STATUS, BATCH_PID) SELECT DISTINCT INCF.IDENTIFICATION, INCF.EFFTDATE, ACCO.IDCODE ACCOUNTCODE, ACCO.EMAIL, ' . singleQuote('PEND') . ' EMAIL_STATUS, ' . singleQuote($this->batch_id) . ' BATCH_PID FROM ' . $this->incfname . ' INCF LEFT JOIN ' . $this->acconame . ' ACCO ON ACCO.IDENTIFICATION = INCF.IDENTIFICATION WHERE INCF.LA_OPR_STATUS = ' . singleQuote($this->oper_status) . ' AND INCF.EFFTDATE = ' . singleQuote($efftdate) . ' AND NOT EXISTS(SELECT X.ID FROM ' . $this->inclname . ' X WHERE X.IDENTIFICATION = INCF.IDENTIFICATION AND X.EFFTDATE = INCF.EFFTDATE)';
        ClxCommon::$db->executeQuery($sql);
        //3. Localizar information para los que no tienen email
        $sql = 'SELECT ID, IDENTIFICATION FROM ' . $this->inclname . ' WHERE EFFTDATE = ' . singleQuote($efftdate) . ' AND (EMAIL IS NULL OR EMAIL = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->sendNotificationBuildContact($r[CLX_NUM_ONE], $r[CLX_NUM_ZERO]);
        }
        //5. Construccion del email.
        $this->sendNotificationMail($efftdate);
        if ($this->schedule_code <> '') {
            $PRSP = getTool('PRSP');
            $sql = 'UPDATE ' . $PRSP->tablename . ' SET PARAMETER_VALUE = ' . singleQuote($adodb_next_day($efftdate)) . ' WHERE SCHEDULECODE = ' . singleQuote($this->schedule_code) . ' AND FIELDNAME = ' . singleQuote($EFFTDATE);
            ClxCommon::$db->executeQuery($sql);
            $contenidoHTML.= '<br>' . CLX_CHAR_NL . CLX_CHAR_CR . 'Setting next date to:' . adodb_next_day($efftdate);
        }
        echo $contenidoHTML;
    }

    /**
     * Searches account information for mail delivery
     *
     * @param String $identification
     * @param Integer $notificationId
     */
    function sendNotificationBuildContact($identification, $notificationId) {
        if (empty($notificationId))
            return;
        $sql = 'SELECT IDCODE, EMAIL FROM ' . $this->acconame . ' WHERE IDENTIFICATION = ' . singleQuote($identification);
        $accorec = ClxCommon::$db->getOneRecord($sql);
        if (!empty($accorec['IDCODE']) && !empty($accorec['EMAIL'])) {
            $sql = 'UPDATE ' . $this->inclname . ' SET EMAIL = ' . singleQuote($accorec['EMAIL']) . ', ACCOUNTCODE = ' . singleQuote($accorec['IDCODE']) . ' WHERE IDENTIFICATION = ' . singleQuote($identification) . ' AND ID = ' . $notificationId;
            ClxCommon::$db->executeQuery($sql);
            return;
        } elseif (!empty($accorec['IDCODE'])) {
            $sql = 'UPDATE ' . $this->inclname . ' SET ACCOUNTCODE = ' . singleQuote($accorec['IDCODE']) . ' WHERE IDENTIFICATION = ' . singleQuote($identification) . ' AND ID = ' . $notificationId;
            ClxCommon::$db->executeQuery($sql);
        }
        $parameters_2 = array('status' => CLX_NUM_ZERO, 'mensaje' => '', 'rif' => $identification, 'cadxml' => '');
        getService('LA_CLIENTE', $parameters_2);
        unset($parameters_2);
        $sql = 'UPDATE ' . $this->inclname . ' SET ACCOUNTCODE = (SELECT MAX(ACCO.IDCODE) FROM ' . $this->acconame . ' ACCO WHERE IDENTIFICATION = ' . singleQuote($identification) . '), EMAIL = (SELECT MAX(ACCO.EMAIL) FROM ' . $this->acconame . ' ACCO WHERE IDENTIFICATION = ' . singleQuote($identification) . ') WHERE IDENTIFICATION = ' . singleQuote($identification) . ' AND ID = ' . $notificationId;
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Sends notification to client
     *
     * @param String $efftdate
     * @param String $notificationId
     */
    function sendNotificationMail($efftdate, $notificationId = '') {
        $contenidoHTML = '';
        //4. Marcar como error casos donde no se encontro el email.
        $sql = 'UPDATE ' . $this->inclname . ' SET EMAIL_STATUS = ' . singleQuote('ERR') . ', NOTE = ' . singleQuote($this->error_msgs[CLX_NUM_ZERO]) . ' WHERE (EMAIL IS NULL OR EMAIL = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND EFFTDATE = ' . singleQuote($efftdate);
        if (!empty($notificationId)) {
            $sql .=' AND ID = ' . $notificationId;
        }
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT INCL.ID INCL_ID, ACCO.* FROM ' . $this->inclname . ' INCL, ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = INCL.ACCOUNTCODE AND INCL.EFFTDATE = ' . singleQuote($efftdate) . ' AND INCL.EMAIL_STATUS =' . singleQuote('PEND') . '';
        if ($notificationId <> '') {
            $sql .=' AND INCL.ID = ' . $notificationId;
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $invalid_file = false;
            //Prepare Template
            $UITM = getTool('UITM');
            unset($r['ID']);
            $template = $UITM->getTemplateAndRecordMerge($this->mail_template_code, $r);
            $from = $this->from_mail;
            if ($this->test_email === '') {
                $to = $r['EMAIL'];
            } else {
                $to = $this->test_email;
            }
            $cc = null;
            $bcc = null;
            $msg = $template['CONTENTS'];
            $msg_txt = $template['CONTENTS_TXT'];
            $subject = $template['SUBJECT'];
            $attachments = array();
            //Capture all attachments
            $sql = 'SELECT INCF.LA_CONFIR_URI FROM ' . $this->incfname . ' INCF, ' . $this->inclname . ' INCL WHERE INCF.EFFTDATE = INCL.EFFTDATE AND INCF.IDENTIFICATION = INCL.IDENTIFICATION AND INCF.LA_OPR_STATUS = ' . singleQuote($this->oper_status) . ' AND INCL.ID = ' . $r['INCL_ID'];
            $rs2 = ClxCommon::$db->executeQuery($sql);
            while (($r2 = ClxCommon::$db->getNextRecord($rs2, NUMERIC)) === true) {
                if ($this->path_replace_active) {
                    $r2[CLX_NUM_ZERO] = str_replace($this->path_replace_search, $this->path_replace, $r2[CLX_NUM_ZERO]);
                }
                if (!file_exists($r2[CLX_NUM_ZERO])) {
                    //$invalid_file = true;
                    continue;
                }
                $attachments[] = $r2[CLX_NUM_ZERO];
            }
            //$invalid_file = true;
            if (empty($attachments)) {
                $invalid_file = true;
            }
            //One or more files on error
            if ($invalid_file === true) {
                $sql = 'UPDATE ' . $this->inclname . ' SET EMAIL_STATUS = ' . singleQuote('ERR') . ',NOTE = ' . singleQuote($this->error_msgs[CLX_NUM_FOUR]) . ' WHERE ID = ' . $r['INCL_ID'];
                ClxCommon::$db->executeQuery($sql);
                continue;
            }
            $contenidoHTML.= '<br>' . CLX_CHAR_NL . CLX_CHAR_CR . 'Mail sent to: ' . $to;
            if (!clx_mail($from, $to, $msg, $subject, true, $cc, $bcc, $from, $attachments, $msg_txt)) {
                $error = $this->error_msgs[CLX_NUM_ONE] . ' ' . $this->error_msgs[CLX_NUM_TWO] . ':' . $from . ', ' . $this->error_msgs[CLX_NUM_THREE] . ': ' . $to;
                $status = array('EMAIL_STATUS' => 'ERRO',
                    'NOTE' => substr($error, CLX_NUM_ZERO, CLX_NUM_250));
            } else {
                $status = array('EMAIL_STATUS' => 'SENT', 'NOTE' => '', 'DELIVERY_DATE' => xFormat::getNow());
                //setting copy to parameter if exists
                if ($this->cc_mail <> '') {
                    $contenidoHTML.= '<br>' . CLX_CHAR_NL . CLX_CHAR_CR . '--Mail sent copy to: ' . $this->cc_mail;
                    echo $contenidoHTML;
                    $contenidoHTML = '';
                    clx_mail($from, $this->cc_mail, $msg, $subject . ' (CC)', true, $cc, $bcc, $from, $attachments, $msg_txt);
                }
            }
            ClxCommon::$db->updateRecord($this->inclname, $status, 'ID = ' . $r['INCL_ID']);
        }//end while
        echo $contenidoHTML;
    }

    /**
     * Resends notification to client
     *
     */
    function resendNotification() {
        $idlist = toString(getIdlist());
        if (empty($idlist))
            return;
        $sql = 'UPDATE ' . $this->inclname . ' SET EMAIL_STATUS = ' . singleQuote('PEND') . ', DELIVERY_DATE = nullWHERE ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT ID, IDENTIFICATION, EFFTDATE, EMAIL FROM ' . $this->inclname . ' WHERE ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            if (empty($r[CLX_NUM_THREE])) {//no email
                $this->sendNotificationBuildContact($r[CLX_NUM_ONE], $r[CLX_NUM_ZERO]);
            }
            $this->sendNotificationMail($r[CLX_NUM_TWO], $r[CLX_NUM_ZERO]);
        }
    }

}
