<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-15 16:29:23 -0400 (Thu, 15 Oct 2015) $
 * @version        $Rev: 7314 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Jeca {

    function __construct($procParameters = array()) {
        multiTableName($this, array('JECA', 'GLCP', 'COMP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Generate calendar for all companies
     *
     */
    function generateJecaAllCompanies() {
        $sql = 'SELECT IDCODE FROM ' . $this->compname;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            ClxFreeReturn($this->generateJeca($r['IDCODE']));
        }
    }

    function prompt() {
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = '';

        $EDIT = &getTool('EDIT');
        $title = '';
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('JECA_LOAD') . '');
        $record = UserRequest::$post;
        if (!empty($record['confirm'])) {
            $EDIT->checkForm2($msg, $formrec);
        }
        if (!empty($record['confirm']) && empty($msg)) {
            $lastdate = $this->generateJeca($record['JECA_COMP_CODE'], CLX_365_DAYS, $record['JECA_EFFTDATE']);
            $note = dict('GEN_LBL_PROCESS') . ' ' . dict('GEN_LBL_COMPLETED') . '<br><br>';
            $note .=dict('GEN_LBL_FROM') . ': ' . $record['JECA_EFFTDATE'] . '<br>';
            $note .=dict('GEN_LBL_TO') . ': ' . $lastdate . '<br>';
            return note($note, dict('GEN_LBL_RETURN'));
        } else {
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title, dict('GEN_LBL_EXECUTE'));
            return $form->source();
        }
    }

    /**
     * Loads date table. Increases 365 days from last date.
     */
    function generateJeca($comp_code, $qty = CLX_365_DAYS, $startdate = '') {

        if (!function_exists('setCreationData')) {
            includeCodeLib('GEN_REC_UTIL');
        }
        $now = getNow('Y-m-d');
        $glcprec = ClxCommon::$db->getRecord($this->glcpname, 'COMP_CODE = ' . singleQuote($comp_code));
        if ($startdate === '') {
            $sql = 'SELECT MAX(EFFTDATE) FROM ' . $this->jecaname . ' WHERE COMP_CODE = ' . singleQuote($comp_code);
            $lastdate = ClxCommon::$db->getOne($sql);
        } else {
            $lastdate = $startdate;
        }
        if ($lastdate === '') {
            $lastdate = $glcprec['OPERATION_DATE'];
        }
        if ($lastdate === '') {
            $lastdate = $now;
        }
        for ($i = CLX_INIT_ZERO; $i <= $qty; $i++) {
            $day = date('N', strtotime($lastdate)); //1to7 1 for monday
            if ($day == CLX_NUM_ONE && $glcprec['WORK_DAY_MON'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_TWO && $glcprec['WORK_DAY_TUE'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_THREE && $glcprec['WORK_DAY_WED'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_FOUR && $glcprec['WORK_DAY_THU'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_FIVE && $glcprec['WORK_DAY_FRI'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_SIX && $glcprec['WORK_DAY_SAT'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_7 && $glcprec['WORK_DAY_SUN'] == CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } else {
                $holiday = CLX_INIT_ZERO;
            }
            $record = array('COMP_CODE' => $comp_code, 'IDNAME' => date('l Y-m-d', strtotime($lastdate)), 'EFFTDATE' => $lastdate, 'HOLIDAY' => $holiday, 'CREATEDBY' => '', 'MODIFIEDBY' => '', 'MDATE' => '', 'CDATE' => '');
            setCreationData($record);
            $sql = 'SELECT COUNT(ID) FROM ' . $this->jecaname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($lastdate);
            if ($holiday && !ClxCommon::$db->getOne($sql)) {
                ClxCommon::$db->createRecord($this->jecaname, $record, false);
                //e cho $lastdate.'<br>';
            }
            $lastdate = adodb_next_day($lastdate);
        }
        return $lastdate;
    }

    /**
     * Returns true if selected date is holiday
     * @param string $comp_code
     * @param string $efftdate
     * @return boolean
     */
    function is_holiday($comp_code, $efftdate) {
        return (ClxCommon::$db->oneExistsRecords($this->jecaname, 'COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($efftdate) . ' AND HOLIDAY = 1 ') == CLX_NUM_ZERO) ? false : true;
    }

}
