<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: alenetdev $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2018-02-22 15:09:31 -0500 (Thu, 22 Feb 2018) $
 * @version		$Rev: 9741 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Jehd {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    var $display = false;
    var $back_value_enabled = true;

    function __construct($procParameters = array()) {
        multiTableName($this, array('FIPA', 'FICO','AUTH', 'JEHD', 'INAT', 'GLRC', 'GLAC', 'GLAG', 'COMP', 'INFU', 'FIAS', 'FIAC', 'JELN', 'TTPA', 'FIBK', 'GLCP', 'FIGN', 'FTMP', 'FIAT', 'FITB', 'FITS', 'JEIT', 'OPBV', 'LEDG', 'LEBA', 'JACP', 'FIAT', 'COLO', 'PRAT', 'PROD', 'FILO', 'GUAR', 'GDVW', 'PRPT', 'PLVW', 'LEGI', 'INVO', 'APIN', 'INPH', 'DYCL', 'INRM', 'GLCR'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice jehd form
     * Executed on init event
     */
    function jehd_init_form(&$record) {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters();
        unset($comp);
        $record ['JEHD_EFFTDATE'] = $comprec ['OPERATION_DATE'];
        $record ['JEHD_REAL_DATE'] = $comprec ['OPERATION_DATE'];
        $record ['JEHD_COMP_CODE'] = $comprec ['IDCODE'];
        $record ['JEHD_CLX_AUTH_STATUS'] = 'PEND';
        $record ['JEHD_JE_STATUS'] = 'PEND';
        $record ['JEHD_LGGROUP_CODE'] = 'AC';
        $record ['JEHD_FISCAL_PERIOD'] = $comprec ['FISCAL_PERIOD'];
        $record ['JEHD_JE_SOURCE'] = 'USR';
        $record ['JEHD_REQ_CHANNEL'] = 'OFC';
        $record ['JEHD_DEBITS'] = '0.00';
        $record ['JEHD_CREDITS'] = '0.00';
        $record ['JEHD_BASE_DEBITS'] = '0.00';
        $record ['JEHD_BASE_CREDITS'] = '0.00';
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function jehd_validate_form(&$record, &$msg) {
        if (!empty($msg)) {
            return false;
        }
      
        //Validar que operaciones de reverso no puedan ser modificadas
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY')) {
            if (!empty($record ['JEHD_REV_JEHDR_CODE'])) {
                $msg ['JEHD_COMP_CODE'] = smsg('MSG-89', $record ['JEHD_IDCODE']);
            }
        }

        if (UserRequest::$request['ac'] === 'DELETE'){
            $idlist = getIdlist();
            $idlist = toString($idlist);
            $sql = 'SELECT IDCODE FROM ' . $this->jehdname . ' WHERE ID IN (' . $idlist. ') AND CLX_AUTH_STATUS<>'.singleQuote('PEND').' AND CLX_AUTH_STATUS<>'.singleQuote('OPQU');
            $reg = ClxCommon::$db->getOne($sql);
            if (!empty($reg))  {
                $msg ['JEHD_JE_STATUS'] = smsg('MSG-16', $reg);
                addMessage($msg ['JEHD_JE_STATUS']);
                return false;
            }

            $sql = 'SELECT IDCODE FROM ' . $this->jehdname . ' WHERE ID IN (' . $idlist. ')';
            $reg = ClxCommon::$db->getOne($sql);

            if (!empty($reg))  {

                $fl = ClxCommon::$db->getField('AMGT_ASSET_VALUATIONS', 'ASSET_CODE', 'JEHDR_CODE = ' . singleQuote($reg));
                if (!empty($fl)) {
                        $msg ['JEHD_IDCODE'] = smsg('MSG-491', $fl);
                        addMessage($msg ['JEHD_IDCODE']);
                        return false;
                    }

                $fl = ClxCommon::$db->getField('FIDU_ASSET_INSURANCES', 'ASSET_CODE', 'JEHDR_CODE = ' . singleQuote($reg));
                if (!empty($fl)) {
                        $msg ['JEHD_IDCODE'] = smsg('MSG-490', $fl);
                        addMessage($msg ['JEHD_IDCODE']);
                        return false;
                }

                    //Validando existencia de facturas
                    /*SELECT * FROM BILL_INVOICE WHERE JEHDR_CODE;
                SELECT * FROM AP_PAY_INVOICES WHERE JEHDR_CODE;*/
                $fl = ClxCommon::$db->getField('BILL_INVOICE', 'IDCODE', 'JEHDR_CODE = ' . singleQuote($reg));
                if (!empty($fl)) {
                        $msg ['JEHD_IDCODE'] = smsg('MSG-492', $fl);
                        addMessage($msg ['JEHD_IDCODE']);
                        return false;
                }

                $fl = ClxCommon::$db->getField('AP_PAY_INVOICES', 'IDCODE', 'JEHDR_CODE = ' . singleQuote($reg));
                if (!empty($fl)) {
                        $msg ['JEHD_IDCODE'] = smsg('MSG-493', $fl);
                        addMessage($msg ['JEHD_IDCODE']);
                        return false;
               }
          }
          return true;

        }

        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        // Validar que la fecha de la operacion
        // sea menor o igual a la contabilidad +1 dia
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($record ['JEHD_COMP_CODE']);
        unset($comp);
        $operation_date = $comprec ['OPERATION_DATE'];
        $bckdtdop = $comprec ['BCKDATE_ALLWCE'];
        $record ['JEHD_EFFTDATE'] = xFormat::anytimedate($record ['JEHD_EFFTDATE'], 'Y-m-d');
        $record ['JEHD_EFFTDATE'] = xFormat::anytimedate($record ['JEHD_EFFTDATE'], 'Y-m-d');
        //Validando que fecha real no pueda ser menor a la fecha efectiva
        if ($record['JEHD_JE_SOURCE'] <> 'GLAR' && $record['JEHD_JE_SOURCE'] <> 'GLCL' && $record['JEHD_EFFTDATE'] > $record['JEHD_REAL_DATE']) {
            $msg['JEHD_REAL_DATE'] = smsg('MSG-462', $record['JEHD_REAL_DATE'], $operation_date);
        }
        if ($record['JEHD_JE_SOURCE'] <> 'GLAR' && $record['JEHD_JE_SOURCE'] <> 'GLCL' && $record['JEHD_JE_SOURCE'] <> 'GLTT_FITY' && $record['JEHD_REAL_DATE'] < $operation_date) {
            $msg['JEHD_REAL_DATE'] = smsg('MSG-462', $record['JEHD_REAL_DATE'], $operation_date);
        }
        if (empty($bckdtdop))
            $bckdtdop = CLX_INIT_ZERO;
        if (day_diff($record ['JEHD_EFFTDATE'], $operation_date) < $bckdtdop) {
            $msg ['JEHD_EFFTDATE'] = smsg('MSG-17', $record ['JEHD_IDCODE']);
        }
 
        // Validar que el periodo contable coincida con fecha de transaccion
        $sql = 'SELECT COUNT(JACP.ID) QTY FROM ' . $this->jacpname . ' JACP WHERE JACP.FROM_DATE <= ' . singleQuote($record ['JEHD_EFFTDATE']) . ' AND JACP.TO_DATE >= ' . singleQuote($record ['JEHD_EFFTDATE']) . ' AND JACP.IDCODE = ' . singleQuote($record ['JEHD_FISCAL_PERIOD']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg ['JEHD_FISCAL_PERIOD'] = smsg('MSG-69', $record ['JEHD_IDCODE']);
        }
        $sql = 'SELECT COUNT(LEGI.ID) FROM ' . $this->leginame . ' LEGI WHERE LEGI.LGGROUP_CODE = ' . singleQuote($record ['JEHD_LGGROUP_CODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg ['JEHD_LGGROUP_CODE'] = smsg('MSG-261', $record ['JEHD_IDCODE'], $record ['JEHD_LGGROUP_CODE']);
        }
        if (!empty($msg))
            return;
        // Autorization validations
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' || defined('proc_fiat_jehd_approval')) {
            $check_date_greatter_than = ($record['JEHD_JE_SOURCE'] === 'GLTT_FITY') ? false : true;
            if ($check_date_greatter_than && $record['JEHD_REAL_DATE'] <> $operation_date && $record['JEHD_JE_SOURCE'] <> 'GLCL' && $record['JEHD_JE_SOURCE'] <> 'GLAR') {
                $msg['JEHD_REAL_DATE'] = smsg('MSG-468', $record['JEHD_REAL_DATE'], $operation_date);
            }
            if ($check_date_greatter_than && $record['JEHD_EFFTDATE'] > $operation_date) {
                $msg['JEHD_EFFTDATE'] = smsg('MSG-469', $record['JEHD_EFFTDATE'], $operation_date);
            }
            if ($check_date_greatter_than && $record ['JEHD_EFFTDATE'] > $operation_date) {
                $msg ['JEHD_EFFTDATE'] = smsg('MSG-17', $record ['JEHD_IDCODE']);
            }
            if (!empty($record['JEHD_INAT_CODE'])) {
                $sql = 'SELECT * FROM ' . $this->inatname . ' INAT WHERE IDCODE = ' . singleQuote($record['JEHD_INAT_CODE']) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
                if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO && UserRequest::$request['li'] === 'JEHD') {
                    //if(ClxCommon::$db->getOne($sql)>0){
                    $msg['JEHD_IDCODE'] = smsg('MSG-359', $record['JEHD_INAT_CODE']);
                }
            }
            if (empty($record['JEHD_REV_JEHDR_CODE'])) {
                //Evaluar solo si no es reverso. Transaccion debe estar balanceada
                $sql = 'SELECT JELN.CHART_FIELD01,JELN.CHART_FIELD02, SUM(JELN.DEBIT_AMT) DEBIT_AMT, SUM(JELN.CREDIT_AMT) CREDIT_AMT, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT FROM ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' GROUP BY JELN.CHART_FIELD01, JELN.CHART_FIELD02';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    if ($result ['DEBIT_AMT'] != $result ['CREDIT_AMT']) {
                        $msg ['JEHD_JE_STATUS'] = smsg('MSG-19', $record ['JEHD_IDCODE']);
                        break;
                    }
                    // Verificar que creditos sea o debitos sea diferente de cero.
                    if ($result ['DEBIT_AMT'] == CLX_NUM_ZERO || $result ['CREDIT_AMT'] == CLX_NUM_ZERO) {
                        $msg ['JEHD_JE_STATUS'] = smsg('MSG-19', $record ['JEHD_IDCODE']);
                        break;
                    }
                }
            }
            $sql = 'SELECT COUNT(JELN.ID)QTY FROM ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['JEHD_JE_STATUS'] = smsg('MSG-87', $record ['JEHD_IDCODE']);
            }
            // Validar que todas las lineas contables contengan un grupo correcto
            $sql = 'SELECT COUNT(JELN.ID) QTY FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = GLCP.COMP_CODE AND JEHD.IDCODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND NOT EXISTS (SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE)';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                // Existe una linea de otro grupo contable
                $msg ['JEHD_IDCODE'] = smsg('MSG-20', $record ['JEHD_IDCODE']);
            }
            // Validar que todas las lineas contables contengan un grupo correcto
            $sql = 'SELECT COUNT(GLAC.ID) FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = GLCP.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JEHD.IDCODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.ALLOW_ACTIVITY=0';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                // Existe una linea de otro grupo contable
                $msg ['JEHD_IDCODE'] = smsg('MSG-78', $record ['JEHD_IDCODE']);
            }
            $sql = 'SELECT COUNT(GLAC.ID) FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = GLCP.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JEHD.IDCODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.EFFTSTAT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $sql = 'SELECT GLAC.IDCODE FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = GLCP.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JEHD.IDCODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.EFFTSTAT =' . singleQuote(CLX_CHAR_EMPTY_STRING) . '';
                // Existe una linea de otro grupo contable
                $msg ['JEHD_IDCODE'] = smsg('MSG-79', $record ['JEHD_IDCODE']);
                $msg ['JEHD_IDCODE'] .= ' ' . ClxCommon::$db->getOne($sql);
            }

            // Validar que linea de efectivo coincida con moneda de cuenta de
            // Verificar si esto sera cierto
            $sql = 'SELECT COUNT(GLAC.ID) FROM ' . $this->glacname . ' GLAC, ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fibkname . ' FIBK, ' . $this->prodname . ' PROD, ' . $this->pratname . ' PRAT, ' . $this->fiatname . ' FIAT, ' . $this->fiasname . ' FIAS WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND FIBK.BANK_PROD_CODE = PROD.IDCODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND FIBK.COMP_CODE = JEHD.COMP_CODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.CURRENCY_CODE <> JELN.CURRENCY_CODE AND JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']);
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                // Existe una linea de otro grupo contable
                $msg ['JEHD_IDCODE'] = smsg('MSG-80', $record ['JEHD_IDCODE']);
            }
            // Validacion de disponible por cuenta VERIFICAR CON VISTA DE SALDO
            // donot validate redistributions or investment processes
            $validate_overdraft = true;
            if ($record ['JEHD_JE_SOURCE'] === 'INAC')
                $validate_overdraft = true;
            elseif ($record ['JEHD_JE_SOURCE'] === 'RDST')
                $validate_overdraft = false;
            elseif ($record ['JEHD_JE_SOURCE'] === 'INAP')
                $validate_overdraft = false;
            elseif ($record ['JEHD_JE_SOURCE'] === 'INIP')
                $validate_overdraft = false;
            if ($validate_overdraft === true) {
                /*
                 * VERIFICAR PORQUE EL VIEW DEMORA $sql = 'SELECT
                 * OPBV.JEHDR_CODE, OPBV.GLACCOUNTCODE, (SELECT
                 * FICO.CONTRACT_NUMBER FROM FIDU_CONTRACTS FICO WHERE
                 * FICO.IDCODE=OPBV.CHART_FIELD01) CONTRACT_NUMBER,
                 * OPBV.CHART_FIELD02, OPBV.LEDGER_CODE,
                 * (OPBV.FINAL_BAL_AMT*OPBV.GLAC_SIGN) BALANCE_AMT FROM
                 * GL_OPER_BALANCE_VW OPBV WHERE OPBV.JEHDR_CODE =
                 * '' . $record['JEHD_IDCODE'].'' AND
                 * (OPBV.FINAL_BAL_AMT*OPBV.GLAC_SIGN)<0';
                 */
                /* $sql = 'SELECT
                  JEHD.ID, JEHD.IDCODE JEHDR_CODE, LEGI.LEDGER_CODE, JELN.GLACCOUNTCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.CURRENCY_CODE, GLAC.GL_TYPE, (case GLAC.GL_TYPE WHEN 'AS' THEN 1 WHEN 'EX' THEN 1 WHEN 'OR' THEN 1 ELSE -1 END) *
                  (case GLAC.PROVISION WHEN 1 THEN -1 ELSE  1	END) GLAC_SIGN, IFNULL((SELECT SUM(JCBV.BALANCE_AMT) FROM GL_CUR_BALANCE_VW JCBV WHERE JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE AND JCBV.LEDGER_CODE = LEGI.LEDGER_CODE AND JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE AND JCBV.COMP_CODE = JEHD.COMP_CODE AND JCBV.CHART_FIELD01 = JELN.CHART_FIELD01 AND JCBV.CHART_FIELD02 = JELN.CHART_FIELD02 AND ((case GLAC.GL_TYPE WHEN 'AS' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) WHEN 'LI' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) ELSE  1=1 END)) AND ((case GLAC.GL_TYPE WHEN 'AS' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) WHEN 'LI' THEN (JCBV.CHART_FIELD04 = JELN.CHART_FIELD04 OR (JCBV.CHART_FIELD04 IS NULL AND JELN.CHART_FIELD04 IS NULL)) ELSE  1=1 END)) AND JCBV.CURRENCY_CODE = JELN.CURRENCY_CODE),0) BALANCE_AMT, SUM(DEBIT_AMT-CREDIT_AMT) POSTED_AMT, IFNULL((SELECT SUM(JCBV.BALANCE_AMT) FROM GL_CUR_BALANCE_VW JCBV WHERE JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE AND JCBV.LEDGER_CODE = LEGI.LEDGER_CODE AND JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE AND JCBV.COMP_CODE = JEHD.COMP_CODE AND JCBV.CHART_FIELD01 = JELN.CHART_FIELD01 AND JCBV.CHART_FIELD02 = JELN.CHART_FIELD02 AND ((case GLAC.GL_TYPE WHEN 'AS' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) WHEN 'LI' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) ELSE  1=1 END)) AND ((case GLAC.GL_TYPE WHEN 'AS' THEN (JCBV.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) WHEN 'LI' THEN (JCBV.CHART_FIELD04 = JELN.CHART_FIELD04 OR (JCBV.CHART_FIELD04 IS NULL AND JELN.CHART_FIELD04 IS NULL)) ELSE  1=1 END)) AND JCBV.CURRENCY_CODE = JELN.CURRENCY_CODE ),0) + SUM(DEBIT_AMT-CREDIT_AMT) FINAL_BAL_AMT FROM GL_LED_GITEMS_TBL LEGI, GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE AND GLAC.ALLOW_OVERDRAFT = 0 AND JELN.JEHDR_CODE = '' . $record['JEHD_IDCODE']).' GROUP BY JEHD.ID, JEHD.IDCODE, GLAC.GL_TYPE, GLAC.PROVISION, JELN.GLACCOUNTCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, LEGI.LEDGER_CODE, JELN.CURRENCY_CODE HAVING (FINAL_BAL_AMT*GLAC_SIGN)<0'; */

                $DBTB = &getTool('DBTB');
                $DBTB->buildTemporaryTable('GLOT');
                $sql = 'DELETE FROM GL_OPERATION_TMP WHERE 1=1'; //GLOT
                ClxCommon::$db->executeQuery($sql);
                $sql = 'INSERT INTO GL_OPERATION_TMP (JEHDR_CODE, COMP_CODE, LEDGER_CODE, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, /*CURRENCY_CODE,*/ GL_TYPE, GLAC_SIGN, BALANCE_AMT, POSTED_AMT, FINAL_BAL_AMT) SELECT JEHD.IDCODE JEHDR_CODE, JEHD.COMP_CODE, LEGI.LEDGER_CODE, JELN.GLACCOUNTCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, /*JELN.CURRENCY_CODE,*/ GLAC.GL_TYPE, (case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('CO') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) *(CASE GLAC.PROVISION WHEN 1 THEN -1 ELSE  1 END) GLAC_SIGN, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) POSTED_AMT, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) FINAL_BAL_AMT FROM GL_LED_GITEMS_TBL LEGI, GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE AND GLAC.ALLOW_OVERDRAFT = 0 AND JEHD.JE_SOURCE <> ' . singleQuote('SETT') . ' AND JELN.JEHDR_CODE = ' . singleQuote($record['JEHD_IDCODE']) . ' GROUP BY JEHD.ID, JEHD.IDCODE, JEHD.COMP_CODE, LEGI.LEDGER_CODE, JELN.GLACCOUNTCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, /*JELN.CURRENCY_CODE,*/ GLAC.GL_TYPE';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE GL_OPERATION_TMP SET BALANCE_AMT = 0, FINAL_BAL_AMT = 0';
                ClxCommon::$db->executeQuery($sql);
                //$sql = 'UPDATE GL_OPERATION_TMP X,  GL_LEDGERS LEBA SET X.BALANCE_AMT= X.BALANCE_AMT + LEBA.BASE_BAL_AMT WHERE LEBA.COMP_CODE = X.COMP_CODE AND LEBA.CHART_FIELD01 = X.CHART_FIELD01 AND LEBA.CHART_FIELD02 = X.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = X.CHART_FIELD03 OR (LEBA.CHART_FIELD03 IS NULL AND X.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = X.CHART_FIELD04 OR (LEBA.CHART_FIELD04 IS NULL AND X.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = X.GLACCOUNTCODE AND LEBA.LEDGER_CODE = X.LEDGER_CODE ';
                $sql = 'UPDATE GL_OPERATION_TMP X, GL_LEDGERS LEBA SET X.BALANCE_AMT= X.BALANCE_AMT + LEBA.BASE_BAL_AMT WHERE LEBA.COMP_CODE = X.COMP_CODE AND LEBA.CHART_FIELD01 = X.CHART_FIELD01 AND LEBA.CHART_FIELD02 = X.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = X.CHART_FIELD03 OR (NULLIF(TRIM(LEBA.CHART_FIELD03),'.singleQuote('').') IS NULL AND X.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = X.CHART_FIELD04 OR (NULLIF(TRIM(LEBA.CHART_FIELD04),'.singleQuote('').') IS NULL AND X.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = X.GLACCOUNTCODE AND LEBA.LEDGER_CODE = X.LEDGER_CODE';
                //$sql = 'UPDATE GL_OPERATION_TMP X SET X.BALANCE_AMT = IFNULL((SELECT SUM(LEBA.BASE_BAL_AMT) FROM GL_LEDGERS LEBA WHERE LEBA.COMP_CODE = X.COMP_CODE AND LEBA.CHART_FIELD01 = X.CHART_FIELD01 AND LEBA.CHART_FIELD02 = X.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = X.CHART_FIELD03 OR (LEBA.CHART_FIELD03 IS NULL AND X.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = X.CHART_FIELD04 OR (LEBA.CHART_FIELD04 IS NULL AND X.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = X.GLACCOUNTCODE AND LEBA.LEDGER_CODE = X.LEDGER_CODE),0)';
                $sql = 'UPDATE GL_OPERATION_TMP X SET X.BALANCE_AMT = IFNULL((SELECT SUM(LEBA.BASE_BAL_AMT) FROM GL_LEDGERS LEBA WHERE LEBA.COMP_CODE = X.COMP_CODE AND LEBA.CHART_FIELD01 = X.CHART_FIELD01 AND LEBA.CHART_FIELD02 = X.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = X.CHART_FIELD03 OR (NULLIF(TRIM(LEBA.CHART_FIELD03),'.singleQuote('').') IS NULL AND X.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = X.CHART_FIELD04 OR (NULLIF(TRIM(LEBA.CHART_FIELD04),'.singleQuote('').') IS NULL AND X.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = X.GLACCOUNTCODE AND LEBA.LEDGER_CODE = X.LEDGER_CODE),0)';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE GL_OPERATION_TMP SET FINAL_BAL_AMT = BALANCE_AMT+POSTED_AMT';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'DELETE FROM GL_OPERATION_TMP WHERE (FINAL_BAL_AMT*GLAC_SIGN)>=0';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'SELECT * FROM GL_OPERATION_TMP LIMIT 50';
                $results = ClxCommon::$db->executeQuery($sql);
                $br = '';
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    if (empty($msg ['JEHD_IDCODE'])) {
                        $msg ['JEHD_IDCODE'] = '';
                    }
                    $result ['LEDGER_CODE'] = ClxCommon::$db->getField($this->ledgname, 'IDNAME', 'IDCODE = ' . singleQuote($result ['LEDGER_CODE'])) . ' (' . $result ['LEDGER_CODE'] . ')';
                    $result ['CONTRACT_NUMBER'] = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_NUMBER', 'IDCODE = ' . singleQuote($result ['CHART_FIELD01']));
                    if (empty($msg ['JEHD_IDCODE']))
                        $msg ['JEHD_IDCODE'] = '';
                    $msg ['JEHD_IDCODE'] .= '<li>' . smsg('MSG-21', $result ['JEHDR_CODE'] . ' (' . $record ['JEHD_TRANS_CODE'] . ') ', $result ['LEDGER_CODE'] . ' ' . $result ['CONTRACT_NUMBER'] . '-' . $result ['CHART_FIELD02'], $result ['GLACCOUNTCODE'], $result ['BALANCE_AMT']) . '</li>';
                } // end while

                $qty = ClxCommon::$db->countRecords('GL_OPERATION_TMP');
                if ($qty > CLX_NUM_50) {
                    $msg ['JEHD_IDCODE'] .= '<li>...+' . ($qty - CLX_NUM_50) . '</li>';
                }
                $sql = 'DELETE FROM GL_OPERATION_TMP';
                ClxCommon::$db->executeQuery($sql);
            }

            // VALIDACION DE PRESTACIONES Y EMBARGO

            if (!empty($this->prptname)) {
                $sql = 'SELECT COUNT(PRPT.ID) FROM ' . $this->prptname . ' PRPT, ' . $this->jelnname . ' JELN WHERE JELN.CHART_FIELD01 = PRPT.CONTRACT_CODE AND JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']);
                if ($record ['JEHD_TRANS_CODE'] !== 'SYS_DESIN' && ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                    // not include this validation for desincorporation and other contracts difernt than AD09 prestaciones
                    $batch_id = $record ['JEHD_IDCODE'];
                    // Registrar saldos de capital para contrato y participante en trans Load temporary table - Req on mysql
                    $DBTB = &getTool('DBTB');
                    $DBTB->buildTemporaryTable('FTMP');
                    // Clearing Temporary table for batch id
                    ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));

                    $sql = 'INSERT INTO ' . $this->ftmpname . ' (JE_SOURCE, REC_STATUS, BATCH_ID, EFFTDATE, CHART_FIELD01, CHART_FIELD02, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DEBIT_AMT, GARNISH_PCT, GARNISH_AMT, MAXBLOCKED_AMT, AVAILABLE_AMT) SELECT GDVW.JE_SOURCE, ' . singleQuote('RUN') . ' REC_STATUS, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote($record ['JEHD_EFFTDATE']) . ' EFFTDATE, GDVW.CHART_FIELD01, GDVW.CHART_FIELD02, SUM(GDVW.CREDIT_AMT - GDVW.DEBIT_AMT) CALC_AMT_01, 0 CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, 0 DEBIT_AMT, 0 GARNISH_PCT, 0 GARNISH_AMT, 0 MAXBLOCKED_AMT, 0 AVAILABLE_AMT FROM ' . $this->gdvwname . ' GDVW WHERE GDVW.GL_TYPE = ' . singleQuote('EQ') . ' AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ' AND GDVW.IDCODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' GROUP BY GDVW.JE_SOURCE, GDVW.CHART_FIELD01, GDVW.CHART_FIELD02';
                    ClxCommon::$db->executeQuery($sql);
                    // Calcular el 75% en el caso de que aplique
                    $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_02 = IFNULL( (SELECT ROUND(FTMP.CALC_AMT_01*(PRPT.PRES_AVAIL_PCT/100), 2) FROM ' . $this->prptname . ' PRPT WHERE PRPT.CONTRACT_CODE = FTMP.CHART_FIELD01),0), FTMP.CALC_AMT_03 = IFNULL( (SELECT SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) FROM ' . $this->gdvwname . ' GDVW WHERE GDVW.GL_TYPE = ' . singleQuote('AS') . ' AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('AD') . ' AND FTMP.CHART_FIELD01 = GDVW.CHART_FIELD01 AND FTMP.CHART_FIELD02 = GDVW.CHART_FIELD02),0), FTMP.CALC_AMT_04 = IFNULL( (SELECT SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) FROM ' . $this->gdvwname . ' GDVW WHERE GDVW.GL_TYPE = ' . singleQuote('AS') . ' AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('CR') . ' AND FTMP.CHART_FIELD01 = GDVW.CHART_FIELD01 AND FTMP.CHART_FIELD02 = GDVW.CHART_FIELD02),0), FTMP.DEBIT_AMT = IFNULL( (SELECT SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) FROM ' . $this->gdvwname . ' GDVW WHERE GDVW.GL_TYPE = ' . singleQuote('EQ') . ' AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ' AND FTMP.CHART_FIELD01 = GDVW.CHART_FIELD01 AND FTMP.CHART_FIELD02 = GDVW.CHART_FIELD02),0), FTMP.GARNISH_PCT = IFNULL((SELECT FIGN.GARNISH_PCT FROM ' . $this->fignname . ' FIGN WHERE FIGN.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FTMP.CHART_FIELD01 = FIGN.CONTRACT_CODE AND FTMP.CHART_FIELD02 = FIGN.PARTICIPANT_ID AND FIGN.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fignname . ' X WHERE X.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND X.CLX_EFFTDATE <= FTMP.EFFTDATE AND X.IDCODE = FIGN.IDCODE)),0), FTMP.GARNISH_AMT =  IFNULL((SELECT FIGN.GARNISH_AMT FROM ' . $this->fignname . ' FIGN WHERE FIGN.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FTMP.CHART_FIELD01 = FIGN.CONTRACT_CODE AND FTMP.CHART_FIELD02 = FIGN.PARTICIPANT_ID AND FIGN.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fignname . ' X WHERE X.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND X.CLX_EFFTDATE <= FTMP.EFFTDATE AND X.IDCODE = FIGN.IDCODE)),0), FTMP.MAXBLOCKED_AMT = IFNULL((SELECT FIGN.MAXBLOCKED_AMT FROM ' . $this->fignname . ' FIGN WHERE FIGN.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FTMP.CHART_FIELD01 = FIGN.CONTRACT_CODE AND FTMP.CHART_FIELD02 = FIGN.PARTICIPANT_ID AND FIGN.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fignname . ' X WHERE X.GARNISH_STATUS = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND X.CLX_EFFTDATE <= FTMP.EFFTDATE AND X.IDCODE = FIGN.IDCODE)),0) WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.JE_SOURCE = ' . singleQuote('SYS') . ' AND FTMP.REC_STATUS =' . singleQuote('RUN') . '';
                    ClxCommon::$db->executeQuery($sql);

                    // Calculate percentage cases
                    $sql = 'UPDATE ' . $this->ftmpname . ' SET GARNISH_AMT = GARNISH_AMT + ROUND((CALC_AMT_01*(GARNISH_PCT/100)), 2) WHERE JE_SOURCE = ' . singleQuote('SYS') . ' AND GARNISH_PCT>0 AND BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
                    ClxCommon::$db->executeQuery($sql);
                    // set max if apply
                    $sql = 'UPDATE ' . $this->ftmpname . ' SET GARNISH_AMT = MAXBLOCKED_AMT WHERE JE_SOURCE = ' . singleQuote('SYS') . ' AND MAXBLOCKED_AMT<>0 AND GARNISH_AMT>MAXBLOCKED_AMT AND BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
                    ClxCommon::$db->executeQuery($sql);
                    // determine available
                    $sql = 'UPDATE ' . $this->ftmpname . ' SET AVAILABLE_AMT = (CALC_AMT_02-CALC_AMT_03-CALC_AMT_04-GARNISH_AMT) WHERE JE_SOURCE = ' . singleQuote('SYS') . ' AND BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
                    ClxCommon::$db->executeQuery($sql);

                    $sql = 'SELECT CHART_FIELD01, CHART_FIELD02, AVAILABLE_AMT, DEBIT_AMT FROM ' . $this->ftmpname . ' WHERE AVAILABLE_AMT<DEBIT_AMT AND JE_SOURCE = ' . singleQuote('SYS') . ' AND BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS = ' . singleQuote('RUN') . ' ORDER BY CHART_FIELD01, CHART_FIELD02';
                    $results = ClxCommon::$db->executeQuery($sql);
                    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                        if (empty($msg ['JEHD_IDCODE']))
                            $msg ['JEHD_IDCODE'] = '';
                        $msg ['JEHD_IDCODE'] .= $br . smsg('MSG-22', $record ['JEHD_IDCODE'], $result ['AVAILABLE_AMT'], $result ['DEBIT_AMT'], $result ['CHART_FIELD01'] . '-' . $result ['CHART_FIELD02']);
                        $br = '<li>';
                    }
                    // Update balances
                    ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . '');
                } // end if not sys_desin
            } // end if not empty prptname
            // FIN VALIDACION DE EMBARGO Y PRESTACIONES
            // Validacion para el status del participante
            $sql = 'SELECT COUNT(FIPA.ID) FROM ' . $this->fipaname . ' FIPA, ' . $this->jelnname . ' JELN WHERE FIPA.CONTRACT_CODE = JELN.CHART_FIELD01 AND FIPA.ACCOUNTCODE = JELN.CHART_FIELD02 AND JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND FIPA.STATUS = ' . singleQuote('I');
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg ['JEHD_CHART_FIELD02'] = smsg('MSG-23', '', $record ['JEHD_IDCODE']);
            }
            $sql = 'SELECT COUNT(JELN.ID) FROM ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND (JELN.CHART_FIELD01=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR JELN.CHART_FIELD01 IS NULL OR JELN.CHART_FIELD02=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR JELN.CHART_FIELD02 IS NULL)';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg ['JEHD_CHART_FIELD02'] = smsg('MSG-23', '', $record ['JEHD_IDCODE']);
            }
            // Validar que exista linea com monto mayor a cero.
            $sql = 'SELECT COUNT(ID) FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND ((DEBIT_AMT=0 AND CREDIT_AMT=0) OR GLACCOUNTCODE IS NULL OR GLACCOUNTCODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')';
			
			
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg ['JEHD_IDCODE'] = smsg('MSG-166', '', $record ['JEHD_IDCODE']);
            }
			
            $sql = 'SELECT FILO.IDCODE FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS, ' . $this->jelnname . ' JELN WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->now) . ') AND JELN.JEHDR_CODE = ' . singleQuote($record ['JEHD_IDCODE']) . ' AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FILO.CLX_AUTH_STATUS = ' . singleQuote('PEND');
            $loan = ClxCommon::$db->getOne($sql);
            if (!empty($loan)) {
                $msg ['JEHD_CHART_FIELD03'] = smsg('MSG-311', $loan, $record ['JEHD_IDCODE']);
            }
            // Linea para bloquear en prueba mantener comentada
            //si no es reverso verifica limites
            if (ClxCommon::$db->countRecords('CLX_CODELIB', 'IDCODE = ' . singleQuote('INRM')) > CLX_NUM_ZERO && empty($record['JEHD_REV_JEHDR_CODE'])) {
                //Validaciones de politicas de inversion
                if (!class_exists('Inrm'))
                    includeCodeLib('INRM');
                // Validate Share Holdes Position for payments
                if (class_exists('Inrm')) {
                    $inrm = new Inrm ();
                    $err_msg = array();
                    if (!$inrm->check_jehd_policies($record['JEHD_IDCODE'], $err_msg)) {
                        $msg['JEHD_IDCODE'] = smsg('MSG-378', '<br>' . implode('<br>', $err_msg), $record['JEHD_IDCODE']);
                    }
                    unset($inrm);
                }
            }
	    $sql='SELECT
			COUNT(AUTH.ID) QTY
		FROM
			'.$this->jehdname.' JEHD,
			'.$this->invoname.' INVO,
			'.$this->authname.' AUTH
		WHERE
			JEHD.IDCODE = INVO.JEHDR_CODE
			AND INVO.ID = AUTH.REC_ID
			AND INVO.CLX_AUTH_STATUS IN ('.singleQuoteArray(array('PEND','PEAP')).')
			AND AUTH.TABLECODE = '.singleQuote('INVO').'
			AND AUTH_STATUS = '.singleQuote('PEND').'
			AND JEHD.IDCODE = '.singleQuote($record['JEHD_IDCODE']);


	    $count_rec = ClxCommon::$db->getOne($sql);
            if (!empty($count_rec)) {
		$msg['JEHD_IDCODE'] = smsg('MSG-516');
            }

		$sql='SELECT
			COUNT(AUTH.ID) QTY
		FROM
			'.$this->jehdname.' JEHD,
			'.$this->apinname.' APIN,
			'.$this->authname.' AUTH
		WHERE
			JEHD.IDCODE = APIN.JEHDR_CODE
			AND APIN.ID = AUTH.REC_ID
			AND APIN.CLX_AUTH_STATUS IN ('.singleQuoteArray(array('PEND','PEAP')).')
			AND AUTH.TABLECODE = '.singleQuote('APIN').'
			AND AUTH_STATUS = '.singleQuote('PEND').'
			AND JEHD.IDCODE = '.singleQuote($record['JEHD_IDCODE']);


	    $count_rec = ClxCommon::$db->getOne($sql);
            if (!empty($count_rec)) {
				$msg['JEHD_IDCODE'] = smsg('MSG-517');
            }


        } // end if reqauth
    }
   /**
    * Boton de rechazo de transacion
    * @global type $db
    * @global type $idlist
    * @return type
    */
    function jehd_reject_btn(){
		$idlist = toString(getIdlist());        
        if (empty($idlist)){
            return;
        }
        $sql = "SELECT JEHD.* "
                . "FROM $this->jehdname JEHD "
                . "WHERE JEHD.ID IN (" . $idlist. ")";
        $rs = ClxCommon::$db->executeQuery($sql);
		$total=array();
        while ($r = ClxCommon::$db->getNextRecord($rs)) {
			if ($r['JE_STATUS']== 'PEND')
				$this->jehd_post_autorize($r, true);
			else
				$total[]="Comprobante ".$r['IDCODE']." no puede ser rechazado<br>";
            
        }
        $resultado = array_diff(getIdlist(), $total);
        return note(dict('GEN_LBL_PROCESS_COMPLETED').'<div>'.implode('',$total).'</div>');
    }

    /**
     * Events running post autorizations
     */
    function jehd_post_autorize(&$record, $reject = false) {
        if (UserRequest::$request ['ac'] === 'DELETE')
            return true;
        if (empty($reject)) {
            if (!class_exists('Gloq'))
                includeCodeLib('GLOQ');
            $gloq = new Gloq ();
            $gloq->pushJehdListing($record ['IDCODE']);
            unset($gloq);
        } else {
            //change operation to rejected status
            $this->jehd_set_reject_status($record ['IDCODE']);
        }
        return true;
    }

    /**
     * Marks operation as rejected
     * @param unknown_type $jehd_code
     */
    function jehd_set_reject_status($jehd_code) {
        //rechazando asiento
        ClxCommon::$db->updateRecord($this->jehdname, array('JE_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($jehd_code));
        $trans = ClxCommon::$db->getFields($this->jehdname, 'ID, INAT_CODE, TRANS_CODE', 'IDCODE = ' . singleQuote($jehd_code));
        if (empty($trans['ID']))
            return;
        //Rechazando autorizaciones pendiente para asientos si hay mas de una
        $sql = 'UPDATE CLX_AC_AUTHORIZATIONS AUTH SET AUTH.AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE AUTH.TABLECODE = ' . singleQuote('JEHD') . ' AND AUTH.AUTH_STATUS = ' . singleQuote('PEND') . ' AND AUTH.REC_ID = ' . singleQuote($trans['ID']);
        ClxCommon::$db->executeQuery($sql);
        //Rechazando actividades de inversion
        if (!empty($trans['INAT_CODE'])) {
            ClxCommon::$db->updateRecord($this->inatname, array('CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($trans ['INAT_CODE']));
            $sql = 'UPDATE CLX_AC_AUTHORIZATIONS AUTH SET AUTH.AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE AUTH.TABLECODE = ' . singleQuote('INAT') . ' AND AUTH.AUTH_STATUS = ' . singleQuote('PEND') . ' AND EXISTS (SELECT INAT.ID FROM ' . $this->inatname . ' INAT WHERE INAT.ID = AUTH.REC_ID AND INAT.IDCODE = ' . singleQuote($trans ['INAT_CODE']) . ')';
            ClxCommon::$db->executeQuery($sql);
        }
        //Rechazando transacciones
        if (!empty($trans['TRANS_CODE'])) {
            ClxCommon::$db->updateRecord($this->fiatname, array('TRANS_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($trans ['TRANS_CODE']));
            $sql = 'UPDATE CLX_AC_AUTHORIZATIONS AUTH SET AUTH.AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE AUTH.TABLECODE = ' . singleQuote('FIAT') . ' AND AUTH.AUTH_STATUS = ' . singleQuote('PEND') . ' AND EXISTS (SELECT FIAT.ID FROM ' . $this->fiatname . ' FIAT WHERE FIAT.ID = AUTH.REC_ID AND FIAT.IDCODE = ' . singleQuote($trans ['TRANS_CODE']) . ')';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Actualiza estado del la transaccion acorde al asiento
     */
    function jehd_update_fiat($jehd_code) {
        $jehdrec = ClxCommon::$db->getFields($this->jehdname, 'TRANS_CODE, JE_STATUS, REV_JEHDR_CODE', 'JE_STATUS = ' . singleQuote('AP') . ' AND IDCODE = ' . singleQuote($jehd_code));
        $reversed = (!empty($jehdrec ['REV_JEHDR_CODE'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        $sql = 'UPDATE ' . $this->jehdname . ' SET REVERSED = ' . $reversed . ' WHERE IDCODE IN (' . singleQuote($jehd_code) . ',' . singleQuote($jehdrec ['REV_JEHDR_CODE']) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.CLX_AUTH_STATUS = ' . singleQuote('AP') . ',  FIAT.TRANS_STATUS = ' . singleQuote('AP') . ', FIAT.VOID = ' . $reversed . ', FIAT.REVERSED = ' . $reversed . ' WHERE FIAT.IDCODE IN (SELECT JEHD.TRANS_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE IN (' . singleQuoteArray(array($jehd_code, $jehdrec ['REV_JEHDR_CODE'])) . '))';
        ClxCommon::$db->executeQuery($sql);
    }

    function jehd_update_fiat_batch($batch_id) {
        $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.CLX_AUTH_STATUS = (SELECT MAX(JEHD.CLX_AUTH_STATUS) FROM ' . $this->jehdname . ' JEHD WHERE JEHD.TRANS_CODE = FIAT.IDCODE ), FIAT.TRANS_STATUS = (SELECT MAX(JEHD.JE_STATUS) FROM ' . $this->jehdname . ' JEHD WHERE JEHD.TRANS_CODE = FIAT.IDCODE ) WHERE FIAT.IDCODE IN (SELECT JEHD.TRANS_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.BATCH_ID = ' . singleQuote($batch_id) . ') AND FIAT.TRANS_STATUS IN (' . singleQuoteArray(array('OPQU', 'PEND')) . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Send journal to queue for approval
     *
     * @param string $jehd_code
     * @return boolean
     */
    function jehd_approve_queue_by_code($jehd_code) {
        if (!class_exists('Gloq'))
            includeCodeLib('GLOQ');
        $gloq = new Gloq ();
        $gloq->pushJehdListing($jehd_code, true);
        unset($gloq);
        return true;
    }

    /**
     * Changes the transaction estatus after validations
     *
     * @param
     *        	: String journal code
     * @return : boolean true if entry was approved correctly
     */
    function jehd_approve_by_code($jehd_code) {
        if (!defined('send_alert')) {
            define('send_alert', true); // set alerts to be sent to alerts
        }
        if (!defined('proc_fiat_jehd_approval')) {
            define('proc_fiat_jehd_approval', true); // set alerts to be sent to
        }
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        $msg = array();
        if (!$this->jehd_approve_by_code_validate($jehd_code, $msg)) {

            $sql = 'UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', JE_STATUS = ' . singleQuote('PEND') . ' WHERE IDCODE = ' . singleQuote($jehd_code) . ' AND JE_STATUS = ' . singleQuote('OPQU') . '';
            ClxCommon::$db->executeQuery($sql);
            addMessage($msg);
            return false;
        }
        ClxCommon::$db->executeQuery('UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', JE_STATUS = ' . singleQuote('AP') . ' WHERE JE_STATUS IN (' . singleQuote('PEND') . ',' . singleQuote('OPQU') . ') AND IDCODE = ' . singleQuote($jehd_code));
        $status = (ClxCommon::$db->countRecords($this->jehdname, 'JE_STATUS = ' . singleQuote('AP') . ' AND IDCODE = ' . singleQuote($jehd_code)) > CLX_NUM_ZERO);
        $this->jehd_update_fiat($jehd_code);
        $this->jehd_set_lines_seqnum('', $jehd_code);
        // Actualizar Libros
        if (!class_exists('Leba')) {
            includeCodeLib('LEBA');
        }
        $leba = new Leba ();
        $leba->leba_update_jehd($jehd_code);
        unset($leba);

        // Updating Bank Account Balances
        //Done massive
        $sql = 'SELECT COUNT(FIBK.BANK_ACCOUNT_NO) QTY FROM ' . $this->fibkname . ' FIBK, ' . $this->fiasname . ' FIAS, ' . $this->jelnname . ' JELN WHERE JELN.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            if (!class_exists('fibk_utilities'))
                includeCodeLib('FIBK');
            $fibk = new fibk_utilities ();
            $fibk->update_balances_by_jehd($jehd_code);
            unset($fibk);
        }
        // Updating Share Holdes Position
        if (!empty($this->inphname)) {
            if (!class_exists('Inph'))
                includeCodeLib('INPH');
            $inph = new Inph ();
            $inph->sum_pay_dividends($jehd_code);
            unset($inph);
        }


        // Updating loan balances
        if (!empty($this->filoname)) { // test if module exists
            if (!class_exists('Filo'))
                includeCodeLib('FILO');
            $filo = new Filo ();
            $filo->update_balances_jehd($jehd_code, false);
            unset($filo);
        }


        // Updating guarranty balances
        if (!empty($this->guarname)) { // test if module exists
            if (!class_exists('Guar'))
                includeCodeLib('GUAR');
            $guar = new Guar ();
            $guar->update_balances_jehd($jehd_code, false);
            unset($guar);
        }
        // Setting payment status for AR and AP
        if (!empty($this->invoname)) {
            if (!class_exists('Invo'))
                includeCodeLib('INVO');
            $invo = new Invo ();
            $invo->post_jehd_approve($jehd_code);
            unset($invo);
        }
        if (!empty($this->apinname)) {
            if (!class_exists('Apin'))
                includeCodeLib('APIN');
            $apin = new Apin();
            $apin->post_jehd_approve($jehd_code);
            unset($apin);
        }
        //update indexation items
        if (!empty($this->glcrname)) {
            if (!class_exists('Glcr'))
                includeCodeLib('GLCR');
            $glcr = new Glcr();
            $glcr->monetary_indexation_approval($jehd_code);
            unset($glcr);
        }

        //Actualizando conciliaciones
        if (!empty($this->glrcname)) {
            if (!class_exists('GLRC'))
                includeCodeLib('GLRC');
            $glrc = new Glrc();
            $glrc->setGlrcAmtByJehd($jehd_code);
            unset($glrc);
        }

        //Actualizando saldos de fin de mes si operacion es con fecha valor.
        //El saldo se actualiza si la operacion es menor al primer dia del
        //mes de la fecha de operaciones. Los saldos de fin de mes se sumarizan
        //el ultimo dia del mes por lo que operaciones previas deben actualizar los
        //saldos mensuales.
        $sql = 'SELECT JEHD.COMP_CODE, JEHD.EFFTDATE, GLCP.OPERATION_DATE FROM ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = ' . singleQuote($jehd_code) . ' AND JEHD.EFFTDATE < GLCP.OPERATION_DATE';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $last_day = adodb_prev_month_lastday($r['OPERATION_DATE'], 'Y-m-d');
            if ($last_day >= $r['EFFTDATE']) {
                if (!class_exists('Jebl'))
                    includeCodeLib('JEBL');
                $jebl = new Jebl();
                $jebl->rebuild_balances_since($r['COMP_CODE'], $r['EFFTDATE']);
                unset($jebl);
            }
        }
//Procesing Back Value
        if ($this->back_value_enabled) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            if (class_exists('Fias')) {
                $fias = new Fias();
                $fias->build_back_value($jehd_code);
            }
        }
        $this->jehd_settle($jehd_code);
        return $status;
    }

// end funcion
    /**
     * Changes the transaction estatus after validations starting by batch id
     *
     * @param
     *        	: String batch id
     * @return : boolean true if entry was approved correctly
     */
    function jehd_approve_by_batch_id($batch_id) {
        $sql = 'SELECT IDCODE FROM ' . $this->jehdname . ' WHERE JE_STATUS = ' . singleQuote('PEND') . ' AND BATCH_ID = ' . singleQuote($batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            ClxFreeReturn($this->jehd_approve_by_code($r['IDCODE']));
        }

        $status = (ClxCommon::$db->countRecords($this->jehdname, 'JE_STATUS = ' . singleQuote('PEND') . ' AND BATCH_ID = ' . singleQuote($batch_id)) == CLX_NUM_ZERO);
        return $status;
    }

// end funcion
    /**
     * Performs transaction validations.
     *
     * @param unknown_type $trans_code
     * @param unknown_type $msg
     * @return unknown
     */
    function jehd_approve_by_code_validate($jehd_code, &$msg) {
        $record = ClxCommon::$db->getRecord($this->jehdname, 'IDCODE = ' . singleQuote($jehd_code));
        foreach ($record as $key => $val) {
            $record ['JEHD_' . $key] = $val;
            unset($record [$key]);
        }
        ClxFreeReturn($this->jehd_validate_form($record, $msg));

        return (empty($msg)) ? true : false;
    }

// end method
// Reversal functions
    /**
     * Execute bottom demand from listing jehd
     */
    function jehd_reverse_build() {
        $idlist = toString(getIdlist());
        $results = ClxCommon::$db->executeQuery('SELECT IDCODE FROM ' . $this->jehdname . ' WHERE ID IN (' . $idlist . ')');
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            ClxFreeReturn($this->jehd_reverse($result ['IDCODE']));
        }
    }

    /**
     * Reverses transacion
     * @param string $jehdr_code
     * @param string $rev_trans_code
     * @param string $rev_activity_code
     * @return string|unknown
     */
    function jehd_reverse($jehdr_code, $rev_trans_code = '', $rev_activity_code = '') {
        $new_jehdr_code = '';
// Validating if not reverse of reverse
        if (!$this->jehd_reverse_validate($jehdr_code))
            return $new_jehdr_code;
        $record = ClxCommon::$db->getRecord($this->jehdname, 'IDCODE = ' . singleQuote($jehdr_code) . ' AND JE_STATUS = ' . singleQuote('AP'));
// REV Transaccion Generation
        $revtrans = $record;
        unset($revtrans ['ID'], $revtrans ['REAL_DATE']);
        $revtrans ['REV_JEHDR_CODE'] = $jehdr_code;
        $revtrans ['CLX_AUTH_STATUS'] = 'PEND';
        $revtrans ['JE_STATUS'] = 'PEND';
        $revtrans ['IDCODE'] = 'AUTO';
        $revtrans ['ADJUSTMENT'] = CLX_NUM_ONE;
//Desmarcar como reverso el reverso de un reverso.
        if (!empty($record['REV_JEHDR_CODE'])) {
            $revtrans ['REVERSED'] = CLX_INIT_ZERO;
            $revtrans ['REV_JEHDR_CODE'] = 'null';
        }
        if ($rev_trans_code <> '') {
            $revtrans ['TRANS_CODE'] = $rev_trans_code;
        }
        if ($rev_activity_code <> '') {
            $revtrans['INAT_CODE'] = $rev_activity_code;
        }
        $this->jehd_build($revtrans);
        $new_jehdr_code = $revtrans ['IDCODE'];
        unset($revtrans);
// Doing lines
        $sql = 'INSERT INTO ' . $this->jelnname . '(JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($new_jehdr_code) . ' JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, CREDIT_AMT DEBIT_AMT, DEBIT_AMT CREDIT_AMT, CREDIT_TRANS_AMT DEBIT_AMT, DEBIT_TRANS_AMT CREDIT_AMT, RECONCILIED FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($jehdr_code);
        ClxCommon::$db->executeQuery($sql);
        return $new_jehdr_code;
    }

    /**
     * Reversal validations
     */
    function jehd_reverse_validate($jehdr_code) {
        $record = ClxCommon::$db->getRecord($this->jehdname, 'IDCODE = ' . singleQuote($jehdr_code) . ' AND JE_STATUS = ' . singleQuote('AP'));
        $status = true;
        if (empty($record)) {
            addMessage(smsg('MSG-45', $jehdr_code));
            return false;
        }

        //AND (REVERSED=1 OR RECORD_BLOCKING<>0)' ) > 0) {
        if (!empty($record ['TRANS_CODE']) && ClxCommon::$db->countRecords($this->fiatname, 'IDCODE = ' . singleQuote($record ['TRANS_CODE']) . ' AND (REVERSED=1)') > CLX_NUM_ZERO) {
            //Si el cheque ya fue procesado la operaci�n no puede ser reversada. Transaccion 00019643 (MSG-46) addMessage ( smsg ( 'MSG-46', $jehdr_code ) );  [3] Transaction already reversed. Transaction ^1
            addMessage('[3] ' . smsg('MSG-44', $record ['TRANS_CODE']));
            return false;
        }
        //cuentas por cobrar
        $sql = ClxCommon::$db->executeQuery('SELECT INVO.IDCODE, INVO.INVO_STAT FROM ' . $this->jehdname . ' JEHD, ' . $this->invoname . ' INVO WHERE JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND JEHD.IDCODE = INVO.JEHDR_CODE');
        $invo_res = ClxCommon::$db->getNextRecord($sql);
        if ($invo_res === true) {
            if ($invo_res['INVO_STAT'] === '01') {
                if (ClxCommon::$db->countRecords($this->fiatname, 'REFERENCE_NO = ' . singleQuote($invo_res['IDCODE']) . ' AND CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND TRANS_STATUS = ' . singleQuote('AP') . ' AND REVERSED = 0') == CLX_NUM_ZERO) {
                    return true;
                } else {//Tienen Pagos Realizados
                    addMessage(smsg('MSG-398', $invo_res['IDCODE']));
                    return false;
                }
            } else {//Factura Tiene Estado diferente de 'No Pagado'
                addMessage(smsg('MSG-399', $invo_res['IDCODE']));
                return false;
            }
        }
        //cuentas por pagar
        $sql = ClxCommon::$db->executeQuery('SELECT APIN.IDCODE, APIN.INVO_STAT FROM ' . $this->jehdname . ' JEHD, ' . $this->apinname . ' APIN WHERE ' . 'JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND JEHD.IDCODE = APIN.JEHDR_CODE');
        $apin_res = ClxCommon::$db->getNextRecord($sql);
        if ($apin_res === true) {
            if ($apin_res['INVO_STAT'] === '01') {
                if (ClxCommon::$db->countRecords($this->fiatname, 'REFERENCE_NO = ' . singleQuote($apin_res['IDCODE']) . ' AND CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND TRANS_STATUS = ' . singleQuote('AP') . ' AND REVERSED = 0') == CLX_NUM_ZERO) {
                    return true;
                } else {//Tienen Pagos Realizados
                    addMessage(smsg('MSG-398', $apin_res['IDCODE']));
                    return false;
                }
            } else {//Factura Tiene Estado diferente de 'No Pagado'
                addMessage(smsg('MSG-399', $apin_res['IDCODE']));
                return false;
            }
        }
        return $status;
    }

    /**
     *
     * @param unknown_type $comp_code
     * @param unknown_type $je_source
     * @param unknown_type $operation_date
     */
    function jehd_reverse_by_je_source($comp_code, $je_source, $operation_date) {

        $sql = 'UPDATE ' . $this->jehdname . ' SET JE_STATUS = ' . singleQuote('REJ') . ', CLX_AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE JE_SOURCE = ' . singleQuote($je_source) . ' AND COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE >= ' . singleQuote($operation_date) . ' AND JE_STATUS =' . singleQuote('PEND');
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.TRANS_STATUS = ' . singleQuote('REJ') . ', CLX_AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE FIAT.IDCODE IN (SELECT JEHD.TRANS_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.JE_STATUS = ' . singleQuote('REJ') . ' AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.EFFTDATE >= ' . singleQuote($operation_date) . ' AND JEHD.TRANS_CODE IS NOT null AND JEHD.TRANS_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')';
        ClxCommon::$db->executeQuery($sql);
        // Reject any posible todays entry from this process thas has run today
        $sql = 'SELECT IDCODE FROM ' . $this->jehdname . ' WHERE JE_SOURCE = ' . singleQuote($je_source) . ' AND COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($operation_date) . ' AND JE_STATUS = ' . singleQuote('AP') . ' AND REVERSED = 0';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC))) {
            $rev_jehdr_code = $this->jehd_reverse($result [CLX_NUM_ZERO]);
            if (!empty($this->display))
                echoLog(dict('GEN_LBL_REVERSING') . ' JEHD: ' . $result [CLX_NUM_ZERO] . '->' . $rev_jehdr_code);
            ClxFreeReturn($this->jehd_approve_by_code($rev_jehdr_code));
        }
        unset($rev_jehdr_code);
    }

    /**
     * Build GL Header
     * @param array $record
     */
    function jehd_build(&$record) {
        if (empty($record['IDCODE'])) {
            $record['IDCODE'] = 'AUTO';
        }
        if (empty($record['CLX_AUTH_STATUS']) || $record['CLX_AUTH_STATUS'] === 'null')
            $record['CLX_AUTH_STATUS'] = 'PEND';
        if (empty($record['JE_STATUS']) || $record['JE_STATUS'] === 'null')
            $record['JE_STATUS'] = 'PEND';
        if (empty($record['JE_SOURCE']) || $record['JE_SOURCE'] === 'null')
            $record['JE_SOURCE'] = 'USR';
        if (empty($record['ADJUSTMENT']) || $record['ADJUSTMENT'] === 'null')
            $record['ADJUSTMENT'] = CLX_INIT_ZERO;
        if (empty($record['INT_SALE_COMPLETE']) || $record['INT_SALE_COMPLETE'] === 'null')
            $record['INT_SALE_COMPLETE'] = CLX_INIT_ZERO;
        if (empty($record['HAS_INVOICE']))
            $record['HAS_INVOICE'] = CLX_INIT_ZERO;
        if (empty($record['IS_PAYMENT']))
            $record['IS_PAYMENT'] = CLX_INIT_ZERO;
        if (empty($record['IS_CASH_OPER']) || $record['IS_CASH_OPER'])
            $record['IS_CASH_OPER'] = CLX_INIT_ZERO;
        if (empty($record['IS_ARCHIVE']) || $record['IS_ARCHIVE'] === 'null')
            $record['IS_ARCHIVE'] = CLX_INIT_ZERO;
        if (empty($record['REV_JEHDR_CODE']))
            $record['REV_JEHDR_CODE'] = 'null';
        if (empty($record['TRANS_CODE']))
            $record['TRANS_CODE'] = 'null';
        if (empty($record['INAT_CODE']))
            $record['INAT_CODE'] = 'null';
        if (empty($record['TRANSTBL_CODE']))
            $record['TRANSTBL_CODE'] = 'null';
        if (empty($record['REQ_CHANNEL']))
            $record['REQ_CHANNEL'] = 'SYS';
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        //Validar que la fecha de la operacion
        //sea menor o igual a la contabilidad +1 dia
        $comp = new Comp();
        if (!array_key_exists('COMP_CODE', $record)) {
            $comprec = $comp->comp_operation_parameters();
        } else {
            $comprec = $comp->comp_operation_parameters($record['COMP_CODE']);
        }

        if (!array_key_exists('EFFTDATE', $record)) {
            $record['EFFTDATE'] = $comprec['OPERATION_DATE'];
        }

        if (!array_key_exists('REAL_DATE', $record) || empty($record['REAL_DATE']) || $record['REAL_DATE'] === '' || $record['REAL_DATE'] === 'null' || $record['REAL_DATE'] == '0000-00-00') {
            $record['REAL_DATE'] = $comprec['OPERATION_DATE'];
        }

        if (!array_key_exists('COMP_CODE', $record))
            $record['COMP_CODE'] = $comprec['IDCODE'];
        if (!array_key_exists('FISCAL_PERIOD', $record) || $record['FISCAL_PERIOD'] === 'null' || empty($record['FISCAL_PERIOD'])) {
            if ($record['EFFTDATE'] <> $comprec['OPERATION_DATE']) {
                $record['FISCAL_PERIOD'] = $comp->comp_fiscal_period($record['COMP_CODE'], $record['EFFTDATE']);
            } else {
                $record['FISCAL_PERIOD'] = $comprec['FISCAL_PERIOD'];
            }
        }
        if (!array_key_exists('LGGROUP_CODE', $record) || $record['LGGROUP_CODE'] === 'null' || empty($record['LGGROUP_CODE'])) {
            $record['LGGROUP_CODE'] = $comprec['LGGROUP_CODE'];
        }
        if (empty($record['REQ_CHANNEL']))
            $record['REQ_CHANNEL'] = 'SYS';
        if (empty($record['BRANCH'])) {
            $sql = 'SELECT COLO.IDCODE FROM ' . $this->coloname . ' COLO, ' . $this->dyclname . ' DYCL WHERE DYCL.COMPLOC_CODE = COLO.IDCODE AND DYCL.COMP_CODE = ' . singleQuote($record['COMP_CODE']) . ' AND COLO.ISPRIMARY = 1';
            $record['BRANCH'] = ClxCommon::$db->getOne($sql);
            if ($record['BRANCH'] === '')
                $record['BRANCH'] = 'null';
        }
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        if ($record['IDCODE'] === 'AUTO') {
            setCreationData($record);
            setCreationIdCode($record, 'JEHD');
            ClxCommon::$db->createRecord($this->jehdname, $record, false);
        } else {
            setModificationData($record);
            ClxCommon::$db->updateRecord($this->jehdname, $record, 'IDCODE = ' . singleQuote($record['IDCODE']));
        }
    }

    /**
     * Clear journal entry
     */
    function jehd_delete($idcode) {
        if (!class_exists('Jeln'))
            includeCodeLib('JELN');
        $jeln = new Jeln ();
        if ($this->jehd_is_editable($idcode)) {
            $jeln->jeln_delete_lines($idcode);
            ClxCommon::$db->deleteRecords($this->jehdname, 'IDCODE = ' . singleQuote($idcode));
        }
    }

    /**
     * Initialices jehb record
     */
    function jehd_init_record() {
        $fields = array();
        $DBTB = &getTool('DBTB');
        $fields = $DBTB->tableDefaultRecord('JEHD');
        foreach ($fields as $key => $val) {
            $value = null;
            switch ($key) {
                case 'REQ_CHANNEL' :
                    $value = 'SYS';
                    break;
                case 'BRANCH' :
                    $value = '';
                    break;
                case 'CLOSING_ENTRY' :
                    $value = CLX_INIT_ZERO;
                    break;
                case 'JE_SOURCE' :
                    $value = 'USR';
                    break;
                case 'JE_STATUS' :
                    $value = 'PEND';
                    break;
                case 'IDCODE' :
                    $value = 'AUTO';
                    break;
                case 'REVERSED' :
                case 'HAS_INVOICE' :
                case 'IS_PAYMENT' :
                case 'IS_ARCHIVE' :
                case 'IS_' :
                    $value = CLX_INIT_ZERO;
                    break;
                default :
                    break;
            }
            $fields [$key] = $value;
        }
        unset($fields['ID']);
        return $fields;
    }

// end method
    /**
     * Returns journal header code
     */
    function jehd_get_idcode_by_transcode($trans_code) {
        return ClxCommon::$db->getField($this->jehdname, 'IDCODE', 'TRANS_CODE = ' . singleQuote($trans_code));
    }

    /**
     * Returns journal header status
     */
    function jehd_get_status($idcode) {
        return ClxCommon::$db->getField($this->jehdname, 'JE_STATUS', 'IDCODE = ' . singleQuote($idcode));
    }

    /**
     * Returns true if journal can be modified
     */
    function jehd_is_editable($idcode) {
        return $this->jehd_get_status($idcode) === 'PEND';
    }

    /**
     * Test if header exists
     */
    function jehd_exists($idcode) {
        return (ClxCommon::$db->countRecords($this->jehdname, 'IDCODE = ' . singleQuote($idcode)) > CLX_NUM_ZERO) ? true : false;
    }

    function jehd_build_lines($record) {
        if (empty($record ['TRANSTBL_CODE']) || $record ['TRANSTBL_CODE'] === 'null')
            return false;
        if (!empty($record ['TRANS_CODE']) && $record ['TRANS_CODE'] !== 'null')
            return false;
        if (!class_exists('Jeln'))
            includeCodeLib('JELN');
        $sql = 'SELECT COUNT(FITB.ID) FROM ' . $this->fitbname . ' FITB WHERE FITB.IDCODE = ' . singleQuote($record ['TRANSTBL_CODE']) . ' AND FITB.RESTRICTED = 1';
        $qty = ClxCommon::$db->getOne($sql);
        if ($qty > CLX_NUM_ZERO)
            return; // restricted just return
        $jeln = new Jeln ();
        $sql = 'DELETE FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($record ['IDCODE']);
        ClxCommon::$db->executeQuery($sql);
// Crear lineas de transaccion
        $sql = 'SELECT FITB.IDNAME, FITS.DEBIT_CREDIT, FITS.ITEM_CODE, FITS.GLACCOUNTCODE, FITS.FORMULA_CODE, JEIT.FLAT_RATE, JEIT.EXEMPT_TAX_AMT, JEIT.TAX_WITHOLDING_PCT, JEIT.TAX_TYPE, JEIT.FILING_STATUS, JEIT.STATE, JEIT.COUNTRY, FITS.SEQNUM, 1 EXCHANGE_RT, 1 CUR_OPERATOR, 0 DEBIT_AMT, 0 CREDIT_AMT, (SELECT CURRENCY_CODE FROM ' . $this->compname . ' WHERE IDCODE = ' . singleQuote($record ['COMP_CODE']) . ') CURRENCY_CODE, (case FITS.AFFECT_TYPE WHEN ' . singleQuote('E') . ' THEN IFNULL((SELECT GLCP.EQ_GL_CODE FROM ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE =' . singleQuote($record ['COMP_CODE']) . '),' . singleQuote('999') . ') WHEN ' . singleQuote('C') . ' THEN IFNULL( (SELECT PRAT.PRO_GL_CODE GLACCOUNTCODE FROM ' . $this->fibkname . ' FIBK, ' . $this->glcpname . ' GLCP, ' . $this->pratname . ' PRAT WHERE FIBK.BANK_ACCOUNT_NO = GLCP.DEF_BANKACC_CODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GLCP.COMP_CODE= ' . singleQuote($record ['COMP_CODE']) . '),' . singleQuote('999') . ') WHEN ' . singleQuote('OT') . ' THEN  FITS.GLACCOUNTCODE ELSE  ' . singleQuote('999') . 'END) GLACCOUNTCODE FROM ' . $this->fitbname . ' FITB,' . $this->fitsname . ' FITS,' . $this->jeitname . ' JEIT WHERE JEIT.IDCODE = FITS.ITEM_CODE AND FITS.TRANSTBL_CODE = FITB.IDCODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->jeitname . ' X WHERE X.IDCODE = FITS.ITEM_CODE AND X.CLX_EFFTDATE<=' . singleQuote($record ['EFFTDATE']) . ') AND FITB.IDCODE = ' . singleQuote($record ['TRANSTBL_CODE']) . ' AND FITS.STATUS = ' . singleQuote('A') . '';
        $results = ClxCommon::$db->executeQuery($sql);
        $clear_jeln_rec = $jeln->jeln_init_record();
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $jeln_rec = $clear_jeln_rec;
            foreach ($jeln_rec as $key => $val) {
                if (array_key_exists($key, $result))
                    $jeln_rec [$key] = $result [$key];
            }
            $jeln_rec ['JEHDR_CODE'] = $record ['IDCODE'];
            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
            $jeln->jeln_build($jeln_rec);
        }
    }

    /**
     * Setting seqnum
     *
     * @param string $batch_id
     * @param string $jehdr_code
     */
    function jehd_set_lines_seqnum($batch_id, $jehdr_code) {
        $sql = 'UPDATE ' . $this->jelnname . ' JELN,' . $this->jehdname . ' JEHD SET JELN.SEQNUM = 0 WHERE JEHD.JE_SOURCE<> '.singleQuote('SETT').' AND JELN.JEHDR_CODE = JEHD.IDCODE AND JELN.DEBIT_AMT<>0 ';
        if ($batch_id !== '') {
            $sql .= ' AND JEHD.BATCH_ID = ' . singleQuote($batch_id);
        }
        if ($jehdr_code !== '') {
            $sql .= ' AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code);
        }
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jelnname . ' JELN,' . $this->jehdname . ' JEHD SET JELN.SEQNUM = 1 WHERE JEHD.JE_SOURCE<> '.singleQuote('SETT').' AND JELN.JEHDR_CODE = JEHD.IDCODE AND JELN.CREDIT_AMT<>0 ';
        if ($batch_id !== '') {
            $sql .= ' AND JEHD.BATCH_ID = ' . singleQuote($batch_id);
        }
        if ($jehdr_code !== '') {
            $sql .= ' AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code);
        }
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     *
     * @param unknown_type $jehdr_code
     */
    function jehd_settle($jehdr_code) {
        $sql = 'SELECT DISTINCT JELN.CHART_FIELD01 CONTRACT_CODE, JELN.CHART_FIELD02 PARTICIPANT_ID FROM ' . $this->fiatname . ' FIAT, ' . $this->jehdname . ' JEHD,' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.TRANSTBL_CODE = ' . singleQuote('SYS_DESIN') . ' AND JEHD.JE_SOURCE = ' . singleQuote('SETT') . ' AND JEHD.IDCODE = ' . singleQuote($jehdr_code);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (!class_exists('Fipa'))
                includeCodeLib('FIPA');
            $fipa = new Fipa ();
            $fipa->fipa_settle_status($result ['CONTRACT_CODE'], $result ['PARTICIPANT_ID']);
            unset($fipa);
        }
    }

    /**
     * Permite Ajustar diferencia por diferencia cambiaria hasta +/- 0.1
     * si monto de cambio es diferente a 1
     * @param string $jehdr_code
     */
    function balance_exchange_rounding($jehdr_code, $by_batch_id = false) {
        if ($by_batch_id === true) {
            $sql = 'SELECT JEHDR_CODE, CHART_FIELD01, CHART_FIELD02, MAX(ID) ID, ROUND(SUM(DEBIT_AMT-CREDIT_AMT), 2) DIF FROM ' . $this->jelnname . ' WHERE JEHDR_CODE IN (SELECT IDCODE FROM ' . $this->jehdname . ' WHERE BATCH_ID = ' . singleQuote($jehdr_code) . ') AND EXCHANGE_RT <> 1 GROUP BY JEHDR_CODE, CHART_FIELD01, CHART_FIELD01 HAVING ROUND(SUM(DEBIT_AMT-CREDIT_AMT), 2) BETWEEN -0.1 AND 0.1 ';
        } else {
            $sql = 'SELECT CHART_FIELD01, CHART_FIELD02, MAX(ID) ID, ROUND(SUM(DEBIT_AMT-CREDIT_AMT), 2) DIF FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND EXCHANGE_RT <> 1 GROUP BY CHART_FIELD01, CHART_FIELD01 HAVING ROUND(SUM(DEBIT_AMT-CREDIT_AMT), 2) BETWEEN -0.1 AND 0.1 ';
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->jelnname . ' SET DEBIT_AMT = DEBIT_AMT + ' . ($r['DIF'] * -CLX_NUM_ONE) . ' WHERE ID = ' . $r['ID'] . ' AND DEBIT_AMT > 0.1 AND CREDIT_AMT = 0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->jelnname . ' SET CREDIT_AMT = CREDIT_AMT + ' . ($r['DIF'] * -CLX_NUM_ONE) . ' WHERE ID = ' . $r['ID'] . ' AND CREDIT_AMT > 0.1 AND DEBIT_AMT = 0';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Achiving process for JEHD
     * @param string $comp_code Company code where archival is required.
     * @param int $mode mode of archival, 1=summary by process, 2 = year archive
     */
    function archive($comp_code, $mode = CLX_NUM_ONE) {
        //1. Select dates to archiva according to mode.
        //2. call
        if (empty($comp_code))
            return;
        if ($mode == CLX_NUM_ONE) {//summary method
            //From date is last archival date or min date available if no archival is found.
            //To date is the closest last day of the month less or equal to the backvalue allowed.
            $sql = 'SELECT LAST_ARCH_MODE1 FROM_DATE, ADDDATE(ADDDATE(DATE_FORMAT(OPERATION_DATE, ' . singleQuote('%Y-%m-0') . '), INTERVAL -2 MONTH), INTERVAL -1 DAY) TO_DATE FROM ' . $this->glcpname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' HAVING FROM_DATE<TO_DATE LIMIT 4';
            $prmt = ClxCommon::$db->getOneRecord($sql);
            if (empty($prmt))
                return;
            $this->archive_mode1($comp_code, $prmt['FROM_DATE'], $prmt['TO_DATE']);
        }elseif ($mode == CLX_NUM_TWO) {//archive
        }
        return;
    }

    /**
     * JEHD Archival Method for mode 1. Summary of large processes is summarized
     */
    private function archive_mode1($comp_code, $from_date, $to_date) {
        $contenidoHTML = '';
        //Check if tables exists

        if (!ClxCommon::$db->tableExists($this->jehhname) || !ClxCommon::$db->tableExists($this->jelhname)) {
            $contenidoHTML = 'Tables JEHH and JELH missing. saliring process<br>';
            echo $contenidoHTML;
            return;
        }
        $sql = 'SELECT DISTINCT JEHD.JE_STATUS, JEHD.JE_SOURCE, JEHD.FISCAL_PERIOD, JEHD.LGGROUP_CODE, DATE_FORMAT(JEHD.EFFTDATE, ' . singleQuote('%Y-%m-01') . ' FROM_DATE, ADDDATE(ADDDATE(DATE_FORMAT(JEHD.EFFTDATE, ' . singleQuote('%Y-%m-0') . '),INTERVAL 1 MONTH), INTERVAL -1 DAY) TO_DATE FROM ' . $this->jehdname . ' JEHD LEFT JOIN ' . $this->jehhname . ' JEHH  ON JEHH.IDCODE = JEHD.IDCODE WHERE JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE IN (' . singleQuote('CRL') . ',' . singleQuote('PINT') . ') AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHH.ID IS NULL ORDER BY TO_DATE ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Archivando lineas
            $this->archive_mode1_jeln($comp_code, $r['FROM_DATE'], $r['TO_DATE'], $r['JE_SOURCE'], $r['JE_STATUS'], $r['FISCAL_PERIOD'], $r['LGGROUP_CODE']);
            //Archivando encabezados
            $this->archive_mode1_jehd($comp_code, $r['FROM_DATE'], $r['TO_DATE'], $r['JE_SOURCE'], $r['JE_STATUS'], $r['FISCAL_PERIOD'], $r['LGGROUP_CODE']);
            //Asiento sumarizado
            $this->archive_mode1_sum($comp_code, $r['FROM_DATE'], $r['TO_DATE'], $r['JE_SOURCE'], $r['JE_STATUS'], $r['FISCAL_PERIOD'], $r['LGGROUP_CODE']);
            //borrando lineas de detalle
            $this->archive_mode1_del($comp_code, $r['FROM_DATE'], $r['TO_DATE'], $r['JE_SOURCE'], $r['JE_STATUS'], $r['FISCAL_PERIOD'], $r['LGGROUP_CODE']);
            //Commit entries
            ClxCommon::$db->commit();
        }
        //Set last archive mode
        $sql = 'UPDATE ' . $this->glcpname . ' SET LAST_ARCH_MODE1 = ' . singleQuote($to_date) . ' WHERE COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
    }

    /**
     * Builds model lines
     *
     * @param type $comp_code
     * @param type $from_date
     * @param type $to_date
     */
    private function archive_mode1_jehd($comp_code, $from_date, $to_date, $je_source, $je_status, $fiscal_period, $lggroup_code) {
        $sql = 'INSERT INTO ' . $this->jehhname . '(YEAR_NO, ID, IDCODE, EFFTDATE, JE_SOURCE, COMP_CODE, CDATE, MDATE, TRANS_CODE, CLOSING_ENTRY, CREATEDBY, MODIFIEDBY, IDNAME, CLX_AUTH_STATUS, REVERSED, REV_JEHDR_CODE, BATCH_ID, TRANSTBL_CODE, BRANCH, REQ_CHANNEL, LGGROUP_CODE, FISCAL_PERIOD, JE_STATUS, ADJUSTMENT, INT_SALE_COMPLETE, REAL_DATE, HAS_INVOICE, INAT_CODE, IS_CASH_OPER, IS_PAYMENT) SELECT YEAR(JEHD.EFFTDATE) YEAR_NO, JEHD.ID, JEHD.IDCODE, JEHD.EFFTDATE, JEHD.JE_SOURCE, JEHD.COMP_CODE, JEHD.CDATE, JEHD.MDATE, JEHD.TRANS_CODE, JEHD.CLOSING_ENTRY, JEHD.CREATEDBY, JEHD.MODIFIEDBY, JEHD.IDNAME, JEHD.CLX_AUTH_STATUS, JEHD.REVERSED, JEHD.REV_JEHDR_CODE, JEHD.BATCH_ID, JEHD.TRANSTBL_CODE, JEHD.BRANCH, JEHD.REQ_CHANNEL, JEHD.LGGROUP_CODE, JEHD.FISCAL_PERIOD, JEHD.JE_STATUS, JEHD.ADJUSTMENT, JEHD.INT_SALE_COMPLETE, JEHD.REAL_DATE, JEHD.HAS_INVOICE, JEHD.INAT_CODE, JEHD.IS_CASH_OPER, JEHD.IS_PAYMENT FROM ' . $this->jehdname . ' JEHD LEFT JOIN ' . $this->jehhname . ' JEHH ON JEHH.IDCODE = JEHD.IDCODE WHERE JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.JE_STATUS = ' . singleQuote($je_status) . ' AND JEHD.FISCAL_PERIOD = ' . singleQuote($fiscal_period) . ' AND JEHD.LGGROUP_CODE = ' . singleQuote($lggroup_code) . ' AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' AND JEHH.ID IS NULL';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds model lines
     *
     * @param type $comp_code
     * @param type $from_date
     * @param type $to_date
     */
    private function archive_mode1_jeln($comp_code, $from_date, $to_date, $je_source, $je_status, $fiscal_period, $lggroup_code) {
        $sql = 'INSERT INTO ' . $this->jelhname . '(YEAR_NO, ID, GLACCOUNTCODE, JEHH_CODE, CREDIT_TRANS_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, DEBIT_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, RECONCILIED, SEQNUM, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, ITEM_CODE, ITEM_REF_NO) SELECT YEAR(JEHD.EFFTDATE) YEAR_NO, JELN.ID, JELN.GLACCOUNTCODE, JELN.JEHDR_CODE JEHH_CODE, JELN.CREDIT_TRANS_AMT, JELN.CREDIT_AMT, JELN.DEBIT_TRANS_AMT JELN.DEBIT_AMT, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.RECONCILIED, JELN.SEQNUM, JELN.CURRENCY_CODE, JELN.EXCHANGE_RT, JELN.CUR_OPERATOR, JELN.ITEM_CODE, JELN.ITEM_REF_NO FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN LEFT JOIN ' . $this->jehhname . ' JELH ON JELH.ID = JELN.ID WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.JE_STATUS = ' . singleQuote($je_status) . ' AND JEHD.FISCAL_PERIOD = ' . singleQuote($fiscal_period) . ' AND JEHD.LGGROUP_CODE = ' . singleQuote($lggroup_code) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' AND JELH.ID IS NULL';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Creating Summary Entry
     * @param type $comp_code
     * @param type $from_date
     * @param type $to_date
     */
    private function archive_mode1_sum($comp_code, $from_date, $to_date, $je_source, $je_status, $fiscal_period, $lggroup_code) {
        $jehd_init_rec = $this->jehd_init_record();
        $DBLT = &getTool('DBLT');
        //Seleccionando comprobantes por mes
        $record = $jehd_init_rec;
        $record['IDNAME'] = substr($DBLT->getListItem('SOTY', $je_source), CLX_NUM_ZERO, CLX_NUM_60);
        $record['COMP_CODE'] = $comp_code;
        $record['JE_SOURCE'] = $je_source;
        $record['FISCAL_PERIOD'] = $fiscal_period;
        $record['LGGROUP_CODE'] = $lggroup_code;
        $record['EFFTDATE'] = $to_date;
        $record['REAL_DATE'] = $to_date;
        $record['IS_ARCHIVE'] = CLX_NUM_ONE;
        $record['JE_STATUS'] = $je_status;
        $this->jehd_build($record);
        $jehdr_code = $record['IDCODE'];
        $contenidoHTML = '<br>Summary Entry Created' . $jehdr_code . ' for:<br>--' . $comp_code . '|' . $from_date . '|' . $to_date . '|' . $je_source . '|' . $je_status . '|' . $fiscal_period . '|' . $lggroup_code;
        echo $contenidoHTML;
        //Including Lines
        $sql = 'INSERT INTO ' . $this->jelnname . ' (GLACCOUNTCODE, JEHDR_CODE, CREDIT_TRANS_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, DEBIT_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, RECONCILIED, SEQNUM, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, ITEM_CODE, ITEM_REF_NO) SELECT JELN.GLACCOUNTCODE, ' . singleQuote($jehdr_code) . ' JEHDR_CODE, SUM(JELN.CREDIT_TRANS_AMT) CREDIT_TRANS_AMT, SUM(JELN.CREDIT_AMT) CREDIT_AMT, SUM(JELN.DEBIT_TRANS_AMT) DEBIT_TRANS_AMT, SUM(JELN.DEBIT_AMT) DEBIT_AMT, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.RECONCILIED, JELN.SEQNUM, JELN.CURRENCY_CODE, case JELN.CUR_OPERATOR WHEN 1 THEN ROUND(SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)/SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT), 5) WHEN -1 THEN ROUND(SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)/SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT), 5) ELSE 0 END EXCHANGE_RT, JELN.CUR_OPERATOR, JELN.ITEM_CODE, JELN.ITEM_REF_NO FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.JE_STATUS = ' . singleQuote($je_status) . ' AND JEHD.FISCAL_PERIOD = ' . singleQuote($fiscal_period) . ' AND JEHD.LGGROUP_CODE = ' . singleQuote($lggroup_code) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' GROUP BY JELN.GLACCOUNTCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.RECONCILIED, JELN.SEQNUM, JELN.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.ITEM_CODE, JELN.ITEM_REF_NO';
        ClxCommon::$db->executeQuery($sql);
        //Set status
        $sql = 'UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', JE_STATUS = ' . singleQuote($je_status) . ' WHERE IDCODE = ' . singleQuote($jehdr_code);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Creating Summary Entry
     * @param type $comp_code
     * @param type $from_date
     * @param type $to_date
     */
    private function archive_mode1_del($comp_code, $from_date, $to_date, $je_source, $je_status, $fiscal_period, $lggroup_code) {
        $sql = 'DELETE JELN.* FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.JE_STATUS = ' . singleQuote($je_status) . ' AND JEHD.FISCAL_PERIOD = ' . singleQuote($fiscal_period) . ' AND JEHD.LGGROUP_CODE = ' . singleQuote($lggroup_code) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date);
        ClxCommon::$db->executeQuery($sql);
        //Delete encabezados
        $sql = 'DELETE JEHD.* FROM ' . $this->jehdname . ' JEHD WHERE JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.JE_STATUS = ' . singleQuote($je_status) . ' AND JEHD.FISCAL_PERIOD = ' . singleQuote($fiscal_period) . ' AND JEHD.LGGROUP_CODE = ' . singleQuote($lggroup_code) . ' AND JEHD.IS_ARCHIVE = 0 AND JEHD.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date);
        ClxCommon::$db->executeQuery($sql);
    }
	
	/**
     * Validate transaction by $jehdr_code
     * @param type $jehdr_code
     * @param type $msg
     * @return type
     */
    function jehd_validate_by_code($jehdr_code, &$msg){
       // global $db;

        $jehdrec = ClxCommon::$db->getRecord($this->jehdname, "IDCODE = '" . $jehdr_code . "'");
        if (!empty($jehdrec)) {
            foreach ($jehdrec as $key => $val) {
                $jehdrec ['JEHD_' . $key] = $val;
            }
        } else {
            $msg ['JEHD_TRANS_STATUS'] = smsg('MSG-41', $jehdr_code);
        }
        $this->jehd_validate_form($jehdrec, $msg);

        return (!empty($msg))?false:true;
    }

}
