<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-02 10:43:11 -0400 (Fri, 02 Oct 2015) $
 * @version        $Rev: 7085 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Prbe {

    function __construct($procParameters = array()) {
        multiTableName($this, array('PRBE', 'GLCP', 'PRPT'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {

    }

    function prompt_dialog($title, $formcode, &$msg) {
        $contents = '';
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = UserRequest::$request['it'];
        //RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        if (!empty($record['confirm'])) {
            $EDIT->checkForm2($msg, $formrec);
            $sql = 'SELECT COUNT(ID) FROM ' . $this->prbename . ' WHERE REC_STATUS IN (' . singleQuoteArray(array('IDLE', 'ERRO')) . ') AND CUST_FILEID = ' . singleQuote($record['RTBL_CUST_FILEID']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg['RTBL_CUST_FILEID'] = smsg('MSG-244', $record['RTBL_CUST_FILEID']);
            }
            //Validando que contrato tenga parametros
            $sql = 'SELECT COUNT(PRBE.ID) FROM ' . $this->prbename . ' PRBE WHERE PRBE.REC_STATUS IN (' . singleQuoteArray(array('IDLE', 'ERRO')) . ') AND PRBE.CUST_FILEID = ' . singleQuote($record['RTBL_CUST_FILEID']) . ' AND NOT EXISTS(SELECT PRPT.ID FROM ' . $this->prptname . ' PRPT WHERE PRBE.CONTRACT_CODE = PRPT.CONTRACT_CODE)';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg['RTBL_CUST_FILEID'] = smsg('MSG-246', $record['RTBL_CUST_FILEID']);
            }
            if (empty($msg)) {
                //Reset prbe status on error
                $sql = 'UPDATE ' . $this->prbename . ' SET REC_STATUS = ' . singleQuote('IDLE') . ' WHERE REC_STATUS = ' . "'ERRO'" . ' AND CUST_FILEID = ' . singleQuote($record['RTBL_CUST_FILEID']);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'SELECT MAX(GLCP.OPERATION_DATE) FROM ' . $this->prbename . ' PRSO, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = PRSO.COMP_CODE AND PRSO.CUST_FILEID = ' . singleQuote($record['RTBL_CUST_FILEID']);
                $prmt = array('CUST_FILEID' => $record['RTBL_CUST_FILEID'],
                    'TRANS_DATE' => ClxCommon::$db->getOne($sql));
                $PRSC = getTool('PRSC');
                $PRSC->runScheduleOneTimeNow('PRSO', $prmt);
                $note = dict('UTIL_DBBK_PROC_SCHEDULED') . '<ul><li>' . dict('GEN_LBL_BATCH_ID') . ': ' . $record['RTBL_CUST_FILEID'] . '</li>' . '<li>' . dict('GEN_LBL_OPERATION_DATE') . ': ' . $prmt['TRANS_DATE'] . '</li></ul>';
                $contents .= note($note, dict('GEN_LBL_CONTINUE'));
                unset($note);
            }
        }
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title, dict('GEN_LBL_EXECUTE'));
        return $form->source() . $contents;
    }

}
