<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-05-23 11:43:58 -0400 (Mon, 23 May 2016) $
 * @version        $Rev: 8256 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Slap {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('SLAP', 'SLAA', 'ACTI', 'PROD', 'ACCO', 'OPPO', 'SRRP'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice fiai form
     * Executed on init event
     */
    function init_form(&$record) {
        if (UserRequest::$request['ac'] == 'DUPLICATE') {
            $record ['SLAP_IDCODE'] = 'AUTO';
        }
    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {

    }

// end function
    /**
     * Save form post database comit
     * @param unknown_type $record
     */
    function save_form_post(&$record) {

    }

    /**
     * Builds activities based in opportunity.
     * @param unknown_type $opporec
     */
    function process_opportunity($opporec) {
        includeCodeLib('ACTI');
        $acti = new Acti();
        //Actividades a generar seran todas aquellas sin dependencia.
        //Otras actividades post dependencia se colocaran al modificar
        //actividad.
        $sql = 'SELECT SLAA.ASSIGN_RULE, case SLAA.ASSIGN_RULE WHEN ' . singleQuote('RL') . ' THEN SRRP.USER_CODE WHEN ' . singleQuote('RO') . ' THEN SRRP.USER_CODE ELSE OPPO.ASSIGNEDTO_USER END ASSIGNEDTO_USER, OPPO.IDCODE OPPORTUNITYCODE, OPPO.PRODUCTCODE PRODUCT_CODE, OPPO.COMP_CODE, OPPO.ACCOUNTCODE, OPPO.ASSIGNEDTO_USER OWNERCODE, OPPO.CDATE START_DTTM, SLAA.ID SLAA_CODE, SLAA.* FROM SFA_OPPORTUNITIES OPPO, SFA_SLSACTPLN_TBL SLAP, SFA_SLSACTI_ASSIGN SLAA LEFT JOIN SERV_ROLE_PARTICIPANTS SRRP ON SRRP.ROLE_CODE = SLAA.ROLE_CODE WHERE SLAP.IDCODE = SLAA.SLAP_CODE AND SLAP.CLX_EFFTDATE = SLAA.CLX_EFFTDATE AND SLAP.STATUS = ' . singleQuote('A') . ' AND (SLAA.ACTI_DEPEND IS NULL OR SLAA.ACTI_DEPEND =' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND SLAP.CLX_EFFTDATE = (SELECT MAX(SLAPX.CLX_EFFTDATE) FROM SFA_SLSACTPLN_TBL SLAPX WHERE SLAPX.IDCODE = SLAP.IDCODE AND SLAPX.CLX_EFFTDATE<=' . singleQuote($this->now) . '  AND SLAPX.STATUS = ' . singleQuote('A') . ') AND SLAP.PRODUCT_CODE = OPPO.PRODUCTCODE AND OPPO.IDCODE =' . singleQuote($opporec['IDCODE']);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            unset($r['ID']);
            //ACTI_DUEDATE, ACTI_START_DTTM, SLAA_DURATION_UNITS, SLAA_DURATION_PER -> D, H,M
            $r['DUEDATE'] = adodb_period_date($r['START_DTTM'], $r['DURATION_PER'], $r['DURATION_UNITS'], 'Y-m-d H:i:s');
            $r['COMPLETE_DATE'] = 'null';
            $r['LAST_ESCALATION'] = 'null';
            $r['LAST_REMINDER'] = 'null';
            $r['REMINDER'] = 'null';
            $acti->create_activity($r);
        }
    }

    /**
     * Builds next activity information.
     * @param unknown_type $activity_id
     */
    function process_activity($activity_id) {
        includeCodeLib('ACTI');
        $acti = new Acti();
        //Llamado post commit de acti update
        $sql = 'SELECT SLAA.ASSIGN_RULE, case SLAA.ASSIGN_RULE WHEN ' . singleQuote('RL') . ' THEN SRRP.USER_CODE WHEN ' . singleQuote('RO') . ' THEN SRRP.USER_CODE ELSE OPPO.ASSIGNEDTO_USER END ASSIGNEDTO_USER, OPPO.IDCODE OPPORTUNITYCODE, OPPO.PRODUCTCODE PRODUCT_CODE, OPPO.COMP_CODE, OPPO.ACCOUNTCODE, OPPO.ASSIGNEDTO_USER OWNERCODE, SLAA.ID SLAA_CODE, ACTI.MDATE START_DTTM, SLAA.* FROM ' . $this->actiname . ' ACTI, ' . $this->opponame . ' OPPO, ' . $this->slapname . ' SLAP, ' . $this->slaaname . ' SLAA LEFT JOIN ' . $this->srrpname . ' SRRP ON SRRP.ROLE_CODE = SLAA.ROLE_CODE WHERE SLAP.IDCODE = SLAA.SLAP_CODE AND SLAP.CLX_EFFTDATE = SLAA.CLX_EFFTDATE AND SLAP.STATUS = ' . singleQuote('A') . ' AND ACTI.ACTIVITY_STATUS = SLAA.ACTI_DEPSTAT AND SLAA.ACTI_DEPEND = ACTI.SLAA_CODE AND ACTI.ID = ' . $activity_id . '   AND SLAP.CLX_EFFTDATE = (SELECT MAX(SLAPX.CLX_EFFTDATE) FROM SFA_SLSACTPLN_TBL SLAPX WHERE SLAPX.IDCODE = SLAP.IDCODE AND SLAPX.CLX_EFFTDATE<=' . singleQuote($this->now) . ' AND SLAPX.STATUS = ' . singleQuote('A') . ') AND SLAP.PRODUCT_CODE = OPPO.PRODUCTCODE AND OPPO.IDCODE = ACTI.OPPORTUNITYCODE AND NOT EXISTS(SELECT ACTI2.ID FROM ' . $this->actiname . ' ACTI2 WHERE ACTI2.SLAA_CODE = SLAA.ID AND ACTI2.OPPORTUNITYCODE = ACTI.OPPORTUNITYCODE AND ACTI2.OWNERCODE = ACTI.OWNERCODE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            unset($r['ID']);
            $r['DUEDATE'] = adodb_period_date($r['START_DTTM'], $r['DURATION_PER'], $r['DURATION_UNITS'], 'Y-m-d H:i:s');
            $r['COMPLETE_DATE'] = 'null';
            $r['LAST_ESCALATION'] = 'null';
            $r['LAST_REMINDER'] = 'null';
            $r['REMINDER'] = 'null';
            $acti->create_activity($r);
        }
    }

}
