<?php
/**
* General Code File
* For more information contact  support@alenet.com
* 
* @author       Edgard Campos
* @copyright    Alenet, Inc.
* @since        $Date: 2020-06-26 15:01:21 -0500 
* @version        $Rev: 0001 $
* 
* CHANGE LOG
**/

class web_services {

	var $curl;
	var $token_type;
	var $access_token;
	var $rol_user;
	
	var $error;
	var $message;
    var $tablename; 
	/**
	 * Constructor
	 */
    function __construct() {
        multiTableName($this, array('FILO', 'FICO','FIPA', 'ACCO','SRRQ'));
		$token_type=null;
		$access_token=null;
		$error='';
		$message='';
		$CODE = &getTool('CODE'); 
	} // end function

	function ws_login($login = null , $password = null, $autoservice = false) {
		$this->curl = curl_init();
        if (!$autoservice){
          $curlopt_url = CODE_IBS_WS_URL_LOGIN;
        }else{
          $curlopt_url = CODE_IBS_WS_URL_LOGIN_AUTOSERVICE;
        }
		curl_setopt_array($this->curl, array(
          CURLOPT_URL => $curlopt_url,
          CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS =>"\r\n{\r\n  \"username\" : \"".$login."\",\r\n  \"password\" : \"".$password."\"\r\n\r\n}",
		  CURLOPT_HTTPHEADER => array(
			"x-api-key: ".CODE_IBS_WS_API_KEY,
			"Content-Type: application/json"
		  ),
		));

		$response = curl_exec($this->curl);
        //$errno = curl_errno($this->curl)
		//Si hay un error en la conexión capturo el error
        if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
		    //verifico que no haya recibido un error en el header de la respuesta
			if ($this->isErrorHeader($response,1)){
				$response=null;
			}else{
				// si la respuesta no tiene error en el header tomó el token
				//convierte JSON en un Arreglo
				//echo "la respuesta es un Json";
				//pre ($response);
				$response = json_decode($response,TRUE);

				$this->token_type=$response['token_type'];
				$this->access_token=$response['access_token'];			
				$this->rol_user=$response['scope'];		
			}
		}

		return $response;

	} // end function

	function ws_logout() {
 		curl_close($this->curl);
    }

	function isJson($string) {
 		json_decode($string);
 		return (json_last_error() == JSON_ERROR_NONE);
    }
	
	function getError() {
 		return $this->error. ': <br> ' . $this->message ;
    }
	
	function getRol() {
 		return $this->rol_user ;
    }
	
	function getToken() {
 		return $this->access_token ;
    }
	
	function isErrorCurl($curl) {
		//Si hay un error en la conexión capturo el error
		if($errno = curl_errno($curl)) {
    		$error_message = curl_strerror($errno);
    		//echo "cURL error ({$errno}):\n {$error_message}";
			$this->error='Error';	
			$this->message= "{$errno}".' : '."{$error_message}";
			return true;
		}else{
			return false;
		}
	
	}
	
	//validar el tipo de error de Header en respuesta del IBS
	function isErrorHeader($response, $modelogin = 0) {
		$this->error='';
		$this->message='';
		//pre ($response);
	    //$http_code = curl_getinfo( $this->curl, CURLINFO_HTTP_CODE);
		//echo $http_code;
		//El error viene en el header
		switch ($http_code = curl_getinfo( $this->curl, CURLINFO_HTTP_CODE)) {
			case 200: return false;# OK
				      break;
			case 400: $this->error='Error 400';	
					  $this->message='Bad Request';
				      return true;
					  break;	
			case 401: if ($modelogin==1){
						  $this->error='';	
					      $this->message=dict('GEN_ERR_USERNAME_INVALID');			
					  }else{
						  $this->error='Error 401';	
					      $this->message=dict('GEN_LBL_UNAUTHORIZED');	
					  }
				      return true;
					  break;
			case 404: $this->error='Error 404';	
					  $this->message='No Found';
				      return true;
					  break;
			case 409: $this->error=dict('GEN_LBL_WARNING');	
					  $this->message='Un criterio no coincide. Verificar o corregir criterios';
				      return false;
					  break;
/*			case 500: $this->error='Error 500';	
					  $this->message='Error Interno en el Servidor';
				      return true;
					  break;	*/	
			default:
				//en una repuesta de Header tipo 500 podemos recibir un xml o un JSON y debe tratarse de formas distintas
                if (!$this->isJson($response)){
					//La respuesta es un error de tipo 500, se recibe en XML no un JSON
					//se convierte XML en un objeto -> JSON -> luego obtener el arreglo
					//convierte  xml string en un objeto
					$xml_response = simplexml_load_string($response);
					//convierte  objeto en un JSON
					$json_resp = json_encode($xml_response);
					//convierte JSON en un Arreglo
					$response = json_decode($json_resp,TRUE); 	
					//pre ($response);
					//procesamos el error que llego, puede venir de dos formas. Identificamos cuál
					if (array_key_exists('errors', $response)){
						//con error 500 me puede venir la descripcion del error de esta forma
						$response=$response['errors'][0];
						//$response=$response[0];
						$this->error=$response['level'];	
						if (array_key_exists('field', $response)){
							$this->message=$response['field'].': '.$response['message'];
						}else{
							$this->message=$response['message'];
						}
						//echo 'Unexpected HTTP code: ', $http_code, "\n";
					}else{
						//El error viene en otra estructura
						$this->error=$response['status'];	
						$this->message=$response['error'];
					}
				}else{
					//convierte JSON en un Arreglo
					$array_response = json_decode($response,TRUE);
					//el arreglo de respuesta puede contener uno o mas errores
					//pre($array_response);
					if (array_key_exists('errors', $array_response)){
						foreach ($array_response['errors'] as $error) {
							$this->error=$error['level'];	
							if (array_key_exists('field', $error)){
								$this->message.=$error['field'].': '.$error['message'].'<br>';
							}else{
								$this->message.=$error['message'].'<br>';
							}

							//$this->message.=$error['message'].'<br>';
						}
					}else{
						//El error viene en otra estructura
						$this->error=$array_response['status'];	
						if (array_key_exists('message', $array_response)){
						    $this->message=$array_response['message'];
						}else{
							$this->message=$array_response['error'];
						}
					}
					//pre ($array_response['errors']);
				}
				return true;
	    }
    }

	//Busqueda de cliente por CUSCUN en IBS
	function ws_search_client($record){
		  $this->curl = curl_init();
		  $legalType='';
		  if ($record['ACCO_LEGAL_TYPE']=='I'||$record['ACCO_LEGAL_TYPE']=='E'){
			 $legalType='personal';
		  }else{
			 $legalType='corporate'; 
		  }

		  curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_COSTUMER_SEARCH."/".$legalType."/". $record['ACCO_IBS_CUSCUN'] ."/INQUIRY",
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "GET",
		  CURLOPT_HTTPHEADER => array(
			"Authorization: ".$this->token_type." ".$this->access_token,
			"Content-Type: application/json"
		  ),
		));

		$json_response = curl_exec($this->curl);

		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			if ($this->isErrorHeader($json_response)){
					$response=null;
			}else{
				//convierte el JSON en un arreglo	
				$response=json_decode($json_response,TRUE);	
                $response=$response['body'][0];
			}		
			return 	$response;
		}
	}
	
	//Para crear un cheque en el IBS
	function ws_create_check($record){
		$this->curl = curl_init();
	    //pre($record);
		curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_OFFICIAL_CHECK."/create/".$record['bank']."/".$record['format_check']."/".$record['currency'],
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "GET",
		  CURLOPT_HTTPHEADER => array(
			"Authorization: ".$this->token_type." ".$this->access_token
		  ),
		));

		$json_response = curl_exec($this->curl);

		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			if ($this->isJson($json_response)){
				//convierte el JSON en un arreglo
				$response=json_decode($json_response,TRUE);	

			}else{
				//verifico que no haya recibido un error en el header de la respuesta
				if ($this->isErrorHeader($json_response)){
					$response=null;
				}			
			}
		}

		return 	$response;

	}

	//Para solicitar la actualización de los datos del cheque en el IBS
	function ws_req_saved_record_check($record){

		$json_record_check=json_encode($record);
		
		//pre ($json_record_check); 
		//exit;
		$this->curl = curl_init();
		
		curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_OFFICIAL_CHECK."/save",
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS => $json_record_check,
		  CURLOPT_HTTPHEADER => array(
			"Authorization: ".$this->token_type." ".$this->access_token,
			"Content-Type: application/json"
		  ),
		));	
		
		$json_response = curl_exec($this->curl);

		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			if ($this->isJson($json_response)){
				if ($this->isErrorHeader($json_response)){
					$response=null;
				}else{
					$response=json_decode($json_response,TRUE);	
				}		
			}else{
				//verifico que no haya recibido un error en el header de la respuesta
				if ($this->isErrorHeader($json_response)){
					$response=null;
				}			
			}
		}
	
		return 	$response;
		
	}
	
	
	//Para realizar busqueda de cheques
	function ws_srch_check($record){
		
		$json_srch_check=json_encode($record);
		
		$this->curl = curl_init();
		
		curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_OFFICIAL_CHECK."/search",
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS => $json_srch_check,
		  CURLOPT_HTTPHEADER => array(
			"Authorization: ".$this->token_type." ".$this->access_token,
			"Content-Type: application/json"
		  ),
		));	
		
		$json_response = curl_exec($this->curl);

		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			if ($this->isJson($json_response)){
				if ($this->isErrorHeader($json_response)){
					$response=null;
				}else{
					$response=json_decode($json_response,TRUE);	
					if ($response==null){
						$response['found'] = 0;
					}
				}		
			}else{
				//verifico que no haya recibido un error en el header de la respuesta
				if ($this->isErrorHeader($json_response)){
					$response=null;
				}			
			}
		}
	
		return 	$response;
		
	}
	
	
	 /*
     * Applicant data retrieval
     * @param array, text
     * @return array
     */
    function applicant_data_get($s_contract_code) {
        $DBLT = getTool('DBLT');
        $record = array();
        $record['CONTRACT_CODE'] = $s_contract_code;
	    $sql = 'SELECT
                ACCO.IDCODE ACCO_IDCODE,
                ACCO.IDNAME APPLICANT_NAME,
                ACCO.IDENTIFICATION APPLICANT_IDENTIFICATION,
                ACCO.IBS_CUSCUN APPLICANT_IBS_CUSCUN,
                ACCO.ADDRESS1 APPLICANT_ADDRESS1,
                ACCO.ADDRESS2 APPLICANT_ADDRESS2,
                ACCO.CITY APPLICANT_CITY,
                ACCO.STATE APPLICANT_STATE,
                ACCO.ZIPCODE APPLICANT_ZIPCODE,
                ACCO.COUNTRY APPLICANT_COUNTRY 
            FROM
                ' . $this->fipaname . ' FIPA
                LEFT JOIN ' . $this->acconame . ' ACCO ON ACCO.IDCODE = FIPA.ACCOUNTCODE ';
  
            // New acco version
            $sql.= 'WHERE FIPA.CONTRACT_CODE = ' . singleQuote($s_contract_code) . ' AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB')) . ')';
        
        
			$sql.= 'ORDER BY FIPA.ISPRIMARY DESC';

        
        $ar_applicant = ClxCommon::$db->getOneRecord($sql);
        if (!empty($this->debug))
            echoLog(debug_dump('ar_applicant', $ar_applicant));
            $record['APPLICANT_NAME'] = $ar_applicant['APPLICANT_NAME'];
            $record['APPLICANT_IDENTIFICATION'] = $ar_applicant['APPLICANT_IDENTIFICATION'];
            $record['APPLICANT_IBS_CUSCUN'] = $ar_applicant['APPLICANT_IBS_CUSCUN'];
            $record['APPLICANT_ADDRESS1'] = $ar_applicant['APPLICANT_ADDRESS1'];
            $record['APPLICANT_ADDRESS2'] = $ar_applicant['APPLICANT_ADDRESS2'];
            $record['APPLICANT_ZIPCODE'] = $ar_applicant['APPLICANT_ZIPCODE'];
            $record['APPLICANT_CITY'] = ($ar_applicant['APPLICANT_CITY'] === '') ? '' : $DBLT->getListItem('LOCI', $ar_applicant['APPLICANT_CITY'], CLX_NUM_TWO);
            $record['APPLICANT_STATE'] = ($ar_applicant['APPLICANT_STATE'] === '') ? '' : $DBLT->getListItem('VZST', $ar_applicant['APPLICANT_STATE'], CLX_NUM_TWO);
            $record['APPLICANT_COUNTRY'] = ($ar_applicant['APPLICANT_COUNTRY'] === '') ? '' : $DBLT->getListItem('COUN', $ar_applicant['APPLICANT_COUNTRY'], CLX_NUM_TWO);
            $record['APPLICANT_ADDRESS3'] = $record['APPLICANT_CITY'] . ' ' . trim($record['APPLICANT_STATE'] . ' ' . $record['APPLICANT_ZIPCODE']);
        
        return $record;
    }
	
	
	 /*
     * Beneficiary data retrieval
     * @param array, text
     * @return array
     */
    function beneficiary_data_get($idcode_beneficiary) {
        $DBLT = getTool('DBLT');
        $record = array();
        $sql = 'SELECT 
	       ACCO.IDCODE ACCO_IDCODE, ACCO.IDNAME ACCO_IDNAME, ACCO.IDENTIFICATION ACCO_IDENTIFICATION
           FROM 
           CRM_ACCOUNTS ACCO ';
           // New acco version
        $sql.= 'WHERE ACCO.IDCODE= ' . singleQuote($idcode_beneficiary);
        
        $beneficiary = ClxCommon::$db->getOneRecord($sql);
        $record['ACCO_IDNAME'] = $beneficiary['ACCO_IDNAME'];
        $record['ACCO_IDENTIFICATION'] = $beneficiary['ACCO_IDENTIFICATION'];
        return $record;
    }

	
	//preparando la data del cheque  para enviar al ibs
	function ws_prepares_record_check($resp_req_print_check, $record){
		//pre($record);
		
		$DBLT = getTool('DBLT');
        //$EBSK = getTool('EBSK');
		//$resp_req_print_check['addressLine1'] = $record['ADDRESS'];
		//$resp_req_print_check['addressLine2'] = ''; 
		//$resp_req_print_check['addressLine3'] = '';
		//$resp_req_print_check['amountInletters'] = 'ciento veinte y cinco'; 
		
		$applicant = $this->applicant_data_get($record['CONTRACT_CODE']);
        
		$resp_req_print_check['applicant'] =$applicant['APPLICANT_NAME']; //campo a enviar
		$resp_req_print_check['applicantId'] = $applicant['APPLICANT_IBS_CUSCUN']; //campo a enviar
		$resp_req_print_check['applicantLine1'] = ''; //campo a enviar
		$resp_req_print_check['applicantLine2'] = ''; //campo a enviar		
		//$resp_req_print_check['approvalFlad'] = ''; 
		//$resp_req_print_check['bank'] = 01; //campo a enviar
		//$resp_req_print_check['batchNumer'] = 0;
		//$resp_req_print_check['beneficiary'] = $record['LEGAL_NAME_ACCO'];	//campo a enviar
		if ($record['FIAT_BENEFICIARY_CODE']!=''){
			$beneficiary= $this->beneficiary_data_get($record['FIAT_BENEFICIARY_CODE']); 
			$resp_req_print_check['beneficiary'] = $beneficiary['ACCO_IDNAME']; //campo a enviar		
		    $resp_req_print_check['beneficiaryID'] = $beneficiary['ACCO_IDENTIFICATION']; //campo a enviar	
		}else{
		     $resp_req_print_check['beneficiary'] = $record['BENEFICIARY_NAME']; //campo a enviar
			 $resp_req_print_check['beneficiaryID'] = $record['IDENTIFICATION']; //campo a enviar	
		}

		
		$resp_req_print_check['beneficiaryLine'] = ''; //campo a enviar
		$resp_req_print_check['beneficiaryLine2'] = ''; //campo a enviar
		//$resp_req_print_check['branch'] = 1; //campo a enviar
		$resp_req_print_check['checkAmount'] = number_format($record['TRANS_AMT'], CLX_NUM_TWO, '.', ''); //campo a enviar
		//$resp_req_print_check['checkClass'] = ''; 	
		//$resp_req_print_check['checkDescription'] = 'CHEQUES GERENCIA SUCURSALES'; viene del IBS
		//$resp_req_print_check['checkFormat'] = 1; // campo a enviar
		//$resp_req_print_check['checkFormatSel'] = ''; 	
		$resp_req_print_check['checkNumber'] = 0; //campo a enviar
		//$resp_req_print_check['checkOriginSel'] = ''; 
		//$resp_req_print_check['checkTypeSel'] = ''; 
		//$resp_req_print_check['cityCode'] = $record['CITY'];
		//$resp_req_print_check['cityName'] = $record['BENEFICIARY_CITY'];
		//$resp_req_print_check['commissionAmount'] = 0;
		$resp_req_print_check['concepline1'] = $record['IDNAME']; // campo a enviar
		$resp_req_print_check['concepline2'] = ''; // campo a enviar
		$resp_req_print_check['concepline3'] = ''; // campo a enviar	
		//$resp_req_print_check['concept'] = $record['IDNAME'];
		$resp_req_print_check['correspondent'] = 0; // campo a enviar
		//$resp_req_print_check['currency'] = 'USD'; viene del IBS o clientix		
		//$resp_req_print_check['customerID'] = $record['ACCO_IBS_CUSCUN']; 		
		$resp_req_print_check['debitAccount'] = $record['FIDU_BANKACT_CODE']; // cuenta a debitar campo a enviar
		$resp_req_print_check['debitBank'] = $record['FIBK_BANK_CODE']; //cuenta contable a debitar campo a enviar
		$resp_req_print_check['debitBranch'] = EIBS_JOURNAL_ENTRY_EXPORT_BRANCH ; // Agencia  campo a enviar
		$resp_req_print_check['debitCurrency'] = $record['CURRENCY_CODE']; // Moneda campo a enviar
		$resp_req_print_check['debitGeneralLedger'] = '0'; // campo a enviar
		$resp_req_print_check['debitOperationCode'] = '01'; //$record['TRANSTBL_CODE'];		
		//$resp_req_print_check['flag2'] = ''; 
		//$resp_req_print_check['flag3'] = ''; 		
		//$resp_req_print_check['formAddress'] = ''; 		
		//$resp_req_print_check['fromCheck'] = 0;
		//$resp_req_print_check['fromInitalDay'] = 0;	
		//$resp_req_print_check['fromInitalMonth'] = 0;
		//$resp_req_print_check['toInitalYear'] = 0;
		//$resp_req_print_check['identificationType'] = $record['ACCO_ID_TYPE']; 		
		//$resp_req_print_check['issueBankSel'] = ''; 
		//$resp_req_print_check['issueBranchSel'] = 0;
		//$resp_req_print_check['issueCurrencySel'] = ''; 			
		//$resp_req_print_check['more'] = ''; 		
		//$resp_req_print_check['newCheckNumber'] = 0;		
		//$resp_req_print_check['operation'] = '0001';
		//$resp_req_print_check['paymentFlag'] = ''; 		
		//$resp_req_print_check['phoneNumber'] = $record['ACCO_PHONE'];
		//$resp_req_print_check['printedBranch'] = 0;		
		//$resp_req_print_check['printedFlagSel'] = 0;		
		//$resp_req_print_check['program'] = 'EOF0115';	viene del IBS	
		//$resp_req_print_check['saleTax'] = 0;		
		//$resp_req_print_check['screneCode'] = '01';  viene del IBS	
		$resp_req_print_check['startDateDay'] = xFormat::getNow('d');; //campo a enviar
		$resp_req_print_check['startDateMonth'] = xFormat::getNow('m');; //campo a enviar
		$resp_req_print_check['startDateYear'] = xFormat::getNow('Y');; //campo a enviar
		//$resp_req_print_check['systemTime'] = '200721151909';
		//$resp_req_print_check['toCheck'] = 0;		
		//$resp_req_print_check['toInitalDay'] = 0;		
		//$resp_req_print_check['toInitalMonth'] = 0;		
		//$resp_req_print_check['fromInitalYear'] = 0;		
		//$resp_req_print_check['userId'] = 'UNIALENET';
		//$resp_req_print_check['userLanguage'] = ''; 
		return $resp_req_print_check;
	}
	
	
	//Mapeo de campos en la respuesta del IBS busqueda de cliente figura personal
	function ws_mapping_fields_acco_personal_response($response_search){
		//Si es persona natural mapeamos lo siguiente
		$ar_acco=array();
			
		$ar_acco['IDCODE'] = 'AUTO';
		$ar_acco['IDNAME'] = $response_search['shortName'];
		$ar_acco['FIRSTNAME'] = $response_search['firstName'];
		$ar_acco['SECOND_NAME'] = $response_search['secondName'];
		$ar_acco['LASTNAME'] = $response_search['lastName'];
		$ar_acco['SECOND_LASTNAME'] = $response_search['secondLastName'];


		if ($response_search['legalType']=='2'){
			$ar_acco['LEGAL_TYPE'] = 'I';
			$isindividual=true;
		}else{
			$ar_acco['LEGAL_TYPE'] = 'C';
			$isindividual=false;
		}
		
		$ar_acco['ACCDEP']='AAA';
		
		$ar_acco['ASSIGNEDTO_USER'] = $_SESSION['user_record']['username'];
			
		$ar_acco['ACCTYPE']='';
		
		
		if ($response_search['id1Type']!='CID'){
			$ar_acco['ID_TYPE'] = $response_search['id1Type'];
	    }else{
		    $ar_acco['ID_TYPE'] = '';
		}

		if ($response_search['id1Type']=='CIP' || $response_search['id1Type']=='CID'){
			$ar_acco['IDENTIFICATION'] = $response_search['panamaId'];
		}else{
			$ar_acco['IDENTIFICATION'] = $response_search['identification1'];
		}
		
		$ar_acco['IDISS_DT'] = '0000-00-00';
		$ar_acco['IDEXP_DT'] = '0000-00-00';

		$ar_acco['IBS_CUSCUN'] = str_pad($response_search['customerNumber'], 9, '0', STR_PAD_LEFT);
		$ar_acco['ISINDIVIDUAL'] = $isindividual;

		$ar_acco['MARRIED_LASTNAME'] = $response_search['marriedSurname'];
		$ar_acco['MARRIED_NAME'] = $response_search['marriedSurname'];
		$ar_acco['ADDRESS1'] = $response_search['addressLine2'].'.'.$response_search['addressLine3'];
		$ar_acco['ADDRESS2'] = $response_search['addressLine4'];
		$ar_acco['CITY'] = $response_search['distric'];
		$ar_acco['STATE'] = $response_search['state'];
		$ar_acco['COUNTRY'] = $response_search['geographicalCode'];
		$ar_cont['CITIZENSHIP'] = $response_search['citizenship'];
		$ar_cont['MIGRA_STAT'] = $response_search['resident'];
		
		$ar_cont['ZIPCODE'] = $response_search['zipCode'];

		$ar_acco['BIRTH_COUNTRY'] = $response_search['birthCountry'];
		$ar_acco['BIRTHDATE'] = $response_search['birthYear'].'-'.$response_search['birthMonth'].'-'.$response_search['birthDay'];

		$ar_acco['SEX'] = $response_search['gender'];
		$ar_acco['MARITAL_STATUS'] = $response_search['maritalStatus'];

		// ACCSTAT, comentario: CUSTOMER STATUS '2.Inactivo 1.Activo 3.Lista Negra'
		$ar_acco['ACCSTAT'] = $response_search['customerStatus'];

		//Si existe set de traducciones para los campos PEP y Nivel e Riesgo las obtenemos de la BD
        $sql='SELECT CLX_TRANSLATE('.singleQuote($response_search['riskLevel']).',"UBK_ACRL", 0, 0) AS RISK_LEVEL, CLX_TRANSLATE('.singleQuote($response_search['classification']).',"UBK_PEPC", 0, 0) AS PEP_CLASS FROM DUAL';

        $rs = ClxCommon::$db->executeQuery($sql);
        if($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) { 
            $response_search['riskLevel']=$r['RISK_LEVEL'];
            $response_search['classification']=$r['PEP_CLASS'];
        }    

        //Obtener calificación de riesgo - Se deshabilita para que no se actualice
		//$ar_acco['RISK_LEVEL'] = $response_search['riskLevel'];

		$ar_acco['PHONE'] = $response_search['phone1'];
		$ar_acco['HOME_PHONE'] = $response_search['homePhone'];
		$ar_acco['EMAIL'] = $response_search['emailAddress'];

		$ar_acco['REFERREDBYNAME'] = $response_search['referByName'];
		//$ar_acco['INDUSTRYCLASS'] = $response_search['emailAddress'];

		$ar_acco['IDISS_DT'] = '0000-00-00';
		$ar_acco['IDEXP_DT'] = '0000-00-00';

		$ar_acco['CLIENT_SINCE_DATE'] = $response_search['registerYear'].'-'.$response_search['registerMonth'].'-'.$response_search['registerDay'];
		
		$ar_acco['INCOME_SOURCE'] = $response_search['incomeSource'];
		
		$ar_acco['EDUCATION'] = $response_search['d01EDL'];
		
		$ar_acco['EDUCATION_LEVEL'] = $response_search['educationLevel'];
		
		
		$ar_acco['PROFESSION_CODE'] = $response_search['userCode9'];
		
		$ar_acco['PROFESSION'] = $response_search['d01UC9'];
		
		$ar_acco['EMPLOYER'] = $response_search['d01UC5'];
		
		$ar_acco['INCOME_LEVEL'] = $response_search['incomeLevel'];
		
		$ar_acco['PEP_CLASS'] = $response_search['classification'];

		return $ar_acco;				
	}
	
	//Mapeo de campos en la respuesta del IBS busqueda de cliente figura Juridica
	function ws_mapping_fields_acco_corporate_response($response_search){
		//Si es persona juridica mapeamos lo siguiente
		$ar_acco=array();
			
		$ar_acco['IDCODE'] = 'AUTO';
		$ar_acco['IDNAME'] = $response_search['legalName'];

		if ($response_search['id1Type']!='CID'){
			$ar_acco['ID_TYPE'] = $response_search['id1Type'];
	    }else{
		    $ar_acco['ID_TYPE'] = '';
		}
		
		$ar_acco['IDENTIFICATION'] = $response_search['panamaId'];

		$ar_acco['LEGAL_TYPE'] = 'C';
		
		$ar_acco['IBS_CUSCUN'] = str_pad($response_search['customerNumber'], 9, '0', STR_PAD_LEFT);
		$ar_acco['ISINDIVIDUAL'] = false;
		$ar_acco['ADDRESS1'] = $response_search['addressLine2'].'.'.$response_search['addressLine3'];
		$ar_acco['ADDRESS2'] = $response_search['addressLine4'];
		$ar_acco['CITY'] = $response_search['distric'];
		$ar_acco['STATE'] = $response_search['state'];
		$ar_acco['COUNTRY'] = $response_search['geographicalCode'];
		$ar_acco['ZIPCODE'] = $response_search['zipCode'];
		
		$ar_acco['ACCDEP'] = 'AAA';
		
		$ar_acco['ASSIGNEDTO_USER'] = $_SESSION['user_record']['username'];
		
		$ar_acco['ACCTYPE'] = '';
		
		$ar_acco['LEGAL_NAME'] = $response_search['addressLine1'];
		
		$ar_acco['INCORPORATION_COUNTRY'] = $response_search['foundationCountry'];
		$ar_acco['INCORPORATION_DATE'] = $response_search['foundingYear'].'-'.$response_search['foundingMonth'].'-'.$response_search['foundingDay'];
		
		$ar_acco['CLIENT_SINCE_DATE'] = $response_search['availableYear1'].'-'.$response_search['availableMonth1'].'-'.$response_search['availableDay1'];
		
		
		$ar_acco['CORRESPONDENCE_LANGUAGE'] =  ($response_search['language'] === 'S' ? 'SP' : ($response_search['language'] === 'E' ? 'EN' : $response_search['language']));
		
		// ACCSTAT, comentario: CUSTOMER STATUS '2.Inactivo 1.Activo 3.Lista Negra'
		$ar_acco['ACCSTAT'] = $response_search['customerStatus'];

		//Si existe set de traducciones para los campos PEP y Nivel e Riesgo las obtenemos de la BD
        $sql='SELECT CLX_TRANSLATE('.singleQuote($response_search['riskLevel']).',"UBK_ACRL", 0, 0) AS RISK_LEVEL, CLX_TRANSLATE('.singleQuote($response_search['classification']).',"UBK_PEPC", 0, 0) AS PEP_CLASS FROM DUAL';
        $rs = ClxCommon::$db->executeQuery($sql);
        if($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) { 
            $response_search['riskLevel']=$r['RISK_LEVEL'];
            $response_search['pepTable']=$r['PEP_CLASS'];
        }    

        //Obtener calificación de riesgo
		$ar_acco['RISK_LEVEL'] = $response_search['riskLevel'];

		$ar_acco['PHONE'] = $response_search['businessPhone'];
		$ar_acco['FAX'] = $response_search['businessPhone2'];
		$ar_acco['EMAIL'] = $response_search['emailAddress'];
		
		$ar_acco['COSIZE_CLASS'] = $response_search['corporationSize1'];
		
		$ar_acco['INDUSTRYCLASS'] = $response_search['industryCode'];
		
		$ar_acco['EMPLOYEES'] = $response_search['numberEmployees'];
		
		$ar_acco['REFERREDBYNAME'] = $response_search['referByName'];
		
		$ar_acco['PEP_CLASS'] = $response_search['pepTable'];
		
		return $ar_acco;				
	}
    


} // end class
?>