<?php

require 'includes/constants.php';
require 'includes/includes.php';
PrepareConstants();
ConnectToDatabase();
initTools();
$ACUS = &getTool('ACUS');
$ACUS->login();
changeLanguage();
$PAGE_VARIABLES = getVariables();

function generateNewPassword() {
    $qty = CLX_NUM_SIX;
    $pass = '';
    mt_srand(make_seed());
    for ($i = CLX_INIT_ZERO; $i < $qty; $i++) {
        $pass .= chr(mt_rand(CLX_NUM_65, CLX_NUM_90));
    }
    $pass .= mt_rand(CLX_NUM_11, CLX_NUM_99);
    return $pass;
}

function make_seed() {
    list($usec, $sec) = explode(' ', microtime());
    return (float) $sec + ((float) $usec * CLX_NUM_HUNDRED_THOUSAND);
}

function welcomeMessage() {
    return dict('GEN_LBL_LOGIN_HELP_MSG');
}

function successMessage() {
    return dict('GEN_LBL_LOGIN_HELP_MSGSENT');
}

$contents = '';
$msg = array();
if (!empty(UserRequest::$post['mail'])) {
    $msg = array();
    xValidate::mail($msg, 'mail', UserRequest::$post['mail']);
    if (count($msg) === CLX_NUM_ZERO) {
        $qty = ClxCommon::$db->oneExistsRecordss('CLX_AC_USERS', 'STATUS = 1 AND EMAIL=' . singleQuote(UserRequest::$post['mail']));
        if ($qty === CLX_NUM_ZERO) {
            $variables = array();
            /*
             * GEN_LBL_LOGIN_HELP_MSG01
             * This e-mail address is not registered in our databases.
             * Esta dirección de e-mail no es reconocida en nuestras bases de datos.
             */
            $variables['MSG'] = dict('GEN_LBL_LOGIN_HELP_MSG01');
            $variables['MAIL'] = UserRequest::$post['mail'];
            $variables['WELCOME'] = welcomeMessage();
            $contents .= getSkinForm('loginhelp.html', $variables);
        } else {
            $info = ClxCommon::$db->getRecord('CLX_AC_USERS', 'EMAIL=' . singleQuote(UserRequest::$post['mail']));
            if (empty($info)) {
                $variables['MSG'] = dict('GEN_LBL_ERROR');
                $variables['MAIL'] = UserRequest::$post['mail'];
                $variables['WELCOME'] = welcomeMessage();
                $contents .= getSkinForm('loginhelp.html', $variables);
            } else {
                $newpass = generateNewPassword();
                $fields = array();
                $fields['PASSWORD'] = clx_mcript($newpass);
                $fields['LOGIN_ATTEMPTS'] = CLX_INIT_ZERO;
                ClxCommon::$db->updateRecord('CLX_AC_USERS', $fields, 'STATUS = 1 AND ID=' . $info['ID']);
                $to = UserRequest::$post['mail'];
                /*
                 * GEN_LBL_LOGIN_HELP_MSG02
                 * Your password for Clientix
                 * Su contraseña para Clientix
                 */
                $subject = dict('GEN_LBL_LOGIN_HELP_MSG02') . CLX_CHAR_NL . CLX_CHAR_NL;
                /*
                 * GEN_LBL_LOGIN_HELP_MSG03
                 * Here is the information you requested.
                 * A continuación encontrará la información por usted solicitada.
                 */
                $message = dict('GEN_LBL_LOGIN_HELP_MSG03') . CLX_CHAR_NL . CLX_CHAR_NL;
                /*
                 * GEN_LBL_LOGIN_HELP_MSG04
                 * Your username is
                 * Su nombre de usuario es
                 */
                $message .= dict('GEN_LBL_LOGIN_HELP_MSG04') . ': ' . $info['USERNAME'] . CLX_CHAR_NL;
                /*
                 * GEN_LBL_LOGIN_HELP_MSG05
                 * Your new password is
                 * Su nueva contraseña es
                 */
                $message .= dict('GEN_LBL_LOGIN_HELP_MSG05') . ': ' . $newpass . CLX_CHAR_NL . CLX_CHAR_NL;
                /*
                 * GEN_LBL_LOGIN_HELP_MSG06
                 * Remember that the passwords in Clientix are case sensitive.
                 * Recuerde que la contraseña en Clientix es sensible a las mayúsculas y minúsculas.
                 */
                $message .= dict('GEN_LBL_LOGIN_HELP_MSG06');
                //mail($to, $subject, $message);
                //$variables['MSG'] = successMessage();
                $from = kDefaultEmail;
                $message = str_replace(chr(10), '<br>', $message);
                $subject = 'Clientix password recovery'; // No se pudo arreglar problema con Ñ...
                $a_response = clx_mail_wres($from, $to, $message, $subject);
                $variables['MSG'] = ($a_response['error'] ? $a_response['errormsg'] : successMessage());
                $variables['MAIL'] = '';
                /*
                 * GEN_LBL_LOGIN_HELP_MSGSENT
                 * The new password has been sent to you e-mail address
                 * La nueva contraseña ha sido enviada a su direccion de correo electrónico.
                 */
                $variables['WELCOME'] = successMessage();
                $contents .= getSkinForm('loginhelp.html', $variables);
            }
        }
    } else {
        $variables = array();
        $variables['MSG'] = $msg['mail'];
        $variables['MAIL'] = UserRequest::$post['mail'];
        $variables['WELCOME'] = welcomeMessage();
        $contents .= getSkinForm('loginhelp.html', $variables);
    }
} else {
    $variables = array();
    $variables['MSG'] = '';
    $variables['MAIL'] = '';
    $variables['WELCOME'] = welcomeMessage();
    $contents .= getSkinForm('loginhelp.html', $variables);
}
$PAGE_VARIABLES['CONTENTS'] = $contents;
print getSkinForm(CLX_TPL_DEFAULT, $PAGE_VARIABLES);
