<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('anog') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'anog.php';

class anog_text extends anog {

    var $template;

    function __construct() {
        $this->code = 'ATXT';
        $this->name = 'Plain Text';
        $this->type = 'ANOG';
        $this->version = '0.1.0.2';
        $this->description = 'Output Generator Form Format: Plain Text';
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_TEXTFILE',
                    'fields' => array(
                        array('name' => 'textfile', 'type' => 'file', 'validations' => array(
                                array('type' => 'string', 'required' => '1'))
                        )
                    )
                )
            )
        );
    }

    function extractFields($templaterec) {
        $templateid = $templaterec['ID'];
        $this->deletefiles($templateid);
        $field_name = $this->type . '_textfile';
        $filename = kPathToWebSite . kPathToTemplates . $templateid . '.txt';
        if (!move_uploaded_file(UserRequest::$files[$field_name]['tmp_name'], $filename))
            addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
        ClxCommon::$db->deleteRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templaterec['IDCODE']));
        $contents = file_get_contents($filename);
        $matches = gettags('clxfield', $contents);
        $record = array();
        $record['TEMPLATECODE'] = $templaterec['IDCODE'];
        foreach ($matches[CLX_NUM_ZERO] as $field) {
            $field = str_replace('<clxfield>', '', $field);
            $field = str_replace('</clxfield>', '', $field);
            $record['FIELDNAME'] = $field;
            $record['MAP'] = $field;
            $this->savefield($record);
        }
    }

    function deletefiles($templateid) {
        $this->deleteFile($templateid . '.txt');
    }

    function printtemplate($templaterec, $tree, &$contents, &$headers) {
        $templateid = $templaterec['ID'];
        $filename = kPathToWebSite . kPathToTemplates . $templateid . '.txt';
        $fd = fopen($filename, 'r');
        $this->template = fread($fd, filesize($filename));
        fclose($fd);
        $tree->set($this);
        $headers = array();
        $headers['Content-type'] = 'text/plain';
        $contents = $this->template;
    }

    function set($field, $value) {
        $this->template = str_replace('<clxfield>$field</clxfield>', $value, $this->template);
    }

    function view_template($templaterec) {
        $filename = kPathToWebSite . kPathToTemplates . $templaterec['ID'] . '.txt';
        header('Content-type: text/plain');
        if (is_readable($filename)) {
            $fd = fopen($filename, 'r');
            echo fread($fd, filesize($filename));
            fclose($fd);
        } else {
            echo alert(dict('GEN_ERR_CANT_OPEN_FILE'));
        }
    }

}
