<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 10:58:27 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9614 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class anqn extends clx_object {

    var $operators;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'DBFT';
        $this->name = 'Generic Clientix Questionary Field';
        $this->type = '----';
        $this->version = '1.0.0.0';
        $this->description = 'This is a Generic Clientix Questinary';
    }

    /**
     * The following procedures are intented to be used by the Database
     * Administrator to interface with the user when creating new fields in the database.
     */
    function panel($msg, $fieldrecord, &$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell('This is the panel for field: ' . $this->code, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $msg['SOMETHING'] = 'This field does not have defined a checkPanel function';
    }

    function savePanel(&$fieldrecord) {

    }

    function loadPanel(&$fieldrecord, $values) {

    }

    function deletePanel($fieldrecord) {

    }

    function defaultPanel(&$fieldrecord) {

    }

    function viewForm(&$table, $record) {

    }

    function fieldProperties($fieldrecord) {
        $props = array();
        // DB implementation
        switch (kDatabaseType) {
            case 'oci':
                $props['type'] = 'number(1)';
                break;
            default:
                $props['type'] = 'tinyint(1) unsigned';
                break;
        }
        $props['default'] = $fieldrecord['FIELD_DEFAULT'];
        $props['properties'] = '';
        $props['null'] = ($fieldrecord['FIELD_REQUIRED']) ? 'NO' : 'YES';
        return $props;
    }

    function defaultField($form_fieldname, $fieldrecord, &$record) {
        $record[$form_fieldname] = $fieldrecord['FIELD_DEFAULT'];
    }

    function placeEditField($msg, $form_fieldname, $fieldrecord, $record, &$form, $jsevents) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        //Setting form field requirement if any diferent than table default
        if ($fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
            $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        if ($fieldrecord['FIELD_HIDDEN'] === true) {
            $form->addArgument($form_fieldname, (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '');
            if (empty($fieldrecord['FIELD_HIDDEN'])) {
                $table = $this->placeViewField($form_fieldname, $fieldrecord, $record);
            }
        } else {
            $cpt = dict($fieldrecord['CAPTION']);
            if (strlen($cpt) > CLX_NUM_ZERO) {
                $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            if (isset($msg[$form_fieldname])) {
                $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            $fieldobj = $this->fieldObject($form_fieldname, $fieldrecord, $record);
            foreach ($jsevents as $key => $value) {
                $fieldobj->setProp($key, $value);
            }
            $pfx = dict($fieldrecord['FIELDPREFIX']);
            $fieldsource = (strlen($pfx) > CLX_NUM_ZERO) ? $pfx : '';
            $fieldsource .= $fieldobj->source();
            $sfx = dict($fieldrecord['FIELDSUFIX']);
            $fieldsource .= (strlen($sfx) > CLX_NUM_ZERO) ? $sfx : '';
            $class = ($fieldrecord['FIELD_REQUIRED']) ? CLX_CLASS_PROMPTREQUIRED : CLX_CLASS_PROMPT;
            //Added to Display Date Format
	    if ($fieldrecord['FIELDTYPE'] === 'DATE') {
		$EDIT = &getTool('EDIT');
		$format_label_dict = $EDIT->date_in_formats[$_SESSION['prefs']['DATE_FORMAT']];
                $fieldlabel = dict($fieldrecord['FIELDFORMLABEL']) . '<br><span class=' . singleQuote('promptdateforma') . '>' . dict($format_label_dict) . '</span>';
            } elseif ($fieldrecord['FIELDTYPE'] === 'DATI') {
		$EDIT = &getTool('EDIT');
		$format_label_dict = $EDIT->date_in_formats[$_SESSION['prefs']['DATE_FORMAT']]."_TIME";
                $fieldlabel = dict($fieldrecord['FIELDFORMLABEL']) . '<br><span class=' . singleQuote('promptdateforma') . '>' . dict($format_label_dict) . '</span>';
            } else {
                $fieldlabel = dict($fieldrecord['FIELDFORMLABEL']);
            }
            $table->addCell($fieldlabel, array(CLX_PROP_CLASS => $class));
            //Added to display calendar link
            $class = CLX_CLASS_DATA;
            if (empty($fieldrecord['FIELD_READONLY']) && ($fieldrecord['FIELDTYPE'] === 'DATE' || $fieldrecord['FIELDTYPE'] === 'DATI')) {
                $class = 'hasDatepicker';
                $picker = '<script type="text/javascript">
                            $(function() {
                                var pickOpts = {
                                        dateFormat: "yy-mm-dd",
                                        showTime: true,
                                        stepMinutes: 1,
                                        stepHours: 1,
                                        altTimeField: "",
                                        duration: "",
                                        showTime: ' . (($fieldrecord['FIELDTYPE'] === 'DATI') ? 'true' : 'false') . ',' .
                                        'constrainInput: false,
                                        time24h: true,
                                        changeMonth: true,
                                        changeYear: true,
                                        showOn: "button",
                                        buttonImage: "./' . kPathToSkins . $_SESSION["skin"] . '/images/calendar/cal.gif",
                                        buttonImageOnly: true
                                    };
                                $("#' . $form_fieldname . '").datepicker(pickOpts);
                            });
                        </script>';
                    $fieldsource=$fieldsource.' '.$picker;
            }
            $table->addCell($fieldsource, array(CLX_PROP_CLASS => $class));
        }
        return $table;
    }

    function fieldObject($form_fieldname, $fieldrecord, $record) {
        if (!empty($fieldrecord['FIELD_PASSWORD']) && $fieldrecord['FIELD_PASSWORD']) {
            $fieldobj = new htmlPassword($form_fieldname, $record[$form_fieldname], $fieldrecord['FIELD_DISPLAYSIZE'], $fieldrecord['FIELD_SIZE']);
        } else {
            if (!array_key_exists($form_fieldname, $record))
                $record[$form_fieldname] = '';
            $field_displaysize = $fieldrecord['FIELD_DISPLAYSIZE'];
            if (empty($field_displaysize) && array_key_exists('FIELD_DB_DISPLAYSIZE', $fieldrecord)) {
                $field_displaysize = $fieldrecord['FIELD_DB_DISPLAYSIZE'];
            }
            $field_size = $field_displaysize;

            $fieldobj = new htmlField($form_fieldname, $record[$form_fieldname], $field_displaysize, $field_size);
            //Added instead of displaying read only files
            if (!empty($fieldrecord['FIELD_READONLY'])) {
                $fieldobj->setProp('readonly', 'true');
                $fieldobj->setProp(CLX_PROP_CLASS, 'readonly');
            }
            return $fieldobj;
        }
        return $fieldobj;
    }

    function placeViewField($form_fieldname, $fieldrecord, $record, $msg = array()) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (empty($fieldrecord['FIELD_HIDDEN'])) {
            $cpt = dict($fieldrecord['CAPTION']);
            if (strlen($cpt) > CLX_NUM_ZERO) {
                $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            if (!empty($msg[$form_fieldname])) {
                $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            $pfx = dict($fieldrecord['FIELDPREFIX']);
            $sfx = dict($fieldrecord['FIELDSUFIX']);
            $cell = $this->formatField($form_fieldname, $fieldrecord, $record);
            // Field Anchor
            $cell = $this->placeFieldAnchor($form_fieldname, $fieldrecord, $record, $cell);
            $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($pfx . ((strlen($cell) == CLX_NUM_ZERO) ? CLX_CHAR_HTML_NBSP : $cell) . $sfx, CLX_PROP_CLASS, CLX_CLASS_DATA);
        }
        return $table;
    }

    function placeSearchField($form_fieldname, $fieldrecord, $record, &$form) {

    }

    function searchFieldObject($form_fieldname, $fieldrecord, $record) {
        return $this->fieldObject($form_fieldname, $fieldrecord, $record);
    }

    function placeListField($form_fieldname, $fieldrecord, $record, $class, &$table) {
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $sfx = dict($fieldrecord['FIELDSUFIX']);
        $form_fieldname = uppercase($form_fieldname);
        $cell = $this->formatField($form_fieldname, $fieldrecord, $record);
        // Field Anchor
        $cell = $this->placeFieldAnchor($form_fieldname, $fieldrecord, $record, $cell);
        $table->addCell($pfx . $cell . $sfx, array(CLX_PROP_CLASS => $class));
    }

    function validateField(&$msg, $form_fieldname, $fieldrecord, &$record, &$table, &$form) {

    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {

    }

    function saveField($form_fieldname, $fieldrecord, &$record, $recordid) {
        if (array_key_exists($form_fieldname, UserRequest::$post)) {
            $record[$fieldrecord['FIELDNAME']] = UserRequest::$post[$form_fieldname];
        }
    }

    function loadField($form_fieldname, $fieldrecord, &$record, $values) {
        $fieldrecord['FIELDNAME'] = $fieldrecord['FIELDNAME'];
        $record[$form_fieldname] = $values[$fieldrecord['FIELDNAME']];
    }

    function removeField($fieldrecord, $record) {

    }

    function formatField($form_fieldname, $fieldrecord, $record) {
        $form_fieldname = uppercase($form_fieldname);
        $record = array_change_key_case($record, CASE_UPPER);
        if (!empty($fieldrecord['FIELD_PASSWORD']) && $fieldrecord['FIELD_PASSWORD']) {
            $la = strlen($record[$form_fieldname]);
            $input = '';
            return str_pad($input, $la, '*');
        } else {
            return htmlspecialchars($record[$form_fieldname]);
        }
    }

}
