<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_gbar extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CBAG';
        $this->name = 'Grouped Bar Plot';
        $this->type = 'CPTB';
        $this->version = '0.3.0.0';
        $this->description = 'Grouped Bar Plot';
        $this->classname = 'BarPlot';
        $this->classfile = 'jpgraph_bar.php';
        $this->functions = array(array('function' => 'HideLegend', 'name' => 'HIDELEGEND', CLX_CLASS_PROMPT => 'GEN_LBL_HIDELEGEND', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetCenter', 'name' => 'CENTER', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_SETCENTER', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetCSIMTargets', 'name' => 'CSIMTARGETS', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_SETTARGETS', 'arguments' => array(
                    array('name' => 'TARGETS', 'type' => 'TEXT', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_TARGETS'), array('name' => 'ALTS', 'type' => 'TEXT', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_ALTTEXTS'))
            ), array('function' => 'SetLegend', 'name' => 'LEGEND', CLX_CLASS_PROMPT => 'GEN_LBL_LEGEND', 'arguments' => array(
                    array('name' => 'TEXT', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_TEXT'), array('name' => 'CSIM', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_TARGET'), array('name' => 'CSIMAlt', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_ALTTEXT'))
            ), array('function' => 'SetColor', 'name' => 'LINECOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_LINECOLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
            ), array('function' => 'SetLineWeight', 'name' => 'LINEWEIGHT', CLX_CLASS_PROMPT => 'GEN_LBL_LINEWEIGHT', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetAbsWidth', 'name' => 'ABSWIDTH', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_ABSWIDTH', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetAlign', 'name' => 'ALIGN', CLX_CLASS_PROMPT => 'GEN_LBL_ALIGN', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetFillColor', 'name' => 'FILLCOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_FILLCOLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
            ), array('function' => 'SetFillGradient', 'name' => 'FILLGRADIENT', CLX_CLASS_PROMPT => 'GEN_LBL_GRADIENT', 'arguments' => array(
                    array('name' => 'FROMCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_FROMCOLOR'), array('name' => 'TOCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_TOCOLOR'), array('name' => 'STYLE', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_TYPE', 'constant' => '1', 'options' => 'GRAD_VER:GEN_LBL_GRADVERT,GRAD_HOR:GEN_LBL_GRADHORZ,GRAD_MIDHOR:GEN_LBL_GRADCENTERHOR,GRAD_MIDVER:GEN_LBL_GRADCENTERVER,GRAD_WIDE_MIDVER:GEN_LBL_GRADCENTERVERWIDE,GRAD_WIDE_MIDHOR:GEN_LBL_GRADCENTERHORWIDE,GRAD_CENTER:GEN_LBL_GRADCENTERBEAM,GRAD_LEFT_REFLECTION:GEN_LBL_GRADLEFTREFLEX,GRAD_RIGHT_REFLECTION:GEN_LBL_GRADRIGHTREFLEX')
                )
            ), array('function' => 'SetShadow', 'name' => 'SHADOW', CLX_CLASS_PROMPT => 'GEN_LBL_SHADOW', 'arguments' => array(
                    array('name' => 'COLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR'), array('name' => 'HSIZE', 'type' => 'NUMBER', CLX_CLASS_PROMPT => 'GEN_LBL_HSIZE'), array('name' => 'VSIZE', 'type' => 'NUMBER', CLX_CLASS_PROMPT => 'GEN_LBL_VSIZE'))
            ), array('function' => 'SetValuePos', 'name' => 'VALUEPOS', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_VALUEPOS', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'options' => 'top:GEN_LBL_TOP,center:GEN_LBL_CENTER,bottom:GEN_LBL_BOTTOM')
                )
            ), array('function' => 'SetWidth', 'name' => 'WIDTH', CLX_CLASS_PROMPT => 'GEN_LBL_WIDTH', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => ''))
            ), array('function' => 'SetYBase', 'name' => 'YBASE', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_YBASE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => ''))
            )
        );
    }

    function getPlot(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        require_once kPathToWebSite . kPathToJpgraph . $this->classfile;
        $plot = new $this->classname($series);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($plot, $function, $func_arguments);
            }
        }
        return $plot;
    }

}
