<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_pie extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CPIE';
        $this->name = 'Pie Plot';
        $this->type = 'CPTP';
        $this->version = '0.3.1.0';
        $this->description = 'Pie Plot';
        $this->classname = 'PiePlot';
        $this->classfile = 'jpgraph_pie.php';
        $this->functions = array(array('function' => 'ExplodeSlice', 'name' => 'EXPLODESLICE', CLX_CLASS_PROMPT => 'OBJ_CPIE_PROMPT_EXPLODESLICE', 'arguments' => array(
                    array('name' => 'SLICE', 'type' => 'NUMBER', 'default' => '', 'min' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_SLICE'), array('name' => 'RADIUS', 'type' => 'NUMBER', 'default' => '', 'min' => '0', 'postfix' => 'pixels', CLX_CLASS_PROMPT => 'GEN_LBL_RADIUS'))
            ), array('function' => 'SetCenter', 'name' => 'CENTER', CLX_CLASS_PROMPT => 'GEN_LBL_CENTER', 'arguments' => array(
                    array('name' => 'VALUEX', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_X', 'decimal' => '1'), array('name' => 'VALUEY', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_Y', 'decimal' => '1'))
            ), array('function' => 'SetColor', 'name' => 'LINECOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_LINECOLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
            ), array('function' => 'SetCSIMTargets', 'name' => 'CSIMTARGETS', CLX_CLASS_PROMPT => 'OBJ_CPIE_PROMPT_SETTARGETS', 'arguments' => array(
                    array('name' => 'TARGETS', 'type' => 'ARRAY', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_TARGETS', 'delim' => ','), array('name' => 'ALTS', 'type' => 'ARRAY', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CBAR_PROMPT_ALTTEXTS', 'delim' => ','))
            ), array('function' => 'SetFont', 'name' => 'FONT', CLX_CLASS_PROMPT => 'GEN_LBL_FONT', 'arguments' => array(
                    array('name' => 'FAMILY', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FONTFAMILY', 'displaysize' => '30', 'size' => '255', 'constant' => '1'), array('name' => 'STYLE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'constant' => '1', 'options' => 'FS_NORMAL:GEN_LBL_PLAIN,FS_BOLD:GEN_LBL_BOLD,FS_ITALIC:GEN_LBL_ITALIC,FS_BOLDITALIC:GEN_LBL_BOLDITALIC', CLX_CLASS_PROMPT => 'GEN_LBL_STYLE'),
                    array('name' => 'SIZE', 'type' => 'NUMBER', 'default' => '', 'min' => '2', 'max' => '255', CLX_CLASS_PROMPT => 'GEN_LBL_SIZE', 'postfix' => 'GEN_LBL_POINTS'))
            ), array('function' => 'SetColor', 'name' => 'COLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '30'))
            ), array('function' => 'SetLabelType', 'name' => 'TYPE', CLX_CLASS_PROMPT => 'OBJ_CPIE_LABELTYPE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'options' => 'PIE_VALUE_ABS:OBJ_CPIE_VALUE_ABS,PIE_VALUE_PER:OBJ_CPIE_VALUE_PER,PIE_VALUE_ADJPER:OBJ_CPIE_VALUE_ADJPER')
                )
            ), array('function' => 'SetLegends', 'name' => 'LEGENDS', CLX_CLASS_PROMPT => 'GEN_LBL_LEGENDS', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'ARRAY', 'default' => '', 'delim' => ','))
            ), array('function' => 'SetShadow', 'name' => 'SHADOW', CLX_CLASS_PROMPT => 'GEN_LBL_SHADOW', 'arguments' => array(
                    array('name' => 'COLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR'), array('name' => 'HSIZE', 'type' => 'NUMBER', CLX_CLASS_PROMPT => 'GEN_LBL_SIZE', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetSize', 'name' => 'SIZE', CLX_CLASS_PROMPT => 'GEN_LBL_SIZE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS', 'decimal' => '1'))
            ), array('function' => 'SetSliceColors', 'name' => 'SLICECOLORS', CLX_CLASS_PROMPT => 'GEN_LBL_COLORS', 'arguments' => array(
                    array('name' => 'VALUES', 'type' => 'ARRAY', 'default' => '', 'delim' => ','))
            ), array('function' => 'SetStartAngle', 'name' => 'STARTANGLE', CLX_CLASS_PROMPT => 'OBJ_CPIE_STARTANGLE', 'arguments' => array(
                    array('name' => 'VALUES', 'type' => 'NUMBER', 'default' => '', 'min' => '0', 'max' => '360', 'postfix' => 'GEN_LBL_DEGREES'))
            ), array('function' => 'ShowBorder', 'name' => 'HIDELEGEND', CLX_CLASS_PROMPT => 'GEN_LBL_BORDERS', 'arguments' => array(
                    array('name' => 'EXTERIOR', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_EXTERIOR'), array('name' => 'INTERIOR', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_EXTERIOR'))
            )
        );
    }

    function getPlot(&$graph, $series_records, $series_data) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($series_records[CLX_NUM_ONE]['SERIES_PROPERTIES']);
        require_once kPathToWebSite . kPathToJpgraph . $this->classfile;
        $plot = new $this->classname($series_data[$series_records[CLX_NUM_ONE]['ID']]);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($plot, $function, $func_arguments);
            }
        }
        $plot->SetLegends($series_data[$series_records[CLX_NUM_ZERO]['ID']]);
        return $plot;
    }

}
