<?php

/**
 * Boolean field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-09 15:15:00 -0400 (Tue, 09 Oct 2018) $
 * @version    	$Rev: 10228 $
 *
 * Change log
 *  Added Oracle on field properties
 *
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_boolean extends dbft {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'BOOL';
        $this->name = 'Boolean';
        $this->type = 'DBFT';
        $this->version = '0.2.5.4';
        $this->description = 'true or false field.';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array('===' => 'GEN_LBL_EQUALTO','!== ' => 'GEN_LBL_NOTEQUALTO');
        $this->ltype = array('Default', 'Checkbox', 'Radio');
		IF (ISSET($_SESSION['ADDRDEBUGEDIT']) && $_SESSION['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}

    }

    function fieldProperties($fieldrecord) {
		if ((isset(ClxCommon::$db->debugCF) && ClxCommon::$db->debugCF==true) || $this->debug==true) {
			pre("fieldproperties en dbft_boolean");
			$te=debug_backtrace();$pos=$posx=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}	
		}	
        $props = array();
        // DB implementation
        switch (kDatabaseType) {
            case 'oci':
                $props['type'] = 'NUMBER(1)';
                break;
            default:
                $props['type'] = 'tinyint(1) unsigned';
                break;
			$props['Extype']='bool';
			
        }
		if ($fieldrecord['FIELD_DEFAULT'] === 'null' || strlen($fieldrecord['FIELD_DEFAULT']) == CLX_NUM_ZERO) {
            $props['default'] = '0';
        } else {
            $props['default'] = $fieldrecord['FIELD_DEFAULT'];
        }
		
        $props['null'] = 'NO';
        $props['properties'] = '';
        return $props;
    }

    function panel($msg, $fieldrecord, &$form) {
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
            $this->defaultPanel($fieldrecord);
        }
        $this->yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_BOOLFIELDPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $DICT = &getTool('DICT');
        $DICT->editEntry($msg, dict('GEN_LBL_trueVALUE') . '(1):', $c . '_extra1', $fieldrecord, $table, $form);
        $DICT->editEntry($msg, dict('GEN_LBL_falseVALUE') . '(0):', $c . '_extra2', $fieldrecord, $table, $form);

        $yesno = new htmlSelect($c . '_default');
        foreach ($this->yesno as $key => $val) {
            if ($key == CLX_NUM_ZERO)
                $val = dict('GEN_LBL_falseVALUE') . '(' . $key . ')';
            else
                $val = dict('GEN_LBL_trueVALUE') . '(' . $key . ')';
            $yesno->addItem($val, $key, ($fieldrecord[$c . '_default'] == $key));
        }
        $table->addData(dict('GEN_LBL_DEFAULT') . ':', $yesno->source());
        $yesno = new htmlSelect($c . '_extra3');
        foreach ($this->ltype as $key => $val) {
            $yesno->addItem($val, $key, ($fieldrecord[$c . '_extra3'] == $key));
        }
        $table->addData(dict('GEN_LBL_DISPLAY_TYPE'), $yesno->source());
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $c = $this->code;
        $DICT = &getTool('DICT');
        $DICT->validateEntry($c . '_extra1', UserRequest::$post, true, $msg);
        $DICT->validateEntry($c . '_extra2', UserRequest::$post, true, $msg);
        if (UserRequest::$post[$c . '_default'] <> CLX_NUM_ZERO && UserRequest::$post[$c . '_default'] <> CLX_NUM_ONE && UserRequest::$post[$c . '_default'] <> '') {
            $msg[c . '_default'] = dict('GEN_ERR_INVALIDDEFAULT');
        }
        if (!empty(UserRequest::$post[$c . '_required'])) {
            xValidate::required($msg, $c . '_default', UserRequest::$post[$c . '_default']);
        }
    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {
        if ($fieldvalue <> '0' && $fieldvalue <> '1') {

        }
    }

    function savePanel(&$fieldrecord) {
        $DICT = &getTool('DICT');
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = CLX_INIT_ZERO;

        $fieldrecord['FIELD_REQUIRED'] = '1';
        $fieldrecord['FIELD_FORMAT'] = '';
        $fieldrecord['FIELD_ALIGN'] = '0';
        $fieldrecord['FIELD_DEFAULT'] = UserRequest::$post[$c . '_default'];
        $fieldrecord['FIELD_MINVALUE'] = '';
        $fieldrecord['FIELD_MAXVALUE'] = '';
        $fieldrecord['FIELD_EXTRA1'] = $DICT->createEntry($c . '_extra1', UserRequest::$post);
        $fieldrecord['FIELD_EXTRA2'] = $DICT->createEntry($c . '_extra2', UserRequest::$post);
        $fieldrecord['FIELD_EXTRA3'] = UserRequest::$post[$c . '_extra3'];
        $fieldrecord['FIELD_EXTRA4'] = '';
        $fieldrecord['FIELD_EXTRA5'] = '';
    }

    function loadPanel(&$fieldrecord, $values) {
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
            $DICT = &getTool('DICT');
            $DICT->loadEntry($c . '_extra1', $values['FIELD_EXTRA1'], $fieldrecord);
            $DICT->loadEntry($c . '_extra2', $values['FIELD_EXTRA2'], $fieldrecord);
            $fieldrecord[$c . '_extra3'] = $values['FIELD_EXTRA3'];
            $fieldrecord[$c . '_default'] = $values['FIELD_DEFAULT'];
        } else {
            $this->defaultPanel($fieldrecord);
        }
    }

    /*  function deletePanel($fieldrecord) {
      $c = $this->code;
      }
     */

    function defaultPanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_required'] = CLX_NUM_ONE;
        $fieldrecord[$c . '_format'] = '';
        $fieldrecord[$c . '_align'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_default'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_minvalue'] = '';
        $fieldrecord[$c . '_maxvalue'] = '';
        $fieldrecord[$c . '_extra1'] = '';
        $fieldrecord[$c . '_extra1_DICT'] = '';
        $fieldrecord[$c . '_extra2'] = '';
        $fieldrecord[$c . '_extra2_DICT'] = '';
        $fieldrecord[$c . '_extra3'] = '0';
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '';
    }

    function viewForm(&$table, $record) {
        $this->yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $this->name);
        $table->addData(dict('GEN_LBL_FIELD_DEFAULT') . ':', dict(((empty($record['BOOL_default'])) ? 'GEN_LBL_falseVALUE' : 'GEN_LBL_trueVALUE')));
        $table->addData(dict('GEN_LBL_trueVALUE') . ':', dict($record['BOOL_extra1']));
        $table->addData(dict('GEN_LBL_falseVALUE') . ':', dict($record['BOOL_extra2']));
    }

    function fieldObject(&$form_fieldname, &$fieldrecord, $record) {
	//	
	//echo '---------------->';pre($form_fieldname);pre($fieldrecord);pre(UserRequest::$request['ac']);
        if (array_key_exists($form_fieldname, $record) && $record[$form_fieldname] === '') {
            $record[$form_fieldname] = $fieldrecord['FIELD_DEFAULT'];
        }
        $true = empty($record[$form_fieldname]);
        $readonly = false;
        if ($fieldrecord['FIELD_READONLY'] == CLX_NUM_ONE)
            $readonly = true;
        if ($fieldrecord['FIELD_READONLY'] == CLX_NUM_TWO && UserRequest::$request['ac'] === 'CREATE')
            $readonly = true;
        if ($fieldrecord['FIELD_READONLY'] == CLX_NUM_THREE && UserRequest::$request['ac'] === 'MODIFY')
            $readonly = true;
      
		
		if ($readonly === true) {

            $fieldobj = new htmlTable(CLX_WIDTH_ONE);
            $c = new htmlObject('input', '', array('type'=>'hidden', 'name'=>$form_fieldname, 'value'=> (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : ''));
            $fieldobj->addCell($c->source() . ' ' . ((!$readonly || !$true) ? dict($fieldrecord['FIELD_EXTRA1']) : dict($fieldrecord['FIELD_EXTRA2'])), array());
        } else {
            switch ($fieldrecord['FIELD_EXTRA3']) {
                case CLX_NUM_ONE: // Checkboxes

                    $fieldobj = new htmlCheckbox($form_fieldname, (!$true));
                    break;
                case CLX_NUM_TWO:// Radio

                    $fieldobj = new htmlTable(CLX_WIDTH_TWO);
                    $radio = new htmlRadioButton($form_fieldname, (!$true), '1');
                    $fieldobj->addCell(dict($fieldrecord['FIELD_EXTRA1']) . $radio->source(), array());
                    $radio = new htmlRadioButton($form_fieldname, ($true), '0');
                    $fieldobj->addCell(dict($fieldrecord['FIELD_EXTRA2']) . $radio->source(), array());
                    break;
                default:
                    $fieldobj = new htmlSelect($form_fieldname);
					IF (UserRequest::$request['ac']=='REPORT_BUILD') {
						$fieldobj->addItem(dict($fieldrecord['FIELD_EXTRA1']), '1', ('1'==$fieldrecord['FIELD_DEFAULT']) );
						$fieldobj->addItem(dict($fieldrecord['FIELD_EXTRA2']), '0', ('1'!=$fieldrecord['FIELD_DEFAULT']));
					
                    }
					else {
						$fieldobj->addItem(dict($fieldrecord['FIELD_EXTRA1']), '1', (!$true));
						$fieldobj->addItem(dict($fieldrecord['FIELD_EXTRA2']), '0', ($true));
						
					}	
            }
        }
        return $fieldobj;
    }

    function searchFieldObject($form_fieldname, $fieldrecord, $record) {
        $fieldobj = $this->fieldObject($form_fieldname, $fieldrecord, $record);
        if ($fieldrecord['FIELD_EXTRA3'] !== '1' && $fieldrecord['FIELD_EXTRA3'] !== '2') {
            $fieldobj->addItem('', '', !isset($record[$form_fieldname]));
        }
        return $fieldobj;
    }

    function formatField($form_fieldname, $fieldrecord, $record) {
             //  comentada consume memoria pero strtoupper no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = strtoupper($form_fieldname);

        $record = array_change_key_case($record, CASE_UPPER);

        if(!empty($fieldrecord['DBQF_FIELD_FORMAT']) &&   $fieldrecord['DBQF_FIELD_FORMAT'] === '1'){
            if (array_key_exists($form_fieldname, $record)) {
                $original_value = $record[$form_fieldname];
            } else {
                $original_value = '';
            }
            return $original_value;
        }

        if (!array_key_exists($form_fieldname, $record)) {
            $record[$form_fieldname] = CLX_INIT_ZERO;
        }
        if ($record[$form_fieldname] == CLX_NUM_ONE) {
            return dict($fieldrecord['FIELD_EXTRA1']);
        } else {
            return dict($fieldrecord['FIELD_EXTRA2']);
        }

    }

    function saveField($form_fieldname, $fieldrecord, &$record, $recordid) {
        if (!empty(UserRequest::$post[$form_fieldname]) && UserRequest::$post[$form_fieldname] == CLX_NUM_ONE) {
            $record[$fieldrecord['FIELDNAME']] = CLX_NUM_ONE;
        } else {
            $record[$fieldrecord['FIELDNAME']] = CLX_INIT_ZERO;
        }
    }

    function saveFieldImport($form_fieldname, $fieldrecord, &$record) {
        if (empty($record[$form_fieldname]) || $record[$form_fieldname] <> CLX_NUM_ONE) {
            $record[$form_fieldname] = CLX_INIT_ZERO;
        }
    }

    /**
     * Formats field in text only
     * @param string $form_fieldname
     * @param array $fieldrecord
     * @param array $record
     * @param bool $append_quote when true value will attach ' to prevent number interpretation
     */
    function placeListFieldText($form_fieldname, $fieldrecord, $record, $append_quote = true,$csv=1) {
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $sfx = dict($fieldrecord['FIELDSUFIX']);
     //  comentada consume memoria pero strtoupper no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = strtoupper($form_fieldname);

        $cell = $this->formatField($form_fieldname, $fieldrecord, $record);
        $cell = str_replace(CLX_CHAR_NL, '', $pfx . $cell . $sfx);
        $cell = str_replace(CLX_CHAR_CR, '', $cell);
        $cell = str_replace(CLX_CHAR_TAB, '', $cell);
		if ( $this->debug==true ) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_boolean-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".$cell);
			fclose($tta);
			if (!isset($GLOBALS['placelistcount']))
				$GLOBALS['placelistcount']=1;
			else
				$GLOBALS['placelistcount']++;
		}
		//$rra=fopen(kPathToWebSite."/".kPathToTemp."archivox4x.txt","a+");	fwrite($rra,$_SERVER['REMOTE_ADDR']." p89:dbft_boolean:".memory_get_usage(). print_R($cell,TRUE).chr(13).chr(10));	fclose($rra);

        return $cell;
    }

}
