<?php

/**
 * Integer field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_integer extends dbft {

    function __construct() {
        $this->code = 'INTN';
        $this->name = 'Integer Number';
        $this->type = 'DBFT';
        $this->version = '0.2.4.2';
        $this->description = 'This field creates and intenger number';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array('===' => 'GEN_LBL_EQUALTO', '!== ' => 'GEN_LBL_NOTEQUALTO', '>' => 'GEN_LBL_GREATERTHAN', '>=' => 'GEN_LBL_GREATERTHANOREQUEALTO', '<=' => 'GEN_LBL_LESSTHANOREQUALTO', '<' => 'GEN_LBL_LESSTHAN');
		IF (ISSET($_SESSION['ADDRDEBUGEDIT']) && $_SESSION['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}
	
    }

    function panel($msg, $fieldrecord, &$form) {
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
            $this->defaultPanel($fieldrecord);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_INTFIELDPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $size = new htmlSelect($c . '_size');
        $size->addItem(dict('GEN_LBL_TINY'), CLX_NUM_ZERO, ($fieldrecord[$c . '_size'] == CLX_NUM_ZERO));
        $size->addItem(dict('GEN_LBL_SMALL'), CLX_NUM_ONE, ($fieldrecord[$c . '_size'] == CLX_NUM_ONE));
        $size->addItem(dict('GEN_LBL_MEDIUM'), '2', ($fieldrecord[$c . '_size'] == CLX_NUM_TWO));
        $size->addItem(dict('GEN_LBL_NORMAL'), '3', ($fieldrecord[$c . '_size'] == CLX_NUM_THREE));
        $size->addItem(dict('GEN_LBL_BIG'), '4', ($fieldrecord[$c . '_size'] == CLX_NUM_FOUR));
        $table->addData(dict('GEN_LBL_SIZE') . ':', $size->source());
        $yesno = new htmlSelect($c . '_required');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($fieldrecord[$c . '_required'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($fieldrecord[$c . '_required'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno->source());
        $yesno = new htmlSelect($c . '_extra1');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($fieldrecord[$c . '_extra1'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($fieldrecord[$c . '_extra1'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_ZERO_FILL') . ':', $yesno->source());
        $yesno = new htmlSelect($c . '_extra2');
        $yesno->addItem(dict('GEN_LBL_UNSIGNED'), '0', ($fieldrecord[$c . '_extra2'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_SIGNED'), '1', ($fieldrecord[$c . '_extra2'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_SIGN') . ':', $yesno->source());
        $align = new htmlSelect($c . '_align');
        $align->addItem(dict('GEN_LBL_LEFT'), '0', ($fieldrecord[$c . '_align'] == CLX_NUM_ZERO));
        $align->addItem(dict('GEN_LBL_CENTER'), '1', ($fieldrecord[$c . '_align'] == CLX_NUM_ONE));
        $align->addItem(dict('GEN_LBL_RIGHT'), '2', ($fieldrecord[$c . '_align'] == CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_ALIGN') . ':', $align->source());
        $table->addField($msg, dict('GEN_LBL_DEFAULT') . ':', $c . '_default', $fieldrecord[$c . '_default'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_MIN') . ':', $c . '_minvalue', $fieldrecord[$c . '_minvalue'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_MAX') . ':', $c . '_maxvalue', $fieldrecord[$c . '_maxvalue'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_DISPLAY_SIZE') . ':', $c . '_displaysize', $fieldrecord[$c . '_displaysize'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $c = $this->code;
        $sign = UserRequest::$post[$c . '_extra2'];
        $def = UserRequest::$post[$c . '_default'];
        $min = UserRequest::$post[$c . '_minvalue'];
        $max = UserRequest::$post[$c . '_maxvalue'];
        if (strlen($def) != CLX_NUM_ZERO) {
            xValidate::integer($msg, $c . '_default', $def, $min, $max, 'default value', $sign);
        }
        if (strlen($min) != CLX_NUM_ZERO) {
            xValidate::integer($msg, $c . '_minvalue', $min, '', $max, 'minimum value', $sign);
        }
        if (strlen($max) != CLX_NUM_ZERO) {
            xValidate::integer($msg, $c . '_maxvalue', $max, $min, '', 'maximum value', $sign);
        }
        xValidate::integer($msg, $c . '_displaysize', UserRequest::$post[$c . '_displaysize'], CLX_NUM_TWO, CLX_NUM_38, 'default size');
        if (!empty(UserRequest::$post[$c . '_required'])) {
            xValidate::required($msg, $c . '_default', trim(UserRequest::$post[$c . '_default']));
        }
    }

    function savePanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = UserRequest::$post[$c . '_size'];
        $fieldrecord['FIELD_REQUIRED'] = UserRequest::$post[$c . '_required'];
        $fieldrecord['FIELD_FORMAT'] = '';
        $fieldrecord['FIELD_ALIGN'] = UserRequest::$post[$c . '_align'];
        $fieldrecord['FIELD_DEFAULT'] = UserRequest::$post[$c . '_default'];
        $fieldrecord['FIELD_MINVALUE'] = UserRequest::$post[$c . '_minvalue'];
        $fieldrecord['FIELD_MAXVALUE'] = UserRequest::$post[$c . '_maxvalue'];
        $fieldrecord['FIELD_DISPLAYSIZE'] = UserRequest::$post[$c . '_displaysize'];
        $fieldrecord['FIELD_EXTRA1'] = UserRequest::$post[$c . '_extra1'];
        $fieldrecord['FIELD_EXTRA2'] = UserRequest::$post[$c . '_extra2'];
        $fieldrecord['FIELD_EXTRA3'] = '';
        $fieldrecord['FIELD_EXTRA4'] = '';
        $fieldrecord['FIELD_EXTRA5'] = '';
    }

    function loadPanel(&$fieldrecord, $values) {
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
            $fieldrecord[$c . '_size'] = $values['FIELD_SIZE'];
            $fieldrecord[$c . '_required'] = $values['FIELD_REQUIRED'];
            $fieldrecord[$c . '_align'] = $values['FIELD_ALIGN'];
            $fieldrecord[$c . '_default'] = $values['FIELD_DEFAULT'];
            $fieldrecord[$c . '_minvalue'] = $values['FIELD_MINVALUE'];
            $fieldrecord[$c . '_maxvalue'] = $values['FIELD_MAXVALUE'];
            $fieldrecord[$c . '_displaysize'] = $values['FIELD_DISPLAYSIZE'];
            $fieldrecord[$c . '_extra1'] = $values['FIELD_EXTRA1'];
            $fieldrecord[$c . '_extra2'] = $values['FIELD_EXTRA2'];
            $fieldrecord[$c . '_format'] = $values['FIELD_FORMAT'];
        } else {
            $this->defaultPanel($fieldrecord);
        }
    }

    function defaultPanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_NUM_THREE;
        $fieldrecord[$c . '_required'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_format'] = '';
        $fieldrecord[$c . '_align'] = CLX_NUM_TWO;
        $fieldrecord[$c . '_default'] = '0';
        $fieldrecord[$c . '_minvalue'] = '0';
        $fieldrecord[$c . '_maxvalue'] = CLX_NUM_HUNDRED;
        $fieldrecord[$c . '_displaysize'] = '10';
        $fieldrecord[$c . '_extra1'] = '0';
        $fieldrecord[$c . '_extra2'] = '0';
        $fieldrecord[$c . '_extra3'] = '';
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '';
    }

    function viewForm(&$table, $record) {
        $size = array(dict('GEN_LBL_TINY'), dict('GEN_LBL_SMALL'), dict('GEN_LBL_MEDIUM'), dict('GEN_LBL_NORMAL'), dict('GEN_LBL_BIG'));
        $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $align = array(dict('GEN_LBL_LEFT'), dict('GEN_LBL_CENTER'), dict('GEN_LBL_RIGHT'));
        $sign = array(dict('GEN_LBL_UNSIGNED'), dict('GEN_LBL_SIGNED'));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $this->name);
        $table->addData(dict('GEN_LBL_SIZE') . ':', $size[$record['INTN_size']]);
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno[$record['INTN_required']]);
        $table->addData(dict('GEN_LBL_ZEROFILL') . ':', $yesno[$record['INTN_extra1']]);
        $table->addData(dict('GEN_LBL_SIGN') . ':', $sign[$record['INTN_extra2']]);
        $table->addData(dict('GEN_LBL_ALIGN') . ':', $align[$record['INTN_align']]);
        $table->addData(dict('GEN_LBL_DEFAULT') . ':', $record['INTN_default']);
        $table->addData(dict('GEN_LBL_MIN') . ':', xFormat::number($record['INTN_minvalue'], $record['INTN_format']));
        $table->addData(dict('GEN_LBL_MAX') . ':', xFormat::number($record['INTN_maxvalue'], $record['INTN_format']));
        $table->addData(dict('GEN_LBL_DISPLAY_SIZE') . ':', $record['INTN_displaysize']);
    }

    function fieldProperties($fieldrecord) {
        // DB implementation
		switch (kDatabaseType) {
            case 'oci':
                $size = array('NUMBER', 'NUMBER', 'NUMBER', 'NUMBER', 'NUMBER');
                $signed = array('', '');
                $fill = array('', ' ');
                break;
            default:
                $size = array('TINYINT', 'SMALLINT', 'MEDIUMINT', 'INT', 'BIGINT');
                $signed = array(' UNSIGNED', '');
                $fill = array('', ' ZEROFILL');
                break;
        }
        $props = array();
        $props['type'] = $size[$fieldrecord['FIELD_SIZE']] . '(' . $fieldrecord['FIELD_DISPLAYSIZE'] . ')' . $signed[$fieldrecord['FIELD_EXTRA2']] . $fill[$fieldrecord['FIELD_EXTRA1']];
        $props['properties'] = '';
		if ($size[$fieldrecord['FIELD_SIZE']]=='TINYINT' && $signed[$fieldrecord['FIELD_EXTRA2']]==' UNSIGNED' && $fill[$fieldrecord['FIELD_EXTRA1']]==' ZEROFILL'){
			$props['type'] = $size[$fieldrecord['FIELD_SIZE']] . '(' . $fieldrecord['FIELD_DISPLAYSIZE'] . ')' . $signed[$fieldrecord['FIELD_EXTRA2']] . $fill[$fieldrecord['FIELD_EXTRA1']];
		}else{
			$props['type'] = $size[$fieldrecord['FIELD_SIZE']] . $signed[$fieldrecord['FIELD_EXTRA2']] . $fill[$fieldrecord['FIELD_EXTRA1']];
		}
        
		$props['properties'] = '';
        if ($fieldrecord['FIELD_DEFAULT'] === 'null' || strlen($fieldrecord['FIELD_DEFAULT']) == CLX_NUM_ZERO) {
            $props['default'] = 'null';
        } else {
            $props['default'] = $fieldrecord['FIELD_DEFAULT'];
        }
        $props['null'] = ($fieldrecord['FIELD_REQUIRED']) ? 'NO' : 'YES';
        return $props;
    }

    function fieldObject(&$form_fieldname, &$fieldrecord, $record) {
        //Alignment
        switch ($fieldrecord['FIELD_ALIGN']) {

            case CLX_NUM_ONE:
                $align = 'text-align: center;';
                break;
            case CLX_NUM_TWO:
                $align = 'text-align: right; right';
                break;
            default:
                $align = 'text-align: left;';
                break;
        }
        $fieldobj = new htmlField($form_fieldname, (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '', $fieldrecord['FIELD_DISPLAYSIZE'], (!empty($fieldrecord['FIELD_DISPLAYSIZE'])) ? $fieldrecord['FIELD_DISPLAYSIZE'] : '');
        $fieldobj->setProp('style', $align);
        //Added instead of displaying read only files
        if (!empty($fieldrecord['FIELD_READONLY']) and (!$fieldrecord["FIELD_REQUIRED"] or ($fieldrecord["FIELD_REQUIRED"] and $record[$form_fieldname]<>''  )) ) {
            $fieldobj->setProp('readonly', 'true');
            $fieldobj->setProp(CLX_PROP_CLASS, 'readonly');
        }
        return $fieldobj;
    }

    function validateField(&$msg, $form_fieldname, $fieldrecord, &$record, &$table, &$form) {
        //Setting form require pref if any
        if (array_key_exists('FIELD_FORM_REQUIRED', $fieldrecord) && $fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
            $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        // Note: !array_key_exists was added to enable lookups to validate
        if (!array_key_exists('FIELD_HIDDEN', $fieldrecord))
            $fieldrecord['FIELD_HIDDEN'] = false;
        if (empty($fieldrecord['FIELD_HIDDEN']) === true) {
            if (UserRequest::$request['ac']!='DELETE' &&(!empty($record[$form_fieldname]) || $fieldrecord['FIELD_REQUIRED'] === '1')) {
                xValidate::integer($msg, $form_fieldname, $record[$form_fieldname], $fieldrecord['FIELD_MINVALUE'], $fieldrecord['FIELD_MAXVALUE'], $fieldrecord['FIELDLISTLABEL']);
            }
        }//end hidden
    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {
        if ($fieldrecord['FIELD_REQUIRED'] == CLX_NUM_ZERO && $fieldvalue === 'null') {
            return;
        } else {
            xValidate::integer($msg, $fieldrecord['FIELDNAME'], $fieldvalue, $fieldrecord['FIELD_MINVALUE'], $fieldrecord['FIELD_MAXVALUE'], $fieldrecord['FIELDLISTLABEL']);
        }
    }

    /**
     * Formats field in text only
     * @param string $form_fieldname
     * @param array $fieldrecord
     * @param array $record
     * @param bool $append_quote when true value will attach ' to prevent number interpretation
     */
    function placeListFieldText($form_fieldname, $fieldrecord, $record, $append_quote = true,$csv=1) {
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $sfx = dict($fieldrecord['FIELDSUFIX']);
        $form_fieldname = uppercase($form_fieldname);
        $cell = strip_tags($this->formatField($form_fieldname, $fieldrecord, $record));
        $cell = str_replace(CLX_CHAR_NL, '', $pfx . $cell . $sfx);
        $cell = str_replace(CLX_CHAR_CR, '', $cell);
        $cell = str_replace(CLX_CHAR_TAB, '', $cell);
		if ($this->debug==true &&!isset($GLOBALS['placelistcount']) && $GLOBALS['placelistcount']<200) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_integer-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".$cell);
			fclose($tta);
			if (!isset($GLOBALS['placelistcount']))
				$GLOBALS['placelistcount']=1;
			else
				$GLOBALS['placelistcount']++;			
		}
		unset ($pfx); unset($sfx);	
		unset($form_fieldname);
		unset($fieldrecord);
		unset($record);
		//$rra=fopen(kPathToWebSite."/".kPathToTemp."archivox4x.txt","a+");	fwrite($rra,$_SERVER['REMOTE_ADDR']." p89:dbft:".memory_get_usage(). print_R($cell,TRUE).chr(13).chr(10));	fclose($rra);

        return $cell;
    }

    /**
     * Build session key for filters
     */
    function setQuickFilters($tablecode, $fieldname, $fieldrecord, $record) {
        $criteria = '';
        if (array_key_exists($tablecode . '_' . $fieldname, $record) && strlen($record[$tablecode . '_' . $fieldname]) > CLX_NUM_ZERO) {
            if (is_numeric($record[$tablecode . '_' . $fieldname])) {
                $criteria = $tablecode . '.' . $fieldname . ' = ' . $record[$tablecode . '_' . $fieldname];
            }
        }
        return $criteria;
    }

    /**
     * (non-PHPdoc)
     * @see dbft::formatField()
     */
    function formatField($form_fieldname, $fieldrecord, $record) {
             //  comentada consume memoria pero strtoupper no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = strtoupper($form_fieldname);

        if(!empty($fieldrecord['DBQF_FIELD_FORMAT']) &&   $fieldrecord['DBQF_FIELD_FORMAT'] === '1'){
            if (array_key_exists($form_fieldname, $record)) {
                $original_value = $record[$form_fieldname];
            } else {
                $original_value = '';
            }
            return $original_value;
        }


        $dc = CLX_INIT_ZERO;
        //Setting Textual Value
        if (array_key_exists('FORMAT', $fieldrecord) && $fieldrecord['FORMAT'] == CLX_NUM_7) {
            if (rounder($record[$form_fieldname], $dc) == CLX_NUM_ZERO) {
                $record[$form_fieldname] = CLX_INIT_ZERO;
            }
            return clx_format_textual($record[$form_fieldname], getCurrentLanguage(), true);
        }
        return parent::formatField($form_fieldname, $fieldrecord, $record);
    }

}
