<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('plot') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'plot.php';

class plot_fi2linear extends plot {

    var $operators;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'PLLC';
        $this->name = 'Single Series - Linear Chart';
        $this->type = 'PLOT';
        $this->version = '1.0.0.1';
        $this->description = 'The Clientix Linear Chart';
        $this->plotfile = 'FI2_Linear.swf';
        $this->has_range = true;
        $this->serie_types = array('VAL' => dict('GEN_LABEL_VALUE'));
    }

    function defaultRange($plotrecord) {
        $ANPR = &getTool('ANPR');
        $default = array();
        $default[] = array('CHARTCODE' => $plotrecord['IDCODE'], 'DISPLAY_LABEL' => dict('GEN_LBL_LOW'), 'FROM_VALUE' => CLX_NUM_ZERO, 'TO_VALUE' => CLX_NUM_33, 'COLOR' => '00FF00', 'TRANSPARENCY' => CLX_NUM_HUNDRED, 'SEQNUM' => CLX_NUM_ONE);
        $default[] = array('CHARTCODE' => $plotrecord['IDCODE'], 'DISPLAY_LABEL' => dict('GEN_LBL_MEDIUM'), 'FROM_VALUE' => CLX_NUM_34, 'TO_VALUE' => CLX_NUM_66, 'COLOR' => 'FFFF00', 'TRANSPARENCY' => CLX_NUM_HUNDRED, 'SEQNUM' => CLX_NUM_TWO);
        $default[] = array('CHARTCODE' => $plotrecord['IDCODE'], 'DISPLAY_LABEL' => dict('GEN_LBL_HIGH'), 'FROM_VALUE' => CLX_NUM_67, 'TO_VALUE' => CLX_NUM_HUNDRED, 'COLOR' => 'FF0000', 'TRANSPARENCY' => CLX_NUM_HUNDRED, 'SEQNUM' => CLX_NUM_THREE);
        foreach ($default as $key => $val) {
            ClxCommon::$db->createRecord($ANPR->tablename, $val, false);
        }
    }

    /**
     * The following procedures are intented to be used by the Database
     * Administrator to interface with the user when creating new fields in the database.
     */
    function panel($msg, $plotrecord, &$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        //Chart Numerical Limits
        $table->addField($msg, dict('GEN_LBL_LOWERLIMIT') . ':', $this->code . '_field_extra1', $plotrecord[$this->code . '_field_extra1'], CLX_NUM_20, CLX_NUM_20);
        $table->addField($msg, dict('GEN_LBL_UPPERLIMIT') . ':', $this->code . '_field_extra2', $plotrecord[$this->code . '_field_extra2'], CLX_NUM_20, CLX_NUM_20);
        $table->addField($msg, dict('GEN_LBL_LOWERLIMITDISPLAY') . ':', $this->code . '_field_extra3', $plotrecord[$this->code . '_field_extra3'], CLX_NUM_40, CLX_NUM_40);
        $table->addField($msg, dict('GEN_LBL_UPPERLIMITDISPLAY') . ':', $this->code . '_field_extra4', $plotrecord[$this->code . '_field_extra4'], CLX_NUM_40, CLX_NUM_40);
        $pop = new htmlSelect($this->code . '_field_extra5');
        $pop->addItem(dict('GEN_LBL_YES'), '1', ($plotrecord[$this->code . '_field_extra5'] === '1'));
        $pop->addItem(dict('GEN_LBL_NO'), '0', ($plotrecord[$this->code . '_field_extra5'] === '0'));
        $table->addData(dict('GEN_LBL_SHOWLIMITS') . ':', $pop->source());
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function createPanel(&$plotrecord) {
        $plotrecord['HSIZE'] = CLX_NUM_250;
        $plotrecord['VSIZE'] = CLX_NUM_HUNDRED;
        $plotrecord['FIELD_EXTRA1'] = UserRequest::$post[$this->code . '_field_extra1'];
        $plotrecord['FIELD_EXTRA2'] = UserRequest::$post[$this->code . '_field_extra2'];
        $plotrecord['FIELD_EXTRA3'] = UserRequest::$post[$this->code . '_field_extra3'];
        $plotrecord['FIELD_EXTRA4'] = UserRequest::$post[$this->code . '_field_extra4'];
        $plotrecord['FIELD_EXTRA5'] = UserRequest::$post[$this->code . '_field_extra5'];
    }

    function savePanel(&$plotrecord) {
        $plotrecord['FIELD_EXTRA1'] = UserRequest::$post[$this->code . '_field_extra1'];
        $plotrecord['FIELD_EXTRA2'] = UserRequest::$post[$this->code . '_field_extra2'];
        $plotrecord['FIELD_EXTRA3'] = UserRequest::$post[$this->code . '_field_extra3'];
        $plotrecord['FIELD_EXTRA4'] = UserRequest::$post[$this->code . '_field_extra4'];
        $plotrecord['FIELD_EXTRA5'] = UserRequest::$post[$this->code . '_field_extra5'];
    }

    function loadPanel(&$plotrecord, $values) {
        $plotrecord[$this->code . '_field_extra1'] = $values['FIELD_EXTRA1'];
        $plotrecord[$this->code . '_field_extra2'] = $values['FIELD_EXTRA2'];
        $plotrecord[$this->code . '_field_extra3'] = $values['FIELD_EXTRA3'];
        $plotrecord[$this->code . '_field_extra4'] = $values['FIELD_EXTRA4'];
        $plotrecord[$this->code . '_field_extra5'] = $values['FIELD_EXTRA5'];
    }

    function defaultPanel(&$plotrecord) {
        $plotrecord['HSIZE'] = '400';
        $plotrecord['VSIZE'] = '200';
        $plotrecord[$this->code . '_field_extra1'] = '0';  //lowerLimit
        $plotrecord[$this->code . '_field_extra2'] = CLX_NUM_HUNDRED; //upperLimit
        $plotrecord[$this->code . '_field_extra3'] = '';  //lowerLimitDisplay
        $plotrecord[$this->code . '_field_extra4'] = '';  //upperLimitDisplay
        $plotrecord[$this->code . '_field_extra5'] = '1';  //showLimits
    }

    function viewForm(&$table, $record) {
        $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $table->addData(dict('GEN_LBL_LOWERLIMIT') . ':', $record[$this->code . '_field_extra1']);
        $table->addData(dict('GEN_LBL_UPPERLIMIT') . ':', $record[$this->code . '_field_extra2']);
        $table->addData(dict('GEN_LBL_LOWERLIMITDISPLAY') . ':', $record[$this->code . '_field_extra3']);
        $table->addData(dict('GEN_LBL_UPPERLIMITDISPLAY') . ':', $record[$this->code . '_field_extra4']);
        $table->addData(dict('GEN_LBL_SHOWLIMITS') . ':', $yesno[$record[$this->code . '_field_extra5']]);
    }

    /**
     * builds Final Plot
     */
    function build($plotrecord) {
        if (!empty($plotrecord))
            $sourceData = $this->plotData($plotrecord);
        if (!empty($sourceData)) {
            /** Chart Data start * */
            /** XML Setup * */
            $basefont = ($plotrecord['FONTTYPE'] === '') ? 'arial' : $plotrecord['FONTTYPE'];
            $baseFontSize = $plotrecord['FONTSIZE'];
            $basefontcolor = '000000';
            /** XML Creation * */
            $data = new XMLObject('Chart');
            $data->setProp('basefontsize', $baseFontSize);
            $data->setProp('basefont', $basefont);
            $data->setProp('basefontcolor', $basefontcolor);
            $data->setProp('caption', dict($plotrecord['TITLE']));
            $data->setProp('subCaption', dict($plotrecord['SUBTITLE']));
            $data->setProp('lowerLimit', $plotrecord['FIELD_EXTRA1']);
            $data->setProp('upperLimit', $plotrecord['FIELD_EXTRA2']);
            $data->setProp('lowerLimitDisplay', $plotrecord['FIELD_EXTRA3']);
            $data->setProp('upperLimitDisplay', $plotrecord['FIELD_EXTRA4']);
            $data->setProp('showLimits', $plotrecord['FIELD_EXTRA5']);
            //To be added to prompt
            $data->setProp('showColorNames', '1');
            $data->setProp('BorderThickness', '1');
            $data->setProp('chartLeftMargin', CLX_NUM_30);
            $data->setProp('chartTopMargin', CLX_NUM_20);
            $data->setProp('chartRightMargin', CLX_NUM_30);
            $data->setProp('chartBottomMargin', CLX_NUM_20);
            $data->setProp('pointerSides', '3');
            $data->setProp('pointerborderColor', '333333');
            $data->setProp('pointerBgColor', 'FF3333');
            $data->setProp('pointerRadius', '10');
            $data->setProp('placeValuesInside', '0');
            $data->setProp('decimalPrecision', '2');
            $data->setProp('displayValueDistance', '30');
            $data->setProp('hoverCapBgColor', 'F2F2FF');
            $data->setProp('hoverCapBorderColor', '6A6FA6');
            /** Color Range * */
            $ANPR = &getTool('ANPR');
            $ranges = ClxCommon::$db->getRecords($ANPR->tablename, 'CHARTCODE =' . singleQuote($plotrecord['IDCODE']) . ' ORDER BY SEQNUM ASC');
            $colorRange = new XMLObject('colorRange');
            while (($range = ClxCommon::$db->getNextRecord($ranges))) {
                $color = new XMLObject('color');
                $color->setProp('minValue', $range['FROM_VALUE']);
                $color->setProp('maxValue', $range['TO_VALUE']);
                $color->setProp('name', $range['DISPLAY_LABEL']);
                $color->setProp('code', $range['COLOR']);
                $color->setProp('alpha', $range['TRANSPARENCY']);
                $colorRange->addObject($color);
            }
            $data->addObject($colorRange);
            /** PLOT Data * */
            reset($sourceData);
            foreach ($sourceData as $key => $val) {
                reset($val);
                foreach ($val as $key2 => $val2) {
                    if ($val2['type'] === 'VAL') {
                        $set = new XMLObject('value');
                        $set->setContents($val2['val']);
                        $data->addObject($set);
                    }
                }//end while
            }//end while
            $flash = array();
            $flash['TYPE'] = $this->plotfile;

            $flash['FILENAME'] = 'rep_' . $plotrecord['IDCODE'] . '_' . time() . '.xml';
            $data->save(kPathToWebSite . kPathToTemp . $flash['FILENAME']);
            $flash['WIDTH'] = $plotrecord['HSIZE'];
            $flash['HEIGHT'] = $plotrecord['VSIZE'];
            $flash['BORDER'] = $plotrecord['BORDER'];
            $flash['SWFFILE'] = 'plot/' . $flash['TYPE'] . '?dataUrl=' . kWebSite . 'temp/' . $flash['FILENAME'];
            $flash['ID'] = str_replace('.swf', '', $flash['TYPE']);
            $flash['ALIGN'] = '';
            $flash['BGCOLOR'] = '#FFFFFF';
            $contents = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6, 0, 0,0" WIDTH="' . $plotrecord['HSIZE'] . '" HEIGHT="' . $plotrecord['VSIZE'] . '" VIEWASTEXT>
						<param NAME="movie" VALUE="' . $flash['SWFFILE'] . '&amp;chartWidth=' . $plotrecord['HSIZE'] . '&amp;chartHeight=' . $plotrecord['VSIZE'] . '">
						<param NAME="FlashVars" VALUE="">
						<param NAME="quality" VALUE="high">
						<param NAME="bgcolor" VALUE="#FFFFFF">
						<embed src="' . $flash['SWFFILE'] . '&amp;chartWidth=' . $plotrecord['HSIZE'] . '&amp;chartHeight=' . $plotrecord['VSIZE'] . '" FlashVars="" quality="high" bgcolor="#FFFFFF" NAME="FusionCharts" ALIGN TYPE="application/x-shockwave-flash" WIDTH="' . $plotrecord['HSIZE'] . '" HEIGHT="' . $plotrecord['VSIZE'] . '" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer">';
        } else {
            $contents = dict('GEN_ERROR_INVALID_CHART');
        }
        return $contents;
    }

}
