<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_tool extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'TOOL';
        $this->name = 'Tool';
        $this->type = 'USSH';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Shortcut that invokes a Clientix Tool';
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_ACCESS',
                    'fields' => array(
                        array('name' => 'access', 'type' => CLX_CLASS_LIST, 'default' => 'private',
                            'options' => array(
                                '1' => 'GEN_LBL_PUBLIC',
                                '0' => 'GEN_LBL_PRIVATE'
                            )
                        )
                    )
                )
            )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['USTO_extra1'];
        $record['EXTRA2'] = UserRequest::$post['USTO_extra2'];
    }

    function setPanel(&$record, $values) {
        $record['USTO_extra1'] = $values['EXTRA1'];
        $record['USTO_extra2'] = $values['EXTRA2'];
    }

    function defaultPanel(&$record) {
        $record['USTO_extra1'] = '';
        $record['USTO_extra2'] = '';
    }

    function viewForm(&$table, $record) {
        $table->addData(dict('GEN_LBL_USTO') . ':', $record['USTO_extra1']);
        $table->addData(dict('GEN_LBL_PARAMETERS') . ':', $record['USTO_extra2']);
    }

    function describe($record) {
        return 'Execute tool: ' . $record['EXTRA1'] . ' (' . $record['EXTRA2'] . ')';
    }

    function makeURL($record) {
        return sprintf('tool.php?to=%s&%s', $record['EXTRA1'], $record['EXTRA2']);
    }

}
