<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_url extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UURL';
        $this->name = 'URL';
        $this->type = 'USSH';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Shortcut that takes you to an URL';
        $this->editPanel = array('entries' => array(
                array('label' => 'OBJ_USSH_UURL_TITLE',
                    'fields' => array(
                        array('name' => 'UURL_extra1', 'type' => 'string', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '64', 'validations' => array(
                                array('type' => 'string', 'required' => '1'),)
                        )
                    )
                )
            )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['UURL_extra1'];
        $record['EXTRA2'] = UserRequest::$post['UURL_extra2'];
    }

    function setPanel(&$record, $values) {
        $record['UURL_extra1'] = $values['EXTRA1'];
        $record['UURL_extra2'] = $values['EXTRA2'];
    }

    function defaultPanel(&$record) {
        $record['UURL_extra1'] = 'http://www.alenet.com/';
    }

    function viewForm(&$table, $record) {
        $windows = array(dict('GEN_LBL_EXTWIN'), dict('GEN_LBL_SAMWIN'));
        $table->addData(dict('GEN_LBL_WINDOW') . ':', $windows[$record['UURL_extra2']]);
    }

    function describe($record) {
        return 'Go to: ' . $record['EXTRA1'];
    }

    function makeUURL($record) {
        return $record['EXTRA1'];
    }

}
