<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 * 
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-08-09 14:52:08 -0400 (ma., 09 ago. 2016) $
 * @version        $Rev: 8610 $
 * 
 * CHANGE LOG
 * 2005/07/05 Oracle uppercase record changed
 * 2009/04/06 Included label
 */

class ac_reports extends clx_tool {

    // CONSTRUCTOR //

    function __construct() {
	$this->code = 'ACRP';
	$this->name = 'Reports Access Manager';
	$this->system = 'Security';
	$this->version = '1.0.0.1';

	$this->has_preferences = false;
	$this->has_access = true;
	$this->has_package = false;
	$this->has_pagelet = false;

	$this->tablename = 'CLX_AC_REPORTS';
	$this->record_name_singular = 'reports access';
	$this->record_name_plural = 'reports accesses';

	$this->primary_field = 'OWNERCODE';
	$this->primary_field = 'OWNERCODE';
	$this->secondary_field = 'OWNERREF';
    }

    /* function init() {
      $this->accesskey = $this->code;
      $this->access = $this->getAccess($this->accesskey);
      } */

//------------------------------------------------------------------------------

    function install() {
	$UIMI = getTool('UIMI');
	$UIMI->add($this->code, 'MENU_TOOLS:MENU_SECURITY:MENU_REPORT_ACCESS', 'TOOL', $this->code, 'ac=LIST');
//	$UIMI->add($this->code, 'MENU_TOOLS:MENU_SECURITY:MENU_ACCESS_REPORT', 'TOOL', $this->code, 'ac=ACREPORT');
    }

    function toolTableStructure() {

	$fields = array();
	$fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
	$fields['OWNERCODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
	$fields['OWNERREF'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
	$fields['REPORTSCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
	$fields['ISADMIN'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
	$fields['CANREAD'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
	$fields['CANMODIFY'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
	$fields['CANDELETE'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
	$fields['CANAPPEND'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
	$indexes = array();
	$ipf = 'CLX' . $this->code;
	$indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
	$indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'OWNERCODE,OWNERREF,REPORTSCODE');
	return array('idcode' => $this->code,
	    'idname' => $this->name,
	    'name' => $this->tablename,
	    'type' => 'InnoDB',
	    'fields' => $fields,
	    'indexes' => $indexes);
    }

//------------------------------------------------------------------------------
//-- A C C E S S
//------------------------------------------------------------------------------

    function action($ac, $idlist) {
	$contents = '';
	$msg = array();
	if ($this->getAccess()->canRead()) {
	    switch ($ac) {
		case 'ACREPORT':
		    if (($this->getAccess()->canDisplay()) || $this->getAccess()->canModify()) {
			if (!empty(UserRequest::$post['confirm']) && $this->checkRepForm($msg)) {
			    $contents = $this->repAccess(
				    UserRequest::$post['ACAD_usergroup'], UserRequest::$post['ACAD_username'], UserRequest::$post[$this->code . '_format']);
			} else {
			    $contents = $this->repForm(UserRequest::$post, $msg);
			}
		    } else {
			$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_REPORTS-CAN_APPEND & CAN_MODIFY 1][' . $ac . '] ' . $this->getCode(false));
		    }
		    break;
		case 'WIZARD':
		    if (($this->getAccess()->canDisplay()) || $this->getAccess()->canModify()) {
			$contents = $this->controlWizard();
		    } else {
			$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_REPORTS-CAN_APPEND & CAN_MODIFY 2][' . $ac . '] ' . $this->getCode(false));
		    }
		    break;

		case 'MODIFY':
		    if ($this->getAccess()->canModify()) {
			$id = array_pop($idlist);
			$record = ClxCommon::$db->getRecord($this->tablename, "ID=$id");
			UserRequest::$post[$this->code . '_ownercode'] = $record['OWNERCODE'];
			UserRequest::$post[$this->code . '_ownerref'] = $record['OWNERREF'];
			UserRequest::$post[$this->code . '_toolcode'] = (!empty($record['TOOLCODE'])) ? $record['TOOLCODE'] : ''; //Verify TOOLCODE?
			UserRequest::$post['step'] = CLX_NUM_THREE;

			$contents = $this->editForm3(UserRequest::$post, $msg);
		    } else {
			$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_REPORTS-CAN_MODIFY][' . $ac . '] ' . $this->getCode(false));
		    }
		    break;

		// Default
		default:
		    $contents = parent::action($ac, $idlist);
	    }
	} else {
	    $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_REPORTS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
	}
	return $contents;
    }

//------------------------------------------------------------------------------

    function makelist($listingcode = null) {
    //$t = time('U'); genera un warning
	$t = time();
	$to = $this->code;
	$here = 'tool.php?to=' . $to . '&t=' . $t;
	clearHistory();
	pushHistory($this->code, 'LIST', array());
	$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
	$form->setProp('id', $this->code . 'List');
	$form->addArgument('to', $this->code);
	$form->addArgument('ac', 'NOT_DEFINED');

	$selectclause = $this->code . '.*, 
            ANRP.IDNAME REPORTSNAME,
            /* ANRP.IDCODE REPORTSCODE, */
            ANRP.ID ID2,
            DBMO.IDNAME MODULENAME, 
            DBMO.IDCODE MODULECODE';
	$fromclause = ' CLX_AN_REPORTS ANRP 
            JOIN CLX_AC_REPORTS ACRP ON ACRP.REPORTSCODE = ANRP.IDCODE
            JOIN CLX_DB_MODULES DBMO ON ANRP.MODULECODE = DBMO.IDCODE';
	$whereclause = '';
	$sortclause = '';
	$page = new xPaging();
	$page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause);

	$tableWidth = CLX_NUM_FIVE;
	$table = new htmlTable($tableWidth);
	//$table->setProps(array('class' => 'list', 'width' => '100%'));
	//$table->addCell(dict('TOOL_ACRP_TITLE_LIST'), array(CLX_PROP_CLASS => 'title', CLX_PROP_COLSPAN => $tableWidth));
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$table->addCell(dict('TOOL_ACRP_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
	$page->header($table);

	//$table->addCells('headers', array(dict('GEN_LBL_SEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_MODULE'), dict('GEN_LBL_REPORTS'), dict('GEN_LBL_PRIVILEGES')));
	$table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_MODULE'), dict('GEN_LBL_REPORTS'), dict('GEN_LBL_PRIVILEGES')));
	$i = CLX_NUM_ZERO;

	while (($record = $page->nextRecord()) == true) {
	    $recordid = $record['ID'];
	    $select = new htmlCheckbox('selector_' . $recordid, false);
	    $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp('id')) . ');');
	    //$table->addCell($select->source(), array(CLX_PROP_CLASS => 'footers', CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
	    $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => CLX_NUM_40, CLX_PROP_ALIGN => CLX_PROP_CENTER));
	    $access = $this->accessDetail($record);
	    //$table->addCells(($i % CLX_NUM_TWO == 0) ? 'data' : 'dataalt', array(($record['OWNERCODE'] . ':' . $record['OWNERREF'] == ':') ? "USER:ADMINISTRADOR" :
	    $table->addCells(($i % CLX_NUM_TWO == 0) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(($record['OWNERCODE'] . ':' . $record['OWNERREF'] == ':') ? "USER:ADMINISTRADOR" :
			$record['OWNERCODE'] . ':' . $record['OWNERREF'], $record['MODULENAME'], $record['REPORTSNAME'], $access));
	    $i++;
	}

	$buttons = '';
	if ($this->getAccess()->canDelete()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_DELETE'), 'DELETE', $form->getProp('id'));
	    $b->setProp('id', 'MULT');
	    $buttons .= $b->source();
	}
	if ($this->getAccess()->canModify()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_MODIFY'), 'MODIFY', $form->getProp('id'));
	    $b->setProp('id', 'MULT');
	    $buttons .= $b->source();
	}

	if ($this->getAccess()->canDisplay()) {
	    $b = new htmlFormSubmit(dict('TOOL_ACRP_BUTTON_CREATEWIZ'), 'WIZARD', $form->getProp('id'));
	    $b->setProp('id', 'ON');
	    $buttons .= $b->source();
	}
	$b = new htmlFormSubmit(dict('GEN_LBL_FILTER'), 'FILTER', $form->getProp('id'));
	$b->setProp('id', 'ON');
	$buttons .= $b->source();

	$form->addContents($page->footers($table, $buttons));
	return $form->source();
    }

    private function accessDetail($record) {
	$access = '';
	if (!empty($record['ISADMIN'])) {
	    $access = 'Administrator';
	} else {
	    if (!empty($record['CANREAD'])) {
		if ($access === '') {
		    $access .= 'Can read';
		} else {
		    $access .= ', read';
		}
	    }
	    if (!empty($record['CANMODIFY'])) {
		if ($access === '') {
		    $access .= 'Can modify';
		} else {
		    $access .= ', modify';
		}
	    }
	    if (!empty($record['CANDELETE'])) {
		if ($access === '') {
		    $access .= 'Can delete';
		} else {
		    $access .= ', delete';
		}
	    }
	    if (!empty($record['APPEND'])) {
		if ($access === '') {
		    $access .= 'Can append';
		} else {
		    $access .= ', append';
		}
	    }
	    if ($access === '') {
		$access = 'No access privileges.';
	    } else {
		$access .= '.';
	    }
	}
	return $access;
    }

    function controlWizard() {
	$msg = array();
	$contents = '';
	$step = (isset(UserRequest::$post['step'])) ? UserRequest::$post['step'] : '0';
	switch ($step) {
	    case '0':
		UserRequest::$post = $this->defaultRecord();
		$contents = $this->editForm1(UserRequest::$post, $msg);
		break;
	    case '1':
		if ($this->checkForm1($msg)) {
		    $contents = $this->editForm2(UserRequest::$post, $msg);
		} else {
		    $contents = $this->editForm1(UserRequest::$post, $msg);
		}
		break;
	    case '2':
		if ($this->checkForm2($msg)) {
		    $contents = $this->editForm3(UserRequest::$post, $msg);
		} else {
		    $contents = $this->editForm2(UserRequest::$post, $msg);
		}
		break;
	    case '3':
		if ($this->checkForm3($msg)) {
		    $this->saveWizard();
		    $info = popHistory();
		    $contents = executeHistory($info);
		} else {
		    $contents = $this->editForm3(UserRequest::$post, $msg);
		}
		break;
	    default:
		break;
	}
	return $contents;
    }

    function editForm1($record, $msg) {
	$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
	$form->addArgument(CLX_PROP_TO, $this->code);
	$form->addArgument('ac', 'WIZARD');
	$form->addArgument('step', '1');
	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ1'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	$codes = new HTMLSelect('ACRP_ownercode');
	$codes->addItem(dict('GEN_LBL_USER'), 'USER', ($record['ACRP_ownercode'] === 'USER'));
	$codes->addItem(dict('GEN_LBL_USERGROUP'), 'GRUP', ($record['ACRP_ownercode'] === 'GRUP'));
	$table->addData(dict('GEN_LBL_GIVE_ACCESS_TO') . ':', $codes->source());
	$form->addContents($table->source());
	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$buttons = htmlButton::getButton('submit', dict('GEN_LBL_CONTINUE'), array('action' => 'WIZARD', 'form' => $form->getProp(CLX_PROP_ID)))->source();
	$c = new htmlButtonCancel();
	$buttons .= $c->source();
	$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	$form->addContents($table->source());
	return $form->source();
    }

    function checkForm1(&$msg) {
	$msg = array();
	return count($msg) == CLX_NUM_ZERO;
    }

    function editForm2($record, $msg) {
	$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
	$form->addArgument(CLX_PROP_TO, $this->code);
	$form->addArgument('ac', 'WIZARD');
	$form->addArgument('step', '2');
	$form->addArgument($this->code . '_ownercode', $record[$this->code . '_ownercode']);
	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$table->addCell(dict('TOOL_ACTA_TITLE_CREATEWIZ'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	if ($record[$this->code . '_ownercode'] == 'USER') {
	    $table->addCell(dict('TOOL_ACTA_TITLE_CREATEWIZ2U'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	    $ACUS = &getTool('ACUS');
	    $ACUS->placeChooseUser($msg, dict('GEN_LBL_USERNAME') . ':', $this->code . '_ownerref', (array_key_exists($this->code . '_ownerref', $record)) ? $record[$this->code . '_ownerref'] : '', $table);
	} elseif ($record[$this->code . '_ownercode'] == 'GRUP') {
	    $table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ2G'), array(CLX_PROP_CLASS => 'subtitle', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	    $ACGR = &getTool('ACGR');
	    $ACGR->placeChooseGroup($msg, dict('GEN_LBL_USERGROUP') . ':', $this->code . '_ownerref', (array_key_exists($this->code . '_ownerref', $record)) ? $record[$this->code . '_ownerref'] : '', $table);
	}

	$form->addContents($table->source());
	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$buttons = htmlButton::getButton('submit', dict('GEN_LBL_CONTINUE'), array('action' => 'WIZARD', 'form' => $form->getProp(CLX_PROP_ID)))->source();
	$c = new htmlButtonCancel();
	$buttons .= $c->source();
	$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	$form->addContents($table->source());
	return $form->source();
    }

    function checkForm2(&$msg) {
	$msg = array();

	if (UserRequest::$post[$this->code . '_ownercode'] == 'USER') {
	    $ACUS = &getTool('ACUS');
	    if (!$ACUS->userExists(UserRequest::$post[$this->code . '_ownerref'])) {
		$msg[$this->code . '_ownerref'] = 'There is no user with this code.';
	    }
	} elseif (UserRequest::$post[$this->code . '_ownercode'] == 'GRUP') {
	    $ACGR = &getTool('ACGR');
	    if (!$ACGR->groupExists(UserRequest::$post[$this->code . '_ownerref'])) {
		$msg[$this->code . '_ownerref'] = 'There is no group with this code.';
	    }
	}

	return (count($msg) == CLX_NUM_ZERO);
    }

//------------------------------------------------------------------------------

    function editForm3($record, $msg) {
	$variables = array();
	$script = getJavaScript($this->code . '_editform3.js', $variables);

	// the Form --------------------------------------
	$form = new htmlForm('action', 'tool.php');
	$form->addArgument('to', $this->code);
	$form->addArgument('ac', 'WIZARD');
	$form->addArgument('step', '3');
	$form->addArgument($this->code . '_ownercode', $record[$this->code . '_ownercode']);
	$form->addArgument($this->code . '_ownerref', $record[$this->code . '_ownerref']);

	// header info --------------------------------------
	$tableWidth = CLX_NUM_TWO;
	$table = new htmlTable($tableWidth);
	//$table->setProps(array('class' => 'form', 'width' => '100%'));
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	//$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ'), array(CLX_PROP_CLASS => 'title', CLX_PROP_COLSPAN => $tableWidth));
	//$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ3'), array(CLX_PROP_CLASS => 'subtitle', CLX_PROP_COLSPAN => $tableWidth));
	$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
	$table->addCell(dict('TOOL_ACRP_TITLE_CREATEWIZ3'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
	if ($record[$this->code . '_ownercode'] == 'USER') {
	    $table->addData(dict('GEN_LBL_USERNAME') . ':', $record[$this->code . '_ownerref']);
	} elseif ($record[$this->code . '_ownercode'] == 'GRUP') {
	    $table->addData(dict('GEN_LBL_USERGROUP') . ':', $record[$this->code . '_ownerref']);
	}
	$form->addContents($table->source());

	// the records --------------------------------------
	$tableWidth = CLX_NUM_SIX;
	$table = new htmlTable($tableWidth);
	//$table->setProps(array('class' => 'form', 'width' => '100%'));
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	//$table->addCells('headers', array(dict('GEN_LBL_TOOLS'), dict('GEN_LBL_CANREAD'), dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN')));
	$table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_TOOLS'), dict('GEN_LBL_CANREAD'), dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN')));

	$reportsrecs = ClxCommon::$db->executeQuery('SELECT t.*, m.IDNAME MODULENAME, m.IDCODE MODULECODE FROM CLX_AN_REPORTS t, CLX_DB_MODULES m WHERE t.MODULECODE=m.IDCODE ORDER BY m.IDNAME');
	$lastmodule = '';
	$i = CLX_NUM_ZERO;
	while (($reportsrec = ClxCommon::$db->getNextRecord($reportsrecs)) == true) {
	    if ($lastmodule != $reportsrec['MODULENAME']) {
		$lastmodule = $reportsrec['MODULENAME'];
		$table->addCell($lastmodule . ' [' . $reportsrec['MODULECODE'] . ']', array(CLX_PROP_CLASS => 'subtitle', CLX_PROP_COLSPAN => $tableWidth));
	    }
	    $this->fillAccessForm($record[$this->code . '_ownercode'], $record[$this->code . '_ownerref'], $reportsrec['IDCODE'], $reportsrec['IDNAME'], ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? 'data' : 'dataalt', $table, $form);
	    $i++;
	}

	// buttons  --------------------------------------
	$buttons = '';
	$c = new htmlFormSubmit(dict('GEN_LBL_SAVE'), 'WIZARD', $form->getProp('id'));
	$buttons .= $c->source();
	$c = new htmlButtonCancel();
	$buttons .= $c->source();

	// Masive selectors  --------------------------------------
	$canread = new htmlCheckBox('Masive_All_canread', false);
	$canread->setProp('onClick', 'checkAll(' . singleQuote($form->getProp('id')) . ', ' . singleQuote('canread') . ');');
	$canread->setProp('class', 'cread');
	$canmodify = new htmlCheckBox('Masive_All_canmodify', false);
	$canmodify->setProp('onClick', 'checkAll(' . singleQuote($form->getProp('id')) . ', ' . singleQuote('canmodify') . ');');
	$canmodify->setProp('class', 'cmodify');
	$candelete = new htmlCheckBox("Masive_All_candelete", false);
	$candelete->setProp('onClick', 'checkAll(' . singleQuote($form->getProp('id')) . ', ' . singleQuote('candelete') . ');');
	$candelete->setProp('class', 'cdelete');
	$canappend = new htmlCheckBox('Masive_All_canappend', false);
	$canappend->setProp('onClick', 'checkAll(' . singleQuote($form->getProp('id')) . ', ' . singleQuote('canappend') . ');');
	$canappend->setProp('class', 'cappend');
	$isadmin = new htmlCheckBox("Masive_All_isadmin", false);
	$isadmin->setProp('onClick', 'checkAll(' . singleQuote($form->getProp('id')) . ', ' . singleQuote('isadmin') . ');');
	$isadmin->setProp('class', 'cadmin');

	// Footers
	$table->addCells('footers', array($buttons, $canread->source(), $canmodify->source(), $candelete->source(), $canappend->source(), $isadmin->source()));
	$form->addContents($table->source());

	return $script . $form->source();
    }

    function fillAccessForm($ownercode, $ownerref, $reportscode, $reportsname, $class, &$table, &$form) {
	$record = ClxCommon::$db->getRecord($this->tablename, 'OWNERCODE=' . singleQuote($ownercode) . ' AND OWNERREF=' . singleQuote($ownerref) . ' AND REPORTSCODE=' . singleQuote($reportscode));
	if(is_null($record)) {
		$record['CANREAD'] = '0';
		$record['CANMODIFY'] = '0';
		$record['CANDELETE'] = '0';
		$record['CANAPPEND'] = '0';
		$record['ISADMIN'] = '0';
	}
	$js = 'checkReadValue(' . singleQuote($form->getProp('id')) . ', ' . singleQuote($reportscode) . ');';
	$canread = new htmlCheckBox($reportscode . '_canread', $record['CANREAD']);
	$canread->setProp('onClick', $js);
	$canread->setProp('class', 'cread');


	$js = 'checkAccessValues(' . singleQuote($form->getProp('id')) . ', ' . singleQuote($reportscode) . ');';
	$canmodify = new htmlCheckBox($reportscode . '_canmodify', $record['CANMODIFY']);
	$canmodify->setProp('onClick', $js);
	$canmodify->setProp('class', 'cmodify');

	$candelete = new htmlCheckBox($reportscode . '_candelete', $record['CANDELETE']);
	$candelete->setProp('onClick', $js);
	$candelete->setProp('class', 'cdelete');

	$canappend = new htmlCheckBox($reportscode . '_canappend', $record['CANAPPEND']);
	$canappend->setProp('onClick', $js);
	$canappend->setProp('class', 'cappend');


	$js = 'checkAdminValue(' . singleQuote($form->getProp('id')) . ', ' . singleQuote($reportscode) . ');';
	$isadmin = new htmlCheckBox($reportscode . "_isadmin", $record["ISADMIN"]);
	$isadmin->setProp('onClick', $js);
	$isadmin->setProp('class', 'cadmin');


	$table->addCells($class, array($reportsname . ' [' . $reportscode . ']', $canread->source(), $canmodify->source(), $candelete->source(), $canappend->source(), $isadmin->source()));
    }

    function checkForm3(&$msg) {
	$msg = array();

	return (count($msg) == CLX_NUM_ZERO);
    }

    function saveWizard() {
	$ownercode = UserRequest::$post[$this->code . '_ownercode'];
	$ownerref = UserRequest::$post[$this->code . '_ownerref'];
	$lastid = CLX_NUM_ZERO;
	$records = array();
	$reportsrecs = ClxCommon::$db->executeQuery('select * from CLX_AN_REPORTS');
	$tablerec = ClxCommon::$db->getNextRecord($reportsrecs);
	while (($tablerec = ClxCommon::$db->getNextRecord($reportsrecs)) == true) {
	    $record = array();
	    $record['OWNERCODE'] = $ownercode;
	    $record['OWNERREF'] = $ownerref;
	    $record['REPORTSCODE'] = $tablerec['IDCODE'];
	    $record['CANREAD'] = (empty(UserRequest::$post[$tablerec['IDCODE'] . '_canread'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	    $record['CANMODIFY'] = (empty(UserRequest::$post[$tablerec['IDCODE'] . '_canmodify'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	    $record['CANDELETE'] = (empty(UserRequest::$post[$tablerec['IDCODE'] . '_candelete'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	    $record['CANAPPEND'] = (empty(UserRequest::$post[$tablerec['IDCODE'] . '_canappend'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	    $record['ISADMIN'] = (empty(UserRequest::$post[$tablerec['IDCODE'] . '_isadmin'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	    $crit = 'OWNERCODE=' . singleQuote($ownercode) . ' AND OWNERREF=' . singleQuote($ownerref) . ' AND UPPER(REPORTSCODE) = ' . singleQuote(UPPERCASE($record['REPORTSCODE']));
	    ClxCommon::$db->loadDbRecord($this->tablename, $record, false, $crit);
	    unset($id);
	}
    }

//end method

    /**
     * Saves Menu Table Wizard from Menu Items.
     * @param string $ownercode
     * @param string $ownerref
     * @param string $reportscode
     * @param string $canread
     * @param string $canmodify
     * @param string $candelete
     * @param string $canappend
     * @param string $isadmin
     */
    function saveMenuWizard($ownercode, $ownerref, $reportscode, $canread, $canmodify, $candelete, $canappend, $isadmin) {
	$record = array();
	$record['OWNERCODE'] = $ownercode;
	$record['OWNERREF'] = $ownerref;
	$record['REPORTSCODE'] = $reportscode;
	$record['CANREAD'] = (empty($canread)) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	$record['CANMODIFY'] = (empty($canmodify)) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	$record['CANDELETE'] = (empty($candelete)) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	$record['CANAPPEND'] = (empty($canappend)) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	$record['ISADMIN'] = (empty($isadmin)) ? CLX_NUM_ZERO : CLX_NUM_ONE;
	$crit = 'OWNERCODE=' . singleQuote($ownercode) . ' AND OWNERREF=' . singleQuote($ownerref) .' AND UPPER(REPORTSCODE) = ' . singleQuote(UPPERCASE($record['REPORTSCODE']));
	$id = ClxCommon::$db->loadDbRecord($this->tablename, $record, false, $crit);
	unset($id);
    }

//end method
//------------------------------------------------------------------------------

    function confirmDeleteFill(&$table, $record) {
	$table->addData(dict('GEN_LBL_NAME') . ':', $record[$this->code . '_ownercode'] . ':' . $record[$this->code . '_ownerref']);
	$table->addData(dict('GEN_LBL_REPORTSCODE') . ':', $record[$this->code . '_reportscode']);
    }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

    function filterFormFill($msg, &$table) {
	if (!array_key_exists($this->code . '_ownerref', UserRequest::$post))
	    UserRequest::$post[$this->code . '_ownerref'] = '';
	if (!array_key_exists($this->code . '_reportscode', UserRequest::$post))
	    UserRequest::$post[$this->code . '_reportscode'] = '';

	$codes = new HTMLSelect($this->code . '_ownercode');
	$codes->addItem('', '', true);
	$codes->addItem(dict('GEN_LBL_USER'), 'USER', false);
	$codes->addItem(dict('GEN_LBL_USERGROUP'), 'GRUP', false);

	$field = new HTMLField($this->code . '_ownerref', UserRequest::$post[$this->code . '_ownerref'], CLX_NUM_30, CLX_NUM_30);
	$table->addData(dict('GEN_LBL_GIVE_ACCESS_TO') . ':', $codes->source() . $field->source());

	$table->addField($msg, dict('GEN_LBL_REPORTS') . ':', $this->code . '_reportscode', UserRequest::$post[$this->code . '_reportscode'], CLX_NUM_FOUR, CLX_NUM_FOUR);

	$sort = new HtmlSelect($this->code . '_sort');
	$sort->addItem('', '', true);
	$sort->addItem(dict('GEN_LBL_NAME'), $this->code . '.OWNERCODE, ACRP.OWNERREF', false);
	$sort->addItem(dict('GEN_LBL_REPORTS'), $this->code . '.REPORTSCODE', false);
	$table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {

	$filter = '';
	$boolean = '';
	if (!empty(UserRequest::$post[$this->code . '_ownercode'])) {
	    $filter .= $boolean . ' ACRP.OWNERCODE = ' . singleQuote(UserRequest::$post[$this->code . '_ownercode']);
	    $boolean = 'AND';
	    $filter .= $boolean . ' ACRP.OWNERREF LIKE ' . singleQuote(UserRequest::$post[$this->code . '_ownerref'] . '%');
	}

	if (!empty(UserRequest::$post[$this->code . '_reportscode'])) {
	    $filter .= $boolean . ' UPPER(ACRP.REPORTSCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post[$this->code . '_reportscode']) . '%');
	    $boolean = 'AND';
	}

	$_SESSION['paging'][$this->code . 'List']['sortby'] = UserRequest::$post[$this->code . '_sort'];
	$_SESSION['paging'][$this->code . 'List']['criteria'] = $filter;
	$_SESSION['paging'][$this->code . 'List']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
	$_SESSION['paging'][$this->code . 'List']['criteria'] = '';
    }*/

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

    function loadToolRecord($recordid) {
	$values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
	$record = array();
	$record[$this->code . '_id'] = $recordid;
	$record[$this->code . '_ownercode'] = $values['OWNERCODE'];
	$record[$this->code . '_ownerref'] = $values['OWNERREF'];
	$record[$this->code . '_reportscode'] = $values['REPORTSCODE'];
	$record[$this->code . '_isadmin'] = $values['ISADMIN'];
	$record[$this->code . '_canread'] = $values['CANREAD'];
	$record[$this->code . '_canmodify'] = $values['CANMODIFY'];
	$record[$this->code . '_candelete'] = $values['CANDELETE'];
	$record[$this->code . '_canappend'] = $values['CANAPPEND'];
	return $record;
    }

    function deleteRecordSk($id) {
	ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
	$record = array();
	$record[$this->code . '_ownercode'] = 'USER';
	$record[$this->code . '_ownerref'] = $_SESSION['user_record']['username'];
	$record[$this->code . '_reportscode'] = '';
	$record[$this->code . '_isadmin'] = '0';
	$record[$this->code . '_canread'] = '0';
	$record[$this->code . '_canmodify'] = '0';
	$record[$this->code . '_candelete'] = '0';
	$record[$this->code . '_canappend'] = '0';
	return $record;
    }

    function userGroups($username) {
	$list = array();
	$records = ClxCommon::$db->getRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
	while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
	    $list[] = singlequote($record['GROUPCODE']);
	}
	return $list;
    }

    function securityQuery() {
	$username = $_SESSION['user_record']['username'];
	$usersql = '(OWNERCODE=' . singleQuote('USER') . ' AND UPPER(OWNERREF)=' . singleQuote(uppercase($username)) . ')';
	$usergroups = $this->userGroups($username);
	if (count($usergroups) > CLX_NUM_ZERO) {
	    $usergroups = toString($usergroups);
	    $sql = '(' . $usersql . ' OR (OWNERCODE=' . singleQuote('GRUP') . ' AND OWNERREF IN (' . $usergroups . ')))';
	} else {
	    $sql = $usersql;
	}
	return $sql;
    }

    /**
     * Build access report form
     *
     * @param array $record
     * @param array $msg
     * @return string
     */
    function repForm($record, $msg) {

	$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
	$form->addArgument(CLX_PROP_TO, $this->code);
	$form->addArgument('ac', 'ACREPORT');
	$form->addArgument('confirm', '1');
	if (empty($record['ACAD_usergroup'])) {
	    $record['ACAD_usergroup'] = '';
	}
	if (empty($record['ACAD_username'])) {
	    $record['ACAD_username'] = '';
	}
	if (empty($record['ACRP_format'])) {
	    $record['ACRP_format'] = '';
	}

	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$table->addCell(dict('TOOL_ACRP_TITLE_ACREPORT'), array(CLX_PROP_CLASS => 'title', CLX_PROP_COLSPAN => $tableWidth));
	$table->addCell(dict('TOOL_ACRP_TITLE_ACREPORT_EXPLAIN'), array(CLX_PROP_CLASS => 'subtitle', CLX_PROP_COLSPAN => $tableWidth));

	$table->addLookup($msg, dict('GEN_LBL_USERGROUP') . ':', 'ACAD_usergroup', $record['ACAD_usergroup'], 'ACGR', CLX_NUM_16, CLX_NUM_16);
	$table->addLookup($msg, dict('GEN_LBL_USERNAME') . ':', 'ACAD_username', $record['ACAD_username'], 'ACUS', CLX_NUM_30, CLX_NUM_30);
	$table->addSeparator(CLX_CLASS_DATA);
	$codes = new HTMLSelect($this->code . '_format');
	$codes->addItem(dict('GEN_LBL_ONLINE'), 'HTML', ($record[$this->code . '_format'] == 'HTML') ? true : false);
	$codes->addItem(dict('GEN_LBL_EXCELL'), 'XLS', ($record[$this->code . '_format'] == 'XLS') ? true : false);
	$table->addData(dict('GEN_LBL_FORMAT'), $codes->source());

	$form->addContents($table->source());
	$table = new htmlTable(CLX_WIDTH_TWO);
	$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
	$buttons = htmlButton::getButton('submit', dict('GEN_LBL_CONTINUE'), array('action' => 'ACREPORT', 'form' => $form->getProp(CLX_PROP_ID)))->source();
	$c = new htmlButtonCancel();
	$buttons .= $c->source();
	$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
	$form->addContents($table->source());
	return $form->source();
    }

    /**
     * Validate report form data
     *
     * @param array $msg
     * @return boolean
     */
    function checkRepForm(&$msg) {
	//Check group
	if (!empty(UserRequest::$post['ACAD_usergroup'])) {
	    if (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUPS', 'UPPER(IDCODE) = ' . singleQuote(uppercase(UserRequest::$post['ACAD_usergroup']))) == CLX_NUM_ZERO) {
		$msg['ACAD_usergroup'] = dict('TOOL_ACGR_NOGROUPFOUND');
	    }
	}
	//Check user
	if (!empty(UserRequest::$post['ACAD_username'])) {
	    if (ClxCommon::$db->oneExistsRecords('CLX_AC_USERS', 'UPPER(USERNAME) = ' . singleQuote(uppercase(UserRequest::$post['ACAD_username']))) == CLX_NUM_ZERO) {
		$msg['ACAD_username'] = dict('GEN_LBL_USER_DONT_EXIST');
	    }
	}
	//check if user on group
	if (!empty(UserRequest::$post['ACAD_username']) && !empty(UserRequest::$post['ACAD_usergroup'])) {
	    if (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME) = ' . singleQuote(uppercase(UserRequest::$post['ACAD_username'])) . ' AND GROUPCODE = ' . singleQuote(UserRequest::$post['ACAD_usergroup'])) == CLX_NUM_ZERO) {
		$msg['ACAD_username'] = dict('GEN_LBL_USER_NOTIN_GROUP');
	    }
	}
	return count($msg) == CLX_NUM_ZERO;
    }

    function repAccess($groupcode, $username, $format) {
	$contents = '';
	if (empty($groupcode) && empty($username)) {
	    $sql = 'SELECT IDCODE FROM CLX_AC_GROUPS ORDER BY IDCODE ASC';
	    $rs = ClxCommon::$db->executeQuery($sql);
	    while (($r = ClxCommon::$db->getNextRecord($rs)) == true) {
		$contents .= $this->repAccessBuildGroup($r['IDCODE'], '', $format);
	    }
	} else {
	    $contents .= $this->repAccessBuildGroup($groupcode, $username, $format);
	}
	if ($format === 'XLS') {
	    sendDownloadFile('download', 'xls');
	}
	return $contents;
    }

    function repAccessBuildGroup($groupcode, $username, $format) {
	$contents = '';
	$lang = getCurrentLanguage();
	$xls = ($format == 'XLS') ? true : false;
	$yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
	$status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
	$isadmin = ClxCommon::$db->getField('CLX_AC_USERS', 'ISADMIN', 'UPPER(USERNAME) = ' . singleQuote(uppercase($username)));
	if (empty($username)) {
	    $sql = '  SELECT  ACRP.ID,
				ACRP.REPORTSCODE,
				ACRP.ISADMIN ISADMIN,
				ACRP.CANREAD CANREAD,
				ACRP.CANMODIFY CANMODIFY,
				ACRP.CANDELETE CANDELETE,
				ACRP.CANAPPEND CANAPPEND,
					ANRP.IDNAME REPORTSNAME,
					ANRP.IDCODE REPORTSCODE,
					ANRP.ID ID2,
					DBMO.IDNAME MODULENAME, 
					DBMO.IDCODE MODULECODE
			FROM 	CLX_AN_REPORTS ANRP 
				JOIN CLX_AC_REPORTS ACRP 
			ON	ACRP.REPORTSCODE = ANRP.IDCODE
				JOIN CLX_DB_MODULES DBMO 
			ON	ANRP.MODULECODE = DBMO.IDCODE 
			WHERE ACRP.OWNERREF =' . singleQuote($groupcode);
	} else {
	    $sql = 'SELECT ACRP.ID,
					ACRP.REPORTSCODE,
					MAX(ACRP.ISADMIN) ISADMIN,
					MAX(ACRP.CANREAD) CANREAD,
					MAX(ACRP.CANMODIFY) CANMODIFY,
					MAX(ACRP.CANDELETE) CANDELETE,
					MAX(ACRP.CANAPPEND) CANAPPEND,
						ANRP.IDNAME REPORTSNAME,
						ANRP.IDCODE REPORTSCODE,
						ANRP.ID ID2,
						DBMO.IDNAME MODULENAME, 
						DBMO.IDCODE MODULECODE,
					  MAX(ACRP.GROU) GROU
					FROM 	CLX_AN_REPORTS ANRP 
					JOIN (SELECT  ACRP.ID,
						    ACRP.REPORTSCODE,
						    ACRP.ISADMIN ISADMIN,
						    ACRP.CANREAD CANREAD,
						    ACRP.CANMODIFY CANMODIFY,
						    ACRP.CANDELETE CANDELETE,
						    ACRP.CANAPPEND CANAPPEND,
						    NULL GROU
					      FROM  CLX_AC_REPORTS ACRP 
					      WHERE  ACRP.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(ACRP.OWNERREF)=' . singleQuote(uppercase($username)) . ' 
					      
					    UNION
					    SELECT  ACRP.ID,
						    ACRP.REPORTSCODE,
						    ACRP.ISADMIN ISADMIN,
						    ACRP.CANREAD CANREAD,
						    ACRP.CANMODIFY CANMODIFY,
						    ACRP.CANDELETE CANDELETE,
						    ACRP.CANAPPEND CANAPPEND,
						    G.GROUPCODE GROU
					      FROM  CLX_AC_REPORTS ACRP,
                                                      CLX_AC_GROUP_MEMBERS G
					      WHERE  ACRP.OWNERREF =G.GROUPCODE AND UPPER(G.USERNAME)=' . singleQuote(uppercase($username)) . ' AND ACRP.OWNERCODE=' . singleQuote('GRUP') . ' AND CANREAD=1
					      UNION
					      SELECT  0 ID,
						    ANRP.IDCODE REPORTSCODE,
						    1 ISADMIN,
						    1 CANREAD,
						    1 CANMODIFY,
						    1 CANDELETE,
						    1 CANAPPEND,
						    NULL GROU
					      FROM CLX_AN_REPORTS ANRP
					    WHERE		  
						  NOT EXISTS 
						    (SELECT 1 FROM 	
						    CLX_AC_REPORTS ACRP3 
						    WHERE ANRP.IDCODE =ACRP3.REPORTSCODE AND ACRP3.CANREAD=1))  ACRP 
							ON	ACRP.REPORTSCODE = ANRP.IDCODE
								JOIN CLX_DB_MODULES DBMO 
							ON	ANRP.MODULECODE = DBMO.IDCODE
							GROUP BY ACRP.REPORTSCODE,
                                                                    ACRP.ID,  
                                                                    ANRP.IDNAME,
                                                                    ANRP.IDCODE,
                                                                    ANRP.ID,
                                                                    DBMO.IDNAME, 
                                                                    DBMO.IDCODE';
	}
	$rs =ClxCommon::$db->executeQuery($sql);
	if ($xls) {
	    $nbreak = CLX_CHAR_CR; //Line Break
	    $lbreak = CLX_CHAR_NL; //Line Break
	    $fbreak = CLX_CHAR_TAB; //Field Selarator
	    $contents .= dict('TOOL_ACRP_TITLE_ACREPORT') . $lbreak;
	    $contents .= dict('GEN_LBL_DATE') . ': ' . xFormat::getNow('Y-m-d G:i:s') . $lbreak;
	    $contents .= dict('GEN_LBL_CREATEDBY') . ': ' . $_SESSION['user_record']['username'] . $lbreak;
	    if (!empty($groupcode)) {
		$contents .= dict('GEN_LBL_GROUPCODE') . ': ' . $groupcode . $lbreak;
	    }
	    if (!empty($username)) {
		$contents .= dict('GEN_LBL_USERNAME') . ': ' . $username . $lbreak;
		$contents .= dict('GEN_LBL_SYSADMIN') . ': ' . $yesno[$isadmin] . $lbreak;
	    }
	    $contents .= dict('GEN_LBL_MODULE') . $fbreak .
		    dict('GEN_LBL_CANREAD') . $fbreak;
	    /* dict('GEN_LBL_CANMODIFY') . $fbreak .
	      dict('GEN_LBL_CANDELETE') . $fbreak .
	      dict('GEN_LBL_CANAPPEND') . $fbreak ; */
	    if (!empty($username)) {
		$contents .= dict('GEN_LBL_CODE_GROUP') . $lbreak;
	    } else {
		$contents .= $lbreak;
	    }
	    while (($r = ClxCommon::$db->getNextRecord($rs)) == true) {
		$contents .= $r['MODULECODE'] . $fbreak;
		$prim_tbl = $r['REPORTSNAME'] . '(' . $r['REPORTSCODE'] . ')';
		$contents .= $prim_tbl . $fbreak;
		$contents .= $yesno[$r['CANREAD']] . $fbreak;
		/* 		    $contents .= $yesno[$r['CANMODIFY']] . $fbreak;
		  $contents .= $yesno[$r['CANDELETE']] . $fbreak;
		  $contents .= $yesno[$r['CANAPPEND']] . $fbreak;
		  $contents .= $yesno[$r['ISADMIN']] . $fbreak; */
		if (!empty($username)) {
		    $contents .= $r['GROU'] . $fbreak;
		}
		$contents .= $lbreak;
	    }
	    $contents .= $lbreak;
	    $contents = encode_string($contents, 'ISO-8859-1', 'UTF-8');
	} else {//else xls
	    if (empty($username)) {
		$tableWidth = CLX_NUM_THREE;
	    } else {
		$tableWidth = CLX_NUM_FOUR;
	    }
	    //$table = new htmlTable($tableWidth, 'class', 'form', 'width', '100%');
	    //$table->addCell(dict('TOOL_ACRP_TITLE_ACREPORT'), array(CLX_PROP_CLASS => 'title', CLX_PROP_COLSPAN => $tableWidth));
            $table = new htmlTable($tableWidth);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addCell(dict('TOOL_ACRP_TITLE_ACREPORT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
	    if (!empty($groupcode)) {
		//$table->addCell(dict('GEN_LBL_GROUPCODE') . ':' . $groupcode, array(CLX_PROP_CLASS => 'data', CLX_PROP_COLSPAN => $tableWidth));
		$table->addCell(dict('GEN_LBL_GROUPCODE') . ':' . $groupcode, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
	    }
	    if (!empty($username)) {
		//$table->addCell(dict('GEN_LBL_USERNAME') . ':' . $username, array(CLX_PROP_CLASS => 'data', CLX_PROP_COLSPAN => $tableWidth));
		//$table->addCell(dict('GEN_LBL_SYSADMIN') . ':' . $yesno[$isadmin], array(CLX_PROP_CLASS => 'data', CLX_PROP_COLSPAN => $tableWidth));
		$table->addCell(dict('GEN_LBL_USERNAME') . ':' . $username, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
		$table->addCell(dict('GEN_LBL_SYSADMIN') . ':' . $yesno[$isadmin], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
	    }
	    if (empty($username)) {
		//$table->addCells('headers', array(dict('GEN_LBL_MODULE'), dict('GEN_LBL_MAIN_REPORTS'), dict('GEN_LBL_CANREAD')/* , dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN') */));
		$table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_MODULE'), dict('GEN_LBL_MAIN_REPORTS'), dict('GEN_LBL_CANREAD')/* , dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN') */));
	    } else {
		//$table->addCells('headers', array(dict('GEN_LBL_MODULE'), dict('GEN_LBL_MAIN_REPORTS'), dict('GEN_LBL_CANREAD')/* , dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN') */, dict('GEN_LBL_CODE_GROUP')));
		$table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_MODULE'), dict('GEN_LBL_MAIN_REPORTS'), dict('GEN_LBL_CANREAD')/* , dict('GEN_LBL_CANMODIFY'), dict('GEN_LBL_CANDELETE'), dict('GEN_LBL_CANAPPEND'), dict('GEN_LBL_ISADMIN') */, dict('GEN_LBL_CODE_GROUP')));
	    }

	    //$class = 'data';
	    $class = CLX_CLASS_DATA;
	    $i = CLX_NUM_ZERO;
	    while (($r = ClxCommon::$db->getNextRecord($rs)) == true) {

		//$class = ($i % CLX_NUM_TWO) ? 'dataalt' : 'data';
		$class = ($i % CLX_NUM_TWO) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
		$i++;
		$table->addCell($r['MODULECODE'], array(CLX_PROP_CLASS => $class));
		$prim_tbl = $r['REPORTSNAME'] . '(' . $r['REPORTSCODE'] . ')';
		$table->addCell($prim_tbl, array(CLX_PROP_CLASS => $class));
		$table->addCell($yesno[$r['CANREAD']], array(CLX_PROP_CLASS => $class));
		/* $table->addCell($yesno[$r['CANMODIFY']], array(CLX_PROP_CLASS => $class));
		  $table->addCell($yesno[$r['CANDELETE']], array(CLX_PROP_CLASS => $class));
		  $table->addCell($yesno[$r['CANAPPEND']], array(CLX_PROP_CLASS => $class));
		  $table->addCell($yesno[$r['ISADMIN']], array(CLX_PROP_CLASS => $class)); */
		if (!empty($username)) {
		    $table->addCell($r['GROU'], array(CLX_PROP_CLASS => $class));
		}
	    }
            $contents .= $table->source() . '<br>';
	} //end if xls
	return $contents;
    }

}
