<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: mchirino $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-07-13 15:31:15 -0400 (Fri, 13 Jul 2018) $
 * @version        $Rev: 9846 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
class ac_tree_users extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ACTU';
        $this->name = 'Access Tree Users';
        $this->system = 'Security';
        $this->version = '0.1.2.1';



        $this->accesskey = 'ACTE';
        $this->tablename = 'CLX_AC_TREE_USERS';
        $this->record_name_singular = 'user';
        $this->record_name_plural = 'users';
        $this->primary_field = 'username';
        $this->secondary_field = 'TREECODE';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_ACTU_TITLE_MODIFY',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_USERNAME',
                            'fields' => array(
                                array('name' => 'username', 'type' => 'lookup', 'default' => '', 'tool' => 'ACUS', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'status', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array(
                                        '0' => 'GEN_LBL_INACTIVE',
                                        '1' => 'GEN_LBL_ACTIVE'
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_DEFAULT',
                            'fields' => array(
                                array('name' => 'default', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array(
                                        '1' => 'GEN_LBL_YES',
                                        '0' => 'GEN_LBL_NO'
                                    )
                                )
                            )
                        ), array('fields' => array(
                                array('name' => 'treenode', 'type' => 'string', 'invisible' => '1'))
                        ), array('fields' => array(
                                array('name' => 'treecode', 'type' => 'string', 'invisible' => '1'))
                        )
                    )
                )
            )
        );
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['TREECODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['TREENODE'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['DEFAULT_ENTRY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'USERNAME,TREECODE,TREENODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- A C C E S S   T R E E    U S E R S
    function pack($record) { // not working
        $o = $this->packRecord($record);
        $id = $record['ID'];
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'DBTF', 'SELECT * FROM CLX_DB_TABLEFIELDS WHERE TABLECODE=' . singleQuote($code));
        $this->packsub($objs, 'DBTI', 'SELECT * FROM CLX_DB_TABLEINDEXES WHERE TABLECODE=' . singleQuote($code));
        $this->packsub($objs, 'DBFL', ' SELECT f.* FROM CLX_DB_TABLEFIELDS tb, CLX_DB_FIELDS f WHERE tb.TABLECODE = ' . singleQuote($code) . ' and tb.FIELDNAME = f.FIELDNAME ORDER BY tb.SEQNUM');
        $this->packsub($objs, 'EVNT', 'SELECT * FROM CLX_EVENTS WHERE OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=', $id);
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {  // not working
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $tablecode = $record['IDCODE'];
        $exists = (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'UPPER(IDCODE)=' . singleQuote(uppercase($tablecode))) > CLX_NUM_ZERO);
        if ($exists === true) {
            $tableid = ClxCommon::$db->getField('CLX_DB_TABLES', 'UPPER(IDCODE)=' . singleQuote(uppercase($tablecode)));
            ClxCommon::$db->deleteRecords('CLX_DB_TABLEFIELDS', 'UPPER(TABLECODE)=' . singleQuote(uppercase($tablecode)));
            ClxCommon::$db->deleteRecords('CLX_DB_TABLEINDEXES', 'UPPER(TABLECODE)=' . singleQuote(uppercase($tablecode)));
            ClxCommon::$db->deleteRecords('CLX_EVENTS', 'OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . $tableid);
            ClxCommon::$db->deleteRecords('CLX_DB_TABLES', 'UPPER(IDCODE)=' . singleQuote(uppercase($tablecode)));
        }
        $tableid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObject_($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $tableid));
            }
        }
    }

    function checkForm(&$msg) {
        parent::checkForm($msg);
        $action = UserRequest::$post['ac'];
        if ($action === 'CREATE') {
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME) = ' . singleQuote(uppercase(UserRequest::$post['ACTU_username'])) . ' AND UPPER(TREECODE) = ' . singleQuote(uppercase(UserRequest::$post['ACTU_treecode'])) . ' AND TREENODE = ' . singleQuote(UserRequest::$post['ACTU_treenode']));
            if ($qty > CLX_NUM_ZERO) {
                /*
                 * TOOL_ACTU_ERR_DUP_USR
                 * '^1' user already exists in this Accees Tree level
                 * Usuario '^1' ya existe para este nivel del Árbol de Acceso
                 */
                $msg['ACTU_username'] = dict('TOOL_ACTU_ERR_DUP_USR', UserRequest::$post['ACTU_username']);
            }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function makepanel($treecode = null, $treenode = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
            $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'ACTUPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('treecode', $treecode);
            $form->addArgument('treenode', $treenode);
            $form->addArgument('ac', 'NOT_DEFINED');
            switch (kDatabaseType) {
                case 'oci':
                    $selectclause = 'tu.*, u.LASTNAME||' . singleQuote(',') . '||u.FIRSTNAME FULLNAME';
                    break;
                default:
                    $selectclause = 'tu.*, concat(u.LASTNAME, CONCAT(' . singleQuote(',') . ', u.FIRSTNAME)) FULLNAME';
                    break;
            }//End switch
            $fromclause = 'CLX_AC_TREE_USERS tu, CLX_AC_USERS u';
            $whereclause = 'tu.USERNAME = u.USERNAME AND tu.TREECODE=' . singleQuote($treecode) . ' AND tu.TREENODE=' . singleQuote($treenode);
            $sortclause = 'u.LASTNAME, u.FIRSTNAME';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_NUM_FIVE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_DEFAULT'), dict('GEN_LBL_STATUS')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['FULLNAME'], $record['USERNAME'], $yesno[$record['DEFAULT_ENTRY']], $status[$record['STATUS']]));
                $i++;
            }
            $buttons = '';
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_INCLUDE_SOMETHING', dict('GEN_LBL_USER')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_ACTU_TITLE_LIST'), $treecode . $treenode . 'USERS', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ACTU_id'] = $recordid;
        $record['ACTU_treecode'] = $values['TREECODE'];
        $record['ACTU_treenode'] = $values['TREENODE'];
        $record['ACTU_username'] = $values['USERNAME'];
        $record['ACTU_status'] = $values['STATUS'];
        $record['ACTU_default'] = $values['DEFAULT_ENTRY'];
        return $record;
    }

    function saveRecord() {
        if (UserRequest::$post['ACTU_default']) {
            $record = array();
            $record['DEFAULT_ENTRY'] = '0';
            ClxCommon::$db->updateRecord($this->tablename, $record, 'UPPER(USERNAME)=' . singleQuote(uppercase(UserRequest::$post['ACTU_username'])) . ' AND UPPER(TREECODE)=' . singleQuote(uppercase(UserRequest::$post['ACTU_treecode'])));
        }
        $record = array();
        $record['USERNAME'] = UserRequest::$post['ACTU_username'];
        $record['STATUS'] = UserRequest::$post['ACTU_status'];
        $record['DEFAULT_ENTRY'] = UserRequest::$post['ACTU_default'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ACTU_id']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        if (UserRequest::$post['ACTU_default']) {
            $record = array();
            $record['DEFAULT_ENTRY'] = '0';
			ClxCommon::$db->updateRecord($this->tablename, $record, 'UPPER(USERNAME)=' . singleQuote(uppercase(UserRequest::$post['ACTU_username'])) . ' AND UPPER(TREECODE)=' . singleQuote(uppercase(UserRequest::$post['ACTU_treecode'])));
        }
        $record = array();
        $record['USERNAME'] = UserRequest::$post['ACTU_username'];
        $record['TREENODE'] = UserRequest::$post['ACTU_treenode'];
        $record['TREECODE'] = UserRequest::$post['ACTU_treecode'];
        $record['STATUS'] = UserRequest::$post['ACTU_status'];
        $record['DEFAULT_ENTRY'] = UserRequest::$post['ACTU_default'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['ACTU_id'] = CLX_INIT_ZERO;
        $record['ACTU_treecode'] = $callingpage['treecode'];
        $record['ACTU_treenode'] = $callingpage['treenode'];
        $record['ACTU_username'] = '';
        $record['ACTU_status'] = '1';
        $record['ACTU_default'] = '1';
        return $record;
    }

}
