<?php
/**
 * System Users Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: mchirino $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-03-13 19:46:24 +0000 (Wed, 13 Mar 2019) $
 * @version    	$Rev: 10567 $
 *
 * CHANGE LOG
 *  Incorporado login attemp es necesario ejecutar
 * 		ALTER TABLE CLX_AC_USERS, ADD COLUMN LOGIN_ATTEMPTS
 * 		INT (1)  DEFAULT '0' NOT null;
 */
class ac_users extends clx_tool {

    var $debug = false;
    //var $debug = true;
    var $status_types;
    var $login_img = true;
    private $login_msg = '';
    var $current_date = '';
    var $eibs_utilities;
    var $eibs_mode = false;
    var $authenticated = false;
	
    /**
     * CONSTRUCTOR
     * @param void
     * @return void
     */
    function __construct() {
        $this->code = 'ACUS';
        $this->name = 'User Manager';
        $this->system = 'Security';
        $this->version = '0.5.6.4';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_AC_USERS';
        $this->record_name_singular = 'user';
        $this->record_name_plural = 'users';
        $this->primary_field = 'username';
        $this->secondary_field = 'LASTNAME';

        $this->status_types = array('0' => 'GEN_LBL_INACTIVE', '1' => 'GEN_LBL_ACTIVE',
            '2' => 'GEN_LBL_BLOCKED');
        $this->current_date = date('Y-m-d');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_ACUS_TITLE_MODIFY',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_USERNAME',
                            'fields' => array(
                                array('name' => 'username', 'type' => 'string', 'default' => '', 'size' => '30', 'displaysize' => '32', 'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_PASSWORD',
                            'caption' => 'GEN_LBL_BLANKNOCHANGE',
                            'fields' => array(
                                array('name' => 'password', 'type' => 'password', 'default' => '', 'size' => '32', 'displaysize' => '32', 'dontmodify' => '0',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_CONFIRM',
                            'fields' => array(
                                array('name' => 'confirm', 'type' => 'password', 'default' => '', 'size' => '32', 'displaysize' => '32', 'dontmodify' => '0',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_LDAP_RDN_USERNAME',
                            'fields' => array(
                                array('name' => 'ldap_rdn_username', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '64', 'dontmodify' => '0',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIRSTNAME',
                            'fields' => array(
                                array('name' => 'firstname', 'type' => 'string', 'default' => '', 'size' => '32', 'displaysize' => '32', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_LASTNAME',
                            'fields' => array(
                                array('name' => 'lastname', 'type' => 'string', 'default' => '', 'size' => '32', 'displaysize' => '32', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_COMPANY',
                            'fields' => array(
                                array('name' => 'company', 'type' => 'string', 'default' => '', 'size' => '32', 'displaysize' => '32', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_POSITION',
                            'fields' => array(
                                array('name' => 'position', 'type' => 'string', 'default' => '', 'size' => '32', 'displaysize' => '32', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_EMAIL',
                            'fields' => array(
                                array('name' => 'email', 'type' => 'string', 'default' => '', 'size' => '120', 'displaysize' => '64', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_PHONE',
                            'fields' => array(
                                array('name' => 'phone', 'type' => 'string', 'default' => '', 'size' => '120', 'displaysize' => '32', 'validations' => array(
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_FAX',
                            'fields' => array(
                                array('name' => 'fax', 'type' => 'string', 'default' => '', 'size' => '120', 'displaysize' => '32', 'validations' => array(
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_EXT_REF_NO',
                            'fields' => array(
                                array('name' => 'ext_ref_no', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '32', 'validations' => array(
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_USERAUDIT',
                            'fields' => array(
                                array('name' => 'audit', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES')))
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'status', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => $this->status_types))
                        ), array('label' => 'GEN_LBL_SYSADMIN',
                            'fields' => array(
                                array('name' => 'isadmin', 'type' => 'function', 'function' => 'createAdministratorOption'))
                        ), array('label' => 'GEN_LBL_PASSEXPIRE',
                            'caption' => 'GEN_LBL_PASSEXPIRECAPTION',
                            'fields' => array(
                                array('name' => 'passexpire', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES')))
                        ), array('label' => 'GEN_LBL_PASSREQCHANGE',
                            'caption' => 'GEN_LBL_PASSREQCAPTION',
                            'fields' => array(
                                array('name' => 'passreqchange', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES')))
                        ), array('label' => 'GEN_LBL_LOGIN_ATTEMPTS',
                            'fields' => array(
                                array('name' => 'login_attempts', 'type' => 'string', 'readonly' => 'true'))
                        ), array('label' => 'GEN_LBL_LOGIN_COUNTER',
                            'fields' => array(
                                array('name' => 'login_counter', 'type' => 'string', 'default' => '0'))
                        )
                    )
                )
            )
        );
		IF (ISSET($_SESSION['ADDRDEBUGACUSER']) && $_SESSION['ADDRDEBUGACUSER']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
			
		}	
    }

    /**
     * Returns tool object description (last, first name and user name)
     *
     * @param string $primary_field_value
     * @return string
     */
    function describe($primary_field_value) {
		$name='';
		if (!empty($primary_field_value)) {
			$fetched = false;
			if (kApcTtl_6>0) $record = apc_fetchFct($findVar='descUSer_' .$this->tablename.'_'. $this->primary_field . '_' . $primary_field_value , $fetched);
			if (!$fetched) {
				$record = ClxCommon::$db->getRecord($this->tablename, $this->primary_field . '=' . singleQuote($primary_field_value));
				
				if (kApcTtl_6>0 && !empty($record['LASTNAME'].$record['FIRSTNAME'].$record['USERNAME'])) {
					apc_addFct($findVar,$record,kApcTtl_6);
				}
			}

			if (!empty($record)) {
				$name = $record['LASTNAME'] . ', ' . $record['FIRSTNAME'] . ' (' . $record['USERNAME'] . ')';
			}
		}
		
		return $name;
    }

    /**
     * Tool installator
     *
     * @param void
     * @return void
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SECURITY:MENU_USERS', 'TOOL', $this->code, 'ac=LIST');
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote('ADMIN')) == CLX_NUM_ZERO) {
            ClxCommon::$db->createRecord($this->tablename, array('ID' => '', 'FIRSTNAME' => 'System', 'LASTNAME' => 'Administrator',
                'USERNAME' => 'admin', 'PASSWORD' => clx_mcript('admin'), 'ISADMIN' => '1', 'PASSEXPIRE' => CLX_NUM_ZERO, 'PASSREQCHANGE' => CLX_NUM_ONE, 'STATUS' => CLX_NUM_ONE, 'EMAIL' => 'support@alenet.com',
                'COMPANY' => 'ALeNet, Inc.', 'POSITION' => 'System Administrator',
                'CDATE' => date('Ymdhis'), 'MDATE' => date('Ymdhis'), 'CREATORUSER' => 'admin',
                'AUDITU' => CLX_NUM_ZERO, 'LOGIN_ATTEMPTS' => CLX_NUM_ZERO), false);
            $USPR = &getTool('USPR');
            $USPR->defaultPreferences('admin');
        }
    }

    /**
     * Returns tool Table Structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['FIRSTNAME'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['LASTNAME'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['PASSWORD'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '', 'protected' => '1');
        //   Caso 1002687 - MUN-LDAP login userid alterno
        $fields['LDAP_RDN_USERNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        //Added to track 5 password changes
        $fields['PASSWORD01'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '', 'protected' => '1');
        $fields['PASSWORD02'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '', 'protected' => '1');
        $fields['PASSWORD03'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '', 'protected' => '1');
        $fields['PASSWORD04'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '', 'protected' => '1');
        $fields['PASSWORD05'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '', 'protected' => '1');
        $fields['ISADMIN'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['PASSEXPIRE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['PASSREQCHANGE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['PASSLSTCHANGE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['EMAIL'] = array('type' => 'varchar(128)', 'null' => 'YES', 'properties' => '');
        $fields['PHONE'] = array('type' => 'varchar(128)', 'null' => 'YES', 'properties' => '');
        $fields['FAX'] = array('type' => 'varchar(128)', 'null' => 'YES', 'properties' => '');
        $fields['COMPANY'] = array('type' => 'varchar(64)', 'properties' => '');
        $fields['POSITION'] = array('type' => 'varchar(64)', 'properties' => '');
        $fields['EXT_REF_NO'] = array('type' => 'varchar(64)', 'properties' => '');
        $fields['LAST_SESSION_IP'] = array('type' => 'varchar(32)', 'null' => 'YES', 'properties' => '');
        $fields['LAST_SESSION_DATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['CREATORUSER'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['AUDITU'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO, 'index' => '');
        $fields['LOGIN_ATTEMPTS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO, 'index' => '');
        $fields['LOGIN_COUNTER'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['EXT_REF_NO'] = array('type' => 'varchar(64)', 'null' => 'YES', 'default' => '', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'FIRSTNAME,LASTNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'PASSWORD');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'EMAIL');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'CREATORUSER');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'MyISAM',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    /**
     * Tool action selector
     *
     * @param string $ac, array $idlist
     * @return string
     */
    function action($ac, $idlist) {
        $contents = '';
        $msg = array();
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'INCLUDE':
                    if ($this->getAccess()->canDisplay()) {
                        if (isset(UserRequest::$post['confirm'])) {
                            if ($this->checkIncludeForm($msg)) {
                                $record = array();
                                $record['GROUPCODE'] = UserRequest::$post['ACUS_groupcode'];
                                $record['USERNAME'] = UserRequest::$post['ACUS_username'];
                                ClxCommon::$db->createRecord('CLX_AC_GROUP_MEMBERS', $record, false);
                                $info = popHistory();
                                $to = &getTool($info[CLX_PROP_TO]);
                                $contents = $to->action($info['ac'], toArray($info['idlist']));
                            } else {
                                $contents = $this->includeForm($ac, UserRequest::$post, $msg);
                            }
                        } else {
                            $record = array();
                            if (empty($msg))
                                $msg = array();
                            $record['ACUS_groupcode'] = UserRequest::$request['groupcode'];
                            $contents = $this->includeForm($ac, $record, $msg);
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_USERS-CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'UNLOCK':
                    $this->lockAction($ac, $idlist);
                    $contents = parent::action('LIST', $idlist);
                    break;
                case 'LOCK':
                    $this->lockAction($ac, $idlist);
                    $contents = parent::action('LIST', $idlist);
                    break;
                case 'LDAP_USER_SRCH':
                    $contents = $this->ldapUserSrch();		$tta=fopen(kPathToWebSite."/".kPathToTemp."LDAParchivo.txt","a+");fwrite($tta,"LDAPARCHIVO:".$contents.chr(13).chr(10));fclose($tta);
                    break;
                case 'LDAP_CMD_SRCH':
                    $contents = $this->ldapSearchFromCLI();
                    break;
                 case "USR_GRP_REP":
                    $contents = $this->user_group_report();
                    break;
                case 'EXCLUDE':
                    if ($this->getAccess()->canDelete()) {
                        foreach ($idlist as $id) {
                            $username = ClxCommon::$db->getField($this->tablename, 'USERNAME', 'ID=' . $id);
                            ClxCommon::$db->deleteRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND GROUPCODE=' . singleQuote(UserRequest::$post['groupcode']));
                        }
                        $info = popHistory();
                        $to = &getTool($info[CLX_PROP_TO]);
                        $contents = $to->action($info['ac'], toArray($info['idlist']));
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_USERS-CAN_DELETE][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AC_USERS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Make List
     *
     * @param void
     * @return string
     */
    function makelist($listingcode = null) {
        //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'ACUSList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_NUM_12);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ACUS_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_12));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SELECT'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_FIRSTNAME'), dict('GEN_LBL_LASTNAME'), dict('GEN_LBL_ADMINISTRATOR'), dict('GEN_LBL_EMAIL'), dict('GEN_LBL_PHONE'), dict('GEN_LBL_FAX'), dict('GEN_LBL_STATUS'), dict('GEN_LBL_LOGIN_ATTEMPTS'), dict('GEN_LBL_PASSEXPIRE'), dict('GEN_LBL_PASSREQCHANGE')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['USERNAME'], $record['FIRSTNAME'], $record['LASTNAME'], dict($this->yesno[$record['ISADMIN']]), $record['EMAIL'], $record['PHONE'], $record['FAX'], dict($this->status_types[$record['STATUS']]), $record['LOGIN_ATTEMPTS'] . ' / ' . ((kSessionLoginAttempts == CLX_NUM_ZERO) ? dict('GEN_LBL_NO_LIMIT') : kSessionLoginAttempts), dict($this->yesno[$record['PASSEXPIRE']]), dict($this->yesno[$record['PASSREQCHANGE']])));
            $i++;
        }
        $id = $form->getProp(CLX_PROP_ID);
        $buttons = parent::listingButtons($id);
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_LOCK'), array('action' => 'LOCK', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_UNLOCK'), array('action' => 'UNLOCK', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canRead()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_USR_GRP_REP'), array('action' => 'USR_GRP_REP', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'NONE'))->source();
        }

        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    /**
     * Make Panel
     *
     * @param string $groupcode
     * @return string
     */
    function makepanel($groupcode = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'ACUSPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('groupcode', $groupcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = 'U.*';
            $fromclause = 'CLX_AC_USERS U, CLX_AC_GROUP_MEMBERS G';
            $whereclause = 'U.USERNAME = G.USERNAME AND G.GROUPCODE=' . singleQuote($groupcode);
            $sortclause = 'U.LASTNAME, U.FIRSTNAME';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');

            $table = new htmlTable(CLX_NUM_NINE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SELECT'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_FIRSTNAME'), dict('GEN_LBL_LASTNAME'), dict('GEN_LBL_ADMINISTRATOR'), dict('GEN_LBL_EMAIL'), dict('GEN_LBL_PHONE'), dict('GEN_LBL_FAX'), dict('GEN_LBL_STATUS')));
            $i = CLX_INIT_ZERO;
            $yesno = array('No', 'Yes');
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['USERNAME'], $record['FIRSTNAME'], $record['LASTNAME'], $yesno[$record['ISADMIN']], $record['EMAIL'], $record['PHONE'], $record['FAX'], dict($this->status_types[$record['STATUS']])));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $b = new htmlFormSubmit(dict('GEN_LBL_EXCLUDE'), 'EXCLUDE', $form->getProp(CLX_PROP_ID));
                $b->setProp(CLX_PROP_ID, 'MULT');
                $buttons .= $b->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_USER')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
                $b = new htmlFormSubmit(dict('GEN_LBL_INCLUDE_SOMETHING', dict('TOOL_ACUS_PROMPT_AUSER')), 'INCLUDE', $form->getProp(CLX_PROP_ID));
                $b->setProp(CLX_PROP_ID, 'ON');
                $buttons .= $b->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_ACUS_TITLE_LIST'), $groupcode . '_USERS', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    /**
     * Export listing
     *
     * @param string $listingcode
     */
    function exportList($listingcode = null) {
        $this->export_notes .= dict('GEN_LBL_STATUS') . ': ';
        $comma = '';
        foreach ($this->status_types as $key => $val) {
            $this->export_notes .= $comma . $key . '=' . dict($val, true);
            $comma = ', ';
        }
        return parent::exportList($listingcode);
    }

    /**
     * Search Form
     *
     * @param void
     * @return string
     */
    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_NUM_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ACUS_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        if (!array_key_exists('ACUS_username', UserRequest::$post))
            UserRequest::$post['ACUS_username'] = '';
        if (!array_key_exists('ACUS_lastname', UserRequest::$post))
            UserRequest::$post['ACUS_lastname'] = '';
        if (!array_key_exists('ACUS_firstname', UserRequest::$post))
            UserRequest::$post['ACUS_firstname'] = '';
        $table->addField($msg, dict('GEN_LBL_USERNAME') . ':', 'ACUS_username', UserRequest::$post['ACUS_username'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_LASTNAME') . ':', 'ACUS_lastname', UserRequest::$post['ACUS_lastname'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_FIRSTNAME') . ':', 'ACUS_firstname', UserRequest::$post['ACUS_firstname'], CLX_NUM_32, CLX_NUM_32);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_NUM_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            $boolean = '';
            if (UserRequest::$post['ACUS_username'] <> '') {
                $criteria .= $boolean . 'USERNAME LIKE ' . singleQuote(clx_change_especial_char_html (UserRequest::$post['ACUS_username']) . '%');
                $boolean = ' AND ';
            }
            if (UserRequest::$post['ACUS_lastname'] <> '') {
                $criteria .= $boolean . 'LASTNAME LIKE ' . singleQuote(clx_change_especial_char_html (UserRequest::$post['ACUS_lastname']) . '%');
                $boolean = ' AND ';
            }
            if (UserRequest::$post['ACUS_firstname'] <> '') {
                $criteria .= $boolean . 'FIRSTNAME LIKE ' . singleQuote(clx_change_especial_char_html (UserRequest::$post['ACUS_firstname']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_NUM_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['USERNAME']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=acusers></page><a href=' . singleQuote($js) . '>' . $record['LASTNAME'] . ', ' . $record['FIRSTNAME'] . '</a>', $record['USERNAME']));
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    /**
     * Form Checker
     *
     * @param void
     * @return void
     */
    function checkForm(&$msg) {
        $msg = array();
        $action = UserRequest::$post['ac'];
        if ($action === 'CREATE' || $action === 'DUPLICATE') {
            /* ACUS_USER_MAX_LENGTH */
            $min = CLX_NUM_SIX;
            if (defined('ACUS_USER_MIN_LENGTH') && ACUS_USER_MIN_LENGTH > CLX_NUM_ZERO) {
                $min = ACUS_USER_MIN_LENGTH;
            }
            $max = CLX_NUM_16;
            if (ACUS_USER_MAX_LENGTH > CLX_NUM_30) {
                $msg['ACUS_username'] = dict('GEN_LBL_PARAMETERS') . ' - ' . dict('GEN_ERR_USERTOLONG', '30') . ' ';
            }
            if (defined('ACUS_USER_MAX_LENGTH') && ACUS_USER_MAX_LENGTH > CLX_NUM_ZERO) {// && ACUS_USER_MAX_LENGTH<31
                $max = ACUS_USER_MAX_LENGTH;
            }
            if (strlen(UserRequest::$post['ACUS_username']) < $min) {
                $msg['ACUS_username'] = dict('GEN_ERR_USERTOSHORT', $min);
            }
            if (strlen(UserRequest::$post['ACUS_username']) > $max) {
                $msg['ACUS_username'] = dict('GEN_ERR_USERTOLONG', $max);
            }
            if (defined('ACUS_USER_CHAR_CASE') && ACUS_USER_CHAR_CASE > CLX_NUM_ZERO) {
                switch (ACUS_USER_CHAR_CASE) {
                    case '1'://uppercase
                        if (UserRequest::$post['ACUS_username'] <> uppercase(UserRequest::$post['ACUS_username'])) {
                            $msg['ACUS_username'] = dict('GEN_ERR_USR_TOUPPERCASE');
                        }
                        break;
                    case '2'://LOWERcase
                        if (UserRequest::$post['ACUS_username'] <> lowercase(UserRequest::$post['ACUS_username'])) {
                            $msg['ACUS_username'] = dict('GEN_ERR_USR_TOuppercase');
                        }
                        break;
                    default:
                        break;
                }//end  switch
            }
            if (empty($msg)) {
                xValidate::unique($msg, 'ACUS_username', 'user name', $this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase(UserRequest::$post['ACUS_username'])));
            }
        }
        if (($action === 'MODIFY' && strlen(UserRequest::$post['ACUS_password'] > CLX_NUM_ZERO || UserRequest::$post['ACUS_confirm']) > CLX_NUM_ZERO) || $action === 'CREATE' || $action === 'DUPLICATE') {

            xValidate::password($msg, 'ACUS_password', UserRequest::$post['ACUS_password'], 'ACUS_confirm', UserRequest::$post['ACUS_confirm']);
            //Additional password validations
            xValidate::password_extras($msg, 'ACUS_password', UserRequest::$post['ACUS_password']);
            //Enforce history
            $password = clx_mcript(UserRequest::$post['ACUS_password']);
            if (!$this->checkPasswordHistory(UserRequest::$post['ACUS_id'], $password, $action)) {
                $msg['ACUS_password'] = dict('GEN_ACUS_PASS_ON_HISTORY');
            }
            //Validating that password should be at least x number od day to change
            if (!$this->checkPasswordMinDaysToChange(UserRequest::$post['ACUS_id'])) {
                $msg['ACUS_password'] = dict('GEN_ACUS_PASS_MIN_CHANGE', ACUS_PWD_MIN_DAYS);
            }
            /* ACUS_PWD_EXP_LOGINS
              Defines number of login to require password change. Set 0 = no limit */
            if (defined('ACUS_PWD_EXP_LOGINS') && ACUS_PWD_EXP_LOGINS > CLX_NUM_ZERO) {

            }
            /*
              ACUS_PWD_EXP_DAYS Defines number of days for password to expire. Set 0 for no limit */
            if (defined('ACUS_PWD_EXP_DAYS') && ACUS_PWD_EXP_DAYS > CLX_NUM_ZERO) {

            }
        }
        xValidate::Required($msg, 'ACUS_firstname', UserRequest::$post['ACUS_firstname']);
        xValidate::Required($msg, 'ACUS_lastname', UserRequest::$post['ACUS_lastname']);
        xValidate::Mail($msg, 'ACUS_email', UserRequest::$post['ACUS_email']);
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Create Administrator Option
     *
     * @param string $field_name, array $record
     * @return string
     */
    function createAdministratorOption($field_name, $record) {
        if (!empty($_SESSION['user_record']['isadmin'])) {
            $yesno = new htmlSelect($field_name);
            $yesno->addItem(dict('GEN_LBL_YES'), '1', ($record[$field_name] == CLX_NUM_ONE));
            $yesno->addItem(dict('GEN_LBL_NO'), '0', ($record[$field_name] == CLX_NUM_ZERO));
            $source = $yesno->source();
        } else {
            $source = 'You are not allowed to edit this information.';
        }
        return $source;
    }

    /**
     * Include Form
     *
     * @param string $ac, array $record, array $msg
     * @return string
     */
    function includeForm($ac, $record, $msg) {
        $contents = '';
        $title = dict('TOOL_ACUS_TITLE_INCLUDEUSER');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('ACUS_groupcode', $record['ACUS_groupcode']);
        $table = new htmlTable(CLX_NUM_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_GROUPCODE') . ':', $record['ACUS_groupcode']);
        $contents .= $this->placeChooseUser($msg, dict('GEN_LBL_USERNAME') . ':', 'ACUS_username', (!empty($record['ACUS_username'])) ? $record['ACUS_username'] : '', $table);
        $form->addContents($table->source());
        $buttons = '';
        $table = new htmlTable(CLX_NUM_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $c = new htmlFormSubmit(dict('GEN_LBL_INCLUDE', dict('GEN_LBL_USER')), 'INCLUDE', $form->getProp(CLX_PROP_ID));
        $buttons .= $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $form->addContents($table->source());
        $contents .= $form->source();
        return $contents;
    }

    /**
     * Check Include Form
     *
     * @param void
     * @return void
     */
    function checkIncludeForm(&$msg) {
        $msg = array();
        //Validate if user exists
        if (!$this->userExists(UserRequest::$post['ACUS_username'])) {
            $msg['ACUS_username'] = dict('GEN_LBL_USER_DONT_EXIST');
        }
        //Validate if user already exists in the group
        if (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUP_MEMBERS', 'GROUPCODE = ' . singleQuote(UserRequest::$post['ACUS_groupcode']) . ' AND UPPER(USERNAME) = ' . singleQuote(uppercase(UserRequest::$post['ACUS_username']))) > CLX_NUM_ZERO) {
            $msg['ACUS_username'] = dict('GEN_ACGR_USERALREADYEXISTS');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Confirm Delete From Filler
     *
     * @param object $table, array $record
     * @return void
     */
    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ACUS_username']);
        $table->addData(dict('GEN_LBL_LASTNAME') . ':', $record['ACUS_lastname']);
        $table->addData(dict('GEN_LBL_FIRSTNAME') . ':', $record['ACUS_firstname']);
    }

    /**
     * Form editor call
     *
     * @param string $ac, array $idlist, array $record, array $msg
     * @return void
     */
    function editForm($ac, $idlist, $record, $msg) {
        if (UserRequest::$request['ac'] === 'CREATE') {
            unset($this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_ONE]['caption']);
            $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_ONE]['fields'][CLX_NUM_ZERO]['validations'][CLX_NUM_ZERO]['required'] = CLX_NUM_ONE;
            $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_TWO]['fields'][CLX_NUM_ZERO]['validations'][CLX_NUM_ZERO]['required'] = CLX_NUM_ONE;
        }
        $contents = '';
        //if (ACUS_LOGIN_MODE === 'LDAP'/* && ACUS_LDAP_DIRECTORY_TYPE==1 */) {
        if (uppercase(trim(ACUS_LOGIN_MODE)) === 'LDAP'/* && ACUS_LDAP_DIRECTORY_TYPE==1 */) {
            //Attach ldap and active directory not set for eny other
            $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_ZERO]['fields'][CLX_NUM_ZERO]['sufix_extra'] = $this->ldap_js_script(CLX_NUM_ONE);
            $contents .= $this->ldap_js_script(CLX_NUM_ZERO);
            $contents .= $this->ldap_js_script(CLX_NUM_TWO);
        } else {
            //   Caso 1002687 - MUN-LDAP login userid alterno
            // If Login mode is not LDAP, deletes LDAP_RDN_USERNAME field
            //unset($this->editform['panels'][CLX_NUM_ZERO]['entries'][3]);
            $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_THREE]['fields'][CLX_NUM_ZERO]['sufix_extra'] = $this->ldap_js_script(CLX_NUM_THREE);
        }
        $contents .= parent::editForm($ac, $idlist, $record, $msg);
        return $contents;
    }

    /**
     * Filter Form screen filler
     *
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('username', $record['ACUS_username']);
        $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $contents = '';
        $table = new htmlTable(CLX_NUM_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ACUS_TITLE_VIEW') . ': ' . $record['ACUS_username'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ACUS_username']);
        if (ACUS_LOGIN_MODE === 'LDAP') {
            $table->addData(dict('GEN_LBL_LDAP_RDN_USERNAME') . ':', $record['ACUS_ldap_rdn_username']);
        }
        $table->addData(dict('GEN_LBL_FIRSTNAME') . ':', $record['ACUS_firstname']);
        $table->addData(dict('GEN_LBL_LASTNAME') . ':', $record['ACUS_lastname']);
        $table->addData(dict('GEN_LBL_COMPANY') . ':', $record['ACUS_company']);
        $table->addData(dict('GEN_LBL_POSITION') . ':', $record['ACUS_position']);
        $table->addData(dict('GEN_LBL_EMAIL') . ':', $record['ACUS_email']);
        $table->addData(dict('GEN_LBL_PHONE') . ':', $record['ACUS_phone']);
        $table->addData(dict('GEN_LBL_FAX') . ':', $record['ACUS_fax']);
        $table->addData(dict('GEN_LBL_EXT_REF_NO') . ':', $record['ACUS_ext_ref_no']);
        $table->addData(dict('GEN_LBL_USERAUDIT') . ':', $yesno[$record['ACUS_audit']]);
        $table->addData(dict('GEN_LBL_SYSADMIN') . ':', $yesno[$record['ACUS_isadmin']]);
        $table->addData(dict('GEN_LBL_PASSEXPIRE') . ':', $yesno[$record['ACUS_passexpire']]);
        $table->addData(dict('GEN_LBL_PASSREQCHANGE') . ':', $yesno[$record['ACUS_passreqchange']]);
        $table->addData(dict('GEN_LBL_PASSLSTCHANGE') . ':', $record['ACUS_passlstchange']);
        $table->addData(dict('GEN_LBL_STATUS') . ':', dict($this->status_types[$record['ACUS_status']]));
        $table->addData(dict('GEN_LBL_LOGIN_ATTEMPTS') . ':', $record['ACUS_login_attempts'] . ' / ' . ((kSessionLoginAttempts == CLX_NUM_ZERO) ? dict('GEN_LBL_NO_LIMIT') : kSessionLoginAttempts));
        $table->addData(dict('GEN_LBL_LAST_SESSION_IP') . ':', $record['ACUS_last_session_ip']);
        $table->addData(dict('GEN_LBL_LAST_SESSION_DATE') . ':', $record['ACUS_last_session_date']);
        $contents .= $table->source();
        $ACGR = &getTool('ACGR');
        $contents .= $ACGR->makepanel($record['ACUS_username']);
        //Adding field security panel.
        $ACFS = &getTool('ACFS');
        $contents .= $ACFS->makepanel($record['ACUS_username']);
        $table = new htmlTable(CLX_NUM_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['ACUS_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['ACUS_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ACUS_creatoruser']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    /**
     * Filter Form screen filler
     *
     * @param array $msg, object $table
     * @return void
     */
    function filterFormFill($msg, &$table) {
        if (!array_key_exists('ACUS_username', UserRequest::$post))
            UserRequest::$post['ACUS_username'] = '';
        if (!array_key_exists('ACUS_lastname', UserRequest::$post))
            UserRequest::$post['ACUS_lastname'] = '';
        if (!array_key_exists('ACUS_firstname', UserRequest::$post))
            UserRequest::$post['ACUS_firstname'] = '';
        $table->addField($msg, dict('GEN_LBL_USERNAME') . ':', 'ACUS_username', UserRequest::$post['ACUS_username'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_LASTNAME') . ':', 'ACUS_lastname', UserRequest::$post['ACUS_lastname'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_FIRSTNAME') . ':', 'ACUS_firstname', UserRequest::$post['ACUS_firstname'], CLX_NUM_32, CLX_NUM_32);
        $yesno = new htmlSelect('ACUS_audit');
        $yesno->addItem('', '', true);
        $yesno->addItem(dict('GEN_LBL_YES'), '1', false);
        $yesno->addItem(dict('GEN_LBL_NO'), '0', false);
        $table->addData(dict('GEN_LBL_USERAUDIT') . ':', $yesno->source());
        $yesno = new htmlSelect('ACUS_isadmin');
        $yesno->addItem('', '', true);
        $yesno->addItem(dict('GEN_LBL_YES'), '1', false);
        $yesno->addItem(dict('GEN_LBL_NO'), '0', false);
        $table->addData(dict('GEN_LBL_SYSADMIN') . ':', $yesno->source());
        $status = new htmlSelect('ACUS_status');
        $status->addItem('', '', true);
        foreach ($this->status_types as $key => $val) {
            $status->addItem(dict($val), $key, false);
        }
        $table->addData(dict('GEN_LBL_STATUS') . ':', $status->source());
        $sort = new HtmlSelect('ACUS_sort');
        $sort->addItem('', '', true);
        $sort->addItem('User Name', 'username', false);
        $sort->addItem('Last Name', 'lastname', false);
        $sort->addItem('First Name', 'firstname', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    /**
     * Sets given filter
     *
     * @param void
     * @return void
     */
    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['ACUS_username'])) {
            $filter .= $boolean . ' UPPER(USERNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ACUS_username'])) . '%');
            $boolean = ' AND ';
        }
        if (!empty(UserRequest::$post['ACUS_lastname'])) {
            $filter .= $boolean . ' UPPER(LASTNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ACUS_lastname'])) . '%');
            $boolean = ' AND ';
        }
        if (!empty(UserRequest::$post['ACUS_firstname'])) {
            $filter .= $boolean . ' UPPER(FIRSTNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ACUS_firstname'])) . '%');
            $boolean = ' AND ';
        }
        if (array_key_exists('ACUS_audit', UserRequest::$post) && strlen(UserRequest::$post['ACUS_audit']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' AUDITU=' . UserRequest::$post['ACUS_audit'];
            $boolean = ' AND ';
        }
        if (array_key_exists('ACUS_status', UserRequest::$post) && strlen(UserRequest::$post['ACUS_status']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' STATUS=' . UserRequest::$post['ACUS_status'];
            $boolean = ' AND ';
        }
        if (array_key_exists('ACUS_isadmin', UserRequest::$post) && strlen(UserRequest::$post['ACUS_isadmin']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' ISADMIN=' . UserRequest::$post['ACUS_isadmin'];
            $boolean = ' AND ';
        }
        $_SESSION['paging']['ACUSList']['sortby'] = UserRequest::$post['ACUS_sort'];
        $_SESSION['paging']['ACUSList']['criteria'] = $filter;
        $_SESSION['paging']['ACUSList']['startat'] = '0';
    }

    /**
     * Clear Filter
     *
     * @param void
     * @return void
     */
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	////////////////////////////////////////////////// 
    /*function clearfilter() {
        $_SESSION['paging']['ACUSList']['criteria'] = '';
    }*/

    /**
     * Loads tool row
     *
     * @param string $recordid
     * @return void
     */
    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ACUS_id'] = $recordid;
        $record['ACUS_username'] = $values['USERNAME'];
        $record['ACUS_password'] = '';
        $record['ACUS_confirm'] = '';
        $record['ACUS_ldap_rdn_username'] = $values['LDAP_RDN_USERNAME'];
        $record['ACUS_firstname'] = $values['FIRSTNAME'];
        $record['ACUS_lastname'] = $values['LASTNAME'];
        $record['ACUS_company'] = $values['COMPANY'];
        $record['ACUS_position'] = $values['POSITION'];
        $record['ACUS_email'] = $values['EMAIL'];
        $record['ACUS_phone'] = $values['PHONE'];
        $record['ACUS_fax'] = $values['FAX'];
        $record['ACUS_ext_ref_no'] = $values['EXT_REF_NO'];
        $record['ACUS_isadmin'] = $values['ISADMIN'];
        $record['ACUS_passexpire'] = $values['PASSEXPIRE'];
        $record['ACUS_passreqchange'] = $values['PASSREQCHANGE'];
        $record['ACUS_passlstchange'] = $values['PASSLSTCHANGE'];
        $record['ACUS_status'] = $values['STATUS'];
        $record['ACUS_cdate'] = xFormat::date($values['CDATE']);
        $record['ACUS_mdate'] = xFormat::date($values['MDATE']);
        $record['ACUS_creatoruser'] = $values['CREATORUSER'];
        $record['ACUS_audit'] = $values['AUDITU'];
        $record['ACUS_login_attempts'] = $values['LOGIN_ATTEMPTS'];
        $record['ACUS_login_counter'] = $values['LOGIN_COUNTER'];
        $record['ACUS_last_session_ip'] = $values['LAST_SESSION_IP'];
        $record['ACUS_last_session_date'] = $values['LAST_SESSION_DATE'];
        return $record;
    }

    /**
     * Save tool row
     *
     * @param void
     * @return void
     */
    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['LDAP_RDN_USERNAME'] = UserRequest::$post['ACUS_ldap_rdn_username'];
        $record['FIRSTNAME'] = UserRequest::$post['ACUS_firstname'];
        $record['LASTNAME'] = UserRequest::$post['ACUS_lastname'];
        $record['COMPANY'] = UserRequest::$post['ACUS_company'];
        $record['POSITION'] = UserRequest::$post['ACUS_position'];
        $record['STATUS'] = UserRequest::$post['ACUS_status'];
        $record['PASSEXPIRE'] = UserRequest::$post['ACUS_passexpire'];
        $record['PASSREQCHANGE'] = UserRequest::$post['ACUS_passreqchange'];
        $record['LOGIN_ATTEMPTS'] = CLX_INIT_ZERO;
        $record['LOGIN_COUNTER'] = UserRequest::$post['ACUS_login_counter'];
        if(is_null($record['LOGIN_COUNTER']) || $record['LOGIN_COUNTER'] == '') {
            $record['LOGIN_COUNTER'] = CLX_NUM_ZERO;
        }
        $record['EMAIL'] = UserRequest::$post['ACUS_email'];
        $record['PHONE'] = UserRequest::$post['ACUS_phone'];
        $record['FAX'] = UserRequest::$post['ACUS_fax'];
        $record['EXT_REF_NO'] = UserRequest::$post['ACUS_ext_ref_no'];
        if (UserRequest::$post['ACUS_password'] <> '') {//if not empty just change it
            if (array_key_exists('ACUS_ibsuser', UserRequest::$post)) {
                $record['PASSWORD'] = UserRequest::$post['ACUS_password'];
            } else {
                $record['PASSWORD'] = clx_mcript(UserRequest::$post['ACUS_password']);
                //move user password for history
                $usrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . UserRequest::$post['ACUS_id']);
                $record['PASSWORD01'] = $usrec['PASSWORD'];
                $record['PASSWORD02'] = $usrec['PASSWORD01'];
                $record['PASSWORD03'] = $usrec['PASSWORD02'];
                $record['PASSWORD04'] = $usrec['PASSWORD03'];
                $record['PASSWORD05'] = $usrec['PASSWORD04'];
                $record['PASSLSTCHANGE'] = $d;
            }
        }
        if (array_key_exists('ACUS_ibsuser', UserRequest::$post) || $_SESSION['user_record']['isadmin']) {
            $record['ISADMIN'] = UserRequest::$post['ACUS_isadmin'];
        }
        $record['AUDITU'] = UserRequest::$post['ACUS_audit'];
        $record['MDATE'] = $d;
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ACUS_id']);
    }

    /**
     * Create tool row
     *
     * @param void
     * @return int
     */
    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['USERNAME'] = UserRequest::$post['ACUS_username'];
        if (array_key_exists('ACUS_ibsuser', UserRequest::$post)) {
            $record['PASSWORD'] = UserRequest::$post['ACUS_password'];
        } else {
            $record['PASSWORD'] = clx_mcript(UserRequest::$post['ACUS_password']);
        }
        $record['PASSLSTCHANGE'] = $d;
        if (isset($record['LDAP_RDN_USERNAME']))
            $record['LDAP_RDN_USERNAME'] = UserRequest::$post['ACUS_ldap_rdn_username'];
        $record['FIRSTNAME'] = UserRequest::$post['ACUS_firstname'];
        $record['LASTNAME'] = UserRequest::$post['ACUS_lastname'];
        $record['COMPANY'] = UserRequest::$post['ACUS_company'];
        $record['POSITION'] = UserRequest::$post['ACUS_position'];
        $record['EMAIL'] = UserRequest::$post['ACUS_email'];
        $record['PHONE'] = UserRequest::$post['ACUS_phone'];
        $record['FAX'] = UserRequest::$post['ACUS_fax'];
        $record['EXT_REF_NO'] = UserRequest::$post['ACUS_ext_ref_no'];
        $record['PASSEXPIRE'] = UserRequest::$post['ACUS_passexpire'];
        $record['PASSREQCHANGE'] = UserRequest::$post['ACUS_passreqchange'];
        $record['LOGIN_ATTEMPTS'] = CLX_INIT_ZERO;
        $record['LOGIN_COUNTER'] = CLX_INIT_ZERO;
        if (!empty($_SESSION['user_record']['isadmin'])) {
            $record['ISADMIN'] = UserRequest::$post['ACUS_isadmin'];
        }
        $record['PASSLSTCHANGE'] = $d;
        $record['LAST_SESSION_DATE'] = $d;
        $record['STATUS'] = UserRequest::$post['ACUS_status'];
        $record['AUDITU'] = UserRequest::$post['ACUS_audit'];
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['CREATORUSER'] = (!empty($_SESSION['user_record']['username'])) ? $_SESSION['user_record']['username'] : 'system';
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $callingpage = peekHistory();
        if (array_key_exists(CLX_PROP_TO, $callingpage) && $callingpage[CLX_PROP_TO] === 'ACGR') {
            $record = array();
            $record['GROUPCODE'] = $callingpage['groupcode'];
            $record['USERNAME'] = UserRequest::$post['ACUS_username'];
            ClxCommon::$db->createRecord('CLX_AC_GROUP_MEMBERS', $record, false);
        }
        $USPR = &getTool('USPR');
        $USPR->defaultPreferences($record['USERNAME']);
        return $recordid;
    }

    /**
     * Delete tool row
     *
     * @param string $id
     * @return void
     */
    function deleteRecordSk($id) {
        $userrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        //$username = $userrec['username'];
        $username = $userrec['USERNAME'];
        ClxCommon::$db->deleteRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_AC_TOOLS', 'OWNERCODE=' . singleQuote('USER') . ' AND UPPER(OWNERREF)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_AC_MENUITEMS', 'OWNERCODE=' . singleQuote('USER') . ' AND UPPER(OWNERREF)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_AC_TABLES', 'OWNERCODE=' . singleQuote('USER') . ' AND UPPER(OWNERREF)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_AC_TREE_USERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_US_PREFERENCES', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords('CLX_AC_USER_FSECURE', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    /**
     * Returns tool blank row
     *
     * @param void
     * @return array
     */
    function defaultRecord() {
        $record = array();
        $record['ACUS_id'] = CLX_INIT_ZERO;
        $record['ACUS_username'] = '';
        $record['ACUS_password'] = '';
        $record['ACUS_confirm'] = '';
        //$record['LDAP_RDN_USERNAME'] = ''; // 2018-12-18 CR | Caso 1003704 - FICOHSA-Desar PDF Reader Oracle | al crear el usuario y hacer login por 1era vez, pone en blanco el campo LDAP_RDN_USERNAME
        $record['ACUS_ldap_rdn_username'] = '';
        $record['ACUS_firstname'] = '';
        $record['ACUS_lastname'] = '';
        $record['ACUS_company'] = kDefaultCompany;
        $record['ACUS_position'] = '';
        $record['ACUS_email'] = '';
        $record['ACUS_phone'] = '';
        $record['ACUS_fax'] = '';
        $record['ACUS_ext_ref_no'] = '';
        $record['ACUS_isadmin'] = CLX_INIT_ZERO;
        $record['ACUS_passexpire'] = CLX_INIT_ZERO;
        $record['ACUS_passreqchange'] = CLX_INIT_ZERO;
        $record['ACUS_passlstchange'] = '';
        $record['ACUS_status'] = CLX_NUM_ONE;
        $record['ACUS_audit'] = CLX_INIT_ZERO;
        $record['ACUS_login_attempts'] = CLX_INIT_ZERO;
        $record['ACUS_login_counter'] = CLX_INIT_ZERO;
        $record['ACUS_cdate'] = '';
        $record['ACUS_mdate'] = '';
        $record['ACUS_creatoruser'] = (!empty($_SESSION['user_record']['username'])) ? $_SESSION['user_record']['username'] : 'system';
        return $record;
    }

    /**
     * Place html code to select a user from list
     *
     * @param array $msg, string $prompt, string $name, string $default, object $table
     * @return string
     */
    function placeChooseUser($msg, $prompt, $name, $default, &$table) {
        $searchIcon = getSkinIcon('view', 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=ACUS&ac=SEARCH&target=' . $name) . ', 500, 300);', 'Search for a user');
        if (!empty($msg[$name]))
            $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $c = new htmlField($name, $default, CLX_NUM_32, CLX_NUM_32);
        $table->addCell($c->source() . $searchIcon, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return CLX_CHAR_EMPTY_STRING;
    }

    /**
     * Returns true if given user name exists
     *
     * @param string $username
     * @return boolean
     */
    function userExists(&$username) {
        if (empty($username)) {
            $qty = CLX_INIT_ZERO;
        } else {
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
            if ($qty > CLX_NUM_ZERO) {
                $username = ClxCommon::$db->getField($this->tablename, 'username', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
            }
        }
        return $qty > CLX_NUM_ZERO;
    }

    /**
     * Test if user session exists
     * return boolean
     */
    function sessionHasUserItem() {
        return (empty($_SESSION['hasUser'])) ? false : true;
    }

    /**
     * General CLX login receiver from CLX interface
     *
     * @param void
     * @return void
     */
    function ws_login($username, $password) {
		ClxFreeReturn($this->systemDaysLeft());
        if (!$this->sessionHasUserItem() && (empty($username) || empty($password))) {
            //Anonimous user
            $this->initSession();
        } elseif ((!empty($username) || !empty($password))) {			IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 2:('. $password.')  , 1:'. clx_mcript($password).'2:'.clx_mcript(md5($password)).chr(13).chr(10)); fclose($kk);}		

			//Trying to login
			$userhash = ClxCommon::$db->getField($this->tablename, 'PASSWORD', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1');
          //  echo clx_mcript_verify($password, $userhash);
			if (!empty($userhash) && clx_mcript_verify($password, $userhash) === true) {
				$password=$userhash;
			}
			else 
				$password = clx_mcript($password) ;
            //Adding system expiration parameter
 
			if ($this->systemExpired() <= CLX_NUM_ZERO) {			IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 3'.chr(13).chr(10)); fclose($kk);}		
                $this->set_login_msg(dict('GEN_ERR_SYSTEM_EXPIRED'));
                $this->initSession();
            } elseif (!$this->checkAttempts($username)) {						IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 4'.chr(13).chr(10)); fclose($kk);}		
                //if not more attempts
                $this->set_login_msg(dict('GEN_ERR_ACCOUNT_BLOCKED'));
                ClxFreeReturn($this->blockUser($username));
            } else {	IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 5 :  USERNAME:'.singleQuote(uppercase($username)). ' PASSWORD : '.singleQuote($password)	.chr(13).chr(10)); fclose($kk);}		
                if (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND PASSWORD=' . singleQuote($password) . ' AND STATUS=1') == CLX_NUM_ONE) {
                    // Acction to be taken on a successfull user login

                    $this->successfull_login($username);			IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 6'.chr(13).chr(10)); fclose($kk);}		
					$_SESSION['hasUser'] = CLX_NUM_ONE;
					
					
				} else {			IF (isset($GLOBALS['DEBUG_USER']) && $GLOBALS['DEBUG_USER']==1) {$kk=fopen('temp/saldebug2.txt','a+');fwrite($kk, chr(13).chr(10).'--> CASO 7'.chr(13).chr(10)); fclose($kk);}		
                    ClxFreeReturn($this->addAttemp($username));
                    $this->set_login_msg(dict('GEN_ERR_USERNAME_INVALID'));
                    if (kSessionLoginAttempts <> CLX_NUM_ZERO) {
                        $this->set_login_msg($this->get_login_msg() . '<br>' . dict('GEN_LBL_LOGIN_ATTEMPTS') . ' ');
                        $this->set_login_msg($this->get_login_msg() . $this->getAttempts($username) . ' / ' . kSessionLoginAttempts);
                    }
                }
            }
        }
    }

    /**
     * General CLX login receiver from CLX interface
     *
     * @param void
     * @return void
     */
    function login() {
		
        $contenidoHTML = '';
        ClxFreeReturn($this->systemDaysLeft());
        if (!empty($_SESSION['SETPASSWORD'])) {
            if (empty(UserRequest::$request[CLX_PROP_TO]) || UserRequest::$request[CLX_PROP_TO] <> 'USIF') {
				if($this->debug) {
					echo '<BR>[LOFF-010]';
	                salir(CLX_NUM_ZERO);
				}
                gotoLocation('logoff.php');
                echo $contenidoHTML;
                salir(CLX_NUM_ZERO);
            }
        }
        //user agent validation to prevent misleding
        if (!array_key_exists('HTTP_USER_AGENT', UserRequest::$server)) {
            UserRequest::$server['HTTP_USER_AGENT'] = 'unknown';
        }
        //Check User Agent
        $browser = getBrowser();
        $uak = clx_mcript($browser['name'] . $browser['version'] . $browser['platform'] . kPathToWebSite);
        /*
         * ACUS_UAK_VER_DISABLED System Parameter: To disable UAK Verification al Login time o pop-up opening.
         * UAK Verification stores the browser type and version and other info in session variable, but sometimes (i.e. working under EIBS menú environment),
         * the session terminates and a message 'Log off successful. Please visit us again soon!' appears when a magnifier glass is clicled.
         * To avoid this situation, set 1 to disable UAK verification. Set to 0 to normal operation.
         */
		if(!defined('ACUS_UAK_VER_DISABLED')) {
			define('ACUS_UAK_VER_DISABLED', CLX_CHAR_EMPTY_STRING);
		}
        $uak_verification = (!empty(ACUS_UAK_VER_DISABLED)) ? true : false;
        if ($uak_verification === true) {
            if (!empty($_SESSION['uak_rq']) && !clx_mcript_verify($_SESSION['uak_rq'], $uak)) {
                /* Prompt for password */
				if($this->debug) {
					echo '<BR>[LOFF-020] - [ACUS_UAK_VER_DISABLED-' . ACUS_UAK_VER_DISABLED . ']';
	                salir(CLX_NUM_ZERO);
				}
                gotoLocation('logoff.php');
                echo $contenidoHTML;
                salir(CLX_NUM_ZERO);
            } else {
                $_SESSION['uak_rq'] = $uak;
            }
        }
        if (!defined('ACUS_LOGIN_MODE')) {
            define('ACUS_LOGIN_MODE', 'CLX');
        }
        if (!defined('ACUS_LOGIN_ERROR_MODE')) {
            define('ACUS_LOGIN_ERROR_MODE', CLX_NUM_ZERO);
        }
        if (!defined('ACUS_LOGIN_ATTEMPS')) {
            define('ACUS_LOGIN_ATTEMPS', CLX_NUM_ZERO);
        }
        //Get user from ibs menu if mode enabled
        if (ACUS_LOGIN_MODE === 'IBS' && !empty(UserRequest::$request['ibslog']) && !empty(UserRequest::$request['USER'])) {
            //Ibs login may be set into 2 modes.
            UserRequest::$post['username'] = UserRequest::$request['USER'];
            UserRequest::$post['password'] = UserRequest::$request['JKEY'];
        }
        //check if login attemp
        if (!$this->sessionHasUserItem() && !array_key_exists('username', UserRequest::$post) && !array_key_exists('password', UserRequest::$post)) {
            //Anonimous user
            $this->initSession();
            //Siteminder Auth No Login required
            $is_sideminder = (array_key_exists('HTTP_SMUSER', UserRequest::$server) && !empty(UserRequest::$server['HTTP_SMUSER'])) ? true : false;
            if ($is_sideminder === true) {
                /* SITEMINDER AUTH */
                /* UserRequest::$server['HTTP_SMUSER'] => asdcasd   UserRequest::$server['HTTP_SMUSERDN'] => uid=asdcasd,cn=People,ou=Internal,o=mfc   [HTTP_SMSERVERSESSIONID] => U55dCwj3BRa0sXzgT22tFmH6g5I= */
                $siteminder = (strpos(lowercase(UserRequest::$server['HTTP_SMUSERDN']), lowercase('=' . UserRequest::$server['HTTP_SMUSER'] . ',')) === false) ? false : true; //tst ldap info and user info
                $username = UserRequest::$server['HTTP_SMUSER'];
                if ($siteminder && ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1') === CLX_NUM_ONE) {
                    // Acction to be taken on a successfull user login
                    $this->successfull_login($username);
                    //Password change set by siteminder
                } else {
                    if (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS<>1') <> CLX_NUM_ZERO) {//report blocked user
                        $msg = dict('GEN_ERR_BLOCK_SITEMINDER');
                        $this->logout();
                        header('HTTP/1.0 401 ' . $msg);
                        $contenidoHTML.= '<h1>' . $msg . '</h1>';
                    } else {
                        $msg = dict('GEN_ERR_NOACC_SITEMINDER');
                        $this->logout();
                        header('HTTP/1.0 401 ' . $msg);
                        $contenidoHTML.= '<h1>' . $msg . '</h1>';
                    }
                    echo $contenidoHTML;
                    salir(CLX_NUM_ZERO);
                }
            }
        } elseif (array_key_exists('username', UserRequest::$post) && array_key_exists('password', UserRequest::$post)) {
            $username = UserRequest::$post['username'];
            ClxCommon::$db->addslashes($username);
            if ($this->hasOpenSession($username)) {
                $this->set_login_msg(dict('GEN_ERR_ALREADY_LOGED_IN'));
                return;
            }
            //Trying to login
            $this->initSession();
			getcompanydefault($username);
			
			//}
            //Lock all expired users
            $this->autoLockUser();
            //Adding system expiration parameter
            if ($this->systemExpired() <= CLX_NUM_ZERO) {
                $this->set_login_msg(dict('GEN_ERR_SYSTEM_EXPIRED'));
                $this->initSession();
            } elseif ($this->userIsLocked($username)) {
                $this->set_login_msg(dict('GEN_ERR_ACCOUNT_BLOCKED'));
                ClxFreeReturn($this->blockUser($username));
            } elseif (!$this->checkAttempts($username)) {
                //if not more attempts
                $this->set_login_msg(dict('GEN_ERR_ACCOUNT_BLOCKED'));
                ClxFreeReturn($this->blockUser($username));
            } else {
                //Check if Administrator privileges
                $interface_exclusion_group = false;
                if (ACUS_LOGIN_MODE === 'IBS') {
                    $EBSK = &getTool('EBSK');
                    $superuser = ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1 AND ISADMIN = 1');
                    if ($superuser === CLX_NUM_ZERO) {//check is not a superuser already
                        // Verify special interface exclusions group parameter
                        if (EBSK_EIBS_EXCL_GRP <> '0') {
                            // If the special interface exclusions group parameters is specified, verify if the user belongs to any of the groups on the parameter (separated by comma)
                            if (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . '  AND GROUPCODE IN (' . singleQuote(str_replace(',', singleQuote(','), EBSK_EIBS_EXCL_GRP)) . ')') > CLX_NUM_ZERO) {
                                $interface_exclusion_group = true;
                            }
                        }
                    }
                } elseif (ACUS_LOGIN_MODE === 'LDAP') {//same as ibs
                    $superuser = ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1 AND ISADMIN = 1');
                    if (empty($superuser)) {//check is not a superuser already
                        // Verify special interface exclusions group parameter
                        if (!defined('ACUS_LDAP_EXCL_GRP'))
                            define('ACUS_LDAP_EXCL_GRP', '0'); //changing constant
                        if (ACUS_LDAP_EXCL_GRP <> '0') {
                            // If the special interface exclusions group parameters is specified, verify if the user belongs to any of the groups on the parameter (separated by comma)
                            if (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . '  AND GROUPCODE IN (' . singleQuote(str_replace(',', '' . singleQuote(CLX_CHAR_EMPTY_STRING) . '', ACUS_LDAP_EXCL_GRP)) . ')') > CLX_NUM_ZERO) {
                                $interface_exclusion_group = true;
                            }
                        }
                    }
                } else {
                    $superuser = false;
                    $interface_exclusion_group = false;
                }
                //check if superuser or is in exclusion group it are can login if no interface.
                //Note: Exclusion exclusion groups allow users that are not recognized in ibs to access administrative
               //tasks on clx
                if (ACUS_LOGIN_MODE === 'IBS' && !$superuser && !$interface_exclusion_group) { //ibs authentication
                    $menu_mode = (!empty(UserRequest::$request['ibslog'])) ? true : false;
                    if ($this->login_ibs(UserRequest::$post['username'], UserRequest::$post['password'], $menu_mode)) {
                        // Acction to be taken on a successfull user login
                        $this->successfull_login($username);
                    }
                    //see sitminder login on top of this if
                } elseif (ACUS_LOGIN_MODE === 'LDAP' && !$superuser && !$interface_exclusion_group) {
                    if ($this->login_ldap(UserRequest::$post['username'], UserRequest::$post['password'])) {
                        // Acction to be taken on a successfull user login
                        $this->successfull_login($username);
                    }
                } else {//default clx login
                    $userhash = ClxCommon::$db->getField($this->tablename, 'PASSWORD', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1');
					if (!empty($userhash) && clx_mcript_verify(UserRequest::$post['password'], $userhash) === true) {
                        // Acction to be taken on a successfull user login
                        $this->successfull_login($username);
                        //Check if expiration date reached or redirect to change password
                        $this->setChangePassword($username);
                        //Check if change password required
                        if ($this->checkChangePassword($username)) {
                            $_SESSION['SETPASSWORD'] = CLX_NUM_ONE;
                            header('location: pop.php?to=USIF&ac=PASSWORD&login=1');
                            salir(CLX_NUM_ZERO);
                        }
                        //Notify about changing password
                        $this->alertChangePassword();
                    } else {
                        ClxFreeReturn($this->addAttemp($username));
                        $this->set_login_msg(dict('GEN_ERR_USERNAME_INVALID'));
                        if (ACUS_LOGIN_ATTEMPS <> CLX_NUM_ZERO) {
                            if (ACUS_LOGIN_ERROR_MODE == CLX_NUM_ZERO) {
                                $this->set_login_msg($this->get_login_msg() . '<br>' . dict('GEN_LBL_LOGIN_ATTEMPTS') . ' ');
                                $this->set_login_msg($this->get_login_msg() . $this->getAttempts($username) . ' / ' . kSessionLoginAttempts);
                            }
                        }
                    }
                }
            }
        }
		else {
			getcompanydefault( $_SESSION['user_record']['username']);	
		}
    }

    /**
     * Acction to be taken on a successfull user login
     *
     * @param string $username
     * @return void
     */
    function successfull_login($username) {
        ClxFreeReturn($this->clearAttempts($username));
        $sql = 'SELECT ID, FIRSTNAME, LASTNAME, USERNAME, ISADMIN, STATUS, EMAIL, COMPANY, POSITION, CREATORUSER, AUDITU, LOGIN_ATTEMPTS, PASSEXPIRE, PASSREQCHANGE, PASSLSTCHANGE, LOGIN_COUNTER, PHONE, FAX, LAST_SESSION_IP, LAST_SESSION_DATE, EXT_REF_NO FROM ' . $this->tablename . ' WHERE UPPER( USERNAME)=' . singleQuote(uppercase($username));
        $userrecord = ClxCommon::$db->getOneRecord($sql);
        $_SESSION['user_record'] = array_change_key_case($userrecord, CASE_LOWER);
        $_SESSION['hasUser'] = CLX_NUM_ONE;
        //Increasing login counter if defined
        if (defined('ACUS_PWD_EXP_LOGINS') && ACUS_PWD_EXP_LOGINS > CLX_NUM_ZERO) {
            $userrecord['LOGIN_COUNTER'] = $userrecord['LOGIN_COUNTER'] + CLX_NUM_ONE;
            ClxCommon::$db->updateRecord($this->tablename, array('LOGIN_COUNTER' => $userrecord['LOGIN_COUNTER']), 'ID = ' . $userrecord['ID']);
        }
        //Mark true for authenticated
        $this->authenticated = true;
        //Setting acus last login information
        if (ClxCommon::$db->fieldExists($this->tablename, 'LAST_SESSION_IP') && ClxCommon::$db->fieldExists($this->tablename, 'LAST_SESSION_DATE')) {
			ClxCommon::$db->updateRecord($this->tablename, array('LAST_SESSION_IP' => (isset($_SESSION['ip']) ? $_SESSION['ip'] :'127.0.0.1') , 'LAST_SESSION_DATE' => xFormat::getNow('Y-m-d H:i:s')), 'UPPER(USERNAME) = ' . singleQuote(uppercase($username)));
		}
        //Updating lan preferences from login form
        $USPR = &getTool('USPR');
		if (!isset($_SESSION ['prefs'])) {
			$_SESSION['prefs']=array();
		}  
		if (!isset($_SESSION ['prefs'] ['LANGUAGE'])) {
			$_SESSION ['prefs'] =array('LANGUAGE' => getCurrentLanguage());
		}	
        $USPR->prfSavePref($username, 'LANGUAGE', clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']));
        //Loading user pref
        $USPR->loadPreferences();
        $UIFT = &getTool('UIFT');
        $UIFT->loadFilterPreferences();
        $ACAD = &getTool('ACAD');
        $ACAD->log('', '0', 'LOGIN', $username, $userrecord);
        //Adding field security
        $ACFS = &getTool('ACFS');
        if (!empty($ACFS)) {
            $ACFS->set_session_field_security();
        }
        // Caso 1003680 - SAAS-Sistema Control de Clientes | BEGIN
        if (!defined('ACUS_LIC_ACT')) {
            define('ACUS_LIC_ACT', '-1');
        }
        if (!defined('ACUS_LIC_ACT_DAYS')) {
            define('ACUS_LIC_ACT_DAYS', '7');
        }
        if (ACUS_LIC_ACT !== '-1') {
            $superuser = ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND STATUS=1 AND ISADMIN=1');
            $system_days_to_expire = day_diff(ACUS_LIC_ACT, $this->current_date);
            if ($system_days_to_expire <= CLX_NUM_ZERO) {
                /* Dict GEN_ERR_LIC_ACT_010 = Access denied due to inactive Service. Please call Technical Support / Acceso denegado debido a Servicio inactivo. Por favor llame al Soporte Técnico */
                $contenidoHTML=dict('GEN_ERR_LIC_ACT_010') . ' [SAAS-E010] ' . $system_days_to_expire;
                if ($superuser === CLX_NUM_ZERO) {
                    $this->logout();
                    $this->set_login_msg($contenidoHTML);
                } else {
                    addMessage($contenidoHTML);
                }
            } else {
                if ($system_days_to_expire <= ACUS_LIC_ACT_DAYS) {
                    /* GEN_ERR_SYSTEM_DAYS_LEFT = System will expire in ^1 days | El sistema expira en ^1 días */
                    addMessage(dict('GEN_ERR_SYSTEM_DAYS_LEFT', $system_days_to_expire) . ' [SAAS-E020]');
                }
            }
        }
        // Caso 1003680 - SAAS-Sistema Control de Clientes | END
    }

    /**
     * Initialize session for process engine
     * @param string $username
     */
    function process_engine_login($username) {
        $this->successfull_login($username);
        $_SESSION['paging'] = array();
    }

    /**
     * Initialize session for db import by list
     * @param string $username
     */
    function process_list_import_login($username) {
        //Lock all expired users
        $this->autoLockUser();
        if (!$this->userExists($username)) {
            $this->set_login_msg(dict('GEN_ERR_USERNAME_INVALID'));
        } elseif ($this->systemExpired() <= CLX_NUM_ZERO) {
            //Adding system expiration parameter
            $this->set_login_msg(dict('GEN_ERR_SYSTEM_EXPIRED'));
            $this->initSession();
        } elseif ($this->userIsLocked($username)) {
            $this->set_login_msg(dict('GEN_ERR_ACCOUNT_BLOCKED'));
            ClxFreeReturn($this->blockUser($username));
        } elseif (!$this->checkAttempts($username)) {
            //if not more attempts
            $this->set_login_msg(dict('GEN_ERR_ACCOUNT_BLOCKED'));
            ClxFreeReturn($this->blockUser($username));
        } else {
            //Trying to login
            $this->initSession();
            $this->successfull_login($username);
            $_SESSION['paging'] = array();
            return true;
        }
        return false;
    }

    /**
     * Returns true if user requires password change
     *
     * @param string $username
     * @return boolean
     */
    function checkChangePassword($username) {
        $status = false;
        if (defined('ACUS_PWD_EXP_LOGINS') && ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(USERNAME) = ' . singleQuote(uppercase($username)) . ' AND PASSREQCHANGE=1') <> CLX_NUM_ZERO) {
            $status = true;
        }
        return $status;
    }

    /**
     * Sets login message
     * @param type $msg
     */
    function set_login_msg($msg) {
        $this->login_msg = $msg;
    }

    /**
     * Gets login message
     * @return type
     */
    function get_login_msg() {
        return $this->login_msg;
    }

    function alertChangePassword() {
        //Adding notification aler for posible password expiration
        if (defined('ACUS_PWD_EXP_DAYS') && ACUS_PWD_EXP_DAYS > CLX_NUM_ZERO) {
            //Days for notification
            if (!defined('ACUS_PWD_EXP_DAYS_NOTICE')) {
                define('ACUS_PWD_EXP_DAYS_NOTICE', CLX_NUM_FIVE);
            }
            $d = xFormat::getNow('Y-m-d G:i:s');
            $ld = $_SESSION['user_record']['passlstchange'];
            $dif = ACUS_PWD_EXP_DAYS - day_diff($d, $ld);
            if ($dif > CLX_NUM_ZERO && $dif < ACUS_PWD_EXP_DAYS && $dif <= ACUS_PWD_EXP_DAYS_NOTICE) {
                $url = 'tool.php?to=USIF&ac=PASSWORD';
                $link = new htmlAnchor(dict('GEN_PWD_EXP_CLICK_HERE'), $url);
                $change_pass_msg = dict('ACUS_PWD_EXP_DAYS_SOON', $dif) . '<br>';
                $change_pass_msg .= $link->source();
                addMessage($change_pass_msg);
            }
        }
    }

    /**
     * Evaluates diferent user parameters to set password change required
     *
     * @param string $username
     */
    function setChangePassword($username) {
        if (defined('ACUS_PWD_EXP_LOGINS') && ACUS_PWD_EXP_LOGINS > CLX_NUM_ZERO) {
            $sql = 'UPDATE ' . $this->tablename . ' SET PASSREQCHANGE=1 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username)) . ' AND LOGIN_COUNTER>=' . ACUS_PWD_EXP_LOGINS;
            ClxCommon::$db->executeQuery($sql);
        }
        /*
          Defines number of days for password to expire. Set 0 for no limit ACUS_PWD_EXP_DAYS */
        if (defined('ACUS_PWD_EXP_DAYS') && ACUS_PWD_EXP_DAYS > CLX_NUM_ZERO) {
            if (kDatabaseType === 'oci') {
                $sql = 'UPDATE ' . $this->tablename . ' SET PASSREQCHANGE=1 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username)) . ' AND PASSEXPIRE=1 AND TO_CHAR((CURRENT_DATE-PASSLSTCHANGE), ' . singleQuote('DD') . ')>=' . singleQuote(ACUS_PWD_EXP_DAYS) . ' OR PASSLSTCHANGE IS NULL)';
            } else {
                $sql = 'UPDATE ' . $this->tablename . ' SET PASSREQCHANGE=1 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username)) . ' AND PASSEXPIRE=1 AND (DATEDIFF(NOW(),PASSLSTCHANGE)>=' . ACUS_PWD_EXP_DAYS . ' OR PASSLSTCHANGE IS NULL)';
            }
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Performs username Login on IBS
     * @param string $username
     * @param string $password_or_key
     * @param bool $menu_mode = 0
     */
    function login_ibs($username, $password_or_key, $menu_mode = false) {
        $err = '';
        $record = array();
        //Search User information on socket
        $EBSK = &getTool('EBSK');
        if (!empty($this->debug))
            $EBSK->debug = true;
        // To get field sizes from EBSK mapping...
        //$mappings_by_fieldname = $EBSK->get_mappings_by_fieldname(EBSK_IBS_DEF_USER_MSG);
        // Adjust field to mapping field size
        //$record['PASSWORD'] = substr(uppercase($password_or_key), 0, $mappings_by_fieldname['E01PSW']['FIELD_LENGTH']);	//  PARA BNP...
        if ($menu_mode === true) {
            //username and session on ibs
            $record['USERNAME'] = uppercase($username);
            $record['JSID'] = uppercase($password_or_key);
            $record['H01WK2'] = (defined('ACUS_IBS_WK2_MENU_MODE') ? ACUS_IBS_WK2_MENU_MODE : '2');
            //$record['H01WK2'] = '2';
        } else {
            //Regular login username amd password on ibs
            $record['USERNAME'] = uppercase($username);
            $record['PASSWORD'] = uppercase($password_or_key);
            //   - after testing in BNP, we conclude to use mode 2 intead of mode 1 to make it work
            $record['H01WK2'] = (defined('ACUS_IBS_WK2_NO_MENU_MODE') ? ACUS_IBS_WK2_NO_MENU_MODE : '');
            //$record['H01WK2'] = '1';
        }
        if ($record['H01WK2'] === 'null')
            $record['H01WK2'] = '';
        if (!empty($this->debug)) {
            echoLog('LOGIN_IBS<br>rec-USERNAME = ' . $record['USERNAME'] . '<br>rec-PASSWORD = ' . $record['PASSWORD'] . '<br>rec-JSID = ' . $record['JSID'] . '<br>H01WK2 = ' . $record['H01WK2'] . '<br>');
        }
        //Send request to ibs
        $ibsuser_data = $EBSK->sendMessage(EBSK_IBS_DEF_USER_MSG, $record, 'SELECT');

        //Check for response errors
        if (!empty($this->debug)) {
            echoLog('<br>' . debug_dump('ibsuser_data', $ibsuser_data) . '<br>');
        }
        if (empty($ibsuser_data)) {
            if (!empty($this->debug))
                echoLog('-No data recieved from socket<br>');
            $err = dict('IBS_ERR_NODATAFROMSOCKET');
            $this->set_login_msg($err);
            return false;
        }else {
            $err = '';
            if (!empty($ibsuser_data[CLX_NUM_ZERO]['HEADERMSG']['ERRNUM'])) {
                $err = $EBSK->string_error_ibs_message($ibsuser_data);
                if ($err !== '' || ($ibsuser_data[CLX_NUM_ZERO]['HEADERMSG']['ERRNUM'] !== '' && $ibsuser_data[CLX_NUM_ZERO]['HEADERMSG']['ERRNUM'] !== 'ELEERR')) {
                    $err = dict('IBS_ERR_MSGERROR') . $err . ' [' . $ibsuser_data[CLX_NUM_ZERO]['HEADERMSG']['ERRNUM'] . ']';
                    if (!empty($this->debug))
                        echoLog($err);
                    $this->set_login_msg($err);
                    return false;
                }
                if (!empty($ibsuser_data[CLX_NUM_ZERO]['HEADERMSG']['ERDS01'])) {
                    $err = dict('IBS_ERR_MSGERROR') . ': ' . dict('GEN_LBL_SOCK_READ_FAIL', '');
                    $this->set_login_msg($err);
                    return false;
                }
            }
        }
        //Check user existance
        $storepost = UserRequest::$post;
        UserRequest::$post = array();
        //Get user if exists
        $recordid = ClxCommon::$db->getField($this->tablename, 'ID', 'UPPER(USERNAME) = ' . singleQuote(uppercase($record['USERNAME'])));
        if (!empty($recordid)) {
            if (!empty($this->debug))
                echoLog('-Updating user record: ' . $record['USERNAME'] . '<br>');
            //Update User information where Apply
            UserRequest::$post = $this->loadToolRecord($recordid);
            UserRequest::$post['ACUS_password'] = clx_mcript($password_or_key);
            UserRequest::$post['ACUS_confirm'] = UserRequest::$post['ACUS_password'];
            UserRequest::$post = $this->ibsUser(UserRequest::$post, $ibsuser_data);
            $this->saveRecord();
        }else {
            if (!empty($this->debug))
                echoLog('-Creating user record: ' . $record['USERNAME'] . '<br>');
            //Create new User and prepare login
            UserRequest::$post = $this->defaultRecord();
            UserRequest::$post['ACUS_password'] = clx_mcript($password_or_key);
            UserRequest::$post['ACUS_confirm'] = UserRequest::$post['ACUS_password'];
            $_SESSION['user_record']['isadmin'] = CLX_INIT_ZERO;
            UserRequest::$post = $this->ibsUser(UserRequest::$post, $ibsuser_data);
            $this->createRecord_();
        }
        $this->ibsUserGroup($ibsuser_data);
        UserRequest::$post = $storepost;
        return true;
    }

    /**
     * Performs username Login on LDAP Server
     * @param string $username
     * @param string $password_or_key
     * @param bool $menu_mode = 0
     */
    function login_ldap($username, $password) {
        require_once kPathToWebSite . 'classes/clx_ldap.php';
        $this->ldap_defvals();
        //   Caso 1002687 - MUN-LDAP login userid alterno
        // Saves original username
        $original_username = $username;
        //Search User information on socket
        if (!empty($this->debug))
            echoLog('Ldap Login');
        if (empty($username) || empty($password)) {
            $this->set_login_msg('1 ' . dict('GEN_ERR_EMPTY_FIELDS')); //Mensaje de password invalido
            return false;
        }
        //First validate that user exists
        $acus_record = ClxCommon::$db->getRecord($this->tablename, 'UPPER(USERNAME) = ' . singleQuote(uppercase($original_username)));
        if (empty($acus_record)) {
            $this->set_login_msg('2 ' . dict('GEN_ERR_USERNOTINLOCAL'));
            return false;
        }
        $ldap = new clx_ldap(ACUS_LDAP_HOST, ACUS_LDAP_PORT, ACUS_LDAP_BASE_DN);
        $ldap->debug = $this->debug; //   Caso 1002687 - MUN-LDAP login userid alterno
        if ($ldap->haserror()) {//conection fail just stop
            $this->set_login_msg('3 ' . dict($ldap->geterrorlabel())) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E010-CONN]';
            return false;
        }
        if (ACUS_LDAP_DIRECTORY_TYPE == CLX_NUM_ONE)
            $ldap->set_active_directory(true);
        if (ACUS_LDAP_DIRECTORY_TYPE == CLX_NUM_THREE)
            $ldap->set_extended_open_ldap(true);
        $ldap->connectandbind($username, $password);
		$err_detail = '';
        if ($ldap->haserror()) {
            //   Caso 1002687 - MUN-LDAP login userid alterno
            // If 1st attempt failes, uses alternative LDAP login method
            // Just in case LDAP is configured to use 'sAMAccountName' instead 'CN' to directory login
            // uses 'full name' instead 'userid'
            if (ACUS_LDAP_EXTRA_SRCH == CLX_NUM_ONE) {
				$err_detail = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E020-B-AUTH] ' . '<br>CLX-USR: ' . $username . ' | Try 1<br>';
			} else {
				$err_detail = dict($ldap->geterrorlabel()) . ' | [LDAP-E020-A-AUTH]<br>';
			}
            $username = null;
            if (isset($acus_record['LDAP_RDN_USERNAME'])) {
                if (!empty($acus_record['LDAP_RDN_USERNAME']) && !is_null($acus_record['LDAP_RDN_USERNAME'])) {
                    // if column LDAP_RDN_USERNAME salirs and it isn\'t null or blank, uses it
                    $username = trim($acus_record['LDAP_RDN_USERNAME']);
                }
            }
            if (is_null($username)) {
                // If not, try with first and last names
                $acus_record['LASTNAME'] = ($acus_record['LASTNAME'] === 'null' ? '' : $acus_record['LASTNAME']); // taking account no lastname cases
                $username = trim($acus_record['FIRSTNAME'] . ' ' . $acus_record['LASTNAME']);
            }
            // Try alternate login method
            $ldap->seterror(false);
            $ldap->connectandbind($username, $password);
        }
        //Check for response errors
        if ($ldap->haserror()) {//authentication error
            //   Caso 1002687 - MUN-LDAP login userid alterno
            if (ACUS_LDAP_EXTRA_SRCH == CLX_NUM_ONE) {
				$err_detail .= dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E025-B-AUTH] ' . '<br>CLX-USR: ' . $username . ' | Try 2';
			} else {
				$err_detail = dict($ldap->geterrorlabel()) . ' | [LDAP-E025-A-AUTH]<br>';
			}
            $this->set_login_msg('4 ' . $err_detail);
            return false;
        }
        return true;
    }

    /**
     * Logging out from system. Destroy session
     *
     * @param void
     * @return void
     */
    function logout() {
        if (kApcEnabled) {
            $UIMI = &getTool('UIMI');
            $UIMI->clearUserHeap();
        }
        if ($this->sessionHasUserItem()) {
            $username = $_SESSION['user_record']['username'];
            $ACAD = &getTool('ACAD');
            $ACAD->log('', '0', 'LOGOUT', $username, '');
        }
		if (isset($_SESSION))
			@session_destroy();
        $this->initSession();
        ClxCommon::$db->commit();
    }

    /**
     * Session Initializer
     *
     * @param void
     * @return void
     */
    function initSession() {
        $this->authenticated = false;
        $_SESSION = array();
        $_SESSION[CLX_PROP_ID] = session_id();
        $_SESSION['dbn'] = kDatabaseNo;
        $_SESSION['ip'] = ( isset(UserRequest::$server['REMOTE_ADDR']) ? UserRequest::$server['REMOTE_ADDR'] : '' );
        $_SESSION['hasUser'] = CLX_NUM_ZERO;
        $_SESSION['skin'] = CurrentSkin();
        $_SESSION['prefs']['LANGUAGE'] = getCurrentLanguage(); //getCurrentLanguage();
        $_SESSION['history'] = array();
        $_SESSION['user_record'] = array();
        $_SESSION['login_key'] = $this->loginKey(CLX_NUM_SIX);
        $_SESSION['client']['browser'] = CLX_CUR_BROWSER; // msie || gecko || khtml
        $_SESSION['client']['system'] = CLX_CUR_SYSTEM; // windows ||  linux || mac
        // CLX local user autheticated
        if ($this->eibs_mode) {
            $this->eibs_utilities->set_eibs_auth_user('');  // e_IBS autheticated user
        }
    }

    /**
     * Verifies user attempts status
     *
     * @param string $username
     * @return bool $status
     */
    function checkAttempts($username) {
        $status = (bool) true;
        if (kSessionLoginAttempts <> CLX_NUM_ZERO) {
            if ($this->getAttempts($username) >= kSessionLoginAttempts) {
                $status = false;
            }
        }
        return $status;
    }

    /**
     * Return the number of attempts
     *
     * @param string $username
     * @param int $attempts
     */
    function getAttempts($username) {
        $attempts = ClxCommon::$db->getField($this->tablename, 'LOGIN_ATTEMPTS', 'UPPER(USERNAME) = ' . singleQuote(uppercase($username)));
        if (empty($attempts))
            $attempts = CLX_INIT_ZERO;
        $attempts = CLX_INIT_ZERO;
        return $attempts;
    }

    /**
     * Increases the attemp counter by one
     * @param string $username
     * @return bool $update_result
     */
    function addAttemp($username) {
        $sql = 'UPDATE ' . $this->tablename . ' SET LOGIN_ATTEMPTS = LOGIN_ATTEMPTS+1 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username));
        $sql = 'UPDATE ' . $this->tablename . ' SET LOGIN_ATTEMPTS = 0 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username));
        return ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Initialize login attempts counter
     *
     * @param unknown_type $username
     * @return bool $update_result
     */
    function clearAttempts($username) {
        $sql = 'UPDATE ' . $this->tablename . ' SET LOGIN_ATTEMPTS = 0, STATUS = 1 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username));
        return ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Block user after any number of attempts
     *
     * @param string $username
     * @return bool $update_result
     */
    function blockUser($username) {
        $sql = 'UPDATE ' . $this->tablename . ' SET STATUS = 2 WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username));
        $r = ClxCommon::$db->executeQuery($sql);
        //Remove session
        $sql = 'DELETE FROM CLX_AC_USER_SESSIONS WHERE USERNAME IN (SELECT X.USERNAME FROM CLX_AC_USERS X WHERE UPPER(X.USERNAME) = ' . singleQuote(uppercase($username)) . ' AND X.STATUS = 2)';
        ClxCommon::$db->executeQuery($sql);
        return $r;
    }

    /**
     * Check is user its currently blocked
     *
     * @param string $username
     * @return bool $update_result
     */
    function userIsLocked($username) {
        return (ClxCommon::$db->oneExistsRecords($this->tablename, 'STATUS = 2 AND UPPER(USERNAME) = ' . singleQuote(uppercase($username))) > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Check is user its currently blocked
     *
     * @param string $username
     * @return bool $update_result
     */
    function userIsActive($username) {
        return (ClxCommon::$db->oneExistsRecords($this->tablename, 'STATUS = 1 AND UPPER(USERNAME) = ' . singleQuote(uppercase($username))) > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Lock action
     * @param string $ac, array $idlist
     * @return void
     */
    function lockAction($ac, $idlist) {
        foreach ($idlist as $key => $val) {
            $username = ClxCommon::$db->getField($this->tablename, 'USERNAME', 'ID=' . $val);
            switch ($ac) {
                case 'LOCK':
                    ClxFreeReturn($this->blockUser($username));
                    break;
                case 'UNLOCK':
                    ClxFreeReturn($this->clearAttempts($username));
                    break;
                default :
                    break;
            }
        }
    }

    /**
     * Returns a user login key
     *
     * @param int $lengh=6
     * @return string $key
     */
    function loginKey($length) {
        $key = '';
        $p_chars = 'AGHACEFHJKRSTVXY124579'; // can be any set of characters
        while (strlen($key) < $length) {
            $key.=substr($p_chars, (rand() % (strlen($p_chars))), CLX_NUM_ONE);
        }
        return $key;
    }

    /**
     * System expiration time
     * @param void
     * @return int
     */
    function systemDaysLeft() {
        $sys_exp_date = (defined('kSystemExpireDate')) ? kSystemExpireDate : '-1';
        if ($sys_exp_date <> '-1') {
            $system_days_to_expire = day_diff($this->current_date, $sys_exp_date) + CLX_NUM_ONE;
            if ($system_days_to_expire > CLX_NUM_ZERO) {
                $this->set_login_msg(dict('GEN_ERR_SYSTEM_DAYS_LEFT', $system_days_to_expire));
            } else {
                $this->set_login_msg(dict('GEN_ERR_SYSTEM_EXPIRED'));
            }
        } else {
            $system_days_to_expire = CLX_NUM_THOUSAND; //really no end date
        }
        return $system_days_to_expire;
    }

    /**
     * Test if current system has expired
     *
     * @return boolean
     */
    function systemExpired() {
        $days_left = $this->systemDaysLeft();
        return ($days_left > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Locks user
     */
    private function autoLockUser() {
        if (defined('ACUS_PWD_EXP_AUTO_LOCK') && defined('ACUS_PWD_EXP_DAYS') && ACUS_PWD_EXP_DAYS > CLX_NUM_ZERO && ACUS_PWD_EXP_AUTO_LOCK == CLX_NUM_ONE) {
            $sql = 'UPDATE CLX_AC_USERS SET PASSLSTCHANGE = MDATE WHERE PASSLSTCHANGE = NULL';
            ClxCommon::$db->executeQuery($sql);
            //bloking users
            //see also $this->blockUser($username);
            if (kDatabaseType === 'oci') {
                $sql = 'UPDATE ' . $this->tablename . ' SET STATUS = 2 WHERE ISADMIN <> 1 AND TO_CHAR((CURRENT_DATE-PASSLSTCHANGE), ' . singleQuote('DD') . ') >=' . singleQuote(ACUS_PWD_EXP_DAYS);
            } else {
                $sql = 'UPDATE ' . $this->tablename . ' SET STATUS = 2 WHERE ISADMIN <> 1 AND DATEDIFF(NOW(),PASSLSTCHANGE) >=' . singleQuote(ACUS_PWD_EXP_DAYS);
            }
            ClxCommon::$db->executeQuery($sql);
        }
        //Block users that no has login on certain amount of days
        if (defined('ACUS_DAYS_NOLOGIN_LOCK') && ACUS_DAYS_NOLOGIN_LOCK > CLX_NUM_ZERO) {
            $sql = 'UPDATE CLX_AC_USERS SET LAST_SESSION_DATE = MDATE WHERE LAST_SESSION_DATE = NULL';
            ClxCommon::$db->executeQuery($sql);
            //bloking users
            //see also $this->blockUser($username);
            if (kDatabaseType === 'oci') {
                $sql = 'UPDATE ' . $this->tablename . ' SET STATUS = 2 WHERE ISADMIN <> 1 AND TO_CHAR((CURRENT_DATE-LAST_SESSION_DATE), ' . singleQuote('DD') . ') >=' . singleQuote(ACUS_DAYS_NOLOGIN_LOCK);
            } else {
                $sql = 'UPDATE ' . $this->tablename . ' SET STATUS = 2 WHERE ISADMIN <> 1 AND DATEDIFF(NOW(),LAST_SESSION_DATE) >=' . singleQuote(ACUS_DAYS_NOLOGIN_LOCK);
            }
            ClxCommon::$db->executeQuery($sql);
        }
        //drop session on lowg users where account has been blocked
        //Delete all actives session where user its blocked
        $sql = 'DELETE FROM CLX_AC_USER_SESSIONS WHERE USERNAME IN (SELECT X.USERNAME FROM CLX_AC_USERS X WHERE X.STATUS = 2)';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds IBS User
     *
     * @param array $record, array $ibsuser_data
     * @return array
     */
    function ibsUser($record, $ibsuser_data) {
        $record['ACUS_username'] = $ibsuser_data[CLX_NUM_ZERO]['USERNAME'];
        //   - Firtsname and lastname in BNP are separated by comma

        if (strpos($ibsuser_data[CLX_NUM_ZERO]['FULLNAME'], ',') === false) {
            $ibsuser_data[CLX_NUM_ZERO]['FULLNAME'] = trim(preg_replace('!\s+!', ' ', $ibsuser_data[CLX_NUM_ZERO]['FULLNAME']));
            $sep = ' '; // Separated by space. FULLNAME comes with "FIRSTNAME space LASTNAME"
            $NameSeparated = explode($sep, $ibsuser_data[CLX_NUM_ZERO]['FULLNAME']);
            switch (count($NameSeparated)) {
                case 1:
                    $record["ACUS_firstname"] = trim($NameSeparated[CLX_NUM_ZERO]);
                    $record["ACUS_lastname"] = 'NA';
                    break;
                case 2:
                    $record["ACUS_firstname"] = trim($NameSeparated[CLX_NUM_ZERO]);
                    $record["ACUS_lastname"] = trim($NameSeparated[CLX_NUM_ONE]);
                    break;
                case 3:
                    // More than two elements, could be "FIRSTNAME MIDDLE LASTNAME1 [LASTNAME2]"
                    $record["ACUS_firstname"] = trim($NameSeparated[CLX_NUM_ZERO]);
                    $record["ACUS_lastname"] = trim($NameSeparated[CLX_NUM_ONE] . ' ' . $NameSeparated[CLX_NUM_TWO]);
                    break;
                case 4:
                    // More than two elements, could be "FIRSTNAME MIDDLE LASTNAME1 [LASTNAME2]"
                    $record["ACUS_firstname"] = trim($NameSeparated[CLX_NUM_ZERO] . ' ' . $NameSeparated[CLX_NUM_ONE]);
                    $record["ACUS_lastname"] = trim($NameSeparated[CLX_NUM_TWO] . ' ' . $NameSeparated[CLX_NUM_THREE]);
                    break;
                default:
                    $record["ACUS_firstname"] = 'NA';
                    $record["ACUS_lastname"] = 'NA';
                    break;
            }
        } else {
            $sep = ','; // Separated by comma. FULLNAME comes with 'LASTNAME, FIRSTNAME'
            $NameSeparated = strpos($ibsuser_data[CLX_NUM_ZERO]['FULLNAME'], $sep);
            $record['ACUS_lastname'] = trim(substr($ibsuser_data[CLX_NUM_ZERO]['FULLNAME'], CLX_NUM_ZERO, $NameSeparated));
            $record['ACUS_firstname'] = trim(substr($ibsuser_data[CLX_NUM_ZERO]['FULLNAME'], $NameSeparated + CLX_NUM_ONE));
        }
        $record["ACUS_company"] = (empty($ibsuser_data[CLX_NUM_ZERO]['E01NME'])) ? kDefaultCompany : trim($ibsuser_data[CLX_NUM_ZERO]['E01NME']);
        $record["ACUS_email"] = trim($ibsuser_data[CLX_NUM_ZERO]['EMAIL']);
        $record["ACUS_position"] = $record["ACUS_company"];
        $record["ACUS_phone"] = trim($ibsuser_data[CLX_NUM_ZERO]['E01PHN']);
        if (!empty($ibsuser_data[CLX_NUM_ZERO]['E01PXT'])) {
            $record["ACUS_phone"] .= ' Ex:' . trim($ibsuser_data[CLX_NUM_ZERO]['E01PXT']);
        }
        $record['ACUS_fax'] = '';
        $record['ACUS_status'] = CLX_NUM_ONE;
        $record['ACUS_audit'] = CLX_INIT_ZERO;
        $record['ACUS_login_attempts'] = CLX_INIT_ZERO;
        $record['ACUS_creatoruser'] = 'system';
        $record['ACUS_isadmin'] = CLX_NUM_ZERO;
        $record['ACUS_ibsuser'] = CLX_NUM_ONE;
        $record['ACUS_ext_ref_no'] = '';
        return $record;
    }

    /**
     * Set user to group
     *
     * @param array $ibsuser_data
     * @return void
     */
    function ibsUserGroup($ibsuser_data) {
        //Adding User Groups
        $record = array();
        $record['GROUPCODE'] = $this->ibsUserGroupTranslation(trim($ibsuser_data[CLX_NUM_ZERO]['E01AUT'])); //E01AUT
        $record['USERNAME'] = $ibsuser_data[CLX_NUM_ZERO]['USERNAME'];
        ClxCommon::$db->loadDbRecord('CLX_AC_GROUP_MEMBERS', $record, false, 'UPPER(USERNAME) = ' . singleQuote(uppercase($record['USERNAME'])) . ' AND GROUPCODE = ' . singleQuote($record['GROUPCODE']));
        if (defined('ACUS_FORCE_INTERFACE_GROUP') && intval(ACUS_FORCE_INTERFACE_GROUP) == CLX_NUM_ONE) {
            ClxCommon::$db->deleteRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(UPPERCASE($record['USERNAME'])) . ' AND GROUPCODE IN (' . singleQuote('IBSADMIN') . ', ' . singleQuote('IBSSUP') . ', ' . singleQuote('IBSOPE') . ', ' . singleQuote('IBSSUPOPE') . ', ' . singleQuote('IBSCONS') . ', ' . singleQuote('IBSSUPOPA') . ') AND GROUPCODE <> ' . singleQuote($record['GROUPCODE']));
        }
    }

    /**
     * Returns Equivalent CLX Group from IBS Group code AUTHZTN TYPE E01AUT (S,O,B,I)
     *
     * @param string $groupcode
     * @return string
     */
    function ibsUserGroupTranslation($groupcode) {
        //EIBS_GROUP_TRNSLT_SET
        //EBSK Group translations
        //A:IBSADMIN,S:IBSSUP,O:IBSOPE,B:IBSSUPOPE,I:IBSCONS,DEFAULT:IBSCONS
        //A, I O B S
        $return = '';
        switch (uppercase($groupcode)) {
            case 'A': //ADMINISTRADOR
                $return = 'IBSADMIN';
                break;
            case 'S': //Supervisor
                $return = 'IBSSUP';
                break;
            case 'O': //Operador
                $return = 'IBSOPE';
                break;
            case 'B': //Supervisor/Operador
                $return = 'IBSSUPOPE';
                break;
            case 'C': //Supervisor/Operador que aprueba sus propias transacciones  (NEW )
                $return = 'IBSSUPOPA';
                break;
            case 'I': //Solo Consultas
                $return = 'IBSCONS';
                break;
            default:
                $return = 'IBSCONS';
                break;
        }
        return $return;
    }

// Other methods
    /**
     * Verifies password history to check
     *
     * @param string $userid
     * @param string $password
     * @param string $action
     * @return boolean
     */
    function checkPasswordHistory($userid, $password, $action) {
        if ($action === 'CREATE' || $action === 'DELETE') {
            return true;
        }
        if (empty($userid)) {
            return false;
        }
        if (defined('ACUS_PWD_FORCE_HISTORY') && ACUS_PWD_FORCE_HISTORY == CLX_NUM_ONE) {
            $sql = 'SELECT COUNT(ID) FROM CLX_AC_USERS WHERE ID = ' . $userid . ' AND (PASSWORD = ' . singleQuote($password) . ' OR PASSWORD01 = ' . singleQuote($password) . ' OR PASSWORD02 = ' . singleQuote($password) . ' OR PASSWORD03 = ' . singleQuote($password) . ' OR PASSWORD04 = ' . singleQuote($password) . ' OR PASSWORD05 = ' . singleQuote($password) . ')';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                return false;
            }
        }
        return true;
    }

    /**
     * Performs validation to identify if password can be changed
     *
     * @param string $username
     * @return boolean
     */
    function checkPasswordMinDaysToChange($userid) {
        if (empty($userid))
            return true;
        if (defined('ACUS_PWD_MIN_DAYS') && ACUS_PWD_MIN_DAYS > CLX_NUM_ZERO) {
            $sql = 'SELECT PASSLSTCHANGE FROM CLX_AC_USERS WHERE ID = ' . $userid;
            $d = xFormat::getNow();
            $last_change_date = ClxCommon::$db->getOne($sql);
            if (!empty($last_change_date) && day_diff($d, $last_change_date) <= ACUS_PWD_MIN_DAYS) {
                return false;
            }
        }
        return true;
    }

    function hasOpenSession($username) {
        if (defined('kSessionMultiple') && kSessionMultiple == false) {
            $sql = 'SELECT COUNT(USERNAME) FROM CLX_AC_USER_SESSIONS WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username)) . ' AND XDATE>=NOW()';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    /**
     * Search user and return information
     */
    function ldapUserSrch() {
        require_once kPathToWebSite . 'classes/clx_ldap.php';
        $info = array('error' => '', 'items' => array());
        $contents = '';
        $ldap = new clx_ldap(ACUS_LDAP_HOST, ACUS_LDAP_PORT, ACUS_LDAP_BASE_DN);
		$contents2='';
        if ($ldap->haserror()) {//conection fail just stop
            $contents = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E030-CONN]';
            $info['error'] = $contents;
            ob_clean();
            return json_encode($info);
        }
        //   Caso 1002687 - MUN-LDAP login userid alterno
        // Sets default search fieldname if ACUS_LDAP_SEARCH_FIELDNAME system parameter is defined
        if (defined('ACUS_LDAP_SEARCH_FIELDNAME')) {
            if (ACUS_LDAP_SEARCH_FIELDNAME !== 'null' && trim(ACUS_LDAP_SEARCH_FIELDNAME) !== '') {
                $ldap->set_search_fieldname(ACUS_LDAP_SEARCH_FIELDNAME);
            }
        }
        $ldap_user = (isset(UserRequest::$post['ldap_user']) ? UserRequest::$post['ldap_user'] : $_SESSION['user_record']['username']);
        $ldap_pass = (isset(UserRequest::$post['ldap_pass']) ? UserRequest::$post['ldap_pass'] : '');
        if (ACUS_LDAP_DIRECTORY_TYPE == CLX_NUM_ONE)
            $ldap->set_active_directory(true);
        if (ACUS_LDAP_DIRECTORY_TYPE == CLX_NUM_THREE)
            $ldap->set_extended_open_ldap(true);
        if (ACUS_LDAP_ALLOW_ANONYMOUS == CLX_NUM_ONE && empty($ldap_pass)) {
            $ldap->connectandbind();
        } else {
            $ldap->connectandbind($ldap_user, $ldap_pass);
        }
        //Check for response errors
	    $contents2.='ACUS_LDAP_HOST:'.ACUS_LDAP_HOST."<br>".chr(13).chr(10).
					'ACUS_LDAP_PORT:'.ACUS_LDAP_PORT."<br>".chr(13).chr(10).
					'ACUS_LDAP_BASE_DN:'.ACUS_LDAP_BASE_DN."<br>".chr(13).chr(10).
					'LDAP_USER:'.$ldap_user."<br>".chr(13).chr(10).
					'LDAP_PASS:'.$ldap_pass."<br>".chr(13).chr(10).
					'ACUS_LDAP_DIRECTORY_TYPE:'.ACUS_LDAP_DIRECTORY_TYPE."<br>".chr(13).chr(10);
					
        if ($ldap->haserror()) {//authentication error
            $contents = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E040-AUTH]';
            $contents.=$contents2;
            $info['error'] = $contents;
			ob_clean();
            return json_encode($info);
        }
        //perform search
        $info['items'] = $ldap->get_user_info(UserRequest::$request['srch_key']);
        if ($ldap->haserror()) {//authentication error
            $contents = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E050-AUTH]';
            $contents2.='LDAP_PARAMETER:'.print_r($ldap->get_ldap_search_options(),true)."<br>".chr(13).chr(10).
			$contents.=$contents2;
			
            $info['error'] = $contents;
            $info['items'] = array();
        }
        $ldap->close();
        unset($ldap);
		ob_clean();
        return json_encode($info);
    }

    /**
     * Search user and return information
     */
    function ldapSearchFromCLI() {
		$params = array();
		$cmd = urldecode(UserRequest::$request['cmd']);
		if(isset(UserRequest::$request['ldap_host'])) {
			$params['ldap_host'] = UserRequest::$request['ldap_host'];
		}
		if(isset(UserRequest::$request['ldap_port'])) {
			$params['ldap_port'] = UserRequest::$request['ldap_port'];
		}
		if(isset(UserRequest::$request['ldap_base_dn'])) {
			$params['ldap_base_dn'] = UserRequest::$request['ldap_base_dn'];
		}
		if(isset(UserRequest::$request['ldap_base_dn_sec'])) {
			$params['ldap_base_dn_sec'] = UserRequest::$request['ldap_base_dn_sec'];
		}
		if(isset(UserRequest::$request['ldap_directory_type'])) {
			$params['ldap_directory_type'] = UserRequest::$request['ldap_directory_type'];
		}
		if(isset(UserRequest::$request['ldap_allow_anonymous'])) {
			$params['ldap_allow_anonymous'] = UserRequest::$request['ldap_allow_anonymous'];
		}
		$ldap_attr = array('dn', 'uid', 'cn', 'givenname', 'sn', 'mail', 'sAMAccountName', 'memberOf');
		$response = $this->ldapSearch($cmd, $params, $ldap_attr);
		return $response;
	}
	
    function ldapGetConnection($params = array()) {
        require_once kPathToWebSite . 'classes/clx_ldap.php';
        $info = array('error' => CLX_CHAR_EMPTY_STRING, 'ldap_conn' => null);
        $contents = '';
		if(!isset($params['ldap_host'])) {
			$params['ldap_host'] = ACUS_LDAP_HOST;
		}
		if(!isset($params['ldap_port'])) {
			$params['ldap_port'] = ACUS_LDAP_PORT;
		}
		if(!isset($params['ldap_base_dn'])) {
			$params['ldap_base_dn'] = ACUS_LDAP_BASE_DN;
		}
		if(!isset($params['ldap_directory_type'])) {
			$params['ldap_directory_type'] = ACUS_LDAP_DIRECTORY_TYPE;
		}
		if(!isset($params['ldap_allow_anonymous'])) {
			$params['ldap_allow_anonymous'] = ACUS_LDAP_ALLOW_ANONYMOUS;
		}
        $ldap = new clx_ldap($params['ldap_host'], $params['ldap_port'], $params['ldap_base_dn']);
        if ($ldap->haserror()) {//conection fail just stop
            $contents = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E035-CONN]';
            $info['error'] = $contents;
            return $info;
        }
        $ldap_user = (isset(UserRequest::$post['ldap_user']) ? UserRequest::$post['ldap_user'] : $_SESSION['user_record']['username']);
        $ldap_pass = (isset(UserRequest::$post['ldap_pass']) ? UserRequest::$post['ldap_pass'] : CLX_CHAR_EMPTY_STRING);
        if (CLX_NUM_ZERO+$params['ldap_directory_type'] == CLX_NUM_ONE) {
            $ldap->set_active_directory(true);
		}
        if (CLX_NUM_ZERO+$params['ldap_directory_type'] == CLX_NUM_THREE) {
            $ldap->set_extended_open_ldap(true);
		}
        if (CLX_NUM_ZERO+$params['ldap_allow_anonymous'] == CLX_NUM_ONE && empty($ldap_pass)) {
            $ldap->connectandbind();
        } else {
            $ldap->connectandbind($ldap_user, $ldap_pass);
        }
        //Check for response errors
        if ($ldap->haserror()) {//authentication error
            $contents = dict($ldap->geterrorlabel()) . ' | ' . $ldap->getExtendedError() . ' [LDAP-E045-AUTH]';
            $info['error'] = $contents;
            return $info;
        }
        $info['ldap_conn'] = $ldap;
		return $info;
	}
	
    function ldapSearch($cmd, $params = array(), $ldap_attr = null) {
        //Perform search
        $info = array('error' => '', 'items' => null, 'cmd' => $cmd, 'params' => $params);
		$response = $this->ldapGetConnection($params);
		if($response['error'] !== CLX_CHAR_EMPTY_STRING) {
            $info['error'] = $response['error'];
	        ob_clean();
	        return json_encode($info);
		}
		if(isset($params['ldap_base_dn_sec'])) {
			$response['ldap_conn']->setbasedn($params['ldap_base_dn_sec']);
		}
		// $response['ldap_conn']->debug = true;
		$sr = $response['ldap_conn']->search($cmd, $ldap_attr);
		$info['items'] = $response['ldap_conn']->get_entries($sr);
		$response['ldap_conn']->close();
        unset($response);
		ob_clean();
        return json_encode($info);
    }

    private function ldap_defvals() {
		if (!defined('ACUS_LDAP_EXTRA_SRCH')) {
			define('ACUS_LDAP_EXTRA_SRCH', CLX_NUM_ZERO);
		}
	}
	
    private function ldap_js_script($element) {
        //TODO: Para mejorar sacando script a javascript incluyendo etiquetas
        $this->ldap_defvals();
		if ($element == CLX_NUM_ZERO) {
            $return = '<script type="text/javascript">
			function acus_ldap_setaction(item){
				var data  = $(' . singleQuote('#usr_') . '+item).val();
				var t = data.split(' . singleQuote('-:-') . ');
				if (t[0]!="null")
					$(' . singleQuote('#ACUS_firstname') . ').val(t[0]);
				if (t[1]!="null")
					$(' . singleQuote('#ACUS_lastname') . ').val(t[1]);
				if (t[2]!="null")
					$(' . singleQuote('#ACUS_username') . ').val(t[2]);
				if (t[3]!="null")
					$(' . singleQuote('#ACUS_company') . ').val(t[3]);
				if (t[4]!="null")
					$(' . singleQuote('#ACUS_position') . ').val(t[4]);
				if (t[5]!="null")
					$(' . singleQuote('#ACUS_email') . ').val(t[5]);
				if (t[6]!="null")
					$(' . singleQuote('#ACUS_phone') . ').val(t[6]);
				if (t[7]!="null")
					$(' . singleQuote('#ACUS_fax') . ').val(t[7]);
				if (t[8]!="null")
					$(' . singleQuote('#ACUS_ext_ref_no') . ').val(t[8]);
				if (t[9]!="null")
					$(' . singleQuote('#ACUS_password') . ').val(t[9]);
				if (t[9]!="null")
					$(' . singleQuote('#ACUS_confirm') . ').val(t[9]);
				if (t[10]!="null")
					$(' . singleQuote('#ACUS_ldap_rdn_username') . ').val(t[10]);
				$(' . singleQuote('#ldapsrch') . ').dialog(' . singleQuote('close') . ');
			}
			$(document).ready(function() {
			   $(' . singleQuote('#ldapsrch') . ').dialog({autoOpen: false, modal: true,height: 400,width: 400});
			   $(' . singleQuote('#opener') . ').click(function(){
				   $(' . singleQuote('#response') . ').html(' . singleQuote('') . ');
				   $(' . singleQuote('#ldapsrch') . ').dialog(' . singleQuote('open') . ');
				   return false;
				});
			   var btn_clicked = null;
			   $(' . singleQuote('#ldap_search_ex') . ').click(function(){
				   btn_clicked = ' . singleQuote('ldap_search_ex') . ';
				   runClick();
			   });					
			   $(' . singleQuote('#ldap_search_run') . ').click(function(){
				   btn_clicked = ' . singleQuote('ldap_search_run') . ';
				   runClick();
			   });					
			   function runClick() {
				   $(' . singleQuote('#response') . ').html(' . singleQuote('...') . ');
				   var errhtml = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ';';
            if (ACUS_LDAP_ALLOW_ANONYMOUS == CLX_NUM_ZERO) {
                $return .= ' if($(' . singleQuote('#ldappass') . ').val()==' . singleQuote(CLX_CHAR_EMPTY_STRING) . '){
						    errhtml =' . singleQuote('<br><div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>' . dict('GEN_LBL_PASSWORD') . ' ' . dict('GEN_LBL_REQUIRED') . '</p></div>') . ';
						    $(' . singleQuote('#response') . ').html(errhtml);
						    return;
					    }';
            }
            $return .= ' if($("#search").val()==' . singleQuote(CLX_CHAR_EMPTY_STRING) . '){
					    errhtml =' . singleQuote('<br><div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>' . dict('GEN_LBL_SEARCH_USER') . ' ' . dict('GEN_LBL_REQUIRED') . '</p></div>') . ';
					    $(' . singleQuote('#response') . ').html(errhtml);
					    return;
				    }
					var url = "window.php?to=ACUS&ac=LDAP_USER_SRCH";
					var ldp_par = { ldap_user: $("#ldapusr").val(), ldap_pass: $("#ldappass").val(), srch_key: $("#search").val() };
				    if(btn_clicked === ' . singleQuote('ldap_search_ex') . ') {
						url = "window.php?to=ACUS&ac=LDAP_CMD_SRCH";
						ldp_par = { ldap_user: $("#ldapusr").val(), ldap_pass: $("#ldappass").val(), cmd: $("#search").val(), ldap_base_dn_sec: $("#ldapdnsec").val() };
					}
				    $.post(url, ldp_par, function(response) {
					  ' . (ACUS_LDAP_EXTRA_SRCH == CLX_NUM_ONE ? 'console.log(response);' : '' ) . '
				      var obj = jQuery.parseJSON(response);
				      if(obj.error!=' . singleQuote(CLX_CHAR_EMPTY_STRING) . '){
				      	errhtml =' . singleQuote('<br><div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>') . '+obj.error+' . singleQuote('</p></div>') . ';
				      	$(' . singleQuote('#response') . ').html(errhtml);
				      	return;
				      }
				      errhtml = ' . singleQuote('<div class="ui-state-highlight ui-corner-all" style="padding: 0 .7em;"><ul>') . ';
				      if(btn_clicked === ' . singleQuote('ldap_search_ex') . ') {
				        if(obj.items === null) {
						  errhtml += '. singleQuote('0 ' . dict('GEN_LBL_FOUND') . ' [EX-010]') . ';
				        } else if(typeof(obj.items[0]) === '.singleQuote('undefined').') {
						  errhtml += '. singleQuote('0 ' . dict('GEN_LBL_FOUND') . ' [EX-020]') . ';
				        } else {
							$.each(obj.items, function(key, values) {
							  if(key !== '. singleQuote('count') . ') {
							    errhtml += ' . singleQuote('<li>') . ';
							    // errhtml += ' . singleQuote('<li>key: "') . '+key+' . singleQuote('" values:<br>') . ';
							    $.each(values, function(key, value) {	
								  if(isNaN(parseInt(key)) && key !== '. singleQuote('count') . ') {
							        errhtml += key + ' . singleQuote(' = ') . ';
							        if(typeof(value) === ' . singleQuote('object') . ') {
								      errhtml += value[0];
							        } else { 
								      errhtml += value;
							        }
							        errhtml += ' . singleQuote('<br>') . ';
							      }
							    });
							    errhtml += ' . singleQuote('<br></li>') . ';
							  }
							});
				        }
				      } else {
				        if(obj.items.length === 0) {
						  errhtml += '. singleQuote('0 ' . dict('GEN_LBL_FOUND')) . ';
				        }
				        $.each(obj.items, function(key, value) {
						  var action = value.FIRSTNAME+' . singleQuote('-:-') . '+value.LASTNAME+' . singleQuote('-:-') . '+value.USERNAME+' . singleQuote('-:-') . '+value.COMPANY+' . singleQuote('-:-') . '+value.POSITION+' . singleQuote('-:-') . '+value.EMAIL+' . singleQuote('-:-') . '+value.PHONE+' . singleQuote('-:-') . '+value.FAX+' . singleQuote('-:-') . '+value.EXT_REF_NO+' . singleQuote('-:-') . '+value.PASSWORD+' . singleQuote('-:-') . '+value.LDAP_RDN_USERNAME;
				    	  errhtml += ' . singleQuote('<li><p><input type="hidden" id="usr_') . '+key+' . singleQuote('" value="') . '+action+' . singleQuote('" />') . ';
				    	  errhtml += ' . singleQuote('<b><a href="javascript:acus_ldap_setaction(') . '+key+' . singleQuote(')">') . '+value.FIRSTNAME+' . singleQuote(' ') . '+value.LASTNAME+' . singleQuote('</a></b> (') . '+value.USERNAME+' . singleQuote(')<br>') . ';
				    	  errhtml += (value.COMPANY===' . singleQuote('') . ' ? ' . singleQuote('') . ' : value.COMPANY+' . singleQuote('<br>') . ');
				    	  errhtml += (value.POSITION===' . singleQuote('') . ' ? ' . singleQuote('') . ' : value.POSITION+' . singleQuote('<br>') . ');
				    	  errhtml += (value.EMAIL===' . singleQuote('') . ' ? ' . singleQuote('') . ' : value.EMAIL+' . singleQuote('<br>') . ');
				    	  errhtml += (value.PHONE===' . singleQuote('') . ' ? ' . singleQuote('') . ' : value.PHONE+' . singleQuote('<br>') . ');
				    	  errhtml += ' . singleQuote('</p></li>') . ';
				        });
				      }
				      errhtml += ' . singleQuote('</ul></div>') . ';
				      $(' . singleQuote('#response') . ').html(errhtml);
				    }).error(function() { alert("Request error. Try again later"); });
				   return false;
				};
			});
			</script>';
            return $return;
        }
        if ($element == CLX_NUM_ONE) {
            return '<img src="' . kPathToSkins . $_SESSION['skin'] . '/icons/view.gif" title="' . dict('GEN_LBL_DIRECTORY_SEARCH') . '" border="0" id="opener">';
        }
        if ($element == CLX_NUM_TWO) {
            $return = '<div id="ldapsrch" title="' . dict('GEN_LBL_DIRECTORY_SEARCH') . '"  class="ui-widget">
					<table border="0">
				<tr>
				<td><p><b>' . dict('GEN_LBL_SEARCH_USER') . ':</b></p></td>
				<td><input type="text" id = "search" name = "search" size=20 maxlength=32></td>
				</tr>';
            if (ACUS_LDAP_ALLOW_ANONYMOUS == CLX_NUM_ZERO) {
                $return .='<tr>
							<td colspan = 2><p>' . dict('GEN_LBL_AUTH_REQUIRED') . '</p>
							</td>
						  </tr>';
            } else {
                $return .='<tr>
							<td colspan = 2><p>' . dict('GEN_LBL_LDAP_ANON_OPTPASS') . '</p>
							</td>
						  </tr>';
            }
            if (ACUS_LDAP_EXTRA_SRCH == CLX_NUM_ONE) {
				$return .= '<tr>
					<td><p><b>DN: </b></p></td>
					<td><input type="text" id = "ldapdnsec" name = "ldapdnsec" size=20 maxlength=32 value="'.ACUS_LDAP_BASE_DN.'"></td>
					</tr>';
			}
			$user_name_input = $_SESSION['user_record']['username'];
	        $acus_record = ClxCommon::$db->getRecord($this->tablename, 'UPPER(USERNAME) = ' . singleQuote(uppercase($user_name_input)));
            if (isset($acus_record['LDAP_RDN_USERNAME'])) {
                if (!empty($acus_record['LDAP_RDN_USERNAME']) && !is_null($acus_record['LDAP_RDN_USERNAME'])) {
                    // if column LDAP_RDN_USERNAME exists and it isn't null or blank, uses it as username for LDAP binding
                    $user_name_input = trim($acus_record['LDAP_RDN_USERNAME']);
                }
            }
			$return .= '<tr>
				<td><p><b>' . dict('GEN_LBL_USERNAME') . ': </b></p></td>
				<td><input type="text" id = "ldapusr" name = "ldapusr" size=20 maxlength=32 value="'.$user_name_input.'"></td>
				</tr>';
            $return .= '<tr>
				<td><p><b>' . dict('GEN_LBL_PASSWORD') . ': </b></p></td>
				<td><input type="password" id = "ldappass" name = "ldappass" size=20 maxlength=32></td>
				</tr>';
            $return .= '<tr>
						<td colspan = 2><p><button type="button" id="ldap_search_run"  name="ldap_search_run">Search</button></p>';
            if (ACUS_LDAP_EXTRA_SRCH == CLX_NUM_ONE) {
	            $return .= '<p><button type="button" id="ldap_search_ex"  name="ldap_search_ex">Search (Extended)</button></p>';
			}
            $return .= '
							</td>
						  </tr>
				</table>';
            $return .= '<Br><div id="response"></div></div>';
            return $return;
        }
        //   - Caso 1002687 - MUN-LDAP login userid alterno
        // Hides LDAP_RDN_USERNAME field if LDAP login type isn\'t configured
        if ($element == CLX_NUM_THREE) {
            $return = '<script type="text/javascript">
				$(' . singleQuote('#ACUS_ldap_rdn_username') . ').parent().parent().hide();
			</script>';
            return $return;
        }
    }

    /**
     * User group report
     * @return string
     */
    private function user_group_report() {

        $return = dict('GEN_LBL_USER_GROUP_REPORT') . CLX_CHAR_NL .
                dict('GEN_LBL_VERSION') . ': ' . kSystemVersion . CLX_CHAR_NL .
                dict('GEN_LBL_SYSTEM') . ': ' . kDatabaseDisplay . '@' .   UserRequest::$server['HTTP_HOST'] . CLX_CHAR_NL .
                dict('GEN_LBL_CREATEDBY').':'.$_SESSION["user_record"]["username"].CLX_CHAR_NL.
                dict('GEN_LBL_DATE') . ': ' . xFormat::getNow("Y-m-d H:i:s") . CLX_CHAR_NL;

        $sql = 'SELECT
                    ACUS.USERNAME,
                    ACUS.CDATE,
                    ACUS.FIRSTNAME,
                    ACUS.LASTNAME,
                    ACUS.EMAIL,
                    ACUS.PHONE,
                    ACUS.COMPANY,
                    ACUS.ISADMIN,
                    ACUS.STATUS,
                    ACGM.GROUPCODE,
                    ACGR.IDNAME,
                    CASE WHEN ACUS.AUDITU=1 THEN '.singleQuote(dict('GEN_LBL_YES')).' ELSE '.singleQuote(dict('GEN_LBL_NO')).' END AS USER_AUDIT,
                    CASE WHEN ACGR.AUDITU=1 THEN '.singleQuote(dict('GEN_LBL_YES')).' ELSE '.singleQuote(dict('GEN_LBL_NO')).' END AS GROUP_AUDIT,
                    CASE WHEN ACUS.AUDITU=1 OR ACGR.AUDITU>0 THEN '.singleQuote(dict('GEN_LBL_YES')).' ELSE '.singleQuote(dict('GEN_LBL_NO')).' END AS HAS_AUDIT
                  FROM CLX_AC_USERS ACUS
                  LEFT JOIN CLX_AC_GROUP_MEMBERS ACGM ON ACGM.USERNAME = ACUS.USERNAME
                  LEFT JOIN CLX_AC_GROUPS ACGR ON ACGR.IDCODE = ACGM.GROUPCODE
                  WHERE 1=1
                  ORDER BY
                    ACUS.ISADMIN DESC,
                    ACUS.USERNAME ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        $flag = false;
        while ($r = ClxCommon::$db->getNextRecord($rs)) {
            $r['STATUS'] = dict($this->status_types[$r['STATUS']]);
            if (!$flag) {
                $flag = true;
                $comma = '';
                foreach ($r as $key => $val) {
                    $return .=$comma . dict('GEN_LBL_'.$key);
                    $comma = CLX_CHAR_TAB;
                }
                $return .= CLX_CHAR_NL;
            }

            $return .= implode(CLX_CHAR_TAB, $r).CLX_CHAR_NL;
        }
        UserResponse::setContentType('application/octet-stream');
        UserResponse::setContentDisposition('attachment');
        UserResponse::setFilename('user_report.xls');
        UserResponse::setKeepAlive('On');
        UserResponse::setPragma('no-cache');
        $return = utf8_decode($return);

        return $return;
    }
	function exists_session_token($key) {
		$d = date('Y-m-d H:i:s');
        return !empty (ClxCommon::$db->getOne('SELECT COUNT(1) FROM CLX_AC_USER_SESSIONS WHERE SESSION_KEY=' . singleQuote($key) . ' AND XDATE >' . singleQuote($d)));
	}
}