<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-05 09:42:44 -0400 (Fri, 05 Oct 2018) $
 * @version        $Rev: 10209 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_errors extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DBIE';
        $this->name = 'Import Errors';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->accesskey = 'DBIM';


        $this->tablename = 'CLX_DB_IMPORT_ERRORS';
        $this->record_name_singular = 'import error';
        $this->record_name_plural = 'import errors';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IMPORTID';
    }

    function toolTableStructure() {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1690;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_errors-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['LOG_ID'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['LINENUM'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
		$fields['TEST'] = array('type' => 'int(1)', 'null' => 'YES', 'properties' => '');
		$fields['ERRORNUM'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ERRORMSG'] = array('type' => 'varchar(2000)', 'null' => 'NO', 'properties' => '');
       
	    $fields['EXTRA1'] = array('type' => 'varchar(2000)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA2'] = array('type' => 'varchar(2000)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA3'] = array('type' => 'varchar(2000)', 'null' => 'YES', 'properties' => '');
       

        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'LINENUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function action($ac, $idlist) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1691;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_errors-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'LIST':
                    if (!empty(UserRequest::$request['importcode'])) {//Adding parameter to the filter if mc is set on menu to display only mc.
                        $_SESSION['paging']['DBIEList']['criteria'] = ' IMPORTCODE = ' . singleQuote(UserRequest::$request['importcode']);
                        if (empty($_SESSION['paging']['DBIEList']['sortby']))
                            $_SESSION['paging']['DBIEList']['sortby'] = CLX_NUM_ZERO;
                        if (empty($_SESSION['paging']['DBIEList']['startat']))
                            $_SESSION['paging']['DBIEList']['startat'] = CLX_NUM_ZERO;
                    }
                    $contents = parent::action($ac, $idlist);
                    break;
                case 'PANEL':
                    $contents = $this->makepanel(UserRequest::$request['importcode']);
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT_ERRORS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($importcode = null) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1692;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_errors-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'DBIEPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('importcode', $importcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = 'CLX_DB_IMPORT_ERRORS';
            $whereclause = 'IMPORTCODE=' . singleQuote($importcode);
            $sortclause = 'LOG_ID DESC,CDATE ASC ,LINENUM ASC';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN);
            $page->setProp('printheaders', false);
            $page->setProp('selector', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_SIX);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_LOG'),dict('GEN_LBL_LINE_NUM'), dict('GEN_LBL_TABLE_FIELD'), dict('GEN_LBL_ERROR_MSG'), dict('GEN_LBL_CDATE'), dict('GEN_LBL_TEST')));
            $i = CLX_INIT_ZERO;
			$ant='';
			$imprec=ClxCommon::$db->getonerecord($X='SELECT * FROM CLX_DB_IMPORTS WHERE IDCODE='.singlequote($importcode));
            while ($record = $page->nextRecord()) {
                if (!empty($ant) and $ant!=$record['CDATE'])
					$table->addCells('separator', array(
                    '&nbsp;', '&nbsp;', '&nbsp;', '&nbsp;','&nbsp;','&nbsp;'));
				$errorm=stripslashes($record['ERRORMSG']);
				IF ( $imprec['TYPE']=='CVS2' or $imprec['TYPE']=='FRL2' or $imprec['TYPE']=='FRL3' or $imprec['TYPE']=='XLS2') {
						$errorm.='<div id="b'.$i.$record['LOG_ID'].'_'.$record['LINENUM'].'">...</div>'.
						'<script>$( function() {$( "#x'.$i.$record['LOG_ID'].'_'.$record['LINENUM'].'" ).dialog({autoOpen: false});});'.
						
						'$("#b'.$i.$record['LOG_ID'].'_'.$record['LINENUM'].'").click(function(){$( "#x'.$i.$record['LOG_ID'].'_'.$record['LINENUM'].'" ).dialog( "open" );})'.
						'</script>'.
					'<div id="x'.$i.$record['LOG_ID'].	'_'.$record['LINENUM'].'" title="Sql Show"><p>'.addslashes($record['EXTRA1'].$record['EXTRA2'].$record['EXTRA3']).'</p></div>';
				}
				$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                    $record['LOG_ID'], $record['LINENUM'], $record['FIELDNAME'], $errorm,$record['CDATE'],$record['TEST']? dict('GEN_LBL_YES'):dict('GEN_LBL_NO')));
                $i++;
				$ant=$record['CDATE'];
            }
            $form->addContents($page->footers($table, ''));
            return buildPanelInterface(dict('TOOL_DBIE_TITLE_LIST'), 'IMPORT_ERRORS_' . $importcode, $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

}
