<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-09-11 21:26:29 -0400 (Tue, 11 Sep 2018) $
 * @version        $Rev: 10046 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_fields extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DBIF';
        $this->name = 'Import Fields';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->accesskey = 'DBIM';


        $this->tablename = 'CLX_DB_IMPORT_FIELDS';
        $this->record_name_singular = 'import field';
        $this->record_name_plural = 'import fields';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IMPORTCODE';
        $this->seqnum_field = 'SEQNUM';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
		//$fields['IMPORTSHEETS'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
		$fields['IMPORTSHEETS'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['FILE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

}
