<?php

/**
 * ui_view_columns
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Initial load
 *    INSERT INTO  CLX_DB_INDEX_COLUMNS (INDEX_CODE, FIELDNAME,	SEQNUM)
 *    SELECT DISTINCT IDCODE, FIELDNAME,0 SEQNUM FROM CLX_DB_TABLEINDEXES;
 *
 *    INSERT INTO  CLX_DB_INDEX_COLUMNS (INDEX_CODE, FIELDNAME,	SEQNUM)
 *    SELECT DISTINCT IDCODE, FIELDNAME_SEC, 1 SEQNUM  FROM CLX_DB_TABLEINDEXES
 *    WHERE FIELDNAME_SEC IS NOT null AND FIELDNAME_SEC <> );
 *
 * 	UPDATE CLX_DB_TABLEINDEXES SET TYPE = 'UNI' WHERE TYPE = 'COM';
 *  Included label
 */
class db_query_save extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
       $this->code = 'DBQS';
        $this->name = 'Query Save';
        $this->system = 'Database';
        $this->version = '0.3.3.2';


        $this->accesskey = 'DBQY';

        $this->tablename = 'CLX_DB_QUERY_SAVE';
        $this->record_name_singular = 'query save';
        $this->record_name_plural = 'querys save';
        $this->primary_key = array('QUERYCODE');
    }
    
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['TEXT_SQL'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'QUERYCODE');
		return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }


    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

//--  I N D E X   C O L U M N S
}
