<?php

/**
 * ui_view_columns
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Initial load
 *    INSERT INTO  CLX_DB_INDEX_COLUMNS (INDEX_CODE, FIELDNAME,	SEQNUM)
 *    SELECT DISTINCT IDCODE, FIELDNAME,0 SEQNUM FROM CLX_DB_TABLEINDEXES;
 *
 *    INSERT INTO  CLX_DB_INDEX_COLUMNS (INDEX_CODE, FIELDNAME,	SEQNUM)
 *    SELECT DISTINCT IDCODE, FIELDNAME_SEC, 1 SEQNUM  FROM CLX_DB_TABLEINDEXES
 *    WHERE FIELDNAME_SEC IS NOT null AND FIELDNAME_SEC <> );
 *
 * 	UPDATE CLX_DB_TABLEINDEXES SET TYPE = 'UNI' WHERE TYPE = 'COM';
 *  Included label
 */
class db_tableind_columns extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DBTC';
        $this->name = 'Index Columns';
        $this->system = 'Database';
        $this->version = '0.1.0.0';


        $this->accesskey = 'DBTC';

        $this->tablename = 'CLX_DB_INDEX_COLUMNS';
        $this->record_name_singular = 'Index column';
        $this->record_name_plural = 'Index columns';
        $this->primary_field = 'INDEX_CODE';
        $this->secondary_field = 'FIELDNAME';
        $this->seqnum_field = 'SEQNUM';
        $this->primary_key = array('INDEX_CODE', 'FIELDNAME');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['INDEX_CODE'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'INDEX_CODE,FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

//--  I N D E X   C O L U M N S
}
