<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.IbsSockets
 * @abstract		IBS Socket Messages Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version      $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class eb_socket_fields extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'EBIF';
        $this->name = 'IBS Socket Manager Import Fields';
        $this->system = 'Sockets';
        $this->version = '1.0.0.0';


        $this->accesskey = 'EBSK';

        $this->tablename = 'CLX_EB_SOCKET_FIELDS';
        $this->record_name_singular = 'import field';
        $this->record_name_plural = 'import fields';
        $this->primary_field = 'ID';
        $this->secondary_field = 'EBSOCKETCODE';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['EBSOCKETCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'EBSOCKETCODE,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

}
