<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @abstract		Application Controler C;ass.
 * @package		Clientix.Tool
 * @author	   $Author: alenetdev $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2018-12-20 12:36:57 -0400 (ju., 20 dic. 2018) $
 * @version		$Rev: 10423 $
 *
 * CHANGE LOG
 *  - Version 56 Revision
 */
class edit extends clx_tool {

    private $sec_table_list = NULL;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'EDIT';
        $this->name = 'Edit Database Contents';
        $this->system = 'Interface';
        $this->version = '7.0.0.0';
        $this->has_preferences = true;
        $this->has_access = true;
        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';
		$this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->clx_auth_status = false;
		IF (ISSET($_SESSION['ADDRDEBUGEDIT']) && $_SESSION['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}
    }

    /**
     * Add this tool preferences to the preferences form,
     * $record are the saved preferences.
     *
     * @param array $record
     * @param object $form
     * @param object $table
     */
    function preferencesForm($record, &$form, &$table) {
        ClxFreeReturn($form);
        $table->addCell(dict('TOOL_EDIT_TITLE_PREFS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $table->width));
        $locations = new htmlSelect('EDIT_BUTTON_LOCATION');
        $locations->addItem(dict('GEN_LBL_UP'), '1', ($record ['EDIT_BUTTON_LOCATION'] == CLX_NUM_ONE));
        $locations->addItem(dict('GEN_LBL_BOTH'), '2', ($record ['EDIT_BUTTON_LOCATION'] == CLX_NUM_TWO));
        $locations->addItem(dict('GEN_LBL_DOWN'), '3', ($record ['EDIT_BUTTON_LOCATION'] == CLX_NUM_THREE));
        $table->addData(dict('TOOL_EDIT_PROMPT_LOCATION') . ':', $locations->source());
        $locations2 = new htmlSelect('NEXT_ACTION');
        $locations2 = new htmlSelect('NEXT_ACTION');
        $locations2->addItem(dict('TOOL_EDIT_LBL_GOBACK'), '1', ($record ['NEXT_ACTION'] == CLX_NUM_ONE));
        $locations2->addItem(dict('TOOL_EDIT_LBL_DISPLAY'), '2', ($record ['NEXT_ACTION'] == CLX_NUM_TWO));
        $table->addData(dict('TOOL_EDIT_NEXT_ACTION') . ':', $locations2->source());
        $locations3 = new htmlSelect('DATE_FORMAT');
        $formatdate = array();
        $letter_no_necesary = array('H', 'i', 's', 'g', 'c', ':');
        foreach ($this->date_in_formats as $key => $val) {
            if ($val >= 'GEN_LBL_DATEFORMAT03' and $val <= 'GEN_LBL_DATEFORMAT23')
                continue;
            $key = trim(str_replace($letter_no_necesary, '', $key));
            if (!in_array($key, $formatdate) && strlen($key) > 2) {
                $locations3->addItem($key, $key, ($record ['DATE_FORMAT'] == $key));
                $formatdate[] = $key;
            }
        }

        $table->addData(dict('TOOL_EDIT_DATE_FORMAT') . ':', $locations3->source());
    }

    /**
     * Check the user input in the above form.
     *
     * Use UserRequest::$post to check user input.
     *
     * @param array $msg
     */
    function preferencesCheckForm(&$msg) {
        ClxFreeReturn($msg);
    }

    /**
     * Load preferences from the database.
     *
     * $record will be used as first argument int preferencesForm
     *
     * @param array $record
     */
    function preferencesLoad(&$record) {
        $username = $_SESSION ['user_record'] ['username'];
        $record ['EDIT_BUTTON_LOCATION'] = ClxCommon::$db->getField('CLX_US_PREFERENCES', 'PREFVALUE', 'USERNAME=' . singleQuote($username), 'PREFKEY=' . singleQuote('EDIT_BUTTON_LOCATION'));
        $record ['NEXT_ACTION'] = ClxCommon::$db->getField('CLX_US_PREFERENCES', 'PREFVALUE', 'USERNAME=' . singleQuote($username), 'PREFKEY=' . singleQuote('NEXT_ACTION'));
        $record ['DATE_FORMAT'] = ClxCommon::$db->getField('CLX_US_PREFERENCES', 'PREFVALUE', 'USERNAME=' . singleQuote($username), 'PREFKEY=' . singleQuote('DATE_FORMAT'));
    }

    /**
     * Save user input.
     * Use UserRequest::$post to check user input.
     *
     * @param array $record
     * @return boolean
     */
    function preferencesSave() {
        $USPR = &getTool('USPR');
        $USPR->prfSavePref($_SESSION['user_record']['username'], 'EDIT_BUTTON_LOCATION', UserRequest::$post['EDIT_BUTTON_LOCATION']);
        $USPR->prfSavePref($_SESSION['user_record']['username'], 'NEXT_ACTION', UserRequest::$post['NEXT_ACTION']);
        $USPR->prfSavePref($_SESSION['user_record']['username'], 'DATE_FORMAT', UserRequest::$post['DATE_FORMAT']);
    }

    /**
     * Create preferences for new users.
     *
     * @param array $record
     * @return boolean
     */
    function preferencesDefault(&$record) {
        ClxFreeReturn($record);
        $values = array();
        $values ['EDIT_BUTTON_LOCATION'] = CLX_NUM_THREE;
        $values ['NEXT_ACTION'] = CLX_NUM_ONE;
        $values ['DATE_FORMAT'] = CLX_NUM_ONE;
        return $values;
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {		IF ($this->debug==true) {echo"request<br>";		pre(UserRequest::$request);echo"post<br>";		pre(UserRequest::$post);echo"session<br>";		pre($_SESSION);}
        $msg = null;
        $formcode = null;
        $formrec = null;
        $tablecode = null;
        $tablerec = null;
        $continue = null;
        $contents = '';
	//	pre($ac);
        $next_action = $_SESSION ['prefs'] ['NEXT_ACTION'];
		if (!empty($GLOBALS['VIEWINFORMATION']))
			$ac='VIEWINFORMATION';
		$parentrecord=array();
		if (isset($_SESSION['history']['main'][1]['parentrecord'])){
			$parentrecord=$_SESSION['history']['main'][1]['parentrecord'];
		}
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'HISTORY' :
                    $listingcode = UserRequest::$request ['li'];
                    $contents = $this->makeListHistory($listingcode);
                    break;
                case 'POPLIST' :
                    $listingcode = UserRequest::$request ['li'];
                    $contents = $this->makePopList($listingcode);
                    break;
                case 'LIST' :
                    $listingcode = UserRequest::$request ['li'];
                    if ($listingcode === '') {
                        $contents = '';
                    } else {
                        $contents = $this->makeList($listingcode);
                    }
                    break;
                case 'VIEWS' :
                    $UIVW = &getTool('UIVW');
                    $contents = $UIVW->makeshortlist(UserRequest::$request ['qy']);
                    break;
                case 'QFILTER' :
                    $callingpage = peekHistory();
                    if (defined('CLX_IS_POP')) {
                        $listingcode = UserRequest::$request ['li'];
                        pushHistory($this->code, 'LIST', array(), 'li', $listingcode);
                    }
                    //Save new entries on litsts
                    $this->addNewListItems();
                    $this->setQuickFilter($callingpage);
                    $contents = executeHistory($callingpage);
                    break;
                case 'CLEARQFILTER' :
                    $callingpage = peekHistory();
                    $this->clearQuickFilter($callingpage);
                    $contents = executeHistory($callingpage);
                    break;
                case 'SEARCH' :
                    $contents = $this->searchForm();
                    break;
                case 'LINK' :
                    $contents = $this->linkSearch();
                    break;
                case 'LINK_BUILD' :
                    $contents = $this->linkRecord();
                    break;
                case 'UNLINK' :
                    $contents = $this->unLinkRecord($idlist, $msg);
                    break;
                case 'TOOLTIP' :
                    $listingcode = UserRequest::$request ['li'];
                    $this->getMenuInformation($listingcode, 'TOOLTIP_FORM', $formcode, $formrec, $tablecode, $tablerec);
                    if (array_key_exists('next', UserRequest::$request)) {
                        popHistory();
                        array_pop($idlist);
                    }
                    if (!$this->recordExists($tablerec, $idlist [CLX_NUM_ZERO])) {
                        $contents = warning(dict('TOOL_ANQN_ERR_NO_RECORD'), dict('GEN_LBL_CONTINUE'));
                    } else {
                        return $this->viewForm($listingcode, $ac, $idlist);
                    }
                    break;
                case 'SHOWEXECPAGE':
					if (empty($idlist))
						$idlist=UserRequest::$request['idlist'];
					UserRequest::$request=UserRequest::$post=ARRAY('to' => 'EDIT','relfm'=>'','ac' => 'QFILTER',  'qy' => 'RCEX',  'fm' => 'RCEX_SRCH',  'li' => 'RCEX_SRCH',  'obj_uid' => '',  'startat' => '0',  'pc' => '',  'nofr' => '0',  'pfid' => '0',  'RCEX_RCTM_CODE_terc' => '',  'RCEX_RCTM_CODE' => '', 'RCEX_RCTM_CODE_prim' => '',  'RCEX_RCTM_CODE_secd' => '', 'RCEX_RUNID' => $idlist,  'RCEX_EFFTDATETIME' => '','RCEX_PROC_STATUS' => '',  'RCEX_EXECUTEDBY' => '',  'submit1' => 'Filtro');
					$yes=1;
				case 'DISPLAY' :
                    $listingcode = UserRequest::$request ['li'];
                    $this->getMenuInformation($listingcode, 'DISPLAY_FORM', $formcode, $formrec, $tablecode, $tablerec);
                    if (array_key_exists('next', UserRequest::$request)) {
                        popHistory();
                        array_pop($idlist);
                    }
                    $msg = array();
                    $EVNT = &getTool('EVNT');
                    $listingid = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'ID', 'IDCODE = ' . singleQuote($listingcode));
                    $EVNT->execute5('UILG', $listingid, 'LIDI', UserRequest::$post, $msg);
                    if (!$this->recordExists($tablerec, $idlist [CLX_NUM_ZERO])) {
                        $contents = warning(dict('TOOL_ANQN_ERR_NO_RECORD'), dict('GEN_LBL_CONTINUE'));
                    } else {
                        $contents = $this->viewForm($listingcode, $ac, $idlist);
                    }
					if (isset($yes)) {
						$contents.='<script>setTimeout(function(){window.location.reload(1);}, 10000)</script>';
						
						
					}
                    break;
                case 'CREATE' :
                    if ($this->getAccess()->canAppend()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'CREATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        if (isset(UserRequest::$post ['confirm'])) {
                            //Save new entries on litsts
                            $this->addNewListItems();
                            if ($this->checkForm2($msg, $formrec)) {
                                $id = $this->createRecord($formrec, $tablerec, false);
								apc_clear_xppaging_count($tablerec['IDCODE']);
                                // Next Action
                                if ( isset($GLOBALS["process"])  ) { 
                                    $contents="";      
								}
								else if ($next_action == CLX_NUM_ONE) { // Go Back
                                    $info = popHistory();
                                    $contents = executeHistory($info);
                                } else { // Display == 2
                                    $idlist = array($id);
                                    $contents = $this->viewForm($listingcode, $ac, $idlist);
                                }
                            } else {
								if ( isset($_SESSION["_dEBUG"]) ) { 
										$te=debug_backtrace();
										$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
										fwrite($tta,chr(13).chr(10)."ed1- hora:".date("h:i:s d/m/Y").chr(13).chr(10));
										fwrite($tta,chr(13).chr(10).var_export($msg,true).chr(13).chr(10));
										for ($t=0;$t<18;$t++) {
											if (isset($te[$t]["file"]))
												fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));


										}	
										fwrite($tta,chr(13).chr(10));
										fclose($tta);
								}

                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, array(), UserRequest::$post, $msg);
                                $contents = $form->source();
                            }
                        } else {
                            $record = $this->defaultRecord($tablerec, $formcode);
                            // Add bp Default Values from bp process
                            $this->bp_default_record($record);
                            $this->executeInitEvents($formrec, $tablerec, $record, $msg);
                            $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, array(), $record, $msg,$parentrecord);
                            $contents = $form->source();
                        }
                    } else {
                        //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_APPEND_1][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'MODIFY' :
                    if ($this->getAccess()->canModify()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'MODIFY_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        if (isset(UserRequest::$post ['confirm'])) {
                            //Save new entries on litsts
                            $this->addNewListItems();//pre(userRequest::$request);
                            if ($this->checkForm2($msg, $formrec)) {//pre($tablecode);
								if ($tablecode /*userRequest::$request['fm']*/=='RCTR' ) {
									includeCodeLib('RCAA');
									$a = new Rcaa();
									$recordid = UserRequest::$post [$tablecode . '_ID'];
									$record = $this->prepareRecord($formrec, $tablerec, $recordid);
									if ($a->rctr_view_item_is_approved_or_auth($record)){//pre('aca1');die;
										$recordid = $this->saveRecord($formrec, $tablerec);
										apc_clear_xppaging_count($tablerec['IDCODE']);
									}
									else if (!$this->requestAuthorization('MODIFY', $formrec, $tablerec)) {
									//pre('aca2');die;		
										$recordid = $this->saveRecord($formrec, $tablerec);
										apc_clear_xppaging_count($tablerec['IDCODE']);
									}
									else {
										//pre('aca3');die;
									}
								}
                                else if (!$this->requestAuthorization('MODIFY', $formrec, $tablerec)) {
                                    $recordid = $this->saveRecord($formrec, $tablerec);
									apc_clear_xppaging_count($tablerec['IDCODE']);
                                }
								if ( isset($GLOBALS["process"])  ) { 
                                    $contents="";      
								}
                                else if ($next_action == CLX_NUM_ONE || empty($recordid)) { // Go Back
                                    if (count($idlist) > CLX_NUM_ZERO) {
                                        $id = array_pop($idlist);
                                        $record = $this->loadRecord_($tablerec, $id, false);
                                        $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, $idlist, $record, $msg);
                                        $contents = $form->source();
                                    } else {
                                        $info = popHistory();
                                        $contents = executeHistory($info);
                                    }
                                } else { // Display == 2
                                    $idlist = array($recordid);
                                    $contents = $this->viewForm($listingcode, $ac, $idlist);
                                }
                            } else {
								if ( isset($_SESSION["_dEBUG"]) ) { 
										$te=debug_backtrace();
										$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
										fwrite($tta,chr(13).chr(10)."ed2- hora:".date("h:i:s d/m/Y").chr(13).chr(10));
										fwrite($tta,chr(13).chr(10).var_export($msg,true).chr(13).chr(10));
										for ($t=0;$t<18;$t++) {
											if (isset($te[$t]["file"]))
												fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));


										}	
										fwrite($tta,chr(13).chr(10));
										fclose($tta);
								}

                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, $idlist, UserRequest::$post, $msg);
                                $contents = $form->source();
                            }
                        } else {
                            $id = array_pop($idlist);
                            if (!$this->recordExists($tablerec, $id)) {
                                $contents = warning(dict('TOOL_ANQN_ERR_NO_RECORD'), dict('GEN_LBL_CONTINUE'));
                            } else {
                                $record = $this->loadRecord_($tablerec, $id, false);
                                $this->executeInitEvents($formrec, $tablerec, $record, $msg);
                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, $idlist, $record, $msg);
                                $contents = $form->source();
                            }
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY_1][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'DUPLICATE' : // Alpha
                    if ($this->getAccess()->canAppend()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'DUPLICATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        if (isset(UserRequest::$post ['confirm'])) {
                            //Save new entries on litsts
                            $this->addNewListItems();
                            if ($this->checkForm2($msg, $formrec)) {
                                $id = $this->duplicateRecord($formrec, $tablerec);
								apc_clear_xppaging_count($tablerec['IDCODE']);
								if ( isset($_SESSION["_dEBUG"]) ) { $te=debug_backtrace();$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."ed17- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10).var_export($msg,true).chr(13).chr(10));for ($t=0;$t<18;$t++) {if (isset($te[$t]["file"])) {fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));	fclose($tta);}}

								if ( isset($GLOBALS["process"])  ) { 
                                    $contents="";      
								}
                                else if ($next_action == CLX_NUM_ONE) { // Go Back
                                    $info = popHistory();
                                    $contents = executeHistory($info);
                                } else { // Display == 2
                                    $idlist = array($id);
                                    $contents = $this->viewForm($listingcode, $ac, $idlist);
                                }
                            } else {
                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, array(), UserRequest::$post, $msg);
                                $contents = $form->source();
                            }
                        } else {
                            $id = array_pop($idlist);
                            if (!$this->recordExists($tablerec, $id)) {
                                $contents = warning(dict('TOOL_ANQN_ERR_NO_RECORD'), dict('GEN_LBL_CONTINUE'));
                            } else {
                                $record = $this->loadRecord_($tablerec, $id, false);
                                if (array_key_exists($tablerec['IDCODE'] . '_CLX_AUTH_STATUS', $record)) {
                                    $record[$tablerec['IDCODE'] . '_CLX_AUTH_STATUS'] = 'PEND';
                                }
                                $this->executeInitEvents($formrec, $tablerec, $record, $msg);
                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, $idlist, $record, $msg);
                                $contents = $form->source();
                            }
                        }
                    } else {
                        //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY & CAN_APPEND 1][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'DUPLICATE_EFFTDATE' : // Alpha
                    if ($this->getAccess()->canAppend()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'EFFTDATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        if (isset(UserRequest::$post ['confirm'])) {
                            if ($this->checkForm2($msg, $formrec)) {
                                //Save new entries on litsts
                                $this->addNewListItems();
                                $id = $this->duplicateRecord($formrec, $tablerec);
								apc_clear_xppaging_count($tablerec['IDCODE']);
                                if ($next_action == CLX_NUM_ONE) { // Go Back
                                    $info = popHistory();
                                    $contents = executeHistory($info);
                                } else { // Display == 2
                                    $idlist = array($id);
                                    $contents = $this->viewForm($listingcode, $ac, $idlist);
                                }
                            } else {
                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, array(), UserRequest::$post, $msg);
                                $contents = $form->source();
                            }
                        } else {
                            $id = array_pop($idlist);
                            if (!$this->recordExists($tablerec, $id)) {
                                $contents = warning(dict('TOOL_ANQN_ERR_NO_RECORD'), dict('GEN_LBL_CONTINUE'));
                            } else {
                                $record = $this->loadRecord_($tablerec, $id, false);
                                if (array_key_exists($tablerec['IDCODE'] . '_CLX_AUTH_STATUS', $record)) {
                                    $record[$tablerec['IDCODE'] . '_CLX_AUTH_STATUS'] = 'PEND';
                                }
                                $this->executeInitEvents($formrec, $tablerec, $record, $msg);
                                $form = $this->editForm($listingcode, $formrec, $tablerec, $ac, $idlist, $record, $msg);
                                $contents = $form->source();
                            }
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY & CAN_APPEND 2][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'DELETE' :
                    if ($this->getAccess()->canDelete()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'DELETE_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        if (isset(UserRequest::$post ['confirm'])) {
                            if ($this->checkDeleteForm($formrec, $msg)) {
								if ($this->checkForm2($msg, $formrec)) {
									if (!$this->requestAuthorizationMult($ac, $formrec, $tablerec)) {
										$this->deleteRecords($tablerec, $idlist);
										apc_clear_xppaging_count($tablerec['IDCODE']);
									}
                                }
								
                                $info = popHistory();
								$contents='';
								if (count($msg)>0) {
									foreach ($msg as $key=>$value) {$contents.=note($key." ".$value);}
									$contents.=executeHistory($info);
								}
								else
                                $contents = executeHistory($info);
                            } else {
                                $contents = $this->confirmDelete($listingcode, $formrec, $tablerec, $idlist, $msg);
                            }
                        } else {
                            $contents = $this->confirmDelete($listingcode, $formrec, $tablerec, $idlist, $msg);
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_DELETE_1][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case "REQAUTHORIZATIONBATCH":
                    if ($this->getAccess()->canModify()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, "MODIFY_FORM", $formcode, $formrec, $tablecode, $tablerec);
                        ClxFreeReturn($this->requestAuthorizationBatch('CREATE', $formrec, $tablerec));
						apc_clear_xppaging_count($tablerec['IDCODE']);
						if ( !isset($GLOBALS["process"])  ) { 
							$info = popHistory();
							$contents .= executeHistory($info);
						}	
						else {
							$contents='';
						}	
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY_2][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'REQAUTHORIZATION' :
                    if ($this->getAccess()->canModify()) {
                        $listingcode = UserRequest::$request ['li'];
                        $this->getMenuInformation($listingcode, 'MODIFY_FORM', $formcode, $formrec, $tablecode, $tablerec);
                        ClxFreeReturn($this->requestAuthorizationMult('CREATE', $formrec, $tablerec));
						apc_clear_xppaging_count($tablerec['IDCODE']);
						if ( !isset($GLOBALS["process"])  ) { 
							$info = popHistory();
							$contents .= executeHistory($info);
						}
						else {
							$contents='';
						}
                    } else {
                        //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY_2][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
				case 'QUESTIONARY_DIALOG' :
                    if ($this->getAccess()->canRead()) {
                        $listingcode = UserRequest::$request ['li'];
                        $tablecode = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'TABLECODE', 'IDCODE=' . singleQuote($listingcode));
                        $url = 'pop.php?to=ANQN&ac=QUESTIONARY_DIALOG&tc='.$tablecode.'&recs=' . toString($idlist);
                        $contents = '<!-- openUbicacionwindow1 -->'.setJavaScriptTag('openWindow('. singlequote('questionary' . time()) . ', ' . singleQuote($url) . ', 700, 500);', false);
                        $info = popHistory();
                        $contents .= executeHistory($info);
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_READ_1][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'PRINT_DIALOG' :
                    if ($this->getAccess()->canRead()) {
                        $listingcode = UserRequest::$request ['li'];
                        $tablecode = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'TABLECODE', 'IDCODE=' . singleQuote($listingcode));
                        $url = 'pop.php?to=ANOG&ac=PRINT_DIALOG&tc=' . $tablecode . '&recs=' . toString($idlist);
                        $contents = '<!-- openUbicacionwindow2	 -->'.setJavaScriptTag('openWindow(' . singleQuote(dict('GEN_LBL_PRINT')) . ', ' . singleQuote($url) . ', 500, 500);', false);
                        $info = popHistory();
                        $contents .= executeHistory($info);
                    } else {
                        //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_READ_2][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                case 'AJAX' :
                    $result_container = UserRequest::$request ['reslt'];
                    $contents .= $result_container . '<-container>' . $this->ajax();
                    break;
                case 'CODE' : // Executing Menu Code
                    $contents .= $this->executeCode();
                    break;
                case 'OS_EXECUTE' :
                    $contents .= $this->executeCommand($idlist);
                    break;
                case 'JUMP_LIST'://same as default with variations
                    if (!empty(UserRequest::$request['jm'])) {
                        $contents = $this->executeJumpListingButton(UserRequest::$request['jm'], $idlist, $continue);
                        if ($continue === true) {
                            $callingpage = popHistory();
                            $contents .= executeHistory($callingpage);
                        }
                    } else {
                        ////$contents = parent::action($ac, $idlist);
                        //if no option found for jump listing just return to previous
                        $callingpage = popHistory();
                        $contents .= executeHistory($callingpage);
                    }
                    break;
                case 'CHNG_FL_VAL'://changes field value
                    if ($this->getAccess()->canModify()) {
                        $msg = array();
                        if (isset(UserRequest::$post ['confirm'])) {
                            $fieldname = UserRequest::$post['EDIT_fieldname'];
                            $tablecode = UserRequest::$post['EDIT_tablecode'];
                            $from_value = UserRequest::$post['EDIT_from_value'];
                            $to_value = UserRequest::$post['EDIT_to_value'];
                            if ($this->changeFieldValueValidate($fieldname, $tablecode, $from_value, $to_value, $msg)) {
                                if ($this->changeFieldValue($fieldname, $tablecode, $from_value, $to_value)) {
                                    $contents = note(dict('GEN_LBL_PROCESS_COMPLETED'));
                                } else {
                                    $contents = warning(dict('GEN_SYS_EXCEPTION', 'EDIT.CHNG_FL_VAL'));
                                }
                            } else {
                                $contents = $this->changeFieldValuePrompt($msg);
                            }
                        } else {
                            $contents = $this->changeFieldValuePrompt($msg);
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
				case 'SHOWMSG' :
					$contents=base64_decode(ClxCommon::$db->getOne('SELECT TEXT_MESSAGE FROM CLX_MESSAGE WHERE IDCODE='.singlequote(UserRequest::$get['Xmsg'])));
					//$contents=$_SESSION['Xmsg_'];
					break;
				case 'VIEWINFORMATION':
					$contents=$GLOBALS['VIEWINFORMATION'];
					$GLOBALS['VIEWINFORMATION']='';
					break;
				default :
                    $la = strlen('BUTTON_');
                    if (substr($ac, CLX_NUM_ZERO, $la) === 'BUTTON_') {
                        $buttonid = str_replace('id', '', substr($ac, $la));
                        $contents = $this->executeListingButton($buttonid, $idlist, $continue);
                        if (!defined('clxbathrun') && $continue === true) {
                            $callingpage = popHistory();
                            $contents .= executeHistory($callingpage);
                        }
                    } else {
                        $contents = parent::action($ac, $idlist);
                    }
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_READ_3][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Loads Menu Information for application
     *
     * @param string $listingcode
     * @param string $formname
     * @param string $formcode
     * @param array $formrec
     * @param string $tablecode
     * @param array $tablerec
     */
    function getMenuInformation($listingcode, $formname, &$formcode, &$formrec, &$tablecode, &$tablerec) {
        $listingrec = ClxCommon::$db->getRecord('CLX_UI_LISTINGS', 'IDCODE=' . singleQuote($listingcode));

        $formcode = $listingrec [$formname];
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($formcode));
        $tablecode = $listingrec ['TABLECODE'];
        $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
    }

    /**
     * Returns table access
     * @param type $tablecode
     * @return \ClxAccess
     */
    function getAppAccess($tablecode, $tableonly = false) {
        $callingpage = peekHistory();
        $access = new ClxAccess($this->code);
        if (intval($_SESSION['user_record']['isadmin']) === CLX_NUM_ONE) {
            $access->setAdminUser();
            $this->sec_table_list = array($tablecode => array('access_obj' => $access));
        } elseif (!empty($callingpage ['li']) && false===$tableonly) {
            if (empty($callingpage ['qy'])) {
                $qy = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'QUERYCODE', 'IDCODE = ' . singleQuote($callingpage['li']));
            } else {
                $qy = $callingpage ['qy'];
            }
            $DBQY = &getTool('DBQY');
            $access = $DBQY->getAppAccess($qy);
            $this->sec_table_list = $DBQY->sec_table_list;  // Tables in query
        } else {
            $username = $_SESSION ['user_record'] ['username'];
            $sql = 'SELECT AT.TABLECODE, MAX(AT.CANREAD) CANREAD, MAX(AT.CANMODIFY) CANMODIFY, MAX(AT.CANDELETE) CANDELETE, MAX(AT.CANAPPEND) CANAPPEND, MAX(AT.ISADMIN) ISADMIN FROM CLX_DB_TABLES TB, CLX_AC_TABLES AT WHERE TB.IDCODE = AT.TABLECODE AND TB.IDCODE = ' . singleQuote($tablecode) . ' AND ((AT.OWNERCODE=' . singleQuote('USER') . ' AND AT.OWNERREF=' . singleQuote($username) . ') OR AT.OWNERCODE=' . singleQuote('GRUP') . ' AND AT.OWNERREF IN (SELECT G.GROUPCODE FROM CLX_AC_GROUP_MEMBERS G WHERE G.USERNAME=' . singleQuote($username) . ')) GROUP BY AT.TABLECODE';
            $records = ClxCommon::$db->executeQuery($sql);
            $this->sec_table_list = array();
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                $access->setUserAccess(intval($record ['CANREAD']), intval($record ['CANMODIFY']), intval($record ['CANDELETE']), intval($record ['CANAPPEND']), intval($record ['CANREAD']), intval($record ['ISADMIN']));
                $this->sec_table_list[$record ['TABLECODE']] = array('access_obj' => $access, 'CANREAD' => intval($record ['CANREAD']), 'CANMODIFY' => intval($record ['CANMODIFY']), 'CANDELETE' => intval($record ['CANDELETE']), 'CANAPPEND' => intval($record ['CANAPPEND']), 'DISPLAY' => intval($record ['CANREAD']), 'ISADMIN' => intval($record ['ISADMIN']));
            }
        }
        return $access;
    }

    function setQuickFilter($callingpage) {
        // Get all posts
        $criteria = '';
        $boolean = '';
        if (!array_key_exists('li', $callingpage) && array_key_exists('li', UserRequest::$post)) {
            $callingpage ['li'] = UserRequest::$post ['li'];
        }
        if (array_key_exists('qy', UserRequest::$post)) {
            $callingpage ['qy'] = UserRequest::$post ['qy'];
        }
        $listingcode = (array_key_exists('li', $callingpage)) ? $callingpage ['li'] : '';
        $querycode = (array_key_exists('qy', $callingpage)) ? $callingpage ['qy'] : '';
        $formcode = UserRequest::$post ['fm'];
		
        $msg = array();
        if (UserRequest::$request['ac'] === 'QFILTER') {
            $EDIT = &getTool('EDIT');
            $schformrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($formcode));
            $EDIT->checkQuickSearchForm($msg, $schformrec);
        }
        // Added to allow search form
        // Listing Quick Search Event
        if ($listingcode !== '') {
            $listingid = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'ID', 'IDCODE=' . singleQuote($listingcode));
            $EVNT = &getTool('EVNT');
            $EVNT->execute5('UILG', $listingid, 'LQSR', UserRequest::$post, $msg);
            // End Listing Quick Search Event
        }
        $DBTB = &getTool('DBTB');
        $DBFL = &getTool('DBFL');
        foreach (UserRequest::$post as $key => $val) {
            // any form field must have table and _ less is other stuff not to
            // concider
            $tablecode = substr($key, CLX_NUM_ZERO, strpos($key, '_', CLX_NUM_ZERO));
            $tb = $DBTB->getTable($tablecode);
			$fieldname = substr($key, strlen($tablecode . '_'), strlen($key));
            $sufix = substr($key, - CLX_NUM_FIVE, CLX_NUM_FIVE);
            $fieldrec = $DBFL->getField($fieldname); 
            if ($tablecode === '' || empty($tb) ||
                    $sufix === '_prim' || $sufix === '_secd' || $sufix === '_terc' ||
                    $tablecode == CLX_CLASS_FORM && $fieldname == CLX_PROP_ID ||
                    ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE = ' . singleQuote($tablecode) . ' AND FIELDNAME = ' . singleQuote($fieldname)) == CLX_NUM_ZERO || empty($fieldrec)) {
                continue; // Not found field. may report error
            }
            $fieldinstance = getToolObject('DBFT', $fieldrec ['FIELDTYPE']);
            $crit = $fieldinstance->setQuickFilters($tablecode, $fieldname, $fieldrec, UserRequest::$post);
            if ($crit !== '') {
                $criteria .= $boolean . $crit;
                $boolean = ' AND ';
            }
			//echo '----------------------<br>';
			//pre($crit);
			
        }
		apc_clear_xppaging_count_query($querycode);
		if (!empty($msg)) {//bloquearsi la validacion da problemas
            $criteria = '1=2';
        }
        $_SESSION ['paging'] [$querycode . '_LIST'] ['criteria'] = $criteria;
        $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] = UserRequest::$post;
        unset($_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] [CLX_PROP_TO], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['ac'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['qy'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['fm'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['li'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['obj_uid'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['startat'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['pc'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['nofr'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['pfid'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['rf'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['rfi'], $_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter'] ['submit1']);
    }

    /**
     * Clear quick filter
     * @param unknown_type $callingpage
     */
    function clearQuickFilter($callingpage) {
        UserRequest::$request ['menuid'] = (!empty($callingpage ['menuid'])) ? $callingpage ['menuid'] : '';
        if (array_key_exists('qy', UserRequest::$post)) {
            $callingpage ['qy'] = UserRequest::$post ['qy'];
        }
        if (!array_key_exists('li', $callingpage)) {
            if (array_key_exists('li', UserRequest::$post)) {
                $callingpage ['li'] = UserRequest::$post ['li'];
            }
        }
        $querycode = (array_key_exists('qy', $callingpage)) ? $callingpage ['qy'] : '';
        $_SESSION ['paging'] [$querycode . '_LIST'] ['criteria'] = '';
        unset($_SESSION ['paging'] [$querycode . '_LIST'] ['qfilter']);
        
		$UIFT = &getTool('UIFT');
        $UIFT->initPref($querycode);
		apc_clear_xppaging_count_query($querycode);
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::makelist()
     */
    function makelist($listingcode = null) {
        if (!defined('CLX_IS_POP')) {
            clearHistory();
        }

        pushHistory($this->code, 'LIST', array(), 'li', $listingcode, 'relfm', (isset(UserRequest::$request['relfm'])) ? UserRequest::$request['relfm'] : '');
        $UILG = &getTool('UILG');
        return (!$UILG->listingExists($listingcode)) ? alert(dict('GEN_ERR_LISTING_DOES_NOT_EXISTS')) : $UILG->buildListing($listingcode);
    }

    /**
     *
     * @param unknown_type $listingcode
     */
    function makePopList($listingcode) {
        if (!defined('CLX_IS_POP')) {
            clearHistory();
        }
        UserRequest::$request['ac'] = 'LIST';
        pushHistory($this->code, 'LIST', array(), 'li', $listingcode);
        $UILG = &getTool('UILG');
        return (!$UILG->listingExists($listingcode)) ? alert(dict('GEN_ERR_LISTING_DOES_NOT_EXISTS')) : $UILG->buildListing($listingcode, 'pop.php');
    }

    /**
     *
     * @param string $listingcode
     */
    function makeListHistory($listingcode) {
        UserRequest::$request ['startat'] = CLX_INIT_ZERO;
        if (!defined('CLX_IS_POP')) {
            clearHistory();
        }

        if (array_key_exists('eftk', UserRequest::$request)) {
            $eftk = UserRequest::$request ['eftk'];
            pushHistory($this->code, 'HISTORY', array(), 'li', $listingcode, 'eftk', $eftk);
        } else {
            $eftkp = (array_key_exists('eftkp', UserRequest::$request)) ? UserRequest::$request ['eftkp'] : '';
            pushHistory($this->code, 'HISTORY', array(), 'li', $listingcode, 'eftkp', $eftkp);
        }
        $UILG = &getTool('UILG');
        if (!$UILG->listingExists($listingcode)) {
            return alert(dict('GEN_ERR_LISTING_DOES_NOT_EXISTS'));
        }
        return $UILG->buildListing($listingcode, 'pop.php', false, false);
    }

    /**
     * Tool Edit Form
     * @param string $ac
     * @param string $idlist
     * @param array $record
     * @param array $msg
     * @return string
     */
    function editForm($listingcode, $formrec, $tablerec, $ac, $idlist = '', $record = '', $msg = '',$parentrecord=array()) {IF (isset($GLOBALS['ADDRDEBUGEDITFORM_']) && $GLOBALS['ADDRDEBUGEDITFORM_']==1) { ECHO __METHOD__.' '.__FILE__.':'.__LINE__.'<br>'; }
        if ($this->debug) {
			echo "editFORM en edit variable record ";
			pre($record);
		}	
        $formcode = $formrec ['IDCODE'];
        $tablecode = $tablerec ['IDCODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        $buttonloc = $_SESSION ['prefs'] ['EDIT_BUTTON_LOCATION'];
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        if (($modify && !$taccess->canModify()) || (!$modify && !$taccess->canDisplay())) {
            $table = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tablessec = '';
            $comma = '';
            foreach ($this->sec_table_list as $key => $val) {
                $tablessec .=$comma . '<br> ' . $key . ' ';
                foreach ($val as $k => $v) {
                    if (!$k === 'access_obj' && $v == CLX_NUM_ONE)
                        $tablessec .=$comma . ' [' . $k . ']';
                }
                $tablessec .=$comma . ' ';
                $comma = ',';
            }
            $table->addCell(warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_MODIFY|CAN_APPEND][' . $ac . '] ' . $this->getCode(false) . ' - Table: ' . $tablecode . ' ' . $tablessec), array());
            return $table;
        }
        $title = ($modify) ? dict('TOOL_EDIT_TITLE_MODIFY', dict($tablerec ['RECORDNAME_SINGULAR'])) : dict('TOOL_EDIT_TITLE_CREATE', dict($tablerec ['RECORDNAME_SINGULAR']));
        // Prepare anchor
        $back_anchor = '#' . $listingcode . '_LISTING_AN';
        $action = (!empty(UserRequest::$server ['PHP_SELF'])) ? UserRequest::$server ['PHP_SELF'] : 'tool.php';
        // Create the Form
        $form = new htmlForm(CLX_PROP_ACTION, $action . $back_anchor);
        $form->addArgument(CLX_PROP_TO, 'EDIT');
        $form->addArgument('ac', $ac);
        $form->addArgument('fm', $formcode);
        $form->addArgument('ac_tbl', $tablecode);
        $form->addArgument('confirm', '1');
        $form->addArgument('idlist', toString($idlist));
        $form->addArgument('relfm', UserRequest::$request ['relfm']);
        foreach ($parentrecord as $key=>$value) {
			$form->addArgument('parent_'.$key,$value);	
		}	
        if (!empty(UserRequest::$request['is_panel']))
            $form->addArgument('is_panel', CLX_NUM_ONE);
        // pre ($form);
        if (!array_key_exists('dplid', UserRequest::$request)) {
            if (UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') {
                $form->addArgument('dplid', (array_key_exists($tablecode . '_ID', $record)) ? $record [$tablecode . '_ID'] : CLX_NUM_ZERO );
            } else {
                $form->addArgument('dplid', CLX_NUM_ZERO);
            }
        } else {
            $form->addArgument('dplid', UserRequest::$request ['dplid']);
        }
        $tx = microtime();
        $this->http_set_tx($tx);
        $form->addArgument('clxtx_id', $tx);
        if (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') {
            $form->addArgument($tablecode . '_ID', '');
        } elseif (UserRequest::$request['ac'] === 'DUPLICATE') {
            $form->addArgument($tablecode . '_ID', '');
        } else {
            $form->addArgument($tablecode . '_ID', (array_key_exists($tablecode . '_ID', $record)) ? $record [$tablecode . '_ID'] : CLX_NUM_ZERO );
        }
        $form->addArgument('li', $listingcode);
        // Buttons Table
        $buttons = '';

        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (!empty($modify)) {
            if ($taccess->canModify()) {
                $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
            }
        } else {
            if ($taccess->canDisplay()) {
                $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
            }
        }

        $c = new htmlButtonCancel(null, $back_anchor, $action);
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => 'buttons'));
        $btable = $table->source();
        if ($buttonloc <= CLX_NUM_TWO) {
            $form->addContents($btable);
        }
        // Call the form manager to draw the form...
        $UIFM = &getTool('UIFM');
        $formsrc = $UIFM->userEditForm($formrec, $title, $record, $msg, $form);
        // Check if exists related form.
        if (!empty(UserRequest::$request ['relfm'])) {
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote(UserRequest::$request ['relfm']));
            if (empty($formrec)) {
                $BUGS = &getTool('BUGS');
                $BUGS->report(E_USER_ERROR, 'Missing Relation Form ' . UserRequest::$request ['relfm'] . ' on Listing $listingcode', 'edit.php', '844', UserRequest::$request, CLX_NUM_ONE, '');
            }
            $title = '';
            $formsrc .= '<br>' . $UIFM->userEditForm($formrec, $title, $record, $msg, $form);
        }

        $form->addContents($formsrc);
        if ($buttonloc >= CLX_NUM_TWO) {
            $form->addContents($btable);
        }

        $html = new htmlObject('div');
        $html->addContents($form->source());
        if (!empty(UserRequest::$request['relfm'])) {//limit rel form
            //do nothing
        } else {
            $contents = '';
            $UILG = &getTool('UILG');
            $record['TABLECODE'] = $tablecode;
            $formlistings = $this->getFormPanelListings($formcode);
            while ($formlistingrec = ClxCommon::$db->getNextRecord($formlistings)) {
                $contents .= $UILG->buildPanel($formlistingrec, $record);
            }
            $html->addContents($contents);
        }
        return $html;
    }

    function defaultForm($formrec, $record, $msg, $ac, $to, $it, $action = 'tool.php', $field_prefix = '', $title = '', $button_title = '', $target = '') {
        $idlist = getIdlist();

        $formcode = $formrec ['IDCODE'];
        $tablecode = ($field_prefix !== '') ? $field_prefix . '_' : $formrec ['IDCODE'] . '_';
        $taccess = $this->getAppAccess($formrec ['TABLECODE'], true);
        $is_code = ($ac==='CODE')?true:false;
        $title = ($title !== '') ? $title : '';
        $buttonloc = $_SESSION ['prefs'] ['EDIT_BUTTON_LOCATION'];
        // Create the Form
        $form = new htmlForm(CLX_PROP_ACTION, $action, CLX_PROP_TARGET, $target);
        $form->addArgument(CLX_PROP_TO, $to);
        $form->addArgument('ac', $ac);
        $form->addArgument('fm', $formcode);
        $form->addArgument('it', $it);
        if (array_key_exists('pc', UserRequest::$request))
            $form->addArgument('pc', UserRequest::$request ['pc']);
        $form->addArgument('confirm', '1');
        $form->addArgument('idlist', toString($idlist));
        $form->addArgument($tablecode . CLX_PROP_ID, (array_key_exists($tablecode . CLX_PROP_ID, $record)) ? $record [$tablecode . CLX_PROP_ID] : '' );
        $buttons = '';
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (!empty($button_title)) {
            if (is_array($button_title)) {
                foreach ($button_title as $key => $val) {
                    $c = new htmlFormSubmit($val, $key, $form->getProp(CLX_PROP_ID));
                    $buttons .= $c->source();
                }
            } else {
                $c = new htmlFormSubmit($button_title, $ac, $form->getProp(CLX_PROP_ID));
                $buttons .= $c->source();
            }
        } else {
            if ($taccess->canModify() || $is_code) {
                $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
            } elseif ($taccess->canDisplay() || $is_code) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => $ac))->source();
            } elseif ($taccess->canRead() || $is_code) {
                $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
            }
        }
        /*
         * COMMENT SINCE FROM INDEX.PHP WILL NOT DISPLAY ANYTHING. if
         * (countHistory()>0) { $c = new htmlButtonCancel(null, $back_anchor);
         * $buttons .= $c->source(); }
         */
        $table->addCell($buttons, array(CLX_PROP_CLASS => 'buttons'));
        $btable = $table->source();
        if ($buttonloc <= CLX_NUM_TWO) {
            $form->addContents($btable);
        }
        // Call the form manager to draw the form...
        $UIFM = &getTool('UIFM');
        $form->addContents($UIFM->userEditForm($formrec, $title, $record, $msg, $form));
        if ($buttonloc >= CLX_NUM_TWO) {
            $form->addContents($btable);
        }
        return $form;
    }

    /**
     * Saves item to the list
     *
     * @return type
     */
    private function addNewListItems() {
        if (empty(UserRequest::$request['fm'])) {
            return;
        }
        $sql = 'SELECT UIFM.TABLECODE, UIPF.TABLECODE FIELD_TABLECODE, DBFL.FIELD_EXTRA1 LISTCODE, UIPF.FIELDNAME, UIPF.FIELD_PARENT FROM CLX_UI_FORMS UIFM, CLX_UI_FORM_PANEL_FIELDS UIPF, CLX_UI_FORM_PANELS UIPN, CLX_DB_FIELDS DBFL WHERE UIPF.PANELID = UIPN.IDCODE AND UIFM.IDCODE = UIPN.FORMCODE AND UIPF.FIELDNAME = DBFL.FIELDNAME AND UIPF.ADD_LIST_ENTRY = 1 AND DBFL.FIELDTYPE = ' . singleQuote('LIST') . ' AND UIPN.FORMCODE = ' . singleQuote(UserRequest::$request['fm']);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $tablecode = (!empty($r['FIELD_TABLECODE'])) ? $r['FIELD_TABLECODE'] : $r['TABLECODE'];
            if (!empty(UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']]) && substr(UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']], CLX_NUM_ZERO, CLX_NUM_FOUR) === 'new_') {
                $item_lbl = str_replace('new_', '', UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']]);
                if (!empty($r['FIELD_PARENT']) && isset(UserRequest::$request[$tablecode . '_' . $r['FIELD_PARENT']])) {
                    $parent = UserRequest::$request[$tablecode . '_' . $r['FIELD_PARENT']];
                } else {
                    $parent = '';
                }

                $DBLI = getTool('DBLI');
                $list_item_code = $DBLI->createItem($r['LISTCODE'], $item_lbl, '', $parent);
                UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']] = $list_item_code;
                if (isset(UserRequest::$post[$tablecode . '_' . $r['FIELDNAME']]))
                    UserRequest::$post[$tablecode . '_' . $r['FIELDNAME']] = UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']];
                if (isset(UserRequest::$get[$tablecode . '_' . $r['FIELDNAME']]))
                    UserRequest::$get[$tablecode . '_' . $r['FIELDNAME']] = UserRequest::$request[$tablecode . '_' . $r['FIELDNAME']];
            }
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::checkForm()
     */
    function checkForm2(&$msg, $formrec = '') {
        $record = UserRequest::$post;
		if ( isset($_SESSION["_dEBUG"]) ) {	$te=debug_backtrace(); $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."ed312- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10)."msg:".var_export($msg,true).chr(13).chr(10));	fwrite($tta,chr(13).chr(10)."formrec:".var_export($formrec,true).chr(13).chr(10));	fwrite($tta,"http_tx_status:".$this->http_tx_status().chr(13).chr(10));	for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));fclose($tta);}

        if (empty($msg))
            $msg = array();
        if (!$this->http_tx_status()) {
            $msg [CLX_NUM_ZERO] = dict('GEN_ERROR_ALREADYDONE');
            addMessage(dict('GEN_ERROR_ALREADYDONE'));
			
        } else {

            $UIFM = &getTool('UIFM');
			if ( isset($_SESSION["_dEBUG"]) ) {	$te=debug_backtrace();	$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."ed31- hora:".date("h:i:s d/m/Y").chr(13).chr(10));	fwrite($tta,chr(13).chr(10).var_export($msg,true).chr(13).chr(10));	for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));fclose($tta);}
            $UIFM->userCheckForm($formrec, $record, $msg);
        }
		if ( isset($_SESSION["_dEBUG"]) ) { $te=debug_backtrace();$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."ed3- hora:".date("h:i:s d/m/Y").chr(13).chr(10));	fwrite($tta,chr(13).chr(10).var_export($msg,true).chr(13).chr(10));	for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10));fclose($tta);}

        // Perform pre authorize events
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') { // Verificar si esto es realmente necesario
            $this->authPreEvent($msg, $record, $formrec);
        }

        // Checking Restriction for update
        if (UserRequest::$request['ac'] === 'MODIFY') {
            $DBDR = &getTool('DBDR');
            $DBTB = &getTool('DBTB');
            $parent_tablecode = $formrec ['TABLECODE'];
            $parent_tablename = tableName($parent_tablecode);
            $relations = $DBDR->getChildRelation($parent_tablecode);
            foreach ($relations as $relation) {
                if ($relation ['UPDATE_ACTION'] != CLX_NUM_THREE) {
                    break;
                }
                $crit = '';
                $comma = '';
                foreach ($relation ['CRITERIAS'] as $val2) {
                    $crit .= $comma . ' C.' . $val2 ['CHILD_FIELD'] . ' = P.' . $val2 ['PARENT_FIELD'];
                    $comma = ' AND ';
                }
                $id = $record [$parent_tablecode . '_ID'];
                if (empty($id)) {
                    $id = CLX_INIT_ZERO;
                }
                $child_tablename = tableName($relation ['CHILD_TABLECODE']);
                $sql = 'SELECT P.ID, COUNT(P.ID) QTY FROM ' . $parent_tablename . ' P, ' . $child_tablename . ' C WHERE ' . $crit . ' AND P.ID = ' . $id . ' GROUP BY P.ID HAVING COUNT(P.ID)  >0';
                $rs = ClxCommon::$db->executeQuery($sql);
                while (ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $tbrec = $DBTB->getTable($relation ['CHILD_TABLECODE']);
                    $msg [$parent_tablecode . '_ID'] = dict('GEN_LBL_CHILD_UPDATE_REQ', dict($tbrec ['RECORDNAME_SINGULAR']));
                    addMessage($msg [$parent_tablecode . '_ID']);
                }
            }
        }


        return ClxCommon::checkMsgStatus($msg);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::checkForm()
     */
    function checkQuickSearchForm(&$msg, $formrec = '') {
        $record = UserRequest::$post;
        if (empty($msg)) {
            $msg = array();
        }
        $UIFM = &getTool('UIFM');
        $UIFM->userCheckQuickSearchForm($formrec, $record, $msg);
        return ClxCommon::checkMsgStatus($msg);
    }

    /**
     *
     * @param array $formrec
     * @param array $msg
     * @return boolean
     */
    function checkDeleteForm($formrec, &$msg) {
        if (empty($msg)) {
            $msg = array();
        }
        // Checking Restriction for delete
        $DBDR = &getTool('DBDR');
        //$DBFL = &getTool('DBFL');
        $DBTB = &getTool('DBTB');
        $parent_tablecode = $formrec ['TABLECODE'];
        $parent_tablename = tableName($parent_tablecode);
        $relations = $DBDR->getChildRelation($parent_tablecode);
        foreach ($relations as $relation) {
            if ($relation ['DELETE_ACTION'] != CLX_NUM_THREE)
                break;
            $crit = '';
            $comma = '';
            foreach ($relation ['CRITERIAS'] as $val2) {
                $crit .= $comma . ' C.' . $val2 ['CHILD_FIELD'] . ' = P.' . $val2 ['PARENT_FIELD'];
                $comma = ' AND ';
            }
            $idlist = toString(getIdlist());
            if (empty($idlist))
                $idlist = CLX_INIT_ZERO;
            $child_tablename = tableName($relation ['CHILD_TABLECODE']);
            $sql = 'SELECT P.ID, COUNT(P.ID) QTY FROM ' . $parent_tablename . ' P, ' . $child_tablename . ' C WHERE ' . $crit . ' AND P.ID IN (' . $idlist . ') GROUP BY P.ID HAVING COUNT(P.ID)  >0';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $tbrec = $DBTB->getTable($relation ['CHILD_TABLECODE']);
                if (empty($msg ['HAS_CHILD'])) {
                    $msg ['HAS_CHILD'] = array();
                }
                $msg ['HAS_CHILD'] [$r ['ID']] = dict('GEN_LBL_CHILD_DELETE_REQ', dict($tbrec ['RECORDNAME_SINGULAR']));
            }
        }
        return ClxCommon::checkMsgStatus($msg);
    }

    /**
     * Build Links Form for Dynamic Relations
     *
     * @return string
     */
    function linkSearch() {

        $callingpage = peekHistory();
        if (!empty(UserRequest::$request['parentli'])) {
            $callingpage ['parentli'] = UserRequest::$request['parentli'];
            $callingpage ['childli'] = UserRequest::$request['childli'];
            $callingpage ['relfm'] = UserRequest::$request['relfm'];
        } else {
            $callingpage ['parentli'] = (empty($callingpage ['parentli'])) ? $callingpage ['li'] : $callingpage ['parentli'];
            $callingpage ['childli'] = (empty($callingpage ['childli'])) ? UserRequest::$request ['li'] : $callingpage ['childli'];
            $callingpage ['relfm'] = (empty($callingpage ['relfm'])) ? UserRequest::$request ['relfm'] : $callingpage ['relfm'];
        }


        $sql = 'SELECT
                    UILG_CH.TABLECODE,
                    UIFL.RELFORMCODE,
                    UIFL.RELLINKLIST
                  FROM
                    CLX_UI_LISTINGS UILG_PL,
                    CLX_UI_LISTINGS UILG_CH,
                    CLX_UI_FORM_LISTINGS UIFL
                  WHERE
                    UILG_PL.DISPLAY_FORM = UIFL.FORMCODE
                    AND UILG_CH.IDCODE = UIFL.LISTINGCODE
                    AND UILG_PL.IDCODE = ' . singleQuote($callingpage ['parentli']) . '
                    AND UILG_CH.IDCODE = ' . singleQuote($callingpage ['childli']);
        $relrec1 = ClxCommon::$db->getOneRecord($sql);
        if (empty($relrec1['TABLECODE'])) {
            return note(dict('GEN_ERR_NOTDYNAMICREL', $callingpage ['parentli'], $callingpage ['childli']));
        }

        $child_tablecode = $relrec1['TABLECODE'];
        $rellisting = $relrec1['RELLINKLIST'];

        pushHistory($this->code, 'LINK', $callingpage ['idlist'], 'li', $callingpage ['li'], 'parentrecord', $callingpage ['parentrecord'], 'parentli', $callingpage ['parentli'], 'childli', $callingpage ['childli'], 'relfm', $callingpage ['relfm']);
        $UILG = &getTool('UILG');
        $DBDR = &getTool('DBDR');
        $relrec = $DBDR->getRelationInfo($callingpage ['parentrecord'] ['TABLECODE'], $child_tablecode);
        if (empty($relrec)) {
            return note(dict('GEN_ERR_NOTDYNAMICREL', $callingpage ['parentrecord'] ['TABLECODE'], $child_tablecode));
        }
        $rellisting = (!empty($rellisting)) ? $rellisting : $relrec ['SRCH_LISTING'];
        return $UILG->buildListing($rellisting, '', true, false, true);
    }

    function linkRecord() {
        if (empty($this->getAccess()->canDisplay())) {
            //return warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
            return warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_APPEND_2][LINKRECORD] ' . $this->getCode(false));
        }
        $msg = array();
        $child_tablecode = UserRequest::$request ['ctc'];
        $child_recordid = UserRequest::$request ['idlist'];
        popHistory(); // pop two times to return to display form since link
        // listing added one not needed to the stack.
        $callingpage = peekHistory();
        if (empty($callingpage ['parentrecord'])) { // no parent to merge just return
            // to origin
            $callingpage = popHistory();
            return executeHistory($callingpage);
        }

        $DBDR = &getTool('DBDR');
        $relrec = $DBDR->getRelationInfo($callingpage ['parentrecord'] ['TABLECODE'], $child_tablecode);
        if (empty($relrec)) {
            return note(dict('GEN_ERR_NOTDYNAMICREL', $callingpage ['parentrecord'] ['TABLECODE'], $child_tablecode));
        }
        if (empty(UserRequest::$request ['relfm'])) { // if no related form just link and return
            ClxFreeReturn($this->saveRelationRecord($child_tablecode, $child_recordid, $msg));
            $callingpage = popHistory();
            $contents = executeHistory($callingpage);
        } else { // build link form
            // IF RELATED FORM EXISTS JUST OPEN RECORN IN MODIFY
            $contents = $this->action('MODIFY', toArray($child_recordid));
        }
        return $contents;
    }

    /**
     * Unlinks Dynamic Relation Records
     * @param $idlist
     * @param $msg
     */
    function unLinkRecord($idlist, &$msg) {
        ClxFreeReturn($msg);
        // child information
        $childlisting = UserRequest::$post ['li'];
        $childrecid = toString($idlist);
        $child_tablecode = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'TABLECODE', 'IDCODE = ' . singleQuote($childlisting));
        // Parent information
        $callingpage = popHistory();
        // $callingpage = peekHistory();
        $parentrecid = $callingpage ['idlist'];
        $parent_tablecode = $callingpage ['parentrecord'] ['TABLECODE'];
        // Relation information
        $DBDR = &getTool('DBDR');
        $relrec = $DBDR->getRelationInfo($parent_tablecode, $child_tablecode);
        if (empty($relrec)) {
            return note(dict('GEN_ERR_NOTDYNAMICREL', $parent_tablecode, $child_tablecode));
        }
        // handling mn relations
        if ($relrec ['RELATION_TYPE'] == CLX_NUM_TWO) {
            $crit = '';
            $parent_fields = array();
            $child_fields = array();
            foreach ($relrec ['RELATIONS'] as $key => $val) {
                if ($val ['MN_TABLECODE'] == $parent_tablecode) {
                    $parent_fields [] = $val ['MN_TABLECODE'] . '.' . $val ['PARENT_FIELD'] . ' ' . $val ['CHILD_FIELD'];
                } elseif ($val ['MN_TABLECODE'] == $child_tablecode) {
                    $child_fields [] = $val ['MN_TABLECODE'] . '.' . $val ['PARENT_FIELD'] . ' ' . $val ['CHILD_FIELD'];
                }
            }
            if (!empty($parent_fields)) {
                $sql = 'SELECT ' . implode(',', $parent_fields) . ' FROM ' . $relrec ['PARENT_TABLENAME'] . ' ' . $relrec ['PARENT_TABLECODE'] . ' WHERE ' . $relrec ['PARENT_TABLECODE'] . '.ID = ' . $parentrecid;
            }
            $parentrec = ClxCommon::$db->getOneRecord($sql);
            // Check multiselect
            foreach ($idlist as $childrecid) {
                if (!empty($child_fields)) {
                    $sql = 'SELECT ' . implode(',', $child_fields) . ' FROM ' . $relrec ['CHILD_TABLENAME'] . ' ' . $relrec ['CHILD_TABLECODE'] . ' WHERE ' . $relrec ['CHILD_TABLECODE'] . '.ID = ' . $childrecid;
                }
                $childrec = ClxCommon::$db->getOneRecord($sql);
                $DBTB = &getTool('DBTB');
                $record = array();
                $record = array_merge($record, $parentrec, $childrec);
                $comma = '';
                $crit = '';
                foreach ($relrec ['RELATIONS'] as $key => $val) {
                    $crit .= $comma . $val ['CHILD_FIELD'] . '=' . singleQuote($record [$val ['CHILD_FIELD']]);
                    $comma = ' AND ';
                }
                $DBTB = &getTool('DBTB');
                $tablerec = $DBTB->getTable($relrec ['REL_TABLECODE']);
                $mnrecid = ClxCommon::$db->getOne('SELECT ID FROM ' . $relrec ['REL_TABLENAME'] . ' WHERE ' . $crit);
                $this->deleteRecord_($tablerec, $mnrecid);
            }
        } elseif ($relrec ['RELATION_TYPE'] == CLX_NUM_ZERO) { // dyn relation
            // Delete relations
            $sql = 'DELETE FROM ' . $relrec ['REL_TABLENAME'] . ' WHERE PARENT_TABLECODE = ' . singleQuote($parent_tablecode) . ' AND CHILD_TABLECODE = ' . singleQuote($child_tablecode) . ' AND ' . $relrec ['RELT_PFIELD'] . ' IN (SELECT ' . $relrec ['PARENT_FIELDNAME'] . ' FROM ' . $relrec ['PARENT_TABLENAME'] . ' WHERE ID IN (' . $parentrecid . ')) AND ' . $relrec ['RELT_CFIELD'] . ' IN (SELECT ' . $relrec ['CHILD_FIELDNAME'] . ' FROM ' . $relrec ['CHILD_TABLENAME'] . ' WHERE ID IN (' . $childrecid . '))';
            ClxCommon::$db->executeQuery($sql);
            $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($relrec ['REL_TABLENAME']));
            $ACAD = &getTool('ACAD');
            $ACAD->log($tablerec, $parentrecid, 'DEL_REC', $tablerec ['IDNAME'], $callingpage);
        }
        return executeHistory($callingpage);
    }

    /**
     * Default lookups
     * @return type
     */
    function searchForm() {
        $UIFM = &getTool('UIFM');
        $UIFT = &getTool('UIFT');
        $msg = array();
        $columns = array();

        $targettablecode = UserRequest::$request ['tc'];
        $fieldid = UserRequest::$request ['fid'];
        $relatedfield = (array_key_exists('rf', UserRequest::$request)) ? UserRequest::$request ['rf'] : '';
        if (array_key_exists('rfi', UserRequest::$request)) {
            $relatedfieldid = UserRequest::$request ['rfi'];
            $relatedfieldname = ClxCommon::$db->getField('CLX_UI_FORM_PANEL_FIELDS', 'FIELD_RELATED', 'ID=' . singleQuote($relatedfieldid));
            if (strpos($relatedfieldname, '.') !== false) {
                $rfieldsplit = explode('.', $relatedfieldname);
                $relatedfieldname = $rfieldsplit [CLX_NUM_ONE];
            }
        } else {
            $relatedfieldid = '';
            $relatedfieldname = '';
        }

        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'ID=' . $fieldid);

        $has_terciary = !empty($fieldrec ['FIELD_EXTRA9']);
        $tablecode = $fieldrec ['FIELD_EXTRA1'];

        $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
        $has_effective_date = (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE = ' . singleQuote($tablerec ['IDCODE']) . ' AND FIELDNAME = ' . singleQuote('CLX_EFFTDATE')) == CLX_NUM_ZERO) ? false : true;
        $fieldname = $fieldrec['FIELDNAME'];
        $form_fieldname = $targettablecode . '_' . $fieldname;
        $copy_fieldname = $fieldrec ['FIELD_EXTRA2'];
        $prim_record = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldrec ['FIELD_EXTRA3']));
        $secd_record = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldrec ["FIELD_EXTRA4"]));
        if ($has_terciary === true) {
            $terc_record = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldrec ['FIELD_EXTRA9']));
        }

        $contents = setJavaScriptTag(getJavaScriptFilename('EDIT_search.js'), true);
        $script = (!isset(UserRequest::$post ['confirm'])) ? setJavaScriptTag('getSearchValues(' . singleQuote($targettablecode) . ', ' . singleQuote($fieldname) . ');', false) : CLX_CHAR_EMPTY_STRING;

        // The Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server ['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument('tc', $targettablecode);
        $form->addArgument('fid', $fieldid);
        $form->addArgument('rf', $relatedfield); // Related Field Value
        $form->addArgument('rfi', $relatedfieldid); // Related Formfield Value
        // Buttons
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();

        $table->addCell($buttons, array(CLX_PROP_CLASS => 'buttons', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $buttons = $table->source();
        $title = dict('TOOL_EDIT_TITLE_SEARCH', dict($tablerec ['RECORDNAME_PLURAL']));
        $hasform = (strlen($fieldrec ['FIELD_EXTRA7']) != CLX_NUM_ZERO);
        if ($hasform === true) {
            $formcode = $fieldrec ['FIELD_EXTRA7'];
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($formcode));
            $form->addContents($UIFM->userSearchForm($formrec, $title, UserRequest::$post));
        } else {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));


            if (!array_key_exists($form_fieldname . '_prim', UserRequest::$post)) {
                UserRequest::$post [$form_fieldname . '_prim'] = '';
            }
            if (!array_key_exists($form_fieldname . '_secd', UserRequest::$post)) {
                UserRequest::$post [$form_fieldname . '_secd'] = '';
            }
            if (!array_key_exists($form_fieldname . '_terc', UserRequest::$post)) {
                UserRequest::$post [$form_fieldname . '_terc'] = '';
            }

            $form->addArgument($form_fieldname, '');
            $table->addField($msg, dict($prim_record ['FIELDFORMLABEL']), $form_fieldname . '_prim', UserRequest::$post [$form_fieldname . '_prim'], CLX_NUM_32, CLX_NUM_32);
            $table->addField($msg, dict($secd_record ['FIELDFORMLABEL']), $form_fieldname . '_secd', UserRequest::$post [$form_fieldname . '_secd'], CLX_NUM_32, CLX_NUM_32);

            if ($has_terciary === true) {
                $table->addField($msg, dict($terc_record ['FIELDFORMLABEL']), $form_fieldname . '_terc', UserRequest::$post [$form_fieldname . '_terc'], CLX_NUM_32, CLX_NUM_32);
            } else {
                $form->addArgument($form_fieldname . '_terc', '');
            }
            $form->addContents($table->source());
        }


        $form->addContents($buttons);
        $contents .= $form->source();

        // Search Procedure
        if (isset(UserRequest::$post ['confirm'])) {

            $criteria = '';
            $boolean = '';
            if ($_SESSION ['user_record'] ['isadmin'] !== '1') {
                $tlooks = ClxCommon::$db->executeQuery('SELECT	TF.TABLECODE TABLECODE, F.* FROM CLX_DB_TABLEFIELDS TF,	CLX_DB_FIELDS F WHERE TF.TABLECODE = ' . singleQuote($tablecode) . ' AND TF.FIELDNAME = F.FIELDNAME AND F.FIELDTYPE = ' . singleQuote('TLOK'));
                $has_tlook_field = ClxCommon::$db->numRows($tlooks);
            } else {
                $has_tlook_field = false;
            }
            if ($has_tlook_field === true) {
                $tcriteria = '';
                $tboolean = '';
                $ACTR = &getTool('ACTR');
                while ($tlook_field = ClxCommon::$db->getNextRecord($tlooks)) {
                    $nodes = $ACTR->getUserNodes($tlook_field ['FIELD_EXTRA1']);
                    foreach ($nodes as $node) {
                        $tcriteria .= $tboolean . $tlook_field ['FIELDNAME'] . ' LIKE ' . singleQuote($node . '%');
                        $tboolean = ' OR ';
                    }
                }
                if (strlen($tcriteria) > CLX_NUM_ZERO)
                    $criteria = '(' . $tcriteria . ')';
            }
            // Adding related fields criteria
            if ($relatedfield !== '') {
                if (strlen($criteria) > CLX_NUM_ZERO) {
                    $criteria = ' AND A.' . $fieldname . ' = ' . singleQuote($relatedfield);
                } else {
                    $criteria = ' A.' . $relatedfieldname . ' = ' . singleQuote($relatedfield);
                }
            }
            // Adding Effective date criteria.
            if ($has_effective_date === true) {
                if (strlen(trim($criteria)) > CLX_NUM_ZERO) {
                    $criteria .= ' AND A.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'] . ' X WHERE X.' . $copy_fieldname . ' = ' . $copy_fieldname . ')';
                } else {
                    $criteria .= ' A.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'] . ' X WHERE X.' . $copy_fieldname . ' = A.' . $copy_fieldname . ')';
                }
            }
            if ($hasform === true) {
                if (strlen($criteria) > CLX_NUM_ZERO) {
                    $boolean = ' AND ';
                }
                $fields = ClxCommon::$db->executeQuery(' SELECT FM.TABLECODE, F.* FROM CLX_UI_FORMS FM, CLX_UI_FORM_PANELS FP, CLX_UI_FORM_PANEL_FIELDS FPF, CLX_DB_FIELDS F WHERE FM.IDCODE = ' . singleQuote($formcode) . ' AND FP.FORMCODE = FM.IDCODE AND FPF.PANELID = FP.IDCODE AND FPF.FIELDNAME = F.FIELDNAME AND FPF.ACTIVE = 1 AND FP.ACTIVE = 1 ORDER BY FP.SEQNUM, FPF.FIELDSEQNUM');
                $columns = array();
                while ($field = ClxCommon::$db->getNextRecord($fields)) {
                    $columns [] = $field;
                    $sufix = $field ['TABLECODE'] . '_' . $field ['FIELDNAME'];
                    if ((strlen(UserRequest::$post [$sufix]) > CLX_NUM_ZERO) or ( strlen(UserRequest::$post [$sufix . '_operator']) > CLX_NUM_ZERO) or ( strlen(UserRequest::$post [$sufix . '_boolean']) > CLX_NUM_ZERO)) {
                        $operator = (strlen(UserRequest::$post [$sufix . '_operator']) > CLX_NUM_ZERO) ? UserRequest::$post [$sufix . '_operator'] : '===';
                        $fieldvalue = UserRequest::$post [$sufix];
                        $criteria .= $UIFT->makeCriteria($field ['FIELDNAME'], $operator, $fieldvalue, $boolean);
                        $boolean = (strlen(UserRequest::$post [$sufix . '_boolean']) > CLX_NUM_ZERO) ? UserRequest::$post [$sufix . '_boolean'] : ' AND ';
                    }
                }
            } else {
                if (strlen($criteria) > CLX_NUM_ZERO) {
                    $boolean = ' AND ';
                }
                if (strlen(UserRequest::$post [$form_fieldname . '_prim']) > CLX_NUM_ZERO) {
                    $criteria .= $boolean . $prim_record ['FIELDNAME'] . ' LIKE ' . singleQuoteWoSq(UserRequest::$post [$form_fieldname . '_prim'] . '%');
                    $boolean = ' AND ';
                }
                if (strlen(UserRequest::$post [$form_fieldname . '_secd']) > CLX_NUM_ZERO) {
                    $criteria .= $boolean . $secd_record ['FIELDNAME'] . '  LIKE ' . singleQuoteWoSq(UserRequest::$post [$form_fieldname . '_secd'] . '%');
                    $boolean = ' AND ';
                }
                if (strlen(UserRequest::$post [$form_fieldname . '_terc']) > CLX_NUM_ZERO) {
                    $criteria .= $boolean . $terc_record ['FIELDNAME'] . '  LIKE ' . singleQuoteWoSq(UserRequest::$post [$form_fieldname . '_terc'] . '%');
                    $boolean = ' AND ';
                }
            }

            //Adding field security
            $ACFS = &getTool('ACFS');
            $fcriteria = $ACFS->get_lookup_criteria($tablerec['IDCODE'], 'A');
            if ($fcriteria <> '') {
                if (strlen($criteria) > CLX_NUM_ZERO) {
                    $criteria .= ' AND ' . $fcriteria;
                } else {
                    $criteria .= ' ' . $fcriteria;
                }
            }
            if (strlen($criteria) > CLX_NUM_ZERO) {
                $criteria .= ' AND ';
            }
            switch (kDatabaseType) {
                case 'oci' :
                    $criteria .= ' 1=1 AND ROWNUM<=1000 ORDER BY A.' . $prim_record ['FIELDNAME'] . ' ASC, A.' . $secd_record ['FIELDNAME'] . ' ASC';
                    break;
                default :
                    $criteria .= ' 1=1 ORDER BY A.' . $prim_record ['FIELDNAME'] . ' ASC, A.' . $secd_record ['FIELDNAME'] . ' ASC LIMIT 500';
                    break;
            } // End switch
            $tableWidth = ($hasform) ? count($columns) : CLX_NUM_TWO;
            $tableWidth++;
            $table = new htmlTable($tableWidth);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            ClxCommon::$db->ci_search = true;
            $qty = ClxCommon::$db->oneExistsRecords($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'] . ' A ', $criteria);
            ClxCommon::$db->ci_search = false;
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $tableWidth));
            } else {
                $table->addCell(dict('GEN_LBL_FOUND') . ' ' . dict($tablerec ['RECORDNAME_PLURAL']), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
                // Peform Search
                ClxCommon::$db->ci_search = true;
                $records = ClxCommon::$db->getRecords($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'] . ' A ', $criteria);
                ClxCommon::$db->ci_search = false;
                $i = CLX_INIT_ZERO;
                $target0 = quote($targettablecode . '_' . $fieldname);
                $target1 = quote($targettablecode . '_' . $fieldname . '_prim');
                $target2 = quote($targettablecode . '_' . $fieldname . '_secd');
                $target3 = quote($targettablecode . '_' . $fieldname . '_terc');
                if (strlen($fieldrec ['FIELD_EXTRA7']) != CLX_NUM_ZERO)
                    $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
                foreach ($columns as $column) {
                    $table->addCell(dict($column ['FIELDFORMLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
                }
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $prim_record ['FIELDNAME'] = uppercase($prim_record ['FIELDNAME']);
                    $secd_record ['FIELDNAME'] = uppercase($secd_record ['FIELDNAME']);
                    $v0 = quoteWoSq(str_replace('"', '\"', $record [$copy_fieldname]), '&apos;');
                    $v1 = quoteWoSq(str_replace('"', '\"', $record [$prim_record ['FIELDNAME']]), '&apos;');
                    $v2 = quoteWoSq(str_replace('"', '\"', $record [$secd_record ['FIELDNAME']]), '&apos;');
                    if ($has_terciary === true) {
                        $terc_record ['FIELDNAME'] = uppercase($terc_record ['FIELDNAME']);
                        $v3 = quoteWoSq(str_replace(CLX_CHAR_DOUBLE_QUOTE, '\"', $record [$terc_record ['FIELDNAME']]), '&apos;');
                    } else {
                        $target3 = '';
                        $v3 = '';
                    }
                    $class = ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                    if ($fieldrec ['FIELD_EXTRA8'] === '3') { // means single
                        $js = 'javascript:setSearchValues(' . $target0 . ', ' . $v0 . ', ' . $target1 . ', ' . $v1 . ', ' . $target2 . ', ' . $v2 . ');';
                    } else {
                        if (!empty($target3)) {
                            $js = 'javascript:setSearchValues(' . $target1 . ', ' . $v1 . ', ' . $target2 . ', ' . $v2 . ', ' . $target3 . ', ' . $v3 . ');';
                        } else {
                            $js = 'javascript:setSearchValues(' . $target1 . ', ' . $v1 . ', ' . $target2 . ', ' . $v2 . ', false, false);';
                        }
                    }
                    if (strlen($fieldrec ['FIELD_EXTRA7']) == CLX_NUM_ZERO) { // default lookup
                        // type
                        if ($prim_record ['FIELDTYPE'] === 'LOOK') {
                            $lookdata = ClxCommon::$db->getFields(tableName($prim_record ['FIELD_EXTRA1']), $prim_record ['FIELD_EXTRA3'] . ', ' . $prim_record ['FIELD_EXTRA4'], $prim_record ['FIELD_EXTRA2'] . '=' . singleQuote($record [$prim_record ['FIELDNAME']]));
                            if (!empty($lookdata)) {
                                $record [$prim_record ['FIELDNAME']] = $lookdata [$prim_record ['FIELD_EXTRA3']] . '- ' . $lookdata [$prim_record ['FIELD_EXTRA4']];
                            }
                            unset($lookdata);
                        }
                        if ($secd_record ['FIELDTYPE'] === 'LOOK') {
                            $lookdata = ClxCommon::$db->getFields(tableName($secd_record ['FIELD_EXTRA1']), $secd_record ['FIELD_EXTRA3'] . ', ' . $secd_record ['FIELD_EXTRA4'], $secd_record ['FIELD_EXTRA2'] . '=' . singleQuote($record [$secd_record ['FIELDNAME']]));
                            if (!empty($lookdata)) {
                                $record [$secd_record ['FIELDNAME']] = $lookdata [$secd_record ['FIELD_EXTRA3']] . '- ' . $lookdata [$secd_record ['FIELD_EXTRA4']];
                            }
                            unset($lookdata);
                        }
                        $table->addCells($class, array('<a href=' . singleQuote($js) . '>' . getSkinIcon('MODIFY', '', '') . '</a>', $record [$prim_record ['FIELDNAME']], $record [$secd_record ['FIELDNAME']]));
                    } else {
                        $first = true;
                        foreach ($columns as $column) {
                            if ($first === true) {
                                $table->addCell('<a href=' . singleQuote($js) . '>' . getSkinIcon('MODIFY', '', '') . '</a>', array(CLX_PROP_CLASS => $class));
                                $first = false;
                            }
                            $fieldinstance = getToolObject('DBFT', $column ['FIELDTYPE']);
                            $fieldinstance->placeListField($column ['FIELDNAME'], $column, $record, $class, $table);
                        }
                    }
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents . $script;
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::confirmDelete()
     */
    function confirmDelete($listingcode, $formrec, $tablerec = '', $idlist = '', &$msg = '') {
        $UIFM = &getTool('UIFM');
        // Prepare anchor
        $back_anchor = '#' . $listingcode . '_LISTING_AN';
        $tablecode = $formrec ['TABLECODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        if (!$taccess->canDelete()) {
            //return warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
            return warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_DELETE_2][CONFIRMDELETE] ' . $this->getCode(false));
        }
        $action = (!empty(UserRequest::$server ['PHP_SELF'])) ? UserRequest::$server ['PHP_SELF'] : 'tool.php';
        // Create the Form
        $form = new htmlForm(CLX_PROP_ACTION, $action . $back_anchor);
        $form->addArgument('ac', 'DELETE');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('idlist', implode(',', $idlist));
        $form->addArgument('li', $listingcode);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_TTL_DELETE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (count($idlist) == CLX_NUM_ONE) {
            $table->addCell(dict('GEN_TTL_DELETE_CONFIRM', dict($tablerec ['RECORDNAME_SINGULAR'])), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        } else {
            $table->addCell(dict('GEN_TTL_DELETE_CONFIRM', dict($tablerec ['RECORDNAME_PLURAL'])), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        $form->addContents($table->source());

        foreach ($idlist as $id) {
            if ($this->recordExists($tablerec, $id)) {
                $record = $this->loadRecord_($tablerec, $id, false);
                $m = (!empty($msg ['HAS_CHILD'] [$id])) ? '<br>' . alert($msg ['HAS_CHILD'] [$id]) : '';
                $form->addContents($m . $UIFM->userViewForm($formrec, '', $record) . '<br>');
            }
        }
        $buttons = '';
        if ($taccess->canDelete()) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        $c = new htmlButtonCancel(null, $back_anchor, $action);
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => 'buttons', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::viewForm()
     */
    function viewForm($listingcode, $ac = '', $idlist = '') {
		IF (ISSET($_SESSION['ADDRDEBUGUILISTING']) && $_SESSION['ADDRDEBUGUILISTING']==$_SERVER['REMOTE_ADDR']) {
			$te=debug_backtrace(); 
			$pos=$posx=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}
		}
        $UIFM = &getTool('UIFM');
        $UILG = &getTool('UILG');
        $listingrec = ClxCommon::$db->getRecord('CLX_UI_LISTINGS', 'IDCODE=' . singleQuote($listingcode));
        if (empty($listingrec ['DISPLAY_FORM'])) {
            $formcode = $listingrec ['CREATE_FORM'];
        } else {
            $formcode = $listingrec ['DISPLAY_FORM'];
        }
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($formcode));
        $tablecode = $formrec ['TABLECODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        if (!$taccess->canRead()) {
            return warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_READ_5][' . UserRequest::$request['ac'] . '] ' . $this->getCode(false));
        }
        $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
        $id = $idlist [count($idlist) - CLX_NUM_ONE]; // get the last one
	//	e
	//	echo "del listado id");pre($id);
        // allow formulas
        $record = $this->loadRecord_($tablerec, $id, false);
        $record ['TABLECODE'] = $tablecode;
        $callingpage = peekHistory();
        if (!empty($callingpage['idlist'])) {
            pushHistory($this->code, 'DISPLAY', $idlist, 'li', $listingcode, 'parentrecord', $record, 'relfm', UserRequest::$request['relfm'], 'relpid', $callingpage['idlist']);
        } else {
            pushHistory($this->code, 'DISPLAY', $idlist, 'li', $listingcode, 'parentrecord', $record, 'relfm', UserRequest::$request['relfm']);
        }
        $title = dict('TOOL_EDIT_TITLE_VIEW', dict($tablerec ['RECORDNAME_SINGULAR']));
        $msg = array();
        $contents = '';
        $contents .= $UIFM->userViewForm($formrec, $title, $record, $msg);
        // Check if exists related form.
        if (!empty(UserRequest::$request ['relfm'])) {
            $formrecrel = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote(UserRequest::$request ['relfm']));
            if (empty($formrecrel)) {
                $BUGS = &getTool('BUGS');
                $BUGS->report(E_USER_ERROR, 'Missing Relation Form ' . UserRequest::$request ['relfm'] . ' on Listing $listingcode', 'edit.php', '844', UserRequest::$request, CLX_NUM_ONE, '');
            }
            $title = '';
            $contents .= '<br>' . $UIFM->userViewForm($formrecrel, $title, $record, $msg);
        }
        // Short display will present only de form not de panels
        if (UserRequest::$request['ac'] === 'TOOLTIP') {
            return $contents;
        }
        //Accion que viene de guardar pero ahora esta en DISPLAY
        if (UserRequest::$request['ac'] === 'MODIFY' or UserRequest::$request['ac'] === 'CREATE') {
            UserRequest::$request['ac'] = 'DISPLAY';
        }
        // Prepare anchor
        $back_anchor = '#' . $listingcode . '_LISTING_AN';
        $action = (!empty(UserRequest::$server ['PHP_SELF'])) ? UserRequest::$server ['PHP_SELF'] : 'tool.php';
        // Create the Form
        $form = new htmlForm(CLX_PROP_ACTION, $action . $back_anchor);
        $form->setProp(CLX_PROP_ID, CLX_CLASS_FOOTERS);
        $form->addArgument('ac', 'NOT_DEFINED');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('idlist', toString($idlist));
        $form->addArgument('next', CLX_NUM_ONE);
        $form->addArgument('li', $listingcode);
        $form->addArgument('relfm', UserRequest::$request ['relfm']);

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $c = new htmlButtonReturn('', $back_anchor, $action);
        $buttons = $c->source();
        if ($taccess->canModify() && !empty($listingrec ['MODIFY_FORM'])) {
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        if (count($idlist) > CLX_NUM_ONE) {
            $c = new htmlFormSubmit(dict('GEN_LBL_VIEWNEXT_SOMETHING', dict($tablerec ['RECORDNAME_SINGULAR'])), 'DISPLAY', $form->getProp(CLX_PROP_ID));
            $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => 'buttons', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();

		$formlistings = $this->getFormPanelListings($formcode);
        while ($formlistingrec = ClxCommon::$db->getNextRecord($formlistings)) {
			//pre($formlistingrec);
            $contents .= $UILG->buildPanel($formlistingrec, $record);
        }
        return $contents;
    }


    /**
     * Paints bread crumbs
     *
     * @return string
     */
    function makeBreadCrumbs() {
        //desde interfaz
        return makeBreadCrumbs();
    }

    /**
     * Validates if record exists
     * @param string $field_label
     * @param string $field_value
     * @param array $msg
     * @return bool
     */
    function recordExists($field_label, &$field_value, &$msg = null) {
        //compatibilidad con clx_tools
        $tablerec = $field_label;
        $recordid = $field_value;
        $values = (!empty($recordid)) ? ClxCommon::$db->oneExistsRecords($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'], 'ID IN (' . $recordid . ')') : CLX_INIT_ZERO;
        return ($values > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Loads record base on input.
     * if no query provided it will use tablecode
     *
     * @param string $tablecode
     * @param string $querycode
     * @param int $recordid
     * @param array $msg
     * @return array
     */
    function loadRecordFill($tablecode, $querycode, $recordid, &$msg) {
        if (empty($querycode)) { // load from record
			$tablename = tableName($tablecode);
            $values = ClxCommon::$db->getRecord($tablename, 'ID=' . singleQuote($recordid));
        } else { // load from query
		    $DBQY = &getTool('DBQY');
            $efftstatus = $DBQY->get_efftdate_status();
            $DBQY->set_efftdate_status(false);
            $query = $DBQY->getquery('EDIT', $querycode);
            $DBQY->set_efftdate_status($efftstatus);
			
            if (strpos('*', $query ['SELECTCLAUSE']) === false) {
                $query ['SELECTCLAUSE'] .= ', `' . $tablecode . '`.* ';
            }
            $sql = (!empty($query ['SELECTCLAUSE'])) ? 'SELECT ' . $query ['SELECTCLAUSE'] : '';
            $sql .= (!empty($query ['FROMCLAUSE'])) ? ' FROM ' . $query ['FROMCLAUSE'] : '';
            $sql .= (!empty($query ['WHERECLAUSE'])) ? ' WHERE (' . $query ['WHERECLAUSE'] . ') AND ' . $tablecode . '.ID = ' . singleQuote($recordid) . ' ' : ' WHERE ' . $tablecode . '.ID = ' . singleQuote($recordid) . ' ';
            $sql .= (!empty($query ['GROUPCLAUSE'])) ? ' GROUP BY ' . $query ['GROUPCLAUSE'] : '';
            $sql .= (!empty($query ['ORDERCLAUSE'])) ? ' ORDER BY ' . $query ['ORDERCLAUSE'] : '';
			
			//agregado para despliegue desde el listado, los campos se llenen en expresiones de criteria. Usuario, date, languaje
			$sql = str_replace('!CURDATE', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT']), $sql);
			$sql = str_replace('!CURTIME', xFormat::getNow('H:i:s'), $sql);
			$sql = str_replace('!CURUSER', $_SESSION['user_record']['username'], $sql);
			$sql = str_replace('!CURRENT_DATE', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT']), $sql);
			$sql = str_replace('!CURRENT_TIME', xFormat::getNow('H:i:s'), $sql);
			$sql = str_replace('!CURRENT_DATETIME', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'].' H:i:s'), $sql);
			$sql = str_replace('!CURRENT_USERNAME', $_SESSION['user_record']['username'], $sql);
			$sql = str_replace('!CURRENT_LANGUAGE', getCurrentLanguage(), $sql);
            $values = ClxCommon::$db->getOneRecord($sql);
        }
        $norecordfound = false;
        if (empty($values)) { // set for dynamic relation record. on link related
            // table is empty what drops warning.
            $values = array();
            $norecordfound = true;
        }
        unset($query, $sql);
        $DBTB = &getTool('DBTB');
        // Loading record from post
        $record = array();
        $record [$tablecode . '_ID'] = $recordid;
        $fields = $DBTB->getTableAllFields($tablecode);
        $fieldrecs = array();
        $field_names = array();
        $field_fullnames = array();
		//echo ">>>", $recordid;
		//pre($fields);
        foreach ($fields as $key => $fieldrec) {
            if ($fieldrec ['ISWRK_FLD'] == CLX_NUM_ONE) { // Setting derived fields
                if (array_key_exists($tablecode . '_' . $fieldrec['FIELDNAME'] . '_WRK', $values)) {
                    $values [$fieldrec['FIELDNAME']] = $values [$tablecode . '_' . $fieldrec['FIELDNAME'] . '_WRK'];
                } else {
                    $values [$fieldrec['FIELDNAME']] = '';
                }
            } else {
                if (array_key_exists($tablecode . '_' . $fieldrec['FIELDNAME'], $values)) {
                    $values [$fieldrec['FIELDNAME']] = $values [$tablecode . '_' . $fieldrec['FIELDNAME']];
                }
            }
            // adding in case of dinamic link where record do not exists
            if ($norecordfound === true && !array_key_exists($tablecode . '_' . $fieldrec['FIELDNAME'], $values)) {
                $values [$fieldrec['FIELDNAME']] = '';
            }
            // loading on record
            $fieldinstance = getToolObject('DBFT', $fieldrec ['FIELDTYPE']);
            $fieldinstance->loadField($tablecode . '_' . $fieldrec['FIELDNAME'], $fieldrec, $record, $values);
            $fieldrecs [$fieldrec['FIELDNAME']] = $fieldrec;
            $field_names [] = '!' . $fieldrec['FIELDNAME'];
            $field_fullnames [] = '\$record[' . singleQuote($tablecode . '_' . $fieldrec['FIELDNAME']) . ']';
        }
        // Executing Formula
        $this->executeFieldFormulas($fieldrecs, $tablecode . '_', $field_names, $field_fullnames, $record);
        $tablerec = $DBTB->getTable($tablecode);
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'LREC', $record, $msg); // Load
        // Record
        $ACAD = &getTool('ACAD');
        $ACAD->log($tablerec, $recordid, 'LOAD_REC', $tablerec ['IDNAME'], $record);
        return $record;
    }

    /**
     * Record builder
     *
     * @param integer $id
     * @return array
     */
    function loadRecord_($tablerec, $recordid = '', $subform = false) {
        //Compatibilidad con clx_tools
        $msg = array();
        $listingcode = (!empty(UserRequest::$request ['li'])) ? UserRequest::$request ['li'] : '';
        if ($listingcode !== '') {
            if (empty($subform)) {
                $querycode = ClxCommon::$db->getField('CLX_UI_LISTINGS', 'QUERYCODE', 'IDCODE = ' . singleQuote($listingcode));
            } else {
                $querycode = '';
            }
        } else {
            $querycode = '';
        }
        $record = $this->loadRecordFill($tablerec ['IDCODE'], $querycode, $recordid, $msg);
        $relrecord = $this->loadRelationRecord($tablerec ['IDCODE'], $recordid, $msg);
	//	pre($relrecord);
        if (!empty($relrecord)) {
            $record = array_merge($record, $relrecord);
        } //pre ($record);
        return $record;
    }

    /**
     * Prepares record from form
     *
     * @param array $formrec
     * @param array $tablerec
     * @param integer $recordid
     * @return array:
     */
    function prepareRecord($formrec, $tablerec, $recordid) {
        $formcode = (!empty($formrec ['IDCODE'])) ? $formrec ['IDCODE'] : '';
        $tablecode = $tablerec ['IDCODE'];
        $record = array();
        //get field from table
        $sql = 'SELECT FM.TABLECODE, F.*, PF.FIELD_REQUIRED FIELD_FORM_REQUIRED, PF.FIELD_HIDDEN FIELD_FORM_HIDDEN FROM CLX_UI_FORMS FM, CLX_DB_TABLEFIELDS TF, CLX_DB_FIELDS F, CLX_UI_FORM_PANELS FP, CLX_UI_FORM_PANEL_FIELDS PF WHERE FM.IDCODE=' . singleQuote($formcode) . ' AND TF.TABLECODE = FM.TABLECODE AND F.FIELDNAME = TF.FIELDNAME AND FP.FORMCODE = FM.IDCODE AND PF.PANELID = FP.IDCODE AND FP.FORMCODE = FM.IDCODE AND PF.FIELDNAME = TF.FIELDNAME AND FP.ACTIVE = 1 AND PF.ACTIVE = 1 UNION ALL /*PANEL FORM OBJECTS*/ SELECT PF.TABLECODE, F.*,  PF.FIELD_REQUIRED FIELD_FORM_REQUIRED, PF.FIELD_HIDDEN FIELD_FORM_HIDDEN FROM CLX_UI_FORM_PANELS FP1, CLX_UI_FORMS FM, CLX_DB_TABLEFIELDS TF, CLX_DB_FIELDS F, CLX_UI_FORM_PANELS FP, CLX_UI_FORM_PANEL_FIELDS PF WHERE FP1.FORMCODE = ' . singleQuote($formcode) . ' AND FM.IDCODE = FP1.FORM_OBJ_CODE AND TF.TABLECODE =PF.TABLECODE AND F.FIELDNAME = TF.FIELDNAME AND FP.FORMCODE = FM.IDCODE AND PF.PANELID = FP.IDCODE AND FP.FORMCODE = FM.IDCODE AND PF.FIELDNAME = TF.FIELDNAME AND FP.ACTIVE = 1 AND PF.ACTIVE = 1';
        $fields = ClxCommon::$db->executeQuery($sql);
        $fieldrecs = array();
        $field_names = array();
        $field_fullnames = array();
        while ($fieldrec = ClxCommon::$db->getNextRecord($fields)) {
            if ($fieldrec['FIELDNAME'] !== 'ID') {
                $fieldinstance = getToolObject('DBFT', $fieldrec ['FIELDTYPE']);
                $fieldinstance->saveField($tablecode . '_' . $fieldrec['FIELDNAME'], $fieldrec, $record, $recordid);
                $fieldrecs [$fieldrec['FIELDNAME']] = $fieldrec;
                $field_names [] = '!' . $fieldrec['FIELDNAME'];
                $field_fullnames [] = '\$record[' . singleQuote($fieldrec['FIELDNAME']) . ']';
            }
        }
		if ($this->debug==true) {
			
			echo "prepareRecord ";
			pre($field_fullnames);
			pre($fieldrec);
			ECHO $sql;
			
		}
        $this->executeFieldFormulas($fieldrecs, '', $field_names, $field_fullnames, $record);   // 2017-10-25-CR-Debe ser sin el nombre de la tabla
        return $record;
    }

    // Authotization Methods

     /**
     * Describes autorization
     * @global type $db
     * @param array $record
     * @return type
     */
    function describeAuthorizationSummary(&$record) {
        global $db;

        if(!array_key_exists('AUTH_DETAILS_WRK',  $record) || !empty($record['AUTH_AUTH_BATCH_ID'])){
            return;
        }

        $id = $record['AUTH_ID'];
        $data = ClxCommon::$db->getFields('CLX_AC_AUTHORIZATIONS', 'OLD_RECORD,TABLECODE', 'ID = '.$id);
        if(empty($data['OLD_RECORD'])){
            return;
        }
        $old_record = unserialize($data['OLD_RECORD']);
        $tablecode = $data['TABLECODE'];

        unset($old_record['ID']); $i = 0; $ret = ''; $break = '';
        $DBFL = &getTool('DBFL');
        foreach($old_record as $fieldname=>$val){
            if($fieldname =='ID') continue;
            $field = $DBFL->getField($fieldname);
            $DBFT = getToolObject('DBFT', $field ['FIELDTYPE']);
            $val = $DBFT->formatField($tablecode . '_' . $fieldname, $field, array($tablecode . '_' . $fieldname=>$val));
            $ret .= $break.'<b>' . dict($field['FIELDLISTLABEL']). '</b>: ' . strip_tags($val);
            $break = '<br>';
            $i++;
            if($i==4) break;
        }
        $record['AUTH_DETAILS_WRK'] = $ret;
    }


    /**
     * Autorization method
     * @param type $record
     */
    function describeAuthorization(&$record) {
        $record ['AUTH_COMMENTS'] = '';
        $record ['AUTH_DETAILS'] = '';
        if(!empty($record['AUTH_AUTH_BATCH_ID'])){
            $record ['AUTH_COMMENTS'] = '<b>'.dict('GEN_LBL_BATCH_AUTHORIZATION').'</b><br>';
            $record ['AUTH_COMMENTS'] .= '<b>'.dict('GEN_LBL_BATCH_ID').':</b> '.$record['AUTH_AUTH_BATCH_ID'];
            $UILG = &getTool('UILG');
            $listingrec = $UILG->getToolRecord($record['AUTH_AUTH_LISTING'], '');
            if(!empty($listingrec['AUTH_BTCH_FILDSUM'])){
                $DBFL = getTool('DBFL');
                $field = $DBFL->getField($listingrec['AUTH_BTCH_FILDSUM']);
                $totals = ClxCommon::$db->getOneRecord('SELECT SUM('.$listingrec['AUTH_BTCH_FILDSUM'].') SM, COUNT('.$listingrec['AUTH_BTCH_FILDSUM'].') QY FROM '.tablename($record['AUTH_TABLECODE']).' WHERE '.$listingrec['AUTH_BTCH_FILD'].' = '.singleQuote($record['AUTH_AUTH_BATCH_ID']));
                if(!empty($totals)){
                    $record ['AUTH_COMMENTS'] .= '<br><b>'.dict($field['FIELDLISTLABEL']).'('.dict('GEN_LBL_TOTAL_OPERATION').'):</b> '.$totals['SM'];
                    $record ['AUTH_COMMENTS'] .= '<br><b>'.dict('GEN_LBL_NO_ROWS').':</b> '.$totals['QY'];
                }
            }
            $record ['AUTH_COMMENTS'] .= '<br><i>'.dict('GEN_LBL_BATCH_AUTH_DET_DISCL').'</i><br>';
        }
        $old_record = unserialize($record ['AUTH_OLD_RECORD']);
        $new_record = unserialize($record ['AUTH_NEW_RECORD']);
        if (empty($old_record))
            $old_record = array();
        if (empty($new_record))
            $new_record = array();
        $tablecode = $record ['AUTH_TABLECODE'];
        $excludekeys = array($tablecode . '_ID', 'ID', CLX_PROP_ID, CLX_PROP_TO, 'masive_selector', 'qy', 'ac', 'fm', 'confirm', 'idlist', 'clxtx_id', 'li', 'submit', 'dbn', 'skn', 'lan', 'clientix_MenuBar_option', 'PHPSESSID');
        foreach ($excludekeys as $key) {
            unset($new_record [$key], $old_record [$key]);
        }
        // describe record information
        foreach ($old_record as $key => $val) {
            $fieldname = '';
            $key = str_ireplace($tablecode . '_', '', $key);
            $key_nolook = str_ireplace('_prim', '', $key);
            $key_nolook = str_ireplace('_secd', '', $key_nolook);
            $key_nolook = str_ireplace('_terc', '', $key_nolook);
            if (strpos($key, '_prim') !== false || strpos($key, '_secd') !== false || strpos($key, '_terc') !== false || strlen($val) == CLX_NUM_ZERO ||
                    strpos($key, '_prim') !== false || strpos($key, '_secd') !== false || strpos($key, '_terc') !== false)
                continue;
            $field = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($key_nolook));
            if (!empty($field ['FIELDTYPE'])) {
                $DBFT = getToolObject('DBFT', $field ['FIELDTYPE']);
                $val = $DBFT->formatField($tablecode . '_' . $key, $field, array($tablecode . '_' . $key => $old_record [$key_nolook]
                ));
                $fieldname = $field ['FIELDFORMLABEL'];
            }
            $fieldname = (trim($fieldname) === '') ? $key : dict($fieldname);
            $record ['AUTH_DETAILS'] .= '<b>' . $fieldname . '</b>: ' . strip_tags($val) . '<br>';
        }
        // describe change
        foreach ($new_record as $key => $val) {
            if (strpos($key, '_prim') !== false || strpos($key, '_secd') !== false || strpos($key, '_terc') !== false)
                continue;
            $fieldname = '';
            $key = str_ireplace($tablecode . '_', '', $key);
            $key_nolook = str_ireplace('_prim', '', $key);
            $key_nolook = str_ireplace('_secd', '', $key_nolook);
            $key_nolook = str_ireplace('_terc', '', $key_nolook);
            if (strpos($key, '_prim') !== false || strpos($key, '_secd') !== false || strpos($key, '_terc') !== false ||
                    !array_key_exists($key_nolook, $old_record) || $old_record [$key_nolook] == $val)
                continue;
            $field = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($key_nolook));
            if (!empty($field ['FIELDTYPE'])) {
                $DBFT = getToolObject('DBFT', $field ['FIELDTYPE']);
                $val = singleQuote($DBFT->formatField($tablecode . '_' . $key, $field, array($tablecode . '_' . $key => $old_record [$key_nolook]
                )));
                $val .= ' -> ' . singleQuote($DBFT->formatField($tablecode . '_' . $key, $field, $new_record));
                $fieldname = $field ['FIELDFORMLABEL'];
            }
            $fieldname = (trim($fieldname) === '') ? $key : dict($fieldname);
            $record ['AUTH_COMMENTS'] .= $fieldname . ': ' . strip_tags($val) . '<br>';
        }
        if ($record ['AUTH_COMMENTS'] === '')
            $record ['AUTH_COMMENTS'] = dict('GEN_LBL_NOCHANGE');
    }

    /**
     *
     * @param unknown_type $msg
     * @param unknown_type $record
     */
    function validateAuthorization(&$msg, &$record) {
        if ($record ['AUTH_CREATEDBY'] == $_SESSION ['user_record'] ['username']) {
            $msg ['AUTH_REC_EVENT'] = dict('GEN_ERR_CANNOTAUTHORIZE');
        }
        if (empty($record ['AUTH_ID'])) {
            $record ['AUTH_ID'] = CLX_INIT_ZERO;
        }
        if ($record ['AUTH_AUTH_STATUS'] === 'PEAP') {
            $msg ['AUTH_AUTH_STATUS'] = dict('GEN_ERR_STATUSINVALID');
        }

        if (ClxCommon::$db->oneExistsRecords('CLX_AC_AUTHORIZATIONS', 'AUTH_STATUS <> ' . singleQuote('PEND') . ' AND ID=' . $record ['AUTH_ID']) > CLX_NUM_ZERO) {
            $msg ['AUTH_AUTH_STATUS'] = dict('GEN_ERR_NOTPENDING');
        }
	
    }

    /**
     * Executes events previous authorization
     */
    function authPreEvent(&$msg, &$record, &$formrec) {
        /*
         * do not validate more if message exists means that Previous record
         * validation already fail.
         */
        if (!empty($msg)) {
            return;
        }
        $tablecode = $formrec ['TABLECODE'];
        $tablerecid = ClxCommon::$db->getField('CLX_DB_TABLES', 'ID', 'IDCODE = ' . singleQuote($tablecode));
        if (!$this->requireAuthorization($tablecode)) {
            return;
        }
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('DBTB', $tablerecid, 'AREC', $record, $msg); // Update
    }

    /**
     * Events that occurs post autorization
     *
     * @param array $record
     * @param array $auth_rec
     * @param string $status
     */
    function authPostEvent(&$record, &$auth_rec, $status) {
        $tablecode = $auth_rec ['TABLECODE'];
        if (!$this->requireAuthorization($tablecode))
            return;
        $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($tablecode));
        $msg = array();
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('DBTB', $tablerec ['ID'], ($status === 'AP') ? 'AREP' : 'ARRP', $record, $msg); // Update
    }

    /**
     *
     * @param unknown_type $tablecode
     * @return boolean
     */
    function requireAuthorization($tablecode) {
        // Verify if exists clx_efftdate
        if (!empty($tablecode)) {
            $this->clx_auth_status = ClxCommon::$db->fieldExists(tableName($tablecode), 'CLX_AUTH_STATUS');
        } else {
            $this->clx_auth_status = false;
        }
        return $this->clx_auth_status;
    }

    /**
     * Request authorization batch
     * @param type $ac
     * @param type $formrec
     * @param type $tablerec
     */
    function requestAuthorizationBatch($ac, &$formrec, &$tablerec) {

        return $this->requestAuthorizationMult($ac, $formrec, $tablerec);
    }

    /**
     *
     * @param unknown_type $ac
     * @param unknown_type $formrec
     * @param unknown_type $tablerec
     * @return boolean
     */
    function requestAuthorizationMult($ac, &$formrec, &$tablerec) {
        $return = false;
        $old_post = UserRequest::$post; // save request
        $idlist = getIdlist();
        foreach ($idlist as $val) {
            UserRequest::$post [$tablerec ['IDCODE'] . '_ID'] = $val;
            $status = $this->requestAuthorization($ac, $formrec, $tablerec);
            if (!empty($status))
                $return = $status;
        }
        UserRequest::$post = $old_post; // retore request
        return $return;
    }

    /**
     *
     * @param unknown_type $ac
     * @param unknown_type $formrec
     * @param unknown_type $tablerec
     * @return boolean
     */
    function requestAuthorization($ac, &$formrec, &$tablerec) {
        $tablecode = $tablerec ['IDCODE'];

        if (!$this->requireAuthorization($tablecode)) {
            return false;
        }
        $recordid = UserRequest::$post [$tablecode . '_ID'];
        $record = ClxCommon::$db->getRecord($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'], 'ID=' . $recordid);
		
        if (empty($record)) {
            return true;
        }
		else if ($record['CLX_AUTH_STATUS'] =='PEAP'){ 
			return true;
		}
        $auth_batch_id = 'null';
        $auth_listing = 'null';
        $isbatch = false;
        if (UserRequest::$request ['ac'] == 'REQAUTHORIZATIONBATCH') {
            $UILG = &getTool('UILG');
            $listingrec = $UILG->getToolRecord(UserRequest::$post['li'], '');
            $isbatch = true;
            $auth_batch_id = (array_key_exists($listingrec['AUTH_BTCH_FILD'], $record)) ? $record[$listingrec['AUTH_BTCH_FILD']] : 'null';
            $auth_listing = $listingrec['IDCODE'];
             if(empty($auth_batch_id) || $auth_batch_id=='null'){
                 return false;
             }
        }

        if ($ac !== 'CREATE' && ClxCommon::$db->oneExistsRecords($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'], 'CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND ID = ' . $recordid) > CLX_NUM_ZERO) {
            return false;
        }


        // Pre authorization events
        if (UserRequest::$request ['ac'] === 'REQAUTHORIZATION') {
            $form_record = array();
            foreach ($record as $key => $val) {
                $form_record [$tablerec ['IDCODE'] . '_' . $key] = $val;
            }
            $msg = array();
            $this->authPreEvent($msg, $form_record, $formrec);
            if (!empty($msg)) { // means error
                addMessage($msg);
                return false;
            }
            unset($form_record);
        }

        //Evento por cada una de las autorizaciones
        if (UserRequest::$request ['ac'] == 'REQAUTHORIZATIONBATCH') {

            UserRequest::$request['ac'] = UserRequest::$post ['ac'] = 'REQAUTHORIZATION';
            $sql = 'SELECT * '
                    . 'FROM ' . $tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'] . ' '
                    . 'WHERE ((' . singleQuote('CREATE') . '=' . singleQuote($ac) . ' AND CLX_AUTH_STATUS = ' . singleQuote('PEND') . ') OR CLX_AUTH_STATUS<>' . singleQuote('PEND') . ') AND ' . $listingrec['AUTH_BTCH_FILD'] . ' = ' . singleQuote($auth_batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs)) {
                $form_record = array();
                foreach ($r as $key => $val) {
                    $form_record [$tablerec ['IDCODE'] . '_' . $key] = $val;
                }
                $msg = array();
                $this->authPreEvent($msg, $form_record, $formrec);
                if (!empty($msg)) { // means error
                    addMessage($msg);
                    return false;
                }
            }
            unset($form_record);
            UserRequest::$request['ac'] = UserRequest::$post ['ac'] = 'REQAUTHORIZATIONBATCH';
        }



        $d = xFormat::getNow('Y-m-d h:i:s');

        $rec = array('REC_EVENT' => $ac,
            'AUTH_STATUS' => 'PEND',
            'EVENT_NAME' => dict($tablerec ['RECORDNAME_SINGULAR']),
            'TABLECODE' => $tablerec ['IDCODE'],
            'FORMCODE' => $formrec ['IDCODE'],
            'REC_ID' => $recordid,
            'OLD_RECORD' => serialize($record),
            'NEW_RECORD' => serialize(UserRequest::$request),
            'OBSERVATION' => 'null',
            'CDATE' => $d,
            'MDATE' => $d,
            'CREATEDBY' => $_SESSION ['user_record'] ['username'],
            'MODIFIEDBY' => $_SESSION ['user_record'] ['username'],
            'COMP_CODE' => (array_key_exists('COMP_CODE', $record)) ? $record['COMP_CODE'] : 'null',
            'AUTH_BATCH_ID' => $auth_batch_id,
            'AUTH_LISTING' => $auth_listing
        );

        if (ClxCommon::$db->oneExistsRecords('CLX_AC_AUTHORIZATIONS', 'TABLECODE=' . singleQuote($rec ['TABLECODE']) . ' AND REC_ID=' . singleQuote($rec ['REC_ID']) . ' AND CREATEDBY=' . singleQuote($rec ['CREATEDBY']) . ' AND AUTH_STATUS=' . singleQuote('PEND')) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord('CLX_AC_AUTHORIZATIONS', $rec, 'TABLECODE=' . singleQuote($rec ['TABLECODE']) . ' AND REC_ID=' . singleQuote($rec ['REC_ID']) . ' AND CREATEDBY=' . singleQuote($rec ['CREATEDBY']) . ' AND AUTH_STATUS=' . singleQuote('PEND'));
        } else {
            ClxCommon::$db->createRecord('CLX_AC_AUTHORIZATIONS', $rec, false);
        }
        // Set clx_auth_status field
		$tablename=$tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'];
        if ($isbatch) {
            ClxCommon::$db->updateRecord($tablename, array('CLX_AUTH_STATUS' => 'PEAP'), '((' . singleQuote('CREATE') . '=' . singleQuote($ac) . ' AND CLX_AUTH_STATUS = ' . singleQuote('PEND') . ') OR CLX_AUTH_STATUS<>' . singleQuote('PEND') . ') AND ' . $listingrec['AUTH_BTCH_FILD'] . ' = ' . singleQuote($auth_batch_id));
        } else {
            ClxCommon::$db->updateRecord($tablename, array('CLX_AUTH_STATUS' => 'PEAP'), '((' . singleQuote('CREATE') . '=' . singleQuote($ac) . ' AND CLX_AUTH_STATUS = ' . singleQuote('PEND') . ') OR CLX_AUTH_STATUS<>' . singleQuote('PEND') . ') AND ID = ' . $recordid);
        }
		
        // if Administrador then can authorize
        $sql = 'SELECT COUNT(ACTB.ISADMIN) FROM CLX_AC_TABLES ACTB LEFT JOIN CLX_AC_GROUP_MEMBERS ACGM ON ACGM.GROUPCODE = ACTB.OWNERREF AND ACTB.OWNERCODE = ' . singleQuote('GRUP') . ' WHERE ACTB.TABLECODE = ' . singleQuote($rec ['TABLECODE']) . ' AND ACTB.ISADMIN = 1 AND ((ACTB.OWNERCODE = ' . singleQuote('USER') . ' AND ACTB.OWNERREF = ' . singleQuote($_SESSION ['user_record'] ['username']) . ') OR (ACTB.OWNERCODE = ' . singleQuote('GRUP') . ' AND ACGM.USERNAME = ' . singleQuote($_SESSION ['user_record'] ['username']) . '))';
        if (!empty($_SESSION ['user_record']['isadmin']) || ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $authid = ClxCommon::$db->getField('CLX_AC_AUTHORIZATIONS', 'ID', 'TABLECODE=' . singleQuote($rec ['TABLECODE']) . ' AND REC_ID=' . singleQuote($rec ['REC_ID']) . ' AND AUTH_STATUS=' . singleQuote('PEND'));
            $this->processAuthorization('AP', array($authid), true);
        }
		apc_clear_xppaging_count($rec ['TABLECODE']);
        return true;
    }

    /**
     * Method called when authorization is accepted
     * @param unknown_type $status
     * @param unknown_type $auth_id
     * @param unknown_type $allow_self
     */
    function processAuthorization($status, $auth_id = array(), $allow_self = false) {
        if (!empty($auth_id)) {
            $idlist = $auth_id;
        } else {
            if (!empty(UserRequest::$post ['fm']) && UserRequest::$post ['fm'] = 'AUTH') {
                $idlist = array(UserRequest::$post ['AUTH_ID']);
            } else {
                $idlist = getIdlist();
            }
        }

        foreach ($idlist as $val) {

            if (empty($val)) {
                continue;
            }

            $auth_rec = ClxCommon::$db->getRecord('CLX_AC_AUTHORIZATIONS', 'ID=' . $val);
            if (!$allow_self && $auth_rec ['CREATEDBY'] == $_SESSION ['user_record'] ['username']) {
                addMessage(dict('GEN_ERR_CANNOTAUTHORIZE'));
                // 2016-04-05 No puede autorizar este registro. Detiene la secuencia para evitar que de error por no poner el nombre de la tabla
                continue;
            } else {
                $taccess = $this->getAppAccess($auth_rec['TABLECODE'], true);
                if (!$taccess->canModify() && !$taccess->canAppend()) {
                    addMessage(dict('GEN_LBL_NO_ACCESS_TO_AUTH_TBL', $auth_rec['TABLECODE']));
                    // 2016-04-05 No tiene acceso a esta tabla. Detiene la secuencia para evitar que de error por no poner el nombre de la tabla
                    continue;
                } else {
                    //Validate thata user has access
                    $tablename = tableName($auth_rec ['TABLECODE']);
                }

                // if not pending for approval just continue
                if (ClxCommon::$db->oneExistsRecords($tablename, 'CLX_AUTH_STATUS=' . singleQuote('PEAP') . ' AND ID=' . $auth_rec ['REC_ID']) == CLX_NUM_ZERO) {
                    $current_status = ClxCommon::$db->getField($tablename, 'CLX_AUTH_STATUS', 'ID=' . $auth_rec ['REC_ID']);
					if ($current_status === 'AP' ) {
                        $rec = array('AUTH_STATUS' => 'AP', 'MDATE' => xFormat::getNow('Y-m-d H:i:s'), 'MODIFIEDBY' => $_SESSION ['user_record'] ['username']);
                        ClxCommon::$db->updateRecord('CLX_AC_AUTHORIZATIONS', $rec, 'ID=' . $val);
                    } else {
                        $rec = array('AUTH_STATUS' => 'REJ', 'MDATE' => xFormat::getNow('Y-m-d H:i:s'), 'MODIFIEDBY' => $_SESSION ['user_record'] ['username']);
                        ClxCommon::$db->updateRecord('CLX_AC_AUTHORIZATIONS', $rec, 'ID=' . $val);
                    }
                } else {
                    $rec = array('AUTH_STATUS' => $status, 'MDATE' => xFormat::getNow('Y-m-d H:i:s'), 'MODIFIEDBY' => $_SESSION ['user_record'] ['username']);
                    ClxCommon::$db->updateRecord('CLX_AC_AUTHORIZATIONS', $rec, 'ID=' . $val);

                    //caso 1004921
                    $check_record = unserialize($auth_rec ['OLD_RECORD']);
                    if($status === 'AP' && $auth_rec['TABLECODE'] == 'FICO' && $check_record['CLX_AUTH_STATUS'] == 'REJ' && $check_record['CONTRACT_STATUS'] == 'NEG' && $auth_rec ['REC_EVENT'] == 'MODIFY')
                        $auth_rec ['REC_EVENT'] = 'CREATE';
                    //fin caso 1004921

                    if ($auth_rec ['REC_EVENT'] !== 'CREATE' && $status === 'AP') {
                        if ($auth_rec ['REC_EVENT'] === 'DELETE') {
                            $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($auth_rec ['TABLECODE']));
                            $this->deleteRecord_($tablerec, $auth_rec ['REC_ID']);
                            $formrec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($auth_rec ['FORMCODE']));
                            $record = unserialize($auth_rec ['NEW_RECORD']);
                            $this->authPostEvent($record, $auth_rec, $status);
                            ClxCommon::$db->updateRecord($tablename, array('CLX_AUTH_STATUS' => 'AP'), 'ID=' . $auth_rec ['REC_ID']);
							apc_clear_xppaging_count($auth_rec ['TABLECODE']);
						} else { // else delete
                            // Save Current Post to be restored latter
                            $current_post = UserRequest::$post;
                            // do the update

                            UserRequest::$post = unserialize($auth_rec ['NEW_RECORD']);
                            UserRequest::$post [$auth_rec ['TABLECODE'] . '_ID'] = $auth_rec ['REC_ID'];
                            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($auth_rec ['FORMCODE']));
                            $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($auth_rec ['TABLECODE']));
                            $sql = 'SELECT X.FIELDNAME ' . 'FROM CLX_DB_TABLEFIELDS X, CLX_DB_FIELDS F ' . ' WHERE X.FIELDNAME = F.FIELDNAME AND F.FIELDTYPE = ' . singleQuote('LOOK') . ' ' . 'AND X.TABLECODE = ' . singleQuote($tablerec ['IDCODE']);
                            $lookups = ClxCommon::$db->executeQuery($sql);
                            while ($lookup = ClxCommon::$db->getNextRecord($lookups)) {
                                getLookupValue($tablerec ['IDCODE'] . '_' . $lookup ['FIELDNAME'], $lookup ['FIELDNAME'], UserRequest::$post);
                            }
                            ClxFreeReturn($this->saveRecord($formrec, $tablerec));
                            $this->authPostEvent(UserRequest::$post, $auth_rec, $status);
                            UserRequest::$post = $current_post;
                            ClxCommon::$db->updateRecord($tablename, array('CLX_AUTH_STATUS' => 'AP'), 'ID=' . $auth_rec ['REC_ID']);
                        } // end if delete
                        // May send notifications?
                    } else {
                        // If create and status <> ap rej then just reject
                        if (!empty($auth_rec['AUTH_BATCH_ID']) && $auth_rec['AUTH_BATCH_ID']<>'NULL') {
                            //Batch case
                            $UILG = &getTool('UILG');
                            $listingrec = $UILG->getToolRecord($auth_rec['AUTH_LISTING'], '');
                            $sql = 'SELECT * FROM ' . $tablename . ' WHERE ' . $listingrec['AUTH_BTCH_FILD'] . ' = ' . singleQuote($auth_rec['AUTH_BATCH_ID']) . ' AND CLX_AUTH_STATUS = ' . singleQuote('PEAP');
                            $rs = ClxCommon::$db->executeQuery($sql);
                            while ($record = ClxCommon::$db->getNextRecord($rs)) {
                                $db->updateRecord($tablename, array('CLX_AUTH_STATUS' => $status), "ID=" . $record['ID']);
                                $this->authPostEvent($record, $auth_rec, $status);
                            }
                        } else {
                            // If create and status <> ap rej then just reject
                            ClxCommon::$db->updateRecord($tablename, array('CLX_AUTH_STATUS' => $status), 'ID=' . $auth_rec ['REC_ID']);
                            $record = unserialize($auth_rec ['OLD_RECORD']);
                            $this->authPostEvent($record, $auth_rec, $status);
							
							//EC 21-01-2020 
							// Aqui va la asignacion de codigo NCF para la factura o Nota de Debito o Credito

							if ($status==='AP'&&$tablename==='BILL_INVOICE'){
								$comp_code=ClxCommon::$db->getField($tablename, 'COMP_CODE', 'ID=' . $auth_rec ['REC_ID']);
								if(companyParameter('INVO_ASSIG_NCF', $comp_code) == 1){
									//obtengo el tipo de comprobante fiscal de la factura
									$taxrcpt_type = ClxCommon::$db->getField($tablename, 'TAXRCPT_TYPE', 'ID=' . $auth_rec ['REC_ID']);
									$sql = 'SELECT TXRT.ID, TXRT.TAXRCPT_TYPE, TXRT.TAXRCPT_NEXTSEQ, TXRT.TAXRCPT_FINALSEQ, TXRT.TAXRCPT_ASIGN FROM BILL_TAXRCPTSEQ_TBL TXRT WHERE TXRT.TAXRCPT_TYPE = '.singleQuote($taxrcpt_type). ' AND TXRT.TAXRCPT_FINALSEQ>TXRT.TAXRCPT_ASIGN AND  TXRT.TAXRCPT_EXPDATE>= ' . singleQuote($this->today) . ' ORDER BY ID ASC LIMIT 1';

									//busco la secuencia asociada al tipo de comprobante fiscal y obtengo el ultimo NCF asignado
									//$ncfinvo = ClxCommon::$db->getFields('BILL_TAXRCPTSEQ_TBL', 'TAXRCPT_NEXTSEQ, TAXRCPT_ASIGN', 'TAXRCPT_TYPE = ' . singleQuote($taxrcpt_type));
									$ncfinvo = ClxCommon::$db->getOneRecord($sql);

									if ($ncfinvo['TAXRCPT_ASIGN']==='00000000'){
										$ncfinvo['TAXRCPT_ASIGN']=$ncfinvo['TAXRCPT_NEXTSEQ'];
									}else{
										$ncfinvo['TAXRCPT_ASIGN']=str_pad($ncfinvo['TAXRCPT_ASIGN']+1, 8, '0', STR_PAD_LEFT); //incremento NCF para obtener el disponible
									}

									if (!is_null($ncfinvo['TAXRCPT_ASIGN'])){
										 //Asigno NCF 
										ClxCommon::$db->updateRecord($tablename, array('TAXRCPT_NO' => $ncfinvo['TAXRCPT_ASIGN']), 'ID=' . $auth_rec ['REC_ID']);

										//guardo el ultimo NCF asignado usando el ID de la secuencia ncf
										ClxCommon::$db->updateRecord('BILL_TAXRCPTSEQ_TBL', array('TAXRCPT_ASIGN' => $ncfinvo['TAXRCPT_ASIGN']), 'ID=' . $ncfinvo['ID']);
									}
								}
							}
							
                        }
                    }
                }
            }
        }
    }

    /**
     * Present authorization form to describe rejections
     *
     * @param
     *        	$status
     */
    function promptAuthorizationDetails($status) {
        $idlist = getIdlist();
        if (!empty(UserRequest::$post ['confirm']) && array_key_exists($this->code . '_observation', UserRequest::$post)) {
            // store observation and continue
            ClxCommon::$db->updateRecord('CLX_AC_AUTHORIZATIONS', array('OBSERVATION' => UserRequest::$post [$this->code . '_observation']), 'ID IN (' . singleQuoteArray($idlist) . ')');
            $this->processAuthorization('REJ');
            $info = popHistory();
            return executeHistory($info);
        }
        $reject_fm = array(CLX_CLASS_TITLE => 'TOOL_AUTH_REJECT_REASON',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_OBSERVATION',
                            'fields' => array(
                                array('name' => 'observation',
                                    'type' => 'text',
                                    'default' => '',
                                    'cols' => '48',
                                    'rows' => '4'
                                )
                            )
                        )
                    )
                )
            )
        );
        $record = array($this->code . '_observation' => ((!empty(UserRequest::$post [$this->code . '_observation'])) ? UserRequest::$post [$this->code . '_observation'] : '')
        );
        $msg = array();
        $form = new clx_form($this->code, $reject_fm);
        return $form->editForm(UserRequest::$request['ac'], $idlist, $record, $msg);
    }

    /**
     * Saves Application Record
     *
     * @param array $formrec
     * @param array $tablerec
     * @param array $record
     * @return int
     */
    function saveRecord($formrec = '', $tablerec = '', $record = false) {
        $msg = null;
        $tablecode = $tablerec ['IDCODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        if (!$taccess->canModify()) {
            return CLX_NUM_ZERO; // no puede modificar
        }
        if (empty($record)) {
            $recordid = UserRequest::$post [$tablecode . '_ID'];
            $record = $this->prepareRecord($formrec, $tablerec, $recordid);
        } else {
            $recordid = $record ['ID'];
        }
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('UIFM', $formrec ['ID'], 'SAFO', $record, $msg); // Update
        // From
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'UREP', $record, $msg); // Update
        $record ['ID'] = $recordid;
        $this->updateChildRecords($tablerec ['IDCODE'], $record);
		$tablename=$tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'];
        ClxCommon::$db->updateRecord($tablename, $record, 'ID=' . $recordid);
        
			
		$EVNT->execute5('DBTB', $tablerec ['ID'], 'UREC', $record, $msg); // Update
        $ACAD = &getTool('ACAD');
        $ACAD->log($tablerec, $recordid, 'SAVE_REC', $tablerec ['IDNAME'], $record);
        // Creating link for dynamic relation
        ClxFreeReturn($this->saveRelationRecord($tablerec ['IDCODE'], $recordid, $msg));
        $this->http_set_tx('null');
		apc_clear_xppaging_count($tablecode);
        return $recordid;
    }

    /**
     * Create Application Record
     *
     * @param array $formrec
     * @param array $tablerec
     * @param array $record
     * @return int
     */
    function createRecordVoid($table, $record, $silent) {
        ClxFreeReturn($this->createRecord($table, $record, $silent));
    }

    function createRecord($formrec = '', $tablerec = '', $record = false) {
        $recordid = CLX_NUM_ZERO;
        $taccess = $this->getAppAccess($tablerec ['IDCODE'], true);
        if ($taccess->canAppend()) {
            $msg = null;
			if ($this->debug) {
				echo "edit createrecord variable record";
				pre($record);	
			}	
            if (empty($record)) {
                $record = $this->prepareRecord($formrec, $tablerec, CLX_NUM_ZERO);
            }
            $EVNT = &getTool('EVNT');
            $EVNT->execute5('UIFM', $formrec ['ID'], 'CRFO', $record, $msg); // Create
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREP', $record, $msg); // Create
            $recordid = ClxCommon::$db->createRecord($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'], $record, false);
            ClxCommon::$db->executequery('commit');
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREC', $record, $msg); // Create
            $record ['ID'] = $recordid;
            $ACAD = &getTool('ACAD');
            $ACAD->log($tablerec, $recordid, 'CREATE_REC', $tablerec ['IDNAME'], $record);
            // Creating link for dynamic relation
            ClxFreeReturn($this->saveRelationRecord($tablerec ['IDCODE'], $recordid, $msg));
            // Bp Module Save Create Result to task
            $this->bp_complete_task(true, $record, $tablerec ['IDCODE'], $recordid);
            $this->http_set_tx('null');
			ClxCommon::$db->executequery('commit');
			apc_clear_xppaging_count($tablerec['IDCODE']);
        }
        return $recordid;
    }

    /**
     * Duplicates Application Record
     *
     * @param array $formrec
     * @param array $tablerec
     */
    function duplicateRecord($formrec = '', $tablerec = '') {
        $msg = null;
        $record = $this->prepareRecord($formrec, $tablerec, CLX_NUM_ZERO);
        $tablecode = $tablerec ['IDCODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        if (!$taccess->canAppend()) {
            return CLX_NUM_ZERO; // no puede modificar
        }
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('UIFM', $formrec ['ID'], 'CRFO', $record, $msg); // Create
        // From
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREP', $record, $msg); // Create
        // Record Pre
        $recordid = ClxCommon::$db->createRecord($tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'], $record, false);
        //$EVNT->execute5('DBTB', $tablerec ['ID'], 'CREC', $record, $msg); // Create Record Post
        $record ['ID'] = $recordid;
        $ACAD = &getTool('ACAD');
        $ACAD->log($tablerec, $recordid, 'CREATE_REC', $tablerec ['IDNAME'], $record);
        // Creating link for dynamic relation
        ClxFreeReturn($this->saveRelationRecord($tablerec ['IDCODE'], $recordid, $msg));
        // Duplicating Relation Fields
        $this->duplicateChildRecords($tablerec ['IDCODE'], $record, UserRequest::$request ['dplid']);
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREC', $record, $msg); // Create Record Post
        $this->http_set_tx('null');
		apc_clear_xppaging_count($tablerec['IDCODE']);
        return $recordid;
    }

    // Dynamic Relation
    /**
     * Loads Relation Record for Related Form.
     *
     * @param string $child_tablecode
     * @param int $child_recordid
     * @param array $msg
     * @return array
     */
    function loadRelationRecord($child_tablecode, $child_recordid, &$msg) {//pre($child_recordid);
        $callinginfo = peekHistory();//pre($callinginfo);
        if (!empty($callinginfo ['parentrecord'] ['TABLECODE'])) {
            $parent_tablecode = $callinginfo ['parentrecord'] ['TABLECODE'];
        } else {
            $parent_tablecode = false;
        }
        if (!empty($callinginfo ['parentrecord'] [$parent_tablecode . '_ID'])) {
            $parent_recordid = $callinginfo ['parentrecord'] [$parent_tablecode . '_ID'];
        } else {
            $parent_recordid = false;
        }
        // test if parent of child exists or just return.
        if (empty($parent_tablecode) || empty($child_tablecode)) {
            return array();
        }
			
        //Lidiando con padre al desplegar el hijo
        if (UserRequest::$request['ac'] <> 'DISPLAY' && !empty($callinginfo['relpid']))
            $parent_recordid = $callinginfo['relpid'];
        $DBDR = &getTool('DBDR');
        $relrec = $DBDR->getRelationInfo($parent_tablecode, $child_tablecode);
		if (empty($relrec))
            return array();
        if ( $parent_recordid===$child_recordid ){
			$sql='SELECT CHILD_RECORDID FROM BASE_DYNAMIC_RELATIONS_MASTER WHERE CHILD_TABLECODE= '.singlequote($relrec ['CHILD_TABLECODE']).' AND PARENT_TABLECODE= '.singlequote($relrec ['PARENT_TABLECODE']). ' AND PARENT_RECORDID ='.$parent_recordid;
			$child_recordid=  ClxCommon::$db->getOne($sql);
		}
		 // no relation
        if ($relrec ['RELATION_TYPE'] == CLX_NUM_TWO) { // mn relation
            $sql = 'SELECT ' . $relrec ['REL_TABLECODE'] . '.ID FROM ' . $relrec ['PARENT_TABLENAME'] . ' ' . $relrec ['PARENT_TABLECODE'] . ', ' . $relrec ['CHILD_TABLENAME'] . ' ' . $relrec ['CHILD_TABLECODE'] . ', ' . $relrec ['REL_TABLENAME'] . ' ' . $relrec ['REL_TABLECODE'] . ' WHERE ' . $relrec ['PARENT_TABLECODE'] . '.ID = ' . $parent_recordid . ' AND ' . $relrec ['CHILD_TABLECODE'] . '.ID = ' . $child_recordid;
            foreach ($relrec ['RELATIONS'] as $key => $val) {
                $sql .= ' AND ' . $val ['MN_TABLECODE'] . '.' . $val ['PARENT_FIELD'] . '=' . $relrec ['REL_TABLECODE'] . '.' . $val ['CHILD_FIELD'];
            }
        } elseif ($relrec ['RELATION_TYPE'] == CLX_NUM_ZERO) { // dynamic relation
            $sql = 'SELECT R.ID FROM ' . $relrec ['PARENT_TABLENAME'] . ' P, ' . $relrec ['CHILD_TABLENAME'] . ' C, ' . $relrec ['REL_TABLENAME'] . ' R WHERE P.ID = ' . $parent_recordid . ' AND C.ID = ' . singlequote($child_recordid) . ' AND R.' . $relrec ['RELT_PFIELD'] . '=P.' . $relrec ['PARENT_FIELDNAME'] . ' AND R.' . $relrec ['RELT_CFIELD'] . '=C.' . $relrec ['CHILD_FIELDNAME'] . ' AND R.PARENT_TABLECODE=' . singleQuote($relrec ['PARENT_TABLECODE']) . ' AND R.CHILD_TABLECODE=' . singleQuote($relrec ['CHILD_TABLECODE']);
        } else {
            return array();
        }
        $child_id = ClxCommon::$db->getOne($sql);
	    return (empty($child_id)) ? array() : $this->loadRecordFill($relrec ['REL_TABLECODE'], '', $child_id, $msg);
    }

    /**
     * Saves Dynamic Relation Record.
     *
     * @param string $parent_tablecode
     * @param string $child_tablecode
     * @param int $parent_recordid
     * @param int $child_recordid
     * @return int
     */
    function saveRelationRecord($child_tablecode, $child_recordid, &$msg) {
        $callinginfo = peekHistory();
        if (!empty($callinginfo ['parentrecord'] ['TABLECODE'])) {
            $parent_tablecode = $callinginfo ['parentrecord'] ['TABLECODE'];
        } else {
            $parent_tablecode = false;
        }
        if (!empty($callinginfo ['parentrecord'] [$parent_tablecode . '_ID'])) {
            $parent_recordid = $callinginfo ['parentrecord'] [$parent_tablecode . '_ID'];
        } else {
            $parent_recordid = false;
        }
        // test if parent of child exists or just return.
        if (empty($parent_tablecode) || empty($child_tablecode)) {
            return CLX_NUM_ZERO;
        }
        $record = array();
        // Creating link for dynamic relation
        $DBDR = &getTool('DBDR');
        $relrec = $DBDR->getRelationInfo($parent_tablecode, $child_tablecode);
        if (empty($relrec))
            return CLX_NUM_ZERO; // no relation
        $EVNT = &getTool('EVNT');
        $ACAD = &getTool('ACAD');
        if (empty(UserRequest::$request ['relfm'])) {
            $formrec = array();
        } else {
            $sql = 'SELECT ID, IDCODE, IDNAME, MODULECODE FROM CLX_UI_FORMS WHERE IDCODE = ' . singleQuote(UserRequest::$request ['relfm']);
            $formrec = ClxCommon::$db->getOneRecord($sql);
        }
        $crit = '';
        if ($relrec ['RELATION_TYPE'] == CLX_NUM_ZERO) { // Dynamic Relation
            // Search for parent key if diferent
            // than Record
            if ($relrec ['PARENT_FIELDNAME'] !== 'ID') {
                $parentkey = ClxCommon::$db->getField($relrec ['PARENT_TABLENAME'], $relrec ['PARENT_FIELDNAME'], 'ID = ' . $parent_recordid);
            } else {
                $parentkey = $parent_recordid;
            }
            // Search for parent key if diferent than Record
            if ($relrec ['PARENT_FIELDNAME'] !== 'ID') {
                $childkey = ClxCommon::$db->getField($relrec ['CHILD_TABLENAME'], $relrec ['CHILD_FIELDNAME'], 'ID = ' . $child_recordid);
            } else {
                $childkey = $child_recordid;
            }
            $sql = 'SELECT ID, IDCODE, IDNAME, MODULECODE FROM CLX_DB_TABLES WHERE IDCODE = ' . singleQuote($relrec ['REL_TABLECODE']);
            $tablerec = ClxCommon::$db->getOneRecord($sql);
            $record = $this->prepareRecord($formrec, $tablerec, CLX_NUM_ZERO);
            $record ['PARENT_TABLECODE'] = $parent_tablecode;
            $record ['CHILD_TABLECODE'] = $child_tablecode;
            $record [$relrec ['RELT_PFIELD']] = $parentkey;
            $record [$relrec ['RELT_CFIELD']] = $childkey;
            // check if exists
            $crit = 'PARENT_TABLECODE = ' . singleQuote($parent_tablecode) . ' AND CHILD_TABLECODE = ' . singleQuote($child_tablecode) . ' AND ' . $relrec ['RELT_PFIELD'] . '=' . singleQuote($parentkey) . ' AND ' . $relrec ['RELT_CFIELD'] . '=' . singleQuote($childkey);
            // Setting mn relations instead of Dynamic relation
        } elseif ($relrec ['RELATION_TYPE'] == CLX_NUM_TWO) {
            /*
             * 1.get parent record 2.get child record 3.create record field
             */
            $parent_fields = array();
            $child_fields = array();
            foreach ($relrec ['RELATIONS'] as $key => $val) {
                if ($val ['MN_TABLECODE'] == $parent_tablecode) {
                    $parent_fields [] = $val ['MN_TABLECODE'] . '.' . $val ['PARENT_FIELD'] . ' ' . $val ['CHILD_FIELD'];
                } elseif ($val ['MN_TABLECODE'] == $child_tablecode) {
                    $child_fields [] = $val ['MN_TABLECODE'] . '.' . $val ['PARENT_FIELD'] . ' ' . $val ['CHILD_FIELD'];
                }
            }
            if (!empty($parent_fields)) {
                $sql = 'SELECT ' . implode(',', $parent_fields) . ' FROM ' . $relrec ['PARENT_TABLENAME'] . ' ' . $relrec ['PARENT_TABLECODE'] . ' WHERE ' . $relrec ['PARENT_TABLECODE'] . '.ID = ' . $parent_recordid;
            }
            $parentrec = ClxCommon::$db->getOneRecord($sql);
            if (!empty($child_fields)) {
                $sql = 'SELECT ' . implode(',', $child_fields) . ' FROM ' . $relrec ['CHILD_TABLENAME'] . ' ' . $relrec ['CHILD_TABLECODE'] . ' WHERE ' . $relrec ['CHILD_TABLECODE'] . '.ID = ' . $child_recordid;
            }
            $childrec = ClxCommon::$db->getOneRecord($sql);
            $DBTB = &getTool('DBTB');
            $tablerec = $DBTB->getTable($relrec ['REL_TABLECODE']);
            $record = $DBTB->tableDefaultRecord($relrec ['REL_TABLECODE']); // tableDefaultRecord($tablecode)
            $record = array_merge($record, $parentrec, $childrec);
            $comma = '';
            foreach ($relrec ['RELATIONS'] as $key => $val) {
                $crit .= $comma . $val ['CHILD_FIELD'] . '=' . singleQuote($record [$val ['CHILD_FIELD']]);
                $comma = ' AND ';
            }
            $mnrec = ClxCommon::$db->getRecord($relrec ['REL_TABLENAME'], $crit);
            if (!empty($mnrec)) {
                foreach ($mnrec as $key => $val) {
                    if (!array_key_exists($key, $record)) {
                        $record [$key] = $val;
                    }
                    if ($record [$key] === '' && $val !== '') {
                        $record [$key] = $val;
                    }
                }
            }
            // check if some form info submitted to record
            foreach ($record as $key => $val) {
                if (array_key_exists($relrec ['REL_TABLECODE'] . '_' . $key, UserRequest::$post)) {
                    $record [$key] = UserRequest::$post [$relrec ['REL_TABLECODE'] . '_' . $key];
                }
            }
        } else {
            return CLX_NUM_ZERO; // unkwon relation
        }
        if (ClxCommon::$db->oneExistsRecords($relrec ['REL_TABLENAME'], $crit) > CLX_NUM_ZERO) {
            if (!empty($formrec)) {
                $EVNT->execute5('UIFM', $formrec ['ID'], 'SAFO', $record, $msg); // Update
            }
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'UREP', $record, $msg); // Update
            $return = ClxCommon::$db->updateRecord($relrec ['REL_TABLENAME'], $record, $crit);
            $record ['ID'] = $return;
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'UREC', $record, $msg); // Update
            $ACAD->log($tablerec, $return, 'SAVE_REC', $tablerec ['IDNAME'], $record);
        } else {
            if (!empty($formrec)) {
                $EVNT->execute5('UIFM', $formrec ['ID'], 'CRFO', $record, $msg); // Create
            }
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREP', $record, $msg); // Create
            // Record Pre
            $return = ClxCommon::$db->createRecord($relrec ['REL_TABLENAME'], $record, false);
            $record ['ID'] = $return;
            $EVNT->execute5('DBTB', $tablerec ['ID'], 'CREC', $record, $msg); // Create
            $ACAD->log($tablerec, $return, 'CREATE_REC', $tablerec ['IDNAME'], $record);
        }
		apc_clear_xppaging_count($tablerec['IDCODE']);
        return $return;
    }

    /**
     * Delete Dynamic Relation Records
     *
     * @param string $tablecode
     * @param int $recordid
     * @param array $msg
     */
    function deleteDynamicChildRecords($tablecode, $recordid, &$msg) {
        // select all posible relations
        // delete relations where child exists
        // delete relation where parent exists
        $tablename = tableName($tablecode);
        $sql = 'SELECT * FROM CLX_DB_DYNRELATIONS WHERE ACTIVE = 1 AND RELATION_TYPE = 0 AND (PARENT_TABLECODE=' . singleQuote($tablecode) . ' OR CHILD_TABLECODE=' . singleQuote($tablecode) . ')';
        $rls = ClxCommon::$db->executeQuery($sql);
        while ($rl = ClxCommon::$db->getNextRecord($rls)) {
            if ($rl ['PARENT_TABLECODE'] == $tablecode) {
                $rel_fieldname = $rl ['RELT_PFIELD'];
                $crit = 'SELECT ' . $rl ['PARENT_FIELDNAME'] . ' FROM ' . $tablename . ' WHERE ID = ' . $recordid;
            } elseif ($rl ['CHILD_TABLECODE'] == $tablecode) {
                $rel_fieldname = $rl ['RELT_CFIELD'];
                $crit = 'SELECT ' . $rl ['CHILD_FIELDNAME'] . ' FROM ' . $tablename . ' WHERE ID = ' . $recordid;
            } else {
                continue;
            }
            $rel_tablename = tableName($rl ['TABLECODE']);
            $sql = 'DELETE FROM ' . $rel_tablename . ' WHERE ' . $rel_fieldname . ' IN (' . $crit . ' ) ';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    function executeFieldFormulas($fieldrecs, $tablecode, $field_names, $field_fullnames, &$record, $constants = null) {
        if(!defined('CLX_FLD_FRM_NOCALC')) {
            define('CLX_FLD_FRM_NOCALC', '=NOCALC=');
        }
        if(is_null($constants)) {
            $constants = array('kDatabaseURL'=>kDatabaseURL, /*'kDatabaseUsername', 'kDatabasePassword',*/ 'kDatabaseName'=>kDatabaseName, 'kSystemVersion' =>kSystemVersion, 'kSystemLanguage'=>kSystemLanguage, 'kSystemLoginLanguage'=>kSystemLoginLanguage, 'kMysqlVersion'=>kMysqlVersion, 'kPathToWebSite'=>kPathToWebSite, 'kPathToTools'=>kPathToTools, 'kPathToObjects'=>kPathToObjects, 'kPathToData'=>kPathToData, 'kPathToCode'=>kPathToCode, 'kPathToTemplates'=>kPathToTemplates, 'kPathToPackages'=>kPathToPackages, 'kPathToSkins'=>kPathToSkins, 'kPathToExport'=>kPathToExport, 'kPathToTemp'=>kPathToTemp, 'kPathToPear'=>kPathToPear, 'kPathToSendmail'=>kPathToSendmail, 'kDirectPathToArchive'=>kDirectPathToArchive, 'kWebSite'=>kWebSite, 'kDefaultEmail'=>kDefaultEmail, 'kDefaultSmtp'=>kDefaultSmtp, 'kDefaultSmtpPort'=>kDefaultSmtpPort, 'kDefaultMailer'=>kDefaultMailer, /*'kDefaultSmtpReqAuth', 'kDefaultSmtpUsername', 'kDefaultSmtpPassword',*/ 'kDefaultPrecision'=>kDefaultPrecision, 'kDefaultSkin'=>kDefaultSkin, /*'kDefaultFrameLess', */ 'kDefaultCompany'=>kDefaultCompany, 'kSideBarCookieName'=>kSideBarCookieName, 'kSessionTimeout'=>kSessionTimeout, 'kTimeLimit'=>kTimeLimit, 'kSessionMultiple'=>kSessionMultiple, 'kSessionLoginAttempts'=>kSessionLoginAttempts, /*'kSessionIbsLogin', */ 'kSystemExpireDate'=>kSystemExpireDate, 'kAppMemoryLimit'=>kAppMemoryLimit, 'kAppMaxUploadSize'=>kAppMaxUploadSize, 'kAppMaxPostSize'=>kAppMaxPostSize, 'kDefaultTimeZone'=>kDefaultTimeZone, 'kPhpDisplayErrors'=>kPhpDisplayErrors, 'kPhpLogErrors'=>kPhpLogErrors, 'kPhpErrorLog'=>kPhpErrorLog, 'kPhpCLI'=>kPhpCLI, 'kAppDev'=>kAppDev, /*'kDemoIbs'*/);
        }
	    foreach ($fieldrecs as $fieldrec) {
            if (strlen($fieldrec ['FIELDFORMULA']) > CLX_NUM_ZERO) {
                //$expr = str_replace('=', '', $fieldrec ['FIELDFORMULA']);
                $expr = trim($fieldrec['FIELDFORMULA']);
                $sw_apply_calc = true;
                if(substr($fieldrec['FIELDFORMULA'], CLX_NUM_ZERO, strlen(CLX_FLD_FRM_NOCALC))===CLX_FLD_FRM_NOCALC) {
                    $sw_apply_calc = false;
                    $expr = substr($fieldrec['FIELDFORMULA'], strlen(CLX_FLD_FRM_NOCALC));
                } else {
                    $expr = (substr($fieldrec['FIELDFORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE)==='=' ? substr($fieldrec['FIELDFORMULA'], CLX_NUM_ONE) : $fieldrec['FIELDFORMULA']);
                }
                foreach ($record as $key => $val) {
                    $fl = '!' . substr($key, -CLX_NUM_ONE * (strlen($key) - strlen($tablecode)));
                    $expr = str_replace($fl, $val, $expr);
                }
                foreach ($constants as $key => $val) {
                    $expr = str_replace($key, $val, $expr);
                }
                if($sw_apply_calc === true){
                    $cal = new ClxExpression();
                    $record[$tablecode . $fieldrec['FIELDNAME']] = $cal->calculate(str_replace(' ', '', $expr));
                } else {
                    $record[$tablecode . $fieldrec['FIELDNAME']] = $expr;
                }
            }
        }
    }

    /**
     * Deletes multiple records
     *
     * @param array $tablerec
     * @param array $idlist
     */
    function deleteRecords($tablerec, $idlist) {
        foreach ($idlist as $id) {
            $this->deleteRecord_($tablerec, $id);
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::deleteRecord()
     */
    function deleteRecord_($id, $recordid = '') {

        //Compatibilidad con clx_tools
        $tablerec = $id;
        $tablecode = $tablerec ['IDCODE'];
        $taccess = $this->getAppAccess($tablecode, true);
        if (!$taccess->canDelete()) {
            return; // cannot delete
        }
        $tablename = $tablerec ['MODULECODE'] . '_' . $tablerec ['IDNAME'];
        $tmp = array();
        $record = ClxCommon::$db->getRecord($tablename, 'ID=' . $recordid);
        if (is_array($record)) {
            foreach ($record as $key => $val) { // adding elements for event validation
                $tmp [$tablerec ['IDCODE'] . '_' . $key] = $val;
            }
        } else
            $record = Array();
        $record = array_merge($record, $tmp);
        $msg = array();
        $EVNT = &getTool('EVNT');
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'DREC', $record, $msg); // Delete
        // Record Event Predatabase
        if (!empty($msg)) {
            // Added to allow validations before delete, this may be reset toshow message to user.
            return;
        }
        // send deletemsg to fields, currently used by file field to unlink
        $DBTF = &getTool('DBTF');
        $fields = $DBTF->getTableFields($tablecode);
        foreach ($fields as $fieldrecord) {
            $fieldinstance = getToolObject('DBFT', $fieldrecord ['FIELDTYPE']);
            $fieldinstance->removeField($fieldrecord, $record);
        }
        $this->deleteDynamicChildRecords($tablerec ['IDCODE'], $recordid, $msg);
        $this->deleteChildRecords($tablerec ['IDCODE'], $record);

        ClxCommon::$db->deleteRecords($tablename, 'ID=' . $recordid);
		
		apc_clear_xppaging_count($tablecode);
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'DREP', $record, $msg); // Delete
        $ACAD = &getTool('ACAD');
        $ACAD->log($tablerec, $recordid, 'DEL_REC', $tablerec ['IDNAME'], $record);
    }

    /**
     * Cascade Delete
     *
     * @param string $tablecode
     */
    function deleteChildRecords($tablecode, $record) {
        $DBFL = &getTool('DBFL');
        // getRelation
        $sql = 'SELECT A.* FROM CLX_DB_DYNRELATIONS A, CLX_DB_TABLES B WHERE B.STATUS = 1 AND A.CHILD_TABLECODE = B.IDCODE AND A.PARENT_TABLECODE = ' . singleQuote($tablecode) . ' AND B.TYPE NOT IN (' . singleQuoteArray(array('VIEW', 'TEMP')) . ') AND A.RELATION_TYPE = 1 AND A.ACTIVE = 1 AND A.DELETE_ACTION IN (1, 2)';
        $relationrecs = ClxCommon::$db->executeQuery($sql);
        while ($relationrec = ClxCommon::$db->getNextRecord($relationrecs)) {
            $crit = '';
            $comma = '';
            $upkeys = array();
            $sql = 'SELECT DBDC.* FROM CLX_DB_DYNRELATION_COLS DBDC, CLX_DB_TABLES DBTB WHERE DBTB.STATUS = 1 AND DBTB.IDCODE = DBDC.CHILD_TABLECODE AND DBTB.TYPE NOT IN (' . singleQuote('TEMP') . ',' . singleQuote('VIEW') . ') AND DBDC.PARENT_TABLECODE = ' . singleQuote($relationrec ['PARENT_TABLECODE']) . ' AND DBDC.CHILD_TABLECODE = ' . singleQuote($relationrec ['CHILD_TABLECODE']) . ' ORDER BY DBDC.SEQNUM ASC';
            $childs = ClxCommon::$db->executeQuery($sql);

            while ($child = ClxCommon::$db->getNextRecord($childs)) {
                $fl = $DBFL->getField($child ['CHILD_FIELD']);
                if ($fl ['FIELDTYPE'] === 'BOOL' || $fl ['FIELDTYPE'] === 'DECN' || $fl ['FIELDTYPE'] === 'FILE' || $fl ['FIELDTYPE'] === 'INTN' || $fl ['FIELDTYPE'] === 'PRIM') {
                    if (empty($record [$child ['PARENT_FIELD']])) {
                        $record [$child ['PARENT_FIELD']] = CLX_INIT_ZERO;
                    }
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . $record [$child ['PARENT_FIELD']];
                } else {
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . singleQuote($record [$child ['PARENT_FIELD']]);
                }
                $comma = ' AND ';
                $upkeys [$child ['CHILD_FIELD']] = 'null';
            }
            $child ['TABLENAME'] = tableName($relationrec ['CHILD_TABLECODE']);
            $child_records = ClxCommon::$db->getRecords($child ['TABLENAME'], $crit);
            while ($child_record = ClxCommon::$db->getNextRecord($child_records)) {
                $this->deleteChildRecords($relationrec ['CHILD_TABLECODE'], $child_record);
            }
            switch ($relationrec ['DELETE_ACTION']) {
                case CLX_NUM_ONE : // cascade
                    ClxCommon::$db->deleteRecords($child ['TABLENAME'], $crit);
                    break;
                case CLX_NUM_TWO : // set null
                    ClxCommon::$db->updateRecord($child ['TABLENAME'], $upkeys, $crit);
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * Cascade Update Child Records
     *
     * @param string $tablecode
     * @param array $record
     */
    function updateChildRecords($tablecode, $record) {
        if (empty($record ['ID']))
            return;
        // getRelation

        $sql = 'SELECT DR.* FROM CLX_DB_DYNRELATIONS DR, CLX_DB_TABLES T WHERE T.IDCODE = DR.CHILD_TABLECODE AND DR.PARENT_TABLECODE=' . singleQuote($tablecode) . ' AND DR.RELATION_TYPE = 1 AND DR.ACTIVE = 1 AND DR.UPDATE_ACTION IN (1,2) ';
		$relationrecs = ClxCommon::$db->executeQuery($sql);
        while ($relationrec = ClxCommon::$db->getNextRecord($relationrecs)) {
            if (empty($relationrec))
                return;
            if ($relationrec ['UPDATE_ACTION'] == CLX_NUM_ZERO)
                return; // no action
            $sql = 'SELECT DBDC.* FROM CLX_DB_DYNRELATIONS DBDR, CLX_DB_DYNRELATION_COLS DBDC WHERE DBDR.PARENT_TABLECODE = DBDC.PARENT_TABLECODE AND DBDR.CHILD_TABLECODE = DBDC.CHILD_TABLECODE AND DBDR.ACTIVE = 1 AND DBDR.UPDATE_ACTION IN (1, 2) AND DBDR.PARENT_TABLECODE = ' . singleQuote($tablecode) . ' ORDER BY SEQNUM ASC';
            $childs = ClxCommon::$db->executeQuery($sql);
            $oldfls = '';
            $crtifl = array();
            $comma = '';
            while ($child = ClxCommon::$db->getNextRecord($childs)) {
                $oldfls .= $comma . $child ['PARENT_FIELD'];
                $crtifl [] = $child;
                $comma = ', ';
            }
            // Get old Record
			if (empty($oldfls))
				$oldfls='*';
            $parent_tablename = tableName($tablecode);
            $sql = 'SELECT ' . $oldfls . ' FROM ' . $parent_tablename . ' WHERE ID = ' . $record ['ID'];
            $old_record = ClxCommon::$db->getOneRecord($sql);
            $DBFL = &getTool('DBFL');
            $crit = '';
            $comma = '';
            $upkeys = array();
            foreach ($crtifl as $child) {
                $fl = $DBFL->getField($child ['CHILD_FIELD']);
                if ($fl ['FIELDTYPE'] === 'BOOL' || $fl ['FIELDTYPE'] === 'DECN' || $fl ['FIELDTYPE'] === 'FILE' || $fl ['FIELDTYPE'] === 'INTN' || $fl ['FIELDTYPE'] === 'PRIM') {
                    if (empty($record [$child ['PARENT_FIELD']])) {
                        $record [$child ['PARENT_FIELD']] = CLX_INIT_ZERO;
                    }
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . $old_record [$child ['PARENT_FIELD']];
                } else {
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . singleQuote($old_record [$child ['PARENT_FIELD']]);
                }
                $comma = ' AND ';
                if ($relationrec ['UPDATE_ACTION'] == CLX_NUM_TWO)
                    $upkeys [$child ['CHILD_FIELD']] = 'null';
                else
                    $upkeys [$child ['CHILD_FIELD']] = $record [$child ['PARENT_FIELD']];
            }
            $child ['TABLENAME'] = tableName($relationrec ['CHILD_TABLECODE']);
            $child_records = ClxCommon::$db->getRecords($child ['TABLENAME'], $crit);
            while ($child_record = ClxCommon::$db->getNextRecord($child_records)) {
                $this->updateChildRecords($relationrec ['CHILD_TABLECODE'], $child_record);
            }
            // updating field
	
				
				
            ClxCommon::$db->updateRecord($child ['TABLENAME'], $upkeys, $crit);
        }
    }

    /**
     * Cascade Update Child Records
     *
     * @param string $tablecode
     * @param array $record
     */
    function duplicateChildRecords($tablecode, $record, $load_rec_id) {
        if (empty($record ['ID']) && empty($load_rec_id)) {
            return;
        }
        // getRelation
        $sql = 'SELECT DR.* FROM CLX_DB_DYNRELATIONS DR, CLX_DB_TABLES T WHERE T.IDCODE = DR.CHILD_TABLECODE AND DR.PARENT_TABLECODE=' . singleQuote($tablecode) . ' AND DR.RELATION_TYPE = 1 AND DR.ACTIVE = 1 AND DR.DUPLICATE_ACTION = 1 ';
        $relationrecs = ClxCommon::$db->executeQuery($sql);
        while ($relationrec = ClxCommon::$db->getNextRecord($relationrecs)) {
            if (empty($relationrec))
                return;
            $sql = 'SELECT DBDC.* FROM CLX_DB_DYNRELATIONS DBDR, CLX_DB_DYNRELATION_COLS DBDC WHERE DBDR.PARENT_TABLECODE = DBDC.PARENT_TABLECODE AND DBDR.CHILD_TABLECODE = DBDC.CHILD_TABLECODE AND DBDR.ACTIVE = 1 AND DBDR.DUPLICATE_ACTION = 1 AND DBDR.PARENT_TABLECODE = ' . singleQuote($tablecode) . ' ORDER BY SEQNUM ASC';
            $childs = ClxCommon::$db->executeQuery($sql);
            $oldfls = '';
            $crtifl = array();
            $comma = '';
            while ($child = ClxCommon::$db->getNextRecord($childs)) {
                $oldfls .= $comma . $child ['PARENT_FIELD'];
                $crtifl [] = $child;
                $comma = ', ';
            }
            // Get old Record
            $parent_tablename = tableName($tablecode);
            $sql = 'SELECT ' . $oldfls . ' FROM ' . $parent_tablename . ' WHERE ID = ' . $load_rec_id;
            $load_record = ClxCommon::$db->getOneRecord($sql);
            $DBFL = &getTool('DBFL');
            $crit = '';
            $comma = '';
            $upkeys = array();
            foreach ($crtifl as $child) {
                $fl = $DBFL->getField($child ['CHILD_FIELD']);
                if ($fl ['FIELDTYPE'] === 'BOOL' || $fl ['FIELDTYPE'] === 'DECN' || $fl ['FIELDTYPE'] === 'FILE' || $fl ['FIELDTYPE'] === 'INTN' || $fl ['FIELDTYPE'] === 'PRIM') {
                    if (empty($record [$child ['PARENT_FIELD']])) {
                        $record [$child ['PARENT_FIELD']] = CLX_INIT_ZERO;
                    }
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . $load_record [$child ['PARENT_FIELD']];
                } else {
                    $crit .= $comma . $child ['CHILD_FIELD'] . ' = ' . singleQuote($load_record [$child ['PARENT_FIELD']]);
                }
                $comma = ' AND ';
                $upkeys [$child ['CHILD_FIELD']] = $record [$child ['PARENT_FIELD']];
            }
            $DBTI = &getTool('DBTI');
            $child ['TABLENAME'] = tableName($relationrec ['CHILD_TABLECODE']);
            $child_records = ClxCommon::$db->getRecords($child ['TABLENAME'], $crit);
            while ($child_record = ClxCommon::$db->getNextRecord($child_records)) {
                $this->duplicateChildRecords($relationrec ['CHILD_TABLECODE'], $child_record, $child_record ['ID']);
                $crit2 = '';
                $comma2 = '';
                $child_record = array_merge($child_record, $upkeys);
                $indx = $DBTI->getTableIndexes($relationrec ['CHILD_TABLECODE'], 'UNI');
//                print_r($indx);
                if (!empty($indx)) {
                    foreach ($indx as $indexv) {
                        $indxfls = explode(',', $indexv ['FIELDNAME']);
                        foreach ($indxfls as $v) {
                            $fl = $DBFL->getField($v);
                            if ($fl ['FIELDTYPE'] === 'BOOL' || $fl ['FIELDTYPE'] === 'DECN' || $fl ['FIELDTYPE'] === 'FILE' || $fl ['FIELDTYPE'] === 'INTN' || $fl ['FIELDTYPE'] === 'PRIM') {
                                $crit2 .= $comma2 . ' ' . $v . ' = ' . $child_record [$v];
                            } else {
                                $crit2 .= $comma2 . ' ' . $v . ' = ' . singleQuote($child_record [$v]);
                            }
                            $comma2 = ' AND ';
                        }
                    }
                    unset($child_record ['ID']);
                    if (ClxCommon::$db->oneExistsRecords($child ['TABLENAME'], $crit2) == CLX_NUM_ZERO) {
                        ClxCommon::$db->createRecord($child ['TABLENAME'], $child_record, false);
                    }
                } else {
                    unset($child_record ['ID']);
                    ClxCommon::$db->createRecord($child ['TABLENAME'], $child_record, false);
                }
            }
        }
        if(isset($tablerec['IDCODE'])){
            apc_clear_xppaging_count($tablerec['IDCODE']);
        }    
    }

    /**
     * Loads table field default value
     *
     * @param array $tablerec
     * @param string $formcode
     * @return array
     * @see ui_form_panel_fields::setUserPrefFieldDefault()
     * @see ui_forms::userEditForm()
     */
    function defaultRecord($tablerec = '', $formcode = '') {
        $msg = null;
        $tablecode = $tablerec ['IDCODE'];
        $UIFF = &getTool('UIFF');
        $record = array();
        // See history
        $callingpage = peekHistory();
        $hasparent = (isset($callingpage ['parentrecord'])) ? true : false;
        $frel = array();
        if ($hasparent === true) {
            $DBDC = &getTool('DBDC');
            $frel = $DBDC->getRelationFieldsArray($callingpage ['parentrecord'] ['TABLECODE'], $tablecode);
        }
        if (empty($formcode)) {
            $sql = 'SELECT F.ID, F.USERNAME, F.FIELDNAME, F.FIELDFORMLABEL, F.FIELDLISTLABEL, F.FIELDPREFIX, F.FIELDSUFIX, F.FIELDTYPE, F.FIELD_ANCHOR, F.FIELDFORMULA, F.FIELD_SIZE, F.FIELD_REQUIRED, F.FIELD_FORMAT, F.FIELD_ALIGN, F.FIELD_DEFAULT, F.FIELD_MINVALUE, F.FIELD_MAXVALUE, F.FIELD_DISPLAYSIZE, F.FIELD_EXTRA1, F.FIELD_EXTRA2, F.FIELD_EXTRA3, F.FIELD_EXTRA4, F.FIELD_EXTRA5, F.FIELD_EXTRA6, F.FIELD_EXTRA7, F.FIELD_EXTRA8, F.FIELD_EXTRA9 FROM CLX_DB_FIELDS F, CLX_DB_TABLEFIELDS T WHERE F.FIELDNAME=T.FIELDNAME AND T.TABLECODE=' . singleQuote($tablecode);
        } else {
            $sql = 'SELECT F.ID, F.USERNAME, F.FIELDNAME, F.FIELDFORMLABEL, F.FIELDLISTLABEL, F.FIELDPREFIX, F.FIELDSUFIX, F.FIELDTYPE, F.FIELD_ANCHOR, F.FIELDFORMULA, F.FIELD_SIZE, F.FIELD_REQUIRED, F.FIELD_FORMAT, F.FIELD_ALIGN, F.FIELD_MINVALUE, F.FIELD_MAXVALUE, F.FIELD_DISPLAYSIZE, F.FIELD_EXTRA1, F.FIELD_EXTRA2, F.FIELD_EXTRA3, F.FIELD_EXTRA4, F.FIELD_EXTRA5, F.FIELD_EXTRA6, F.FIELD_EXTRA7, F.FIELD_EXTRA8, F.FIELD_EXTRA9, (SELECT MAX(PF.FIELD_DEFAULT) FROM CLX_UI_FORM_PANEL_FIELDS PF, CLX_UI_FORM_PANELS P WHERE PF.PANELID = P.IDCODE AND F.FIELDNAME = PF.FIELDNAME AND PF.ACTIVE = 1 AND P.ACTIVE = 1 AND P.FORMCODE = ' . singleQuote($formcode) . ') FIELD_DEFAULT, IFNULL((SELECT MAX(PF.USE_USR_DEFAULT) FROM CLX_UI_FORM_PANEL_FIELDS PF, CLX_UI_FORM_PANELS P WHERE PF.PANELID = P.IDCODE AND F.FIELDNAME = PF.FIELDNAME AND PF.ACTIVE = 1 AND P.ACTIVE = 1 AND P.FORMCODE = ' . singleQuote($formcode) . '),0) USE_USR_DEFAULT FROM CLX_DB_FIELDS F, CLX_DB_TABLEFIELDS T WHERE F.FIELDNAME=T.FIELDNAME AND T.TABLECODE=' . singleQuote($tablecode);
        }
        $fields = ClxCommon::$db->executeQuery($sql);

        while ($field = ClxCommon::$db->getNextRecord($fields)) {
            $fln = $tablecode . '_' . $field ['FIELDNAME'];
            // Adding user prefrences for default values
            $UIFF->setUserPrefFieldDefault($fln, $field);
            // setting parent if relation exists
            // Check if parent exists then just add the information from parent
            if ($hasparent === true) {
                foreach ($frel as $key => $val) {
                    $pfl = $val ['PARENT_TABLECODE'] . '_' . $val ['PARENT_FIELD'];
                    $cfl = $val ['CHILD_TABLECODE'] . '_' . $val ['CHILD_FIELD'];

                    if (intval($val ['COPY_FLAG']) === CLX_NUM_ZERO || $cfl != $fln) {
                        $field['NOPARENT'] = 1;
                        continue;
                    }

                    if (array_key_exists($pfl, $callingpage ['parentrecord'])) {
                        $field ['FIELD_DEFAULT'] = $callingpage ['parentrecord'] [$pfl];
                    }
                }
            }
            $fieldinstance = getToolObject('DBFT', $field ['FIELDTYPE']);
            $fieldinstance->defaultField($tablecode . '_' . $field ['FIELDNAME'], $field, $record);
        }

        $EVNT = &getTool('EVNT');
        $EVNT->execute5('DBTB', $tablerec ['ID'], 'IREC', $record, $msg); // Init
        // Record
        // Calendar Loader
        $UICA = &getTool('UICA');
        $record = $UICA->loadRequest($record);
        if (!empty($formcode)) {
            $sql = 'SELECT UIFP.FORM_OBJ_CODE FORM_CODE, DBTB.* FROM CLX_DB_TABLES DBTB, CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP WHERE UIFM.IDCODE = UIFP.FORM_OBJ_CODE AND DBTB.IDCODE = UIFM.TABLECODE AND UIFP.FORMCODE = ' . singleQuote($formcode) . ' AND UIFM.IDCODE <> ' . singleQuote($formcode);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $subrecord = $this->defaultRecord($r, $r ['FORM_CODE']);
                $record = array_merge($record, $subrecord);
            }
        }
        return $record;
    }

    /**
     *
     * @param type $buttonid
     * @param type $idlist
     * @param type $continue
     */
    function executeJumpListingButton($jmitem, $idlist, &$continue) {
        $jm = explode(':', $jmitem);
        $buttonid = $jm[CLX_NUM_ZERO];
        $jmp_list_item_id = $jm[CLX_NUM_ONE];
        $contents = '';
        $sql = 'SELECT UILB.*, UILG.QUERYCODE JMPLISTING_QUERY, UILG.TABLECODE JMPLISTING_TBL FROM CLX_UI_LISTING_BUTTONS UILB, CLX_UI_LISTINGS UILG WHERE UILG.IDCODE = UILB.JUMPLISTCODE AND UILB.ID = ' . $buttonid . ' ORDER BY SEQNUM';
        $buttonrec = ClxCommon::$db->getOneRecord($sql);
        if ((($buttonrec ['WINDOW'] === 'POP') or ( $buttonrec ['WINDOW'] === 'CUST')) and ( !isset(UserRequest::$request ['wind']))) {
            $window = ($buttonrec ['WINDOW'] === 'POP') ? 'pop.php' : 'window.php';
			$variables = array();
            $variables ['CONTENTS'] = '';
            if ($buttonrec ['EXECUTE'] === 'ONE') {
                $idlist = toString($idlist);
                $url = $window . '?to=' . $this->code . '&ac=JUMP_LIST&jm=' . $jmitem . '&idlist=' . $idlist . '&wind=1';
                $title = 'windowbutton' . $buttonid;
                $variables ['CONTENTS'] .= 'openWindow(' . singleQuote($title) . ', ' . singleQuote($url) . ', 640, 480);' . CLX_CHAR_NL;
            } else {
				foreach ($idlist as $id) {
                    $url = $window . '?to=' . $this->code . '&ac=JUMP_LIST&jm=' . $jmitem . '&idlist=' . $id . '&id=' . $id . '&wind=1';
					$title = 'windowbutton' . $buttonid . '_' . $id;//ec ho $url;
                    $variables ['CONTENTS'] .= 'openWindow(' . singleQuote($title) . ', ' . singleQuote($url) . ', 640, 480);' . CLX_CHAR_NL;
                }
            }
            $contents = '<!-- openUbicacionwindow7 -->'.setJavaScriptTag($variables ['CONTENTS'], false);
            $continue = true;
        } else {
            //Ejecucion del boton
            $jmplisttbl = tableName($buttonrec['JMPLISTING_TBL']);
            $jmplistrec = ClxCommon::$db->getRecord($jmplisttbl, 'ID = ' . $jmp_list_item_id);
            //this if need eventually to change to include values of objects according to the tool
            if (!empty($jmplistrec['TOOL_CODE']) && $jmplistrec['TOOL_CODE'] === 'ANRP' && !empty($jmplistrec['RPT_CODE'])) {
                //Parametros entrantes: Regisotr de jump listing, registro de listado asociado a boton,
                //1.Determinar campos en forma de busqueda de reporte para incorporarlos.
                //2.Seleccionar campos de registro en listado en campos de forma de busqueda de reporte
                //3.Anexar cambpo a url para pasar los valores.
                $UILG = &getTool('UILG');
                $ANRP = &getTool('ANRP');
                $DBQY = &getTool('DBQY');
                $listingrec = ClxCommon::$db->getRecord($UILG->tablename, 'IDCODE = ' . singleQuote($buttonrec['LISTINGCODE']));
                $report_rec = ClxCommon::$db->getFields($ANRP->tablename, 'ID,SEARCH_FORM', 'IDCODE = ' . singleQuote($jmplistrec['RPT_CODE']));
                $select = array();
                //Find fields to pass to report prompt
                $sql = 'SELECT UIFM.TABLECODE, UIPF.FIELDNAME FROM CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIPF, CLX_UI_FORMS UIFM, CLX_DB_QUERY_TABLES DBQT WHERE UIFP.IDCODE = UIPF.PANELID AND UIFM.IDCODE = UIFP.FORMCODE AND UIFM.IDCODE = ' . singleQuote($report_rec['SEARCH_FORM']) . ' AND DBQT.TABLECODE = UIFM.TABLECODE AND DBQT.QUERYCODE = ' . singleQuote($listingrec['QUERYCODE']);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $select[$r['TABLECODE'] . '.' . $r['FIELDNAME']] = $r['TABLECODE'] . '_' . $r['FIELDNAME'];
                }
                $idlist = toString($idlist);
                $url_extra = '';
                if (!empty($select)) {
                    $query = $DBQY->getQuery($this->code, $listingrec['QUERYCODE']);
                    $sql = 'SELECT ';
                    $comma = '';
                    foreach ($select as $key => $val) {
                        $sql .= $comma . $key . ' ' . $val;
                        $comma = ', ';
                    }
                    $sql .= ' FROM ' . $query['FROMCLAUSE'];
                    $sql .= ' WHERE ' . $listingrec['TABLECODE'] . '.ID IN (' . $idlist . ')';
                    $rec = ClxCommon::$db->getOneRecord($sql);
                    foreach ($rec as $key => $val) {
                        $url_extra .='&' . $key . '=' . $val;
                    }
                }
                $url = 'pop.php?to=ANRP&ac=REPORT_BUILD&ANRP_ID=' . $report_rec['ID'] . '&no_menu=1&no_alerts=1' . $url_extra;
                //$title = 'windowbutton' . $buttonid;
                $jsscript = 'openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote($url) . ', 640, 480);' . CLX_CHAR_NL;
                $contents = '<!-- openUbicacionwindow5 -->'.setJavaScriptTag($jsscript, false);
                $continue = true;
            } else {
                $continue = $this->executeButtonCode($buttonrec, $idlist, $contents);
            }
        }
        return $contents;
    }

    /**
     * Execute list button
     *
     * @param int $buttonid
     * @param array $idlist
     * @param string $continue
     * @return string
     */
    function executeListingButton($buttonid, $idlist, &$continue) {
        $contents = '';
        $buttonrec = ClxCommon::$db->getRecord('CLX_UI_LISTING_BUTTONS', 'ID=' . $buttonid);

        if (!defined('clxbathrun') && (($buttonrec ['WINDOW'] === 'POP') or ( $buttonrec ['WINDOW'] === 'CUST')) and ( !isset(UserRequest::$request ['wind']))) {
            $window = ($buttonrec ['WINDOW'] === 'POP') ? 'pop.php' : 'window.php';
            $variables = array();
            $variables ['CONTENTS'] = '';
            if ($buttonrec ['EXECUTE'] === 'ONE') {
                $idlist = toString($idlist);
                $url = $window . '?to=' . $this->code . '&ac=BUTTON_' . $buttonid . '&idlist=' . $idlist . '&wind=1&nomenu=1&noalert=1';
                $title = dict($buttonrec['NAME'], false); //'windowbutton' . $buttonid;
				$sit=str_replace('\'','\\\'','openWindow(' . singleQuote($title) . ', ' . singleQuote($url) . ', 640, 480);');
                $variables ['CONTENTS'] .='setTimeout('.singlequote($sit).  ',1000)'. CLX_CHAR_NL;
            } else {
                $title = dict($buttonrec['NAME'], false); //'windowbutton' . $buttonid;
                foreach ($idlist as $id) {
                    $url = $window . '?to=' . $this->code . '&ac=BUTTON_' . $buttonrec['ID'] . 'id&idlist=' . $id . '&id=' . $id . '&wind=1';
                    if (isset(UserRequest::$post['submit1']) and UserRequest::$post['submit1'] == 'Descargar Calendario')
                        $winclose = 'true';
                    else
                        $winclose = 'false';

                    $variables ['CONTENTS'] .= 'openWindow(' . singleQuote($title . "', '" . $url) . '  , 640, 480,' . $winclose . ');' . CLX_CHAR_NL;
                }
            }

            $contents = '<!-- openUbicacionwindow6 -->'.setJavaScriptTag($variables ['CONTENTS'], false);
            $continue = true;
        } else {
            $continue = $this->executeButtonCode($buttonrec, $idlist, $contents);
        }
        return $contents;
    }

    /**
     *
     * @param type $buttonrec
     * @param type $idlist
     * @return type boolean
     */
    private function executeButtonCode($buttonrec, $idlist, &$contents) {
        includeCodeLib($buttonrec ['CODELIB']);
        $include_file = savePhpCodeEvents('uilb_' . $buttonrec['ID'], $buttonrec['CALL']);
        if ($buttonrec ['EXECUTE'] === 'EACH') {
            foreach ($idlist as $id) {
                include $include_file;
            }
        } else {
            include $include_file;
        }
        return (!empty($buttonrec ['CONTINUE'])) ? true : false;
    }

    /**
     * Executes code options
     *
     * @return string
     */
    function executeCode() {
        $contents = '';
        $menuid = (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request ['it'] : '';
        $menurec = ClxCommon::$db->getRecord('CLX_UI_MENUITEMS', 'IDCODE=' . singleQuote($menuid));
        if (empty($menurec)) {
            $contents = dict('GEN_ERR_INVALIDCODE');
        } else {
            includeCodeLib($menurec ['EXTRA2']);
            if (strlen($menurec ['EXTRA3']) > CLX_NUM_ZERO) {
                include savePhpCodeEvents('uimi_' . $menurec['ID'], $menurec ['EXTRA3']);
            }
        }
        return $contents;
    }

    function executeCommand($idlist) {
        // to be reviewit later
        return dict('GEN_LBL_INACTIVE');
    }

    /**
     * Execute Init Events
     *
     * @param unknown_type $formrec
     * @param unknown_type $tablerec
     * @param unknown_type $record
     * @param unknown_type $msg
     */
    function executeInitEvents($formrec, $tablerec, &$record, &$msg) {
        $EVNT = &getTool('EVNT');
        $formcode = $formrec ['IDCODE'];
        $EVNT->execute5('UIFM', $formrec ['ID'], 'INFO', $record, $msg); // Init
        // Form
        $panels = ClxCommon::$db->getRecords('CLX_UI_FORM_PANELS', 'ACTIVE = 1 AND FORMCODE=' . singleQuote($formcode) . ' ORDER BY SEQNUM');
        while ($panelrec = ClxCommon::$db->getNextRecord($panels)) {
            $panelid = $panelrec ['IDCODE'];
            $EVNT->execute5('UIFP', $panelid, 'INPA', $record, $msg); // Init Panel
            $fields = ClxCommon::$db->executeQuery('SELECT ID FROM CLX_UI_FORM_PANEL_FIELDS WHERE PANELID=' . singleQuote($panelid) . ' AND ACTIVE = 1 ORDER BY FIELDSEQNUM');
            while ($fieldrec = ClxCommon::$db->getNextRecord($fields)) {
                $EVNT->execute5('UIFF', $fieldrec ['ID'], 'INFI', $record, $msg); // Init
                // Field
            }
        }
    }

    /**
     * Returns the field value
     * @return type
     */
    private function changeFieldValueForm() {
        return array(CLX_CLASS_TITLE => 'EDIT_CHNG_FLD_VAL',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS')))
                            )
                        ), array('label' => 'GEN_LBL_TABLE',
                            'fields' => array(
                                array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'validations' => array(array('type' => 'sqlobject', 'required' => '0'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES')))
                            )
                        ), array('label' => 'GEN_LBL_FROM_VALUE',
                            'fields' => array(
                                array('name' => 'from_value', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => CLX_NUM_HUNDRED, 'validations' => array(array('type' => 'string', 'required' => '1')))
                            )
                        ), array('label' => 'GEN_LBL_TO_VALUE',
                            'fields' => array(
                                array('name' => 'to_value', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => CLX_NUM_HUNDRED, 'validations' => array(array('type' => 'string', 'required' => '1')))
                            )
                        ),))
        )); //end form
    }

    /**
     * Sets form
     * @global type $ac
     * @param type $msg
     * @return string
     */
    function changeFieldValuePrompt(&$msg) {
        $idlist = '';
        //Painting form
        $form = new clx_form($this->code, $this->changeFieldValueForm());
        $contents = $form->editForm(UserRequest::$request['ac'], $idlist, UserRequest::$post, $msg);
        return $contents;
    }

    /**
     * Changes field value from
     * @param type $fieldname
     * @param type $from_value
     * @param type $to_value
     * @param type $msg
     * @return type
     */
    function changeFieldValueBatch($fieldname, $tablecode, $from_value, $to_value, &$msg) {
        $status = false;
        if ($this->changeFieldValueValidate($fieldname, $tablecode, $from_value, $to_value, $msg)) {
            $status = $this->changeFieldValue($fieldname, $tablecode, $from_value, $to_value);
        }
        return $status;
    }

    /**
     * Validacion de datos
     */
    private function changeFieldValueValidate($fieldname, $tablecode, $from_value, $to_value, &$msg) {
        $form = new clx_form($this->code, $this->changeFieldValueForm());
        $form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg);
        //Validar informacion de campo
        $DBFL = &getTool('DBFL');
        $fieldrec = $DBFL->getField($fieldname);
        $allow = false;
        $reqtable = true;
        switch ($fieldrec['FIELDTYPE']) {
            case 'CHAR':
            case 'DATE':
            case 'DATI':
                $allow = true;
                break;
            case 'LOOK':
            case 'SOBJ':
                $allow = true;
                $reqtable = false;
                break;
            default:
                $allow = false;
                break;
        }
        if (!empty($reqtable) && empty($tablecode)) {
            $msg['EDIT_tablecode'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (empty($allow)) {
            $msg['EDIT_fieldname'] = dict('GEN_LBL_FIELDNOTALLOWED');
        }
        if (!empty($tablecode)) {
            $DBTF = &getTool('DBTF');
            if (!$DBTF->fieldExists($tablecode, $fieldname)) {
                $msg['EDIT_fieldname'] = dict('GEN_ERR_TABLEFIELDDONTEXIST');
                $msg['EDIT_tablecode'] = $msg['EDIT_fieldname'];
            }
        }
        if (!empty($msg))
            return false;
        $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
        $fieldinstance->validateImportField($msg, $fieldrec, $to_value);
        if (!empty($msg[$fieldname])) {
            $msg['EDIT_to_value'] = $msg[$fieldname];
        }
        return (empty($msg)) ? true : false;
    }

    /**
     * Changes all field values from
     *
     * @param type $fieldname
     * @param type $from_value
     * @param type $to_value
     * @param type $msg
     * @return boolean
     */
    private function changeFieldValue($fieldname, $tablecode, $from_value, $to_value) {
        //Seleccionar campo
        $sql = 'SELECT DBTB.IDCODE, DBTB.MODULECODE, DBTB.IDNAME, DBTF.FIELDNAME FROM CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF WHERE DBTB.TYPE IN (' . singleQuoteArray(array('InnoDB', 'MyISAM')) . ') AND DBTB.IDCODE = DBTF.TABLECODE AND DBTF.FIELDNAME = ' . singleQuote($fieldname);
        if (!empty($tablecode))
            $sql .= ' AND DBTB.IDCODE = ' . singleQuote($tablecode) . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Check if table can modify
            $taccess = $this->getAppAccess($r['IDCODE'], true);
            if ($taccess->canModify()) {
                ClxCommon::$db->updateRecord($r['MODULECODE'] . '_' . $r['IDNAME'], array($r['FIELDNAME'] => $to_value), $r['FIELDNAME'] . ' = ' . singleQuote($from_value));
            }
        }
        return true;
    }

    /**
     * Resolves ajax request
     *
     * @return string
     */
    function ajax() {
        // ?to=EDIT&ac=DISPLAY&li=MARK_CAMP&qy=MARK_CAMP&idlist=1
        // Nota: to y ac son renombrados al enviarlos como tto y tac
        $to = (array_key_exists('tto', UserRequest::$request)) ? UserRequest::$request ['tto'] : '';
        $ac = (array_key_exists('tac', UserRequest::$request)) ? UserRequest::$request ['tac'] : '';
        UserRequest::$request [CLX_PROP_TO] = $to;
        UserRequest::$request ['ac'] = $ac;
        $idlist = getIdlist();
        $tool = &getTool($to);
        $contents = $tool->action($ac, $idlist);
        if ($contents === '') {
            $contents = '<!-- no result -->';
        }
        return $contents;
    }

    /**
     * Transaction status
     *
     * @return boolean
     */
    function http_tx_status() {
        $status = true;
        if (array_key_exists('clxtx_id', UserRequest::$request) && array_key_exists('clxtx_id', $_SESSION) && $_SESSION ['clxtx_id'] != UserRequest::$request ['clxtx_id']) {
            // Request already set
            $status = false;
        }
        return $status;
    }

    /**
     * Sets transation unique id
     *
     * @param string $tx
     */
    function http_set_tx($tx) {
        $_SESSION ['clxtx_id'] = $tx;
    }

    /**
     * Mark task as complete
     */
    private function bp_complete_task($result_status, &$record, $tablecode = null, $result_rec_id = CLX_NUM_ZERO) {
        if (!empty($_SESSION ['BPCK_task_id'])) {
            // Save parameters back to task
            $BPCK = &getTool('BPCK');
            $BPCK->complete_manual_task($_SESSION ['BPCK_task_id'], $result_status, $record, $tablecode, $result_rec_id);
            unset($_SESSION ['BPCK_task_id']);
        }
    }

    /**
     * Save bp default record
     *
     * @param array $record
     */
    private function bp_default_record(&$record) {
        if (!empty($_SESSION ['BPCK_task_id'])) {
            $BPCK = &getTool('BPCK');
            $BPCK->set_task_default_parameters($_SESSION ['BPCK_task_id'], $record);
        }
    }

    /**
     * Defines security for form panel listings listings
     * @param type $formcode
     * @return type
     */
    private function getFormPanelListings($formcode){
        $callingpage = peekHistory();
        $sec = '';
        if(empty($_SESSION['user_record']['isadmin'])){
            if(!empty($callingpage['menuid'])){
                $sec = 'AND EXISTS(SELECT ACMI.ID FROM CLX_AC_MENUITEMS ACMI WHERE ACMI.MENUID = '.singleQuote($callingpage['menuid']).' AND ACMI.TABLECODE = DBQT.TABLECODE AND ACMI.CANREAD = 1 AND ((ACMI.OWNERCODE = '.singleQuote('USER').' AND ACMI.OWNERREF = '.singleQuote($_SESSION['user_record']['username']).' OR (ACMI.OWNERCODE = '.singleQuote('GRUP').' AND EXISTS (SELECT ACGM.ID FROM CLX_AC_GROUP_MEMBERS ACGM WHERE ACGM.GROUPCODE = ACMI.OWNERREF AND ACGM.USERNAME = '.singleQuote($_SESSION['user_record']['username']).')))))';
            }else{
                $sec = 'AND EXISTS(SELECT ACTA.ID FROM CLX_AC_TABLES ACTA WHERE ACTA.TABLECODE = DBQT.TABLECODE AND ACTA.CANREAD = 1 AND ((ACTA.OWNERCODE = '.singleQuote('USER').' AND ACTA.OWNERREF = '.singleQuote($_SESSION['user_record']['username']).' OR (ACTA.OWNERCODE = '.singleQuote('GRUP').' AND EXISTS (SELECT ACGM.ID FROM CLX_AC_GROUP_MEMBERS ACGM WHERE ACGM.GROUPCODE = ACTA.OWNERREF AND ACGM.USERNAME = '.singleQuote($_SESSION['user_record']['username']).')))))';
            }
        }
        $sql = 'SELECT DISTINCT UIFL.* FROM CLX_UI_FORM_LISTINGS UIFL, CLX_UI_LISTINGS UILG, CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB WHERE DBTB.STATUS = 1 AND UIFL.FORMCODE=' . singleQuote($formcode) . ' AND UIFL.ACTIVE = 1 AND DBTB.IDCODE = DBQT.TABLECODE AND DBQT.QUERYCODE = UILG.QUERYCODE AND UILG.IDCODE = UIFL.LISTINGCODE '.$sec.' ORDER BY UIFL.SEQNUM';
		
		IF (ISSET($_SESSION['ADDRDEBUGUIFORMS']) && $_SESSION['ADDRDEBUGUIFORMS']==$_SERVER['REMOTE_ADDR']) {
			echo "----QUERY PARA LISTADOS EXTRAS------>",  pre($sql);
		}
		return ClxCommon::$db->executeQuery($sql);
    }
}
