<?php

/**
 * Telemarketing Campaign Section Tool
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-04-21 13:22:23 -0400 (Sat, 21 Apr 2018) $
 * @version    	$Rev: 9802 $
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class ma_telemarketing extends clx_tool {

    var $target = CLX_INIT_ZERO;
    var $targetRec = array();
    var $questionary_code = '';
    var $sectionId = CLX_INIT_ZERO;
    var $ownercode = '';
    var $questions = array();
    var $questionId = CLX_INIT_ZERO;
    var $a1astQuestionId = CLX_INIT_ZERO;
    var $nextQuestion = CLX_INIT_ZERO;
    var $resultTargetId = CLX_INIT_ZERO;
    var $now;
    var $act = '';
    var $queryfields = array();
    var $debug = false;
    var $camptarget_id = CLX_INIT_ZERO;

    // Constructor
    function __construct() {
        $this->code = 'MATE';
        $this->name = 'Telemarketing Section';
        $this->system = 'Interface';
        $this->version = '7.0.0.0';
        $this->has_preferences = true;
        $this->has_access = true;


        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';



        $this->target = CLX_INIT_ZERO;
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->sectionId = (!empty(UserRequest::$request['ri'])) ? UserRequest::$request['ri'] : '';
        $this->ownercode = (!empty($_SESSION['user_record']['username'])) ? $_SESSION['user_record']['username'] : '';
        $this->nextQuestion = (!empty(UserRequest::$request['NEXT_QUESTION'])) ? UserRequest::$request['NEXT_QUESTION'] : '';
        $this->questionId = (!empty(UserRequest::$request['qui'])) ? UserRequest::$request['qui'] : '';
        $this->resultTargetId = (!empty(UserRequest::$request['rtg'])) ? UserRequest::$request['rtg'] : '';
        $this->act = (!empty(UserRequest::$request['act'])) ? UserRequest::$request['act'] : '';
        $this->questionary_code = '';
        //Building table namesfor marketing module
        multiTableName($this, array('CAMP', 'CTGT', 'CQRY', 'CEML', 'CTMK', 'CEMR', 'CEME', 'LEAD', 'PRTB', 'CEMA', 'CTMA', 'CTOT', 'PRRC', 'CTEA', 'CTER', 'CQRL', 'CAEX', 'AGTO'));
    }

    /**
     * Action controler
     *
     * @param unknown_type $ac
     * @param unknown_type $idlist
     * @return unknown
     */
    function action($ac, $idlist = '') {
        $contents = '';
        //echo '$this->resultTargetId: '.$this->resultTargetId.'</br>' ;
        if (!$this->verif_exist_resultId($this->resultTargetId)){
            //echo 'no existe resultTargetId - SALTANDO';
            $ac="EXECUTE";
        }
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'START':
                    $contents = $this->start_script();
                    break;
                case 'EXECUTE':
                    if (empty($this->sectionId)) {
                        $contents = $this->action('START', $idlist);
                    } else {
                        $contents = $this->execute_();
                    }
                    break;
                case 'NEXT_QUESTION':
                    ClxFreeReturn($this->processAnswer());
                    $this->lastQuestionId = UserRequest::$request['qui'];
                    $contents = $this->execute_();
                    break;
                case 'OOUT':
                    ClxFreeReturn($this->optout());
                    $contents = $this->execute_();
                    break;
                case 'RESC':
                    $msg = array();
                    if (!empty(UserRequest::$request['CALL_DATE'])) {
                        $res = $this->rescheduleCall($msg);
                    } else {
                        $res = false;
                    }
                    if (empty($res)) {
                        $contents = $this->rescheduleForm($msg);
                    } else {
                        UserRequest::$request['ac'] = 'EXECUTE';
                        $contents = $this->execute_();
                    }
                    break;
                case 'BADT':
                    ClxFreeReturn($this->changeResultStatus('BADT'));
                    $contents = $this->execute_();
                    break;
                case 'RUN_CAMP':
                    //Starting Campaigns
                    ClxFreeReturn($this->changeSectionStatus('RUN_ALL'));
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }//end switch
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [MA_TELEMARKETING-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makeList($a1istingcode = null) {
        return CLX_CHAR_HTML_NBSP;
    }

    function start_script() {
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'START', array());
        if ($this->userOnAbsence()) {
            return note(dict('GEN_LBL_MARK_USER_ABSENT'));
        }
        $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', CLX_PROP_TARGET, 'blank');
        $form->setProp('ID', 'START');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $form->addArgument('li', '');
        $form->addArgument('NEXT_QUESTION', CLX_NUM_MINUS_1);
        $selectclause = 'CAMP.IDNAME CAMP_NAME, TELE.*';
        $fromclause = 'MARK_CAMPAIGNS CAMP, MARK_CAMPSEC_TELEMARK TELE, MARK_CAMPSEC_TELEMARK_AGENTS TELEA';
        $whereclause = 'CAMP.IDCODE = TELE.CAMPAIGNCODE AND TELE.IDCODE=TELEA.CAMPSECTION_TELEMARK_CODE AND TELE.CAMPSECTION_STATUS = ' . singleQuote('WORK') . ' AND TELEA.USER_AGENT=' . singleQuote($this->ownercode) . ' AND CAMP.DELETED=0 AND TELE.DELETED=0 AND TELEA.DELETED=0';
        $sortclause = 'TELE.ID';
        $page = new xPaging();
        $page->specs['selector'] = CLX_INIT_ZERO;
        $page->pageInit($form->getProp('ID'), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_SIX);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LABEL_TELE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        //Field Labels
        $DBFL = &getTool('DBFL');
        $a11 = ClxCommon::$db->getRecord($DBFL->tablename, 'FIELDNAME=' . singleQuote('IDNAME') . '');
        $a15 = ClxCommon::$db->getRecord($DBFL->tablename, 'FIELDNAME=' . singleQuote('CAMPAIGNCODE') . '');
        $a12 = ClxCommon::$db->getRecord($DBFL->tablename, 'FIELDNAME=' . singleQuote('QUESTIONARY_CODE') . '');
        $a13 = ClxCommon::$db->getRecord($DBFL->tablename, 'FIELDNAME=' . singleQuote('SDATE') . '');
        $a14 = ClxCommon::$db->getRecord($DBFL->tablename, 'FIELDNAME=' . singleQuote('CAMPSECTION_STATUS') . '');
        $DBLI = &getTool('DBLI');
        $page->header($table);
        $table->addCell(dict('GEN_LBL_SELECT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_ALIGN => 'center', CLX_PROP_WIDTH => '1%'));
        $table->addCell(dict($a15['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        $table->addCell(dict($a11['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        $table->addCell(dict($a12['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        $table->addCell(dict($a14['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        $table->addCell(dict($a13['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        $i = CLX_INIT_ZERO;
        unset($a11, $a12, $a13);
        while ($record = $page->nextRecord()) {
            $DBLIRecord = ClxCommon::$db->getRecord($DBLI->tablename, 'LISTCODE=' . singleQuote($a14['FIELD_EXTRA1']) . ' AND IDCODE=' . singleQuote($record['CAMPSECTION_STATUS']));
            $recordid = $record['ID'];
            if (!$this->checkRescheduleCalls($recordid)) {
                $this->sectionId = $recordid;
                ClxFreeReturn($this->changeSectionStatus('WORK'));
                $this->sectionId = CLX_INIT_ZERO;
            }
            $select = new htmlRadioButton('ri', false, $recordid);
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_ALIGN => 'center', CLX_PROP_WIDTH => '1%'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['CAMPAIGNCODE'], $record['CAMP_NAME'], $record['QUESTIONARYCODE'], dict($DBLIRecord['IDNAME']), $record['SDATE']));
            $i++;
        }
        $buttons = '';
        $b = new htmlFormSubmit(dict('GEN_LBL_EXECUTE'), 'EXECUTE', $form->getProp(CLX_PROP_ID));
        $buttons .= $b->source();
        $b = new htmlButtonReturn();
        $buttons .= $b->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    /**
     * Return campaign target from target result
     */
    function getCampaignTargetId($resultid) {
        return (!empty($resultid)) ? ClxCommon::$db->getField(tableName('CTER'), 'CAMPTARGET_ID', 'ID='.$resultid) : CLX_NUM_ZERO;
    }

    function execute_() {
        $sectionRec = $this->getSection($this->sectionId);
        //Init some variables
        $ANQN = getTool('ANQN');
        //Sets parent table names
        $ANQN->initParentTable($sectionRec['QUESTIONARYCODE']);
        //load tele section code
        $ANQN->mark_camp_tele_code = $sectionRec['IDCODE']; //set campaign section
        $this->questionary_code = $sectionRec['QUESTIONARYCODE'];
        $this->questionary_parent_table_code = $ANQN->parent_table_code;
        $this->questionary_parent_table = $ANQN->parent_table;
        if (!empty($sectionRec) || $sectionRec['CAMPSECTION_STATUS'] === 'HOLD') {
            ClxFreeReturn($this->changeSectionStatus('WORK'));
        } elseif (empty($sectionRec) || $sectionRec['CAMPSECTION_STATUS'] !== 'WORK') {
            return $this->action('START', '');
        }
        $sectionStatus = 'WORK';
        //$this->target returns telemarketing result code
        $this->target = $this->findTargets($sectionRec['CAMPAIGNCODE']);
        $ANQN->camp_target_id = $this->camptarget_id;
        if (empty($this->target)) {
            if (!$this->checkRescheduleCalls($this->sectionId)) {
                ClxFreeReturn($this->changeSectionStatus('END'));
            }
            $sectionStatus = 'END';
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => 'table', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell('Section Execute', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        $table->addCell(' &nbsp;', array(CLX_PROP_CLASS=>CLX_PROP_COLSPAN, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS=> CLX_CLASS_HEADERS, CLX_PROP_COLSPAN=> CLX_WIDTH_SIX));
        if ($sectionStatus === 'WORK') {
            $targetRecord = $this->targetRec;
            ClxFreeReturn($this->getQuerionary($sectionRec['QUESTIONARYCODE']));

            ClxFreeReturn($this->nextQuestion());
            $table2 = new htmlTable(CLX_WIDTH_ONE);
            $table2->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '5', CLX_PROP_CLASS => 'table'));
            $table2->addCell($this->showTarget($targetRecord), array('' => ''));
            $table2->addCell($this->showCallMenu(), array('' => ''));
            $ANQN->update_parent_at_end = true;
            $campaing_target_result_id = $this->getCampaignTargetId($this->target);
            $qids = ClxCommon::$db->getFields($ANQN->tablename, 'ID, IDCODE, RESULT_TABLECODE', 'IDCODE = ' . singleQuote($sectionRec['QUESTIONARYCODE']));
            $this->saveResultIncludeFields($qids['RESULT_TABLECODE']);
            $runid = $ANQN->getRunid($qids);
            if (!empty($runid)) {
                $this->saveResultFields($qids['RESULT_TABLECODE'], $runid, $sectionRec['IDCODE'], $campaing_target_result_id, '');
            }
            //Questionary initAnswer will get parent if tc and idlist is passed on _REQUEST
            $ANQN->parent_id = $targetRecord['REC_ID']; //revisar
            $quest_content = $ANQN->executeQuestinary($qids['ID']);
            if ($ANQN->isQuestionaryEnd()) {
                if (empty($this->parent_table_id))
                    $this->parent_table_id = CLX_INIT_ZERO;
                $ANQN->setParentTableId($sectionRec['QUESTIONARYCODE'], $this->parent_table_id);
                $ANQN->runid = $runid;
                $ANQN->updateAllParents($sectionRec['QUESTIONARYCODE']);
                ClxFreeReturn($this->changeResultStatus('END'));
                //save result if exists
            }
            $table->addCell($table2->source(), array(CLX_PROP_WIDTH => '30%', CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
            $table->addCell($quest_content, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
        }

        //echo '</br>execute: '.$this->resultTargetId.'</br>';

        //------------actualizo en tabla de resultados del cuestionario con el ID-----------------// 
        //obtenemos la tabla de resultados del cuestionario junto a los campos que serviran de criterio
        $sql = "SELECT ANQN.MODULECODE, ANQN.RESULT_TABLECODE AS TABLECODE, CTMK.QUESTIONARYCODE, CTER.CAMPSECTION_TELE_CODE, CTER.CAMPTARGET_ID 
                FROM CLX_AN_QUESTIONARIES ANQN, MARK_CAMPSEC_TELEMARK CTMK, MARK_CAMPSEC_TELEMARK_RES CTER
		   		WHERE 
                CTER.ID='".$this->resultTargetId."' AND
                CTER.CAMPSECTION_TELE_CODE=CTMK.IDCODE AND
                CTMK.QUESTIONARYCODE=ANQN.IDCODE";
        $results = ClxCommon::$db->executeQuery($sql);

        if (($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) == true) {
            $sql2="UPDATE ".$result['MODULECODE']."_".$result['TABLECODE']." SET CAMPTELERES_ID='$this->resultTargetId' 
                   WHERE 
                   QUESTIONARY_CODE='".$result['QUESTIONARYCODE']."' AND
                   CAMPSECTION_TELE_CODE='".$result['CAMPSECTION_TELE_CODE']."' AND
                   CAMPTARGET_ID='".$result['CAMPTARGET_ID']."'";
            ClxCommon::$db->executeQuery($sql2);
        }

        //e cho '<br>End execute';
        return $table->source();
    }

    /**
     * Finds the next target and prepare it into execution.
     * return execution id
     *
     * @param string $campaigncode
     * @return integer
     */
    function findTargets($campaigncode) {
        
        // 2021-10-05 EC INTENTA BUSCAR LOS TARGETS QUE TIENEN ESTATUS WORK Y QUE HAN SIDO EXCEDIDO EL TIEMPO 
        // PARA EJECUTARLO POR PARTE DE UN AGENTE. SI SE DA EL CASO SE LIBERA EL TARGET PARA QUE EL MISMO PROCESO
        //LO ASIGNE A CUALQUIER AGENTE
        //echo 'pasó por findTargets';
        $targetsincambios=kSessionTimeout+1; //tiempo maximo de espera de un target sin actividad
        //$targetsincambios=5; 

        $sql = "SELECT CTER.ID, CTER.CAMPAIGNCODE, CTER.EXEC_DATE, CTER.RESULT_CODE, CTER.CAMPTARGET_ID, CTER.QUERYCODE, 
                CTER.CAMPSECTION_TELE_CODE, ANQN.MODULECODE, ANQN.RESULT_TABLECODE
                FROM CLX_AN_QUESTIONARIES ANQN, MARK_CAMPSEC_TELEMARK CTMK, MARK_CAMPSEC_TELEMARK_RES CTER
                WHERE 
                CTER.CAMPSECTION_TELE_CODE=CTMK.IDCODE AND
                CTMK.QUESTIONARYCODE=ANQN.IDCODE AND
                CTER.RESULT_CODE='WORK' AND 
                TIMESTAMPDIFF(MINUTE, CTER.EXEC_DATE, '".$this->now."')>".$targetsincambios." AND CTER.CAMPAIGNCODE = '" . $campaigncode . "'";
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //BORRAMOS EL RESULTADO WORK DE LA TABLA DE RESULTADOS DEL CUESTIONARIO 
            //echo '</br>entró a borrar target en findTargets</br>';
            $sql="DELETE FROM ".$r['MODULECODE'].'_'.$r['RESULT_TABLECODE']." 
                  WHERE 
                  CAMPTELERES_ID=".$r['ID'];
            ClxCommon::$db->executeQuery($sql);
            //BORRAMOS EL RESULTADO WORK DE LA TABLA CTER
            $sql="DELETE FROM MARK_CAMPSEC_TELEMARK_RES WHERE ID='".$r['ID']."'";
            ClxCommon::$db->executeQuery($sql);

        }

        /**************************************************************************************************/

        $date = date('Y-m-d');
        //$sql = 'UPDATE MARK_CAMPSEC_TELEMARK_RES CTER SET CTER.NEXT_CALL_DATE = ' . singleQuote($date) . ' WHERE CTER.RESULT_CODE IN (' . singleQuote('RESC') . ',' . singleQuote('NOAN') . ') AND (CTER.NEXT_CALL_DATE IS NULL OR CTER.NEXT_CALL_DATE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND CTER.CAMPAIGNCODE = ' . singleQuote($campaigncode);
        $sql = 'UPDATE MARK_CAMPSEC_TELEMARK_RES CTER SET CTER.NEXT_CALL_DATE = ' . singleQuote($date) . ' WHERE CTER.RESULT_CODE IN (' . singleQuote('RESC') . ',' . singleQuote('NOAN') . ') AND (CTER.NEXT_CALL_DATE IS NULL OR CTER.NEXT_CALL_DATE = ' . singleQuote('0000-00-00') . ') AND CTER.CAMPAIGNCODE = ' . singleQuote($campaigncode);
        ClxCommon::$db->executeQuery($sql);
        //Revising absences:
        //Cambiar los agentes de targets donde
        //exista ausencia con rango de fecha actual
        if (!empty($this->agtoname)) { 
            $sql = 'SELECT DISTINCT CTMK.IDCODE, CTMK.CAMPAIGNCODE, AGTO.USER_CODE, AGTO.ASSIGNTO_USER, AGTO.TIMEOFF_TYPE, AGTO.START_DATE, AGTO.END_DATE FROM ' . $this->agtoname . ' AGTO, ' . $this->ctmaname . ' CTMA, ' . $this->ctmkname . ' CTMK WHERE AGTO.REQ_STATUS = ' . singleQuote('AP') . ' AND CTMK.CAMPSECTION_STATUS <> ' . singleQuote('END') . ' AND CTMK.IDCODE = CTMA.CAMPSECTION_TELEMARK_CODE AND CTMA.USER_AGENT = AGTO.USER_CODE AND CTMK.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND AGTO.START_DATE<=' . singleQuote($date) . ' AND (AGTO.END_DATE>=' . singleQuote($date) . ' OR AGTO.END_DATE IS NULL) AND CTMA.DELETED=0 AND CTMK.DELETED=0';
            //??                                                                                                                                                                                 $this->ctmaname . ' CTMA, ' . $this->ctmkname . ' CTMK WHERE                                                 CTMK.CAMPSECTION_STATUS <> ' . singleQuote('END') . ' AND CTMK.IDCODE = CTMA.CAMPSECTION_TELEMARK_CODE                                      AND CTMK.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND AGTO.START_DATE<=' . singleQuote($date) . ' AND (AGTO.END_DATE>=' . singleQuote($date) . ' OR AGTO.END_DATE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR AGTO.END_DATE IS NULL) AND CTMA.DELETED=0 AND CTMK.DELETED=0';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                //Change reschedule
                //' . $r['ASSIGNTO_USER'].' se quita asignado para que caiga en cualquier agente disponible
                $sql = 'UPDATE MARK_CAMPSEC_TELEMARK_RES CTER SET CTER.NEXT_CALL_DATE = ' . singleQuote($this->now) . ', CTER.CALL_USER = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' WHERE CTER.RESULT_CODE IN (' . singleQuote('RESC') . ',' . singleQuote('NOAN') . ') AND CTER.NEXT_CALL_DATE>' . singleQuote(adodb_prev_day($r['START_DATE'])) . ' AND CTER.NEXT_CALL_DATE<' . singleQuote($adodb_next_day($r['END_DATE'])) . ' AND CTER.CALL_USER = ' . singleQuote($r['USER_CODE']) . ' AND CTER.CAMPAIGNCODE = ' . singleQuote($r['CAMPAIGNCODE']);//echo "<br>",$sql;
                CLX_PROP_100PCTexecuteQuery($sql);
                //Set reschedule to working entries for absence
                $sql = 'UPDATE MARK_CAMPSEC_TELEMARK_RES CTER SET CTER.NEXT_CALL_DATE = ' . singleQuote($this->now) . ', CTER.CALL_USER = ' . singleQuote($r['ASSIGNTO_USER']) . ', CTER.RESULT_CODE = ' . singleQuote('RESC') . ' WHERE CTER.RESULT_CODE=' . singleQuote('WORK') . ' AND CTER.CALL_USER = ' . singleQuote($r['USER_CODE']);
                ClxCommon::$db->executeQuery($sql);
            }
        }//not empty agto
        //1. Search cases on status work, should be done first
        $sql = 'SELECT CTGT.* 
                FROM MARK_CAMPAIGN_TARGETS CTGT, MARK_CAMPAIGN_QUERIES CQRY, MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK 
                WHERE 
                CTGT.CQRY_CODE = CQRY.IDCODE AND 
                CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND 
                CTER.CAMPTARGET_ID_TABLE = '.singleQuote('CTGT').' AND
                CTER.CAMPTARGET_ID=CTGT.ID AND 
                CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND 
                CTGT.PHONE IS NOT null AND 
                CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND 
                CTMK.CAMPAIGNCODE = CQRY.CAMPAIGNCODE AND 
                CTMK.ID = ' . $this->sectionId . ' AND 
                CTGT.PHONE<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' 
                AND CTGT.STATUS = ' . singleQuote('A') . ' AND 
                CQRY.STATUS = ' . singleQuote('A') . ' AND 
                CTER.RESULT_CODE =' . singleQuote('WORK') . ' AND 
                CTER.OWNERCODE = ' . singleQuote($this->ownercode) . ' AND 
                CTGT.DELETED=0 AND CQRY.DELETED=0 AND CTMK.DELETED=0 
                ORDER BY CTGT.ID ASC 
                LIMIT 1 
                FOR UPDATE';//echo "<br>",$sql;die;
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $target = $this->setTarget($result);
            return $target;
        }
        //2. If not work found then Search cases on status resc
        $sql = 'SELECT CTGT.* 
                FROM MARK_CAMPAIGN_TARGETS CTGT, MARK_CAMPAIGN_QUERIES CQRY, MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK 
                WHERE 
                CTGT.CQRY_CODE = CQRY.IDCODE AND 
                CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND 
                CTER.CAMPTARGET_ID_TABLE = '.singleQuote('CTGT').' AND
                CTER.CAMPTARGET_ID=CTGT.ID AND 
                CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND 
                CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND 
                CTMK.CAMPAIGNCODE = CQRY.CAMPAIGNCODE AND 
                CTMK.ID = ' . singleQuote($this->sectionId) . ' AND 
                CTGT.PHONE IS NOT null AND 
                CTGT.PHONE<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND 
                CTGT.STATUS = ' . singleQuote('A') . ' AND 
                CQRY.STATUS = ' . singleQuote('A') . ' AND 
                CTER.RESULT_CODE IN (' . singleQuote('RESC') . ',' . singleQuote('NOAN') . ') AND 
                CTER.NEXT_CALL_DATE<=' . singleQuote($this->now) . ' AND 
                (CTER.CALL_USER IN (' . singleQuote($this->ownercode) . ',' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') OR  CTER.CALL_USER IS NULL) AND 
                CTGT.DELETED=0 AND CQRY.DELETED=0 AND CTMK.DELETED=0 
                ORDER BY CTGT.ID ASC 
                LIMIT 1 
                FOR UPDATE';
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $target = $this->setTarget($result);
            return $target;
        }
        //3. if no work then try any other
        /*
         * too heavy rewriten next
          $sql = 'SELECT CTGT.* FROM MARK_CAMPSEC_TELEMARK CTMK, MARK_CAMPAIGN_TARGETS CTGT, MARK_CAMPAIGN_QUERIES CQRY WHERE CTGT.CQRY_CODE = CQRY.IDCODE AND CQRY.CAMPAIGNCODE = '. singleQuote($campaigncode).' AND CTGT.PHONE IS NOT null AND CTMK.CAMPAIGNCODE = CQRY.CAMPAIGNCODE AND CTMK.ID = ' . $this->sectionId.' AND CTGT.PHONE<>'' AND CTGT.STATUS = ' . singleQuote('A').' AND CQRY.STATUS = ' . singleQuote('A').' AND NOT EXISTS(SELECT X.ID FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPAIGNCODE = CTMK.CAMPAIGNCODE AND X.CAMPTARGET_ID=CTGT.ID AND X.RESULT_CODE = 'BADT') AND NOT EXISTS(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = CTGT.PHONE) AND NOT EXISTS(SELECT CTER.ID FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CTER.CAMPTARGET_ID = CTGT.ID AND CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE) ORDER BY CTGT.ID ASC LIMIT 1'; */
        $sql = 'SELECT CTGT.*, CQRY.CAMPAIGNCODE CQRY_CAMPAIGNCODE 
                FROM MARK_CAMPAIGN_QUERIES CQRY, MARK_CAMPAIGN_TARGETS CTGT 
                WHERE 
                CTGT.CQRY_CODE = CQRY.IDCODE AND 
                CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND 
                CTGT.STATUS = ' . singleQuote('A') . ' AND 
                CQRY.STATUS = ' . singleQuote('A') . ' AND 
                CTGT.DELETED=0 AND 
                CQRY.DELETED=0 AND 
                CTGT.PHONE<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND 
                CTGT.PHONE IS NOT null AND 
                NOT EXISTS(SELECT X.ID FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND X.CAMPTARGET_ID_TABLE = '.singleQuote('CTGT').' AND X.CAMPTARGET_ID=CTGT.ID AND X.RESULT_CODE = ' . singleQuote('BADT') . ') AND 
                NOT EXISTS(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = CTGT.PHONE) AND 
                NOT EXISTS(SELECT CTER.ID FROM MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK WHERE CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CTER.CAMPTARGET_ID_TABLE = '.singleQuote('CTGT').' AND CTER.CAMPTARGET_ID = CTGT.ID AND CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND CTMK.ID = ' . $this->sectionId . ' AND CTMK.DELETED=0) 
                ORDER BY CTGT.ID ASC 
                LIMIT 1 
                FOR UPDATE';
        $result = ClxCommon::$db->getOneRecord($sql);//echo "<br>",$sql;
        if (!empty($result)) {
            $result['CAMPAIGNCODE'] = $result['CQRY_CAMPAIGNCODE'];
            $target = $this->setTarget($result);
            return $target;
        }
	
    /************************* PARA TARGETS QUE SE OBTIENEN POR QUERY **************************************/    
    $target = CLX_INIT_ZERO;
     //1. 05-10-2021 E.C Search cases on status work, should be done first
        $sql = 'SELECT CQRY.* FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND CQRY.QUERYLIST_CODE IS NOT NULL AND CQRY.QUERYLIST_CODE <> '.singleQuote(CLX_CHAR_EMPTY_STRING).' AND CQRY.STATUS = '.singleQuote('A').' AND CQRY.DELETED = 0' .
            ' AND NOT EXISTS (SELECT CTGT.ID FROM MARK_CAMPAIGN_TARGETS CTGT WHERE CQRY.IDCODE = CTGT.CQRY_CODE AND CTGT.STATUS = '.singleQuote('A').' AND CTGT.DELETED=0 AND CTGT.PHONE<>'.singleQuote(CLX_CHAR_EMPTY_STRING).' AND CTGT.PHONE IS NOT NULL AND NOT EXISTS(SELECT X.ID FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND X.CAMPTARGET_ID=CTGT.ID AND X.RESULT_CODE = '.singleQuote('WORK').') AND NOT EXISTS(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = CTGT.PHONE) AND NOT EXISTS (SELECT CTER.ID FROM MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK WHERE CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CTER.CAMPTARGET_ID = CTGT.ID AND CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND CTMK.ID = ' . $this->sectionId . ' AND CTMK.DELETED=0) )';

    if ($cqry = ClxCommon::$db->getOneRecord($sql)) {
        $this->CEML_get_query_sql($cqry);
        $result = $this->CEML_run_sql_targets3();
        if (!empty($result)) {
            $result['CAMPAIGNCODE'] = $campaigncode;
            //$result['QUERYLIST_CODE'] = $cqry['QUERYLIST_CODE'];
            $result['CAMPTARGET_ID_TABLE'] = $this->CEML_prmts['tablecode'];
            //echo  '</br>Antes de REsultado query target RESC / NOAN: '.$this->resultTargetId.'</br>';
            $target = $this->setTarget($result);
            $sql = "UPDATE $this->ctername SET
                    EXEC_DATE = '$this->now',
                    NEXT_CALL_DATE = ''
                    WHERE ID = ".$target;
            ClxCommon::$db->executeQuery($sql); 
                //echo  '</br>REsultado query target que se esta atendiendo: '.$target.'</br>';
            return $target;
        }
    } 

    //2.  2021-10-04 EC Intenta buscar los targets que tienen estatus RESC o NOAN para retomarlos
    $sql = 'SELECT CQRY.* FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND CQRY.QUERYLIST_CODE IS NOT NULL AND CQRY.QUERYLIST_CODE <> '.singleQuote(CLX_CHAR_EMPTY_STRING).' AND CQRY.STATUS = '.singleQuote('A').' AND CQRY.DELETED = 0' .
            ' AND NOT EXISTS (SELECT CTGT.ID FROM MARK_CAMPAIGN_TARGETS CTGT WHERE CQRY.IDCODE = CTGT.CQRY_CODE AND CTGT.STATUS = '.singleQuote('A').' AND CTGT.DELETED=0 AND CTGT.PHONE<>'.singleQuote(CLX_CHAR_EMPTY_STRING).' AND CTGT.PHONE IS NOT NULL AND NOT EXISTS(SELECT X.ID FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND X.CAMPTARGET_ID=CTGT.ID AND X.RESULT_CODE = '.singleQuote('RESC').') AND NOT EXISTS(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = CTGT.PHONE) AND NOT EXISTS (SELECT CTER.ID FROM MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK WHERE CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CTER.CAMPTARGET_ID = CTGT.ID AND CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND CTMK.ID = ' . $this->sectionId . ' AND CTMK.DELETED=0) )';

    if ($cqry = ClxCommon::$db->getOneRecord($sql)) {
        $this->CEML_get_query_sql($cqry);
        $result = $this->CEML_run_sql_targets2();
        if (!empty($result)) {
            $result['CAMPAIGNCODE'] = $campaigncode;
            //$result['QUERYLIST_CODE'] = $cqry['QUERYLIST_CODE'];
            $result['CAMPTARGET_ID_TABLE'] = $this->CEML_prmts['tablecode'];
            //echo  '</br>Antes de REsultado query target RESC / NOAN: '.$this->resultTargetId.'</br>';
            $target = $this->setTarget($result);
            $sql = "UPDATE $this->ctername SET
                    EXEC_DATE = '$this->now',
                    NEXT_CALL_DATE = ''
                    WHERE ID = ".$target;
             ClxCommon::$db->executeQuery($sql); 
                //echo  '</br>REsultado query target que se esta atendiendo: '.$target.'</br>';
                return $target;
        }
    }                

    //3. 2017-04-06 CR Intenta con los Query que PARA buscar un nuevo target
	$sql = 'SELECT CQRY.* FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND CQRY.QUERYLIST_CODE IS NOT NULL AND CQRY.QUERYLIST_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND CQRY.STATUS = '. singleQuote('A') . ' AND CQRY.DELETED = 0 AND NOT EXISTS (SELECT CTGT.ID FROM MARK_CAMPAIGN_TARGETS CTGT WHERE CQRY.IDCODE = CTGT.CQRY_CODE AND CTGT.STATUS = ' . singleQuote('A') . ' AND CTGT.DELETED=0 AND CTGT.PHONE<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND CTGT.PHONE IS NOT NULL AND NOT EXISTS(SELECT X.ID FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND X.CAMPTARGET_ID=CTGT.ID AND X.RESULT_CODE = ' . singleQuote('BADT') . ') AND NOT EXISTS(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = CTGT.PHONE) AND NOT EXISTS (SELECT CTER.ID FROM MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPSEC_TELEMARK CTMK WHERE CTER.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CTER.CAMPTARGET_ID = CTGT.ID AND CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND CTMK.ID = ' . $this->sectionId . ' AND CTMK.DELETED=0) )';//echo "<br>",$sql;
	if ($cqry = ClxCommon::$db->getOneRecord($sql)) {
            $this->CEML_get_query_sql($cqry);
            $result = $this->CEML_run_sql_targets();
            if (!empty($result)) {
                $result['CAMPAIGNCODE'] = $campaigncode;
                $result['CAMPTARGET_ID_TABLE'] = $this->CEML_prmts['tablecode'];
                $target = $this->setTarget($result);
                return $target;
            }
	}
        return $target;
    }

    /**
     * Prepare result record and return result record id
     *
     * @param unknown_type $target
     * @return unknown
     */
    function setTarget(&$target) {
        $record = array();
        $record['CAMPAIGNCODE'] = $target['CAMPAIGNCODE'];
	    $record["CONTACTID"] = (isset($target['CONTACTID']) ? $target['CONTACTID'] : CLX_NUM_ZERO);
        $record['EXEC_DATE'] = $this->now;
        $record['CALL_DATE'] = $this->now;
	    //$record['CAMPTARGET_ID'] = (!isset($target['CAMPTARGET_ID_TABLE']) || (isset($target['CAMPTARGET_ID_TABLE']) && $target['CAMPTARGET_ID_TABLE'] === 'CTGT') ? $target['ID'] : CLX_NUM_ZERO);
        $record['CAMPTARGET_ID'] = (!isset($target['CAMPTARGET_ID_TABLE']) || (isset($target['CAMPTARGET_ID_TABLE']) && $target['CAMPTARGET_ID_TABLE'] === 'CTGT') ? $target['ID'] : $target['CONTACTID']);
        $record['CAMPTARGET_ID_TABLE'] = (isset($target['CAMPTARGET_ID_TABLE']) ? $target['CAMPTARGET_ID_TABLE'] : 'CTGT');
        $record['OWNERCODE'] = $this->ownercode;
        $record['CAMPTARGET_NAME'] = $target['FIRSTNAME'] . ' ' . $target['LASTNAME'];
        
        $record['EMAIL'] = $target['EMAIL'];
        $record['PHONE'] = $target['PHONE'];
        $record['MOBILE_PHONE'] = $target['MOBILE_PHONE'];
        $record['HOME_PHONE'] = $target['HOME_PHONE'];

        $record['RESULT_CODE'] = 'WORK';
        $record['CAMPSECTION_TELE_CODE'] = $this->getSectionCode($this->sectionId);
        $record['QUERYCODE'] = $target['QUERYCODE'];
        $record['REC_ID'] = (!isset($target['CAMPTARGET_ID_TABLE']) || (isset($target['CAMPTARGET_ID_TABLE']) && $target['CAMPTARGET_ID_TABLE'] === 'CTGT') ? $target['REC_ID'] : $target['ID']);
        $target['CAMPTARGET_ID_TABLE'] = $record['CAMPTARGET_ID_TABLE'];
        $this->camptarget_id = $target['ID'];
        $this->parent_table_id = $target['REC_ID']; //SET FOR TARGET
        $this->resultTargetId = CLX_INIT_ZERO; //init variable
        //Retrieve status
        /*$sql = 'SELECT CTER.* 
                FROM ' . $this->ctmkname . ' CTMK,' . $this->ctername . ' CTER 
                WHERE 
                CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND 
                CTMK.DELETED=0 AND CTMK.ID = ' . $this->sectionId . '  AND ' . 
                ($this->camptarget_id !== CLX_NUM_ZERO ? 'CTER.CAMPTARGET_ID='.$this->camptarget_id : 'CTER.REC_ID='.$this->parent_table_id) . ' AND 
                (CTER.OWNERCODE = ' . singleQuote($this->ownercode) . ' OR 
                    CTER.CALL_USER = ' . singleQuote($this->ownercode) . ' OR 
                    CTER.CALL_USER = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR 
                    CTER.CALL_USER IS NULL)';*/
        
        $sql = 'SELECT CTER.* 
                FROM ' . $this->ctmkname . ' CTMK,' . $this->ctername . ' CTER 
                WHERE 
                CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND 
                CTMK.DELETED=0 AND 
                CTMK.ID = ' . $this->sectionId . '  AND ' . 
                ($this->camptarget_id != CLX_NUM_ZERO ? 'CTER.CAMPTARGET_ID='.$this->camptarget_id : 'CTER.REC_ID='.$this->parent_table_id) . ' AND 
                CTER.CAMPTARGET_ID_TABLE = '. singleQuote($record['CAMPTARGET_ID_TABLE']).' AND
                CTER.CONTACTID = '.singleQuote($record["CONTACTID"]).' AND
                (CTER.OWNERCODE = ' . singleQuote($this->ownercode) . ' OR 
                    CTER.CALL_USER = ' . singleQuote($this->ownercode) . ' OR 
                    CTER.CALL_USER = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR 
                    CTER.CALL_USER IS NULL)';
        $cterrec = ClxCommon::$db->getOneRecord($sql);
        if (empty($cterrec)) {
            $record['CALL_USER']= $_SESSION["user_record"]["username"];
            $this->targetRec = $target; //setting target
            
            //04-10-2021 E.C VERIFICAMOS ANTES DE CREAR UNA NUEVA ENTRADA QUE EL TARGET NO LO ESTA TRABAJANDO OTRO AGENTE
            $sql_verif = 'SELECT CTER.*
		        FROM '.$this->ctmkname.' CTMK,'.$this->ctername.' CTER
		        WHERE
		            CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE
                    AND CTMK.DELETED=0
		            AND CTMK.ID = '.singleQuote($this->sectionId).
		            ' AND ' . ($this->camptarget_id != 0 ? 'CTER.CAMPTARGET_ID=' . $this->camptarget_id : 'CTER.REC_ID=' . $this->parent_table_id) . '
                    AND CTER.CAMPTARGET_ID_TABLE = '. singleQuote($record['CAMPTARGET_ID_TABLE']).' 
                    AND CTER.CONTACTID = '.$record["CONTACTID"].'
                    AND CTER.CALL_USER NOT IN ('.singleQuote($this->ownercode).')
                    FOR UPDATE';            

            $cterverif = ClxCommon::$db->getOneRecord($sql_verif);
            //echo '</BR>$cterverif'.pre($cterverif);
            //echo $sql_verif;
            if (empty($cterverif)) {
                $this->resultTargetId = ClxCommon::$db->createRecord($this->ctername, $record, false);
                //ECHO 'CREANDO REGISTRO';
                //echo 'PRIMER REGISTRO EN RESULTADOS </BR>';
            }else{
                //DEBEMOS REDIRECCIONAR PARA PODER SALTAR LLAMANDO A LA FUNCION EXECUTE EN EL URL
                //echo 'SALTANDO....EL TARGET ESTA SIENDO EJECUTADO POR OTRO AGENTE';
                $this->resultTargetId = $record['CAMPTARGET_ID'];
                $url = $_SERVER['PHP_SELF'] . '?to=' . $this->code . '&ac=EXECUTE&ri=' . $this->sectionId . '&tg=' . $this->target . '&rtg=' . $this->resultTargetId;
                header('Location: '.$url);
            }
            //if not call date just return.
        } else {
            switch ($cterrec['RESULT_CODE']) {
                case 'END':
                    $this->resultTargetId = CLX_INIT_ZERO;
                    break;
                case 'BADT':
                    $this->resultTargetId = CLX_INIT_ZERO;
                    break;
                case 'RESC':
                    $this->targetRec = $target; //setting target
                    $this->resultTargetId = $cterrec['ID'];
                    if (!empty($this->resultTargetId)) {
                        $sql = 'UPDATE ' . $this->ctername . '  SET OWNERCODE = ' . singleQuote($this->ownercode) . ', RESULT_CODE = ' . singleQuote('WORK') . ', CALL_DATE = ' . singleQuote($this->now) . ' WHERE ID=' . $this->resultTargetId . '  AND RESULT_CODE NOT IN (' . singleQuote('END') . ',' . singleQuote('OOUT') . ',' . singleQuote('BADT') . ')';
                        ClxCommon::$db->executeQuery($sql);
                    } else {
                        $this->resultTargetId = ClxCommon::$db->createRecord($this->ctername, $record, false);
                    }
                    break;
                default:
                    $this->resultTargetId = $cterrec['ID'];
                    $this->targetRec = $target; //setting target
                    //$sql = 'UPDATE ' . $this->ctername . ' SET RESULT_CODE = ' . singleQuote('WORK') . ' WHERE ID=' . $this->resultTargetId . ' AND RESULT_CODE NOT IN (' . singleQuote('ENDT') . ',' . singleQuote('OOUT') . ',' . singleQuote('BADT') . ')';
                    $sql = 'UPDATE ' . $this->ctername . ' SET RESULT_CODE = ' . singleQuote($cterrec['RESULT_CODE']) . ' WHERE ID=' . $this->resultTargetId . ' AND RESULT_CODE NOT IN (' . singleQuote('END') . ',' . singleQuote('OOUT') . ',' . singleQuote('BADT') . ')';
                    ClxCommon::$db->executeQuery($sql);
                    break;
            }
        }
//e cho '<br>End setTarget';
        return $this->resultTargetId;
    }

    function getTarget() {
        if (empty($this->target))
            $this->target = CLX_INIT_ZERO;
        $sql = 'SELECT CTGT.* FROM ' . $this->ctmkname . ' CTMK, ' . $this->ctgtname . ' CTGT, ' . $this->ctername . ' CTRE WHERE CTGT.ID = CTRE.CAMPTARGET_ID AND CTMK.IDCODE = CTRE.CAMPSECTION_TELE_CODE AND CTMK.DELETED=0 AND CTGT.DELETED=0 AND CTMK.ID = ' . $this->sectionId . '  AND CTGT.ID = ' . singleQuote($this->target);
        return ClxCommon::$db->getOneRecord($sql);
    }

    function showTarget($targetRecord) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => 'table', CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellspacing' => '3'));
        $table->addCell(dict('GEN_LBL_TARGET_INFO'), array(CLX_PROP_CLASS => 'panel', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $DBLT = getTool('DBLT');
        $sql = 'SELECT DBTF.FIELDNAME, DBFL.FIELDLISTLABEL, DBFL.FIELDTYPE, DBFL.FIELD_EXTRA1 FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_FIELDS DBFL WHERE DBTF.FIELDNAME = DBFL.FIELDNAME AND DBTF.TABLECODE = ' . singleQuote('CTGT') . ' AND DBFL.FIELDNAME NOT IN (' . singleQuote('CONTACTID') . ',' . singleQuote('QUERYCODE') . ', ' . singleQuote('REC_ID') . ',' . singleQuote('CALL_DATE') . ', ' . singleQuote('EMAIL_DATE') . ',' . singleQuote('RESULT_CODE') . ', ' . singleQuote('RESULT_MSG') . ',' . singleQuote('EXCLUDED') . ', ' . singleQuote('ID_TYPE') . ',' . singleQuote('CONTACT_TYPE') . ', ' . singleQuote('LOCTYP') . ',' . singleQuote('SOURCE_LEAD') . ', ' . singleQuote('STATUS') . ',' . singleQuote('LEAD_CODE') . ', ' . singleQuote('CDATE') . ',' . singleQuote('CREATEDBY') . ') ORDER BY DBTF.SEQNUM ASC';
        $fields = ClxCommon::$db->executeQuery($sql);
        while ($field = ClxCommon::$db->getNextRecord($fields, ASSOCIATIVE)) {
            if (!isset($targetRecord[$field['FIELDNAME']]))
                continue;
            $value = trim($targetRecord[$field['FIELDNAME']]);
            if($field['FIELDNAME'] === 'ID') {
                $value .= ' [' . $targetRecord['CAMPTARGET_ID_TABLE'] . ']';
            }
            if (strlen($value) == CLX_NUM_ZERO || $value == null || 
		    ($field['FIELDTYPE'] === 'INTN' || $field['FIELDTYPE'] === 'DECN') && $value == CLX_NUM_ZERO) {
                continue;
	    }	
            if (stristr($value, '@')) {
                $value = ' <a href="mailto:' . $value . '" >' . $value . '</a>';
            }
            if ($field['FIELDTYPE'] === 'LIST') {
                $value = $DBLT->getListItem($field['FIELD_EXTRA1'], $value);
            }
            $table->addCell(dict($field['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT, CLX_PROP_WIDTH => '50%'));
            $table->addCell($value, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_WIDTH => '50%'));
        }
        $contents = $table->source();
        return $contents;
    }

    function processAnswer() {
        $response = array();
        $response['QUESTION_ID'] = (UserRequest::$request['qui'] === '') ? CLX_NUM_ZERO : UserRequest::$request['qui'];
        $response['CAMPSECTION_TELEMARK_CODE'] = UserRequest::$request['ri'];
        $response['CAMPTARGET_ID'] = UserRequest::$request['tg'];
        $response['CAMPTARGET_ID'] = UserRequest::$request['tgid'];
        $response['CALL_ANSWER'] = (array_key_exists('CALL_ANSWER', UserRequest::$request)) ? UserRequest::$request['CALL_ANSWER'] : 'END';
        $response['COMMENTS'] = UserRequest::$request['COMMENTS'];
        $response['CALL_DATE'] = xFormat::getNow();
        $response['QUESTIONARYCODE'] = '';
        $response['NEXT_QUESTION'] = '';
        $response['ANSWER_OPTION'] = (array_key_exists('ANSWER_OPTION', UserRequest::$request)) ? UserRequest::$request['ANSWER_OPTION'] : '';
        $response['CAMPSECTION_TELE_CODE'] = $this->sectionId;
        if (!empty($response['ANSWER_OPTION'])) {
            $option = $this->getOption($response['ANSWER_OPTION']); //return array of options
        } else {
            $ANQQ = &getTool('ANQQ');
            $question = ClxCommon::$db->getRecord($ANQQ->tablename, 'ID = ' . singleQuote($response['QUESTION_ID']));
            if (!empty($question['NEXT_QUESTION'])) {
                $question = ClxCommon::$db->getRecord($ANQQ->tablename, 'SEQNUM = ' . $question['NEXT_QUESTION']);
                $option['NEXT_QUESTION'] = $question['SEQNUM'];
            } else {
                $question = ClxCommon::$db->getRecord($ANQQ->tablename, 'ID > ' . $response['QUESTION_ID']);
                $option['NEXT_QUESTION'] = $question['SEQNUM'];
            }
        }
        $checkAnswer = ClxCommon::$db->getRecord($this->cteaname, 'CAMPTARGET_ID=' . singleQuote($response['CAMPTARGET_ID']) . ' AND QUESTION_ID=' . singleQuote($response['QUESTION_ID']) . ' AND CAMPSECTION_TELEMARK_CODE=' . singleQuote($response['CAMPSECTION_TELEMARK_CODE']) . ' AND QUESTION_ID=' . singleQuote($response['QUESTION_ID']) . ' AND CAMPSECTION_TELE_CODE=' . singleQuote($this->sectionId));
        if ($response['CALL_ANSWER'] === 'END') {
            ClxFreeReturn($this->changeResultStatus('END'));
            $this->questionId = '';
            $this->target = CLX_INIT_ZERO;
            $this->saveResults($response);
            return true;
        }
        if (!empty($checkAnswer['ID'])) {
            ClxCommon::$db->updateRecord($this->cteaname, $response, 'ID=' . singleQuote($checkAnswer['ID']));
            if (!empty($option['NEXT_QUESTION'])) {
                $this->questionId = $option['NEXT_QUESTION'];
            }
            return true;
        } else {
            if (ClxCommon::$db->createRecord($this->cteaname, $response, false) > CLX_NUM_ZERO) {
                if (!empty($option['NEXT_QUESTION'])) {
                    $this->questionId = $option['NEXT_QUESTION'];
                }
            }
            return true;
        }
    }

    function saveResultFields($tablecode, $result_id, $section_code, $target_id, $comments = '') {
	ClxFreeReturn($result_id);
	ClxFreeReturn($comments);
        $record = array('CDATE' => xFormat::getNow('Y-m-d H:i:s'),
            'MDATE' => xFormat::getNow('Y-m-d H:i:s'),
            'CREATEDBY' => $_SESSION['user_record']['username'],
            'MODIFIEDBY' => $_SESSION['user_record']['username'],
            'comments' => $comments,
            'CAMPSECTION_TELE_CODE' => $section_code,
            'CAMPTARGET_ID' => $target_id);
        ClxCommon::$db->updateRecord(tableName($tablecode), $record, 'ID = '.$result_id);
    }

    function saveResultIncludeFields($tablecode) {
        $DBTF = getTool('DBTF');
        //For telemarketing set target id and campanign section code
        $campfield = 'CAMPSECTION_TELE_CODE';
        $targetidfield = 'CAMPTARGET_ID';
        $commentsfield = 'COMMENTS';
        if (!$DBTF->fieldExists($tablecode, $campfield)) {
            $DBTF->includeField($tablecode, $campfield);
        }
        if (!$DBTF->fieldExists($tablecode, $targetidfield)) {
            $DBTF->includeField($tablecode, $targetidfield);
        }
        if (!$DBTF->fieldExists($tablecode, $commentsfield)) {
            $DBTF->includeField($tablecode, $commentsfield);
        }
//e cho '<br>End saveResultIncludeFields';
    }

    /**
     * Stores all results on final result table
     */
    function saveResults(&$response) {
        $tablename = '';
        $record = array('CDATE' => $this->now, 'MDATE' => $this->now, 'CREATEDBY' => $this->ownercode, 'MODIFIEDBY' => $this->ownercode, 'comments' => '');
        $sql = 'SELECT Q.IDCODE QUESTIONARY_CODE, X.CALL_DATE, MDATE, Q.RESULT_TABLECODE TABLECODE, CONCAT(Q.MODULECODE,CONCAT(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ',Q.IDNAME)) TABLENAME, CONCAT(Q.IDCODE,CONCAT(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ',QQ.SEQNUM)) FIELDNAME, X.CALL_ANSWER, X.COMMENTS COMMENTS, /*X.ANSWER_OPTION*/                 (SELECT MAX(OPT.OPTION_VALUE) FROM CLX_AN_QUESTIONARY_OPTIONS OPT WHERE OPT.QUESTIONID = QQ.ID AND OPT.ID = X.ANSWER_OPTION AND QQ.TYPE = ' . singleQuote('MULT') . ') ANSWER_OPTION, (SELECT MAX(OPT.SEQNUM) FROM CLX_AN_QUESTIONARY_OPTIONS OPT WHERE OPT.QUESTIONID = QQ.ID AND OPT.ID = X.ANSWER_OPTION AND QQ.TYPE = ' . singleQuote('MULT') . ') OPTION_SEQNUM FROM MARK_CAMPSEC_TELEMARK_ANWERS X, CLX_AN_QUESTIONARY_QUESTS QQ, CLX_AN_QUESTIONARIES Q WHERE QQ.QUESTIONARYCODE = Q.IDCODE AND X.QUESTION_ID = QQ.ID AND X.CAMPTARGET_ID=' . singleQuote($response['CAMPTARGET_ID']) . ' /*AND X.QUESTION_ID=' . singleQuote($response['QUESTION_ID']) . ' */                 /*AND X.CAMPSECTION_TELEMARK_CODE=' . singleQuote($response['CAMPSECTION_TELEMARK_CODE']) . '*/                 /*AND X.QUESTION_ID=' . singleQuote($response['QUESTION_ID']) . ' */ AND X.CAMPSECTION_TELE_CODE=' . singleQuote($this->sectionId);
        $results = ClxCommon::$db->executeQuery($sql);
        $i = CLX_INIT_ZERO;
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if ($i == CLX_NUM_ZERO) {
                $tablename = $result['TABLENAME'];
                $this->saveResultIncludeFields($result['TABLECODE']);
                $record['QUESTIONARY_CODE'] = $result['QUESTIONARY_CODE'];
                $record['CAMPTARGET_ID'] = $response['CAMPTARGET_ID'];
                $record['CAMPSECTION_TELE_CODE'] = $this->sectionId;
            }
            $record['COMMENTS'] .= ($i + CLX_NUM_ONE) . ': ' . $result['COMMENTS'] . '.\r ';
            $record['CDATE'] = $result['CALL_DATE'];
            $record['MDATE'] = $result['CALL_DATE'];
            $record[$result['fieldname']] = $result['CALL_ANSWER'];
            if ($result['CALL_ANSWER'] <> '') {
                $record[$result['fieldname']] = $result['CALL_ANSWER'];
            }
            if ($result['ANSWER_OPTION'] <> '' && $result['CALL_ANSWER'] === '') {
                $record[$result['fieldname']] = $result['ANSWER_OPTION'];
            }
            if ($result['OPTION_SEQNUM'] <> '') {
                $record[$result['fieldname'] . '_' . $result['OPTION_SEQNUM']] = $result['ANSWER_OPTION'];
            }
            if (empty($result['ANSWER_OPTION']) && empty($result['CALL_ANSWER'])) {
                $record[$result['fieldname']] = $result['COMMENTS'];
            }
            $i++;
        }//end while
        if ($tablename <> '') {
            $sql = 'SELECT COUNT(ID) FROM ' . $tablename . ' WHERE ';
            $and = '';
            foreach ($record as $key => $val) {
                $sql .= $and . ' ' . $key . ' = ' . singleQuote($val) . ' ';
                $and = ' AND ';
            }
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                ClxCommon::$db->createRecord($tablename, $record, false);
            }
        }
    }

    function getQuerionary($questionarycode) {
        $this->questions = array();
        if (empty($questionarycode))
            return array();
        $ANQQ = &getTool('ANQQ');
        $questions = ClxCommon::$db->getRecords($ANQQ->tablename, 'QUESTIONARYCODE=' . singleQuote($questionarycode) . ' ORDER BY SEQNUM');
        while (($question = ClxCommon::$db->getNextRecord($questions, ASSOCIATIVE))) {
            $this->questions[$question['ID']] = $question;
        }
        return $this->questions;
    }

    function getQuestion($questionId) {
        $ANQQ = &getTool('ANQQ');
        $question = ClxCommon::$db->getRecord($ANQQ->tablename, 'ID=' . singleQuote($questionId));
        return $question;
    }

    function getAnswers($question_id) {
        $answers = array();
        $answersResult = ClxCommon::$db->getRecords($this->cteaname, 'CAMPTARGET_ID=' . singleQuote($this->target), 'QUESTION_ID=' . singleQuote($question_id), 'CAMPSECTION_TELE_CODE=' . singleQuote($this->sectionId));
        while (($answer = ClxCommon::$db->getNextRecord($answersResult, ASSOCIATIVE))) {
            $answers[] = $answer;
        }
        return $answers;
    }

    function nextQuestion() {
        $return = false;
	$sibreak=false;
        foreach ($this->questions as $key => $value) {
            if (!empty($this->questionId)) {
                if ($value['SEQNUM'] == $this->questionId) {
                    $this->questionId = $value['ID'];
                    $return = $value;
		    $sibreak=true;
                } else {
                    continue;
                }
            } else {
                $this->questionId = $value['ID'];
                $return = $value;
                $sibreak=true;
            }
	    if (!empty($sibreak))
		break;
        }
        return $return;
    }

    function getCampaign($idcode) {
        $campaignTName = tableName('CAMP');
        return ClxCommon::$db->getRecord($campaignTName, 'IDCODE=' . singleQuote($tableName('CAMP')));
    }

    function getSection($sectionId) {
        return ClxCommon::$db->getRecord($this->ctmkname, 'ID=' . singleQuote($sectionId) . ' AND DELETED=0');
    }

    /**
     * Returns section idcode
     *
     * @param integer $sectionId
     * @return string
     */
    function getSectionCode($sectionId) {
        return ClxCommon::$db->getField($this->ctmkname, 'IDCODE', 'ID=' . singleQuote($sectionId));
    }

    function checkRescheduleCalls($sectionId) {
        $sql = 'SELECT COUNT(*) FROM ' . $this->ctername . ' CTER, ' . $this->ctmkname . ' CTMK WHERE CTER.CAMPSECTION_TELE_CODE = CTMK.IDCODE AND CTER.RESULT_CODE IN (' . singleQuote('RESC') . ',' . singleQuote('NOAN') . ') AND CTMK.ID =' . singleQuote($sectionId);
        if (ClxCommon::$db->getOne($sql) <> CLX_NUM_ZERO) {
            return true;
        } else {
            return false;
        }
    }

    function getResult($resultId) {
        return ClxCommon::$db->getRecord($this->ctername, 'ID=' . $resultId); //Get Status
    }

    function changeResultStatus($status) {
        if (empty($this->resultTargetId))
            return false;
        if (empty($status))
            $status = 'WORK';
        $this->changeQuestionaryResultStatus($status);
        ClxCommon::$db->updateRecord($this->ctername, array('RESULT_CODE' => $status), 'ID=' . $this->resultTargetId, 'RESULT_CODE NOT IN (' . singleQuote('END') . ',' . singleQuote('BAD') . ',' . singleQuote('OOUT') . ')'); //Get Status
    }

    function changeQuestionaryResultStatus($status) {
        if (array_key_exists('qq', UserRequest::$request)) {
            $result_table = ClxCommon::$db->getField('CLX_AN_QUESTIONARIES', 'RESULT_TABLECODE', 'IDCODE = ' . singleQuote(UserRequest::$request['qq']));
        }
        if (!empty($result_table)) {
            ClxCommon::$db->updateRecord(tableName($result_table), array('RESULT_CODE' => $status), 'CREATEDBY = ' . singleQuote($this->ownercode) . ' AND RESULT_CODE=' . singleQuote('WORK') . '');
        }
    
        //------------actualizo en tabla de resultados del cuestionario con el ID-----------------// 
        //obtenemos la tabla de resultados del cuestionario junto a los campos que serviran de criterio
        $sql = 'SELECT ANQN.MODULECODE, ANQN.RESULT_TABLECODE AS TABLECODE, CTMK.QUESTIONARYCODE, CTER.CAMPSECTION_TELE_CODE, CTER.CAMPTARGET_ID 
                FROM CLX_AN_QUESTIONARIES ANQN, MARK_CAMPSEC_TELEMARK CTMK, MARK_CAMPSEC_TELEMARK_RES CTER
		   		WHERE 
                CTER.ID='.$this->resultTargetId.' AND
                CTER.CAMPSECTION_TELE_CODE=CTMK.IDCODE AND
                CTMK.QUESTIONARYCODE=ANQN.IDCODE';
        $results = ClxCommon::$db->executeQuery($sql);
        if (($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) == true) {
            //echo 'actualiza CAMPTELERES_ID </br>';
            $sql2='UPDATE '.$result['MODULECODE'].'_'.$result['TABLECODE'].' SET CAMPTELERES_ID='.singleQuote($this->resultTargetId).' 
                   WHERE 
                   QUESTIONARY_CODE='.singleQuote($result['QUESTIONARYCODE']).' AND
                   CAMPSECTION_TELE_CODE='.singleQuote($result['CAMPSECTION_TELE_CODE']).' AND
                   CAMPTARGET_ID='.singleQuote($result['CAMPTARGET_ID']);
            ClxCommon::$db->executeQuery($sql2);
        }


    }

    /**
     * Set Section Status
     */
    function changeSectionStatus($status) {
        if (empty($status))
            return CLX_CHAR_EMPTY_STRING;
        switch ($status) {
            case 'RUN_ALL':
                $idlist = toString(getIdlist());
                $sql = 'SELECT CTMK.IDCODE FROM ' . $this->ctmkname . ' CTMK WHERE ID IN (' . $idlist . ') AND CAMPSECTION_STATUS=' . singleQuote('IDLE') . ' AND CTMK.DELETED=0';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $sql = 'DELETE FROM ' . $this->ctername . ' WHERE CAMPSECTION_TELE_CODE = ' . singleQuote($result['IDCODE']);
                    ClxCommon::$db->executeQuery($sql);
                    ClxCommon::$db->updateRecord($this->ctmkname, array('CAMPSECTION_STATUS' => 'WORK'), 'IDCODE = ' . singleQuote($result['IDCODE']) . ' AND DELETED=0');
                }
                break;
            default:
                ClxCommon::$db->updateRecord($this->ctmkname, array('CAMPSECTION_STATUS' => $status), 'ID=' . singleQuote($this->sectionId) . ' AND CAMPSECTION_STATUS <> ' . singleQuote('END') . ' AND DELETED=0');
                break;
        }
    }

    function getOptions($questionid) {
        $options = array();
        $ANQO = &getTool('ANQO');
        $sqlResult = ClxCommon::$db->getRecords($ANQO->tablename, 'QUESTIONID=' . singleQuote($questionid));
        while (($row = ClxCommon::$db->getNextRecord($sqlResult, ASSOCIATIVE))) {
            $options[] = $row;
        }
        return $options;
    }

    function getOption($optionId) {
        $ANQO = &getTool('ANQO');
        $option = ClxCommon::$db->getRecord($ANQO->tablename, 'ID=' . $optionId);
        return $option;
    }

    function showQuestion($question) {
        $format = new xFormat();
        $qid = $question['ID'];
        $options = $this->getOptions($qid);
        $questionLabel = $question['SEQNUM'] . '. ' . $format->text(dict($question['QUESTION'])) . '<br>';
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->setProp('ID', 'EXECUTE');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NEXT_QUESTION');
        $form->addArgument('li', '');
        $form->addArgument('qui', $question['ID']);
        $form->addArgument('ri', $this->sectionId);
        $form->addArgument('tg', $this->target);
        $form->addArgument('tgid', $this->camptarget_id);
        $form->addArgument('rtg', $this->resultTargetId);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array('valign' => 'top', CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellspacing' => '3'));
        $table->addCell($questionLabel . '<br>', array(CLX_PROP_CLASS => 'panel', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $answer = $this->getAnswers($question['ID']);
        switch ($question['TYPE']) {
            case 'OPEN':
                $form->addArgument('ANSWER_OPTION', '0');
                $b = new htmlTextArea('CALL_ANSWER', (array_key_exists(CLX_NUM_ZERO, $answer)) ? $answer[CLX_NUM_ZERO]['CALL_ANSWER'] : '', CLX_NUM_FOUR, CLX_NUM_60);
                break;
            case 'END':
                $form->addArgument('CALL_ANSWER', 'END');
                $form->addArgument('ANSWER_OPTION', '');
                $b = false;
                break;
            case ('MULT' || 'LIST'):
                $form->addArgument('CALL_ANSWER', '');
                $b = new htmlSelect('ANSWER_OPTION');
                foreach ($options as $key => $value) {
                    $checked = false;
                    if (empty($answer) && $question['DEFAULT_ANSWER_ID'] == $value['ID']) {
                        $checked = true;
                    } elseif (!empty($answer[CLX_NUM_ZERO]['ANSWER_OPTION']) && $answer[CLX_NUM_ZERO]['ANSWER_OPTION'] == $value['ID']) {
                        $checked = true;
                    }
                    $b->addItem(uppercase(dict($value['OPTION_TEXT'])), $value['ID'], $checked);
                }
                break;
            default:
                $b = false;
                $answer = '';
                break;
        }//end switch
        if (!empty($b)) {
            $table->addCell(dict('GEN_LBL_CALL_ANSWER'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($b->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
        $b = new htmlTextArea('COMMENTS', (!empty($answer[CLX_NUM_ZERO]['COMMENTS']) ? $answer[CLX_NUM_ZERO]['COMMENTS'] : ''), CLX_NUM_FOUR, CLX_NUM_60);
        $table->addCell(dict('GEN_LBL_COMMENTS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($b->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $buttons = '';
        $c = new htmlSubmit(dict('GEN_LBL_CONTINUE'));
        $buttons .= $c->source();
        $c = new htmlButtonCancel(' ' . dict('GEN_LBL_salir') . ' ');
        $buttons .= $c->source();
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN=> CLX_WIDTH_TWO));
        $table->addCell(CLX_CHAR_HTML_NBSP, array('' => ''));
        $table->addCell($buttons, array('' => ''));
        $form->addContents($table->source());
        return $form->source();
    }

    function showQuestionary() {
        $contents = '<br>';
        $format = new xFormat();
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '3'));
        $table->addCell(dict('GEN_LBL_QUESTIONARY'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_ONE));
        foreach ($this->questions as $key => $value) {
            $contents = '<font color=' . singleQuote('black') . '>' . $value['SEQNUM'] . '. <a href=' . UserRequest::$server['PHP_SELF'] . '?to=MATE&ac=EXECUTE&ri=' . $this->sectionId . '&qui=' . $value['SEQNUM'] . '&rtg=' . $this->resultTargetId . '>';
            if ($this->questionId == $value['ID'])
                $contents .= '<font color="red">';
            $contents .= $format->text(dict($value['QUESTION']));
            if ($this->questionId == $value['ID'])
                $contents .= '</font>';
            $contents .= '</a>';
            $table->addCell($contents, array('' => ''));
            //Test if options are found
            $contents = '';
            $options = array();
            $options = $this->getOptions($value['ID']);
            foreach ($options as $key2 => $value2) {
                $contents .= '&nbsp;&nbsp;&nbsp;<font color=' . singleQuote('black') . '>' . $format->text(uppercase(dict($value2['OPTION_TEXT']))) . ' -> ' . $value2['NEXT_QUESTION'] . '</font><br>';
            }
            $table->addCell($contents, array('' => ''));
        }
        return $table->source();
    }

    function optout() {
        if (empty($this->resultTargetId))
            return;
        //EC 21-02-2022
        //Se verifica si el target esta en la tabla CTGT (Targets manuales ) o si es por otra tabla (por query)
        //Se ajustó ya que solo agragaba excluidos cuando la lista de target era manual
        $sql = 'SELECT CTGT.CONTACTID, CTGT.ACCOUNTCODE, /*CTGT.EMAIL, CTGT.PHONE,*/ "'.$this->now.'" CDATE, CTER.PHONE, CTER.EMAIL 
                FROM MARK_CAMPSEC_TELEMARK_RES CTER LEFT JOIN MARK_CAMPAIGN_TARGETS CTGT 
                ON CTER.CAMPTARGET_ID = CTGT.ID AND CTGT.DELETED = 0 WHERE CTER.ID = ' . $this->resultTargetId;

        //Add to exception list
        //$sql = 'SELECT CTGT.CONTACTID, CTGT.ACCOUNTCODE, CTGT.EMAIL, CTGT.PHONE, NOW() CDATE FROM MARK_CAMPSEC_TELEMARK_RES CTER, MARK_CAMPAIGN_TARGETS CTGT WHERE CTER.CAMPTARGET_ID = CTGT.ID AND CTGT.DELETED = 0 AND CTER.ID = ' . $this->resultTargetId;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (ClxCommon::$db->oneExistsRecords($this->caexname, 'PHONE=' . singleQuote($r['PHONE'])) > CLX_NUM_ZERO) {
                ClxCommon::$db->updateRecord($this->caexname, $r, 'PHONE=' . singleQuote($r['PHONE']));
            } else {
                ClxCommon::$db->createRecord($this->caexname, $r, false);
            }
        }
        return $this->changeResultStatus('OOUT');
    }

    function checkOptout($camptarget_id, $camptarget_id_table) {
        $sql = 'SELECT COUNT(CAEX.ID) QTY FROM ' . $this->ctgtname . ' CTGT, ' . $this->caexname . ' CAEX WHERE CTGT.ID = ' . $camptarget_id . '  AND CTGT.DELETED=0 AND CTGT.PHONE = CAEX.PHONE ';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            return true;
        }
        $count = ClxCommon::$db->oneExistsRecords($this->ctername, 'RESULT_CODE=' . singleQuote('OOUT') . ' AND CAMPTARGET_ID=' .
                $camptarget_id . ' AND CAMPTARGET_ID_TABLE=' . singleQuote($camptarget_id_table)); //Get Status
        if ($count > CLX_NUM_ZERO) {
            return true;
        } else {
            return false;
        }
    }

    function rescheduleCall(&$msg) {
        $now = xFormat::getNow('Y-m-d H:i:s');
        $newdate = xFormat::datetime(UserRequest::$request['CALL_DATE'], 'Y-m-d H:i:s');
        //do some validations
        xValidate::datetime($msg, 'CALL_DATE', $newdate, 'CALL_DATE');
        if ($now > $newdate) {
            $msg['CALL_DATE'] = dict('GEN_ERR_INVALIDDATE');
        }
        //validate if agent exists
        if (!empty(UserRequest::$request['CALL_USER']) && ClxCommon::$db->oneExistsRecords('CLX_AC_USERS', 'USERNAME = ' . singleQuote(UserRequest::$request['CALL_USER'])) == CLX_NUM_ZERO) {
            $msg['CALL_USER'] = dict('GEN_LBL_USER_DONT_EXIST');
        }
        //validate if user is agent
        $sql = 'SELECT COUNT(B.ID) QTY FROM MARK_CAMPSEC_TELEMARK_RES A, MARK_CAMPSEC_TELEMARK_AGENTS B WHERE A.CAMPSECTION_TELE_CODE = B.CAMPSECTION_TELEMARK_CODE AND B.DELETED=0 AND A.ID = ' . $this->resultTargetId . '  AND B.USER_AGENT = ' . singleQuote(UserRequest::$request['CALL_USER']);
        if (!empty(UserRequest::$request['CALL_USER']) && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg['CALL_USER'] = dict('GEN_LBL_NOT_AN_AGENT');
        }
        if (!empty($msg))
            return false;
        //updating section result
        ClxCommon::$db->updateRecord($this->ctername, array('NEXT_CALL_DATE' => $newdate, 'CALL_USER' => UserRequest::$request['CALL_USER'], 'RESULT_CODE' => $this->act), 'ID=' . $this->resultTargetId);
        //updating target info
        /* $sql = 'UPDATE
          $this->ctgtname SET CALL_DATE='. singleQuote($newdate).', CALL_USER = ''.UserRequest::$request['CALL_USER'].''
          WHERE ID = (SELECT CTER.CAMPTARGET_ID FROM ' . $this->ctername CTER WHERE CTER.ID = ' . $this->resultTargetId.')';
          ClxCommon::$db->executeQuery($sql); */
        $this->changeQuestionaryResultStatus($this->act);
        $this->target = CLX_INIT_ZERO;
        return true;
    }

    function rescheduleForm(&$msg) {
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->setProp('ID', 'RESC');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'RESC');
        $form->addArgument('qui', $this->questionId);
        $form->addArgument('ri', $this->sectionId);
        $form->addArgument('tg', $this->target);
        $form->addArgument('rtg', $this->resultTargetId);
        $form->addArgument('act', $this->act);
        $form->addArgument('qq', UserRequest::$request['qq']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_ALIGN => 'center', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_RESCHEDULE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS=> CLX_CLASS_HEADERS, CLX_PROP_COLSPAN=> CLX_WIDTH_TWO));
        $calldateField = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote('CALL_DATE') . '');
        ClxFreeReturn($this->getResult($this->resultTargetId));
        if (!empty(UserRequest::$request['CALL_DATE']))
            $cDefault = UserRequest::$request['CALL_DATE'];
        else
            $cDefault = date('Y-m-d H:i:s', strtotime('now + 1 hour'));
        if (!empty($msg['CALL_DATE'])) {
            $table->addCell($msg['CALL_DATE'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        }
	$format_javascript = $_SESSION['prefs']['DATE_FORMAT'];
	$format_javascript = str_replace('d', 'dd', $format_javascript);
	$format_javascript = str_replace('m', 'mm', $format_javascript);
	$format_javascript = str_replace('Y', 'yy', $format_javascript);

        $picker = '<script type="text/javascript">
                	<!--
                	$(function() {var pickOpts = {
                    			    	 dateFormat: "'.$format_javascript.'",
          							     stepMinutes: 1,
                 						 stepHours: 1,
                 						 altTimeField: "",
                    			    	 duration: "",
                                         showTime: true,
                                         constrainInput: false,
                                         time24h: true,
                                         changeMonth: true,
        								 changeYear: true,
                                         showOn: "button",
                                         buttonImage: "' . kPathToSkins . $_SESSION['skin'] . '/images/calendar/cal.gif' . '",
                                         buttonImageOnly: true
                    			    	};
                                		$("#CALL_DATE").datepicker(pickOpts);
                                	});
                    --> </script>';
        $table->addCell(dict($calldateField['FIELDFORMLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $c = new htmlField('CALL_DATE', $cDefault, $calldateField['FIELD_DISPLAYSIZE'], $calldateField['FIELD_DISPLAYSIZE']);
        $table->addCell($c->source() . $picker, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        //Asignee

        $sql = 'SELECT CTMA.USER_AGENT, ACUS.FIRSTNAME, ACUS.LASTNAME FROM MARK_CAMPSEC_TELEMARK CTMK, MARK_CAMPSEC_TELEMARK_AGENTS CTMA, CLX_AC_USERS ACUS WHERE CTMK.IDCODE = CTMA.CAMPSECTION_TELEMARK_CODE AND CTMK.DELETED=0 AND CTMA.DELETED=0 AND ACUS.USERNAME = CTMA.USER_AGENT AND CTMK.ID = ' . $this->sectionId;
        $rs = ClxCommon::$db->executeQuery($sql);
        $caller = (array_key_exists('CALL_USER', UserRequest::$post)) ? UserRequest::$post['CALL_USER'] : $_SESSION['user_record']['username'];
        $sel = new htmlSelect('CALL_USER');
        $sel->addItem(dict('GEN_LBL_ANY_CALLER'), '', ($caller === ''));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sel->addItem($r['LASTNAME'] . ', ' . $r['FIRSTNAME'], $r['USER_AGENT'], ($caller = $r['USER_AGENT']));
        }
        $table->addCell(dict('GEN_LBL_CALL_USER'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        unset($sel);
        $buttons = '';
        $c = new htmlSubmit(dict('GEN_LBL_RESCHEDULE'));
        $buttons .= $c->source();
        $url = UserRequest::$server['PHP_SELF'] . '?to=' . $this->code . '&ac=EXECUTE&ri=' . $this->sectionId . '&tg=' . $this->target . '&rtg=' . $this->resultTargetId;
        $c = new htmlButtonGoto(' ' . dict('GEN_LBL_RETURN') . ' ', $url);
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    function showCallMenu() {
        $btoList = array();
        $btoList[] = array('name' => 'GEN_LBL_WRONG_NUMBER', 'ac' => 'BADT', 'act' => 'BADT');
        $btoList[] = array('name' => 'GEN_LBL_OPT_OUT', 'ac' => 'OOUT', 'act' => 'OOUT');
        $btoList[] = array('name' => 'GEN_LBL_RESCHEDULE', 'ac' => 'RESC', 'act' => 'RESC');
        $btoList[] = array('name' => 'GEN_LBL_NO_ANSWER', 'ac' => 'RESC', 'act' => 'NOAN');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_ALIGN => 'center', CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '3'));
        foreach ($btoList as $key => $value) {
            $a1ink = '<p class=CLX_CLASS_PROMPT>';
            $a1ink .= '[ <a href=' . UserRequest::$server['PHP_SELF'] . '?to=MATE&ac=' . $value['ac'] . '&ri=' . $this->sectionId . '&';
            $a1ink .= '&qq=' . $this->questionary_code . '&rtg=' . $this->resultTargetId . '&act=' . $value['act'] . '>';
            $a1ink .= uppercase(dict($value['name']));
            $a1ink .= '</a> ]</p>';
            $table->addCell($a1ink, array(CLX_PROP_WIDTH => '50%', 'nowrap' => 'true'));
        }//end for
        $contents = $table->source();
        return $contents;
    }

    function userOnAbsence() {
        $date = date('Y-m-d');
        //$sql = 'SELECT COUNT(AGTO.ID) FROM ' . $this->agtoname . ' AGTO WHERE AGTO.REQ_STATUS = ' . singleQuote('AP') . ' AND AGTO.USER_CODE = ' . singleQuote($this->ownercode) . ' AND AGTO.START_DATE<=' . singleQuote($date) . ' AND (AGTO.END_DATE>=' . singleQuote($date) . ' OR AGTO.END_DATE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR AGTO.END_DATE IS NULL)';
        $sql = 'SELECT COUNT(AGTO.ID) FROM ' . $this->agtoname . ' AGTO WHERE AGTO.REQ_STATUS = ' . singleQuote('AP') . ' AND AGTO.USER_CODE = ' . singleQuote($this->ownercode) . ' AND AGTO.START_DATE<=' . singleQuote($date) . ' AND (AGTO.END_DATE>=' . singleQuote($date) . ' OR AGTO.END_DATE IS NULL)';
        return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? false : true;
    }

    /*
     * Builds SQL SELECT for campaign / Construye el query para la campaña
     * @global object $db
     * @param array $cqry
     * @return string
     */
    function CEML_get_query_sql($cqry) {
        $DBQY = &getTool('DBQY');
        $queryrec = $DBQY->getQuery('MARK', $cqry['QUERYLIST_CODE']); //Informacion del query
        $cqrl_rec = $this->CEML_get_camp_qry_field_names($cqry['QUERYLIST_CODE']); //Informacion de configuracion de lista de campana
        // Construye la lista de los campos que tendra el select segun campos de tabla CTGT, que se toma como standard a la hora de enviar el registro del target
        $ctgt_flds = array();
        $sql = 'SELECT DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF WHERE DBTF.TABLECODE = ' . singleQuote('CTGT') . ' ORDER BY DBTF.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $ctgt_flds[$r['FIELDNAME']] = array('NULL', $r['FIELDNAME']); //Item sera array('EXPRESION', 'ALIAS');
        }
        // Incorporar todos los campos que existan con el mismo nombre en las tablas asociadas a las consutas, solo queda con uno por campo
        $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLEFIELDS DBTF WHERE DBTF.TABLECODE = DBQT.TABLECODE AND DBQT.QUERYCODE = ' . singleQuote($cqry["QUERYLIST_CODE"]) . ' AND EXISTS(SELECT DBTF2.ID FROM CLX_DB_TABLEFIELDS DBTF2 WHERE DBTF2.TABLECODE = ' . singleQuote('CTGT') . ' AND DBTF2.FIELDNAME = DBTF.FIELDNAME)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $ctgt_flds[$r['FIELDNAME']] = array($r['TABLECODE'] . '.' . $r['FIELDNAME'], $r['FIELDNAME']);
            // 2018-04-20 CJRD Para evitar errores en "CEML_run_sql_targets()" cuando el query especificado no tenga la columna de telefono
            if ($r['FIELDNAME'] === $cqrl_rec['PHONE_FIELD']) {
                $this->CEML_prmts['tablecode'] = $r['TABLECODE'];
                $ctgt_flds['PHONE'] = array($r['TABLECODE'] . '.' . $r['FIELDNAME'], 'PHONE');
                $ctgt_flds['DONE'] = array('(SELECT IFNULL(1,0) FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = ' . $this->getSectionCode($this->sectionId) . ' AND RESULT_CODE IN (' . singleQuoteArray(array('END','OOUT','BADT')) . ') AND CAMPTARGET_ID_TABLE = ' . singleQuote($this->CEML_prmts['tablecode']) . ' AND REC_ID = ' . $r['TABLECODE'] . '.ID LIMIT 1)', 'DONE');
                $this->CEML_prmts['phone_fld_name'] = $r['TABLECODE'] . '.' . $r['FIELDNAME'];
                $ctgt_flds['OPTOUT'] = array('(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX  WHERE CAEX.PHONE = ' . $this->CEML_prmts['phone_fld_name'] . ' LIMIT 1)', 'OPTOUT');
            }
        }
        $add_crits = '';
        $this->CEML_prmts['SORTCLAUSE'] = $queryrec['SORTCLAUSE'];
        //Remplazando aquellos campos que esten definidos explisitos en la consulta
        foreach ($queryrec['COLUMNS'] as $k => $v) { //$k es alias ej: ACCO_FIELDNAME, $v es el registro del campo. Columnas del sql estan por lo menos en la definicion.
            $v['EXPRESSION_ONLY'] = trim($v['EXPRESSION_ONLY']);
            if (!empty($v['EXPRESSION_ONLY'])) {
                // Campo en consulta puede tener una expresion en vez de caso
                $ctgt_flds[$v['FIELDNAME']] = array($v['EXPRESSION_ONLY'], $v['FIELDNAME']);
            } else {
                $ctgt_flds[$v['FIELDNAME']] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], $v['FIELDNAME']);
            }
            // Agregando casos adicionales
            // Prepara ID
            if ($v['FIELDNAME'] === $cqrl_rec['ID_FIELD']) {
                $ctgt_flds['CONTACTID'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'CONTACTID');
                $ctgt_flds['REC_ID'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'REC_ID');
                if (empty($queryrec['SORTCLAUSE']) || $queryrec['SORTCLAUSE'] === ($v['TABLECODE'] . '.' . $v['FIELDNAME'] . ' ASC')) {
                    // Solo agrega el ID > <RECID> en caso que no tenga ORDER BY o que el ORDER BY del Query sea el ID
                    $this->CEML_prmts['SORTCLAUSE'] = 'ID';
                    // En caso que el query no tuviese ORDER BY, le agrega ORDER BY ID, sino lo deja como estaba
                    $queryrec['SORTCLAUSE'] = (empty($queryrec['SORTCLAUSE']) ? ($v['TABLECODE'] . '.' . $v['FIELDNAME']) : $queryrec['SORTCLAUSE']);
                    $add_crits .= ' AND ' . $v['TABLECODE'] . '.' . $v['FIELDNAME'] . ' > <RECID>';
                }
            }
            // Prepara nombre
            if ($v['FIELDNAME'] === $cqrl_rec['FIRSTNAME_FIELD'] && $ctgt_flds['FIRSTNAME'][CLX_NUM_ZERO] === 'NULL') {
                $ctgt_flds['FIRSTNAME'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'FIRSTNAME');
            }
            // Prepara apellido
            if ($v['FIELDNAME'] === $cqrl_rec['LASTNAME_FIELD'] && $ctgt_flds['LASTNAME'][CLX_NUM_ZERO] === 'NULL') {
                $ctgt_flds['LASTNAME'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'LASTNAME');
            }
            // Prepara telefono
            if ($v['FIELDNAME'] === $cqrl_rec['PHONE_FIELD']) {
                $this->CEML_prmts['tablecode'] = $v['TABLECODE'];
                $ctgt_flds['PHONE'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'PHONE');
                $ctgt_flds['DONE'] = array('(SELECT IFNULL(1,0) FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = ' . $this->getSectionCode($this->sectionId) . ' AND RESULT_CODE IN (' . singleQuoteArray(array('END','OOUT','BADT')) . ') AND CAMPTARGET_ID_TABLE = ' . singleQuote($this->CEML_prmts['tablecode']) . ' AND REC_ID = ' . $v['TABLECODE'] . '.ID LIMIT 1)', 'DONE');
                $this->CEML_prmts['phone_fld_name'] = $v['TABLECODE'] . '.' . $v['FIELDNAME'];
                $ctgt_flds['OPTOUT'] = array('(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX  WHERE CAEX.PHONE = ' . $this->CEML_prmts['phone_fld_name'] . ' LIMIT 1)', 'OPTOUT');
            }

            // Prepara Email
            if ($v['FIELDNAME'] == $cqrl_rec['EMAIL_FIELD']) {
                $ctgt_flds['EMAIL'] = array($v['TABLECODE'] . '.' . $v['FIELDNAME'], 'EMAIL');
            }
        }
        // Si columna FULLNAME no existe, la calcula, siempre que se haya especificado las columnas de nombre y apellido
        if(!isset($ctgt_flds['FULLNAME']) && $ctgt_flds['LASTNAME'][CLX_NUM_ZERO] != 'NULL' && $ctgt_flds['FIRSTNAME'][CLX_NUM_ZERO] != 'NULL') {
            $ctgt_flds['FULLNAME'] = array('CONCAT(' . $ctgt_flds['FIRSTNAME'][CLX_NUM_ZERO] . ', ' . $ctgt_flds['LASTNAME'][CLX_NUM_ZERO] . ')', 'FULLNAME');
        }
        // Prepara construcción del SQL
        $ctgt_flds['CQRY_CODE'] = array(singleQuote($cqry['IDCODE']), 'CQRY_CODE');
        $ctgt_flds['CAMPAIGNCODE'] = array(singleQuote($cqry['CAMPAIGNCODE']), 'CAMPAIGNCODE');
        $ctgt_flds['QUERYCODE'] = array(singleQuote($cqry['QUERYLIST_CODE']), 'QUERYCODE');
        $ctgt_flds['CALL_DATE'] = array(singleQuote(xFormat::getNow()), 'CALL_DATE');
        $ctgt_flds['EMAIL_DATE'] = array('NULL', 'EMAIL_DATE');
        $ctgt_flds['EMAIL_STATUS'] = array(singleQuote('PEND'), 'EMAIL_STATUS');
        $ctgt_flds['STATUS'] = array(singleQuote('A'), 'STATUS');
        $ctgt_flds['EXCLUDED'] = array('0', 'EXCLUDED');
        $ctgt_flds['DELETED'] = array('0', 'DELETED');
        $queryrec['WHERECLAUSE'] = trim($queryrec['WHERECLAUSE']);
        $command_tail = (empty($queryrec['SORTCLAUSE']) ? '' : ' ORDER BY ' . $queryrec['SORTCLAUSE']);
        $command_tail .= (empty($queryrec['GROUPCLAUSE']) ? '' : ' GROUP BY ' . $queryrec['GROUPCLAUSE']);
        $queryrec['WHERECLAUSE'] = trim($queryrec['WHERECLAUSE']);
        $where_clause = (!empty($queryrec['WHERECLAUSE'])) ? ' AND ' . $queryrec['WHERECLAUSE'] : '';
        $s_list_values = '';
        $comma = '';
        foreach ($ctgt_flds as $k => $v) {
            $s_list_values .= $comma . $v[CLX_NUM_ZERO] . ' ' . $v[CLX_NUM_ONE] . CLX_CHAR_NL;
            $comma = ', ';
        }
        // Se agrega /* CONTINUE_FLAG_CONDITION */ al SQL para poder insertar la eventual instrucciones para continuar con la ejecución de la campaña
        $this->CEML_prmts['sql_string'] = 'SELECT ' . $s_list_values . ' FROM ' . $queryrec['FROMCLAUSE'] . ' WHERE 1=1 ' . $add_crits . ' ' . $where_clause . ' /* CONTINUE_FLAG_CONDITION */ ' . $command_tail;
    }

    /*
     * Get record with query key field names
     * @global object $db
     * @param string $s_querycode
     * @return array
     */
    function CEML_get_camp_qry_field_names($s_querycode) {
        $a_response = ClxCommon::$db->getRecord($this->cqrlname, 'QUERYCODE=' . singleQuote($s_querycode));
        if (!isset($a_response['ID_FIELD']))
            $a_response['ID_FIELD'] = 'ID';
        if (!isset($a_response['LASTNAME_FIELD']))
            $a_response['LASTNAME_FIELD'] = 'LASTNAME';
        if (!isset($a_response['FIRSTNAME_FIELD']))
            $a_response['FIRSTNAME_FIELD'] = 'FIRSTNAME';
        if (!isset($a_response['PHONE_FIELD']))
            $a_response['PHONE_FIELD'] = 'PHONE';
        if (!isset($a_response['EMAIL_FIELD']))
            $a_response['EMAIL_FIELD'] = 'EMAIL';
        return $a_response;
    }

     /*
     * Get next record with SQL built from query
     * @global object $db
     * @param int $id
     * @return array
     */
    //01-10-2021 E.C PARA OBTENER EL PRIMER NUEVO TARGET POR QUERY (AJUSTADO)
    function CEML_run_sql_targets($id = CLX_NUM_ZERO) {
        // Siempre trae sólo uno: el próximo
        $sql = $this->CEML_prmts['sql_string'] . ' LIMIT 1';
        $sql = str_replace('<RECID>', CLX_NUM_ZERO, $sql);
        if ($id == CLX_NUM_ZERO) {
            // Siempre que no tenga el telefono en blanco
            $sql = str_replace('1=1', $this->CEML_prmts['phone_fld_name'] . '<>' . singleQuote('') . ' AND ' . $this->CEML_prmts['phone_fld_name'] . ' IS NOT NULL', $sql);
            // Se sustituye /* CONTINUE_FLAG_CONDITION */ por las instrucciones para excluir aquellos telefonos ya contactados
            //$sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND NOT EXISTS (SELECT REC_ID FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = ' . $this->getSectionCode($this->sectionId) . ' AND RESULT_CODE IN (' . singleQuoteArray(array('END','OOUT','BADT')) . ') AND CAMPTARGET_ID_TABLE = ' . singleQuote($this->CEML_prmts['tablecode']) . ' AND REC_ID = ' . $this->CEML_prmts['tablecode'] . '.ID)', $sql);
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND NOT EXISTS (SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.PHONE = '.$this->CEML_prmts['phone_fld_name'].' LIMIT 1) AND NOT EXISTS (SELECT REC_ID FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = '.$this->getSectionCode($this->sectionId).' AND (RESULT_CODE IN (' . singleQuoteArray(array('END','OOUT','BADT','RESC', 'NOAN')) . ') OR (RESULT_CODE='.singleQuote('WORK').' AND CALL_USER NOT IN ('.singleQuote($this->ownercode).'))) AND CAMPTARGET_ID_TABLE = '.singleQuote($this->CEML_prmts['tablecode']).' AND REC_ID = '.$this->CEML_prmts['tablecode'].'.ID FOR UPDATE)', $sql);
        } else {
            // Trae uno epecífico
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND ID = ' . $id, $sql);
        }

        $rs = ClxCommon::$db->executeQuery($sql);
        $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
        return $r;
    }

    //01-10-2021 E.C PARA OBTENER EL PRIMER TARGET EN STATUS RESC O NOAN CUANDO EL TARGET ES POR QUERY
    function CEML_run_sql_targets2($id = CLX_NUM_ZERO) {
        // Siempre trae sólo uno: el próximo
        $sql = $this->CEML_prmts['sql_string'] . ' LIMIT 1';
        $sql = str_replace('<RECID>', CLX_NUM_ZERO, $sql);
        if ($id == CLX_NUM_ZERO) {
            // Siempre que no tenga el telefono en blanco
            $sql = str_replace('1=1', $this->CEML_prmts['phone_fld_name'] . '<>' . singleQuote('') . ' AND ' . $this->CEML_prmts['phone_fld_name'] . ' IS NOT NULL', $sql);
            // Se sustituye /* CONTINUE_FLAG_CONDITION */ por las instrucciones para excluir aquellos telefonos ya contactados
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND EXISTS (SELECT REC_ID FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = ' . $this->getSectionCode($this->sectionId) . ' AND (RESULT_CODE IN (' . singleQuoteArray(array('RESC', 'NOAN')) . ') AND NEXT_CALL_DATE<='. singleQuote($this->now).' AND (CALL_USER IN ('.singleQuote($this->ownercode).','.singleQuote('').') OR CALL_USER IS NULL)) AND CAMPTARGET_ID_TABLE = ' . singleQuote($this->CEML_prmts['tablecode']) . ' AND REC_ID = ' . $this->CEML_prmts['tablecode'] . '.ID)', $sql);
        } else {
            // Trae uno epecífico
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND ID = ' . $id, $sql);
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
        return $r;
    }

    //01-10-2021 E.C PARA OBTENER EL PRIMER TARGET EN STATUS WORK EN LA TABLA DE RESULTADOS....HASTA QUE NO TERMINE
    //NO PODRA ATENDER OTROS TARGETS.
    function CEML_run_sql_targets3($id = CLX_NUM_ZERO) {
        // Siempre trae sólo uno: el próximo
        $sql = $this->CEML_prmts['sql_string'] . ' LIMIT 1';
        $sql = str_replace('<RECID>', CLX_NUM_ZERO, $sql);
        if ($id == CLX_NUM_ZERO) {
            // Siempre que no tenga el telefono en blanco
            $sql = str_replace('1=1', $this->CEML_prmts['phone_fld_name'] . '<>' . singleQuote('') . ' AND ' . $this->CEML_prmts['phone_fld_name'] . ' IS NOT NULL', $sql);
            // Se sustituye /* CONTINUE_FLAG_CONDITION */ por las instrucciones para excluir aquellos telefonos ya contactados
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND EXISTS (SELECT REC_ID FROM MARK_CAMPSEC_TELEMARK_RES CTER WHERE CAMPSECTION_TELE_CODE = ' . $this->getSectionCode($this->sectionId) . ' AND RESULT_CODE IN (' . singleQuote('WORK') . ') AND (CALL_USER='.singleQuote($this->ownercode).' /* OR CALL_USER='.singleQuote('').'*/) AND CAMPTARGET_ID_TABLE = ' . singleQuote($this->CEML_prmts['tablecode']) . ' AND REC_ID = ' . $this->CEML_prmts['tablecode'] . '.ID)', $sql);
        } else {
            // Trae uno epecífico
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', ' AND ID = ' . $id, $sql);
        }

        $rs = ClxCommon::$db->executeQuery($sql);
        $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
        return $r;
    }

    function verif_exist_resultId($resultTargetId){
        if ($resultTargetId>0){
            $sql="SELECT ID FROM MARK_CAMPSEC_TELEMARK_RES
              WHERE 
              ID=" . $resultTargetId . "";
            $rs = ClxCommon::$db->executeQuery($sql);
            if ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                return true;
            }else{
                return false;
            }
        }else{
            return true;
        }       
    }                               

}
