<?php

/**
 * Process Parameters Manager
 *
 * @package		Clientix.Tool.Process
 * @abstract		Process Engine Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version    	$Rev: 9902 $
 *
 */
class pr_parameters extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {

        $this->code = 'PRPM';
        $this->name = 'Process Paramters Manager';
        $this->system = 'Process';
        $this->version = '5.5.0.0';

        $this->has_access = true;


        $this->tablename = 'CLX_PR_PARAMETERS';
        $this->record_name_singular = 'GEN_LBL_PR_PARAMETERS';
        $this->record_name_plural = 'GEN_LBL_PR_PARAMETER';
        $this->primary_key = array('PROCESSCODE', 'FIELDNAME');
        $this->primary_field = 'PROCESSCODE';
        $this->secondary_field = 'FIELDNAME';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_PRPM_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_PROCESSCODE', 'fields' => array(array('name' => 'processcode', 'type' => 'lookup', 'default' => '', 'readonly' => true, 'tool' => 'PRPR', 'validations' => array(array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_PR_PROCESS'))))),
                        array('label' => 'GEN_LBL_NAME', 'fields' => array(array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(array('type' => 'string', 'required' => '1'))))),
                        array('label' => 'GEN_LBL_FIELDNAME', 'fields' => array(array('name' => 'fieldname', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS')))))
                    )
                ),
                array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_RECORD_INFO',
                    'entries' => array(
                        array('label' => 'GEN_LBL_VERSION', 'fields' => array(array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16', 'validations' => array(array('type' => 'string', 'required' => '1'))))),
                        array('label' => 'GEN_LBL_VERSION_COUNTER', 'fields' => array(array('name' => 'version_counter', 'type' => 'string', 'default' => '1.0.0', 'readonly' => true, 'size' => '32', 'displaysize' => '16', 'validations' => array())))
                    )
                ),
                array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_RECORD_OPTIONS',
                    'cols' => CLX_NUM_FOUR,
                    'entries' => array(
                        array('label' => 'GEN_LBL_CDATE', 'fields' => array(array('name' => 'cdate', 'type' => 'dati', 'dontmodify' => '1', 'displaysize' => '35', 'readonly' => true, 'validations' => array(array('type' => 'string'))))),
                        array('label' => 'GEN_LBL_MDATE', 'fields' => array(array('name' => 'mdate', 'type' => 'dati', 'displaysize' => '35', 'dontmodify' => '1', 'readonly' => true, 'validations' => array(array('type' => 'string')))))
                    )
                )
            )
        );
        $this->viewform = $this->editform;
        $this->viewform[CLX_CLASS_TITLE] = 'TOOL_PRPM_TITLE_DISPLAY';
        $this->toolpanelkeys = array(array('name' => 'PROCESSCODE', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename,
            CLX_CLASS_TITLE => $this->record_name_plural,
            'fields' => array(
                array('name' => 'ID', 'label' => 'GEN_LBL_ID', 'type' => 'number'),
                array('name' => 'PROCESSCODE', 'label' => 'GEN_LBL_PROCESSCODE', 'type' => 'string'),
                array('name' => 'IDNAME', 'label' => 'GEN_LBL_IDNAME', 'type' => 'string'),
                array('name' => 'FIELDNAME', 'label' => 'GEN_LBL_FIELDNAME', 'type' => 'string'),
                array('name' => 'VERSION', 'type' => 'fieldgroup', 'fields' => array(array('name' => 'VERSION', 'type' => 'string', 'sufix' => '.'), array('name' => 'VERSION_COUNTER', 'type' => 'number')))
            )
        );
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */





    /**
     * Tool Table Structure
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['PROCESSCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'PROCESSCODE,FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    /**
     * Tool Action
     * @param string $ac Action code
     * @param string $idlist Record(s) affected by action
     * @return string
     */
     function action($ac, $idlist) {
			
        $contents = '';
        $msg = array();
		if ( isset($_SESSION["_dEBUG"])) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); fwrite($tta,chr(13).chr(10)."14001- hora: ac:$ac".date("h:i:s d/m/Y").chr(13).chr(10)); $te=debug_backtrace();for ($t=0;$t<18;$t++) { if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}	  fwrite($tta,chr(13).chr(10).chr(13).chr(10));fclose($tta);}
        if ($this->getAccess()->canRead()) {
        //  switch ($ac) {
        //      case 'CREATE':
        //      case 'MODIFY':
		//			pre(UserRequest::$post);
		//			pre(UserRequest::$request);
        //   }
			
			$contents=parent::action($ac,$idlist);
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
		return $contents; 
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxFreeReturn(ClxCommon::$db->createRecord($this->tablename, $record, false));
    }

    /**
     * Tool Version Counter Updater
     * @param string $fieldname
     * @param string $fieldvalue
     */
    function versionIncrease($fieldname, $fieldvalue) {
        $processcode = ClxCommon::$db->getField($this->tablename, 'PROCESSCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $PRPR = &getTool('PRPR');
        $PRPR->versionIncrease('IDCODE', $processcode);
        parent::versionIncrease($fieldname, $fieldvalue);
    }

    /**
     * Prepares tool default record
     * @return array
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record['PRPM_version'] = '1.0.0';
        $record['PRPM_idname'] = '';
        $record['PRPM_fieldname'] = '';
        $record['PRPM_processcode'] = $callingpage['processcode'];
        return $record;
    }

    /**
     * Verify tool edit form
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {

        $DBFL = &getTool('DBFL');
        UserRequest::$post['PRPM_fieldname'] = uppercase(UserRequest::$post['PRPM_fieldname']);
        if (UserRequest::$request['ac'] <> 'MODIFY') {
            if (!$DBFL->fieldexists(UserRequest::$post['PRPM_fieldname'])) {
                $msg['PRPM_fieldname'] = dict('TOOL_PRPM_ERR_NOFIELD');
                $msg['ERROR'] = 'NO_FIELD';
            } else {
                if (ClxCommon::$db->oneExistsRecords($this->tablename, 'PROCESSCODE=' . singleQuote(UserRequest::$post['PRPM_processcode']) . ' AND FIELDNAME=' . singleQuote(UserRequest::$post['PRPM_fieldname'])) > CLX_NUM_ZERO) {
                    $msg['PRPM_fieldname'] = dict('TOOL_PRPM_ERR_ALREADYINCLUDED');
                }
            }
        }
        return (count($msg) === CLX_NUM_ZERO) ? true : false;
    }

}
