<?php

/**
 * Service Connector Manager
 * Webservices Service Connector Manager
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_connectors extends clx_tool {

    var $import_types;
    var $importForm;
    var $type;
    var $url;
    var $errors = array();
    var $hasErrors = false;
    var $other_user = '';
    var $other_pass = '';
    var $hasUser = false;

    function __construct() {
        $this->code = 'SKCO';
        $this->name = 'Service Connector Manager';
        $this->system = 'Sockets';
        $this->version = '5.5.1.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_SK_CONNECTORS';
        $this->record_name_singular = 'GEN_LBL_CONNECTOR';
        $this->record_name_plural = 'GEN_LBL_CONNECTORS';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->wsdl_cache = array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES');
        $this->cnx_types = array('WSDL' => 'GEN_LBL_WEBSERVICE_WSDL', 'SOCK' => 'GEN_LBL_SOCKET',
            'FILE' => 'GEN_LBL_FILE',
            'FTP' => 'GEN_LBL_FTP',
            'CURL' => 'GEN_LBL_CURL');
        $this->cnx_status = array('0' => 'GEN_LBL_INACTIVE', '1' => 'GEN_LBL_ACTIVE');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKCO_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
                                    'validations' => array(array('type' => 'sqlobject', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
                                )
                            )
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_CNX_TYPE',
                            'fields' => array(
                                array('name' => 'cnx_type', 'type' => CLX_CLASS_LIST, 'default' => 'WSDL', 'options' => $this->cnx_types)
                            )
                        ), array('label' => 'GEN_LBL_IP_OR_URL',
                            'fields' => array(
                                array('name' => 'ip_address', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '60', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_WSDL_CACHE',
                            'fields' => array(
                                array('name' => 'wsdl_cache', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->wsdl_cache)
                            )
                        ), array('label' => 'GEN_LBL_PORT_NUMBER',
                            'fields' => array(
                                array('name' => 'port_number', 'type' => 'string', 'default' => '', 'size' => '20', 'displaysize' => '20', 'sufix' => '', 'validations' => array(
                                        array('type' => 'integer', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'cnx_status', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => $this->cnx_status)
                            )
                        ), array('label' => 'GEN_LBL_FTP_PASIVE_MODE',
                            'fields' => array(
                                array('name' => 'ftp_pasive_mode', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => $this->cnx_status)
                            )
                        ), array('label' => 'GEN_LBL_VERSION',
                            'fields' => array(
                                array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_REQUEST',
                            'fields' => array(
                                array('name' => 'request', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_MODULECODE',
                            'fields' => array(
                                array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_MODULES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_SOCKET_TIMEOUT',
                            'fields' => array(
                                array('name' => 'socket_timeout', 'type' => 'string', 'default' => '1', 'size' => '4', 'displaysize' => '4', 'sufix' => 'GEN_LBL_SECONDS', 'validations' => array(
                                        array('type' => 'number', 'required' => '1', 'minimum' => CLX_NUM_0_PT_1, 'maximum' => CLX_NUM_999_PT_9))
                                )
                            )
                        )
                    )
                ), array(CLX_CLASS_SUBTITLE => 'GEN_LBL_CUSTOM_USER',
                    'type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_OTHER_USERNAME',
                            'fields' => array(
                                array('name' => 'other_username', 'type' => 'string', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '30', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_OTHER_PASSWORD',
                            'fields' => array(
                                array('name' => 'other_password', 'type' => 'password', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '30', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        )
                    )
                )
            )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SERVCONNECTOR:MENU_SKCONNECTORS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['REQUEST'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['IP_ADDRESS'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['PORT_NUMBER'] = array('type' => 'int(25)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CNX_TYPE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['WSDL_CACHE'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['CNX_STATUS'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FTP_PASIVE_MODE'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['OTHER_USERNAME'] = array('type' => 'varchar(100)', 'null' => 'YES', 'properties' => '');
        $fields['OTHER_PASSWORD'] = array('type' => 'varchar(100)', 'null' => 'YES', 'properties' => '');
        $fields['SOCKET_TIMEOUT'] = array('type' => 'decimal(4,2)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ONE);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            $contents = ($ac === 'CHECK') ? $this->check() : parent::action($ac, $idlist);
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SK_CONNECTORS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        ClxFreeReturn($listingcode);
         //$t = time('U'); genera un warning
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'SKCOList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_11);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKCO_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_11));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_CNX_TYPE'), dict('GEN_LBL_STATUS'), dict('GEN_LBL_IP_OR_URL'), dict('GEN_LBL_PORT_NUMBER'), dict('GEN_LBL_WSDL_CACHE'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_VERSION')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                $record['IDCODE'], $record['IDNAME'], $record['CNX_TYPE'], dict($this->cnx_status[$record['CNX_STATUS']]), $record['IP_ADDRESS'], $record['PORT_NUMBER'], dict($this->wsdl_cache[$record['WSDL_CACHE']]), xFormat::text($record['DESCRIPTION']),
                $record['MODULECODE'], $record['VERSION'] . '-' . $record['VERSION_COUNTER']));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SKCO_CREATEMSG')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
        }
        if ($this->getAccess()->getIsadmin()) {
            $b = new htmlFormSubmit(dict('GEN_LBL_CHECK'), 'CHECK', $form->getProp(CLX_PROP_ID));
            $b->setProp(CLX_PROP_ID, 'ONE');
            $buttons .= $b->source();
        }
        $b = new htmlFormSubmit(dict('GEN_LBL_FILTER'), 'FILTER', $form->getProp(CLX_PROP_ID));
        $b->setProp(CLX_PROP_ID, 'ON');
        $buttons .= $b->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKCO_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'SKCO_idcode', (array_key_exists('SKCO_idcode', UserRequest::$post)) ? UserRequest::$post['SKCO_idcode'] : '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'SKCO_idname', (array_key_exists('SKCO_idname', UserRequest::$post)) ? UserRequest::$post['SKCO_idname'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'SKCO_modulecode', (array_key_exists('SKCO_modulecode', UserRequest::$post)) ? UserRequest::$post['SKCO_modulecode'] : '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['SKCO_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKCO_idcode']) . '%');
            }
            if (UserRequest::$post['SKCO_idname'] <> '') {
                $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SKCO_idname'])) . '%');
            }
            if (UserRequest::$post['SKCO_modulecode'] <> '') {
                $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKCO_modulecode']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sk_connectors></page><page t=sk_connections></page><a href="' . $js . '">' . $record['IDCODE'] . '</a>', $record['IDNAME']));
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['SKCO_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['SKCO_idname']);
    }

    function viewFormFill($record) {
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKCO_TITLE_VIEW') . ': ' . $record['SKCO_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['SKCO_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['SKCO_idname']);
        $table->addData(dict('GEN_LBL_IP_OR_URL') . ':', $record['SKCO_ip_address']);
        $table->addData(dict('GEN_LBL_PORT_NUMBER') . ':', $record['SKCO_port_number']);
        $table->addData(dict('GEN_LBL_WSDL_CACHE') . ':', $record['SKCO_wsdl_cache']);
        $table->addData(dict('GEN_LBL_FTP_PASIVE_MODE') . ':', $record['SKCO_ftp_pasive_mode']);
        $table->addData(dict('GEN_LBL_STATUS') . ':', $this->cnx_status[$record['SKCO_cnx_status']]);
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['SKCO_version'] . '-' . $record['SKCO_version_counter']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['SKCO_description']));
        $table->addData(dict('GEN_LBL_REQUEST') . ':', '<pre>' . $record['SKCO_request'] . '</pre>');
        $table->addData(dict('GEN_LBL_MODULECODE') . ':', $record['SKCO_modulecode']);
        $contents .= $table->source();
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['SKCO_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['SKCO_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['SKCO_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('SKCO_idcode', UserRequest::$post))
            UserRequest::$post['SKCO_idcode'] = '';
        if (!array_key_exists('SKCO_idname', UserRequest::$post))
            UserRequest::$post['SKCO_idname'] = '';
        if (!array_key_exists('SKCO_modulecode', UserRequest::$post))
            UserRequest::$post['SKCO_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'SKCO_idcode', UserRequest::$post['SKCO_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'SKCO_idname', UserRequest::$post['SKCO_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE'), 'SKCO_modulecode', UserRequest::$post['SKCO_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sort = new HtmlSelect('SKCO_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
        $sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
        $sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['SKCO_idcode'])) {
            $filter .= $boolean . ' IDCODE LIKE ' . singleQuote(UserRequest::$post['SKCO_idcode'] . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SKCO_idname'])) {
            $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SKCO_idname'])) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SKCO_modulecode'])) {
            $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKCO_modulecode']) . '%');
            $boolean = 'AND';
        }
        $_SESSION['paging']['SKCOList']['sortby'] = UserRequest::$post['SKCO_sort'];
        $_SESSION['paging']['SKCOList']['criteria'] = $filter;
        $_SESSION['paging']['SKCOList']['startat'] = '0';
    }

    function clearfilter() {
        $_SESSION['paging']['SKCOList']['criteria'] = '';
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['SKCO_id'] = $recordid;
        $record['SKCO_idcode'] = $values['IDCODE'];
        $record['SKCO_idname'] = $values['IDNAME'];
        $record['SKCO_version'] = $values['VERSION'];
        $record['SKCO_version_counter'] = $values['VERSION_COUNTER'];
        $record['SKCO_cdate'] = $d;
        $record['SKCO_mdate'] = $d;
        $record['SKCO_username'] = $values['USERNAME'];
        $record['SKCO_description'] = $values['DESCRIPTION'];
        $record['SKCO_request'] = $values['REQUEST'];
        $record['SKCO_modulecode'] = $values['MODULECODE'];
        $record['SKCO_cnx_type'] = $values['CNX_TYPE'];
        $record['SKCO_cnx_status'] = $values['CNX_STATUS'];
        $record['SKCO_ip_address'] = $values['IP_ADDRESS'];
        $record['SKCO_port_number'] = $values['PORT_NUMBER'];
        $record['SKCO_wsdl_cache'] = $values['WSDL_CACHE'];
        $record['SKCO_ftp_pasive_mode'] = $values['FTP_PASIVE_MODE'];
        $record['SKCO_other_username'] = $values['OTHER_USERNAME'];
        $record['SKCO_other_password'] = $values['OTHER_PASSWORD'];
        $record['SKCO_socket_timeout'] = $values['SOCKET_TIMEOUT'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['IDNAME'] = UserRequest::$post['SKCO_idname'];
        $record['VERSION'] = UserRequest::$post['SKCO_version'];
        $record['MDATE'] = xFormat::getNow('Y-m-d');
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['SKCO_description'];
        $record['REQUEST'] = UserRequest::$post['SKCO_request'];
        $record['MODULECODE'] = UserRequest::$post['SKCO_modulecode'];
        $record['CNX_TYPE'] = UserRequest::$post['SKCO_cnx_type'];
        $record['CNX_STATUS'] = UserRequest::$post['SKCO_cnx_status'];
        $record['IP_ADDRESS'] = UserRequest::$post['SKCO_ip_address'];
        $record['PORT_NUMBER'] = UserRequest::$post['SKCO_port_number'];
        $record['WSDL_CACHE'] = UserRequest::$post['SKCO_wsdl_cache'];
        $record['FTP_PASIVE_MODE'] = UserRequest::$post['SKCO_ftp_pasive_mode'];
        $record['OTHER_USERNAME'] = UserRequest::$post['SKCO_other_username'];
        $record['OTHER_PASSWORD'] = UserRequest::$post['SKCO_other_password'];
        $record['SOCKET_TIMEOUT'] = UserRequest::$post['SKCO_socket_timeout'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKCO_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKCO_id']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKCO_idcode'];
        $record['IDNAME'] = UserRequest::$post['SKCO_idname'];
        $record['VERSION'] = UserRequest::$post['SKCO_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['SKCO_description'];
        $record['REQUEST'] = UserRequest::$post['SKCO_request'];
        $record['MODULECODE'] = UserRequest::$post['SKCO_modulecode'];
        $record['CNX_TYPE'] = UserRequest::$post['SKCO_cnx_type'];
        $record['CNX_STATUS'] = UserRequest::$post['SKCO_cnx_status'];
        $record['IP_ADDRESS'] = UserRequest::$post['SKCO_ip_address'];
        $record['PORT_NUMBER'] = UserRequest::$post['SKCO_port_number'];
        $record['WSDL_CACHE'] = UserRequest::$post['SKCO_wsdl_cache'];
        $record['FTP_PASIVE_MODE'] = UserRequest::$post['SKCO_ftp_pasive_mode'];
        $record['OTHER_USERNAME'] = UserRequest::$post['SKCO_other_username'];
        $record['OTHER_PASSWORD'] = UserRequest::$post['SKCO_other_password'];
        $record['SOCKET_TIMEOUT'] = UserRequest::$post['SKCO_socket_timeout'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('IDCODE', $record['IDCODE']);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $SKSV = &getTool('SKSV');
        $SKSV->versionIncrease('CONNECTOR', $record['IDCODE']);
    }

    function defaultRecord() {
        $record = array();
        $record['SKCO_id'] = CLX_INIT_ZERO;
        $record['SKCO_idcode'] = '';
        $record['SKCO_idname'] = '';
        $record['SKCO_version'] = '1.0.0';
        $record['SKCO_cdate'] = '';
        $record['SKCO_mdate'] = '';
        $record['SKCO_username'] = $_SESSION['user_record']['username'];
        $record['SKCO_description'] = '';
        $record['SKCO_request'] = '';
        $record['SKCO_modulecode'] = '';
        $record['SKCO_cnx_type'] = 'WSDL';
        $record['SKCO_cnx_status'] = CLX_NUM_ONE;
        $record['SKCO_wsdl_cache'] = CLX_INIT_ZERO;
        $record['SKCO_ftp_pasive_mode'] = CLX_INIT_ZERO;
        $record['SKCO_ip_address'] = '127.0.0.1';
        $record['SKCO_port_number'] = CLX_NUM_80;
        $record['SKCO_other_username'] = '';
        $record['SKCO_other_password'] = '';
        $record['SKCO_socket_timeout'] = CLX_NUM_ONE;
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        parent::versionIncrease($fieldname, $fieldvalue);
        $connector = ClxCommon::$db->getField($this->tablename, 'IDCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKSV = getTool('SKSV');
        $SKSV->versionIncrease('CONNECTOR', $connector);
    }

    function check() {
        $idlist = getIdlist();
        $cntr = ClxCommon::$db->getRecord($this->tablename, 'ID = ' . $idlist[CLX_NUM_ZERO]);
        $this->parse_ftp_address($cntr);
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKCO_TEST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $table->addCell(CLX_CHAR_HTML_NBSP, array());
        $err = array();
        //Validate IP and Port
        if (empty($cntr['IP_ADDRESS'])) {
            $err[] = dict('GEN_LBL_ERROR') . ': <b>' . dict('GEN_LBL_IP_OR_URL') . ' ' . dict('GEN_LBL_REQUIRED') . '</b>';
        }
        if ($cntr['CNX_TYPE'] <> 'FILE' && empty($cntr['PORT_NUMBER'])) {
            $err[] = dict('GEN_LBL_ERROR') . ': <b>' . dict('GEN_LBL_PORT_NUMBER') . ' ' . dict('GEN_LBL_REQUIRED') . '</b>';
        }
        if ($cntr['CNX_STATUS'] == CLX_NUM_ZERO) {
            $err[] = dict('GEN_LBL_ERROR') . ': <b>' . dict('GEN_LBL_STATUS') . ' ' . dict($this->cnx_status[CLX_NUM_ZERO]) . '</b>';
        }
        if (!empty($err)) {
            $table->addCell(implode('<br>', $err), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        } else {
            switch ($cntr['CNX_TYPE']) {
                case 'FTP':
                    $sck = new clx_ftp($cntr['IP_ADDRESS'], $cntr['OTHER_USERNAME'], $cntr['OTHER_PASSWORD'], $cntr['PORT_NUMBER'], false);
                    $sck->timeout = (empty($cntr['SOCKET_TIMEOUT'])) ? CLX_NUM_30 : $cntr['SOCKET_TIMEOUT'];
                    $table->addCell(dict('GEN_LBL_SOCKET_TIMEOUT') . ':<b>' . $cntr['SOCKET_TIMEOUT'] . '</b> ' . dict('GEN_LBL_SECONDS') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $sck->connect();
                    if ($sck->errornum == CLX_NUM_ZERO) {
                        $table->addCell(dict('GEN_LBL_CONNECTION') . ' (' . $cntr['IP_ADDRESS'] . ':' . $cntr['PORT_NUMBER'] . '): <b>' . dict('GEN_LBL_OK') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $sck->close();
                    } else {
                        $table->addCell(dict('GEN_LBL_CONNECTION') . ': <b>' . dict('GEN_LBL_FAIL') . '</b><br>' . $sck->errormsg, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    }
                    break;
                case 'CURL':
                    if (!function_exists('curl_init')) {
                        $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_FAIL') . '<br>' . dict('GEN_LBL_INSTALL_CURL') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        break;
                    }
                    $ch = curl_init($cntr['IP_ADDRESS']);
                    curl_setopt($ch, CURLOPT_HEADER, CLX_NUM_ZERO);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, CLX_NUM_ONE);
                    //curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim('', '& ' ));
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                    $response_string = urldecode(curl_exec($ch));
                    if (!curl_errno($ch)) {
                        $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_OK') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell('<br><blockquote><b>' . dict('GEN_LBL_REQUEST') . '</b><br><pre>' . $cntr['IP_ADDRESS'] . '</pre><br><b>' . dict('GEN_LBL_RESPONSE') . '</b><br><pre>' . $response_string . '</pre></blockquote>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    } else {
                        $response_string = curl_error($ch);
                        $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_FAIL') . '<br>' . $response_string . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    }
                    curl_close($ch);
                    break;
                case 'SOCK':

                    $sck = new clx_socket($cntr['IP_ADDRESS'], $cntr['PORT_NUMBER'], false, false);
                    $sck->timeout = (empty($cntr['SOCKET_TIMEOUT'])) ? CLX_NUM_ONE : $cntr['SOCKET_TIMEOUT'];
                    $table->addCell(dict('GEN_LBL_SOCKET_TIMEOUT') . ':<b>' . $cntr['SOCKET_TIMEOUT'] . '</b> ' . dict('GEN_LBL_SECONDS') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    if ($sck->connect()) {
                        $table->addCell(dict('GEN_LBL_CONNECTION') . ' (' . $cntr['IP_ADDRESS'] . ':' . $cntr['PORT_NUMBER'] . '): <b>' . dict('GEN_LBL_OK') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        //Send Test Request
                        if (!empty($cntr['REQUEST'])) {
                            //Sending first 2 bytes with input size used on datpro socket
                            $sck->write($sck->stringByteLength($cntr['REQUEST']));
                            if ($sck->write($cntr['REQUEST'])) {
                                $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_OK') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                                $table->addCell('<br><blockquote><b>' . dict('GEN_LBL_REQUEST') . '</b><br><pre>->' . $cntr['REQUEST'] . '<-</pre><br><b>' . dict('GEN_LBL_RESPONSE') . '</b><br><pre>' . $sck->read(CLX_NUM_1024, CLX_NUM_ONE) . '</pre></blockquote>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                            } else {
                                $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_FAIL') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                            }
                        }
                        $sck->close();
                    } else {
                        $table->addCell($table->addCell(dict('GEN_LBL_CONNECTION') . ': <b>' . dict('GEN_LBL_FAIL') . '</b><br>' . $sck->errorMsg(), array()), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    }
                    break;
                case 'WSDL':
                    try {
                        $client = new SoapClient($cntr['IP_ADDRESS'], array('trace' => CLX_NUM_ONE, 'exceptions' => CLX_NUM_ONE));
                        $result = $client->__getFunctions();
                        if (!is_soap_fault($result)) {
                            $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_OK') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                            $table->addCell('<br><blockquote><b>' . dict('GEN_LBL_METHODS') . '</b><pre>' . implode('<br>', $result) . '</pre></blockquote>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                            //$table->addCell('<br><blockquote><b>'.dict('GEN_LBL_TYPES') . '</b><pre>'.implode('<br>',array( $result2).'</pre></blockquote>'=> CLX_PROP_CLASS,CLX_CLASS_DATA));
                        } else {
                            $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_FAIL') . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        }
                    } catch (Exception $e) {
                        $table->addCell(dict('GEN_LBL_REQUESTSTATUS') . ': <b>' . dict('GEN_LBL_FAIL') . '<br>' . dict('GEN_LBL_ERROR') . ': </b>' . $e->getMessage(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    }
                    $client = null;
                    break;
                case 'FILE':
                    if (file_exists($cntr['IP_ADDRESS'])) {
                        $table->addCell(dict('GEN_LBL_CONNECTOR') . ': <b>' . $cntr['IDCODE'] . ' - ' . $cntr['IDNAME'] . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(dict('GEN_LBL_FILE') . ': <b>' . $cntr['IP_ADDRESS'] . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(dict('GEN_LBL_STATUS') . ': <b><font color="green">' . dict('GEN_LBL_OK') . '</font></b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    } else {
                        $table->addCell(dict('GEN_LBL_CONNECTOR') . ': <b>' . $cntr['IDCODE'] . ' - ' . $cntr['IDNAME'] . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(dict('GEN_LBL_FILE') . ': <b>' . $cntr['IP_ADDRESS'] . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(dict('GEN_LBL_STATUS') . ': <b><font color="red">' . dict('GEN_ERR_FILE_NOT_FOUND') . '</font></b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    }
                    $client = null;
                    break;
                default:
                    $table->addCell($table->addCell(dict('GEN_LBL_CONNECTION') . ': <b>' . dict('GEN_LBL_FAIL') . '</b><br>' . dict('GEN_LBL_CNXTYPEINVALID')), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    break;
            }
        }
        return $table->source();
    }

    function reportError($errorno, $errormsg) {
        $this->hasErrors = true;
        $this->errors[] = array($errorno, $errormsg);
    }

    function getError() {

    }

    /**
     * Retrive connection parameters and set the wsdl cache parameters on ini
     *
     * @param string $connector
     * @return string $url_or_ip
     */
    function getWsdl($connector_code) {
        $result = $this->getConnector($connector_code);
        if (!empty($result)) {
            //Set php ini parameters for this conection
            if ($result['CNX_TYPE'] === 'WSDL')
                ini_set('soap.wsdl_cache_enabled', $result['WSDL_CACHE']);
        }
        return $result['IP_ADDRESS'];
    }

    function getConnector($connector_code) {
        $cnx = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($connector_code) . ' AND CNX_STATUS = 1');
        $this->parse_ftp_address($cnx);
        return $cnx;
    }

    /**
     * Builds connector for ftp
     * @param unknown_type $connector_rec
     */
    private function parse_ftp_address(&$connector_rec) {
        if (empty($connector_rec))
            return;
        if ($connector_rec['CNX_TYPE'] === 'FTP') {
            $path = explode('/', $connector_rec['IP_ADDRESS']);
            $connector_rec['IP_ADDRESS'] = $path[CLX_NUM_ZERO];
            unset($path[CLX_NUM_ZERO]);
            $connector_rec['CNX_DEFAULT_FOLDER'] = implode('/', $path);
        }
    }

    /**
     * Load connector properties
     *
     * @param unknown_type $connector
     * @return unknown
     */
    function loadConnector($connector_code) {
        $result = $this->getConnector($connector_code);
        if (!empty($result)) {
            $this->url = $result['IP_ADDRESS'];
            $this->type = $result['CNX_TYPE'];
            $this->other_user = $result['OTHER_USERNAME'];
            $this->other_pass = $result['OTHER_PASSWORD'];
            $this->hasUser = (strlen($result['OTHER_USERNAME']) > CLX_NUM_ZERO) ? true : false;
            if ($this->type == 'WSDL')
                ini_set('soap.wsdl_cache_enabled', $result['WSDL_CACHE']);
        } else {
            $this->reportError(CLX_NUM_ZERO, dict('GEN_CODE_SKSV_NOWSDLFOUND', $connector_code));
        }
    }

}

// End class
