<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_formule_functions extends clx_tool {

    function __construct() {
        $this->code = 'SKFE';
        $this->name = 'SK_Formule_Functions';
		$this->version = '1.0.0.0';
        $this->has_preferences = true;

        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';
    }
	function getTransformContractStatus(&$record,$field) { 
		IF (!ISSET($this->FICS))  {
			$DBLT = &getTool('DBLT');
			$this->FICS = $DBLT->getListAsArray('FICS');
			
		}
		/*ECHO '----------';
		PRE($this->FICS);
		pre($record);*/
		if (!empty($record[$field]) && in_array($record[$field],$this->FICS) )
			$record[$field]=$this->FICS[$record[$field]];
		//pre($record);
		else
			$record[$field]='';
	}
	function getTransformAuthStatus(&$record,$field) { 
		IF (!ISSET($this->AUTH))  {
			$DBLT = &getTool('DBLT');
			$this->AUTH = $DBLT->getListAsArray('AUTH');
			
		}
	/*	ECHO '----------';
		PRE($this->AUTH);
		pre($record);
		*/
		if (!empty($record[$field]) && isset($this->AUTH[$record[$field]]) )
			$record[$field]=$this->AUTH[$record[$field]];
		//pre($record);
		else
			$record[$field]='';
	}
	
	function getTransformTrustType(&$record,$field) { 
		IF (!ISSET($this->FITY))  {
			$DBLT = &getTool('DBLT');
			$this->FITY = $DBLT->getListAsArray('FITY');
			
		}
	
		if (!empty($record[$field]) && isset($this->FITY[$record[$field]]) )
			$record[$field]=$this->FITY[$record[$field]];
		else
			$record[$field]='';
	}
	function getTransformContractTypes(&$record,$field) { 
		IF (!ISSET($this->FICT))  {
			$DBLT = &getTool('DBLT');
			$this->FICT = $DBLT->getListAsArray('FICT');
			
		}
	
		if (!empty($record[$field]) && isset($this->FICT[$record[$field]]) )
			$record[$field]=$this->FICT[$record[$field]];
		else
			$record[$field]='';
	}
	function getTransformTrustTypes(&$record,$field) { 
		IF (!ISSET($this->TRUST))  {
			$Xrecords = ClxCommon::$db->executeQuery('SELECT IDCODE,IDNAME FROM FIDU_TRUSTEES');
			$arr=array();
			while ($Xrecord = ClxCommon::$db->getNextRecord($Xrecords, ASSOCIATIVE)) {
				$arr[$Xrecord['IDCODE']]=$Xrecord['IDNAME'];
			}
			$this->TRUST =$arr ;
		}
	
		if (!empty($record[$field]) && isset($this->TRUST[$record[$field]]) )
			$record[$field]=$this->TRUST[$record[$field]];
		else
			$record[$field]='';
		
	}
	//$this->SKFE->getTransformTrustStatus($record,"FICO__PRODUCT_TYPE");
	function getTransformTrustStatus(&$record,$field) { //PRE($record);
		IF (!ISSET($this->TRSTS))  {
			$DBLT = &getTool('DBLT');
			$this->TRSTS= $DBLT->getListAsArray('TRST');
		}//echo 'xxxxxxx',chr(10);
		//pre($record);
		//echo $record[$field];
		if (!empty($record[$field]) && isset($this->TRSTS[$record[$field]]) )
			$record[$field]=$this->TRSTS[$record[$field]];
		else
			$record[$field]='';
		//pre($record);
	}
	//$this->SKFE->getBaseCompanies($record,"JAVW_COMPCODE");
	function getBaseCompanies(&$record,$field) { 
		IF (!ISSET($this->BACO))  {
			$Xrecords = ClxCommon::$db->executeQuery('SELECT IDCODE,IDNAME FROM BASE_COMPANIES');
			$arr=array();
			while ($Xrecord = ClxCommon::$db->getNextRecord($Xrecords, ASSOCIATIVE)) {
				$arr[$Xrecord['IDCODE']]=$Xrecord['IDNAME'];
			}
			$this->BACO=$arr ;
		}
	
		if (!empty($record[$field]) &&  isset($this->BACO[$record[$field]]) )
			$record[$field]=$this->BACO[$record[$field]];
		else
			$record[$field]='';
	}
	
	//$this->SKFE->getTransformFiduTransactionTbl($record,"JAVW_COMPCODE");
	function getTransformFiduTransactionTbl(&$record,$field) { 
		IF (!ISSET($this->FITTL))  {
			$Xrecords = ClxCommon::$db->executeQuery('SELECT IDCODE,IDNAME FROM FIDU_TRANSACTION_TBL');
			$arr=array();
			while ($Xrecord = ClxCommon::$db->getNextRecord($Xrecords, ASSOCIATIVE)) {
				$arr[$Xrecord['IDCODE']]=$Xrecord['IDNAME'];
			}
			$this->FITTL=$arr ;
		}
	
		if (!empty($record[$field]) &&  isset($this->FITTL[$record[$field]]) )
			$record[$field]=$this->FITTL[$record[$field]];
		else
			$record[$field]='';
	}
	
	
	
	
	
	//$this->SKFE->getProductCrm($record,"JAVW_PRODUCT_TYPE");
	function getProductCrm(&$record,$field) { 
		IF (!ISSET($this->BPTY))  {
			$DBLT = &getTool('DBLT');
			$this->BPTY = $DBLT->getListAsArray('BPTY');
		}//echo 'xxxxxxx',chr(10);
		//pre($record);
		//echo $record[$field];
		if (!empty($record[$field]) && isset($this->BPTY[$record[$field]]) )
			$record[$field]=$this->BPTY[$record[$field]];
		else
			$record[$field]='';
		//pre($record);
	}
	
	//$this->SKFE->getFiduContracts($record,"FIAT_CHART_FIELD01");
	function getFiduContracts(&$record,$field) { 
		IF (!ISSET($this->PRDT))  {
			$Xrecords = ClxCommon::$db->executeQuery('SELECT IDCODE,IDNAME FROM FIDU_CONTRACTS');
			$arr=array();
			while ($Xrecord = ClxCommon::$db->getNextRecord($Xrecords, ASSOCIATIVE)) {
				$arr[$Xrecord['IDCODE']]=$Xrecord['IDNAME'];
			}
			$this->PRDT=$arr ;
		}
		if (!empty($record[$field]) && isset($this->PRDT[$record[$field]]) )
			$record[$field]=$this->PRDT[$record[$field]];
		else
			$record[$field]='';
	}



	function getTransformStatusActive(&$record,$field) {
		IF (!ISSET($this->ACST))  {
			$DBLT = &getTool('DBLT');
			$this->ACST = $DBLT->getListAsArray('ACST');
			
		}
	
		if (!empty($record[$field])&& isset($this->ACST[$record[$field]]) )
			$record[$field]=$this->ACST[$record[$field]];
		else
			$record[$field]='';
		
	}
	//CURR  $this->SKFE->getTransformCurrency($record,"FICO_CURRENCY_CODE"); 
	function getTransformCurrency(&$record,$field) {
		IF (!ISSET($this->CURR))  {
			$DBLT = &getTool('DBLT');
			$this->CURR = $DBLT->getListAsArray('CURR');
			
		}
	//	PRE($this->CURR);PRE($record[$field]);
		if (!empty($record[$field])&& isset($this->CURR[$record[$field]]) )
			$record[$field]=$this->CURR[$record[$field]];
		else
			$record[$field]='';
	}
	//DISB  $this->SKFE->getTransformDisbursementType($record,"FIAT_DISBURSEMENT_TYPE"); 
	function getTransformDisbursementType(&$record,$field) {
		IF (!ISSET($this->DISB))  {
			$DBLT = &getTool('DBLT');
			$this->DISB = $DBLT->getListAsArray('DISB');
			
		}
		//pre($record[$field]);pre($this->DISB);
		if (!empty($record[$field])&& isset($this->DISB[$record[$field]]) )
			$record[$field]=$this->DISB[$record[$field]];
		else
			$record[$field]='';
	}
	
	//PRCL  $this->SKFE->getTransformProductClass($record,"JAVW_PRODUCT_CLASS"); 
	function getTransformProductClass(&$record,$field) {//pre($record); 
		
		IF (!ISSET($this->PRCL))  {
			$DBLT = &getTool('DBLT');
			$this->PRCL = $DBLT->getListAsArray('PRCL');
			
		}
	
		if (!empty($record[$field])&& isset($this->PRCL[$record[$field]]) )
			$record[$field]=$this->PRCL[$record[$field]];
		else
			$record[$field]='';
	}
	
	
	//SELECT IDNAME FROM FIDU_TRUSTEES WHERE IDCODE='NJ';
}