<?php

/**
 * Menu item manager
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract	Interfase Mask Manager
 * @package		Clientix.Tool.Interface
 * @author      $Author: fsantana $
 * @copyright   Alenet, Inc.
 * @since       $Date:  10:41:59 -0430 (Thu, 23 Jun 2011) $
 * @version    	$Rev: 2531 $
 *
 * CHANGE LOGS
 *  Tool Created
 */
class ui_form_fld_prop extends clx_tool {

    var $fld_prop_type = array('' => '', 'REQ' => 'GEN_LBL_REQUIRED', 'HID' => 'GEN_LBL_HIDDEN', 'RON' => 'GEN_LBL_READ_ONLY');
    var $operators_types = array('' => array('', ''), 'EQ' => array('GEN_OPE_EQUAL', '==='), 'NQ' => array('GEN_OPE_NOTEQUAL', '!== '), 'LS' => array('GEN_OPE_LESS', '<'), 'GT' => array('GEN_OPE_GREATER', '>'), 'GQ' => array('GEN_OPE_GREATER_EQUAL', '>='), 'LQ' => array('GEN_OPE_LESS_EQUAL', '<='), 'IN' => array('GEN_OPE_IN', 'IN'), 'NI' => array('GEN_OPE_NOTIN', 'NOT IN'));

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'UIFR';
        $this->name = 'Form Field Properties';
        $this->system = 'Interface';
        $this->version = '5.5.0.0';




        $this->tablename = 'CLX_UI_FORM_FLD_PROP';
        $this->record_name_singular = 'CLX_UIFR_PROPERTY';
        $this->record_name_plural = 'CLX_UIFR_PROPERTIES';
        $this->primary_field = 'ID';
        $this->sortclause = 'FORMCODE, FIELDNAME, SEQNUM';
        $this->seqnum_field = 'SEQNUM';
        $this->primary_key = array('ID');
        $this->operators = array();
        foreach ($this->operators_types as $key => $val) {
            $this->operators[$key] = $val[CLX_NUM_ZERO];
        }
        $this->viewform = array(CLX_CLASS_TITLE => 'TOOL_' . $this->code . '_TITLE_DISPLAY', 'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FORMCODE',
                            'fields' => array(
                                array('name' => 'formcode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'UIFM',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'IDCODE',
                                            'tablename' => 'CLX_UI_FORMS',
                                            'required' => '1'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'DBFL',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'FIELDNAME',
                                            'tablename' => 'CLX_DB_FIELDS',
                                            'required' => '1'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_ACTIVE',
                            'fields' => array(
                                array('name' => 'active',
                                    'type' => CLX_CLASS_LIST,
                                    'options' => $this->yesno, 'default' => CLX_NUM_ONE
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROPERTY_TYPE',
                            'fields' => array(
                                array('name' => 'property_type',
                                    'type' => CLX_CLASS_LIST,
                                    'options' => $this->fld_prop_type, 'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        )
                                    )
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_CONDITION',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FRM_FIELDNAME1',
                            'fields' => array(
                                array('name' => 'fieldname1',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'DBFL',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'FIELDNAME',
                                            'tablename' => 'CLX_DB_FIELDS',
                                            'required' => '0'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_OPERATOR',
                            'fields' => array(
                                array('name' => 'operator',
                                    'type' => CLX_CLASS_LIST,
                                    'options' => $this->operators, 'validations' => array(
                                        array('type' => 'string',
                                            'required' => '0'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_VALUE',
                            'fields' => array(
                                array('name' => 'value',
                                    'type' => 'string',
                                    'size' => '64',
                                    'displaysize' => '32',
                                    'default' => '',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '0'
                                        )
                                    )
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_RECORD_OPTIONS',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CDATE',
                            'fields' => array(
                                array('name' => 'cdate',
                                    'type' => 'dati',
                                    'dontmodify' => '1',
                                    'displaysize' => '35',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'string'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_CREATEDBY',
                            'fields' => array(
                                array('name' => 'createdby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'USERNAME',
                                            'tablename' => 'CLX_AC_USERS'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MDATE',
                            'fields' => array(
                                array('name' => 'mdate',
                                    'type' => 'dati',
                                    'displaysize' => '35',
                                    'dontmodify' => '1',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'string'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MODIFIEDBY',
                            'fields' => array(
                                array('name' => 'modifiedby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'USERNAME',
                                            'tablename' => 'CLX_AC_USERS'
                                        )
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->editform = $this->viewform;
        $this->toolpanelkeys = array(array('name' => 'FORMCODE', 'type' => 'string'), array('name' => 'FIELDNAME', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_reorder' => true,
            'has_filter' => false,
            'has_export' => false,
            'fields' =>
            array(array('name' => 'ID', 'type' => 'number'), array('name' => 'FORMCODE', 'type' => 'string', 'label' => 'GEN_LBL_FORMCODE'), array('name' => 'FIELDNAME', 'type' => 'string', 'label' => 'GEN_LBL_FIELDNAME'), array('name' => 'PROPERTY_TYPE', 'type' => CLX_CLASS_LIST, 'options' => $this->fld_prop_type), array('name' => 'FIELDNAME1', 'type' => 'string', 'label' => 'GEN_LBL_FIELDNAME1'), array('name' => 'OPERATOR', 'type' => CLX_CLASS_LIST, 'options' => $this->operators),
                array('name' => 'VALUE', 'type' => 'string'))
        );
        $this->toollist = $this->toolpanel;
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 				'index'=>'', default = '', 'dict'=>true)
     * 				 dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['FORMCODE'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'YES');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['ACTIVE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $fields['PROPERTY_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO');
        $fields['FIELDNAME1'] = array('type' => 'varchar(64)', 'null' => 'YES');
        $fields['OPERATOR'] = array('type' => 'varchar(4)', 'null' => 'YES');
        $fields['FIELDNAME2'] = array('type' => 'varchar(64)', 'null' => 'YES');
        $fields['VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['CREATEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['MODIFIEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '03'] = array('index' => 'UNI', 'fieldname' => 'FORMCODE,FIELDNAME,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => CLX_NUM_ZERO), $parameters));
        list($package, $parent) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->createRecord($this->tablename, $record, true);
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_MASKS_CRIT-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Verify Tool Edit Forms
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $result = parent::checkForm($msg);
        if (!empty(UserRequest::$post[$this->code . '_fieldname1']) && (strlen(UserRequest::$post[$this->code . '_value']) == CLX_NUM_ZERO || empty(UserRequest::$post[$this->code . '_operator']))) {
            $msg[$this->code . '_operator'] = dict('GEN_LBL_FIELD_REQUIRED');
            $msg[$this->code . '_value'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (empty(UserRequest::$post[$this->code . '_fieldname1']) && (strlen(UserRequest::$post[$this->code . '_value']) > CLX_NUM_ZERO || !empty(UserRequest::$post[$this->code . '_operator']))) {
            $msg[$this->code . '_fieldname1'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (UserRequest::$post[$this->code . '_fieldname'] == UserRequest::$post[$this->code . '_fieldname1']) {
            $msg[$this->code . '_fieldname1'] = dict('GEN_ERR_FORMFIELD_NOT_EQUAL_FIELDCRIT');
        }
        if (empty(UserRequest::$post[$this->code . '_operator']) && strlen(UserRequest::$post[$this->code . '_value']) > CLX_NUM_ZERO) {
            $msg[$this->code . '_operator'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty(UserRequest::$post[$this->code . '_operator']) && strlen(UserRequest::$post[$this->code . '_value']) == CLX_NUM_ZERO) {
            $msg[$this->code . '_value'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty(UserRequest::$post[$this->code . '_fieldname1'])) {
            //Validar que campo exista en forma
            $sql = 'SELECT COUNT(UIFP.ID) QTY FROM CLX_UI_FORM_PANEL_FIELDS UIPF, CLX_UI_FORM_PANELS UIFP WHERE UIFP.IDCODE = UIPF.PANELID AND UIFP.FORMCODE = ' . singleQuote(UserRequest::$post[$this->code . '_formcode']) . ' AND UIPF.FIELDNAME = ' . singleQuote(UserRequest::$post[$this->code . '_fieldname1']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg[$this->code . '_fieldname1'] = dict('GEN_ERR_FIELD_NOTIN_FORM', UserRequest::$post[$this->code . '_formcode']);
            }
        }
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
            //validar que si ya existe este requerido
            $sql = 'SELECT COUNT(ID) QTY FROM ' . $this->tablename . ' WHERE FORMCODE = ' . singleQuote(UserRequest::$post[$this->code . '_formcode']) . ' AND FIELDNAME = ' . singleQuote(UserRequest::$post[$this->code . '_fieldname']) . ' AND FIELDNAME1 = ' . singleQuote(UserRequest::$post[$this->code . '_fieldname1']) . ' AND PROPERTY_TYPE = ' . singleQuote(UserRequest::$post[$this->code . '_property_type']) . ' AND OPERATOR = ' . singleQuote(UserRequest::$post[$this->code . '_operator']) . ' AND VALUE = ' . singleQuote(UserRequest::$post[$this->code . '_value']);
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg[$this->code . '_property_type'] = dict('GEN_ERR_PROPERTY_EXISTS');
                if (!empty(UserRequest::$post[$this->code . '_fieldname1']))
                    $msg[$this->code . '_fieldname1'] = $msg[$this->code . '_property_type'];
                if (!empty(UserRequest::$post[$this->code . '_operator']))
                    $msg[$this->code . '_operator'] = $msg[$this->code . '_property_type'];
                if (!empty(UserRequest::$post[$this->code . '_value']))
                    $msg[$this->code . '_value'] = $msg[$this->code . '_property_type'];
            }
        }
        return $result && (count($msg) == CLX_NUM_ZERO);
    }

    /**
     * Defines default record on initializacion
     *
     * @return array
     */
    function defaultRecord() {
        $record = parent::defaultRecord();
        $callingpage = peekHistory();
        $record[$this->code . '_fieldname'] = $callingpage['fieldname'];
        $record[$this->code . '_formcode'] = $callingpage['formcode'];
        return $record;
    }


    function createRecord_() {
        $sql = 'SELECT IFNULL(MAX(SEQNUM),0)+1 SEQNUM FROM ' . $this->tablename . ' WHERE FORMCODE = ' . singleQuote(UserRequest::$post[$this->code . '_formcode']) . ' AND FIELDNAME = ' . singleQuote(UserRequest::$post[$this->code . '_fieldname']);
        UserRequest::$post[$this->code . '_seqnum'] = ClxCommon::$db->getOne($sql);
        parent::createRecord_();
    }

    /**
     * Delete record
     *
     * @param type $id
     */
    function deleteRecordSk($id) {
        $this->versionIncrease('ID', $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    /**
     * Creates reorder list
     * @return string
     */
    function reorderRecords() {
        $callingpage = peekHistory();
        $rs = ClxCommon::$db->getRecords($this->tablename, 'FORMCODE=' . singleQuote($callingpage['formcode']) . ' AND FIELDNAME = ' . singleQuote($callingpage['fieldname']) . ' ORDER BY SEQNUM');
        $list = array();
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $list[$r['ID']] = clx_uppercase($r['FORMCODE'] . '.' . $r['FIELDNAME'] . ': ' . dict($this->fld_prop_type[$r['PROPERTY_TYPE']]));
        }
        return $list;
    }

    /**
     * Performs reorder record action
     */
    function reorderAction() {
        $callingpage = peekHistory();
        $sql = 'UPDATE ' . $this->tablename . ' SET SEQNUM = SEQNUM*10 WHERE FORMCODE = ' . singleQuote($callingpage['formcode']) . ' AND FIELDNAME = ' . singleQuote($callingpage['fieldname']);
        ClxCommon::$db->executeQuery($sql);
        parent::reorderAction();
        $UIFP = &getTool('UIFF');
        $UIFP->versionIncrease('ID', $callingpage['ownerid']);
    }

    /**
     * Return operator
     * @param string $op
     * @return array
     */
    function getOperator($op) {
        return $this->operators[$op][CLX_NUM_ONE];
    }

    /**
     * Performs user validation in forms
     * @param type $formrec
     * @param type $record
     * @param type $msg
     */
    function userCheckForm($formrec, &$record, &$msg) {
        ClxFreeReturn($record);
        /* UIFR.PROPERTY_TYPE, */
        $sql = 'SELECT UIFR.FORMCODE, UIFR.FIELDNAME, UIFR.FIELDNAME1, UIFR.OPERATOR, UIFR.FIELDNAME2, UIFR.VALUE, DBFL.FIELDTYPE, UIFF.TABLECODE FIELD_TABLECODE FROM CLX_DB_FIELDS DBFL, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_FLD_PROP UIFR WHERE UIFP.IDCODE = UIFF.PANELID AND DBFL.FIELDNAME = UIFR.FIELDNAME AND UIFR.FORMCODE = UIFP.FORMCODE AND UIFR.FIELDNAME = UIFF.FIELDNAME AND UIFR.FORMCODE = ' . singleQuote($formrec['IDCODE']) . ' AND UIFR.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND UIFF.ACTIVE = 1 AND UIFR.PROPERTY_TYPE = ' . singleQuote('REQ') . ' ORDER BY UIFP.SEQNUM ASC, UIFR.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Form fieldname
            if (!empty($r['FIELD_TABLECODE'])) {
                $fieldname = $r['FIELD_TABLECODE'] . '_' . $r['FIELDNAME'];
            } else {
                $fieldname = $formrec['TABLECODE'] . '_' . $r['FIELDNAME'];
            }
            //Verificar condicion general sin criterios
            if (empty($r['FIELDNAME1'])) {
                if (strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO)
                    $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
            }else {
                //Verificar por codigo de tabla diferente a codigo y por campos derivados
                $checkfieldname = $formrec['TABLECODE'] . '_' . $r['FIELDNAME1'];
                if (!array_key_exists($fieldname, UserRequest::$post))
                    UserRequest::$post[$fieldname] = '';
                //Verificar condicion especifica en caso de contener criterios
                switch ($r['OPERATOR']) {
                    case 'EQ': //equal
                        if (UserRequest::$post[$checkfieldname] == $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'NQ': //Not equal
                        if (UserRequest::$post[$checkfieldname] != $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'LS': //Less than
                        if (UserRequest::$post[$checkfieldname] < $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'GT': //greater than
                        if (UserRequest::$post[$checkfieldname] > $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'LQ': //less and equal
                        if (UserRequest::$post[$checkfieldname] <= $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'GQ': //greater and equal
                        if (UserRequest::$post[$checkfieldname] >= $r['VALUE'] && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'IN': //In
                        $vals = toArray($r['VALUE']);
                        if (in_array(UserRequest::$post[$checkfieldname], $vals) && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    case 'NI': //Not in
                        $vals = toArray($r['VALUE']);
                        if (!in_array(UserRequest::$post[$checkfieldname], $vals) && strlen(UserRequest::$post[$fieldname]) == CLX_NUM_ZERO) {
                            $msg[$fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
                        }
                        break;
                    default:
                        //nothing to do
                        break;
                }
            }
        }
    }

    /**
     * Returns script required in form for adicional validations
     *
     * @param type $formid
     * @return string
     */
    function getJavaScriptEventsForm($formcode) {
        $scripts_src = '';
        $sql = 'SELECT UIFR.PROPERTY_TYPE, UIFR.FORMCODE, UIFR.FIELDNAME, UIFR.FIELDNAME1, UIFR.OPERATOR, UIFR.FIELDNAME2, UIFR.VALUE, DBFL.FIELDTYPE, UIFM.TABLECODE, UIFF.TABLECODE FIELD_TABLECODE, DBFL.FIELD_EXTRA3 FROM CLX_DB_FIELDS DBFL, CLX_UI_FORMS UIFM, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_FLD_PROP UIFR WHERE UIFP.IDCODE = UIFF.PANELID AND UIFM.IDCODE = UIFR.FORMCODE AND DBFL.FIELDNAME = UIFR.FIELDNAME AND UIFR.FORMCODE = UIFP.FORMCODE AND UIFR.FIELDNAME = UIFF.FIELDNAME AND UIFR.FORMCODE = ' . singleQuote($formcode) . '  AND UIFR.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND UIFF.ACTIVE = 1 ORDER BY UIFP.SEQNUM ASC, UIFR.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $form_fieldname = $r['TABLECODE'] . '_' . $r['FIELDNAME'];
            $checkfieldname = $r['TABLECODE'] . '_' . $r['FIELDNAME1'];
            //adding js to validate
            if (empty($r['FIELDNAME1'])) {
                //Set required no matter what
                switch ($r['PROPERTY_TYPE']) {
                    case 'REQ':
                        $scripts_src .= '$(' . singleQuote('#LBL_' . $form_fieldname) . ').attr("class", "promptrequired")';
                        break;
                    case 'RON':
                        if ($r['FIELDTYPE'] === 'LIST') {
                            $scripts_src .= '$(' . singleQuote('#' . $form_fieldname) . ').attr("class", ' . singleQuote('readonly') . ');setFieldReadLoad();';
                        } else {
                            $scripts_src .= '$(' . singleQuote('#' . $form_fieldname) . ').attr("class", ' . singleQuote('readonly') . ' )';
                        }
                        break;
                    case 'HID':
                        $scripts_src .= ' $(' . singleQuote('#FLD_' . $form_fieldname) . ').hide();$(' . singleQuote('#LBL_' . $form_fieldname) . ').hide()';
                        break;
                    default:
                        $scripts_src .= '{}';
                        break;
                }
            } else {
                //Test condition to validate
                $scripts_src .= ' $("#' . $checkfieldname . '").change(function(){if(';
                //Verificar condicion especifica en caso de contener criterios
                switch ($r['OPERATOR']) {
                    case 'EQ': //equal
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()=="' . $r['VALUE'] . '"';
                        break;
                    case 'NQ': //Not equal
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()!="' . $r['VALUE'] . '"';
                        break;
                    case 'LS': //Less than
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()<"' . $r['VALUE'] . '"';
                        break;
                    case 'GT': //greater than
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()>"' . $r['VALUE'] . '"';
                        break;
                    case 'LQ': //less and equal
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()<="' . $r['VALUE'] . '"';
                        break;
                    case 'GQ': //greater and equal
                        $scripts_src .= ' $("#' . $checkfieldname . '").val()>="' . $r['VALUE'] . '"';
                        break;
                    case 'IN': //In
                        $vals = toArray($r['VALUE']);
                        $comma = '';
                        foreach ($vals as $v) {
                            $scripts_src .= $comma . ' $("#' . $checkfieldname . '").val()=="' . $v . '"';
                            $comma = ' || ';
                        }
                        break;
                    case 'NI': //Not in
                        $vals = toArray($r['VALUE']);
                        $comma = '';
                        foreach ($vals as $v) {
                            $scripts_src .= $comma . ' $("#' . $checkfieldname . '").val()!="' . $v . '"';
                            $comma = ' && ';
                        }
                        break;
                    default:
                        //nothing to do
                        break;
                }
                $scripts_src .= ')';
                switch ($r['PROPERTY_TYPE']) {
                    case 'REQ':
                        $scripts_src .= '{$("#LBL_' . $form_fieldname . '").attr("class", "promptrequired")}else{$("#LBL_' . $form_fieldname . '").attr("class", "prompt")}';
                        break;
                    case 'RON':
                        if ($r['FIELDTYPE'] === 'LIST' || $r['FIELDTYPE'] === 'BOOL') {
                            if ($r['FIELDTYPE'] === 'LIST')
                                $r['FIELD_EXTRA3'] = CLX_INIT_ZERO;
                            //clxlock
                            if ($r['FIELDTYPE'] === 'BOOL' && $r['FIELD_EXTRA3'] === '1') {//checkbox
                                //Si es check hacer el readonly creando un dummy field disabled y colocar un hidden para soportar el valor.
                                $scripts_src .= '{
                                    $("#' . $form_fieldname . '").attr("class", "readonly");
                                    if($("#' . $form_fieldname . '").prop("checked")){
                                        $("#' . $form_fieldname . '").prop("type", "hidden" );
                                            $("#' . $form_fieldname . '").val(1);
                                        $("#FLD_' . $form_fieldname . '").append("<input id = \\"TMP_' . $form_fieldname . '\\" type = \\"checkbox\\"  checked disabled>");
                                    }else{
                                        $("#' . $form_fieldname . '").prop("type", "hidden" );
                                        $("#' . $form_fieldname . '").val(0);
                                        $("#FLD_' . $form_fieldname . '").append("<input id = \\"TMP_' . $form_fieldname . '\\" type = \\"checkbox\\" disabled>");
                                    }
                                }else{
                                    $("#' . $form_fieldname . '").attr("class", "prompt");
                                    $("#' . $form_fieldname . '").val(1);
                                    $("#' . $form_fieldname . '").prop("type", "checkbox" );
                                    $("#TMP_' . $form_fieldname . '").remove();
                                }';
                            } elseif ($r['FIELDTYPE'] === 'BOOL' && $r['FIELD_EXTRA3'] === '2') {//radio
                                $scripts_src .= '{
                                    $("#' . $form_fieldname . '").attr("class", "readonly" );
                                    var checkedValue = $("input[name=' . singleQuote($form_fieldname) . ']").filter(' . singleQuote(':checke') . ').val();
                                    $("input[name=' . singleQuote($form_fieldname) . ']").prop("disabled", true);
                                    $("input[name=' . singleQuote($form_fieldname) . ']").prop(CLX_PROP_ID, "SAVE_' . singleQuote($form_fieldname) . ');
                                    $("input[name=' . singleQuote($form_fieldname) . ']").prop("name", "SAVE_' . singleQuote($form_fieldname) . ');
                                    $("#FLD_' . $form_fieldname . '").append("<input id = \\"' . $form_fieldname . '\\" name = \\"' . $form_fieldname . '\\" type = \\"hidden\\" value = \\""+checkedValue+"\\">");
                                }else{
                                    $("#' . $form_fieldname . '").attr("class", "prompt");
                                    if($("#SAVE_' . $form_fieldname . '").length){
                                       $("#' . $form_fieldname . '").remove();
                                    }
                                    $("input[name=' . singleQuote('SAVE_' . $form_fieldname) . ']").prop(CLX_PROP_ID, "' . $form_fieldname . '" );
                                    $("input[name=' . singleQuote('SAVE_' . $form_fieldname) . ']").prop("name", "' . singleQuote($form_fieldname) . ');
                                    $("input[name=' . singleQuote($form_fieldname) . ']").prop("disabled", false);
                                }';
                            } else {
                                $scripts_src .= '{$("#' . $form_fieldname . '").attr("class", "readonly" );setFieldReadLoad()}else{$("#' . $form_fieldname . '").attr("class", "prompt")}';
                            }
                        } else {
                            $scripts_src .= '{$("#' . $form_fieldname . '").attr("class", "readonly" )}else{$("#' . $form_fieldname . '").attr("class", "prompt")}';
                        }
                        break;
                    case 'HID':
                        $scripts_src .= '{$("#FLD_' . $form_fieldname . '").hide();$("#LBL_' . $form_fieldname . '").hide()}else{$("#FLD_' . $form_fieldname . '").show();$("#LBL_' . $form_fieldname . '").show()}';
                        break;
                    default:
                        $scripts_src .= '{}';
                        break;
                }
                $scripts_src .= '});$("#' . $checkfieldname . '").trigger("change");';
            }
        }
        if ($scripts_src <> '') {
            $scripts_src = 'function formCheckRequired(){' . $scripts_src . '}';
            $scripts_src .= ' $(document).ready(formCheckRequired);';
            $scripts_src = setJavaScriptTag($scripts_src, false);
        }
        return $scripts_src;
    }

}
