<?php

/**
 * Menu item manager
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract	Interfase Mask Manager
 * @package		Clientix.Tool.Interface
 * @author      $Author: fsantana $
 * @copyright   Alenet, Inc.
 * @since       $Date:  10:41:59 -0430 (Thu, 23 Jun 2011) $
 * @version    	$Rev: 2531 $
 *
 * CHANGE LOGS
 *  Tool Created
 */
    
class ui_masks extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'UIMA';
        $this->name = 'Masks Manager';
        $this->system = 'Interface';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_UI_MASKS';
        $this->record_name_singular = 'GEN_LBL_MASK';
        $this->record_name_plural = 'GEN_LBL_MASKS';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';
        $this->primary_key = array('IDCODE');
        $this->quickfilterform = array(CLX_CLASS_TITLE => 'TOOL_UIMA_TITLE_CREATE', 'panels' => array(array('type' => 'normal', 'entries' => array(array('label' => 'GEN_LBL_CODE', 'fields' => array(array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1'))), array('label' => 'GEN_LBL_NAME', 'fields' => array(array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'))), array('label' => 'GEN_LBL_MODULECODE', 'fields' => array(array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO'))), array('label' => 'GEN_LBL_FIELDNAME', 'fields' => array(array('name' => 'fieldcode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL'))), array('label' => 'GEN_LBL_TABLECODE', 'fields' => array(array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB'))), array('label' => 'GEN_LBL_FORMCODE', 'fields' => array(array('name' => 'formdcode', 'type' => 'lookup', 'default' => '', 'tool' => 'UIFM')))))));
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_UIMA_TITLE_CREATE', 'panels' => array(array('type' => 'normal', 'entries' => array(array('label' => 'GEN_LBL_CODE', 'fields' => array(array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'validations' => array(array('type' => 'string', 'required' => '1'))))), array('label' => 'GEN_LBL_NAME', 'fields' => array(array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(array('type' => 'string', 'required' => '1'))))), array('label' => 'GEN_LBL_MODULECODE', 'fields' => array(array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES'))))))), array('type' => 'normal', CLX_CLASS_TITLE => 'GEN_LBL_APPLIES', 'entries' => array(array('label' => 'GEN_LBL_FIELDNAME', 'fields' => array(array('name' => 'fieldname', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS', 'required' => '1'))))), array('label' => 'GEN_LBL_TABLECODE', 'fields' => array(array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'validations' => array(array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES', 'required' => '0'))))), array('label' => 'GEN_LBL_FORMCODE', 'fields' => array(array('name' => 'formcode', 'type' => 'lookup', 'default' => '', 'tool' => 'UIFM', 'validations' => array(array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_FORMS', 'required' => '0'))))))), array('type' => 'normal', CLX_CLASS_TITLE => 'GEN_LBL_DEF_MASKFORMAT', 'caption' => 'GEN_LBL_MASK_HELP', 'entries' => array(array('label' => 'GEN_LBL_DEF_MASKFORMAT', 'fields' => array(array('name' => 'maskformat', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(array('type' => 'string', 'required' => '0'))))))), array('type' => 'normal', CLX_CLASS_TITLE => 'GEN_LBL_RECORD_OPTIONS', 'cols' => CLX_NUM_FOUR, 'entries' => array(array('label' => 'GEN_LBL_CDATE', 'fields' => array(array('name' => 'cdate', 'type' => 'dati', 'dontmodify' => '1', 'displaysize' => '35', 'readonly' => true, 'validations' => array(array('type' => 'string'))))), array('label' => 'GEN_LBL_CREATEDBY', 'fields' => array(array('name' => 'createdby', 'type' => 'lookup', 'default' => '', 'readonly' => true, 'tool' => 'ACUS', 'validations' => array(array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS'))))), array('label' => 'GEN_LBL_MDATE', 'fields' => array(array('name' => 'mdate', 'type' => 'dati', 'displaysize' => '35', 'dontmodify' => '1', 'readonly' => true, 'validations' => array(array('type' => 'string'))))), array('label' => 'GEN_LBL_MODIFIEDBY', 'fields' => array(array('name' => 'modifiedby', 'type' => 'lookup', 'default' => '', 'readonly' => true, 'tool' => 'ACUS', 'validations' => array(array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')))))))));
        $this->viewform = $this->editform;
        $this->toollist = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_filter' => true, 'fields' => array(array('name' => 'ID', 'type' => 'number', 'label' => 'GEN_LBL_ID'), array('name' => 'IDCODE', 'type' => 'string', 'label' => 'GEN_LBL_IDCODE'), array('name' => 'IDNAME', 'type' => 'string', 'label' => 'GEN_LBL_IDNAME'), array('name' => 'MODULECODE', 'type' => 'string', 'label' => 'GEN_LBL_MODULECODE'), array('name' => 'FIELDNAME', 'type' => 'string', 'label' => 'GEN_LBL_FIELDNAME'), array('name' => 'TABLECODE', 'type' => 'string', 'label' => 'GEN_LBL_TABLECODE'), array('name' => 'FORMCODE', 'type' => 'string', 'label' => 'GEN_LBL_FORMCODE'), array('name' => 'MASKFORMAT', 'type' => 'string', 'label' => 'GEN_LBL_DEF_MASKFORMAT'), array('name' => 'CDATE', 'type' => 'string', 'label' => 'GEN_LBL_CDATE'), array('name' => 'CREATEDBY', 'type' => 'string', 'label' => 'GEN_LBL_CREATEDBY'), array('name' => 'MDATE', 'type' => 'string', 'label' => 'GEN_LBL_MDATE'), array('name' => 'MODIFIEDBY', 'type' => 'string', 'label' => 'GEN_LBL_MODIFIEDBY')), 'buttons' => array(array('access' => 'canread', 'tool' => 'has_display', 'library' => 'GEN_LBL_SEE_CODE', 'name' => 'CODE', 'prop' => 'ONE', 'window' => 'POP')));
    }

    /**
     * Install procedure
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_INTERFACE:MENU_MASK', 'TOOL', $this->code, 'ac=LIST');
    }

    /**
     * Describes the tool table structure.
     *
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     *         'index'=>'', default = '', 'dict'=>true)
     *         dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields ['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields ['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields ['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields ['FIELDNAME'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields ['TABLECODE'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields ['FORMCODE'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields ['MASKFORMAT'] = array('type' => 'varchar(64)', 'null' => 'YES');
        $fields ['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields ['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields ['CREATEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields ['MODIFIEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes [$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes [$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME,TABLECODE,FORMCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    /**
     * Pack tool record on xml Format
     *
     * @param
     *        	array record
     * @return obj
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'UIMC', 'SELECT * FROM CLX_UI_MASKS_CRIT WHERE MASKCODE =' . singleQuote($record ['IDCODE']));
        $o->addObject($objs);
        return $o;
    }

    /**
     * Loads package into system
     *
     * @param string $package
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => CLX_NUM_ZERO), $parameters));
        list($package, $parent) = $parameters;
        $record = $this->unpackRecord($package);
        unset($record ['ID']);
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($record ['IDCODE'])) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord($this->tablename, $record, 'IDCODE=' . singleQuote($record ['IDCODE']));
        } else {
            ClxCommon::$db->createRecord($this->tablename, $record, false);
        }
        ClxCommon::$db->deleteRecords('CLX_UI_MASKS_CRIT', 'MASKCODE=' . singleQuote($record['IDCODE']));
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $record['PARENT']));
            }
        }
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
	if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'CREATE_MASKS' :
                    $contents = $this->createFormMasks($idlist);
                    break;
                case 'CODE' :
                    $contents = $this->code($idlist);
                    break;
                default :
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_MASKS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Verify Tool Edit Forms
     *
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $result = parent::checkForm($msg);
        if (!empty(UserRequest::$post ['UIMA_tablecode']) || !empty(UserRequest::$post ['UIMA_formcode'])) {
            // form code but no table code
            if (empty(UserRequest::$post ['UIMA_tablecode']) && !empty(UserRequest::$post ['UIMA_formcode'])) {
                $msg ['UIMA_tablecode'] = dict('GEN_LBL_EMPTY_TABLE_MSG');
            }
            // Checks if the field is on the selected table
            if (!empty(UserRequest::$post ['UIMA_tablecode'])) {
                $DBTF = getTool('DBTF');
                //$sql = 'SELECT ID  FROM ' . $DBTF->tablename . '  WHERE TABLECODE = ' . singleQuote(UserRequest::$post ['UIMA_tablecode']) . '  AND FIELDNAME=' . singleQuote(UserRequest::$post ['UIMA_fieldname']) . ';';
                $sql = 'SELECT ID  FROM ' . $DBTF->tablename . '  WHERE TABLECODE = ' . singleQuote(UserRequest::$post ['UIMA_tablecode']) . '  AND FIELDNAME=' . singleQuote(UserRequest::$post ['UIMA_fieldname']);
                $result = ClxCommon::$db->executeQuery($sql);
                if (!($result = ClxCommon::$db->getNextRecord($result))) {
                    $msg ['UIMA_tablecode'] = dict('GEN_LBL_WRONG_TABLE_MSG');
                }
            }
            // Checks if the form correspond to the selected table
            if (!empty(UserRequest::$post ['UIMA_tablecode']) && !empty(UserRequest::$post ['UIMA_formcode'])) {
                $UIFM = getTool('UIFM');
                //$sql = 'SELECT ID  FROM ' . $UIFM->tablename . '  WHERE TABLECODE = ' . singleQuote(UserRequest::$post ['UIMA_tablecode']) . '  AND IDCODE=' . singleQuote(UserRequest::$post ['UIMA_formcode']). ';';
                $sql = 'SELECT ID  FROM ' . $UIFM->tablename . '  WHERE TABLECODE = ' . singleQuote(UserRequest::$post ['UIMA_tablecode']) . '  AND IDCODE=' . singleQuote(UserRequest::$post ['UIMA_formcode']);
                $result = ClxCommon::$db->executeQuery($sql);
                if (($result = ClxCommon::$db->getNextRecord($result)) == false) {
                    $msg ['UIMA_formcode'] = dict('GEN_LBL_WRONG_FORM_MSG');
                }
            }
        }
        return $result && (count($msg) == CLX_NUM_ZERO);
    }

    /**
     * Build display form contents
     *
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('maskcode', $record ['UIMA_idcode']);
        // Elements
        $UIMA = &getTool('UIMC');
        $contents = $UIMA->makepanel($record ['UIMA_idcode']);
        return $contents;
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $id);
        // Schedules Logs
        $UIMC = getTool('UIMC');
        $rs = ClxCommon::$db->getRecords($UIMC->tablename, 'MASKCODE=' . singleQuote($idcode));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $UIMC->deleteRecordSk($r ['ID']);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    /**
     * Defines default record on initializacion
     *
     * @return array
     */
    function defaultRecord() {
        $record = parent::defaultRecord();
        $record ['UIMA_idname'] = '';
        $record ['UIMA_ownercode'] = $_SESSION ['user_record'] ['username'];
        return $record;
    }

    /**
     * Builds required code to implement the form mask
     *
     * @param array $record
     * @return string
     */
    function createMask($record) {
        $UIMC = &getTool('UIMC');
        $code = '';
        // Save the needed values in variables
        $idcode = $record ['IDCODE'];
        $fieldname = $record ['FIELDNAME'];
        if (!empty($record ['TABLECODE'])) {
            $tablecode = $record ['TABLECODE'] . '_';
        } else {
            $tablecode = '';
        }
        $maskformat = $record ['MASKFORMAT'];
        // Get the criteria
        $sql = 'SELECT * FROM ' . $UIMC->tablename . ' WHERE MASKCODE = ' . singleQuote($idcode) . ' ORDER BY ID DESC';
        $result = ClxCommon::$db->executeQuery($sql);
        $criterias = array();
        while (($record = ClxCommon::$db->getNextRecord($result))) {
            $op = $UIMC->getOperator($record ['OPERATOR']);
            if (empty($record ['FIELDNAME2'])) {
                $value = $record ['VALUE'];
                if (!is_numeric($value)) {
                    $value = singleQuote($value);
                }
            } else {
                $value = '$("#' . $tablecode . $record ['FIELDNAME2'] . '").val()';
            }
            $cond = ' $("#' . $tablecode . $record ['FIELDNAME1'] . '").val() ' . $op . ' ' . $value . ' ';
            if (empty($criterias [$record ['IDNAME']])) {
                $criterias [$record ['IDNAME']] ['MASKFORMAT'] = $record ['MASKFORMAT'];
                $criterias [$record ['IDNAME']] ['CONDITION'] = $cond;
            } else {
                $criterias [$record ['IDNAME']] ['CONDITION'] .= '&&' . $cond;
            }
        }
	
        foreach ($criterias as $crit) {
            $code .= CLX_CHAR_NL . CLX_CHAR_TAB . 'if(' . $crit ['CONDITION'] . ' && $("#' . $tablecode . $fieldname . '").attr("CLX_PROP_CLASS")!="readonly"){' . CLX_CHAR_NL . "\t\t" . '$("#' . $tablecode . $fieldname . '").mask(' . singleQuote($crit ['MASKFORMAT']) . ');' . CLX_CHAR_NL . "\t\t" . 'mask = true;' . CLX_CHAR_NL . CLX_CHAR_TAB . '}' . CLX_CHAR_NL;
        }
	
        if (!empty($maskformat)) {
            $code .= CLX_CHAR_NL . CLX_CHAR_TAB . 'if(!mask && $("#' . $tablecode . $fieldname . '").attr("CLX_PROP_CLASS")!="readonly"){' . CLX_CHAR_NL . "\t\t" . '$("#' . $tablecode . $fieldname . '").mask("' . $maskformat . '");' . CLX_CHAR_NL . CLX_CHAR_TAB . '}' . CLX_CHAR_NL;
        } else {
            $code .= CLX_CHAR_NL . CLX_CHAR_TAB . 'if(!mask && $("#' . $tablecode . $fieldname . '").attr("CLX_PROP_CLASS")!="readonly"){' . CLX_CHAR_NL . "\t\t" . '$("#' . $tablecode . $fieldname . '").unmask();' . CLX_CHAR_NL . "\t}" . CLX_CHAR_NL;
        }
	
        return $code;
    }

    /**
     * Prepares de code to be displayed
     *
     * @param array $idlist
     * @return string
     */
    function code($idlist) {
        $contents = '';
        if (!empty($idlist[CLX_NUM_ZERO])) {
            // Get the mask
            //$sql = 'SELECT * FROM ' . $this->tablename . ' WHERE ID = ' . $idlist[CLX_NUM_ZERO] . ';';
            $sql = 'SELECT * FROM ' . $this->tablename . ' WHERE ID = ' . $idlist[CLX_NUM_ZERO];
            $result = ClxCommon::$db->executeQuery($sql);
            $record = ClxCommon::$db->getNextRecord($result);
            $code = 'var maskFunc = function(){' . CLX_CHAR_NL;
            //$code .= 'var mask = false;' . CLX_CHAR_NL;
            $code .= CLX_CHAR_TAB.'var mask = false; ';
            $nbsp = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
            $code .= $this->createMask($record);
            $code .= CLX_CHAR_NL . '};' . CLX_CHAR_NL;
            $code .= 'maskFunc();' . CLX_CHAR_NL;
            $code .= '$(document).change(maskFunc);' . CLX_CHAR_NL;
            $contents = str_replace(array(CLX_CHAR_NL, CLX_CHAR_TAB), array('<br>', $nbsp), $code);
        }
        return $contents;
    }

    /**
     * Builds Js For form
     * Build javascript
     *
     * @param string $formcode
     * @return string
     */
    function getFormMasks($formcode) {
        // Get the tablecode of the form
        /*
         * ?? why this just get the form table code instead $sql = 'SELECT
         * DISTINCT UIFM.TABLECODE FROM CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS
         * UIFP, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_MASKS UIMA WHERE
         * UIFM.IDCODE = UIFP.FORMCODE AND UIFF.PANELID = UIFP.IDCODE AND
         * UIFF.FIELDNAME = UIMA.FIELDNAME AND UIFF.PF_TYPE = 'FIELD' AND
         * UIFF.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND UIFM.IDCODE = '. singleQuote($formcode' ';
         * $rs = ClxCommon::$db->executeQuery($sql); if(($r = ClxCommon::$db->getNextRecord($pages)))==
         * true){ $tablecode = $r['TABLECODE']; }else{ $tablecode =''; }
         */
        $tablecode = ClxCommon::$db->getField('CLX_UI_FORMS', 'TABLECODE', 'IDCODE = ' . singleQuote($formcode));
        $code = 'var maskFunc = function(){' . CLX_CHAR_NL;
        $code .= 'var mask = false;' . CLX_CHAR_NL;
        // First we get all the masks related to the formcode
        $sql = 'SELECT DISTINCT UIMA.* FROM  CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_MASKS UIMA WHERE  UIFM.IDCODE = UIFP.FORMCODE AND UIFF.PANELID = UIFP.IDCODE AND UIFF.FIELDNAME = UIMA.FIELDNAME AND (UIFM.IDCODE = UIMA.FORMCODE OR UIMA.FORMCODE IS NULL) AND (UIMA.TABLECODE = COALESCE(UIFF.TABLECODE,UIFM.TABLECODE)  OR UIMA.TABLECODE IS NULL) AND UIFF.PF_TYPE = ' . singleQuote('FIELD') . ' AND UIFF.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND UIFM.IDCODE = ' . singleQuote($formcode);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $code .= $this->createMask($r)."/*ee*/";
        }
        // Then we get all the masks related to the tablecode that aren't
        // related to an specific formcode
        if ($tablecode !== '') {
            $sql = 'SELECT * FROM ' . $this->tablename . ' WHERE TABLECODE = ' . singleQuote($tablecode) . ' AND FORMCODE = ' . "''";
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $code .= $this->createMask($r)."/*xx*/";
            }
            // Finally we get all the masks related to the fields on the table
            // that don't have an specific tablecode.
            // First we need to know what fields are in the table
            $sql = 'SELECT DISTINCT UIMA.* FROM  CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_MASKS UIMA WHERE  UIFM.IDCODE = UIFP.FORMCODE AND UIFF.PANELID = UIFP.IDCODE AND UIFF.FIELDNAME = UIMA.FIELDNAME AND UIMA.TABLECODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '  AND UIMA.FORMCODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '  AND UIFF.PF_TYPE = ' . singleQuote('FIELD') . ' AND UIFF.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND UIFM.IDCODE = ' . singleQuote($formcode);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $r ['TABLECODE'] = $tablecode;
                $code .= $this->createMask($r)."/*yyu*/";
            }
        }
        $code .= CLX_CHAR_NL . '};' . CLX_CHAR_NL;
        $code .= 'maskFunc();' . CLX_CHAR_NL;
        $code .= '$(document).change(maskFunc);' . CLX_CHAR_NL;
	return setJavaScriptTag(/*str_replace(array(CLX_CHAR_NL, CLX_CHAR_TAB), array('', ''),*/ $code)/*)*/;
    }

}

// end class
