<?php

/**
 * Menu item manager
 * For more information contact  support@alenet.com
 *
 * @author      $Author: cramirez $
 * @copyright   Alenet, Inc.
 * @since       $Date: 2018-10-15 20:57:54 -0400 (Mon, 15 Oct 2018) $
 * @version    	$Rev: 10266 $
 *
 * CHANGE LOGS
 *  Actualizacion clx56
 */
class ui_menuitems extends clx_tool {

    var $window_strings;

    function __construct() {
        $this->code = 'UIMI';
        $this->name = 'Menu Items Manager';
        $this->system = 'Interface';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_UI_MENUITEMS';
        $this->record_name_singular = 'menu item';
        $this->record_name_plural = 'menu items';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'NAME';
        $this->seqnum_field = 'SEQNUM';
        $this->primary_key = array('IDCODE');
		$GLOBALS['parent_menu']=array();
    }

    function install() {
        $this->add($this->code, 'MENU_TOOLS:MENU_INTERFACE:MENU_MENU_ITEMS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '', 'dict' => false);
        $fields['NAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '', 'dict' => true);
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['TOOLCODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['PARENT'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '', 'default' => '0');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ACTIVE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $fields['EXTRA1'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['EXTRA2'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['EXTRA3'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['EXTRA4'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['EXTRA5'] = array('type' => 'varchar(255)', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'NAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'TOOLCODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '07'] = array('index' => 'MUL', 'fieldname' => 'PARENT');
        $indexes[$ipf . '08'] = array('index' => 'MUL', 'fieldname' => 'ACTIVE');
        $indexes[$ipf . '09'] = array('index' => 'MUL', 'fieldname' => 'TYPE');
        return array('idcode' => $this->code,
            'idname' => $this->name,
            'name' => $this->tablename,
            'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $id = $record['IDCODE'];
        $modulecode = $record['MODULECODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'PARENT=' . singleQuote($record['IDCODE']) . ' AND MODULECODE=' . singleQuote($modulecode)) > CLX_NUM_ZERO) {
            $this->packsub($objs, $this->code, 'SELECT * FROM CLX_UI_MENUITEMS WHERE PARENT=' . singleQuote($record['IDCODE']) . '                 AND MODULECODE=' . singleQuote($modulecode));
            //Packing Dictionary
            if (ClxCommon::$db->oneExistsRecords('CLX_DICTIONARY DICT, CLX_UI_MENUITEMS X', 'DICT.ENTRY=X.NAME AND X.PARENT=' . singleQuote($record['IDCODE']) . ' AND X.MODULECODE=' . singleQuote($modulecode)) > CLX_NUM_ZERO) {
                $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_UI_MENUITEMS X WHERE DICT.ENTRY=X.NAME AND X.PARENT=' . singleQuote($record['IDCODE']) . ' AND X.MODULECODE=' . singleQuote($modulecode));
            }
        }
        //Packing Dictionary
        $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_UI_MENUITEMS X WHERE DICT.ENTRY=X.NAME AND X.IDCODE=' . singleQuote($id) . ' AND UPPER(X.MODULECODE)=' . singleQuote(uppercase($modulecode)));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => CLX_NUM_ZERO), $parameters));
        list($package, $parent) = $parameters;
        $record = $this->unpackRecord($package);
        unset($record['ID']);
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord($this->tablename, $record, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        } else {
            ClxCommon::$db->createRecord($this->tablename, $record, false);
        }
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $record['PARENT']));
            }
        }
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'GET_JSON':
                    if (empty(UserRequest::$get['idlist'])) {
                        $parentid = CLX_INIT_ZERO;
                    } else {
                        $parentid = UserRequest::$get['idlist'];
                    }
                    $contents = $this->getJsonMenu($parentid);
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_MENUITEMS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Defines package name
     * @param obj $o
     * @return string
     */
    function packname($o) {
        $t = '';
        $t .= ucfirst($this->record_name_singular) . ': ';
        $t .= $o->getSubObjectContents(uppercase($this->primary_field)) . ' ';
        $t .= dict($o->getSubObjectContents(uppercase($this->secondary_field)), false) . ' ';
        return $t;
    }

    function makelist($listingcode = null) {
        ClxFreeReturn($listingcode);
        //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'UIMIList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $form->addArgument('parent', '0');
        $DICT = getTool('DICT');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = 'PARENT IN (' . singleQuote(CLX_CHAR_EMPTY_STRING) . ',' . singleQuote('0') . ')';
        $sortclause = 'SEQNUM';
        $page = new xPaging();
        $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_NUM_8);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UIMI_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_8));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_MENU'), dict('GEN_LBL_ACTIVE'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_ACTION'), dict('GEN_LBL_VERSION')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            if (empty($record['NAME'])&&isset($record['name']))
                $record['NAME']=$record['name'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $menu = getToolObject('UIMI', $record['TYPE']);
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['IDCODE'], $DICT->dictFastEdit($record['NAME']), (($record['ACTIVE'] == CLX_NUM_ONE) ? dict('GEN_LBL_YES') : dict('GEN_LBL_NO')), $record['TYPE'], $record['MODULECODE'], $menu->describe($record), $record['VERSION'] . '-' . $record['VERSION_COUNTER']));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_MENU')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        if ($page->getProp('qty') > CLX_NUM_ONE) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function makepanel($groupcode = null) {//group hear means parent
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $parent = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $groupcode);
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'UIMIList');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('parent', $parent);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'PARENT=' . singleQuote($parent);
            $sortclause = 'SEQNUM';
            $page = new xPaging();
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $table = new htmlTable(CLX_NUM_8);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $DICT = getTool('DICT');
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_MENU'), dict('GEN_LBL_ACTIVE'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_ACTION'), dict('GEN_LBL_VERSION')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                if (empty($record['NAME'])&&isset($record['name']))
                    $record['NAME']=$record['name'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $menu = getToolObject('UIMI', $record['TYPE']);
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['IDCODE'], $DICT->dictFastEdit($record['NAME']), (($record['ACTIVE'] == CLX_NUM_ONE) ? dict('GEN_LBL_YES') : dict('GEN_LBL_NO')), $record['TYPE'], $record['MODULECODE'], $menu->describe($record), $record['VERSION'] . '-' . $record['VERSION_COUNTER']));
                $i++;
            }
            $buttons = '';
            $selectButtons = '';
            $selectButtons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            $selectGroup = new htmlSpan('SELECTorbuttons', '', $selectButtons);
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_MENU')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
            }
            if ($page->getProp('qty') > CLX_NUM_ONE) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID)))->source();
            }
            $form->addContents($page->footers($table, $selectGroup->source() . $buttons));
            return buildPanelInterface(dict('TOOL_UIMI_TITLE_LIST'), 'p' . $parent . '_MENUITEMS', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return '';
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $DICT = &getTool('DICT');
        // Build/get the different java scripts...
        $OBJS = &getTool('OBJS');
        $codes = $OBJS->objectList('UIMI');
        $list = 'var panellist = new Array();' . CLX_CHAR_NL . CLX_CHAR_NL;
        $i = CLX_INIT_ZERO;
        foreach ($codes as $code) {
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, $i, $code);
            $i++;
        }

        $script = setJavaScriptTag($list, false);
        $variables = array();
        $variables['VISIBLEPANEL'] = 'UIMI_type';
        $topscript = setJavaScriptTag(getJavaScript('dynform_top.js', $variables));
        $btmscript = setJavaScriptTag(getJavaScriptFilename('dynform_btm.js'), true);
        //Build the form
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        $title = ($modify) ? dict('TOOL_UIMI_TITLE_MODIFY') : dict('TOOL_UIMI_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('UIMI_id', $record['UIMI_id']);
        $form->addArgument('idlist', toString($idlist));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_ID') . ':', $record['UIMI_id']);
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'UIMI_idcode', $record['UIMI_idcode'], CLX_NUM_16, CLX_NUM_16);
        $DICT->editEntry($msg, dict('GEN_LBL_NAME') . ':', 'UIMI_name', $record, $table, $form);
        $table->addYesNo(dict('GEN_LBL_ACTIVE') . ':', 'UIMI_active', $record['UIMI_active'], CLX_NUM_12);
        $table->addField($msg, dict('GEN_LBL_VERSION') . ':', 'UIMI_version', $record['UIMI_version'], CLX_NUM_16, CLX_NUM_16);
        $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'UIMI_description', $record['UIMI_description'], CLX_NUM_FOUR, CLX_NUM_64);
        $callingpage = peekHistory();
        if (($callingpage[CLX_PROP_TO] === 'UIMI') && ($callingpage['ac'] === 'DISPLAY')) {
            $form->addArgument('UIMI_parent', $callingpage['parent']);
        } else {
            $form->addArgument('UIMI_parent', '0');
        }
        $table->addField($msg, dict('GEN_LBL_PARENT') . ':', 'UIMI_parent', $record['UIMI_parent'], CLX_NUM_11, CLX_NUM_11);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'UIMI_modulecode', $record['UIMI_modulecode'], $table);
        $fields = $OBJS->objectPop('UIMI', 'UIMI_type', $record['UIMI_type']);
        $fields->setProp('onchange', 'updateForm();');
        $table->addData(dict('GEN_LBL_TYPE'), $fields->source());
        $form->addContents($table->source() . '<br>');
        foreach ($codes as $code) {
            $object = getToolObject('UIMI', $code);
            $form->addContents($object->panel($msg, $record));
        }
        $form->addContents('<br>');
        // Footers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = '';
        if (!empty($modify)) {
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $script . $topscript . $form->source() . $btmscript;
    }

    function checkForm(&$msg) {
        $msg = array();
        xValidate::required($msg, 'UIMI_modulecode', UserRequest::$post['UIMI_modulecode']);
        xValidate::required($msg, 'UIMI_idcode', UserRequest::$post['UIMI_idcode']);
        xValidate::sqlobject($msg, 'UIMI_idcode', UserRequest::$post['UIMI_idcode']);
        if (UserRequest::$request['ac'] <> 'MODIFY') {
            xValidate::unique($msg, 'UIMI_idcode', 'code', $this->tablename, 'IDCODE=' . singleQuote(UserRequest::$post['UIMI_idcode']));
        }
        $DICT = &getTool('DICT');
        $DICT->validateEntry('UIMI_name', UserRequest::$post, true, $msg);
        $DBMO = &getTool('DBMO');
        if (!$DBMO->moduleExists(UserRequest::$post['UIMI_modulecode'])) {
            $msg['UIMI_modulecode'] = dict('TOOL_UILG_ERR_NOMODULECODE');
        }
        //Validate if parent is type menu in case of not being 0 (root)
        if (!empty(UserRequest::$post['UIMI_parent'])) {
            if (UserRequest::$post['UIMI_parent'] == UserRequest::$post['UIMI_idcode'] || ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$post['UIMI_parent']) . ' AND TYPE = ' . singleQuote('MENU') . '') == CLX_NUM_ZERO) {
                $msg['UIMI_parent'] = dict('TOOL_UILG_ERR_INVALIDPARENT');
            }
        }
        $object = getToolObject('UIMI', UserRequest::$post['UIMI_type']);
        $object->checkPanel($msg);
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addCell(dict('TOOL_UIMI_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_NAME') . ':', dict($record['UIMI_name']));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $record['UIMI_type']);
    }

    function reorderRecords() {
        $records = ClxCommon::$db->getRecords($this->tablename, 'PARENT=' . singleQuote(UserRequest::$post['parent']) . ' ORDER BY SEQNUM');
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            if (empty($record['NAME'])&&isset($record['name']))
                $record['NAME']=$record['name'];
            $list[$record['ID']] = dict($record['NAME']);
        }
        return $list;
    }

    /**
     * Performs reorder record action
     */
    function reorderAction() {
        parent::reorderAction();
        $this->clearHeap();
    }

    function viewFormFill($record) {
        addHistory('parent', $record['UIMI_id']);
        $contents = '';
        // Headers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UIMI_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_ID') . ':', $record['UIMI_id']);
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['UIMI_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', dict($record['UIMI_name']));
        $table->addData(dict('GEN_LBL_ACTIVE') . ':', dict((($record['UIMI_active'] == CLX_NUM_ONE) ? 'GEN_LBL_YES' : 'GEN_LBL_NO')));
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', $record['UIMI_description']);
        $table->addData(dict('GEN_LBL_PARENT') . ':', $record['UIMI_parent']);
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['UIMI_version'] . '-' . $record['UIMI_version_counter']);
        $table->addData(dict('GEN_LBL_MODULECODE') . ':', $record['UIMI_modulecode']);
        $contents .= $table->source();
        // Details
        if ($record['UIMI_type'] === 'MENU') {
            $contents .= $this->makepanel($record['UIMI_id']);
        } else {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $object = getToolObject('UIMI', $record['UIMI_type']);
            $object->viewForm($table, $record);
            $contents .= buildPanelInterface(dict('TOOL_UIMI_TITLE_MENUDETAILS') . ':', 'MENUDETAILS', $table->source(), CLX_NUM_MINUS_1);
        }
        // Footers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['UIMI_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['UIMI_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['UIMI_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function loadToolRecord($recordid) {
        $DICT = &getTool('DICT');
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['UIMI_id'] = $recordid;
        $record['UIMI_idcode'] = $values['IDCODE'];
        $DICT->loadEntry('UIMI_name', $values['NAME'], $record);
        $record['UIMI_active'] = $values['ACTIVE'];
        $record['UIMI_description'] = $values['DESCRIPTION'];
        $record['UIMI_toolcode'] = $values['TOOLCODE'];
        $record['UIMI_modulecode'] = $values['MODULECODE'];
        $record['UIMI_version'] = $values['VERSION'];
        $record['UIMI_version_counter'] = $values['VERSION_COUNTER'];
        $record['UIMI_cdate'] = xFormat::date($values['CDATE']);
        $record['UIMI_mdate'] = xFormat::date($values['MDATE']);
        $record['UIMI_username'] = $values['USERNAME'];
        $record['UIMI_parent'] = $values['PARENT'];
        $record['UIMI_seqnum'] = $values['SEQNUM'];
        $record['UIMI_type'] = $values['TYPE'];
        $object = getToolObject('UIMI', $values['TYPE']);
        $object->setPanel($record, $values);
        return $record;
    }

    function saveRecord() {
        $DICT = &getTool('DICT');
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UIMI_idcode'];
        $record['NAME'] = $DICT->saveEntry('UIMI_name', UserRequest::$post);
        $record['ACTIVE'] = UserRequest::$post['UIMI_active'];
        $record['DESCRIPTION'] = UserRequest::$post['UIMI_description'];
        $record['VERSION'] = UserRequest::$post['UIMI_version'];
        $record['PARENT'] = UserRequest::$post['UIMI_parent'];
        $record['MODULECODE'] = UserRequest::$post['UIMI_modulecode'];
        $record['MDATE'] = $d;
        $record['TYPE'] = UserRequest::$post['UIMI_type'];
        //if code change then update childs
        $lang = clx_language_lower_upper(getCurrentLanguage());;
		apc_deleteFct($findVar=kSpaceName .'_menus_'.$_SESSION ['user_record'] ['username'].'_'.$lang.'_'.$record['PARENT'] );

        if (!empty(UserRequest::$post['UIMI_id'])) {
            $oldidcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . UserRequest::$post['UIMI_id']);
            if ($oldidcode <> UserRequest::$post['UIMI_idcode']) {
                ClxCommon::$db->updateRecord($this->tablename, array('PARENT' => $record['IDCODE']), 'PARENT=' . singleQuote($oldidcode));
            }
        }
        $object = getToolObject('UIMI', UserRequest::$post['UIMI_type']);
        $object->getPanel($record);
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['UIMI_id']);
        $this->versionIncrease('ID', UserRequest::$post['UIMI_id']);
        $this->clearHeap();
		
    }

    function createRecord_() {
        $DICT = &getTool('DICT');
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UIMI_idcode'];
        $record['NAME'] = $DICT->createEntry('UIMI_name', UserRequest::$post);
        $record['ACTIVE'] = UserRequest::$post['UIMI_active'];
        $record['DESCRIPTION'] = UserRequest::$post['UIMI_description'];
        $record['TOOLCODE'] = (!empty(UserRequest::$post['UIMI_toolcode'])) ? UserRequest::$post['UIMI_toolcode'] : null;
        $record['MODULECODE'] = UserRequest::$post['UIMI_modulecode'];
        $record['VERSION'] = UserRequest::$post['UIMI_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['PARENT'] = (empty(UserRequest::$post['UIMI_parent'])) ? '0' : UserRequest::$post['UIMI_parent'];
        $record['SEQNUM'] = CLX_INIT_ZERO; // check
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['TYPE'] = UserRequest::$post['UIMI_type'];
        $lang = clx_language_lower_upper(getCurrentLanguage());;
		apc_deleteFct($findVar=kSpaceName .'_menus_'.$_SESSION ['user_record'] ['username'].'_'.$lang.'_'.$record['PARENT'] );

		$object = getToolObject('UIMI', UserRequest::$post['UIMI_type']);
        $object->getPanel($record);
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->clearHeap();
        return $recordid;
    }

    function deleteRecordSk($id) {
        $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $id);
        $records = ClxCommon::$db->executeQuery('SELECT ID FROM ' . $this->tablename . ' WHERE PARENT=' . singleQuote($idcode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            $this->deleteRecordSk($record['ID']);
        }
        $DICT = &getTool('DICT');
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        $DICT->deleteEntry($record['NAME']);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $this->clearHeap();
    }

    function defaultRecord() {
        $parent = peekHistory();
        $record = array();
        $record['UIMI_id'] = CLX_INIT_ZERO;
        $record['UIMI_idcode'] = '';
        $record['UIMI_name'] = '';
        $record['UIMI_name_DICT'] = '';
        $record['UIMI_active'] = CLX_NUM_ONE;
        $record['UIMI_description'] = '';
        $record['UIMI_toolcode'] = '';
        $record['UIMI_modulecode'] = '';
        $record['UIMI_version'] = '1.0.0';
        $record['UIMI_version_counter'] = '0';
        $record['UIMI_cdate'] = '';
        $record['UIMI_mdate'] = '';
        $record['UIMI_username'] = $_SESSION['user_record']['username'];
        $record['UIMI_seqnum'] = CLX_INIT_ZERO;
        $record['UIMI_parent'] = (empty($parent['parent'])) ? CLX_NUM_ZERO : ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $parent['parent']);
        $record['UIMI_type'] = 'MENU';
        $OBJS = &getTool('OBJS');
        $codes = $OBJS->objectList('UIMI');
        foreach ($codes as $code) {
            $object = $OBJS->getObject_('UIMI', $code);
            $object->defaultPanel($record);
        }
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $record = ClxCommon::$db->getRecord($this->tablename, $fieldname . '=' . singleQuote($fieldvalue));
        $i = $record['VERSION_COUNTER'] + CLX_NUM_ONE;
        $r = array('VERSION_COUNTER' => $i);
        ClxCommon::$db->updateRecord($this->tablename, $r, $fieldname . '=' . singleQuote($fieldvalue));
        if (!empty($record['PARENT'])) {
            $this->versionIncrease('IDCODE', $record['PARENT']);
        }
    }

    function clearHeap() {
		apc_clear_cacheFct();
    }

    function clearUserHeap() {
        if (kApcEnabled) {
            //Clear menu cache
            if (ClxCommon::sessionHasUser()) {
                $userkey = getCurrentLanguage() . (ClxCommon::sessionHasUser() ? clx_mcript($_SESSION[CLX_PROP_ID]) : '');
                apc_deleteFct(kSpaceName . '.uimi.' . $userkey);
            }
        }
    }

    function add($toolcode, $path, $type, $extra1 = '', $extra2 = '', $seqnum = CLX_NUM_ZERO) {
        $d = xFormat::getNow('Y-m-d');
        $path = explode(':', $path);
        $qty = count($path);
        $parent = '0';
        $i = CLX_INIT_ZERO;
        for ($i = CLX_INIT_ZERO; $i < $qty - CLX_NUM_ONE; $i++) {
            if (ClxCommon::$db->oneExistsRecords($this->tablename, 'NAME=' . singleQuote($path[$i])) == CLX_NUM_ZERO) {
                $record = array();
                $record['IDCODE'] = $path[$i];
                $record['ACTIVE'] = CLX_NUM_ONE;
                $record['PARENT'] = $parent;
                $record['NAME'] = $path[$i];
                $record['TYPE'] = 'MENU';
                $record['TOOLCODE'] = $toolcode;
                $record['MODULECODE'] = 'CLX';
                $record['VERSION'] = '1.0.0';
                $record['DESCRIPTION'] = 'MENU ' . $path[$i];
                $record['VERSION_COUNTER'] = CLX_INIT_ZERO;
                $record['SEQNUM'] = CLX_INIT_ZERO;
                $record['CDATE'] = $d;
                $record['MDATE'] = $d;
                ClxCommon::$db->createRecord($this->tablename, $record, false);
                $parent = $record['IDCODE'];
            } else {
                $parent = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'NAME=' . singleQuote($path[$i]));
            }
        }
        if (empty($parent))
            $parent = CLX_INIT_ZERO;
        $record = array();
        $record['IDCODE'] = 'CLX_' . $toolcode;
        $record['ACTIVE'] = CLX_NUM_ONE;
        $record['PARENT'] = $parent;
        $record['NAME'] = $path[$i];
        $record['TYPE'] = $type;
        $record['EXTRA1'] = $extra1;
        $record['EXTRA2'] = $extra2;
        $record['TOOLCODE'] = $toolcode;
        $record['MODULECODE'] = 'CLX';
        $record['VERSION'] = '1.0.0';
        $record['DESCRIPTION'] = $type . ' ' . $path[$i];
        $record['VERSION_COUNTER'] = CLX_INIT_ZERO;
        $record['SEQNUM'] = (int) $seqnum;
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = 'admin';
        $parent = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->clearHeap();
    }

    /**
     *
     * @param type $menus
     */
    function getMenu(&$menus) {
		$a=microtime(true);
        $lang = clx_language_lower_upper(getCurrentLanguage());
        $binds = array('SYS_LANGUAGE' => (string) uppercase(kSystemLanguage), 'LANGUAGE' => uppercase((string) $lang));
        $username = $_SESSION['user_record']['username'];
        $ACTO = &getTool('ACTO');
        $groups = $ACTO->userGroups($username);
        if (count($groups) > CLX_NUM_ZERO) {
            $groups = toString($groups);
            $sq = '((AC.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(AC.OWNERREF)=' . singleQuote(uppercase($username)) . ') OR (AC.OWNERCODE=' . singleQuote('GRUP') . ' AND AC.OWNERREF IN (' . $groups . ')))';
        } else {
            $sq = '(AC.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(AC.OWNERREF)=' . singleQuote(uppercase($username)) . ')';
        }
		$userkey = $lang . ((ClxCommon::sessionHasUser()) ? clx_mcript($_SESSION[CLX_PROP_ID]) : '');
		$fetched = false;
	   // if (kApcTtl_19>0) $menus = apc_fetchFct($findvar=kSpaceName . '.uimi.' .$lang .'_'. $userkey, $fetched);
		//if (empty($fetched)) {
			ClxFreeReturn($this->getMenuItems($menus, CLX_NUM_ZERO, $sq, $binds));
			if (kApcTtl_19>0) {
			//	apc_addFct($findvar, $menus, kApcTtl_19);
			}
		//}
        unset($binds);
    }
	function getMenuItems(&$menus, $parent, $sq, &$binds) {
        $menu = false;
        $binds['PARENT'] = (string) $parent;
		$binds['SYS_LANGUAGE'] = clx_language_lower_upper($binds['SYS_LANGUAGE']);
        $lang = clx_language_lower_upper((string) $binds['LANGUAGE']);
		$fetched=false;
		if(kApcTtl_19>0) $rc = apc_fetchFct($findVar=trim(kSpaceName .'_menus_'.$_SESSION ['user_record'] ['username'].'_'.$lang.'_'.$parent) , $fetched);
		//pre($findVar);
		if (!$fetched) {
			if (kDatabaseType === 'oci') {
				if (ClxCommon::sessionUserIsAdmin()) {
					$sql = 'SELECT UI.*, COALESCE(DI.VALUE, COALESCE((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) = :SYS_LANGUAGE), UI.NAME)) IDNAME FROM CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) = :LANGUAGE WHERE UI.ACTIVE = 1 AND UI.PARENT=:PARENT ORDER BY UI.SEQNUM,UI.ID';
				} else {
					$sql = 'SELECT DISTINCT(UI.ID), UI.IDCODE, UI.NAME, UI.ACTIVE, TO_CHAR(UI.DESCRIPTION),UI.TOOLCODE, UI.MODULECODE, UI.VERSION, UI.VERSION_COUNTER,UI.CDATE, UI.MDATE, UI.USERNAME, UI.TYPE, UI.PARENT, UI.SEQNUM, UI.EXTRA1, UI.EXTRA2, UI.EXTRA3, UI.EXTRA4, UI.EXTRA5, COALESCE(DI.VALUE, COALESCE((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) = :SYS_LANGUAGE), UI.NAME)) IDNAME FROM CLX_AC_MENUITEMS AC, CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) = :LANGUAGE WHERE UI.ACTIVE = 1 AND AC.MENUID = UI.IDCODE AND AC.CANREAD=1 AND UI.PARENT= :PARENT AND ' . $sq . ' ORDER BY UI.SEQNUM,UI.ID';
				}
			} else {
				if (ClxCommon::sessionUserIsAdmin()) {
					$sql = 'SELECT UI.*, IFNULL(DI.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) =' . singleQuote(uppercase(kSystemLanguage)) . '), UI.NAME)) IDNAME FROM CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) =' . singleQuote(uppercase($lang)). ' WHERE UI.ACTIVE = 1 AND UI.PARENT=' . singleQuote($parent) . ' ORDER BY SEQNUM,UI.ID';
				} else {
					$sql = 'SELECT DISTINCT UI.*, IFNULL(DI.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) =' . singleQuote(uppercase(kSystemLanguage)) . '), UI.NAME)) IDNAME FROM CLX_AC_MENUITEMS AC, CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) =' . singleQuote(uppercase($lang)) . ' WHERE UI.ACTIVE = 1 AND AC.MENUID = UI.IDCODE AND AC.CANREAD=1 AND UI.PARENT=' . singleQuote($parent) . ' AND ' . $sq . ' ORDER BY UI.SEQNUM,UI.ID';
				}
			}
			$records = ClxCommon::$db->executeQuery($sql, $binds);
			$rc=array();
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$rc[]=$record;
			}
			if (kApcTtl_19>0 && count($rc)>0){
				apc_addFct($findVar,$rc, kApcTtl_19);
			}
		}
		foreach ($rc as $record) {
			$name = $record['IDCODE'] . '||' . $record['IDNAME'];
			if (strpos($name, 'href="javascript:openWindow') !== false)
				$name = $record['IDCODE'] . '||' . $record['NAME'];
			if ($record['TYPE'] === 'MENU') {
				ClxFreeReturn($this->getMenuItems($menus[$name], $record['IDCODE'], $sq, $binds));
		
			} else {
				$menu = getToolObject('UIMI', $record['TYPE']);
				if (!empty($menu)) {
					$menus[$name] = $menu->makeURL($record);
				}
			}
		}
		//pre($menus);
		return $menu;
    }

    /**
     * Return json menu
     * @param type $parentid
     * @return string
     */
    function getJsonMenu($parentid) {
        $lang = getCurrentLanguage();
        $username = $_SESSION['user_record']['username'];
        if (ClxCommon::sessionUserIsAdmin()) {
            $sql = 'SELECT UI.*, IFNULL(DI.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) =' . singleQuote(uppercase(kSystemLanguage)) . '),UI.NAME)) IDNAME FROM ' . $this->tablename . ' UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) =' . singleQuote(uppercase($lang)) . ' WHERE UI.ACTIVE = 1 AND UI.PARENT=' . singleQuote($parentid) . ' ORDER BY UI.SEQNUM';
        } else {
            switch (kDatabaseType) {
		case 'oci': // Oracle
                $sql = 'SELECT DISTINCT(UI.ID), UI.IDCODE, UI.NAME, UI.ACTIVE, TO_CHAR(UI.DESCRIPTION),UI.TOOLCODE, UI.MODULECODE, UI.VERSION, UI.VERSION_COUNTER,UI.CDATE, UI.MDATE, UI.USERNAME, UI.TYPE, UI.PARENT, UI.SEQNUM, UI.EXTRA1, UI.EXTRA2, UI.EXTRA3, UI.EXTRA4, UI.EXTRA5, IFNULL(DI.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND UPPER(D.LANGUAGE) =' . singleQuote(uppercase(kSystemLanguage)) . '), UI.NAME)) IDNAME FROM CLX_AC_MENUITEMS AC, CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) =' . singleQuote(uppercase($lang)) . ' WHERE UI.ACTIVE = 1 AND AC.MENUID = UI.IDCODE AND AC.CANREAD=1 AND UI.PARENT=' . singleQuote($parentid);    
			break;
		default: // MySQL Version all others
                $sql = 'SELECT DISTINCT UI.*, IFNULL(DI.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = UI.NAME AND D.LANGUAGE =' . singleQuote(clx_language_lower_upper(kSystemLanguage)) . '), UI.NAME)) IDNAME FROM CLX_AC_MENUITEMS AC, CLX_UI_MENUITEMS UI LEFT JOIN CLX_DICTIONARY DI ON DI.ENTRY = UI.NAME AND UPPER(DI.LANGUAGE) =' . singleQuote(uppercase($lang)) . ' WHERE UI.ACTIVE = 1 AND AC.MENUID = UI.IDCODE AND AC.CANREAD=1 AND UI.PARENT=' . singleQuote($parentid);            
			break;
	}
            $ACTO = getTool('ACTO');
            $groups = $ACTO->userGroups($username);
            if (count($groups) > CLX_NUM_ZERO) {
                $groups = toString($groups);
            }
            $sql .= 'ORDER BY UI.SEQNUM';
        }
        $entries = array();
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $entry = utf8_encode($r['IDCODE']);
            $entries[$entry] = array('name' => utf8_encode($r['IDNAME']),
                'type' => $r['type'],
                CLX_PROP_TARGET => '');
            if ($r['type'] <> 'MENU') {
                $menu = getToolObject('UIMI', $r['type']);
                $entries[$entry][CLX_PROP_TARGET] = $menu->makeURL($r);
            }
        }
        if (!empty($entries)) {
            $content = json_encode($entries);
            unset($entries);
        }
        return $content;
    }

}
