<?php

/**
 * Pages Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-03-15 20:11:09 +0000 (Fri, 15 Mar 2019) $
 * @version      $Rev: 10574 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_pages extends clx_tool {

    // CONSTRUCTOR //
    var $search_pending;

    function __construct() {
        $this->code = 'UIPG';
        $this->name = 'Page Manager';
        $this->system = 'Interface';
        $this->version = '0.2.7.0';
        $this->has_preferences = true;
        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_UI_PAGES';
        $this->record_name_singular = 'page';
        $this->record_name_plural = 'pages';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->search_pending = CLX_INIT_ZERO;
        $this->yesno = array('GEN_LBL_NO', 'GEN_LBL_YES');
        $this->primary_key = array('IDCODE');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_UIPG_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
                                )
                            )
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_ACTIVE',
                            'fields' => array(
                                array('name' => 'active', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => $this->yesno))
                        ), array('label' => 'GEN_LBL_TITLE',
                            'fields' => array(
                                array('name' => CLX_CLASS_TITLE, 'type' => 'dict', 'required' => '0'))
                        ), array('label' => 'GEN_LBL_VERSION',
                            'fields' => array(
                                array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_ACCESS',
                            'fields' => array(
                                array('name' => 'accesses', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => array('0' => 'GEN_LBL_PRIVATE', '1' => 'GEN_LBL_PUBLIC')))
                        ), array('label' => 'GEN_LBL_MODULECODE',
                            'fields' => array(
                                array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_EXEONSEARCH',
                            'fields' => array(
                                array('name' => 'exeonsearch', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno))
                        )
                    )
                )
            )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_INTERFACE:MENU_PAGES', 'TOOL', $this->code, 'ac=LIST');
        //Creating Initial Page  dict('GEN_LBL_PAGE')
        ClxCommon::$db->createRecord($this->tablename, array('IDCODE' => 'DEFAULT_PAGE', 'IDNAME' => 'Clientix Default Page', 'TITLE' => 'GEN_LBL_CLIENTIX', 'VERSION' => '1.0.0', 'VERSION_COUNTER' => CLX_NUM_ZERO, 'CDATE' => date('Ymdhis'), 'MDATE' => date('Ymdhis'), 'username' => 'admin', 'DESCRIPTION' => 'Clientix Default Page', 'ACCESSES' => CLX_NUM_ONE, 'MODULECODE' => 'BASE'), false);
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['TITLE'] = array('type' => 'varchar(40)', 'null' => 'YES', 'properties' => '', 'dict' => true);
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['EXEONSEARCH'] = array('type' => 'tinyint(1) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ACTIVE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function preferencesForm($record, &$form, &$table) {
        $table->addCell(dict('TOOL_UIPG_TITLE_PREFS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $table->width));
        $pop = new htmlSelect('UIPG_PREF_PAGE');
        $pages = ClxCommon::$db->getRecords($this->tablename, '(USERNAME=' . singleQuote($_SESSION['user_record']['username']) . ' OR ACCESSES=1) AND ACTIVE = 1 ORDER BY IDNAME');
        while ($page = ClxCommon::$db->getNextRecord($pages)) {
            $pop->addItem($page['IDNAME'] . ' (' . $page['IDCODE'] . ')', $page['IDCODE'], ($record['UIPG_PREF_PAGE'] == $page['IDCODE']));
        }
        $table->addData(dict('TOOL_UIPG_PROMPT_PREF_PAGE') . ':', $pop->source());
    }

    function preferencesLoad(&$record) {
        $username = $_SESSION['user_record']['username'];
        $record['UIPG_PREF_PAGE'] = ClxCommon::$db->getField('CLX_US_PREFERENCES', 'PREFVALUE', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)) . ' AND PREFKEY = ' . singleQuote('UIPG_PREF_PAGE'));
    }

    function preferencesSave() {
        $USPR = &getTool('USPR');
        $USPR->prfSavePref($_SESSION['user_record']['username'], 'UIPG_PREF_PAGE', UserRequest::$post['UIPG_PREF_PAGE']);
    }

    function preferencesDefault(&$record) {
        $values = array();
        $values['UIPG_PREF_PAGE'] = '';
        return $values;
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'UIPR', 'SELECT * FROM CLX_UI_PAGE_ROWS WHERE PAGECODE=' . singleQuote($code));
        //Packing Dictionary
        $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_UI_PAGES X  WHERE DICT.ENTRY=X.TITLE  AND X.IDCODE=' . singleQuote($code));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $panelid = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE = ' . singleQuote($record['IDCODE']));
        if (!empty($panelid)) {
            $this->deleteRecordSk($panelid);
        }
        $panelid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $panelid));
            }
        }
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'QFILTER':
                    $callingpage = peekHistory();
                    $this->setQuickFilter($callingpage);
                    $contents = $this->action('PAGE', $idlist);
                    break;
                case 'CLEAR':
                    $callingpage = peekHistory();
                    $this->clearQuickFilter($callingpage);
                    $contents = $this->action('PAGE', $idlist);
                    break;
                case 'PAGE':
                    $callingpage = peekHistory();
                    $pagecode = (!empty(UserRequest::$request['pc']))?UserRequest::$request['pc']:((!empty($callingpage['pc']))?$callingpage['pc']:'');
                    $pagerec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($pagecode));
                    $contents = $this->drawPage($pagerec);
                    break;
                case 'DEF_PAGE':
                    $contents = $this->drawDefaultPage();
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
            }
        } else {
            //$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' ' . $this->getCode(false));
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_PAGES-CAN_READ_1][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
         //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        $access = array(dict('GEN_LBL_PRIVATE'), dict('GEN_LBL_PUBLIC'));
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'UIPGList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_UI_PAGES';
        $whereclause = '';
        $sortclause = 'IDNAME';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		$table = new htmlTable(CLX_WIDTH_TEN);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UIPG_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TEN));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_ACTIVE'), dict('GEN_LBL_TITLE'), dict('GEN_LBL_ACCESS'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_EXEONSEARCH')));
        $i = CLX_INIT_ZERO;
        $DICT = getTool('DICT');
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ')');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['IDCODE'], $record['IDNAME'], dict($this->yesno[$record['ACTIVE']]), $DICT->dictFastEdit($record['TITLE']), $access[$record['ACCESSES']], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), ($record['EXEONSEARCH']) ? dict('GEN_LBL_YES') : dict('GEN_LBL_NO')));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_PAGE')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $contents = '';
        $msg = array();
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UIPG_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'UIPG_idcode', UserRequest::$post['UIPG_idcode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'UIPG_idname', UserRequest::$post['UIPG_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'UIPG_modulecode', UserRequest::$post['UIPG_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['UIPG_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UIPG_idcode']) . '%');
            }
            if (UserRequest::$post['UIPG_idname'] <> '') {
                $criteria .= 'IDNAME LIKE ' . singleQuote(clx_change_especial_char_html (UserRequest::$post['UIPG_idname']) . '%');
            }
            if (UserRequest::$post['UIPG_idname'] <> '') {
                $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UIPG_modulecode']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=ui_pages></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['UIPG_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['UIPG_idname']);
    }

    function viewFormFill($record) {
        addHistory('pagecode', $record['UIPG_idcode']);
        $access = array(dict('GEN_LBL_PRIVATE'), dict('GEN_LBL_PUBLIC'));
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UIPG_TITLE_VIEW') . ': ' . $record['UIPG_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['UIPG_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['UIPG_idname']);
        $table->addData(dict('GEN_LBL_ACTIVE') . ':', dict($this->yesno[$record['UIPG_active']]));
        $table->addData(dict('GEN_LBL_TITLE') . ':', dict($record['UIPG_title']));
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['UIPG_version'] . '-' . $record['UIPG_version_counter']);
        $table->addData(dict('GEN_LBL_ACCESS') . ':', $access[$record['UIPG_accesses']]);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['UIPG_description']));
        $contents .= $table->source();
        $UIPR = &getTool('UIPR');
        $contents .= $UIPR->makepanel($record['UIPG_idcode']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['UIPG_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['UIPG_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['UIPG_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('UIPG_idcode', UserRequest::$post))
            UserRequest::$post['UIPG_idcode'] = '';
        if (!array_key_exists('UIPG_idname', UserRequest::$post))
            UserRequest::$post['UIPG_idname'] = '';
        if (!array_key_exists('UIPG_modulecode', UserRequest::$post))
            UserRequest::$post['UIPG_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'UIPG_idcode', UserRequest::$post['UIPG_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'UIPG_idname', UserRequest::$post['UIPG_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'UIPG_modulecode', UserRequest::$post['UIPG_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['UIPG_idcode'])) {
            $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UIPG_idcode']) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['UIPG_idname'])) {
            $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['UIPG_idname'])) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['UIPG_modulecode'])) {
            $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UIPG_modulecode']) . '%');
            $boolean = 'AND';
        }
        $_SESSION['paging']['UIPGList']['criteria'] = $filter;
        $_SESSION['paging']['UIPGList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['UIPGList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['UIPG_id'] = $recordid;
        $record['UIPG_idcode'] = $values['IDCODE'];
        $record['UIPG_idname'] = $values['IDNAME'];
        $record['UIPG_active'] = $values['ACTIVE'];
        $DICT = &getTool('DICT');
        $DICT->loadEntry('UIPG_title', $values['TITLE'], $record);
        $record['UIPG_version'] = $values['VERSION'];
        $record['UIPG_version_counter'] = $values['VERSION_COUNTER'];
        $record['UIPG_cdate'] = xFormat::date($values['CDATE']);
        $record['UIPG_mdate'] = xFormat::date($values['MDATE']);
        $record['UIPG_username'] = $values['USERNAME'];
        $record['UIPG_description'] = $values['DESCRIPTION'];
        $record['UIPG_accesses'] = $values['ACCESSES'];
        $record['UIPG_modulecode'] = $values['MODULECODE'];
        $record['UIPG_exeonsearch'] = $values['EXEONSEARCH'];
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UIPG_idcode'];
        $record['IDNAME'] = UserRequest::$post['UIPG_idname'];
        $record['ACTIVE'] = UserRequest::$post['UIPG_active'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->saveEntry('UIPG_title', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['UIPG_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['UIPG_description'];
        $record['ACCESSES'] = UserRequest::$post['UIPG_accesses'];
        $record['MODULECODE'] = UserRequest::$post['UIPG_modulecode'];
        $record['EXEONSEARCH'] = UserRequest::$post['UIPG_exeonsearch'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['UIPG_id']);
        $this->versionIncrease('ID', UserRequest::$post['UIPG_id']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UIPG_idcode'];
        $record['IDNAME'] = UserRequest::$post['UIPG_idname'];
        $record['ACTIVE'] = UserRequest::$post['UIPG_active'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->createEntry('UIPG_title', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['UIPG_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['UIPG_description'];
        $record['ACCESSES'] = UserRequest::$post['UIPG_accesses'];
        $record['MODULECODE'] = UserRequest::$post['UIPG_modulecode'];
        $record['EXEONSEARCH'] = UserRequest::$post['UIPG_exeonsearch'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $code = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID = ' . $id);
        $UIPR = &getTool('UIPR');
        $sql = 'SELECT ID FROM ' . $UIPR->tablename . ' WHERE PAGECODE = ' . singleQuote($code);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
            $UIPR->deleteRecordSk($r[CLX_NUM_ZERO]);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['UIPG_id'] = CLX_INIT_ZERO;
        $record['UIPG_idcode'] = '';
        $record['UIPG_idname'] = '';
        $record['UIPG_active'] = CLX_NUM_ONE;
        $record['UIPG_title'] = '';
        $record['UIPG_title_DICT'] = '';
        $record['UIPG_version'] = '1.0.0';
        $record['UIPG_cdate'] = '';
        $record['UIPG_mdate'] = '';
        $record['UIPG_username'] = $_SESSION['user_record']['username'];
        $record['UIPG_description'] = '';
        $record['UIPG_accesses'] = '0';
        $record['UIPG_modulecode'] = '';
        $record['UIPG_exeonsearch'] = '0';
        return $record;
    }

// DEPRECATED in favor of chooseRecord($name, $default)
    function placeChoosePage($msg, $prompt, $name, $default, &$table) {
        if (!empty($msg[$name]))
            $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->chooseRecord($name, $default), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return '';
    }

// DEPRECATED in favor of recordExists($field_label, &$field_value, $msg)
    function pageExists(&$idcode) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field . '=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
            $idcode = ClxCommon::$db->getField($this->tablename, $this->primary_field, $this->primary_field . '=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

    /**
     * Sets all queries quick filters that may apply
     *
     * @param unknown_type $callingpage
     */
    function setQuickFilter($callingpage) {
        $EDIT = getTool('EDIT');
        $UIPC = getTool('UIPC');
        //Listings to set quick filters
        $sql = 'SELECT DISTINCT UIPO.ID, UILG.QUERYCODE, UILG.IDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_UI_LISTINGS UILG, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND UIPR.ID = UIPO.IDROW AND UILG.IDCODE = UIPO.OBJECTCODE AND UIPG.IDCODE = ' . singleQuote($callingpage['pc']) . ' AND UIPO.TOOLCODE = ' . singleQuote('UIL') . ' AND UIPG.ACTIVE = 1 AND UIPR.ACTIVE = 1 AND UIPO.ACTIVE = 1 AND EXISTS(SELECT X.ID FROM ' . $UIPC->tablename . ' X WHERE X.OBJECTID = UIPO.ID) UNION SELECT DISTINCT  UIPO.ID, ANPL.QUERYCODE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_AN_PLOT ANPL, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND UIPR.ID = UIPO.IDROW AND ANPL.IDCODE = UIPO.OBJECTCODE AND UIPG.IDCODE = ' . singleQuote($callingpage['pc']) . ' AND UIPG.ACTIVE = 1 AND UIPO.ACTIVE = 1 AND TOOLCODE = ' . singleQuote('ANP') . ' AND EXISTS(SELECT X.ID FROM ' . $UIPC->tablename . ' X WHERE X.OBJECTID = UIPO.ID)';
        $save_post = UserRequest::$post;
        //Store page quick search data to be used on UIFM Pagelet
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            UserRequest::$post = array();
            //La idea es transformar UserRequest::$post cambiando los indexes para colocar nuevos valores en criterios
            $criterias = ClxCommon::$db->getRecords($UIPC->tablename, 'OBJECTID = ' . $result['ID']);
            while ($criteria = ClxCommon::$db->getNextRecord($criterias)) {
                if (!array_key_exists($criteria['FRM_FIELDNAME'], $save_post)) {
                    UserRequest::$post[$criteria['FRM_FIELDNAME']] = $criteria['VALUE'];
                } else {
                    UserRequest::$post[$criteria['FRM_FIELDNAME']] = $save_post[$criteria['FRM_FIELDNAME']];
                }
                $UIPC->buildRecordOperator(UserRequest::$post, $criteria);
            }
            UserRequest::$post['fm'] = $save_post['fm'];
            UserRequest::$post[CLX_PROP_TO] = $save_post[CLX_PROP_TO];
            UserRequest::$post['ac'] = $save_post['ac'];
            UserRequest::$post['fm'] = $save_post['fm'];
            UserRequest::$post['it'] = $save_post['it'];
            UserRequest::$post['pc'] = $save_post['pc'];
            UserRequest::$post['confirm'] = $save_post['confirm'];
            UserRequest::$post['idlist'] = $save_post['idlist'];
            UserRequest::$post['form_id'] = $save_post['form_id'];
            $call = $callingpage;
            $call['qy'] = $result['QUERYCODE'];
            $call['li'] = $result['IDCODE'];
            $EDIT->setQuickFilter($call);
            UserRequest::$post = $save_post;
        }
        $_SESSION['page_filters'][$callingpage['pc']] = UserRequest::$post;
        unset($call, $save_post);
    }

    function clearQuickFilter($callingpage) {
        $EDIT = &getTool('EDIT');
        //Listings to set quick filters
        $sql = 'SELECT DISTINCT UILG.QUERYCODE, UILG.IDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_UI_LISTINGS UILG, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND UIPR.ID = UIPO.IDROW AND UILG.IDCODE = UIPO.OBJECTCODE AND UIPG.IDCODE = ' . singleQuote($callingpage['pc']) . ' AND UIPG.ACTIVE = 1 AND UIPO.ACTIVE = 1 AND UIPO.TOOLCODE = ' . singleQuote('UIL') . ' UNION SELECT DISTINCT ANPL.QUERYCODE, ANPL.IDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_AN_PLOT ANPL, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND UIPR.ID = UIPO.IDROW AND ANPL.IDCODE = UIPO.OBJECTCODE AND UIPG.ACTIVE = 1 AND UIPR.ACTIVE = 1 AND UIPO.ACTIVE = 1 AND UIPG.IDCODE = ' . singleQuote($callingpage['pc']) . ' AND TOOLCODE = ' . singleQuote('ANP') . '';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $call = $callingpage;
            $call['qy'] = $result['QUERYCODE'];
            $call['li'] = $result['IDCODE'];
            $EDIT->clearQuickFilter($call);
        }
        unset($_SESSION['page_filters'][$callingpage['pc']]);
        unset($call);
    }

    function drawDefaultPage() {
        $msg = array();
        if (!ClxCommon::$db->fieldExists($this->tablename, 'ACTIVE')) {
            return alert('Field active missing on table for tool UIPG, please audit tool UIPG');
        }
        if (!empty($_SESSION['prefs']['UIPG_PREF_PAGE'])) {
            $pagecode = $_SESSION['prefs']['UIPG_PREF_PAGE'];
        } else {
            $pagecode = '';
        }
        if ($this->recordExists('IDCODE', $pagecode, $msg)) {
            $pagerec = ClxCommon::$db->getRecord($this->tablename, 'ACTIVE = 1 AND IDCODE=' . singleQuote($pagecode));
        } else {
            return warning(dict('GEN_ERR_INVALID_DEF_PAGE_PLSSEL') . ' [' . $pagecode .']');
        }
        return $this->drawPage($pagerec);
    }

    function drawPage($pagerec) {
		if(gettype($pagerec)=='NULL')
			return note(dict('GEN_LBL_PAGE_INFORMATION_NOT_FOUND'), dict('GEN_LBL_CONTINUE'));
        clearHistory();
        pushHistory($this->code, 'PAGE', array(), 'pc', $pagerec['IDCODE']);
        if (!empty($pagerec['EXEONSEARCH']) &&$pagerec['EXEONSEARCH'] == CLX_NUM_ONE && empty($_SESSION['page_filters'][$pagerec['IDCODE']])) {
            $this->search_pending = CLX_NUM_ONE;
        } else {
            $this->search_pending = CLX_INIT_ZERO;
        }
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => 'page'));
        $table->addCell(dict($pagerec['TITLE']), array(CLX_PROP_CLASS => 'pagetitle'));
        $pagecode = $pagerec['IDCODE'];
        $rows = ClxCommon::$db->getRecords('CLX_UI_PAGE_ROWS', 'ACTIVE = 1', 'PAGECODE=' . singleQuote($pagecode) . ' ORDER BY SEQNUM');
        while ($rowrec = ClxCommon::$db->getNextRecord($rows)) {
            $row = $this->drawPageRow($pagerec, $rowrec);
            $table->addCell($row, array());
        }
        return $table->source();
    }

    /**
     * Draw page
     * @param type $pagerec
     * @param type $rowrec
     * @return type
     */
    function drawPageRow($pagerec, $rowrec) {

        $idrow = $rowrec['ID'];
        $owner = ($_SESSION['user_record']['username'] == $pagerec['USERNAME']);
        $title = '';
        $buttons = '';
		$fetched = false;
	    if(kApcTtl_20>0) $tableWidth = apc_fetchFct($findVar=kSpaceName . '_drawPagesRow_'.$idrow, $fetched);
		if (empty($fetched)) {
			$tableWidth = ClxCommon::$db->countRecords('CLX_UI_PAGE_OBJECTS', 'ACTIVE = 1 AND IDROW=' . $idrow);
        	if (kApcTtl_20>0 ) {
				apc_addFct($findVar,$tableWidth, kApcTtl_20);  //actualizacion forzada cada 30 segundos no ilimitada
			}
		}
        $cellwidth = ($tableWidth===CLX_NUM_ZERO)?0:round((CLX_NUM_ONE / $tableWidth) * CLX_NUM_HUNDRED, CLX_NUM_ZERO);
        $table = new htmlTable($tableWidth);
        $table->setProps(array(CLX_PROP_CLASS => 'page'));
        $table->addCell(dict($rowrec['NAME']) . CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
        $objects = ClxCommon::$db->getRecords('CLX_UI_PAGE_OBJECTS', 'ACTIVE = 1 AND IDROW=' . $idrow . ' ORDER BY SEQNUM');
        while ($objectrec = ClxCommon::$db->getNextRecord($objects)) {
            $source = '';
            if ($owner === true) {
                $url = sprintf('tool.php?to=UIPO&ac=MODIFY&idlist=%s', $objectrec['ID']);
                $buttons = getSkinIcon('MODIFY', $url, $title);
                $url = sprintf('tool.php?to=UIPO&ac=DISPLAY&idlist=%s', $objectrec['ID']);
                $buttons .= getSkinIcon('view', $url, $title);
                $url = sprintf('tool.php?to=UIPO&ac=DELETE&idlist=%s', $objectrec['ID']);
                $buttons .= getSkinIcon('DELETE', $url, $title);
            }

            $tool = &getTool($objectrec['TOOLCODE']);
            if(is_null($tool) || empty(trim($objectrec['TOOLCODE']))) {
                $page_row = ClxCommon::$db->getRecord('CLX_UI_PAGE_ROWS', 'ACTIVE = 1 AND ID='.$objectrec['IDROW']);
                $source = 'Page cell inconsistency. Page=' . $page_row['PAGECODE'] . ', Cell data: Row=' . $page_row['SEQNUM'] . ', Line=' . $objectrec['SEQNUM'] . ', Tool=' . $objectrec['TOOLCODE'] . ', Obj=' . $objectrec['OBJECTCODE'] . ', ID=' . $objectrec['ID'];
                $BUGS = &getTool('BUGS');
                if (!empty($BUGS)) {
                    $BUGS->report(E_USER_WARNING, $source, 'tools/ui_pages.php', '611', UserRequest::$request, CLX_NUM_ZERO, '');
                }
                $source = note(dict('GEN_LBL_PAGE').' '.dict('GEN_LBL_INACTIVE'));
            } elseif(!$tool->pageCheckObject($objectrec['OBJECTCODE'])) {
                $BUGS = &getTool('BUGS');
                if (!empty($BUGS)) {
                    $BUGS->report(E_USER_WARNING, 'Missing page object:'.$objectrec['OBJECTCODE'], 'tools/ui_pages.php', '615', array('page'=>$pagerec,'row'=>$objectrec), CLX_NUM_ZERO, '');
                }
                ClxCommon::$db->updateRecord('CLX_UI_PAGE_OBJECTS', array('ACTIVE'=>CLX_NUM_ZERO), 'ID='.$objectrec['ID']);
                continue;
            }else{

                $source = $tool->pageletform();
                if (strlen($source) === CLX_NUM_ZERO) {
                    if ($this->search_pending && $objectrec['FORM_ACTION'] <> 'QFILTER') {
                        $source = note(dict('GEN_LBL_PLEASESEARCH'));
                    } else {
                        if ($tool->getAccess()->canRead()) {
                            $source = $tool->pagelet($objectrec['OBJECTCODE'], $objectrec['FORM_ACTION'], $objectrec['ID']);
                        } else {
                            $source = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_PAGES-CAN_READ_2][DRAWPAGEROW] ' . $this->getCode(false));
                        }
                    }
                }
            }


            $pagelettable = new htmlTable(CLX_WIDTH_ONE);
            $pagelettable->setProps(array('border' => '0', CLX_PROP_WIDTH => '99%'));
            $pagelettable->addCell(dict($objectrec['TITLE']) . ' ' . $buttons, array(CLX_PROP_CLASS => 'pagerowheaders', 'witdh' => CLX_PROP_100PCT));
            $pagelettable->addCell($source, array('witdh' => CLX_PROP_100PCT, CLX_PROP_ALIGN => 'center', 'valign' => 'middle'));
            $table->addCell($pagelettable->source(), array('witdh' => $cellwidth . '%'));
        }
        return $table->source();
    }

}
