<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version        $Rev: 10496 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_templates extends clx_tool {

    // CONSTRUCTOR //
    var $tb_folder;
    var $ctgt_fields;

    function __construct() {
        $this->code = 'UITM';
        $this->name = 'Template Manager';
        $this->system = 'Interface';
        $this->version = '0.1.3.1';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_UI_TEMPLATES';
        $this->record_name_singular = 'template';
        $this->record_name_plural = 'templates';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->tb_folder = kPathToWebSite . kPathToTemplates;
        //Campaign target fields
        $this->ctgt_fields = array('ID' => 'GEN_LBL_ID', 'LEGAL_TYPE' => 'GEN_LBL_LEGAL_TYPE',
            'SALUTATION' => 'GEN_LBL_SALUTATION', 'FIRSTNAME' => 'GEN_LBL_FIRSTNAME',
            'SECOND_NAME' => 'GEN_LBL_SECOND_NAME', 'LASTNAME' => 'GEN_LBL_LASTNAME',
            'SECOND_LASTNAME' => 'GEN_LBL_SECOND_LASTNAME', 'FULLNAME' => 'GEN_LBL_FULLNAME',
            'SEX' => 'GEN_LBL_SEX', 'IDENTIFICATION' => 'GEN_LBL_IDENTIFICATION',
            'ID_TYPE' => 'GEN_LBL_ID_TYPE', 'OPPORTUNITYCODE' => 'GEN_LBL_OPPORTUNITYCODE',
            'CONTACT_TYPE' => 'GEN_LBL_CONTACT_TYPE', 'TITLE' => 'GEN_LBL_TITLE',
            'DEPARTMENT' => 'GEN_LBL_DEPARTMENT', 'INCOME' => 'GEN_LBL_INCOME',
            'LOCTYPE' => 'GEN_LBL_LOCTYPE', 'ADDRESS1' => 'GEN_LBL_ADDRESS1',
            'ADDRESS2' => 'GEN_LBL_ADDRESS2', 'CITY' => 'GEN_LBL_CITY',
            'FOREIGN_CITY' => 'GEN_LBL_FOREIGN_CITY', 'STATE' => 'GEN_LBL_STATE',
            'FOREIGN_STATE' => 'GEN_LBL_FOREIGN_STATE', 'ZIPCODE' => 'GEN_LBL_ZIPCODE',
            'COUNTRY' => 'GEN_LBL_COUNTRY', 'PHONE' => 'GEN_LBL_PHONE',
            'HOME_PHONE' => 'GEN_LBL_HOME_PHONE', 'MOBILE_PHONE' => 'GEN_LBL_MOBILE_PHONE',
            'OTHER_PHONE' => 'GEN_LBL_OTHER_PHONE', 'FAX' => 'GEN_LBL_FAX',
            'EMAIL' => 'GEN_LBL_EMAIL', 'WEBSITE' => 'GEN_LBL_WEBSITE',
            'IM_ADDRESS' => 'GEN_LBL_IM_ADDRESS', 'CITIZENSHIP' => 'GEN_LBL_CITIZENSHIP',
            'BIRTHDATE' => 'GEN_LBL_BIRTHDATE', 'EDUCATION_LEVEL' => 'GEN_LBL_EDUCATION_LEVEL',
            'INCOME_LEVEL' => 'GEN_LBL_INCOME_LEVEL', 'INCOME_SOURCE' => 'GEN_LBL_INCOME_SOURCE',
            'BIRTH_COUNTRY' => 'GEN_LBL_BIRTH_COUNTRY', 'MARRIED_NAME' => 'GEN_LBL_MARRIED_NAME',
            'SOURCE_LEAD' => 'GEN_LBL_SOURCE_LEAD', 'LETTER_HEADER' => 'GEN_LBL_LETTER_HEADER',
            'FIELD_EXTRA00' => 'GEN_LBL_FIELD_EXTRA00', 'FIELD_EXTRA01' => 'GEN_LBL_FIELD_EXTRA01',
            'FIELD_EXTRA02' => 'GEN_LBL_FIELD_EXTRA02', 'FIELD_EXTRA03' => 'GEN_LBL_FIELD_EXTRA03',
            'FIELD_EXTRA04' => 'GEN_LBL_FIELD_EXTRA04', 'FIELD_EXTRA05' => 'GEN_LBL_FIELD_EXTRA05',
            'FIELD_EXTRA06' => 'GEN_LBL_FIELD_EXTRA05', 'FIELD_EXTRA07' => 'GEN_LBL_FIELD_EXTRA07',
            'FIELD_EXTRA08' => 'GEN_LBL_FIELD_EXTRA08', 'FIELD_EXTRA09' => 'GEN_LBL_FIELD_EXTRA09',
            'CDATE' => 'GEN_LBL_CDATE', 'CREATEDBY' => 'GEN_LBL_CREATEDBY',
            'MDATE' => 'GEN_LBL_MDATE', 'MODIFIEDBY' => 'GEN_LBL_MODIFIEDBY');
        $this->ui_templates_cont();
    }

    function ui_templates_cont() {
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_UITM_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
                                )
                            )
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MAP_FIELDS',
                            'fields' => array(
                                array('name' => 'target_fields', 'type' => CLX_CLASS_LIST, 'options' => $this->ctgt_fields, 'js' => array('onChange' => 'setTemplateField(' . singleQuote('UITM_contents') . ', this.value);setTemplateField(' . singleQuote('UITM_contents_txt') . ', this.value);'))
                            )
                        ), array('label' => 'GEN_LBL_CONTENTS',
                            'fields' => array(
                                array('name' => 'contents', 'type' => 'text', 'cols' => CLX_NUM_HUNDRED, 'rows' => '30', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_CONTENTS_TXT',
                            'fields' => array(
                                array('name' => 'contents_txt', 'type' => 'text', 'cols' => CLX_NUM_HUNDRED, 'rows' => '25', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_THUMBNAIL145x148',
                            'fields' => array(
                                array('name' => 'thumbnail', 'type' => 'file', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_VERSION',
                            'fields' => array(
                                array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_MODULECODE',
                            'fields' => array(
                                array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_LANGUAGE',
                            'fields' => array(
                                array('name' => 'language', 'type' => CLX_CLASS_LIST, 'default' => 'en', 'options' => 'LANG'))
                        )
                    )
                )
            )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_INTERFACE:MENU_TEMPLATES', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['CONTENTS'] = array('type' => 'longtext', 'properties' => '');
        $fields['CONTENTS_TXT'] = array('type' => 'longtext', 'properties' => '');
        $fields['LANGUAGE'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['THUMBNAIL'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'LANGUAGE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- T E M P L A T E S
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            $contents = parent::action($ac, $idlist);
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_TEMPLATES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
	ClxFreeReturn($listingcode);
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'UITMList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_UI_TEMPLATES';
        $whereclause = '';
        $sortclause = 'IDNAME';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_SIX);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UITM_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_THUMBNAIL'), dict('GEN_LBL_MODULECODE'), //dict('GEN_LBL_CODE'),
            //dict('GEN_LBL_NAME'),
            dict('GEN_LBL_VERSION'), dict('GEN_LBL_LANGUAGE')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            if (empty($record['THUMBNAIL']) || !file_exists(kPathToTemplates . $record['THUMBNAIL'])) {
                $thumbnail = dict('GEN_LBL_NOTAVAILABLE');
            } else {
                $thumbnail = '<img src="' . kPathToTemplates . $record['THUMBNAIL'] . '" align="left" width="145" height="148">';
            }
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                '<b>' . $record['IDCODE'] . '</b><br>' . $record['IDNAME'] .
                '<br><font size=1><i>' . xFormat::text($record['DESCRIPTION']) . '</i></font>',
                $thumbnail, $record['MODULECODE'], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], $record['LANGUAGE']));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_TEMPLATE')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        if (!array_key_exists('UITM_idcode', UserRequest::$post))
            UserRequest::$post['UITM_idcode'] = '';
        if (!array_key_exists('UITM_idname', UserRequest::$post))
            UserRequest::$post['UITM_idname'] = '';
        if (!array_key_exists('UITM_modulecode', UserRequest::$post))
            UserRequest::$post['UITM_modulecode'] = '';
        $msg = array();
        $contents = '';
        $buttons = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UITM_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'UITM_idcode', UserRequest::$post['UITM_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'UITM_idname', UserRequest::$post['UITM_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'UITM_modulecode', UserRequest::$post['UITM_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['UITM_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UITM_idcode']) . '%');
            }
            if (UserRequest::$post['UITM_idname'] <> '') {
                $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['UITM_idname'])) . '%');
            }
            if (UserRequest::$post['UITM_modulecode'] <> '') {
                $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UITM_modulecode']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    if (empty($record['THUMBNAIL']) || !file_exists(kPathToTemplates . $record['THUMBNAIL'])) {
                        $thumbnail = dict('GEN_LBL_NOTAVAILABLE');
                    } else {
                        $thumbnail = '<img src="' . kPathToTemplates . $record['THUMBNAIL'] . '" align="left" width="145" height="148">';
                    }
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                        '<page t=ui_templates></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a><br>' .
                        $record['IDNAME'], $thumbnail));
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function editForm($ac, $idlist, $record, $msg) {

        $js = setJavaScriptTag(kPathToExtLibJs . 'tinymce403/js/tinymce/tinymce.min.js', true)
                . setJavaScriptTag(getJavaScriptFilename('UITM_editform.js'), true);

        return $js . parent::editForm($ac, $idlist, $record, $msg);
    }

    function checkForm(&$msg) {
        return parent::checkForm($msg);
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['UITM_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['UITM_idname']);
    }

    function viewFormFill($record) {
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UITM_TITLE_VIEW') . ': ' . $record['UITM_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['UITM_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['UITM_idname']);
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['UITM_version'] . '-' . $record['UITM_version_counter']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['UITM_description']));
        $table->addData(dict('GEN_LBL_MODULECODE') . ':', $record['UITM_modulecode']);
        $table->addData(dict('GEN_LBL_LANGUAGE') . ':', $record['UITM_language']);
        $table->addCell(dict('GEN_LBL_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell($record['UITM_contents'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addSeparator(CLX_CLASS_DATA);
        $table->addCell(dict('GEN_LBL_CONTENTS_TXT'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell('<pre>' . $record['UITM_contents_txt'] . '</pre>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $contents .= $table->source();
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['UITM_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['UITM_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['UITM_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('UITM_idcode', UserRequest::$post))
            UserRequest::$post['UITM_idcode'] = '';
        if (!array_key_exists('UITM_idname', UserRequest::$post))
            UserRequest::$post['UITM_idname'] = '';
        if (!array_key_exists('UITM_modulecode', UserRequest::$post))
            UserRequest::$post['UITM_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'UITM_idcode', UserRequest::$post['UITM_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'UITM_idname', UserRequest::$post['UITM_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE'), 'UITM_modulecode', UserRequest::$post['UITM_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sort = new HtmlSelect('UITM_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
        $sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
        $sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['UITM_idcode'])) {
            $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UITM_idcode']) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['UITM_idname'])) {
            $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['UITM_idname'])) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['UITM_modulecode'])) {
            $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['UITM_modulecode']) . '%');
            $boolean = 'AND';
        }
        $_SESSION['paging']['UITMList']['sortby'] = UserRequest::$post['UITM_sort'];
        $_SESSION['paging']['UITMList']['criteria'] = $filter;
        $_SESSION['paging']['UITMList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['UITMList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['UITM_id'] = $recordid;
        $record['UITM_idcode'] = $values['IDCODE'];
        $record['UITM_idname'] = $values['IDNAME'];
        $record['UITM_version'] = $values['VERSION'];
        $record['UITM_version_counter'] = $values['VERSION_COUNTER'];
        $record['UITM_cdate'] = xFormat::date($values['CDATE']);
        $record['UITM_mdate'] = xFormat::date($values['MDATE']);
        $record['UITM_username'] = $values['USERNAME'];
        $record['UITM_description'] = $values['DESCRIPTION'];
        $record['UITM_contents'] = $values['CONTENTS'];
        $record['UITM_contents_txt'] = $values['CONTENTS_TXT'];
        $record['UITM_language'] = $values['LANGUAGE'];
        $record['UITM_modulecode'] = $values['MODULECODE'];
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UITM_idcode'];
        $record['IDNAME'] = UserRequest::$post['UITM_idname'];
        $record['VERSION'] = UserRequest::$post['UITM_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['UITM_description'];
        $record['MODULECODE'] = UserRequest::$post['UITM_modulecode'];
        $record['CONTENTS'] = clx_html_spchrs_decode(UserRequest::$post['UITM_contents']);
        $record['CONTENTS_TXT'] = clx_html_spchrs_decode(UserRequest::$post['UITM_contents_txt']);
        $record['LANGUAGE'] = UserRequest::$post['UITM_language'];
        if (!empty(UserRequest::$files['UITM_thumbnail']['name'])) {
            $fn = explode('.', UserRequest::$files['UITM_thumbnail']['name']);
            $filename = lowercase('UITM_' . $record['IDCODE'] . '.' . $fn[CLX_NUM_ONE]);
            $filefullname = $this->tb_folder . $filename;
            if (!move_uploaded_file(UserRequest::$files['UITM_thumbnail']['tmp_name'], $filefullname))
                addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
            $record['THUMBNAIL'] = $filename;
        }
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['UITM_id']);
        $this->versionIncrease('ID', UserRequest::$post['UITM_id']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['UITM_idcode'];
        $record['IDNAME'] = UserRequest::$post['UITM_idname'];
        $record['VERSION'] = UserRequest::$post['UITM_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['UITM_description'];
        $record['MODULECODE'] = UserRequest::$post['UITM_modulecode'];
        $record['CONTENTS'] = clx_html_spchrs_decode(UserRequest::$post['UITM_contents']);
        $record['CONTENTS_TXT'] = clx_html_spchrs_decode(UserRequest::$post['UITM_contents_txt']);
        $record['LANGUAGE'] = UserRequest::$post['UITM_language'];
        if (!empty(UserRequest::$files['UITM_thumbnail']['name'])) {
            $fn = explode('.', UserRequest::$files['UITM_thumbnail']['name']);
            $filename = lowercase('UITM_' . $record['IDCODE'] . '.' . $fn[CLX_NUM_ONE]);
            $filefullname = $this->tb_folder . $filename;
            if (!move_uploaded_file(UserRequest::$files['UITM_thumbnail']['tmp_name'], $filefullname))
                addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
            $record['THUMBNAIL'] = $filename;
        }
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
        return $recordid;
    }

    function duplicateRecord() {
        $templateid = $this->createRecord_();
        return $templateid;
    }

    function deleteRecordSk($id) {
        $templaterec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        $template_image = $this->tb_folder . $templaterec['THUMBNAIL'];
        $crit = 'THUMBNAIL = ' . singleQuote($templaterec['THUMBNAIL']) . ' AND ID <> ' . $templaterec['ID'];
        if (ClxCommon::$db->oneExistsRecords($this->tablename, $crit) === CLX_NUM_ZERO && file_exists($template_image) && is_writable($template_image)) {
            unlink($template_image);
        }

        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $templaterec['MODULECODE']);
    }

    function defaultRecord() {
        $record = array();
        $record['UITM_id'] = CLX_INIT_ZERO;
        $record['UITM_idcode'] = '';
        $record['UITM_idname'] = '';
        $record['UITM_version'] = '1.0.0';
        $record['UITM_cdate'] = '';
        $record['UITM_mdate'] = '';
        $record['UITM_username'] = $_SESSION['user_record']['username'];
        $record['UITM_description'] = '';
        $record['UITM_modulecode'] = '';
        $record['UITM_contents'] = '';
        $record['UITM_contents_txt'] = '';
        $record['UITM_thumbnails'] = '';
        $record['UITM_language'] = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        parent::versionIncrease($fieldname, $fieldvalue);
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

// DEPRECATED in favor of chooseRecord($name, $default)
    function placeChooseTemplate($msg, $prompt, $name, $default, &$table) {
        if ($msg[$name] <> '')
            $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->chooseRecord($name, $default), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return CLX_CHAR_EMPTY_STRING;
    }

// DEPRECATED in favor of recordExists($field_label, &$field_value, $msg)
    function templateExists(&$idcode) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field . '=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
            $idcode = ClxCommon::$db->getField($this->tablename, $this->primary_field, $this->primary_field . '=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

    function merge($templatecode, $record) {
        $templaterec = ClxCommon::$db->getFields($this->tablename, 'IDNAME,CONTENTS, CONTENTS_TXT', 'IDCODE=' . singleQuote($templatecode));
        foreach ($this->ctgt_fields as $key => $value) {
            $replace = '';
            if (array_key_exists($key, $record))
                $replace = $record[$key];
            $templaterec['SUBJECT'] = str_replace('!' . $key, $replace, $templaterec['IDNAME']);
            $templaterec['CONTENTS'] = str_replace('!' . $key, $replace, $templaterec['CONTENTS']);
            $templaterec['CONTENTS_TXT'] = str_replace('!' . $key, $replace, $templaterec['CONTENTS_TXT']);
        }
        $templaterec['SUBJECT'] = clx_keywords_simple($templaterec['SUBJECT']);
        $templaterec['CONTENTS'] = clx_keywords_simple($templaterec['CONTENTS']);
        $templaterec['CONTENTS_TXT'] = clx_keywords_simple($templaterec['CONTENTS_TXT']);
        return $templaterec;
    }

    function replace($contents, $contents_txt, $record) {
        foreach ($this->ctgt_fields as $key => $value) {
            $replace = '';
            if (array_key_exists($key, $record))
                $replace = $record[$key];
            $contents = str_replace('!' . $key, $replace, $contents);
            $contents_txt = str_replace('!' . $key, $replace, $contents_txt);
        }
        $contents = clx_keywords_simple($contents);
        $contents_txt = clx_keywords_simple($contents_txt);
        return array('CONTENTS' => $contents, 'CONTENTS_TXT' => $contents_txt);
    }

    function getTemplateAndRecordMerge($templatecode, $record) {
        $templaterec = ClxCommon::$db->getFields($this->tablename, 'IDNAME SUBJECT,CONTENTS, CONTENTS_TXT', 'IDCODE=' . singleQuote($templatecode));
        foreach ($record as $key => $value) {
            $templaterec['SUBJECT'] = strip_tags(str_replace('!' . $key, $value, $templaterec['SUBJECT']));
            $templaterec['CONTENTS'] = str_replace('!' . $key, $value, $templaterec['CONTENTS']);
            $templaterec['CONTENTS_TXT'] = str_replace('!' . $key, $value, $templaterec['CONTENTS_TXT']);
        }
        $templaterec['SUBJECT'] = clx_keywords_simple($templaterec['SUBJECT']);
        $templaterec['CONTENTS'] = clx_keywords_simple($templaterec['CONTENTS']);
        $templaterec['CONTENTS_TXT'] = clx_keywords_simple($templaterec['CONTENTS_TXT']);
        return $templaterec;
    }

}
