<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version        $Rev: 10496 $
 *
 * CHANGE LOG
 *  Included label
 */
class us_tasks extends clx_tool {

    var $statuses;
    var $priorities;
    var $att_folder;

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USTK';
        $this->name = 'Task Manager';
        $this->system = 'User';
        $this->version = '0.2.8.1';

        $this->has_access = true;

        $this->has_pagelet = true;
        $this->tablename = 'CLX_US_TASKS';
        $this->record_name_singular = 'task';
        $this->record_name_plural = 'tasks';
        $this->primary_field = 'ID';
        $this->secondary_field = 'DESCRIPTION';
        $this->statuses = array('IDLE' => 'GEN_LBL_IDLE', 'WORK' => 'GEN_LBL_IN_PROGRESS', 'END' => 'GEN_LBL_COMPLETED', 'WAIT' => 'GEN_LBL_WAITING', 'DEF' => 'GEN_LBL_DEFERED');
        $this->priorities = array('H' => 'GEN_LBL_HIGH', 'N' => 'GEN_LBL_MEDIUM', 'L' => 'GEN_LBL_LOW');
        //$this->att_folder = kPathToWebSite.USTK_ATTCH_FOLDER;
        if (!defined('USTK_ATTCH_FOLDER')) {
            define('USTK_ATTCH_FOLDER', 'data/tasks/');
        }
        $this->att_folder = USTK_ATTCH_FOLDER;
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_PERSONAL_INFORMATION:MENU_TASKS', 'TOOL', $this->code, 'ac=LIST');
        $DBLT = getTool('DBLT');
        $items = array();
        $items['WORK'] = 'GEN_LBL_WORK';
        $items['PERS'] = 'GEN_LBL_PERSONAL';
        $items['OTHE'] = 'GEN_LBL_OTHER';
        $DBLT->createList('TKLT', 'Task Types', 'Task types for the Task Manager', CLX_NUM_TWO, $items);
        $items = array();
        $items['1'] = 'GEN_LBL_JANUARY';
        $items['2'] = 'GEN_LBL_FEBRUARY';
        $items['3'] = 'GEN_LBL_MARCH';
        $items['4'] = 'GEN_LBL_APRIL';
        $items['5'] = 'GEN_LBL_MAY';
        $items['6'] = 'GEN_LBL_JUNE';
        $items['7'] = 'GEN_LBL_JULY';
        $items['8'] = 'GEN_LBL_AUGUST';
        $items['9'] = 'GEN_LBL_SEPTEMBER';
        $items['10'] = 'GEN_LBL_OCTOBER';
        $items['11'] = 'GEN_LBL_NOVEMBER';
        $items['12'] = 'GEN_LBL_DECEMBER';
        $DBLT->createList('MOTH', 'Months', 'List of months', CLX_NUM_TWO, $items);
        $items = array();
        $items['1'] = 'GEN_LBL_MONDAY';
        $items['2'] = 'GEN_LBL_TUESDAY';
        $items['3'] = 'GEN_LBL_WEDNESDAY';
        $items['4'] = 'GEN_LBL_THURSDAY';
        $items['5'] = 'GEN_LBL_FRIDAY';
        $items['6'] = 'GEN_LBL_SATURDAY';
        $items['7'] = 'GEN_LBL_SUNDAY';
        $DBLT->createList('DAYS', 'Days', 'List of days', CLX_NUM_TWO, $items);
        $items = array();
        $items['1'] = 'GEN_LBL_FIRST';
        $items['2'] = 'GEN_LBL_SECOND';
        $items['3'] = 'GEN_LBL_THIRD';
        $items['4'] = 'GEN_LBL_FOURTH';
        $DBLT->createList('ORDS', 'Ordinals', 'List of ordinals', CLX_NUM_TWO, $items);
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['START_DATE'] = array('type' => 'date', 'null' => 'NO', 'properties' => '');
        //$fields['END_DATE'] = array('type' => 'date', 'null' => 'NO', 'properties' => '');
        $fields['END_DATE'] = array('type' => 'date', 'null' => 'YES', 'properties' => '');
        //Recurrence dates
        $fields['RSTART_DATE'] = array('type' => 'date', 'null' => 'YES', 'properties' => '');
        $fields['REND_DATE'] = array('type' => 'date', 'null' => 'YES', 'properties' => '');
        $fields['DUE_DATE'] = array('type' => 'date', 'null' => 'YES', 'properties' => '');
        $fields['STATUS'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(10)', 'properties' => '');
        $fields['SUBJECT'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['COMMENTS'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['ATTACHMENT'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '');
        $fields['PERCENT_COMPLETE'] = array('type' => 'tinyint(4) unsigned', 'properties' => '');
        $fields['COMPLETE_DATE'] = array('type' => 'date', 'null' => 'YES', 'properties' => '');
        $fields['PRIORITY'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['OWNERCODE'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['ASSIGNEDTO'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['REMINDER_DATETIME'] = array('type' => 'datetime', 'properties' => '');
        $fields['MAIL_NOTICE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['RECURRING'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['NUMBER1'] = array('type' => 'int(11)', 'properties' => '');
        $fields['NUMBER2'] = array('type' => 'int(11)', 'properties' => '');
        $fields['NUMBER3'] = array('type' => 'int(11)', 'properties' => '');
        $fields['NUMBER4'] = array('type' => 'int(11)', 'properties' => '');
        $fields['DEPENDS'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['TODELETE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'START_DATE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'END_DATE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'STATUS');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'SUBJECT');
        $indexes[$ipf . '07'] = array('index' => 'MUL', 'fieldname' => 'OWNERCODE');
        $indexes[$ipf . '08'] = array('index' => 'MUL', 'fieldname' => 'DEPENDS');
		$indexes[$ipf . '09'] = array('index' => 'MUL', 'fieldname' => 'ASSIGNEDTO');
        return array('idcode' => $this->code,
            'idname' => $this->name,
            'name' => $this->tablename,
            'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'SET_STATUS' :
                    $this->set_task_status();
                    $contents = executeHistory(peekHistory());
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [US_TASKS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($clear_history = true) {
        $username = $_SESSION['user_record']['username'];
        //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        if ($clear_history === true) {
            clearHistory();
            pushHistory($this->code, 'LIST', array());
        }
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'USTKList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');

        $selectclause = '*';
        $fromclause = 'CLX_US_TASKS';
		switch (kDatabaseType) {
			case 'oci':
				$whereclause = '((UPPER(OWNERCODE)=' . singleQuote(uppercase($username)) . ') OR (UPPER(ASSIGNEDTO)=' . singleQuote(uppercase($username)) . '))';
        		break;
			default:
				$whereclause = '(OWNERCODE=' . singleQuote($username) . ' OR ASSIGNEDTO=' . singleQuote($username) . ')';
		}
        $sortclause = 'START_DATE DESC';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        //due date esta comentado solo se usa end date
        $table = new htmlTable(CLX_WIDTH_7);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_USTK_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_7));
        $page->header($table);
        //$table->addCells(CLX_CLASS_HEADERS,array( dict('GEN_LBL_SEL'), dict('GEN_LBL_SUBJECT'), dict('GEN_LBL_OWNER'), dict('GEN_LBL_ASSIGNED_TO'), dict('GEN_LBL_START_DATE'), dict('GEN_LBL_DUE_DATE'), dict('GEN_LBL_REMINDER'), dict('GEN_LBL_STATUS')));
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_SUBJECT'), dict('GEN_LBL_OWNER'), dict('GEN_LBL_ASSIGNED_TO'), dict('GEN_LBL_START_DATE'), dict('GEN_LBL_END_DATE'),
            // dict('GEN_LBL_DUE_DATE'),
            dict('GEN_LBL_STATUS')/* ,dict('GEN_LBL_INITIAL_TASK') */));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(
				($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT,
				array(  $record['SUBJECT'],
					$record['OWNERCODE'],
					$record['ASSIGNEDTO'],
					(!empty($record['START_DATE']) ? xFormat::date($record['START_DATE'],$_SESSION['prefs']['DATE_FORMAT']) : ''),
					(!empty($record['END_DATE'])) ? xFormat::date($record['END_DATE'],$_SESSION['prefs']['DATE_FORMAT']) : '',
					dict($this->statuses[$record['STATUS']])
				)
			    );
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_TASK')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        //Change status
        $sel = new htmlSelect('USTK_status');
        //Change status
        $sel = new htmlSelect('USTK_status');
		if (is_null($record)or !isset($record) or empty($record)){
			$sel->setProp(CLX_PROP_ID, '');
		}
		else {
			$sel->setProp(CLX_PROP_ID, $record ['HIGHLIGHT']);
        }
		$sel->setProp('onchange', 'javascript: setFormAction(' . singleQuote($form->getProp(CLX_PROP_ID)) . ', ' . singleQuote('SET_STATUS') . '); this.form.submit();');
        $sel->addItem(dict('GEN_LBL_SET_STATUS_TO'), '', true);
        $sel->addItem('-------', '', false);
        // Search Listing Query
        foreach ($this->statuses as $k => $v) {
            $sel->addItem(dict($v), $k, false);
        }
        $buttons .= $sel->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function editForm($ac, $idlist, $record, $msg) {
        $contents = '';
        $canmodify = ($record['USTK_ownercode'] == $_SESSION['user_record']['username']);
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        $title = ($modify) ? dict('TOOL_USTK_TITLE_MODIFY') : dict('TOOL_USTK_TITLE_CREATE');
        //For field below
        $fieldobj = getToolObject('DBFT', 'DATE');
        //$id = array_pop($idlist);
        $DBLT = &getTool('DBLT');
        $ACUS = &getTool('ACUS');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp('enctype', 'multipart/form-data');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'UNDEFINED');
        $form->addArgument('confirm', '1');
        $form->addArgument('USTK_id', $record['USTK_id']);
        $form->addArgument('idlist', implode(',', $idlist));
        //Loading file
        $SDFL = &getTool('SDFL');
        $attachment = $SDFL->getFileLink($record['USTK_attachment_id']);
        $script="";

        if ($canmodify === true) {
            $list = 'var panellist = new Array();' . CLX_CHAR_NL . CLX_CHAR_NL;
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, CLX_NUM_ZERO, 'NONE');
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, CLX_NUM_ONE, 'DAY');
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, CLX_NUM_TWO, 'WEEK');
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, CLX_NUM_THREE, 'MOTH');
            $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';' . CLX_CHAR_NL, CLX_NUM_FOUR, 'YEAR');

            $script = setJavaScriptTag(kPathToExtLibJs . 'tinymce403/js/tinymce/tinymce.min.js', true)
                    . setJavaScriptTag(getJavaScriptFilename('USTK_editform.js'), true)
                    . setJavaScriptTag($list, false);


            $topscript = setJavaScriptTag(getJavaScript('dynform_top.js', array('VISIBLEPANEL' => 'USTK_recurring')), false);
            $btmscript = setJavaScriptTag(getJavaScriptFilename('dynform_btm.js'), true);
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));


            $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addField($msg, dict('GEN_LBL_SUBJECT') . ':', 'USTK_subject', $record['USTK_subject'], CLX_NUM_48, CLX_NUM_64);
            $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'USTK_description', $record['USTK_description'], CLX_NUM_FIVE, CLX_NUM_64);
            $table->addText($msg, dict('GEN_LBL_COMMENTS') . ':', 'USTK_comments', $record['USTK_comments'], CLX_NUM_FIVE, CLX_NUM_64);
            $form->addArgument('USTK_attachment_id', $record['USTK_attachment_id']);
            $table->addFile($msg, dict('GEN_LBL_ATTACHFILE') . ':', 'USTK_attachment', (array_key_exists('USTK_attachment', $record)) ? $record['USTK_attachment'] : '', false);
            if ($attachment <> '') {
                $table->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_CLASS, CLX_CLASS_PROMPT);
                $table->addCell($attachment, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            }
            $pop = new HTMLSelect('USTK_status');
            foreach ($this->statuses as $key => $value) {
                $pop->addItem(dict($value), $key, ($record['USTK_status'] == $key));
            }
            $table->addData(dict('GEN_LBL_STATUS') . ':', $pop->source());
            $pop = new HTMLSelect('USTK_priority');
            foreach ($this->priorities as $key => $value) {
                $pop->addItem(dict($value), $key, ($record['USTK_priority'] == $key));
            }
            $table->addData(dict('GEN_LBL_PRIORITY') . ':', $pop->source());
            $types = $DBLT->getList('TKLT', 'USTK_type', $record['USTK_type']);
            $table->addData(dict('GEN_LBL_TYPE') . ':', $types->source());
            $table->addField($msg, dict('GEN_LBL_PERCENT_COMPLETE') . ':', 'USTK_percent_complete', $record['USTK_percent_complete'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            if (!empty($modify)) {
                $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_start_date'], 'DATE', 'USTK_start_date', 'START_DATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
                $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_end_date'], 'DATE', 'USTK_end_date', 'END_DATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
                $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_complete_date'], 'DATE', 'USTK_complete_date', 'COMPLETE_DATE', 'GEN_LBL_COMPLETE_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addCell(dict('GEN_LBL_RESPONSABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $ACUS->placeChooseUser($msg, dict('GEN_LBL_OWNER') . ':', 'USTK_ownercode', $record['USTK_ownercode'], $table);
            $ACUS->placeChooseUser($msg, dict('GEN_LBL_ASSIGNED_TO') . ':', 'USTK_assignedto', $record['USTK_assignedto'], $table);
            $table->addYesNo(dict('GEN_LBL_MAIL_NOTICE'), 'USTK_mail_notice', $record['USTK_mail_notice'], CLX_NUM_ZERO, false);
            $table->addCell(dict('TOOL_USTK_TITLE_RECURRING_OPT'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $recurring = new htmlSelect('USTK_recurring');
            $recurring->addItem(dict('GEN_LBL_NONE'), 'NONE', ($record['USTK_recurring'] === 'NONE'));
            $recurring->addItem(dict('GEN_LBL_DAILY'), 'DAY', ($record['USTK_recurring'] === 'DAY'));
            $recurring->addItem(dict('GEN_LBL_WEEKLY'), 'WEEK', ($record['USTK_recurring'] === 'WEEK'));
            $recurring->addItem(dict('GEN_LBL_MONTHLY'), 'MOTH', ($record['USTK_recurring'] === 'MOTH'));
            $recurring->addItem(dict('GEN_LBL_YEARLY'), 'YEAR', ($record['USTK_recurring'] === 'YEAR'));
            $recurring->setProp('onchange', 'updateForm();');
            $table->addData(dict('GEN_LBL_RECURRING') . ':', $recurring->source());
            if (!empty($modify)) {
                $table->addYesNo(dict('GEN_LBL_UPDATE_ALL_OCCURRANCES'), 'USTK_update_ocurrances', CLX_NUM_ZERO, CLX_NUM_ZERO, false);
            }
            if (!empty($msg['temp_recurring_options'])) {
                $table->addCell($msg['temp_recurring_options'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            $contents = $table->source();
            // NONE Options
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_NONE_sdate'], 'DATE', 'USTK_NONE_sdate', 'NONE_SDATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_NONE_edate'], 'DATE', 'USTK_NONE_edate', 'NONE_DDATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $contents .= CLX_CHAR_NL . '' . CLX_CHAR_NL . '<div id="NONE" style="visibility:hidden;display:none;">' . CLX_CHAR_NL . $table->source() . '</div>' . CLX_CHAR_NL . CLX_CHAR_NL;
            // DAY Options
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, (array_key_exists('USTK_DAY_sdate', $record)) ? $record['USTK_DAY_sdate'] : '', 'DATE', 'USTK_DAY_sdate', 'DAY_SDATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, (array_key_exists('USTK_DAY_edate', $record)) ? $record['USTK_DAY_edate'] : '', 'DATE', 'USTK_DAY_edate', 'DAY_DDATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $opt0 = new htmlRadioButton('USTK_DAY_option', ($record['USTK_DAY_option'] == CLX_NUM_ZERO), '0');
            $field1 = new htmlField('USTK_DAY_field1', $record['USTK_DAY_field1'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt0->source() . ' ' . dict('GEN_LBL_EVERY') . ' ' . $field1->source() . ' ' . dict('GEN_LBL_DAY-S'));
            $opt1 = new htmlRadioButton('USTK_DAY_option', ($record['USTK_DAY_option'] == CLX_NUM_ONE), '1');
            $field2 = new htmlField('USTK_DAY_field2', $record['USTK_DAY_field2'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt1->source() . ' ' . dict('GEN_LBL_EVERY') . ' ' . $field2->source() . ' ' . dict('GEN_LBL_WEEKDAYS'));
            $contents .= CLX_CHAR_NL . '' . CLX_CHAR_NL . '<div id="DAY" style="visibility:hidden;display:none;">' . CLX_CHAR_NL . $table->source() . '</div>' . CLX_CHAR_NL . CLX_CHAR_NL;
            // WEEK Options
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_WEEK_sdate'], 'DATE', 'USTK_WEEK_sdate', 'WEEK_SDATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, (array_key_exists('USTK_WEEK_edate', $record)) ? $record['USTK_WEEK_edate'] : '', 'DATE', 'USTK_WEEK_edate', 'WEEK_DDATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $field1 = new htmlField('USTK_WEEK_field1', $record['USTK_WEEK_field1'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, dict('GEN_LBL_EVERY') . ' ' . $field1->source() . ' ' . dict('GEN_LBL_WEEK-S'));
            $contents .= CLX_CHAR_NL . '' . CLX_CHAR_NL . '<div id="WEEK" style="visibility:hidden;display:none;">' . CLX_CHAR_NL . $table->source() . '</div>' . CLX_CHAR_NL . CLX_CHAR_NL;
            // MOTH Options
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_MOTH_sdate'], 'DATE', 'USTK_MOTH_sdate', 'MOTH_SDATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, (array_key_exists('USTK_MOTH_edate', $record)) ? $record['USTK_MOTH_edate'] : '', 'DATE', 'USTK_MOTH_edate', 'MOTH_DDATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $opt0 = new htmlRadioButton('USTK_MOTH_option', ($record['USTK_MOTH_option'] == CLX_NUM_ZERO), '0');
            $field1 = new htmlField('USTK_MOTH_field1', $record['USTK_MOTH_field1'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $field2 = new htmlField('USTK_MOTH_field2', $record['USTK_MOTH_field2'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt0->source() . ' ' . dict('GEN_LBL_DAY') . ' ' . $field1->source() . ' ' . dict('GEN_LBL_OF_EVERY') . ' ' . $field2->source() . ' ' . dict('GEN_LBL_MONTH-S'));
            $opt1 = new htmlRadioButton('USTK_MOTH_option', ($record['USTK_MOTH_option'] == CLX_NUM_ONE), '1');
            $field3 = $DBLT->getList('ORDS', 'USTK_MOTH_field3', $record['USTK_MOTH_field3']);
            $field4 = $DBLT->getList('DAYS', 'USTK_MOTH_field4', $record['USTK_MOTH_field4']);
            $field5 = new htmlField('USTK_MOTH_field5', $record['USTK_MOTH_field5'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt1->source() . ' ' . dict('GEN_LBL_THE') . ' ' . $field3->source() . $field4->source() . ' ' . dict('GEN_LBL_OF_EVERY') . ' ' . $field5->source() . ' ' . dict('GEN_LBL_MONTH-S'));
            $contents .= CLX_CHAR_NL . '' . CLX_CHAR_NL . '<div id="MOTH" style="visibility:hidden;display:none;">' . CLX_CHAR_NL . $table->source() . '</div>' . CLX_CHAR_NL . CLX_CHAR_NL;
            // YEAR Options
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, $record['USTK_YEAR_sdate'], 'DATE', 'USTK_YEAR_sdate', 'YEAR_SDATE', 'GEN_LBL_START_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $cell = $fieldobj->placeEditFieldObj('theForm', $msg, (array_key_exists('USTK_YEAR_edate', $record)) ? $record['USTK_YEAR_edate'] : '', 'DATE', 'USTK_YEAR_edate', 'YEAR_DDATE', 'GEN_LBL_END_DATE', CLX_NUM_30, CLX_NUM_30, '', '', '', false, false, false);
            $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $opt0 = new htmlRadioButton('USTK_YEAR_option', ($record['USTK_YEAR_option'] == CLX_NUM_ZERO), '0');
            $field1 = $DBLT->getList('MOTH', 'USTK_YEAR_field1', $record['USTK_YEAR_field1']);
            $field2 = new htmlField('USTK_YEAR_field2', $record['USTK_YEAR_field2'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt0->source() . ' ' . dict('GEN_LBL_EVERY') . ' ' . $field1->source() . ' ' . $field2->source());
            $opt1 = new htmlRadioButton('USTK_YEAR_option', ($record['USTK_YEAR_option'] == CLX_NUM_ONE), '1');
            $field3 = $DBLT->getList('ORDS', 'USTK_YEAR_field3', $record['USTK_YEAR_field3']);
            $field4 = $DBLT->getList('DAYS', 'USTK_YEAR_field4', $record['USTK_YEAR_field4']);
            $field5 = $DBLT->getList('MOTH', 'USTK_YEAR_field5', $record['USTK_YEAR_field5']);
            $table->addData(CLX_CHAR_HTML_NBSP, $opt1->source() . ' ' . dict('GEN_LBL_EVERY') . ' ' . $field3->source() . ' ' . $field4->source() . ' ' . dict('GEN_LBL_OF') . ' ' . $field5->source());
            $contents .= CLX_CHAR_NL . '' . CLX_CHAR_NL . '<div id="YEAR" style="visibility:hidden;display:none;">' . CLX_CHAR_NL . $table->source() . '</div>' . CLX_CHAR_NL . CLX_CHAR_NL;
        } else {
            $form->addArgument('USTK_ownercode', $record['USTK_ownercode']);
            $topscript = '';
            $btmscript = '';
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addCell(dict('TOOL_USTK_TITLE_VIEW') . ': ' . $record['USTK_subject'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addData(dict('GEN_LBL_SUBJECT') . ':', $record['USTK_subject']);
            $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['USTK_description']));
            $table->addText($msg, dict('GEN_LBL_COMMENTS') . ':', 'USTK_comments', $record['USTK_comments'], CLX_NUM_FIVE, CLX_NUM_64);
            //Loading file
            $SDFL = getTool('SDFL');
            $attachment = $SDFL->getFileLink($record['USTK_attachment_id']);
            $table->addData(dict('GEN_LBL_ATTACHFILE') . ':', $attachment);
            $pop = new HTMLSelect('USTK_status');
            foreach ($this->statuses as $key => $value) {
                $pop->addItem(dict($value), $key, ($record['USTK_status'] == $key));
            }
            $table->addData(dict('GEN_LBL_STATUS') . ':', $pop->source());
            $table->addData(dict('GEN_LBL_PRIORITY') . ':', dict($this->priorities[$record['USTK_priority']]));
            $table->addData(dict('GEN_LBL_TYPE') . ':', $DBLT->getListItem('TKLT', $record['USTK_type']));
            $table->addField($msg, dict('GEN_LBL_PERCENT_COMPLETE') . ':', 'USTK_percent_complete', $record['USTK_percent_complete'], CLX_NUM_FIVE, CLX_NUM_FIVE);
            $table->addData(dict('GEN_LBL_START_DATE') . ':', $record['USTK_start_date']);
            $table->addData(dict('GEN_LBL_END_DATE') . ':', $record['USTK_end_date']);
            $table->addData(dict('GEN_LBL_COMPLETE_DATE') . ':', $record['USTK_complete_date']);
            $table->addCell(dict('GEN_LBL_RESPONSABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addData(dict('GEN_LBL_OWNER') . ':', $record['USTK_ownercode']);
            $table->addData(dict('GEN_LBL_ASSIGNED_TO') . ':', $record['USTK_assignedto']);
            $contents = $table->source();
        }
        // Footers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => '90%'));
        $buttons = '';
        if (!empty($modify)) {
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $contents .= $table->source();
        $form->setContents($contents);
        return $script . CLX_CHAR_NL . CLX_CHAR_NL . $topscript . CLX_CHAR_NL . CLX_CHAR_NL . $form->source() . CLX_CHAR_NL . CLX_CHAR_NL . $btmscript;
    }

    function checkForm(&$msg) {
        $ACUS = &getTool('ACUS');
        $canmodify = (UserRequest::$post['USTK_ownercode'] == $_SESSION['user_record']['username']);
        xValidate::integer($msg, 'USTK_percent_complete', UserRequest::$post['USTK_percent_complete'], '0', CLX_NUM_HUNDRED, dict('GEN_LBL_PERCENT_COMPLETE'));
        if ($canmodify === true) {
            if (UserRequest::$post['USTK_subject'] === '') {
                $msg['USTK_subject'] = 'You have to write a subject.';
            }
            if (!empty(UserRequest::$post['USTK_complete_date']))
                xValidate::date($msg, 'USTK_complete_date', UserRequest::$post['USTK_complete_date'], dict('GEN_LBL_COMPLETE_DATE'));
            if (!empty(UserRequest::$post['USTK_reminder_datetime']))
                xValidate::datetime($msg, 'USTK_reminder_datetime', UserRequest::$post['USTK_reminder_datetime'], dict('GEN_LBL_REMINDER'));
            if (!$ACUS->userExists(UserRequest::$post['USTK_ownercode'])) {
                $msg['USTK_ownercode'] = dict('GEN_LBL_USER_DONT_EXIST');
            }
            if (!$ACUS->userExists(UserRequest::$post['USTK_assignedto'])) {
                $msg['USTK_assignedto'] = dict('GEN_LBL_USER_DONT_EXIST');
            }
            switch (UserRequest::$post['USTK_recurring']) {
                case 'NONE':
                    xValidate::date($msg, 'USTK_NONE_sdate', UserRequest::$post['USTK_NONE_sdate'], dict('GEN_LBL_START_DATE'));
                    xValidate::date($msg, 'USTK_NONE_edate', UserRequest::$post['USTK_NONE_edate'], dict('GEN_LBL_END_DATE'));
                    break;
                case 'DAY':
                    xValidate::date($msg, 'USTK_DAY_sdate', UserRequest::$post['USTK_DAY_sdate'], dict('GEN_LBL_START_DATE'));
                    xValidate::date($msg, 'USTK_DAY_edate', UserRequest::$post['USTK_DAY_edate'], dict('GEN_LBL_END_DATE'));
                    if (xFormat::date(UserRequest::$post['USTK_DAY_sdate'], 'Y-m-d') > xFormat::date(UserRequest::$post['USTK_DAY_edate'], 'Y-m-d')) {
                        $msg['USTK_DAY_sdate'] = dict('GEN_ERR_DATERANGEINVALID');
                        $msg['USTK_DAY_edate'] = dict('GEN_ERR_DATERANGEINVALID');
                    }
                    if (UserRequest::$post['USTK_DAY_option'] == CLX_NUM_ZERO) {
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_DAY_field1'], CLX_NUM_ONE, CLX_365_DAYS, 'day(s)');
                    } elseif (UserRequest::$post['USTK_DAY_option'] == CLX_NUM_ONE) {
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_DAY_field2'], CLX_NUM_ONE, CLX_365_DAYS, 'weekday(s)');
                    }
                    break;
                case 'WEEK':
                    xValidate::date($msg, 'USTK_WEEK_sdate', UserRequest::$post['USTK_WEEK_sdate'], dict('GEN_LBL_START_DATE'));
                    xValidate::date($msg, 'USTK_WEEK_edate', UserRequest::$post['USTK_WEEK_edate'], dict('GEN_LBL_END_DATE'));
                    if (adodb_strtotime(UserRequest::$post['USTK_sdate']) >= adodb_strtotime(UserRequest::$post['USTK_WEEK_edate'])) {
                        $msg['USTK_edate'] = 'The end date Can' . CLX_CHAR_SINGLE_QUOTE . 't be before the start date.';
                    }
                    xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_WEEK_field1'], CLX_NUM_ONE, CLX_NUM_50, 'week(s)');
                    break;
                case 'MOTH':
                    xValidate::date($msg, 'USTK_MOTH_sdate', UserRequest::$post['USTK_MOTH_sdate'], dict('GEN_LBL_START_DATE'));
                    xValidate::date($msg, 'USTK_MOTH_edate', UserRequest::$post['USTK_MOTH_edate'], dict('GEN_LBL_END_DATE'));
                    if (adodb_strtotime(UserRequest::$post['USTK_MOTH_sdate']) >= adodb_strtotime(UserRequest::$post['USTK_MOTH_edate'])) {
                        $msg['USTK_MOTH_edate'] = 'The end date Can' . CLX_CHAR_SINGLE_QUOTE . 't be before the start date.';
                    }
                    if (UserRequest::$post['USTK_MOTH_option'] == CLX_NUM_ZERO) {
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_MOTH_field1'], CLX_NUM_ONE, CLX_NUM_31, 'day(s)');
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_MOTH_field2'], CLX_NUM_ONE, CLX_NUM_12, 'month(s)');
                    } elseif (UserRequest::$post['USTK_MOTH_option'] == CLX_NUM_ONE) {
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_MOTH_field5'], CLX_NUM_ONE, CLX_NUM_12, 'month(s)');
                    }
                    break;
                case 'YEAR':
                    xValidate::date($msg, 'USTK_YEAR_sdate', UserRequest::$post['USTK_YEAR_sdate'], dict('GEN_LBL_START_DATE'));
                    xValidate::date($msg, 'USTK_YEAR_edate', UserRequest::$post['USTK_YEAR_edate'], dict('GEN_LBL_END_DATE'));
                    if (adodb_strtotime(UserRequest::$post['USTK_sdate']) >= adodb_strtotime(UserRequest::$post['USTK_YEAR_edate'])) {
                        $msg['USTK_edate'] = 'The end date Can'.CLX_CHAR_SINGLE_QUOTE.'t be before the start date.';
                    }
                    if (UserRequest::$post['USTK_YEAR_option'] == CLX_NUM_ZERO) {
                        xValidate::integer($msg, 'temp_recurring_options', UserRequest::$post['USTK_YEAR_field2'], CLX_NUM_ONE, CLX_NUM_31, 'day');
                    } elseif (UserRequest::$post['USTK_YEAR_option'] == CLX_NUM_ONE) {
                        // nothing
                    }
                    break;
                default:
                    break;
            }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_SUBJECT') . ':', $record['USTK_subject']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', $record['USTK_description']);
    }

    function viewFormFill($record) {
        $DBLT = &getTool('DBLT');
        $contents = '';
        //Loading file
        $SDFL = getTool('SDFL');
        $attachment = $SDFL->getFileLink($record['USTK_attachment_id']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_USTK_TITLE_VIEW') . ': ' . $record['USTK_subject'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_SUBJECT') . ':', $record['USTK_subject']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', htmlspecialchars_decode($record['USTK_description']));
        $table->addData(dict('GEN_LBL_COMMENTS') . ':', htmlspecialchars_decode($record['USTK_comments']));
        $table->addData(dict('GEN_LBL_ATTACHFILE') . ':', $attachment);
        $table->addData(dict('GEN_LBL_STATUS') . ':', dict($this->statuses[$record['USTK_status']]));
        $table->addData(dict('GEN_LBL_PRIORITY') . ':', dict($this->priorities[$record['USTK_priority']]));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $DBLT->getListItem('TKLT', $record['USTK_type']));
        $table->addData(dict('GEN_LBL_PERCENT_COMPLETE') . ':', $record['USTK_percent_complete'] . '%');
        $table->addData(dict('GEN_LBL_COMPLETE_DATE') . ':', $record['USTK_complete_date']);
        $table->addData(dict('GEN_LBL_REMINDER') . ':', xFormat::datetime($record['USTK_reminder_datetime']));
        $table->addCell(dict('GEN_LBL_RESPONSABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_OWNER') . ':', $record['USTK_ownercode']);
        $table->addData(dict('GEN_LBL_ASSIGNED_TO') . ':', $record['USTK_assignedto']);
        $table->addData(dict('GEN_LBL_MAIL_NOTICE') . ':', $record['USTK_mail_notice']);
        $contents .= $table->source();
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        $DBLT = &getTool('DBLT');
        $ACUS = &getTool('ACUS');
        if (!array_key_exists('USTK_subject', UserRequest::$post))
            UserRequest::$post['USTK_subject'] = '';
        if (!array_key_exists('USTK_sdate', UserRequest::$post))
            UserRequest::$post['USTK_sdate'] = '';
        if (!array_key_exists('USTK_edate', UserRequest::$post))
            UserRequest::$post['USTK_edate'] = '';
        if (!array_key_exists('USTK_ownercode', UserRequest::$post))
            UserRequest::$post['USTK_ownercode'] = '';
        if (!array_key_exists('USTK_assignedto', UserRequest::$post))
            UserRequest::$post['USTK_assignedto'] = '';
        $table->addField($msg, dict('GEN_LBL_SUBJECT'), 'USTK_subject', UserRequest::$post['USTK_subject'], CLX_NUM_32, CLX_NUM_64);
        $types = $DBLT->getList('TKLT', 'USTK_type', '');
        $types->addItem('', '', true);
        $table->addData(dict('GEN_LBL_TYPE'), $types->source());
        $table->addField($msg, dict('GEN_LBL_START_DATE') . ':', 'USTK_sdate', UserRequest::$post['USTK_sdate'], CLX_NUM_32, CLX_NUM_32);
        //$table->addField($msg, dict('GEN_LBL_DUE_DATE') . ':', 'USTK_edate', UserRequest::$post['USTK_edate'], 32, 32);
        $table->addField($msg, dict('GEN_LBL_END_DATE') . ':', 'USTK_edate', UserRequest::$post['USTK_edate'], CLX_NUM_32, CLX_NUM_32);
        $ACUS->placeChooseUser($msg, dict('GEN_LBL_OWNER') . ':', 'USTK_ownercode', UserRequest::$post['USTK_ownercode'], $table);
        $ACUS->placeChooseUser($msg, dict('GEN_LBL_ASSIGNED_TO') . ':', 'USTK_assignedto', UserRequest::$post['USTK_assignedto'], $table);
        $pop = new HTMLSelect('USTK_status');
        $pop->addItem('', '', true);
        foreach ($this->statuses as $key => $value) {
            $pop->addItem(dict($value), $key, false);
        }
        $table->addData(dict('GEN_LBL_STATUS') . ':', $pop->source());
        $sort = new HtmlSelect('USTK_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_SUBJECT'), 'subject', false);
        $sort->addItem(dict('GEN_LBL_OWNER'), 'ownercode', false);
        $sort->addItem(dict('GEN_LBL_ASSIGNED_TO'), 'assignedto', false);
        $sort->addItem(dict('GEN_LBL_START_DATE'), 'start_date', false);
        $sort->addItem(dict('GEN_LBL_END_DATE'), 'end_date', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (strlen(UserRequest::$post['USTK_subject']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' SUBJECT LIKE ' . singleQuote(UserRequest::$post['USTK_subject'] . '%');
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_sdate']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' START_DATE = ' . singleQuote(xFormat::date(UserRequest::$post['USTK_sdate'], 'Y-m-d'));
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_type']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' TYPE =' . singleQuote(UserRequest::$post['USTK_type']);
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_status']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' STATUS =' . singleQuote(UserRequest::$post['USTK_status']);
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_edate']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' END_DATE = ' . singleQuote(xFormat::date(UserRequest::$post['USTK_edate'], 'Y-m-d'));
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_ownercode']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' OWNERCODE LIKE ' . singleQuote(UserRequest::$post['USTK_ownercode'] . '%');
            $boolean = 'AND';
        }
        if (strlen(UserRequest::$post['USTK_assignedto']) > CLX_NUM_ZERO) {
            $filter .= $boolean . ' ASSIGNEDTO LIKE ' . singleQuote(UserRequest::$post['USTK_assignedto'] . '%');
            $boolean = 'AND';
        }
        $_SESSION['paging']['USTKList']['sortby'] = UserRequest::$post['USTK_sort'];
        $_SESSION['paging']['USTKList']['criteria'] = $filter;
        $_SESSION['paging']['USTKList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['USTKList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['USTK_id'] = $recordid;
        $record['USTK_status'] = $values['STATUS'];
        $record['USTK_type'] = $values['TYPE'];
        $record['USTK_subject'] = $values['SUBJECT'];
        $record['USTK_description'] = $values['DESCRIPTION'];
        $record['USTK_comments'] = $values['COMMENTS'];
        $record['USTK_percent_complete'] = $values['PERCENT_COMPLETE'];
        if (empty($values['COMPLETE_DATE'])) {
            $record['USTK_complete_date'] = '';
        } else {
            $record['USTK_complete_date'] = $values['COMPLETE_DATE'];
        }
        $record['USTK_attachment'] = '';
        $record['USTK_attachment_id'] = $values['ATTACHMENT'];
        $record['USTK_priority'] = $values['PRIORITY'];
        $record['USTK_ownercode'] = $values['OWNERCODE'];
        $record['USTK_assignedto'] = $values['ASSIGNEDTO'];
        $record['USTK_mail_notice'] = $values['MAIL_NOTICE'];
        //Note that rstart date is recurrence start date while start date is just the task date
        $record['USTK_start_date'] = $values['START_DATE'];
        $record['USTK_end_date'] = $values['END_DATE'];
        if (empty($values['REMINDER_DATETIME'])) {
            $record['USTK_reminder_datetime'] = '';
        } else {
            $record['USTK_reminder_datetime'] = $values['REMINDER_DATETIME'];
        }
        $record['USTK_recurring'] = $values['RECURRING'];
        $record['USTK_NONE_sdate'] = $values['RSTART_DATE'];
        $record['USTK_NONE_edate'] = $values['REND_DATE'];
        $record['USTK_DAY_sdate'] = $values['RSTART_DATE'];
        $record['USTK_DAY_edate'] = $values['REND_DATE'];
        $record['USTK_DAY_option'] = $values['NUMBER1'];
        $record['USTK_DAY_field1'] = $values['NUMBER2'];
        $record['USTK_DAY_field2'] = $values['NUMBER2'];
        $record['USTK_WEEK_sdate'] = $values['RSTART_DATE'];
        $record['USTK_WEEK_edate'] = $values['REND_DATE'];
        $record['USTK_WEEK_option'] = $values['NUMBER1'];
        $record['USTK_WEEK_field1'] = $values['NUMBER2'];
        $record['USTK_MOTH_sdate'] = $values['RSTART_DATE'];
        $record['USTK_MOTH_edate'] = $values['REND_DATE'];
        $record['USTK_MOTH_option'] = $values['NUMBER1'];
        $record['USTK_MOTH_field1'] = $values['NUMBER2'];
        $record['USTK_MOTH_field2'] = $values['NUMBER3'];
        $record['USTK_MOTH_field3'] = $values['NUMBER2'];
        $record['USTK_MOTH_field4'] = $values['NUMBER3'];
        $record['USTK_MOTH_field5'] = $values['NUMBER4'];
        $record['USTK_YEAR_sdate'] = $values['RSTART_DATE'];
        $record['USTK_YEAR_edate'] = $values['REND_DATE'];
        $record['USTK_YEAR_option'] = $values['NUMBER1'];
        $record['USTK_YEAR_field1'] = $values['NUMBER2'];
        $record['USTK_YEAR_field2'] = $values['NUMBER3'];
        $record['USTK_YEAR_field3'] = $values['NUMBER2'];
        $record['USTK_YEAR_field4'] = $values['NUMBER3'];
        $record['USTK_YEAR_field5'] = $values['NUMBER4'];
        return $record;
    }

    function saveRecord() {
        $recordid = UserRequest::$post['USTK_id'];
        $canmodify = (UserRequest::$post['USTK_ownercode'] == $_SESSION['user_record']['username']);
        $record = array();
        $record['STATUS'] = UserRequest::$post['USTK_status'];
        $record['PERCENT_COMPLETE'] = UserRequest::$post['USTK_percent_complete'];
        $record['COMMENTS'] = UserRequest::$post['USTK_comments'];
        $record['MAIL_NOTICE'] = UserRequest::$post['USTK_mail_notice'];
        if ($canmodify === true) {
            if (!empty(UserRequest::$files['USTK_attachment']['name'])) {
                $SDFL = getTool('SDFL');
                $name = UserRequest::$files['USTK_attachment']['name'];
                $type = UserRequest::$files['USTK_attachment']['type'];
                $contents = file_get_contents(UserRequest::$files['USTK_attachment']['tmp_name']);
                $saveindatabase = CLX_INIT_ZERO;
                $path = $this->att_folder;
                $record['ATTACHMENT'] = $SDFL->saveFile($name, $type, $contents, $saveindatabase, $path);
            }
            $record['TYPE'] = UserRequest::$post['USTK_type'];
            $record['SUBJECT'] = UserRequest::$post['USTK_subject'];
            $record['DESCRIPTION'] = UserRequest::$post['USTK_description'];
            if (empty(UserRequest::$post['USTK_complete_date'])) {
                $record['COMPLETE_DATE'] = 'null';
            } else {
                $record['COMPLETE_DATE'] = xFormat::date(UserRequest::$post['USTK_complete_date'], 'Y-m-d');
            }
            $record['PRIORITY'] = UserRequest::$post['USTK_priority'];
            $record['OWNERCODE'] = UserRequest::$post['USTK_ownercode'];
            $record['ASSIGNEDTO'] = UserRequest::$post['USTK_assignedto'];
            $record['MAIL_NOTICE'] = UserRequest::$post['USTK_mail_notice'];
            $record['START_DATE'] = UserRequest::$post['USTK_start_date'];
            $record['END_DATE'] = UserRequest::$post['USTK_end_date'];
            if (empty(UserRequest::$post['USTK_reminder_datetime'])) {
                $record['REMINDER_DATETIME'] = '';
            } else {
                $record['REMINDER_DATETIME'] = xFormat::date(UserRequest::$post['USTK_reminder_datetime'], 'Y-m-d');
            }
            $record['RECURRING'] = UserRequest::$post['USTK_recurring'];
        }
        //Recurrence, start and end date
        $this->getRecurrenceOptions($record);
        unset($record['DEPENDS']);
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID= ' . $recordid);
        //email notification
        if ($record['MAIL_NOTICE'] == CLX_NUM_ONE) {
            $record['ID'] = $recordid;
            $this->mail_task($record);
        }
        if ($canmodify === true) {
            if (!empty(UserRequest::$post['USTK_update_ocurrances'])) {//check if need to update recurrences
                $this->createRecurringTasks($recordid, UserRequest::$post);
            }
        }
    }

    /**
     * Sets activity status
     */
    private function set_task_status() {
        $idlist = toString(getIdList());
        if (!empty($idlist) && array_key_exists(UserRequest::$post['USTK_status'], $this->statuses)) {
            $r = array('STATUS' => UserRequest::$post['USTK_status']);
            if (UserRequest::$post['USTK_status'] === 'END') {
                $r['COMPLETE_DATE'] = date('Y-m-d');
            }
            ClxCommon::$db->updateRecord($this->tablename, $r, 'ID IN (' . $idlist . ') AND STATUS <> ' . singleQuote(UserRequest::$post['USTK_status']));
        }
    }

    function createRecord_() {
        $record = array();
        $record['STATUS'] = UserRequest::$post['USTK_status'];
        $record['TYPE'] = UserRequest::$post['USTK_type'];
        $record['SUBJECT'] = UserRequest::$post['USTK_subject'];
        $record['DESCRIPTION'] = UserRequest::$post['USTK_description'];
        $record['COMMENTS'] = UserRequest::$post['USTK_comments'];
        if (!empty(UserRequest::$files['USTK_attachment']['name'])) {
            $SDFL = getTool('SDFL');
            $name = UserRequest::$files['USTK_attachment']['name'];
            $type = UserRequest::$files['USTK_attachment']['type'];
            $contents = file_get_contents(UserRequest::$files['USTK_attachment']['tmp_name']);
            $saveindatabase = CLX_INIT_ZERO;
            $path = $this->att_folder;
            $record['ATTACHMENT'] = $SDFL->saveFile($name, $type, $contents, $saveindatabase, $path);
        }
        $record['PERCENT_COMPLETE'] = UserRequest::$post['USTK_percent_complete'];
        if (empty(UserRequest::$post['USTK_complete_date'])) {
            $record['COMPLETE_DATE'] = 'null';
        } else {
            $record['COMPLETE_DATE'] = xFormat::date(UserRequest::$post['USTK_complete_date'], 'Y-m-d');
        }
        $record['PRIORITY'] = UserRequest::$post['USTK_priority'];
        $record['OWNERCODE'] = UserRequest::$post['USTK_ownercode'];
        $record['ASSIGNEDTO'] = UserRequest::$post['USTK_assignedto'];
        $record['MAIL_NOTICE'] = UserRequest::$post['USTK_mail_notice'];
        if (empty(UserRequest::$post['USTK_reminder_datetime'])) {
            $record['REMINDER_DATETIME'] = 'null';
        } else {
            $record['REMINDER_DATETIME'] = xFormat::date(UserRequest::$post['USTK_reminder_datetime'], 'Y-m-d');
        }
        $record['RECURRING'] = UserRequest::$post['USTK_recurring'];
        $record['DEPENDS'] = '0';
        //Recurrence, start and end date
        $this->getRecurrenceOptions($record);
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        //Adding depends that is going to be used on recurrences
        ClxCommon::$db->updateRecord($this->tablename, array('DEPENDS' => $recordid), 'ID = '.$recordid);
        if ($record['MAIL_NOTICE'] == CLX_NUM_ONE) {
            $record['ID'] = $recordid;
            $this->mail_task($record);
        }
        $this->createRecurringTasks($recordid, UserRequest::$post);
        return $recordid;
    }

    function deleteRecordSk($recordid) {
        $taskrec = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        if (!empty($taskrec['ATTACHMENT'])) {
            $SDFL = getTool('SDFL');
            $SDFL->deleteRecordSk($taskrec['ATTACHMENT']);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'DEPENDS=' . $recordid);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID= ' . $recordid);
    }

    function defaultRecord() {
        $record = array();
        $record['USTK_id'] = CLX_INIT_ZERO;
        $record['USTK_status'] = 'IDLE';
        $record['USTK_type'] = '';
        $record['USTK_subject'] = '';
        $record['USTK_description'] = '';
        $record['USTK_attachment'] = '';
        $record['USTK_attachment_id'] = '';
        $record['USTK_comments'] = '';
        $record['USTK_percent_complete'] = CLX_INIT_ZERO;
        $record['USTK_complete_date'] = '';
        $record['USTK_priority'] = 'NORM';
        $record['USTK_ownercode'] = $_SESSION['user_record']['username'];
        $record['USTK_assignedto'] = $_SESSION['user_record']['username'];
        $record['USTK_mail_notice'] = CLX_INIT_ZERO;
        $record['USTK_reminder_datetime'] = '';
        $record['USTK_recurring'] = 'NONE';
        $today = xFormat::date('today', 'Y-m-d');
        $next_week = xFormat::date('next week', 'Y-m-d');
        $next_month = xFormat::date('next month', 'Y-m-d');
        $next_year = xFormat::date('next year', 'Y-m-d');
        $next_year_plus_five = xFormat::date('today +5 years', 'Y-m-d');
        $record['USTK_start_date'] = $today;
        $record['USTK_end_date'] = $next_week;
        $record['USTK_NONE_sdate'] = $today;
        $record['USTK_NONE_edate'] = $next_week;
        $record['USTK_DAY_sdate'] = $today;
        $record['USTK_DAY_edate'] = $next_week;
        $record['USTK_DAY_option'] = '';
        $record['USTK_DAY_field1'] = '';
        $record['USTK_DAY_field2'] = '';
        $record['USTK_WEEK_sdate'] = $today;
        $record['USTK_WEEK_edate'] = $next_month;
        $record['USTK_WEEK_option'] = '';
        $record['USTK_WEEK_field1'] = '';
        $record['USTK_MOTH_sdate'] = $today;
        $record['USTK_MOTH_edate'] = $next_year;
        $record['USTK_MOTH_option'] = '';
        $record['USTK_MOTH_field1'] = '';
        $record['USTK_MOTH_field2'] = '';
        $record['USTK_MOTH_field3'] = '';
        $record['USTK_MOTH_field4'] = '';
        $record['USTK_MOTH_field5'] = '';
        $record['USTK_YEAR_sdate'] = $today;
        $record['USTK_YEAR_edate'] = $next_year_plus_five;
        $record['USTK_YEAR_option'] = '';
        $record['USTK_YEAR_field1'] = '';
        $record['USTK_YEAR_field2'] = '';
        $record['USTK_YEAR_field3'] = '';
        $record['USTK_YEAR_field4'] = '';
        $record['USTK_YEAR_field5'] = '';
        return $record;
    }

    /**
     * Handles diferent options from form
     * @param array $record
     */
    private function getRecurrenceOptions(&$record) {
        //seting dates
        $record['RSTART_DATE'] = xFormat::date(UserRequest::$post['USTK_' . UserRequest::$post['USTK_recurring'] . '_sdate'], 'Y-m-d');
        $record['REND_DATE'] = xFormat::date(UserRequest::$post['USTK_' . UserRequest::$post['USTK_recurring'] . '_edate'], 'Y-m-d');
        switch (UserRequest::$post['USTK_recurring']) {
            case 'NONE':
                $data = array('START_DATE' => $record['RSTART_DATE'], 'END_DATE' => $record['REND_DATE'], 'NUMBER1' => '0', 'NUMBER2' => '0', 'NUMBER3' => '0', 'NUMBER4' => '0');
                break;
            case 'DAY':
                if (UserRequest::$post['USTK_DAY_option'] == CLX_NUM_ZERO) {
                    $data = array('NUMBER1' => '0', 'NUMBER2' => UserRequest::$post['USTK_DAY_field1'], 'NUMBER3' => '0', 'NUMBER4' => '0');
                } elseif (UserRequest::$post['USTK_DAY_option'] == CLX_NUM_ONE) {
                    $data = array('NUMBER1' => '1', 'NUMBER2' => UserRequest::$post['USTK_DAY_field2'], 'NUMBER3' => '0', 'NUMBER4' => '0');
                }
                break;
            case 'WEEK':
                $data = array('NUMBER1' => '0', 'NUMBER2' => UserRequest::$post['USTK_WEEK_field1'], 'NUMBER3' => '0', 'NUMBER4' => '0');
                break;
            case 'MOTH':
                if (UserRequest::$post['USTK_MOTH_option'] == CLX_NUM_ZERO) {
                    $data = array('NUMBER1' => '0', 'NUMBER2' => UserRequest::$post['USTK_MOTH_field1'], 'NUMBER3' => UserRequest::$post['USTK_MOTH_field2'], 'NUMBER4' => '0');
                } elseif (UserRequest::$post['USTK_MOTH_option'] == CLX_NUM_ONE) {
                    $data = array('NUMBER1' => '1', 'NUMBER2' => UserRequest::$post['USTK_MOTH_field3'], 'NUMBER3' => UserRequest::$post['USTK_MOTH_field4'], 'NUMBER4' => UserRequest::$post['USTK_MOTH_field5']);
                }
                break;
            case 'YEAR':
                if (UserRequest::$post['USTK_YEAR_option'] == CLX_NUM_ZERO) {
                    $data = array('NUMBER1' => '0', 'NUMBER2' => UserRequest::$post['USTK_YEAR_field1'], 'NUMBER3' => UserRequest::$post['USTK_YEAR_field2'], 'NUMBER4' => '0');
                } elseif (UserRequest::$post['USTK_YEAR_option'] == CLX_NUM_ONE) {
                    $data = array('NUMBER1' => '1', 'NUMBER2' => UserRequest::$post['USTK_YEAR_field3'], 'NUMBER3' => UserRequest::$post['USTK_YEAR_field4']/* Day */, 'NUMBER4' => $record['NUMBER4'] = UserRequest::$post['USTK_YEAR_field5']); // Month
                }
                break;
            default:
                break;
        }
        $record = array_merge($record, $data);
    }

    function createRecurringTasks($recordid, $values) {
        $fields = array();
        $recurringDays = array();
        switch ($values['USTK_recurring']) {
            case 'DAY':
                $sdate = adodb_strtotime($values['USTK_DAY_sdate']);
                $fields['START_DATE'] = adodb_date('Y-m-d', $sdate);
                $fields['RSTART_DATE'] = $sdate;
                $edate = adodb_strtotime($values['USTK_DAY_edate']);
                $fields['END_DATE'] = adodb_date('Y-m-d', $edate);
                $fields['REND_DATE'] = $edate;
                if ($values['USTK_DAY_option'] == CLX_NUM_ZERO) {
                    $fields['NUMBER1'] = '0';
                    $fields['NUMBER2'] = $values['USTK_DAY_field1'];
                    $delta = CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60 * $values['USTK_DAY_field1'];
                    for ($i = $sdate; $i <= $edate; $i+=$delta) {
                        $recurringDays[] = array('s' => $i, 'e' => $i);
                    }
                } elseif ($values['USTK_DAY_option'] == CLX_NUM_ONE) {
                    $fields['NUMBER1'] = '1';
                    $fields['NUMBER2'] = $values['USTK_DAY_field2'];
                    $delta = CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60 * $values['USTK_DAY_field2']; // days
                    for ($i = $sdate; $i <= $edate; $i += $delta) {
                        $info = adodb_getdate($i);
                        if ($info['wday'] === CLX_NUM_ZERO) {
                            $dif = CLX_NUM_ONE;
                        } elseif ($info['wday'] === CLX_NUM_SIX) {
                            $dif = CLX_NUM_TWO;
                        } else {
                            $dif = CLX_INIT_ZERO;
                        }
                        $t = $i + $dif * CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60;
                        //$i += $dif * 24 * 60 * 60;
                        $recurringDays[] = array('s' => $i, 'e' => $t);
                    }
                }
                break;
            case 'WEEK':
                $sdate = adodb_strtotime($values['USTK_WEEK_sdate']);
                $fields['START_DATE'] = adodb_date('Y-m-d', $sdate);
                $edate = adodb_strtotime($values['USTK_WEEK_edate']);
                $fields['END_DATE'] = adodb_date('Y-m-d', $edate);
                $fields['NUMBER2'] = $values['USTK_WEEK_field1'];
                $delta = CLX_NUM_7 * CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60 * $values['USTK_WEEK_field1'];
                for ($i = $sdate; $i <= $edate; $i+=$delta) {
                    $recurringDays[] = array('s' => $i, 'e' => $i);
                }
                break;
            case 'MOTH':
                $sdate = adodb_strtotime($values['USTK_MOTH_sdate']);
                $fields['START_DATE'] = adodb_date('Y-m-d', $sdate);
                $edate = adodb_strtotime($values['USTK_MOTH_edate']);
                $fields['END_DATE'] = adodb_date('Y-m-d', $edate);
                if ($values['USTK_MOTH_option'] == CLX_NUM_ZERO) {
                    $fields['NUMBER1'] = '0';
                    $fields['NUMBER2'] = $values['USTK_MOTH_field1'];
                    $fields['NUMBER3'] = $values['USTK_MOTH_field2'];
                    $info = adodb_getdate($sdate);
                    $d = $values['USTK_WEEK_field1'];
                    $m = $info['mon'];
                    $y = $info['year'];
                    $i = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $m, $d, $y);
                    while ($i <= $edate) {
                        $info = adodb_getdate($i);
                        $i = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $info['mon'] + $values['USTK_MOTH_field2'], $info['mday'], $info['year']);
                        $is = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $info['mon'], $info['mday'], $info['year']);
                        $recurringDays[] = array('s' => $is, 'e' => $i);
                    }
                } elseif ($values['USTK_MOTH_option'] == CLX_NUM_ONE) {
                    $fields['NUMBER1'] = '1';
                    $fields['NUMBER2'] = $values['USTK_MOTH_field3'];
                    $fields['NUMBER3'] = $values['USTK_MOTH_field4'];
                    $fields['NUMBER4'] = $values['USTK_MOTH_field5'];
                    $info = adodb_getdate($sdate);
                    $d = CLX_NUM_ONE;
                    $m = $info['mon'];
                    $y = $info['year'];
                    $i = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $m, $d, $y);
                    while ($i <= $edate) {
                        $info = adodb_getdate($i);
                        $dif = $values['USTK_MOTH_field4'] - $info['wday'];
                        if ($dif < CLX_NUM_ZERO)
                            $dif = CLX_NUM_7 + $dif;
                        $dif += (($values['USTK_MOTH_field3'] - CLX_NUM_ONE) * CLX_NUM_7);
                        $founddate = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $info['mon'], $info['mday'] + $dif, $info['year']);
                        $founddateinfo = adodb_getdate($founddate);
                        if ($founddateinfo['mon'] == $info['mon']) {
                            $recurringDays[] = array('s' => $founddate, 'e' => $founddate);
                        }
                        $i = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $info['mon'] + $values['USTK_MOTH_field5'], $info['mday'], $info['year']);
                    }
                }
                break;
            case 'YEAR':
                $sdate = adodb_strtotime($values['USTK_YEAR_sdate']);
                $fields['START_DATE'] = adodb_date('Y-m-d', $sdate);
                $info = adodb_getdate($sdate);
                $syear = $info['year'];
                $edate = adodb_strtotime($values['USTK_YEAR_edate']);
                $fields['END_DATE'] = adodb_date('Y-m-d', $edate);
                $info = adodb_getdate($edate);
                $eyear = $info['year'];
                if ($values['USTK_YEAR_option'] == CLX_NUM_ZERO) {
                    $fields['NUMBER1'] = '0';
                    $fields['NUMBER2'] = $values['USTK_YEAR_field1'];
                    $fields['NUMBER3'] = $values['USTK_YEAR_field2'];
                    for ($i = $syear; $i <= $eyear; $i++) {
                        $at = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $values['USTK_YEAR_field1'], $values['USTK_YEAR_field2'], $i);
                        //$recurringDays[] = adodb_mktime(0, 0, 0, $values['USTK_YEAR_field1'], $values['USTK_YEAR_field2'], $i);
                        $recurringDays[] = array('s' => $at, 'e' => $at);
                        unset($at);
                    }
                } elseif ($values['USTK_YEAR_option'] == CLX_NUM_ONE) {
                    $fields['NUMBER1'] = '1';
                    $fields['NUMBER2'] = $values['USTK_YEAR_field3']; // Count
                    $fields['NUMBER3'] = $values['USTK_YEAR_field4']; // Day
                    $fields['NUMBER4'] = $values['USTK_YEAR_field5']; // Month
                    for ($i = $syear; $i <= $eyear; $i++) {
                        $info = adodb_getdate(adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $values['USTK_YEAR_field5'], CLX_NUM_ONE, $i));
                        $dif = $values['USTK_YEAR_field4'] - $info['wday'];
                        if ($dif < CLX_NUM_ZERO)
                            $dif = CLX_NUM_7 + $dif;
                        $dif += (($values['USTK_YEAR_field3'] - CLX_NUM_ONE) * CLX_NUM_7);
                        $founddate = adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $values['USTK_YEAR_field5'], $dif + CLX_NUM_ONE, $i);
                        $founddateinfo = adodb_getdate($founddate);
                        if (($founddateinfo['year'] == $i) and ( $founddateinfo['mon'] == $values['USTK_YEAR_field5'])) {
                            $recurringDays[] = array('s' => $founddate, 'e' => $founddate);
                        }
                    }
                }
                break;
            default:
                //NONE or any other unknown here
                return;
                break;
        }
        ClxCommon::$db->updateRecord($this->tablename, array('TODELETE' => CLX_NUM_ONE), 'DEPENDS=' . $recordid);
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID = '.$recordid);
        if ($record['COMPLETE_DATE'] === '') {
            $record['COMPLETE_DATE'] = 'null';
        }
        unset($record['ID']);
        foreach ($recurringDays as $key => $d) {
            $record['START_DATE'] = adodb_date('Y-m-d', $d['s']);
            $record['END_DATE'] = adodb_date('Y-m-d', $d['e']);
            $record['TODELETE'] = CLX_INIT_ZERO;
            ClxCommon::$db->loadDbRecord($this->tablename, $record, false, 'START_DATE = ' . singleQuote($record['START_DATE']) . ' AND DEPENDS=' . $recordid);
        }
        //Delete what is not need any more
        ClxCommon::$db->deleteRecords($this->tablename, 'TODELETE=1 AND DEPENDS=' . $recordid);
    }

    function mail_task($record) {
        if (empty($record['OWNERCODE']) || empty($record['ASSIGNEDTO']))
            return;
        $fromrec = ClxCommon::$db->getRecord('CLX_AC_USERS', 'USERNAME=' . singleQuote($record['OWNERCODE']));
        $torec = ClxCommon::$db->getRecord('CLX_AC_USERS', 'USERNAME=' . singleQuote($record['ASSIGNEDTO']));
        $torec['EMAIL'] = str_replace(';', ',', $torec['EMAIL']);
        $tos = explode(',', trim($torec['EMAIL'], ' '));
        $to = '';
        $comma = '';
        foreach ($tos as $key => $val) {
            $to .= $comma . $torec['FIRSTNAME'] . ' ' . $torec['LASTNAME'] . ' <' . $val . '>';
            $comma = ', ';
        }
        unset($tos);
        $from = $fromrec['EMAIL'];
        // Caso 1002862 - GB-garabatos en asunto de actividad
        $subject = decode_string($record['SUBJECT']);
        $message = '';
        $DBLT = getTool('DBLT');
        foreach ($record as $key => $val) {
            if ($val === 'null' || $key === 'ID' || $key === 'MAIL_NOTICE' || $key === 'DEPENDS' || $key === 'ATTACHMENT' || $key === 'SUBJECT' || $key === 'REMINDER_DATETIME' || $key === 'RECURRING') {
                continue;
            }

            if ($key === 'OWNERCODE') {
                $key = 'OWNER';
            }
            if ($key === 'ASSIGNEDTO') {
                $key = 'ASSIGNED_TO';
            }
            if ($key === 'PRIORITY' && array_key_exists($val, $this->priorities)) {
                $val = dict($this->priorities[$val]);
            }
            if ($key === 'STATUS' && array_key_exists($val, $this->statuses)) {
                $val = dict($this->statuses[$val]);
            }
            if ($key === 'TYPE') {
                $val = dict($DBLT->getListItem('TKLT', $val), false);
            }
            $message .= '<b>' . dict('GEN_LBL_' . $key) . ': </b>' . $val . CLX_CHAR_NL;
        }
        // Caso 1002862 - GB-garabatos en asunto de actividad
        $message = decode_string($message);
        $url = kWebSite . 'index.php?to=USTK&ac=DISPLAY&idlist=' . $record['ID'];
        $link = '<br><br><center><page t=us_task></page><a href=' .singleQuote( $url) . '>' . dict('GEN_LBL_CLICK_FOR_DETAIL') . '</a></center>';
        $message .= $link;
        if (!clx_mail($from, $to, str_replace(CLX_CHAR_NL, '<br>', $message), $subject, true, null, null, $from)) {
            addMessage(dict('GEN_ERR_EVENTMAILFAIL'));
        }
    }

    function pageCheckObject($code){
        ClxFreeReturn($code);
        return true;
    }
    function pageletform() {
        return $this->makeList(false);
    }

}
